----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    14:49:29 05/12/2010 
-- Design Name: 
-- Module Name:    DTC_T2 - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
use IEEE.std_logic_misc.all;
use work.ipbus.ALL;
use work.amc13_pack.all;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
-- use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
library UNISIM;
use UNISIM.VComponents.all;
Library UNIMACRO;
use UNIMACRO.vcomponents.all;

entity AMC13_T1 is
    Port (
           VAUXP : in  STD_LOGIC_VECTOR(12 downto 0);
           VAUXN : in  STD_LOGIC_VECTOR(12 downto 0);
-- I2C interface
           CLK_SCL : out  STD_LOGIC;
           CLK_SDA : inout  STD_LOGIC;
           SFP_SCL : out  STD_LOGIC_VECTOR(3 downto 0);
           SFP_SDA : inout  STD_LOGIC_VECTOR(3 downto 0);
-- SFP slow control
           SFP_LOS : in  STD_LOGIC_VECTOR(2 downto 0);
           SFP_ABS : in  STD_LOGIC_VECTOR(3 downto 0);
           TxFault : in  STD_LOGIC_VECTOR(3 downto 0);
           TxDisable : out  STD_LOGIC_VECTOR(3 downto 0);
--           RATE : out  STD_LOGIC_VECTOR(3 downto 0);
-- CDR signals
           DIV4 : out  STD_LOGIC;
           DIV_nRST : out  STD_LOGIC;
           CDRclk_p : in  STD_LOGIC;
           CDRclk_n : in  STD_LOGIC;
           CDRdata_p : in  STD_LOGIC;
           CDRdata_n : in  STD_LOGIC;
           TTCdata_p : out  STD_LOGIC;
           TTCdata_n : out  STD_LOGIC;
           TTCclk_p : in  STD_LOGIC;
           TTCclk_n : in  STD_LOGIC;
           TTC_LOS : in  STD_LOGIC;
           TTC_LOL : in  STD_LOGIC;
           TTS_out_p : out  STD_LOGIC;
           TTS_out_n : out  STD_LOGIC;
-- SPI interface
           SPI_SCK : in  STD_LOGIC;
           SPI_CS_b : in  STD_LOGIC;
           SPI_MOSI : in  STD_LOGIC;
           SPI_MISO : out  STD_LOGIC;
-- DDR3 pins
           sys_clk_p : in  STD_LOGIC;
           sys_clk_n : in  STD_LOGIC;
           ddr3_dq : inout  STD_LOGIC_VECTOR(31 downto 0);
           ddr3_addr : out  STD_LOGIC_VECTOR(13 downto 0);
           ddr3_ba : out  STD_LOGIC_VECTOR (2 downto 0);
           ddr3_dm : out  STD_LOGIC_VECTOR (3 downto 0);
           ddr3_dqs_p : inout  STD_LOGIC_VECTOR(3 downto 0);
           ddr3_dqs_n : inout  STD_LOGIC_VECTOR(3 downto 0);
           ddr3_ras_n : out  STD_LOGIC;
           ddr3_cas_n : out  STD_LOGIC;
           ddr3_we_n : out  STD_LOGIC;
           ddr3_reset_n : out  STD_LOGIC;
           ddr3_cke : out  STD_LOGIC_vector(0 to 0);
           ddr3_odt : out  STD_LOGIC_vector(0 to 0);
           ddr3_ck_p : out  STD_LOGIC_vector(0 to 0);
           ddr3_ck_n : out  STD_LOGIC_vector(0 to 0);
           SFP0_RXN : in  STD_LOGIC;
           SFP0_RXP : in  STD_LOGIC;
           SFP1_RXN : in  STD_LOGIC;
           SFP1_RXP : in  STD_LOGIC;
           SFP2_RXN : in  STD_LOGIC;
           SFP2_RXP : in  STD_LOGIC;
           SFP0_TXN : out  STD_LOGIC;
           SFP0_TXP : out  STD_LOGIC;
           SFP1_TXN : out  STD_LOGIC;
           SFP1_TXP : out  STD_LOGIC;
           SFP2_TXN : out  STD_LOGIC;
           SFP2_TXP : out  STD_LOGIC;
           SFP_REFCLK_N : in  STD_LOGIC;
           SFP_REFCLK_P : in  STD_LOGIC;
           AMC_REFCLK_N : in  STD_LOGIC;
           AMC_REFCLK_P : in  STD_LOGIC;
           AMC_RXN : in  STD_LOGIC_VECTOR(12 downto 1);
           AMC_RXP : in  STD_LOGIC_VECTOR(12 downto 1);
           AMC_TXN : out  STD_LOGIC_VECTOR(12 downto 1);
           AMC_TXP : out  STD_LOGIC_VECTOR(12 downto 1);
-- signal to/from DTC_T2
           S6LINK_RXN : in  STD_LOGIC;
           S6LINK_RXP : in  STD_LOGIC;
           S6LINK_TXN : out  STD_LOGIC;
           S6LINK_TXP : out  STD_LOGIC;
           S2V_p : in  STD_LOGIC;
           S2V_n : in  STD_LOGIC;
           V2S_p : out  STD_LOGIC;
           V2S_n : out  STD_LOGIC;
           GbE_REFCLK_N : in  STD_LOGIC;
           GbE_REFCLK_P : in  STD_LOGIC);
end AMC13_T1;

architecture Behavioral of AMC13_T1 is
COMPONENT TTS_if
	PORT(
		sysclk : IN std_logic;
		CDRclk : IN std_logic;
		local_TTC : in  STD_LOGIC;
		TTC_Ready : IN std_logic;
		TTC_strobe : IN std_logic;
		TTS : IN std_logic_vector(3 downto 0);
		BC0 : IN std_logic;
		L1A_trig : IN std_logic;          
		TTS_out_p : OUT std_logic;
		TTS_out_n : OUT std_logic
		);
END COMPONENT;
COMPONENT ttc_if
	PORT(
		clk : IN std_logic;
		refclk : IN std_logic;
		reset : IN std_logic;
		run : IN std_logic;
		sys_lock : IN std_logic;
		local_TTC : IN std_logic;
		CDRclk_p : IN std_logic;
		CDRclk_n : IN std_logic;
		CDRdata_p : IN std_logic;
		CDRdata_n : IN std_logic;
		TTC_LOS : IN std_logic;
		TTC_LOL : IN std_logic;
		BCN_off : IN std_logic_vector(12 downto 0);
		OC_off : IN std_logic_vector(3 downto 0);
		en_cal_win : IN std_logic;
		cal_win_high : IN std_logic_vector(11 downto 0);
		cal_win_low : IN std_logic_vector(11 downto 0);
		en_localL1A : IN std_logic;
		LocalL1A_cfg : IN std_logic_vector(31 downto 0);
		localL1A_s : IN std_logic;
		localL1A_r : IN std_logic;
    EvnRSt_l : in std_logic;
    OcnRSt_l : in std_logic;
		ovfl_warning : IN std_logic;
		en_brcst : IN std_logic;
		state : IN std_logic_vector(3 downto 0);
		evn_fifo_full : IN std_logic;          
		BC0 : OUT std_logic;
		TTC_strobe : OUT std_logic;
		CDRclk_TTS : OUT std_logic;
		DIV4 : OUT std_logic;
		DIV_nRST : OUT std_logic;
		CDRclk_out : OUT std_logic;
		TTCdata_p : OUT std_logic;
		TTCdata_n : OUT std_logic;
		CalType : OUT std_logic_vector(3 downto 0);
		TTC_Brcst : OUT std_logic_vector(3 downto 0);
		localL1A_periodic : OUT std_logic;
		ttc_start : OUT std_logic;
		ttc_stop : OUT std_logic;
		ttc_soft_reset : OUT std_logic;
		ttc_ready : OUT std_logic;
		ttc_serr : OUT std_logic;
		ttc_derr : OUT std_logic;
		ttc_bcnt_err : OUT std_logic;
		rate_OFW : OUT std_logic;
		sync_lost : OUT std_logic;
		inc_oc : OUT std_logic;
		inc_l1ac : OUT std_logic;
		inc_bcnterr : OUT std_logic;
		inc_serr : OUT std_logic;
		inc_derr : OUT std_logic;
		ttc_evcnt_reset : OUT std_logic;
		event_number_avl : OUT std_logic;
		event_number : OUT std_logic_vector(59 downto 0)
		);
END COMPONENT;
COMPONENT ddr_buf_ctrl
	PORT(
		clk : IN std_logic;
		reset : IN std_logic;
		buf_rqst : IN std_logic_vector(1 downto 0);
		TCP_rqst : IN std_logic_vector(2 downto 0);
		TCP_addr : in  array3X13;
		buf_addr_re : IN std_logic;          
--		buf_full : OUT std_logic;
		TCP_ack : OUT std_logic_vector(2 downto 0);
		buf_addr_avl : OUT std_logic;
		buf_addr : OUT std_logic_vector(12 downto 0);
		TCPbuf_avl : OUT std_logic;
		mon_buf_avl : OUT std_logic
		);
END COMPONENT;
COMPONENT AMC_if
	PORT(
		sysclk : IN std_logic;
		ipb_clk : IN std_logic;
		DRPclk : IN std_logic;
		reset : IN std_logic;
		GTXreset : IN std_logic;
		resetCntr : IN std_logic;
		run : IN std_logic;
		en_localL1A : IN std_logic;
		test : IN std_logic;
		fake_length : IN std_logic_vector(11 downto 0);
		T1_version : IN std_logic_vector(7 downto 0);
		Source_ID : IN std_logic_vector(19 downto 0);
		AMC_en : IN std_logic_vector(11 downto 0);
		AMC_REFCLK_P : IN std_logic;
		AMC_REFCLK_N : IN std_logic;
		AMC_RXN : IN std_logic_vector(12 downto 1);
		AMC_RXP : IN std_logic_vector(12 downto 1);
		evt_data_re : IN std_logic_vector(2 downto 0);
		inc_ddr_pa : IN std_logic;
		ddr_pa : IN std_logic_vector(12 downto 0);
		mon_buf_addr_we : IN std_logic;
		mon_buf_avl : IN std_logic;
		TCPbuf_avl : IN std_logic;
		en_XGbE : IN std_logic;
--		buf_full : IN std_logic;
		ipb_write : IN std_logic;
		ipb_strobe : IN std_logic;
		ipb_addr : IN std_logic_vector(31 downto 0);
		ipb_wdata : IN std_logic_vector(31 downto 0);
		TTC_clk : IN std_logic;
		TTC_LOS : IN std_logic;
		BC0 : IN std_logic;
		bcnt : IN std_logic_vector(3 downto 0);
		ttc_evcnt_reset : IN std_logic;
		event_number_avl : IN std_logic;
		event_number : IN std_logic_vector(59 downto 0);          
		AMC_Ready : OUT std_logic_vector(11 downto 0);
		BC0_lock : OUT std_logic_vector(11 downto 0);
		AMC_TXN : OUT std_logic_vector(12 downto 1);
		AMC_TXP : OUT std_logic_vector(12 downto 1);
		AMC_status : OUT std_logic_vector(31 downto 0);
		evt_data : OUT array3X65;
		evt_buf_full : in std_logic_vector(2 downto 0);
		evt_data_we : out std_logic_vector(2 downto 0);
		evt_data_rdy : OUT std_logic_vector(2 downto 0);
		event_size : OUT std_logic_vector(2 downto 0);
		mon_bufFull : OUT std_logic;
		mon_bufAlmostFull : OUT std_logic;
		mon_buf_empty : OUT std_logic;
		inc_mon_cntr : OUT std_logic;
		mon_evt_wc : OUT std_logic_vector(31 downto 0);
		mon_evt_cnt : OUT std_logic_vector(31 downto 0);
		mon_ctrl : OUT std_logic_vector(31 downto 0);
		mon_wp : OUT std_logic_vector(31 downto 0);
		buf_rqst : OUT std_logic_vector(1 downto 0);
		ipb_rdata : OUT std_logic_vector(31 downto 0);
		ipb_ack : OUT std_logic;
		evn_buf_full : OUT std_logic;
		ovfl_warning : OUT std_logic;
		TrigData : OUT std_logic_vector(7 downto 0);
		TTS : OUT std_logic_vector(3 downto 0)
		);
END COMPONENT;
COMPONENT I2C
	PORT(
		clk : IN std_logic;
		ipb_clk : IN std_logic;
		reset : IN std_logic;
--		ns2500 : IN std_logic;
		addr : IN std_logic_vector(31 downto 0);
		SFP_ABS : IN std_logic_vector(3 downto 0);
		SFP_LOS : IN std_logic_vector(2 downto 0);    
		CLK_SDA : INOUT std_logic;
		SFP_SDA : INOUT std_logic_vector(3 downto 0);      
		rdata : OUT std_logic_vector(31 downto 0);
		CLK_rdy : OUT std_logic;
		CLK_SCL : OUT std_logic;
		SFP_SCL : OUT std_logic_vector(3 downto 0)
		);
END COMPONENT;
COMPONENT SPI_if
	PORT(
		SCK : IN std_logic;
		CSn : IN std_logic;
		MOSI : IN std_logic;
		SN : IN std_logic_vector(7 downto 0);
		IsT1 : IN std_logic;
		SPI_rdata : IN std_logic_vector(7 downto 0);          
		MISO : OUT std_logic;
		SPI_we : OUT std_logic;
		newIPADDR : OUT std_logic;
		IPADDR : OUT std_logic_vector(31 downto 0);
		SPI_wdata : OUT std_logic_vector(7 downto 0);
		SPI_addr : OUT std_logic_vector(7 downto 0)
		);
END COMPONENT;
COMPONENT BRAM_8
  PORT (
    clka : IN STD_LOGIC;
    wea : IN STD_LOGIC_VECTOR(0 DOWNTO 0);
    addra : IN STD_LOGIC_VECTOR(10 DOWNTO 0);
    dina : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
    douta : OUT STD_LOGIC_VECTOR(7 DOWNTO 0)
  );
END COMPONENT;
COMPONENT ddr_if
	port(
		clk_ref     												: in    std_logic;
		mem_clk_p    												: in    std_logic;
		mem_clk_n    												: in    std_logic;
		mem_rst		   												: in    std_logic;
    sysclk	                            : in   std_logic;
    reset 	                            : in   std_logic;
    resetsys 	                          : in   std_logic;
    run			                           	: in   std_logic;
    mem_test	                          : in   std_logic_VECTOR(1 downto 0);
    EventData	                          : in   array3X65;
    EventData_we                        : in   std_logic_VECTOR(2 downto 0);
    wport_rdy	                        	: out  std_logic_VECTOR(2 downto 0);
    EventBufAddr                        : in   std_logic_VECTOR(12 downto 0);
    EventBufAddr_we	                    : in   std_logic_VECTOR(2 downto 0);
    EventFIFOfull		                    : out   std_logic_VECTOR(2 downto 0);
    TCP_din 														: in  array3X32; -- TCP data are written in unit of 32-bit words
    TCP_waddr 													: in  array3X13; -- each XGbE channel can store 8192 entries
    TCP_wrqst 													: in  STD_LOGIC_VECTOR (2 downto 0);
    TCP_re	 														: out  STD_LOGIC_VECTOR (2 downto 0);
		TCP_dout														: out  STD_LOGIC_VECTOR(31 downto 0); -- TCP data are written in unit of 32-bit words
		TCP_raddr														: in  array3X24;
		TCP_length													: in  array3X14; -- in 32 bit word
		TCP_dout_valid											: out  STD_LOGIC_VECTOR (2 downto 0);
		TCP_rrqst														:	in  STD_LOGIC_VECTOR (2 downto 0);
		TCP_rack														: out  STD_LOGIC_VECTOR (2 downto 0);
		TCP_lastword												: out  STD_LOGIC;
--	ipbus signals
    ipb_clk															: in  STD_LOGIC;
    ipb_write														: in  STD_LOGIC;
    ipb_strobe													: in  STD_LOGIC;
    page_addr														: in  STD_LOGIC_VECTOR(11 downto 0);
    ipb_addr														: in  STD_LOGIC_VECTOR(31 downto 0);
    ipb_wdata														: in  STD_LOGIC_VECTOR(31 downto 0);
    ipb_rdata														: out  STD_LOGIC_VECTOR(31 downto 0);
    ipb_ack															: out  STD_LOGIC;
		mem_stat 														: out  STD_LOGIC_VECTOR (63 downto 0);
    device_temp													: in  STD_LOGIC_VECTOR(11 downto 0);
-- ddr3 memory pins
		ddr3_dq 														: inout  STD_LOGIC_VECTOR (31 downto 0);
		ddr3_dm 														: out  STD_LOGIC_VECTOR (3 downto 0);
		ddr3_addr 													: out  STD_LOGIC_VECTOR (13 downto 0);
		ddr3_ba 														: out  STD_LOGIC_VECTOR (2 downto 0);
		ddr3_dqs_p 													: inout  STD_LOGIC_VECTOR (3 downto 0);
		ddr3_dqs_n 													: inout  STD_LOGIC_VECTOR (3 downto 0);
		ddr3_ras_n 													: out  STD_LOGIC;
		ddr3_cas_n 													: out  STD_LOGIC;
		ddr3_we_n 													: out  STD_LOGIC;
		ddr3_reset_n 												: out  STD_LOGIC;
		ddr3_cke 														: out  STD_LOGIC_vector(0 to 0);
		ddr3_odt 														: out  STD_LOGIC_vector(0 to 0);
		ddr3_ck_p 													: out  STD_LOGIC_vector(0 to 0);
		ddr3_ck_n 													: out  STD_LOGIC_vector(0 to 0)
		);
END COMPONENT;
component SFP3 
generic
(
    -- Simulation attributes
    WRAPPER_SIM_GTRESET_SPEEDUP    : string    := "FALSE" -- Set to 1 to speed up sim reset

);
port
(

    --_________________________________________________________________________
    --_________________________________________________________________________
    --GT0  (X0Y13)
    --____________________________CHANNEL PORTS________________________________
    ------------------------------- Eye Scan Ports -----------------------------
    GT0_EYESCANDATAERROR_OUT                : out  std_logic;
    ------------------------ Loopback and Powerdown Ports ----------------------
    GT0_LOOPBACK_IN                         : in   std_logic_vector(2 downto 0);
    ------------------------------- Receive Ports ------------------------------
    GT0_RXUSERRDY_IN                        : in   std_logic;
    -------------- Receive Ports - 64b66b and 64b67b Gearbox Ports -------------
    GT0_RXDATAVALID_OUT                     : out  std_logic;
    GT0_RXGEARBOXSLIP_IN                    : in   std_logic;
    GT0_RXHEADER_OUT                        : out  std_logic_vector(1 downto 0);
    GT0_RXHEADERVALID_OUT                   : out  std_logic;
    ----------------------- Receive Ports - PRBS Detection ---------------------
    GT0_RXPRBSCNTRESET_IN                   : in   std_logic;
    GT0_RXPRBSERR_OUT                       : out  std_logic;
    GT0_RXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
    ------------------- Receive Ports - RX Data Path interface -----------------
    GT0_GTRXRESET_IN                        : in   std_logic;
    GT0_RXDATA_OUT                          : out  std_logic_vector(31 downto 0);
    GT0_RXOUTCLK_OUT                        : out  std_logic;
    GT0_RXPCSRESET_IN                       : in   std_logic;
    GT0_RXUSRCLK_IN                         : in   std_logic;
    GT0_RXUSRCLK2_IN                        : in   std_logic;
    ------- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
    GT0_GTXRXN_IN                           : in   std_logic;
    GT0_GTXRXP_IN                           : in   std_logic;
    GT0_RXCDRLOCK_OUT                       : out  std_logic;
    GT0_RXELECIDLE_OUT                      : out  std_logic;
    -------- Receive Ports - RX Elastic Buffer and Phase Alignment Ports -------
    GT0_RXBUFRESET_IN                       : in   std_logic;
    GT0_RXBUFSTATUS_OUT                     : out  std_logic_vector(2 downto 0);
    ------------------------ Receive Ports - RX PLL Ports ----------------------
    GT0_RXRESETDONE_OUT                     : out  std_logic;
    ----------------- Receive Ports - RX Polarity Control Ports ----------------
    GT0_RXPOLARITY_IN                       : in   std_logic;
    ------------------------------- Transmit Ports -----------------------------
    GT0_TXUSERRDY_IN                        : in   std_logic;
    -------------- Transmit Ports - 64b66b and 64b67b Gearbox Ports ------------
    GT0_TXHEADER_IN                         : in   std_logic_vector(1 downto 0);
    GT0_TXSEQUENCE_IN                       : in   std_logic_vector(6 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    GT0_GTTXRESET_IN                        : in   std_logic;
    GT0_TXDATA_IN                           : in   std_logic_vector(31 downto 0);
    GT0_TXOUTCLK_OUT                        : out  std_logic;
    GT0_TXOUTCLKFABRIC_OUT                  : out  std_logic;
    GT0_TXOUTCLKPCS_OUT                     : out  std_logic;
    GT0_TXPCSRESET_IN                       : in   std_logic;
    GT0_TXUSRCLK_IN                         : in   std_logic;
    GT0_TXUSRCLK2_IN                        : in   std_logic;
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    GT0_GTXTXN_OUT                          : out  std_logic;
    GT0_GTXTXP_OUT                          : out  std_logic;
    ----------------------- Transmit Ports - TX PLL Ports ----------------------
    GT0_TXRESETDONE_OUT                     : out  std_logic;
    --------------------- Transmit Ports - TX PRBS Generator -------------------
    GT0_TXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
    -------------------- Transmit Ports - TX Polarity Control ------------------
    GT0_TXPOLARITY_IN                       : in   std_logic;
   
    --_________________________________________________________________________
    --_________________________________________________________________________
    --GT1  (X0Y14)
    --____________________________CHANNEL PORTS________________________________
    ------------------------------- Eye Scan Ports -----------------------------
    GT1_EYESCANDATAERROR_OUT                : out  std_logic;
    ------------------------ Loopback and Powerdown Ports ----------------------
    GT1_LOOPBACK_IN                         : in   std_logic_vector(2 downto 0);
    ------------------------------- Receive Ports ------------------------------
    GT1_RXUSERRDY_IN                        : in   std_logic;
    -------------- Receive Ports - 64b66b and 64b67b Gearbox Ports -------------
    GT1_RXDATAVALID_OUT                     : out  std_logic;
    GT1_RXGEARBOXSLIP_IN                    : in   std_logic;
    GT1_RXHEADER_OUT                        : out  std_logic_vector(1 downto 0);
    GT1_RXHEADERVALID_OUT                   : out  std_logic;
    ----------------------- Receive Ports - PRBS Detection ---------------------
    GT1_RXPRBSCNTRESET_IN                   : in   std_logic;
    GT1_RXPRBSERR_OUT                       : out  std_logic;
    GT1_RXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
    ------------------- Receive Ports - RX Data Path interface -----------------
    GT1_GTRXRESET_IN                        : in   std_logic;
    GT1_RXDATA_OUT                          : out  std_logic_vector(31 downto 0);
    GT1_RXOUTCLK_OUT                        : out  std_logic;
    GT1_RXPCSRESET_IN                       : in   std_logic;
    GT1_RXUSRCLK_IN                         : in   std_logic;
    GT1_RXUSRCLK2_IN                        : in   std_logic;
    ------- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
    GT1_GTXRXN_IN                           : in   std_logic;
    GT1_GTXRXP_IN                           : in   std_logic;
    GT1_RXCDRLOCK_OUT                       : out  std_logic;
    GT1_RXELECIDLE_OUT                      : out  std_logic;
    -------- Receive Ports - RX Elastic Buffer and Phase Alignment Ports -------
    GT1_RXBUFRESET_IN                       : in   std_logic;
    GT1_RXBUFSTATUS_OUT                     : out  std_logic_vector(2 downto 0);
    ------------------------ Receive Ports - RX PLL Ports ----------------------
    GT1_RXRESETDONE_OUT                     : out  std_logic;
    ----------------- Receive Ports - RX Polarity Control Ports ----------------
    GT1_RXPOLARITY_IN                       : in   std_logic;
    ------------------------------- Transmit Ports -----------------------------
    GT1_TXUSERRDY_IN                        : in   std_logic;
    -------------- Transmit Ports - 64b66b and 64b67b Gearbox Ports ------------
    GT1_TXHEADER_IN                         : in   std_logic_vector(1 downto 0);
    GT1_TXSEQUENCE_IN                       : in   std_logic_vector(6 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    GT1_GTTXRESET_IN                        : in   std_logic;
    GT1_TXDATA_IN                           : in   std_logic_vector(31 downto 0);
    GT1_TXOUTCLK_OUT                        : out  std_logic;
    GT1_TXOUTCLKFABRIC_OUT                  : out  std_logic;
    GT1_TXOUTCLKPCS_OUT                     : out  std_logic;
    GT1_TXPCSRESET_IN                       : in   std_logic;
    GT1_TXUSRCLK_IN                         : in   std_logic;
    GT1_TXUSRCLK2_IN                        : in   std_logic;
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    GT1_GTXTXN_OUT                          : out  std_logic;
    GT1_GTXTXP_OUT                          : out  std_logic;
    ----------------------- Transmit Ports - TX PLL Ports ----------------------
    GT1_TXRESETDONE_OUT                     : out  std_logic;
    --------------------- Transmit Ports - TX PRBS Generator -------------------
    GT1_TXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
    -------------------- Transmit Ports - TX Polarity Control ------------------
    GT1_TXPOLARITY_IN                       : in   std_logic;
   
    --_________________________________________________________________________
    --_________________________________________________________________________
    --GT2  (X0Y15)
    --____________________________CHANNEL PORTS________________________________
    ------------------------------- Eye Scan Ports -----------------------------
    GT2_EYESCANDATAERROR_OUT                : out  std_logic;
    ------------------------ Loopback and Powerdown Ports ----------------------
    GT2_LOOPBACK_IN                         : in   std_logic_vector(2 downto 0);
    ------------------------------- Receive Ports ------------------------------
    GT2_RXUSERRDY_IN                        : in   std_logic;
    -------------- Receive Ports - 64b66b and 64b67b Gearbox Ports -------------
    GT2_RXDATAVALID_OUT                     : out  std_logic;
    GT2_RXGEARBOXSLIP_IN                    : in   std_logic;
    GT2_RXHEADER_OUT                        : out  std_logic_vector(1 downto 0);
    GT2_RXHEADERVALID_OUT                   : out  std_logic;
    ----------------------- Receive Ports - PRBS Detection ---------------------
    GT2_RXPRBSCNTRESET_IN                   : in   std_logic;
    GT2_RXPRBSERR_OUT                       : out  std_logic;
    GT2_RXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
    ------------------- Receive Ports - RX Data Path interface -----------------
    GT2_GTRXRESET_IN                        : in   std_logic;
    GT2_RXDATA_OUT                          : out  std_logic_vector(31 downto 0);
    GT2_RXOUTCLK_OUT                        : out  std_logic;
    GT2_RXPCSRESET_IN                       : in   std_logic;
    GT2_RXUSRCLK_IN                         : in   std_logic;
    GT2_RXUSRCLK2_IN                        : in   std_logic;
    ------- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
    GT2_GTXRXN_IN                           : in   std_logic;
    GT2_GTXRXP_IN                           : in   std_logic;
    GT2_RXCDRLOCK_OUT                       : out  std_logic;
    GT2_RXELECIDLE_OUT                      : out  std_logic;
    -------- Receive Ports - RX Elastic Buffer and Phase Alignment Ports -------
    GT2_RXBUFRESET_IN                       : in   std_logic;
    GT2_RXBUFSTATUS_OUT                     : out  std_logic_vector(2 downto 0);
    ------------------------ Receive Ports - RX PLL Ports ----------------------
    GT2_RXRESETDONE_OUT                     : out  std_logic;
    ----------------- Receive Ports - RX Polarity Control Ports ----------------
    GT2_RXPOLARITY_IN                       : in   std_logic;
    ------------------------------- Transmit Ports -----------------------------
    GT2_TXUSERRDY_IN                        : in   std_logic;
    -------------- Transmit Ports - 64b66b and 64b67b Gearbox Ports ------------
    GT2_TXHEADER_IN                         : in   std_logic_vector(1 downto 0);
    GT2_TXSEQUENCE_IN                       : in   std_logic_vector(6 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    GT2_GTTXRESET_IN                        : in   std_logic;
    GT2_TXDATA_IN                           : in   std_logic_vector(31 downto 0);
    GT2_TXOUTCLK_OUT                        : out  std_logic;
    GT2_TXOUTCLKFABRIC_OUT                  : out  std_logic;
    GT2_TXOUTCLKPCS_OUT                     : out  std_logic;
    GT2_TXPCSRESET_IN                       : in   std_logic;
    GT2_TXUSRCLK_IN                         : in   std_logic;
    GT2_TXUSRCLK2_IN                        : in   std_logic;
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    GT2_GTXTXN_OUT                          : out  std_logic;
    GT2_GTXTXP_OUT                          : out  std_logic;
    ----------------------- Transmit Ports - TX PLL Ports ----------------------
    GT2_TXRESETDONE_OUT                     : out  std_logic;
    --------------------- Transmit Ports - TX PRBS Generator -------------------
    GT2_TXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
    -------------------- Transmit Ports - TX Polarity Control ------------------
    GT2_TXPOLARITY_IN                       : in   std_logic;
   

    --____________________________COMMON PORTS________________________________
    ---------------------- Common Block  - Ref Clock Ports ---------------------
    GT0_GTREFCLK0_COMMON_IN                 : in   std_logic;
    ------------------------- Common Block - QPLL Ports ------------------------
    GT0_QPLLLOCK_OUT                        : out  std_logic;
    GT0_QPLLLOCKDETCLK_IN                   : in   std_logic;
    GT0_QPLLREFCLKLOST_OUT                  : out  std_logic;
    GT0_QPLLRESET_IN                        : in   std_logic


);
end component;
COMPONENT DAQLSC
		Generic (
					 N : integer := 11;
					 INPUT_CLK_TYPE : string := "SINGLE_ENDED";
--					 INPUT_CLK_TYPE : string := "DIFFERENTIAL";
					 RXPOLARITY : std_logic := '0';
					 TXPOLARITY : std_logic := '1');
	PORT(
		sysclk : IN std_logic;
		reset : IN std_logic;
		GTX_RESET : IN std_logic;
		GTX_UsrClk : in  STD_LOGIC;
		GTX_TxOutClk : out  STD_LOGIC;
		ce : IN std_logic;
		LinkWe : IN std_logic;
		LinkCtrl : IN std_logic;
		LinkData : IN std_logic_vector(63 downto 0);
		src_ID : IN std_logic_vector(15 downto 0);
		inject_err : IN std_logic_VECTOR (17 downto 0);
		read_ce : IN std_logic;
		addr : IN std_logic_vector(15 downto 0);
		REFCLK_N : IN std_logic;
		REFCLK_P : IN std_logic;
		REFCLK : IN std_logic;
		SFP_RXN : IN std_logic;
		SFP_RXP : IN std_logic;          
		LinkAlmostFull : OUT std_logic;
		LinkDown : OUT std_logic;
		status_data : OUT std_logic_vector(63 downto 0);
		SFP_TXN : OUT std_logic;
		SFP_TXP : OUT std_logic
		);
END COMPONENT;
COMPONENT DAQcheck
		Generic (
					 INPUT_CLK_TYPE : string := "SINGLE_ENDED";
--					 INPUT_CLK_TYPE : string := "DIFFERENTIAL";
					 RXPOLARITY : std_logic := '1';
					 TXPOLARITY : std_logic := '1');
	PORT(
		reset : IN std_logic;
		GTX_RESET : IN std_logic;
		GTX_UsrClk : IN std_logic;
		sysclk : IN std_logic;
		src_ID : IN std_logic_vector(15 downto 0);
		inject_err : IN std_logic_vector(17 downto 0);
		REFCLK_N : IN std_logic;
		REFCLK_P : IN std_logic;
		REFCLK : IN std_logic;
		SFP_RXN : IN std_logic;
		SFP_RXP : IN std_logic;          
		GTX_TxOutClk : OUT std_logic;
		status_data : OUT std_logic_vector(63 downto 0);
		SFP_TXN : OUT std_logic;
		SFP_TXP : OUT std_logic
		);
END COMPONENT;
COMPONENT ipbus_if
	generic(RXPOLARITY : std_logic := '0'; TXPOLARITY : std_logic := '0');
	port(
		ipb_clk																	: IN std_logic;
		UsRclk																	: IN std_logic;
		DRPclk																	: IN std_logic;
		got_SN																	: out std_logic;
		reset 																	: IN std_logic;
		GTX_RESET															  : IN std_logic;
    GbE_REFCLK	                       	  	: in   std_logic;
    S6LINK_RXN                            	: in   std_logic;
    S6LINK_RXP                            	: in   std_logic;
    S6LINK_TXN                            	: out  std_logic;
    S6LINK_TXP                            	: out  std_logic;
		wr_amc_en																: in std_logic;
    amc_en																	: in  STD_LOGIC_VECTOR(11 downto 0);
    IPADDR																	: in  STD_LOGIC_VECTOR(31 downto 0);
    MACADDR																	: in  STD_LOGIC_VECTOR(47 downto 0);
	  ipb_out																	: out ipb_wbus;
	  ipb_in																	: in ipb_rbus;
    SN																			: out  STD_LOGIC_VECTOR(7 downto 0);
		debug_in																: IN std_logic_vector(31 downto 0);
		debug_out																: OUT std_logic_vector(127 downto 0)
		);
end COMPONENT;
COMPONENT sysmon_if
	PORT(
		DRPclk : IN std_logic;
		SN : IN std_logic_vector(7 downto 0);
		VAUXN_IN : IN std_logic_vector(12 downto 0);
		VAUXP_IN : IN std_logic_vector(12 downto 0);
		addr : IN std_logic_vector(15 downto 0);          
		data : OUT std_logic_vector(31 downto 0);
		device_temp : OUT std_logic_vector(11 downto 0);
		ALM : OUT std_logic_vector(7 downto 0);
		OT : OUT std_logic
		);
END COMPONENT;
COMPONENT check_HTRCRC
	PORT(
		sysclk : IN std_logic;
		reset : IN std_logic;
		HTR_en : IN std_logic_vector(11 downto 0);
		LinkWe : IN std_logic;
		LinkCtrl : IN std_logic;
		LinkData : IN std_logic_vector(63 downto 0);          
		inc_HTRCRC_err : OUT std_logic
		);
END COMPONENT;
COMPONENT SFP_if
	PORT(
		DRPclk : IN std_logic;
		reset : IN std_logic;
		rstCntr : IN std_logic;
		test : IN std_logic;
		SFP0_RXN : IN std_logic;
		SFP0_RXP : IN std_logic;
		SFP1_RXN : IN std_logic;
		SFP1_RXP : IN std_logic;
		SFP2_RXN : IN std_logic;
		SFP2_RXP : IN std_logic;
		SFP_REFCLK_N : IN std_logic;
		SFP_REFCLK_P : IN std_logic;
		SFP0_CLIENTEMACTXD : IN std_logic_vector(31 downto 0);
		SFP0_CLIENTEMACTXDBYTECNT : IN std_logic_vector(1 downto 0);
		SFP0_CLIENTEMACTXDVLD : IN std_logic;
		SFP0_CLIENTEMACTXUNDERRUN : IN std_logic;
		SFP1_CLIENTEMACTXD : IN std_logic_vector(31 downto 0);
		SFP1_CLIENTEMACTXDBYTECNT : IN std_logic_vector(1 downto 0);
		SFP1_CLIENTEMACTXDVLD : IN std_logic;
		SFP1_CLIENTEMACTXUNDERRUN : IN std_logic;
		SFP2_CLIENTEMACTXD : IN std_logic_vector(31 downto 0);
		SFP2_CLIENTEMACTXDBYTECNT : IN std_logic_vector(1 downto 0);
		SFP2_CLIENTEMACTXDVLD : IN std_logic;
		SFP2_CLIENTEMACTXUNDERRUN : IN std_logic;
		ipb_clk : IN std_logic;
		ipb_write : IN std_logic;
		ipb_strobe : IN std_logic;
		ipb_addr : IN std_logic_vector(31 downto 0);
		ipb_wdata : IN std_logic_vector(31 downto 0);          
		REFCLK2X_OUT : OUT std_logic;
		SFP0_TXN : OUT std_logic;
		SFP0_TXP : OUT std_logic;
		SFP1_TXN : OUT std_logic;
		SFP1_TXP : OUT std_logic;
		SFP2_TXN : OUT std_logic;
		SFP2_TXP : OUT std_logic;
		SFP0_EMACCLIENTRXD : OUT std_logic_vector(31 downto 0);
		SFP0_EMACCLIENTRXDVLD : OUT std_logic;
		SFP0_EMACCLIENTRXDBYTECNT : OUT std_logic_vector(1 downto 0);
		SFP0_EMACCLIENTRXGOODFRAME : OUT std_logic;
		SFP0_EMACCLIENTRXBADFRAME : OUT std_logic;
		SFP0_EMACCLIENTTXACK : OUT std_logic;
		SFP1_EMACCLIENTRXD : OUT std_logic_vector(31 downto 0);
		SFP1_EMACCLIENTRXDVLD : OUT std_logic;
		SFP1_EMACCLIENTRXDBYTECNT : OUT std_logic_vector(1 downto 0);
		SFP1_EMACCLIENTRXGOODFRAME : OUT std_logic;
		SFP1_EMACCLIENTRXBADFRAME : OUT std_logic;
		SFP1_EMACCLIENTTXACK : OUT std_logic;
		SFP2_EMACCLIENTRXD : OUT std_logic_vector(31 downto 0);
		SFP2_EMACCLIENTRXDVLD : OUT std_logic;
		SFP2_EMACCLIENTRXDBYTECNT : OUT std_logic_vector(1 downto 0);
		SFP2_EMACCLIENTRXGOODFRAME : OUT std_logic;
		SFP2_EMACCLIENTRXBADFRAME : OUT std_logic;
		SFP2_EMACCLIENTTXACK : OUT std_logic;
		ipb_rdata : OUT std_logic_vector(31 downto 0);
		ipb_ack : OUT std_logic
		);
END COMPONENT;
COMPONENT TCP_if
	PORT(
		sysclk : IN std_logic;
		SFP_clk : IN std_logic;
		reset : IN std_logic;
		en_XGbE : IN std_logic;
		buf_addr : IN std_logic_vector(12 downto 0);
		buf_addr_avl : IN std_logic;
		wport_rdy : IN std_logic_vector(2 downto 0);
		evt_data_rdy : IN std_logic_vector(2 downto 0);
		event_size : IN std_logic_vector(2 downto 0);
		EventData : IN array3X65;
		EventBufAddrRe : out   std_logic;
		EventData_we : IN std_logic_vector(2 downto 0);
		TCP_re : IN std_logic_vector(2 downto 0);
		TCP_dout : IN std_logic_vector(31 downto 0);
		TCP_dout_valid : IN std_logic_vector(2 downto 0);
		TCP_rack : IN std_logic_vector(2 downto 0);
		TCP_lastword : IN std_logic;
		ipb_clk : IN std_logic;
		ipb_write : IN std_logic;
		ipb_strobe : IN std_logic;
		ipb_addr : IN std_logic_vector(31 downto 0);
		Link_established : IN std_logic_vector(2 downto 0);
		SFP0_EMACCLIENTRXD : IN std_logic_vector(31 downto 0);
		SFP0_EMACCLIENTRXDVLD : IN std_logic;
		SFP0_EMACCLIENTRXDBYTECNT : IN std_logic_vector(1 downto 0);
		SFP0_EMACCLIENTRXGOODFRAME : IN std_logic;
		SFP0_EMACCLIENTRXBADFRAME : IN std_logic;
		SFP0_EMACCLIENTTXACK : IN std_logic;
		SFP1_EMACCLIENTRXD : IN std_logic_vector(31 downto 0);
		SFP1_EMACCLIENTRXDVLD : IN std_logic;
		SFP1_EMACCLIENTRXDBYTECNT : IN std_logic_vector(1 downto 0);
		SFP1_EMACCLIENTRXGOODFRAME : IN std_logic;
		SFP1_EMACCLIENTRXBADFRAME : IN std_logic;
		SFP1_EMACCLIENTTXACK : IN std_logic;
		SFP2_EMACCLIENTRXD : IN std_logic_vector(31 downto 0);
		SFP2_EMACCLIENTRXDVLD : IN std_logic;
		SFP2_EMACCLIENTRXDBYTECNT : IN std_logic_vector(1 downto 0);
		SFP2_EMACCLIENTRXGOODFRAME : IN std_logic;
		SFP2_EMACCLIENTRXBADFRAME : IN std_logic;
		SFP2_EMACCLIENTTXACK : IN std_logic;          
		evt_data_re : OUT std_logic_vector(2 downto 0);
		EventBufAddr_we : OUT std_logic_vector(2 downto 0);
		TCP_releaseAddr : OUT array3X13;
		TCP_releaseRqst : OUT std_logic_vector(2 downto 0);
		TCP_releaseAck : IN std_logic_vector(2 downto 0);
		TCP_din : OUT array3X32;
		TCP_waddr : OUT array3X13;
		TCP_wrqst : OUT std_logic_vector(2 downto 0);
		TCP_raddr : OUT array3X24;
		TCP_length : OUT array3X14;
		TCP_rrqst : OUT std_logic_vector(2 downto 0);
		ipb_rdata : OUT std_logic_vector(31 downto 0);
		ipb_ack : OUT std_logic;
		SFP0_CLIENTEMACTXD : OUT std_logic_vector(31 downto 0);
		SFP0_CLIENTEMACTXDBYTECNT : OUT std_logic_vector(1 downto 0);
		SFP0_CLIENTEMACTXDVLD : OUT std_logic;
		SFP0_CLIENTEMACTXUNDERRUN : OUT std_logic;
		SFP1_CLIENTEMACTXD : OUT std_logic_vector(31 downto 0);
		SFP1_CLIENTEMACTXDBYTECNT : OUT std_logic_vector(1 downto 0);
		SFP1_CLIENTEMACTXDVLD : OUT std_logic;
		SFP1_CLIENTEMACTXUNDERRUN : OUT std_logic;
		SFP2_CLIENTEMACTXD : OUT std_logic_vector(31 downto 0);
		SFP2_CLIENTEMACTXDBYTECNT : OUT std_logic_vector(1 downto 0);
		SFP2_CLIENTEMACTXDVLD : OUT std_logic;
		SFP2_CLIENTEMACTXUNDERRUN : OUT std_logic
		);
END COMPONENT;
constant ipbus_ver_addr : std_logic_vector(15 downto 0) := x"0000";
constant ipbus_sfp_addr: std_logic_vector(15 downto 0) := x"0002";
--constant SPI_data_addr: std_logic_vector(8 downto 0) := "000000100";
--constant SPI_IP_addr: std_logic_vector(8 downto 0) := "000001000";
-- polarity = '1' means that signal's differential pads are swapped, so the input/output signal needs be inverted
--constant AMC_RxPolarity : std_logic_vector(11 downto 0) := x"7d6";
--constant AMC_TxPolarity : std_logic_vector(11 downto 0) := x"ffd";
constant CDRclk_pol : std_logic := '0';
constant CDRdata_pol : std_logic := '1';
constant TTCclk_pol : std_logic := '1';
constant TTCdata_pol : std_logic := '1';
constant Coarse_Delay: std_logic_vector(3 downto 0) := x"0";
--subtype vector32 is std_logic_vector(31 downto 0);
--subtype vector8 is std_logic_vector(7 downto 0);
--type array_x12y32 is array(11 downto 0) of vector32;
--type array_x12y8 is array(11 downto 0) of vector8;
--signal EthernetSFP : std_logic := '0';
--signal EthernetSFP_q : std_logic := '0';
signal rst_ipbus : std_logic := '0';
signal LDC_UsrClk : std_logic := '0';
signal wr_AMC_en : std_logic := '0';
signal fake_length : std_logic_vector(11 downto 0) := x"400";
signal AMC_en : std_logic_vector(11 downto 0) := (others =>'0');
signal AMC_Ready : std_logic_vector(11 downto 0) := (others =>'0');
signal BC0_lock : std_logic_vector(11 downto 0) := (others =>'0');
signal AMC_status : std_logic_vector(31 downto 0) := (others =>'0');
signal AMC_DATA : std_logic_vector(31 downto 0) := (others =>'0');
signal AMC_ack : std_logic := '0';
signal L1Aovfl_warning : std_logic := '0';
signal TRIGDATA : std_logic_vector(7 downto 0) := (others =>'0');
signal TTS : std_logic_vector(3 downto 0) := (others =>'0');
signal TTS_pattern : std_logic_vector(3 downto 0) := (others =>'0');
signal AMC_trig : std_logic := '0';
signal Trig_mask : std_logic_vector(7 downto 0) := (others =>'0');
--type RAM2048X8 is array(0 to 2047) of std_logic_vector(7 downto 0);
--signal SPI_RAM : RAM2048X8;
signal SPI_SCK_buf : std_logic := '0';
--signal SPI_we : std_logic := '0';
--signal SPI_wr : std_logic_vector(0 downto 0) := (others =>'0');
--signal SPI_wdata : std_logic_vector(7 downto 0) := (others =>'0');
--signal SPI_rdata : std_logic_vector(7 downto 0) := (others =>'0');
--signal ram_data : std_logic_vector(7 downto 0) := (others =>'0');
--signal SPI_addr : std_logic_vector(7 downto 0) := (others =>'0');
signal CLK_rdy : std_logic := '0';
signal I2C_data : std_logic_vector(31 downto 0) := (others =>'0');
signal TTCclk_in : std_logic := '0';
signal TTC_Clk : std_logic := '0';
signal TTC_strobe : std_logic := '0';
signal BcntErr_cnt : std_logic_vector(7 downto 0) := (others =>'0');
signal SinErr_cnt : std_logic_vector(7 downto 0) := (others =>'0');
signal DbErr_cnt : std_logic_vector(7 downto 0) := (others =>'0');
signal L1_reg : std_logic_vector(15 downto 0) := (others =>'0');
signal Bcnt_reg : std_logic_vector(11 downto 0) := (others =>'0');
signal OC_reg : std_logic_vector(31 downto 0) := (others =>'0');
signal V2S : std_logic := '0';
signal S2V : std_logic := '0';
signal S2V_cntr : std_logic_vector(5 downto 0) := (others => '0');
signal S2V_sr : std_logic_vector(3 downto 0) := (others => '0');
signal t_LED : std_logic_vector(3 downto 0) := (others => '0');
--signal clk_div : std_logic_vector(9 downto 0) := (others => '0');
signal ddr_rdata : std_logic_vector(7 downto 0) := (others =>'0');
--signal MMCM_sysclkRST : std_logic := '0';
signal ipb_clk_dcm : std_logic := '0';
signal ipb_clk : std_logic := '0';
signal clk125_dcm : std_logic := '0';
signal clk125 : std_logic := '0';
signal DRPclk_dcm : std_logic := '0';
signal DRPclk : std_logic := '0';
signal sysclk_dcm : std_logic := '0';
signal sysclk : std_logic := '0';
signal clkfb : std_logic := '0';
signal refclk_dcm : std_logic := '0';
signal refclk : std_logic := '0';
signal mem_clk_dcm : std_logic := '0';
signal mem_clk : std_logic := '0';
signal sysclk_inp : std_logic := '0';
signal sysclk_in : std_logic := '0';
--signal clk125 : std_logic := '0';
signal sys_lock : std_logic := '0';
signal ldc_reset : std_logic := '0';
signal ldc_GTXreset : std_logic := '0';
signal lsc_reset : std_logic := '0';
signal lsc_GTXreset : std_logic := '0';
signal amc_reset : std_logic := '0';
signal amc_GTXreset : std_logic := '0';
signal run : std_logic := '0';
signal mem_rst : std_logic := '0';
signal mem_test : std_logic_vector(1 downto 0) := (others =>'0');
signal mem_stat : std_logic_vector(63 downto 0) := (others =>'0');
signal mem_ack : std_logic := '0';
signal mem_data : std_logic_vector(31 downto 0) := (others =>'0');
signal EventData : array3X65 := (others => (others => '0'));
--signal EventData_WrEn : std_logic_vector(2 downto 0) := (others =>'0');
--signal EventData_we : std_logic_vector(2 downto 0) := (others =>'0');
signal wport_rdy : std_logic_vector(2 downto 0) := (others =>'0');
signal EventBufAddr : std_logic_vector(12 downto 0) := (others =>'0');
signal EventBufAddr_we : std_logic_vector(2 downto 0) := (others =>'0');
signal EventFIFOfull : std_logic_vector(2 downto 0) := (others =>'0');
signal TCP_din : array3X32 := (others => (others => '0'));
signal TCP_waddr : array3X13 := (others => (others => '0'));
signal TCP_wrqst : std_logic_vector(2 downto 0) := (others =>'0');
signal TCP_re : std_logic_vector(2 downto 0) := (others =>'0');
signal TCP_dout : std_logic_vector(31 downto 0) := (others =>'0');
signal TCP_raddr : array3X24 := (others => (others => '0'));
signal TCP_length : array3X14 := (others => (others => '0'));
signal TCP_dout_valid : std_logic_vector(2 downto 0) := (others =>'0');
signal TCP_rrqst : std_logic_vector(2 downto 0) := (others =>'0');
signal TCP_rack : std_logic_vector(2 downto 0) := (others =>'0');
signal TCP_lastword : std_logic := '0';
signal mon_bufFull : std_logic := '0';
signal mon_bufAlmostFull : std_logic := '0';
signal mon_buf_empty : std_logic := '0';
signal inc_mon_cntr : std_logic := '0';
signal mon_evt_wc : std_logic_vector(31 downto 0) := (others =>'0');
signal mon_evt_cnt : std_logic_vector(31 downto 0) := (others =>'0');
signal mon_ctrl : std_logic_vector(31 downto 0) := (others =>'0');
signal TCPbuf_avl : std_logic := '0';
--signal EventBuf_full : std_logic := '0';
signal mon_buf_avl : std_logic := '0';
signal mon_buf_addr_we : std_logic := '0';
signal EventBufAddrAvl : std_logic := '0';
signal EventBufAddrRe : std_logic := '0';
signal mon_wp : std_logic_vector(31 downto 0) := (others =>'0');
signal TCP_releaseAck : std_logic_vector(2 downto 0) := (others =>'0');
signal TCP_releaseRqst : std_logic_vector(2 downto 0) := (others =>'0');
signal TCP_releaseAddr : array3X13 := (others => (others => '0'));
signal EventBuf_rqst : std_logic_vector(1 downto 0) := (others =>'0');
--signal LinkRe : std_logic := '0';
--signal LinkWe : std_logic := '0';
--signal LinkCtrl : std_logic := '0';
--signal LinkData : std_logic_vector(65 downto 0) := (others =>'0');
signal rst_cntr : std_logic := '0';
signal rst_ddr_pa : std_logic := '0';
signal inc_ddr_pa : std_logic := '0';
signal Source_ID : std_logic_vector(19 downto 0) := (others =>'0');
signal ddr_pa : std_logic_vector(12 downto 0) := (others =>'0');
signal CDRclk : std_logic := '0';
signal CDRclk_TTS : std_logic := '0';
signal BC0 : std_logic := '0';
signal BC0_dlp : std_logic := '0';
signal BC0_dlp2 : std_logic := '0';
signal BC0_dl : std_logic := '0';
signal BC0_delay : std_logic_vector(4 downto 0) := "11000";
signal bcnt : std_logic_vector(3 downto 0) := x"0";
signal LocalL1A_cfg : std_logic_vector(31 downto 0) := (others =>'0');
signal BCN_off : std_logic_vector(12 downto 0) := (others =>'0');
signal OC_off : std_logic_vector(3 downto 0) := (others =>'0');
signal en_cal_win : std_logic := '0';
signal CalibCtrl : std_logic_vector(31 downto 0) := x"0d800d80";
signal cal_win_high : std_logic_vector(11 downto 0) := (others =>'0');
signal cal_win_low : std_logic_vector(11 downto 0) := (others =>'0');
signal CalType : std_logic_vector(3 downto 0) := (others =>'0');
signal TTC_Brcst : std_logic_vector(3 downto 0) := (others =>'0');
signal en_brcst : std_logic := '0';
signal ttc_start : std_logic := '0';
signal ttc_stop : std_logic := '0';
signal ttc_soft_reset : std_logic := '0';
signal ttc_soft_resetp : std_logic := '0';
signal ttc_ready : std_logic := '0';
signal ttc_serr : std_logic := '0';
signal ttc_derr : std_logic := '0';
signal ttc_bcnt_err : std_logic := '0';
signal ttc_evcnt_reset : std_logic := '0';
signal inc_rate_ofw : std_logic := '0';
signal rate_ofw : std_logic := '0';
signal rate_ofwp : std_logic := '0';
signal rate_ofw_q : std_logic := '0';
signal sync_lost : std_logic := '0';
signal oc_cntr : std_logic_vector(3 downto 0) := (others =>'0');
signal ttc_resync : std_logic := '0';
signal resync_done : std_logic := '0';
signal dcc_quiet : std_logic := '0';
signal inc_oc : std_logic := '0';
signal inc_L1ac : std_logic := '0';
signal inc_bcnterr : std_logic := '0';
signal inc_serr : std_logic := '0';
signal inc_derr : std_logic := '0';
signal evn_fifo_full : std_logic := '0';
signal event_number_avl : std_logic := '0';
signal state : std_logic_vector(3 downto 0) := (others =>'0');
signal event_number : std_logic_vector(59 downto 0) := (others =>'0');
signal TTC_serr_cntr : std_logic_vector(7 downto 0) := (others =>'0');
signal TTC_derr_cntr : std_logic_vector(7 downto 0) := (others =>'0');
signal TTC_BcntErr_cntr : std_logic_vector(7 downto 0) := (others =>'0');
signal L1A_cntr : std_logic_vector(7 downto 0) := (others =>'0');
signal run_cntr : std_logic_vector(7 downto 0) := (others =>'0');
signal ready_cntr : std_logic_vector(7 downto 0) := (others =>'0');
signal busy_cntr : std_logic_vector(7 downto 0) := (others =>'0');
signal sync_cntr : std_logic_vector(7 downto 0) := (others =>'0');
signal ovfl_cntr : std_logic_vector(7 downto 0) := (others =>'0');
signal SLINKword_cntr : std_logic_vector(7 downto 0) := (others =>'0');
signal SLINKevent_cntr : std_logic_vector(7 downto 0) := (others =>'0');
signal monitorEvent_cntr : std_logic_vector(7 downto 0) := (others =>'0');
type RAM1024X16 is array(0 to 1023) of std_logic_vector(15 downto 0);
signal counter_H : RAM1024X16 := (others => (others => '0'));
type RAM1024X32 is array(0 to 1023) of std_logic_vector(31 downto 0);
signal counter_L : RAM1024X32 := (others => (others => '0'));
signal counter_we : std_logic_vector(3 downto 0) := (others => '0');
signal counter_wa : std_logic_vector(9 downto 0) := (others => '0');
signal counter_ra_l : std_logic_vector(9 downto 0) := (others => '0');
signal counter_ra_h : std_logic_vector(9 downto 0) := (others => '0');
signal CounterDi : std_logic_vector(47 downto 0) := (others => '0');
signal CounterDoA : std_logic_vector(47 downto 0) := (others => '0');
signal CounterDoB : std_logic_vector(63 downto 0) := (others => '0');
signal div : std_logic_vector(7 downto 0) := (others =>'0');
signal CntrRst : std_logic := '0';
signal CntrRstCycle : std_logic := '0';
signal CounterDoB_h : std_logic := '0';
signal got_SN : std_logic := '0';
signal ipb_strobe_q : std_logic := '0';
signal SFP_clk : std_logic := '0';
signal SFP_REFCLK : std_logic := '0';
signal AMC_clk : std_logic := '0';
signal AMC_clk_in : std_logic := '0';
signal SV_Cntr : std_logic_vector(7 downto 0) := (others => '0');
signal sysclk_div : std_logic_vector(7 downto 0) := (others => '0');
signal SFP_UsrClk : std_logic := '0';
signal SFP_TxOutClk : std_logic := '0';
signal I2C_debug_out : std_logic_vector(15 downto 0) := (others =>'0');
signal SFPOSC_rdy : std_logic := '0';
signal reset : std_logic := '0';
signal DAQ_reset : std_logic := '0';
signal AMCOSC_rdy : std_logic := '0';
--signal cs_clk_in : std_logic := '0';
--signal cs_clk : std_logic := '0';
signal TTC_debug : std_logic_vector(63 downto 0) := (others =>'0');
signal TxDisable_i : std_logic_vector(3 downto 0) := (others => '0');
signal DAQfifo_re : std_logic := '0';
signal DAQfifoAlmostEmpty : std_logic := '0';
signal DAQfifoEmpty : std_logic := '0';
signal DAQfifo_do : std_logic_vector(63 downto 0) := (others =>'0');
signal DAQ_debug_in : std_logic_vector(63 downto 0) := (others =>'0');
signal LDC_debug_out : std_logic_vector(63 downto 0) := (others =>'0');
signal LSC_debug_out : std_logic_vector(63 downto 0) := (others =>'0');
signal ddr_debug_in : std_logic_vector(31 downto 0) := (others =>'0');
signal ddr_debug_out : std_logic_vector(127 downto 0) := (others =>'0');
signal GbE_REFCLK : std_logic := '0';
signal S6Link_debug_in : std_logic_vector(31 downto 0) := (others =>'0');
signal S6Link_debug_out : std_logic_vector(127 downto 0) := (others =>'0');
signal GbE_debug_in : std_logic_vector(31 downto 0) := (others =>'0');
signal GbE_debug_out : std_logic_vector(127 downto 0) := (others =>'0');
signal AMC_debug_in : std_logic_vector(255 downto 0) := (others =>'0');
signal AMC_debug_out : std_logic_vector(255 downto 0) := (others =>'0');
signal SFP0_debug_in : std_logic_vector(31 downto 0) := (others =>'0');
signal SFP0_debug_out : std_logic_vector(127 downto 0) := (others =>'0');
signal SFP1_debug_in : std_logic_vector(31 downto 0) := (others =>'0');
signal SFP1_debug_out : std_logic_vector(127 downto 0) := (others =>'0');
signal ipb_master_out : ipb_wbus;
signal ipb_master_in : ipb_rbus;
signal SN : std_logic_vector(7 downto 0) := (others =>'0');
--signal SPI_data_reg : std_logic_vector(31 downto 0) := (others =>'0');
signal ipaddr : std_logic_vector(31 downto 0) := (others =>'0');
--signal use_SPI_IP : std_logic := '0';
--signal SPI_IP : std_logic_vector(31 downto 0) := (others =>'0');
signal status : std_logic_vector(31 downto 0) := (others =>'0');
signal cmd : std_logic_vector(31 downto 0) := (others =>'0');
signal conf : std_logic_vector(15 downto 0) := (others =>'0');
--signal LSCSync : std_logic_vector(3 downto 0) := (others =>'0');
--signal LDCSync : std_logic_vector(3 downto 0) := (others =>'0');
--signal LSC_cntr : std_logic_vector(17 downto 0) := x"0000" & "01";
--signal LDC_cntr : std_logic_vector(17 downto 0) := (others =>'0');
--signal inject_div : std_logic_vector(8 downto 0) := (others =>'0');
--signal LSC_inject : std_logic_vector(17 downto 0) := (others =>'0');
--signal LDC_inject : std_logic_vector(17 downto 0) := (others =>'0');
--signal LSC_resend : std_logic_vector(15 downto 0) := (others =>'0');
--signal LSC_evt : std_logic_vector(15 downto 0) := (others =>'0');
--signal LDC_evt : std_logic_vector(31 downto 0) := (others =>'0');
--signal LDC_CMSCRC_err : std_logic_vector(31 downto 0) := (others =>'0');
--signal LDC_accept_cntr : std_logic_vector(31 downto 0) := (others =>'0');
--signal LDC_abort_cntr : std_logic_vector(31 downto 0) := (others =>'0');
--signal LDC_ACK_cntr : std_logic_vector(31 downto 0) := (others =>'0');
--signal LDC_event_cntr : std_logic_vector(31 downto 0) := (others =>'0');
--signal LDC_word_cntr : std_logic_vector(31 downto 0) := (others =>'0');
--signal LDC_CRC_bad_cntr : std_logic_vector(31 downto 0) := (others =>'0');
--signal LDC_SEQ_bad_cntr : std_logic_vector(31 downto 0) := (others =>'0');
--signal LDC_wc_bad_cntr : std_logic_vector(31 downto 0) := (others =>'0');
--signal LDC_frame_bad_cntr : std_logic_vector(31 downto 0) := (others =>'0');
--signal LDC_buf_ovf_cntr : std_logic_vector(31 downto 0) := (others =>'0');
--signal LDC_time : std_logic_vector(28 downto 0) := (others =>'0');
--signal LDC_rate : std_logic_vector(27 downto 0) := (others =>'0');
--signal LDC_rate_reg : std_logic_vector(27 downto 0) := (others =>'0');
signal LSC_ID : std_logic_vector(15 downto 0) := x"1234";
--signal LSC_read_ce : std_logic := '0';
--signal LSC_LinkAlmostFull : std_logic := '0';
--signal LSC_LinkDown : std_logic := '0';
--signal LDC_LinkCtrl : std_logic := '0';
--signal LDC_LinkWe : std_logic := '0';
--signal LDC_LinkRe : std_logic := '0';
--signal LDC_LinkData : std_logic_vector(63 downto 0) := (others => '0');
--signal LDC_LinkDown : std_logic := '0';
--signal LDC_mcsCRC_err : std_logic := '0';
--signal HTRCRC_err_cntr : std_logic_vector(31 downto 0) := (others =>'0');
signal OT : std_logic := '0';
signal inc_HTRCRC_err : std_logic := '0';
signal sysmon_data : std_logic_vector(31 downto 0) := (others => '0');
signal device_temp : std_logic_vector(11 downto 0) := (others =>'0');
signal ALM : std_logic_vector(7 downto 0) := (others =>'0');
signal evt_data_rdy : std_logic_vector(2 downto 0) := (others => '0');
signal evt_data_re : std_logic_vector(2 downto 0) := (others => '0');
signal evt_data_we : std_logic_vector(2 downto 0) := (others => '0');
signal event_size : std_logic_vector(2 downto 0) := (others => '0');
signal SFP_REFCLK2X : std_logic := '0';
signal SFP0_CLIENTEMACTXDVLD : std_logic := '0';
signal SFP0_CLIENTEMACTXUNDERRUN : std_logic := '0';
signal SFP0_EMACCLIENTRXDVLD : std_logic := '0';
signal SFP0_EMACCLIENTRXGOODFRAME : std_logic := '0';
signal SFP0_EMACCLIENTRXBADFRAME : std_logic := '0';
signal SFP0_EMACCLIENTTXACK : std_logic := '0';
signal SFP0_CLIENTEMACTXD : std_logic_vector(31 downto 0) := (others => '0');
signal SFP0_CLIENTEMACTXDBYTECNT : std_logic_vector(1 downto 0) := (others => '0');
signal SFP0_EMACCLIENTRXD : std_logic_vector(31 downto 0) := (others => '0');
signal SFP0_EMACCLIENTRXDBYTECNT : std_logic_vector(1 downto 0) := (others => '0');
signal SFP1_CLIENTEMACTXDVLD : std_logic := '0';
signal SFP1_CLIENTEMACTXUNDERRUN : std_logic := '0';
signal SFP1_EMACCLIENTRXDVLD : std_logic := '0';
signal SFP1_EMACCLIENTRXGOODFRAME : std_logic := '0';
signal SFP1_EMACCLIENTRXBADFRAME : std_logic := '0';
signal SFP1_EMACCLIENTTXACK : std_logic := '0';
signal SFP1_CLIENTEMACTXD : std_logic_vector(31 downto 0) := (others => '0');
signal SFP1_CLIENTEMACTXDBYTECNT : std_logic_vector(1 downto 0) := (others => '0');
signal SFP1_EMACCLIENTRXD : std_logic_vector(31 downto 0) := (others => '0');
signal SFP1_EMACCLIENTRXDBYTECNT : std_logic_vector(1 downto 0) := (others => '0');
signal SFP2_CLIENTEMACTXDVLD : std_logic := '0';
signal SFP2_CLIENTEMACTXUNDERRUN : std_logic := '0';
signal SFP2_EMACCLIENTRXDVLD : std_logic := '0';
signal SFP2_EMACCLIENTRXGOODFRAME : std_logic := '0';
signal SFP2_EMACCLIENTRXBADFRAME : std_logic := '0';
signal SFP2_EMACCLIENTTXACK : std_logic := '0';
signal SFP2_CLIENTEMACTXD : std_logic_vector(31 downto 0) := (others => '0');
signal SFP2_CLIENTEMACTXDBYTECNT : std_logic_vector(1 downto 0) := (others => '0');
signal SFP2_EMACCLIENTRXD : std_logic_vector(31 downto 0) := (others => '0');
signal SFP2_EMACCLIENTRXDBYTECNT : std_logic_vector(1 downto 0) := (others => '0');
signal SFP_data : std_logic_vector(31 downto 0) := (others =>'0');
signal SFP_ack : std_logic := '0';
signal TCP_data : std_logic_vector(31 downto 0) := (others =>'0');
signal TCP_ack : std_logic := '0';
signal S2V_SyncRegs : std_logic_vector(2 downto 0) := (others => '0');
--signal SPI_we_SyncRegs : std_logic_vector(2 downto 0) := (others =>'0');
signal resetSyncRegs : std_logic_vector(2 downto 0) := (others => '0');
signal sysclk_div7SyncRegs : std_logic_vector(3 downto 0) := (others => '0');
signal resetCntr_SyncRegs : std_logic_vector(2 downto 0) := (others =>'0');
signal newIPADDR : std_logic := '0';
signal newIPADDRSyncRegs : std_logic_vector(2 downto 0) := (others =>'0');
signal DNA_out : std_logic := '0';
signal load_DNA : std_logic := '0';
signal shift_DNA : std_logic_vector(2 downto 0) := (others =>'0');
signal DNA_cntr : std_logic_vector(5 downto 0) := (others =>'0');
signal DNA : std_logic_vector(56 downto 0) := (others =>'0');
--attribute ASYNC_REG : string;
--attribute ASYNC_REG of S2V_sync, SPI_we_sync, resetSync, sysclk_div7Sync, resetCntr_sync : signal is "TRUE";
--component icon2
--  PORT (
--    CONTROL0 : INOUT STD_LOGIC_VECTOR(35 DOWNTO 0);
--    CONTROL1 : INOUT STD_LOGIC_VECTOR(35 DOWNTO 0));
--
--end component;
--component ila64x4096
--  PORT (
--    CONTROL : INOUT STD_LOGIC_VECTOR(35 DOWNTO 0);
--    CLK : IN STD_LOGIC;
--    DATA : IN STD_LOGIC_VECTOR(63 DOWNTO 0);
--    TRIG0 : IN STD_LOGIC_VECTOR(7 DOWNTO 0));
--
--end component;
--component vio_async_in256
--  PORT (
--    CONTROL : INOUT STD_LOGIC_VECTOR(35 DOWNTO 0);
--    ASYNC_IN : IN STD_LOGIC_VECTOR(255 DOWNTO 0));
--
--end component;
--signal CONTROL0 : std_logic_vector(35 downto 0) := (others => '0');
--signal CONTROL1 : std_logic_vector(35 downto 0) := (others => '0');
--signal TRIG0 : std_logic_vector(7 downto 0) := (others => '0');
--signal TRIG1 : std_logic_vector(7 downto 0) := (others => '0');
--signal cs_DATA0 : std_logic_vector(63 downto 0) := (others => '0');
--signal cs_DATA1 : std_logic_vector(63 downto 0) := (others => '0');
--signal ASYNC_IN : std_logic_vector(255 downto 0) := (others => '0');
--attribute LOC : string;
--attribute LOC of i_sysclk_in_buf : label is "BUFGCTRL_X0Y6";
begin
i_TTS_if: TTS_if PORT MAP(
		sysclk => sysclk,
		CDRclk => CDRclk_TTS,
		local_TTC => conf(8),
		TTC_Ready => TTC_Ready,
		TTC_strobe => TTC_strobe,
		TTS => state,
		BC0 => BC0_dl,
		L1A_trig => AMC_trig,
		TTS_out_p => TTS_out_p,
		TTS_out_n => TTS_out_n
	);
process(TTC_Clk)
begin
    if(TTC_Clk'event and TTC_Clk = '1')then
        AMC_trig <= or_reduce(TrigData and Trig_mask);
        BC0_dl <= BC0_dlp2;
        if(BC0_dlp2 = '1')then
            bcnt <= x"0";
        else
            bcnt <= bcnt + 1;
        end if;
    end if;
end process;
TxDisable <= TxDisable_i;
i_I2C: I2C PORT MAP(
		clk => DRPclk,
		ipb_clk => ipb_clk,
		reset => not sys_lock,
--		ns2500 => clk_div(9),
		addr => ipb_master_out.ipb_addr,
		rdata => I2C_data,
		CLK_rdy => CLK_rdy,
		CLK_SCL => CLK_SCL,
		CLK_SDA => CLK_SDA,
		SFP_ABS => SFP_ABS,
		SFP_LOS => SFP_LOS,
		SFP_SCL => SFP_SCL,
		SFP_SDA => SFP_SDA
	);
i_SPI_SCK_buf: bufh port map(i => SPI_SCK, o => SPI_SCK_buf);
i_SPI_if: SPI_if PORT MAP(
		SCK => SPI_SCK,
		CSn => SPI_CS_b,
		MOSI => SPI_MOSI,
		MISO => SPI_MISO,
		SN => SN,
		IsT1 => '1',
		SPI_we => open,
		newIPADDR => newIPADDR,
		IPADDR => IPADDR,
		SPI_rdata => (others => '0'),
		SPI_wdata => open,
		SPI_addr => open
	);
--process(SPI_SCK_buf)
--begin
--	if(SPI_SCK_buf'event and SPI_SCK_buf = '1')then
--		if(SPI_addr(7 downto 2) = SPI_data_addr(7 downto 2) and SPI_we = '1')then
--			case SPI_addr(1 downto 0) is
--				when "00" => SPI_data_reg(7 downto 0) <= SPI_wdata;
--				when "01" => SPI_data_reg(15 downto 8) <= SPI_wdata;
--				when "10" => SPI_data_reg(23 downto 16) <= SPI_wdata;
--				when others => SPI_data_reg(31 downto 24) <= SPI_wdata;
--			end case;
--		end if;
--	end if;
--end process;
--IPADDR <= x"c0a801d9";
--IPADDR <= x"c0a801ff" when got_SN = '0'else x"c0a801" & SN(6 downto 0) & '1' when use_SPI_IP = '0' else SPI_IP;
--process(SPI_SCK_buf,sys_lock)
--begin
----	if(got_SN = '0')then
----		IPADDR <= x"c0a801" & SN(6 downto 0) & '1';
--	if(sys_lock = '0')then
--		use_SPI_IP <= '0';
--	elsif(SPI_SCK_buf'event and SPI_SCK_buf = '1')then
--		if(SPI_addr(7 downto 2) = SPI_IP_addr(7 downto 2) and SPI_we = '1')then
--			case SPI_addr(1 downto 0) is
--				when "00" => SPI_IP(7 downto 0) <= SPI_wdata;
--				when "01" => SPI_IP(15 downto 8) <= SPI_wdata;
--				when "10" => SPI_IP(23 downto 16) <= SPI_wdata;
--				when others => SPI_IP(31 downto 24) <= SPI_wdata;
--							   use_SPI_IP <= '1';
--			end case;
--		end if;
--	end if;
--end process;
--process(SPI_addr, IPADDR)
--begin
--	if(SPI_addr(7 downto 2) /= SPI_IP_addr(7 downto 2))then
--		SPI_rdata <= x"00";
--	else
--		case SPI_addr(1 downto 0) is
--			when "00" => SPI_rdata <= IPADDR(7 downto 0);
--			when "01" => SPI_rdata <= IPADDR(15 downto 8);
--			when "10" => SPI_rdata <= IPADDR(23 downto 16);
--			when others => SPI_rdata <= IPADDR(31 downto 24);
--		end case;
--	end if;
--end process;
i_ttc_if: ttc_if PORT MAP(
		clk => sysclk,
		refclk => sysclk,
		reset => reset,
		run => run,
		TTC_strobe => TTC_strobe,
		sys_lock => sys_lock,
		local_TTC => conf(8),
		CDRclk_TTS => CDRclk_TTS,
		BC0 => BC0,
		DIV4 => DIV4,
		DIV_nRST => DIV_nRST,
		CDRclk_p => CDRclk_p,
		CDRclk_n => CDRclk_n,
		CDRclk_out => CDRclk,
		CDRdata_p => CDRdata_p,
		CDRdata_n => CDRdata_n,
		TTCdata_p => TTCdata_p,
		TTCdata_n => TTCdata_n,
		TTC_LOS => TTC_LOS,
		TTC_LOL => TTC_LOL,
		BCN_off => BCN_off,
		OC_off => OC_off,
		en_cal_win => en_cal_win,
		cal_win_high => cal_win_high,
		cal_win_low => cal_win_low,
		CalType => CalType,
		TTC_Brcst => TTC_Brcst,
		ovfl_warning => L1Aovfl_warning,
		en_localL1A => conf(2),
		LocalL1A_cfg => LocalL1A_cfg,
		localL1A_s => cmd(26),
		localL1A_r => cmd(10),
		localL1A_periodic => status(10),
		EvnRSt_l => cmd(11),
		OcnRSt_l => cmd(12),
		en_brcst => en_brcst,
		ttc_start => ttc_start,
		ttc_stop => ttc_stop,
		ttc_soft_reset => ttc_soft_reset,
		ttc_ready => ttc_ready,
		ttc_serr => ttc_serr,
		ttc_derr => ttc_derr,
		ttc_bcnt_err => ttc_bcnt_err,
		rate_OFW => rate_OFW,
		sync_lost => sync_lost,
		inc_oc => inc_oc,
		inc_l1ac => inc_l1ac,
		inc_bcnterr => inc_bcnterr,
		inc_serr => inc_serr,
		inc_derr => inc_derr,
		state => state,
		evn_fifo_full => evn_fifo_full,
		ttc_evcnt_reset => ttc_evcnt_reset,
		event_number_avl => event_number_avl,
		event_number => event_number
	);
CalibCtrl(31) <= en_cal_win;
CalibCtrl(30 downto 28) <= "000";
CalibCtrl(27 downto 16) <= cal_win_high;
CalibCtrl(15 downto 12) <= CalType;
CalibCtrl(11 downto 0) <= cal_win_low;
cal_win_high(11 downto 6) <= "110110";
cal_win_low(11 downto 6) <= "110110";
i_S2V: IBUFDS generic map(DIFF_TERM => TRUE,IOSTANDARD => "LVDS_25") port map(i => S2V_p, ib => S2V_n, o => S2V);
i_V2S: OBUFDS generic map(IOSTANDARD => "LVDS_25") port map (O => V2S_p, OB => V2S_n, I => sysclk_div(7));
process(sysclk)
begin
	if(sysclk'event and sysclk = '1')then
--		SPI_we_SyncRegs <= SPI_we_SyncRegs(1 downto 0) & SPI_we;
--		SPI_wr(0) <= SPI_we_SyncRegs(2) and not SPI_we_SyncRegs(1);
		sysclk_div <= sysclk_div + 1;
		sysclk_div7SyncRegs <= sysclk_div7SyncRegs(2 downto 0) & S2V;
		if(resetSyncRegs(2) = '1')then
			SV_Cntr <= (others => '0');
		elsif(and_reduce(sysclk_div(6 downto 0)) = '1')then
			SV_Cntr <= SV_Cntr + 1;
		elsif(sysclk_div7SyncRegs(3) /= sysclk_div7SyncRegs(2))then
			SV_Cntr <= SV_Cntr - 1;
		end if;
	end if;
end process;
i_GbE_REFCLK: IBUFDS_GTE2
    port map
    (
        O                               => GbE_REFCLK,
        ODIV2                           => open,
        CEB                             => '0',
        I                               => GbE_REFCLK_P,  -- Connect to package pin AB6
        IB                              => GbE_REFCLK_N       -- Connect to package pin AB5
    );
i_TTCclk_in : IBUFGDS generic map (DIFF_TERM => TRUE,IOSTANDARD => "LVDS_25")
   port map (
      O => TTCclk_in,  -- Clock buffer output
      I => TTCclk_p,  -- Diff_p clock buffer input
      IB => TTCclk_n -- Diff_n clock buffer input
   );
i_TTC_CLK_buf: bufg port map(i => TTCclk_in, o => TTC_Clk);
i_sysclk_in_buf: bufh port map(i => GbE_REFCLK, o => sysclk_in);
i_PLL_sysclk : PLLE2_BASE
   generic map (
      BANDWIDTH => "OPTIMIZED",  -- OPTIMIZED, HIGH, LOW
      CLKFBOUT_MULT => 8,        -- Multiply value for all CLKOUT, (2-64)
      CLKFBOUT_PHASE => 0.0,     -- Phase offset in degrees of CLKFB, (-360.000-360.000).
      CLKIN1_PERIOD => 8.0,      -- Input clock period in ns to ps resolution (i.e. 33.333 is 30 MHz).
      -- CLKOUT0_DIVIDE - CLKOUT5_DIVIDE: Divide amount for each CLKOUT (1-128)
      CLKOUT0_DIVIDE => 5,
      CLKOUT1_DIVIDE => 32,
      CLKOUT2_DIVIDE => 20,
      DIVCLK_DIVIDE => 1,        -- Master division value, (1-56)
      REF_JITTER1 => 0.0,        -- Reference input jitter in UI, (0.000-0.999).
      STARTUP_WAIT => "FALSE"    -- Delay DONE until PLL Locks, ("TRUE"/"FALSE")
   )
   port map (
      -- Clock Outputs: 1-bit (each) output: User configurable clock outputs
      CLKOUT0 => sysclk_dcm,
      CLKOUT1 => ipb_clk_dcm,
      CLKOUT2 => DRPclk_dcm,
     -- Feedback Clocks: 1-bit (each) output: Clock feedback ports
      CLKFBOUT => clk125_dcm, -- 1-bit output: Feedback clock
      -- Status Port: 1-bit (each) output: PLL status ports
      LOCKED => sys_lock,     -- 1-bit output: LOCK
      -- Clock Input: 1-bit (each) input: Clock input
      CLKIN1 => sysclk_in,     -- 1-bit input: Input clock
      -- Control Ports: 1-bit (each) input: PLL control ports
      PWRDWN => '0',     -- 1-bit input: Power-down
      RST => '0',           -- 1-bit input: Reset
      -- Feedback Clocks: 1-bit (each) input: Clock feedback ports
      CLKFBIN => clk125    -- 1-bit input: Feedback clock
   );
i_clk125_buf: bufg port map(i => clk125_dcm, o => clk125);
i_ipb_clk_buf: bufg port map(i => ipb_clk_dcm, o => ipb_clk);
i_DRPclk_buf: bufg port map(i => DRPclk_dcm, o => DRPclk);
i_sysclk_buf: bufg port map(i => sysclk_dcm, o => sysclk);
--i_refclk_buf: bufg port map(i => refclk_dcm, o => refclk);
reset <= not sys_lock or cmd(0);
--sysclk <= refclk;
process(sysclk,reset)
begin
	if(reset = '1')then
		resetSyncRegs <= (others => '1');
	elsif(sysclk'event and sysclk = '1')then
		resetSyncRegs <= resetSyncRegs(1 downto 0) & '0';
	end if;
end process;
i_ddr_if: ddr_if PORT MAP(
		mem_clk_p => sys_clk_p,
		mem_clk_n => sys_clk_n,
		mem_rst => mem_rst,
		clk_ref => sysclk,
		sysclk => sysclk,
		reset => reset,
		resetsys => resetSyncRegs(2),
		run => run,
		mem_test => mem_test,
		EventData => EventData,
		EventData_we => evt_data_we,
		wport_rdy => wport_rdy,
		EventBufAddr => EventBufAddr,
		EventBufAddr_we => EventBufAddr_we,
		EventFIFOfull => EventFIFOfull,
		TCP_din => TCP_din,
		TCP_waddr => TCP_waddr,
		TCP_wrqst => TCP_wrqst,
		TCP_re => TCP_re,
		TCP_dout => TCP_dout,
		TCP_raddr => TCP_raddr,
		TCP_length => TCP_length,
		TCP_dout_valid => TCP_dout_valid,
		TCP_rrqst => TCP_rrqst,
		TCP_rack => TCP_rack,
		TCP_lastword => TCP_lastword,
		page_addr => ddr_pa(11 downto 0),
		ipb_clk => ipb_clk,
		ipb_write => ipb_master_out.ipb_write,
		ipb_strobe => ipb_master_out.ipb_strobe,
		ipb_addr => ipb_master_out.ipb_addr,
		ipb_wdata => ipb_master_out.ipb_wdata,
		ipb_rdata => mem_data,
		ipb_ack => mem_ack,
		mem_stat => mem_stat,
		device_temp => device_temp,
		ddr3_dq => ddr3_dq,
		ddr3_dm => ddr3_dm,
		ddr3_addr => ddr3_addr,
		ddr3_ba => ddr3_ba,
		ddr3_dqs_p => ddr3_dqs_p,
		ddr3_dqs_n => ddr3_dqs_n,
		ddr3_ras_n => ddr3_ras_n,
		ddr3_cas_n => ddr3_cas_n,
		ddr3_we_n => ddr3_we_n,
		ddr3_reset_n => ddr3_reset_n,
		ddr3_cke => ddr3_cke,
		ddr3_odt => ddr3_odt,
		ddr3_ck_p => ddr3_ck_p,
		ddr3_ck_n => ddr3_ck_n
	);
mem_rst <= not sys_lock or not CLK_rdy or cmd(5) or cmd(0);
--mem_rst <= not sys_lock or not CLK_rdy or cmd(5);
--EventData_we <= evt_data_we and EventData_WrEn;
--process(sysclk)
--begin
--	if(sysclk'event and sysclk = '1')then
--		for i in 0 to 2 loop
--			if(evt_data_re(i) = '1')then
--				EventData_WrEn(i) <= or_reduce(event_size);
--			end if;
--		end loop;
--	end if;
--end process;
i_ipbus_if: ipbus_if PORT MAP(
		ipb_clk => ipb_clk,
		UsRclk => clk125,
		DRPclk => DRPclk,
		reset => rst_ipbus,
		GTX_RESET => not sys_lock,
		MACADDR => x"080030f300" & "01" & SN(5 downto 0), -- new mac range 08-00-30-F3-00-00 to  08-00-30-F3-00-7F
		IPADDR => IPADDR,
		GbE_REFCLK => GbE_REFCLK,
		S6LINK_RXN => S6LINK_RXN,
		S6LINK_RXP => S6LINK_RXP,
		S6LINK_TXN => S6LINK_TXN,
		S6LINK_TXP => S6LINK_TXP,
		wr_AMC_en => wr_AMC_en,
		amc_en => AMC_en,
--		rst_ipbus => '0',
		ipb_out => ipb_master_out,
		ipb_in => ipb_master_in,
		got_SN => got_SN,
		SN => SN,
		debug_in => (others => '0'),
		debug_out => open
	);
--process(ipb_clk)
--begin
--	if(ipb_clk'event and ipb_clk = '1')then
--		EthernetSFP_q <= EthernetSFP;
--		if(EthernetSFP_q /= EthernetSFP)then
--			rst_ipbus <= '1';
--		else
--			rst_ipbus <= '0';
--		end if;
--	end if;
--end process;
--GbE_SEL <= "01" when EthernetSFP = '1' else "10"; -- when SFP0 is present and has stable signal, connect SFP0 to Spartan chip for Ethernet input
--status(0) <= LSC_LinkDown;
--status(1) <= LSC_LinkAlmostFull;
status(2) <= mon_bufFull;
status(3) <= mon_buf_empty;
status(4) <= mem_stat(0); -- monitor input FIFO overflow
status(5) <= not ttc_ready;
status(6) <= ttc_bcnt_err;
status(7) <= ttc_serr;
status(8) <= ttc_derr;
status(9) <= sync_lost;
status(13) <= L1Aovfl_warning;
status(23) <= '0';
run <= conf(0);
mem_test <= conf(6) & conf(4);
en_brcst <= conf(5);
process(ipb_clk)
begin
	if(ipb_clk'event and ipb_clk = '1')then
		if(ipb_master_out.ipb_addr(27) = '0' and ipb_master_out.ipb_addr(15 downto 0) = CSR_addr and ipb_master_out.ipb_write = '1' and ipb_master_out.ipb_strobe = '1')then
			cmd <= ipb_master_out.ipb_wdata;
		else
			cmd <= (others => '0');
		end if;
		if(ipb_master_out.ipb_addr(27) = '0' and ipb_master_out.ipb_addr(15 downto 0) = CFG_addr and ipb_master_out.ipb_write = '1' and ipb_master_out.ipb_strobe = '1')then
			conf <= ipb_master_out.ipb_wdata(15 downto 0);
		end if;
		if(ipb_master_out.ipb_addr(27) = '0' and ipb_master_out.ipb_addr(15 downto 0) = HTR_EN_addr and ipb_master_out.ipb_write = '1' and ipb_master_out.ipb_strobe = '1')then
			AMC_en <= ipb_master_out.ipb_wdata(11 downto 0);
			wr_AMC_en <= '1';
		else
			wr_AMC_en <= '0';
		end if;
		if(ipb_master_out.ipb_addr(27) = '0' and ipb_master_out.ipb_addr(15 downto 0) = TTC_cal_addr and ipb_master_out.ipb_write = '1' and ipb_master_out.ipb_strobe = '1')then
			en_cal_win <= ipb_master_out.ipb_wdata(31);
			cal_win_high(5 downto 0) <= ipb_master_out.ipb_wdata(21 downto 16);
			cal_win_low(5 downto 0) <= ipb_master_out.ipb_wdata(5 downto 0);
		end if;
		if(ipb_master_out.ipb_addr(27) = '0' and ipb_master_out.ipb_addr(15 downto 0) = BC0_delay_addr and ipb_master_out.ipb_write = '1' and ipb_master_out.ipb_strobe = '1')then
			BC0_delay <= ipb_master_out.ipb_wdata(4 downto 0);
		end if;
		if(ipb_master_out.ipb_addr(27) = '0' and ipb_master_out.ipb_addr(15 downto 0) = SRC_id_addr and ipb_master_out.ipb_write = '1' and ipb_master_out.ipb_strobe = '1')then
			Source_ID <= ipb_master_out.ipb_wdata(19 downto 0);
		end if;
		if(ipb_master_out.ipb_addr(27) = '0' and ipb_master_out.ipb_addr(15 downto 0) = x"001c" and ipb_master_out.ipb_write = '1' and ipb_master_out.ipb_strobe = '1')then
			LocalL1A_cfg <= ipb_master_out.ipb_wdata;
		end if;
		if(ipb_master_out.ipb_addr(27) = '0' and ipb_master_out.ipb_addr(15 downto 0) = SFP_CSR_addr and ipb_master_out.ipb_write = '1' and ipb_master_out.ipb_strobe = '1')then
			LSC_ID <= ipb_master_out.ipb_wdata(31 downto 16);
			TxDisable_i <= ipb_master_out.ipb_wdata(15 downto 12);
		end if;
		if(ipb_master_out.ipb_addr(27) = '0' and ipb_master_out.ipb_addr(15 downto 0) = TTC_bcnt_addr and ipb_master_out.ipb_write = '1' and ipb_master_out.ipb_strobe = '1')then
			OC_OFF <= ipb_master_out.ipb_wdata(19 downto 16);
			BCN_OFF <= ipb_master_out.ipb_wdata(12 downto 0);
		end if;
		if(ipb_master_out.ipb_addr(27) = '0' and ipb_master_out.ipb_addr(15 downto 0) = fake_length_addr and ipb_master_out.ipb_write = '1' and ipb_master_out.ipb_strobe = '1')then
			fake_length <= '0' & ipb_master_out.ipb_wdata(10 downto 0);
		end if;
		if(ipb_master_out.ipb_addr(27) = '0' and ipb_master_out.ipb_addr(15 downto 0) = x"0019" and ipb_master_out.ipb_write = '1' and ipb_master_out.ipb_strobe = '1')then
            Trig_mask <= ipb_master_out.ipb_wdata(7 downto 0);
        end if;
		if(reset = '1' or (ipb_master_out.ipb_addr(27) = '0' and ipb_master_out.ipb_addr(15 downto 0) = MON_ctrl_addr and ipb_master_out.ipb_write = '1' and ipb_master_out.ipb_strobe = '1'))then
			ddr_pa <= (others => '0');
		elsif(ipb_master_out.ipb_addr(27) = '0' and ipb_master_out.ipb_addr(15 downto 0) = PAGE_addr and ipb_master_out.ipb_write = '1' and ipb_master_out.ipb_strobe = '1')then
			if(run = '1')then 
				if(mon_buf_empty = '0')then
					ddr_pa <= ddr_pa + 1;
				end if;
			else
				ddr_pa <= '0' & ipb_master_out.ipb_wdata(11 downto 0);
			end if;
		end if;
		if(ipb_master_out.ipb_addr(27) = '0' and ipb_master_out.ipb_addr(15 downto 0) = PAGE_addr and ipb_master_out.ipb_write = '1' and ipb_master_out.ipb_strobe = '1' and run = '1' and mon_buf_empty = '0')then
			inc_ddr_pa <= '1';
		else
			inc_ddr_pa <= '0';
		end if;
		if(ipb_master_out.ipb_addr(27) = '1' or ipb_master_out.ipb_addr(14) = '1')then
			ipb_master_in.ipb_rdata <= mem_data;
		elsif(ipb_master_out.ipb_addr(15 downto 5) = CSR_addr(15 downto 5))then
			case ipb_master_out.ipb_addr(4 downto 0) is
				when "00000" => ipb_master_in.ipb_rdata <= not SN & status(23 downto 0);
				when "00001" => ipb_master_in.ipb_rdata <= K7version & conf;
				when "00010" => ipb_master_in.ipb_rdata <= mon_ctrl;
				when "00011" => ipb_master_in.ipb_rdata <= x"0" & AMC_Ready & x"0" & AMC_en;
				when "00100" => ipb_master_in.ipb_rdata <= LSC_ID & TxDisable_i & TxFault & (TTC_LOL or TTC_LOL) & SFP_LOS & SFP_ABS;
				when "00101" => ipb_master_in.ipb_rdata <= AMC_status;
				when "00110" => ipb_master_in.ipb_rdata <= x"0" & BC0_lock & x"00" & "000" & BC0_delay;
				when "00111" => ipb_master_in.ipb_rdata <= x"000" & Source_ID;
				when "01000" => ipb_master_in.ipb_rdata <= x"000" & OC_OFF & "000" & BCN_OFF;
				when "01001" => ipb_master_in.ipb_rdata <= CalibCtrl;
				when "01010" => ipb_master_in.ipb_rdata <= mem_stat(31 downto 0);
				when "01011" => ipb_master_in.ipb_rdata <= mem_stat(63 downto 32);
				when "01100" => ipb_master_in.ipb_rdata <= x"0000" & "000" & ddr_pa;
				when "01101" => ipb_master_in.ipb_rdata <= mon_evt_wc;
				when "01110" => ipb_master_in.ipb_rdata <= mon_evt_cnt;
				when "01111" => ipb_master_in.ipb_rdata <= x"000000" & SV_cntr;
				when "10000" => ipb_master_in.ipb_rdata <= x"000" & "00" & mon_buf_avl & TCPbuf_avl & '0' & EventFIFOfull & '0' & wport_rdy & '0' & event_size & '0' & evt_data_rdy;
				when "11000" => ipb_master_in.ipb_rdata <= x"00000" & fake_length;
				when "11001" => ipb_master_in.ipb_rdata <= x"000" & TTS_pattern & x"00" & Trig_mask;
				when "11010" => ipb_master_in.ipb_rdata <= mon_wp;
				when "11100" => ipb_master_in.ipb_rdata <= LocalL1A_cfg;
				when "11110" => ipb_master_in.ipb_rdata <= DNA(31 downto 0);
				when "11111" => ipb_master_in.ipb_rdata <= "0000000" & DNA(56 downto 32);
				when others => ipb_master_in.ipb_rdata <= (others => '0');
			end case;
		else
			ipb_master_in.ipb_rdata <= AMC_data or CounterDoB(63 downto 32) or CounterDoB(31 downto 0) or I2C_data or sysmon_data or SFP_data or TCP_data;
		end if;
		ipb_strobe_q <= ipb_master_out.ipb_strobe;
		if(ipb_master_out.ipb_addr(27) = '1' or or_reduce(ipb_master_out.ipb_addr(15 downto 11)) = '1')then
			ipb_master_in.ipb_ack <= mem_ack or AMC_ack or SFP_ack or TCP_ack;
		elsif(or_reduce(ipb_master_out.ipb_addr(8 downto 6)) = '1')then
			ipb_master_in.ipb_ack <= ipb_strobe_q;
		else
			ipb_master_in.ipb_ack <= ipb_master_out.ipb_strobe;
		end if;
	end if;
end process;
rst_cntr <= cmd(1) or cmd(0);
process(sysClk, rst_cntr,reset)
begin
	if(reset = '1' or rst_cntr = '1')then
--		LDC_CMSCRC_err <= (others =>'0');
--		LDC_word_cntr <= (others =>'0');
		TTC_serr_cntr <= (others =>'0');
		TTC_derr_cntr <= (others =>'0');
		TTC_BcntErr_cntr <= (others =>'0');
		L1A_cntr <= (others =>'0');
		run_cntr <= (others =>'0');
		ready_cntr <= (others =>'0');
		busy_cntr <= (others =>'0');
		sync_cntr <= (others =>'0');
		ovfl_cntr <= (others =>'0');
--		SLINKword_cntr <= (others =>'0');
--		SLINKevent_cntr <= (others =>'0');
		monitorEvent_cntr <= (others =>'0');
--		HTRCRC_err_cntr <= (others =>'0');
	elsif(sysClk'event and sysClk = '1')then
--		if(LDC_debug_out(0) = '1')then
--			LDC_CMSCRC_err <= LDC_CMSCRC_err + 1;
--		end if;
--		if(LDC_debug_out(15) = '1')then
--			LDC_word_cntr <= LDC_word_cntr + 1;
--		end if;
		if(inc_serr = '1')then
			TTC_serr_cntr <= TTC_serr_cntr + 1;
		end if;
		if(inc_derr = '1')then
			TTC_derr_cntr <= TTC_derr_cntr + 1;
		end if;
		if(inc_bcnterr = '1')then
			TTC_BcntErr_cntr <= TTC_BcntErr_cntr + 1;
		end if;
		if(inc_l1ac = '1')then
			L1A_cntr <= L1A_cntr + 1;
		end if;
		if(run = '1')then
			run_cntr <= run_cntr + 1;
			if(state(3 downto 2) = "10")then
				ready_cntr <= ready_cntr + 1;
			end if;
			if(state(3 downto 2) = "01")then
				busy_cntr <= busy_cntr + 1;
			end if;
			if(state(3) = '0' and state(1) = '1')then
				sync_cntr <= sync_cntr + 1;
			end if;
			if(state(3) = '0' and state(0) = '1')then
				ovfl_cntr <= ovfl_cntr + 1;
			end if;
		end if;
--		if(conf(1) = '1' and LinkWe = '1')then
--			SLINKword_cntr <= SLINKword_cntr + 1;
--		end if;
--		if(conf(1) = '1' and LinkWe = '1' and LinkData(64) = '1')then
--			SLINKevent_cntr <= SLINKevent_cntr + 1;
--		end if;
		if(inc_mon_cntr = '1')then
			monitorEvent_cntr <= monitorEvent_cntr + 1;
		end if;
--		if(inc_HTRCRC_err = '1')then
--			HTRCRC_err_cntr <= HTRCRC_err_cntr + 1;
--		end if;
	end if;
end process;
process(sysClk)
begin
	if(sysClk'event and sysClk = '1')then
--		LinkRe <= not((LSC_LinkAlmostFull and conf(1)) or (mon_bufAlmostFull and conf(14)) or conf(3));
		if(resync_done = '1' or run = '0')then
			ttc_resync <= '0';
		elsif(ttc_soft_reset = '1')then
			ttc_resync <= '1';
		end if;
		if(ttc_resync = '0' or conf(13) = '1')then
			oc_cntr <= "0000";
		elsif(inc_oc = '1')then
			oc_cntr <= oc_cntr + 1;
		end if;
		if(oc_cntr = "1010" or (conf(13) = '1' and ttc_soft_resetp = '1'))then
			resync_done <= '1';
		else
			resync_done <= '0';
		end if;
--		if(LinkWe = '1' or ttc_resync = '0')then
		if(ttc_resync = '0')then
			dcc_quiet <= '0';	
		elsif(inc_oc = '1')then
			dcc_quiet <= '1';
		end if;
		if((conf(13) = '0' and oc_cntr(3) = '0' and ttc_resync = '1') or (conf(13) = '1' and dcc_quiet = '1' and inc_oc = '1'))then
			ttc_soft_resetp <= '1';
		else
			ttc_soft_resetp <= '0';
		end if;
		rate_OFW_q <= rate_OFW;
		inc_rate_OFW <= not rate_OFW_q and rate_OFW;
		rate_OFWp <= rate_OFW and conf(15);
    if(reset = '1')then
			state <= "0100";
		else
			if(conf(12) = '1')then
				state <= conf(11 downto 8);
			elsif(run = '0')then
				state <= "0100"; -- changed upon request starting version 0x3023
			elsif(ttc_resync = '1')then
				state <= "0100";
			else
        case state is
					when "1000" =>
--						if(err_state = "11")then
--							state <= "1111";
--						elsif(err_state = "10")then
--							state <= "1100";
--						elsif(sync_lost = '1' or err_state = "01")then
						if(sync_lost = '1')then
							state <= "0010";
--						elsif(L1Aovfl_warning = '1' or (HTR_ow = '1' and en_htr_ow = '1') or evn_fifo_full = '1' or HTR_bz = '1' or rate_OFWp = '1')then
						elsif(L1Aovfl_warning = '1' or evn_fifo_full = '1' or rate_OFWp = '1')then
							state <= "0001";
						end if;  
					when "0001" =>
--						if(err_state = "11")then
--							state <= "1111";
--						elsif(err_state = "10")then
--							state <= "1100";
--						elsif(sync_lost = '1' or err_state = "01")then
						if(sync_lost = '1')then
							state <= "0010";
						elsif(evn_fifo_full = '1' or rate_OFWp = '1')then
							state <= "0100";
						elsif(L1Aovfl_warning = '0' and rate_OFWp = '0')then
							state <= "1000";
						end if;  
					when "0100" =>
--						if(err_state = "11")then
--							state <= "1111";
--						elsif(err_state = "10")then
--							state <= "1100";
--						elsif(sync_lost = '1' or err_state = "01")then
						if(sync_lost = '1')then
							state <= "0010";
						elsif(evn_fifo_full = '0' and rate_OFWp = '0')then
							state <= "0001";
						end if;  
					when others => null;
				end case;
			end if;
		end if;
	end if;
end process;
ipb_master_in.ipb_err <= '0';	
i_BC0_dl2 : SRLC32E
   port map (
      Q => BC0_dlp2,       -- SRL data output
      Q31 => open,    -- SRL cascade output pin
      A => "01111",        -- 5-bit shift depth select input
      CE => '1',     -- Clock enable input
      CLK => TTC_clk,   -- Clock input
      D => BC0_dlp        -- SRL data input
   );
i_BC0_dl : SRLC32E
   port map (
      Q => BC0_dlp,       -- SRL data output
      Q31 => open,    -- SRL cascade output pin
      A => BC0_delay,        -- 5-bit shift depth select input
      CE => '1',     -- Clock enable input
      CLK => TTC_clk,   -- Clock input
      D => BC0        -- SRL data input
   );
i_ddr_buf_ctrl: ddr_buf_ctrl PORT MAP(
		clk => sysclk,
		reset => resetSyncRegs(2),
		buf_rqst => EventBuf_rqst,
--		buf_full => EventBuf_full,
		TCP_rqst => TCP_ReleaseRqst,
		TCP_ack => TCP_ReleaseAck,
		TCP_addr => TCP_ReleaseAddr,
		buf_addr_re => EventBufAddrRe,
		buf_addr_avl => EventBufAddrAvl,
		buf_addr => EventBufAddr,
		TCPbuf_avl => TCPbuf_avl,
		mon_buf_avl => mon_buf_avl
	);
--EventBufAddrRe <= '0' when EventBufAddr_we = "000" else '1';
i_AMC_if: AMC_if PORT MAP(
		sysclk => sysclk,
		ipb_clk => ipb_clk,
		DRPclk => DRPclk,
		reset => AMC_reset,
		GTXreset => not sys_lock,
		resetCntr => rst_cntr,
		run => run,
		test => conf(7),
		fake_length => fake_length,
		en_localL1A => conf(2),
		T1_version => K7version(7 downto 0),
		Source_ID => Source_ID,
		AMC_en => AMC_en,
		AMC_Ready => AMC_Ready,
		BC0_lock => BC0_lock,
		AMC_REFCLK_P => AMC_REFCLK_P,
		AMC_REFCLK_N => AMC_REFCLK_N,
		AMC_RXN => AMC_RXN,
		AMC_RXP => AMC_RXP,
		AMC_TXN => AMC_TXN,
		AMC_TXP => AMC_TXP,
		AMC_status => AMC_status,
		evt_data => EventData,
		evt_data_we => evt_data_we,
		evt_buf_full => EventFIFOfull,
		evt_data_re => evt_data_re,
		evt_data_rdy => evt_data_rdy,
		event_size => event_size,
		inc_ddr_pa => inc_ddr_pa,
		ddr_pa => ddr_pa,
		mon_bufFull => mon_bufFull,
		mon_bufAlmostFull => mon_bufAlmostFull,
		mon_buf_empty => mon_buf_empty,
		inc_mon_cntr => inc_mon_cntr,
		mon_evt_wc => mon_evt_wc,
		mon_evt_cnt => mon_evt_cnt,
		mon_ctrl => mon_ctrl,
		mon_wp => mon_wp,
		mon_buf_addr_we => mon_buf_addr_we,
		mon_buf_avl => mon_buf_avl,
		TCPbuf_avl => TCPbuf_avl,
		en_XGbE => conf(1),
		buf_rqst => EventBuf_rqst,
--		buf_full => EventBuf_full,
		ipb_write => ipb_master_out.ipb_write,
		ipb_strobe => ipb_master_out.ipb_strobe,
		ipb_addr => ipb_master_out.ipb_addr,
		ipb_wdata => ipb_master_out.ipb_wdata,
		ipb_rdata => AMC_data,
		ipb_ack => AMC_ack,
		TTC_clk => TTC_clk,
		TTC_LOS => TTC_LOS,
		BC0 => BC0_dl,
		bcnt => bcnt,
		ttc_evcnt_reset => ttc_evcnt_reset,
		event_number_avl => event_number_avl,
		event_number => event_number,
		evn_buf_full => evn_fifo_full,
		ovfl_warning => L1Aovfl_warning,
		TrigData => TrigData,
		TTS => TTS
	);
AMC_reset <= not sys_lock or cmd(0);
mon_buf_addr_we <= '1' when EventBufAddr(12) = '0' and EventBufAddr_we /= "000" else '0';
i_SFP_if: SFP_if PORT MAP(
		DRPclk => DRPclk,
		reset => reset,
		rstCntr => rst_cntr,
		test => conf(9),
		REFCLK2X_OUT => SFP_REFCLK2X,
		SFP0_RXN => SFP0_RXN,
		SFP0_RXP => SFP0_RXP,
		SFP1_RXN => SFP1_RXN,
		SFP1_RXP => SFP1_RXP,
		SFP2_RXN => SFP2_RXN,
		SFP2_RXP => SFP2_RXP,
		SFP0_TXN => SFP0_TXN,
		SFP0_TXP => SFP0_TXP,
		SFP1_TXN => SFP1_TXN,
		SFP1_TXP => SFP1_TXP,
		SFP2_TXN => SFP2_TXN,
		SFP2_TXP => SFP2_TXP,
		SFP_REFCLK_N => SFP_REFCLK_N,
		SFP_REFCLK_P => SFP_REFCLK_P,
		SFP0_CLIENTEMACTXD => SFP0_CLIENTEMACTXD,
		SFP0_CLIENTEMACTXDBYTECNT => SFP0_CLIENTEMACTXDBYTECNT,
		SFP0_CLIENTEMACTXDVLD => SFP0_CLIENTEMACTXDVLD,
		SFP0_CLIENTEMACTXUNDERRUN => SFP0_CLIENTEMACTXUNDERRUN,
		SFP0_EMACCLIENTRXD => SFP0_EMACCLIENTRXD,
		SFP0_EMACCLIENTRXDVLD => SFP0_EMACCLIENTRXDVLD,
		SFP0_EMACCLIENTRXDBYTECNT => SFP0_EMACCLIENTRXDBYTECNT,
		SFP0_EMACCLIENTRXGOODFRAME => SFP0_EMACCLIENTRXGOODFRAME,
		SFP0_EMACCLIENTRXBADFRAME => SFP0_EMACCLIENTRXBADFRAME,
		SFP0_EMACCLIENTTXACK => SFP0_EMACCLIENTTXACK,
		SFP1_CLIENTEMACTXD => SFP1_CLIENTEMACTXD,
		SFP1_CLIENTEMACTXDBYTECNT => SFP1_CLIENTEMACTXDBYTECNT,
		SFP1_CLIENTEMACTXDVLD => SFP1_CLIENTEMACTXDVLD,
		SFP1_CLIENTEMACTXUNDERRUN => SFP1_CLIENTEMACTXUNDERRUN,
		SFP1_EMACCLIENTRXD => SFP1_EMACCLIENTRXD,
		SFP1_EMACCLIENTRXDVLD => SFP1_EMACCLIENTRXDVLD,
		SFP1_EMACCLIENTRXDBYTECNT => SFP1_EMACCLIENTRXDBYTECNT,
		SFP1_EMACCLIENTRXGOODFRAME => SFP1_EMACCLIENTRXGOODFRAME,
		SFP1_EMACCLIENTRXBADFRAME => SFP1_EMACCLIENTRXBADFRAME,
		SFP1_EMACCLIENTTXACK => SFP1_EMACCLIENTTXACK,
		SFP2_CLIENTEMACTXD => SFP2_CLIENTEMACTXD,
		SFP2_CLIENTEMACTXDBYTECNT => SFP2_CLIENTEMACTXDBYTECNT,
		SFP2_CLIENTEMACTXDVLD => SFP2_CLIENTEMACTXDVLD,
		SFP2_CLIENTEMACTXUNDERRUN => SFP2_CLIENTEMACTXUNDERRUN,
		SFP2_EMACCLIENTRXD => SFP2_EMACCLIENTRXD,
		SFP2_EMACCLIENTRXDVLD => SFP2_EMACCLIENTRXDVLD,
		SFP2_EMACCLIENTRXDBYTECNT => SFP2_EMACCLIENTRXDBYTECNT,
		SFP2_EMACCLIENTRXGOODFRAME => SFP2_EMACCLIENTRXGOODFRAME,
		SFP2_EMACCLIENTRXBADFRAME => SFP2_EMACCLIENTRXBADFRAME,
		SFP2_EMACCLIENTTXACK => SFP2_EMACCLIENTTXACK,
		ipb_clk => ipb_clk,
		ipb_write => ipb_master_out.ipb_write,
		ipb_strobe => ipb_master_out.ipb_strobe,
		ipb_addr => ipb_master_out.ipb_addr,
		ipb_wdata => ipb_master_out.ipb_wdata,
		ipb_rdata => SFP_data,
		ipb_ack => SFP_ack
	);
i_TCP_if: TCP_if PORT MAP(
		sysclk => sysclk,
		SFP_clk => SFP_REFCLK2X,
		reset => reset,
		en_XGbE => conf(1),
		buf_addr_avl => EventBufAddrAvl,
		buf_addr => EventBufAddr,
		wport_rdy => wport_rdy,
		evt_data_rdy => evt_data_rdy,
		event_size => event_size,
		EventData => EventData,
		EventData_we => evt_data_we,
		evt_data_re => evt_data_re,
		EventBufAddrRe => EventBufAddrRe,
		EventBufAddr_we => EventBufAddr_we,
		TCP_din => TCP_din,
		TCP_waddr => TCP_waddr,
		TCP_wrqst => TCP_wrqst,
		TCP_re => TCP_re,
		TCP_ReleaseRqst => TCP_ReleaseRqst,
		TCP_ReleaseAck => TCP_ReleaseAck,
		TCP_ReleaseAddr => TCP_ReleaseAddr,
		TCP_dout => TCP_dout,
		TCP_raddr => TCP_raddr,
		TCP_length => TCP_length,
		TCP_dout_valid => TCP_dout_valid,
		TCP_rrqst => TCP_rrqst,
		TCP_rack => TCP_rack,
		TCP_lastword => TCP_lastword,
		ipb_clk => ipb_clk,
		ipb_write => ipb_master_out.ipb_write,
		ipb_strobe => ipb_master_out.ipb_strobe,
		ipb_addr => ipb_master_out.ipb_addr,
		ipb_rdata => TCP_data,
		ipb_ack => TCP_ack,
		Link_established => conf(11 downto 9),
		SFP0_CLIENTEMACTXD => SFP0_CLIENTEMACTXD,
		SFP0_CLIENTEMACTXDBYTECNT => SFP0_CLIENTEMACTXDBYTECNT,
		SFP0_CLIENTEMACTXDVLD => SFP0_CLIENTEMACTXDVLD,
		SFP0_CLIENTEMACTXUNDERRUN => SFP0_CLIENTEMACTXUNDERRUN,
		SFP0_EMACCLIENTRXD => SFP0_EMACCLIENTRXD,
		SFP0_EMACCLIENTRXDVLD => SFP0_EMACCLIENTRXDVLD,
		SFP0_EMACCLIENTRXDBYTECNT => SFP0_EMACCLIENTRXDBYTECNT,
		SFP0_EMACCLIENTRXGOODFRAME => SFP0_EMACCLIENTRXGOODFRAME,
		SFP0_EMACCLIENTRXBADFRAME => SFP0_EMACCLIENTRXBADFRAME,
		SFP0_EMACCLIENTTXACK => SFP0_EMACCLIENTTXACK,
		SFP1_CLIENTEMACTXD => SFP1_CLIENTEMACTXD,
		SFP1_CLIENTEMACTXDBYTECNT => SFP1_CLIENTEMACTXDBYTECNT,
		SFP1_CLIENTEMACTXDVLD => SFP1_CLIENTEMACTXDVLD,
		SFP1_CLIENTEMACTXUNDERRUN => SFP1_CLIENTEMACTXUNDERRUN,
		SFP1_EMACCLIENTRXD => SFP1_EMACCLIENTRXD,
		SFP1_EMACCLIENTRXDVLD => SFP1_EMACCLIENTRXDVLD,
		SFP1_EMACCLIENTRXDBYTECNT => SFP1_EMACCLIENTRXDBYTECNT,
		SFP1_EMACCLIENTRXGOODFRAME => SFP1_EMACCLIENTRXGOODFRAME,
		SFP1_EMACCLIENTRXBADFRAME => SFP1_EMACCLIENTRXBADFRAME,
		SFP1_EMACCLIENTTXACK => SFP1_EMACCLIENTTXACK,
		SFP2_CLIENTEMACTXD => SFP2_CLIENTEMACTXD,
		SFP2_CLIENTEMACTXDBYTECNT => SFP2_CLIENTEMACTXDBYTECNT,
		SFP2_CLIENTEMACTXDVLD => SFP2_CLIENTEMACTXDVLD,
		SFP2_CLIENTEMACTXUNDERRUN => SFP2_CLIENTEMACTXUNDERRUN,
		SFP2_EMACCLIENTRXD => SFP2_EMACCLIENTRXD,
		SFP2_EMACCLIENTRXDVLD => SFP2_EMACCLIENTRXDVLD,
		SFP2_EMACCLIENTRXDBYTECNT => SFP2_EMACCLIENTRXDBYTECNT,
		SFP2_EMACCLIENTRXGOODFRAME => SFP2_EMACCLIENTRXGOODFRAME,
		SFP2_EMACCLIENTRXBADFRAME => SFP2_EMACCLIENTRXBADFRAME,
		SFP2_EMACCLIENTTXACK => SFP2_EMACCLIENTTXACK
	);
--i_check_HTRCRC: check_HTRCRC PORT MAP(
--		sysclk => sysclk,
--		reset => cmd(0),
--		HTR_en => AMC_en,
--		LinkWe => LinkWe,
--		LinkCtrl => LinkCtrl,
--		LinkData => LinkData(63 downto 0),
--		inc_HTRCRC_err => inc_HTRCRC_err
--	);
--i_DAQLSC: DAQLSC PORT MAP(
--		sysclk => sysclk,
--		reset => LSC_reset,
--		GTX_RESET => LSC_GTXreset,
--		GTX_UsrClk => SFP_UsrClk,
--		GTX_TxOutClk => SFP_UsrClk,
--		ce => conf(1),
--		LinkWe => LinkWe,
--		LinkCtrl => LinkCtrl,
--		LinkData => LinkData(63 downto 0),
--		LinkAlmostFull => LSC_LinkAlmostFull,
--		LinkDown => LSC_LinkDown,
--		src_ID => LSC_ID,
--		inject_err => (others => '0'),
--		read_ce => '0',
--		addr => x"0000",
--		status_data => LSC_debug_out,
--		REFCLK_N => SFP_REFCLK_N,
--		REFCLK_P => SFP_REFCLK_P,
--		REFCLK => SFP_clk_in,
--		SFP_RXN => SFP0_RXN,
--		SFP_RXP => SFP0_RXP,
--		SFP_TXN => SFP0_TXN,
--		SFP_TXP => SFP0_TXP
--	);
--LSC_reset <= not sys_lock or not SFPOSC_rdy or cmd(0);
--LSC_GTXreset <= not sys_lock or not SFPOSC_rdy or cmd(0) or cmd(3);
--i_DAQcheck: DAQcheck PORT MAP(
--		reset => ldc_reset,
--		GTX_RESET => LDC_GTXreset,
--		GTX_UsrClk => LDC_UsrClk,
--		GTX_TxOutClk => LDC_UsrClk,
--		sysclk => sysclk,
--		src_ID => LSC_ID,
--		inject_err => (others => '0'),
--		status_data => LDC_debug_out,
--		REFCLK_N => SFP_REFCLK_N,
--		REFCLK_P => SFP_REFCLK_P,
--		REFCLK => SFP_clk_in,
--		SFP_RXN => SFP1_RXN,
--		SFP_RXP => SFP1_RXP,
--		SFP_TXN => SFP1_TXN,
--		SFP_TXP => SFP1_TXP
--	);
--LDC_reset <= not sys_lock or cmd(0);
--LDC_GTXreset <= not sys_lock or cmd(0) or cmd(4);
--process(LDC_UsrClk, rst_cntr,reset)
--begin
--	if(reset = '1' or rst_cntr = '1')then
--		LDC_accept_cntr <= (others =>'0');
--		LDC_abort_cntr <= (others =>'0');
--		LDC_ACK_cntr <= (others =>'0');
--		LDC_event_cntr <= (others =>'0');
--		LDC_CRC_bad_cntr <= (others =>'0');
--		LDC_SEQ_bad_cntr <= (others =>'0');
--		LDC_wc_bad_cntr <= (others =>'0');
--		LDC_frame_bad_cntr <= (others =>'0');
--		LDC_buf_ovf_cntr <= (others =>'0');
--	elsif(LDC_UsrClk'event and LDC_UsrClk = '1')then
--		if(LDC_debug_out(1) = '1')then
--			LDC_accept_cntr <= LDC_accept_cntr + 1;
--		end if;
--		if(LDC_debug_out(2) = '1')then
--			LDC_abort_cntr <= LDC_abort_cntr + 1;
--		end if;
--		if(LDC_debug_out(3) = '1')then
--			LDC_ACK_cntr <= LDC_ACK_cntr + 1;
--		end if;
--		if(LDC_debug_out(1) = '1' and LDC_debug_out(4) = '1')then
--			LDC_event_cntr <= LDC_event_cntr + 1;
--		end if;
--		if(LDC_debug_out(58) = '1' and LDC_debug_out(59) = '0')then
--			LDC_CRC_bad_cntr <= LDC_CRC_bad_cntr + 1;
--		end if;
--		if(LDC_debug_out(58) = '1' and LDC_debug_out(60) = '0')then
--			LDC_SEQ_bad_cntr <= LDC_SEQ_bad_cntr + 1;
--		end if;
--		if(LDC_debug_out(58) = '1' and LDC_debug_out(61) = '0')then
--			LDC_wc_bad_cntr <= LDC_wc_bad_cntr + 1;
--		end if;
--		if(LDC_debug_out(58) = '1' and LDC_debug_out(62) = '0')then
--			LDC_frame_bad_cntr <= LDC_frame_bad_cntr + 1;
--		end if;
--		if(LDC_debug_out(58) = '1' and LDC_debug_out(63) = '1')then
--			LDC_buf_ovf_cntr <= LDC_buf_ovf_cntr + 1;
--		end if;
--	end if;
--end process;
i_sysmon_if: sysmon_if PORT MAP(
		DRPclk => DRPclk,
		SN => SN,
		VAUXN_IN => VAUXN,
		VAUXP_IN => VAUXP,
		addr => ipb_master_out.ipb_addr(15 downto 0),
		data => sysmon_data,
		device_temp => device_temp,
		ALM => ALM,
		OT => OT
	);
i_counter_L : BRAM_TDP_MACRO
   generic map (
      BRAM_SIZE => "36Kb", -- Target BRAM, "18Kb" or "36Kb" 
      DEVICE => "7SERIES", -- Target Device: "VIRTEX5", "VIRTEX6", "7SERIES", "SPARTAN6" 
      DOA_REG => 0, -- Optional port A output register (0 or 1)
      DOB_REG => 0, -- Optional port B output register (0 or 1)
      INIT_A => X"000000000", -- Initial values on A output port
      INIT_B => X"000000000", -- Initial values on B output port
      INIT_FILE => "NONE",
      READ_WIDTH_A => 32,   -- Valid values are 1-36 (19-36 only valid when BRAM_SIZE="36Kb")
      READ_WIDTH_B => 32,   -- Valid values are 1-36 (19-36 only valid when BRAM_SIZE="36Kb")
      SIM_COLLISION_CHECK => "NONE", -- Collision check enable "ALL", "WARNING_ONLY", 
                                    -- "GENERATE_X_ONLY" or "NONE" 
      SRVAL_A => X"000000000",   -- Set/Reset value for A port output
      SRVAL_B => X"000000000",   -- Set/Reset value for B port output
      WRITE_MODE_A => "WRITE_FIRST", -- "WRITE_FIRST", "READ_FIRST" or "NO_CHANGE" 
      WRITE_MODE_B => "WRITE_FIRST", -- "WRITE_FIRST", "READ_FIRST" or "NO_CHANGE" 
      WRITE_WIDTH_A => 32, -- Valid values are 1-36 (19-36 only valid when BRAM_SIZE="36Kb")
      WRITE_WIDTH_B => 32) -- Valid values are 1-36 (19-36 only valid when BRAM_SIZE="36Kb")
   port map (
      DOA => CounterDoA(31 downto 0),       -- Output port-A data, width defined by READ_WIDTH_A parameter
      DOB => CounterDoB(31 downto 0),       -- Output port-B data, width defined by READ_WIDTH_B parameter
      ADDRA => counter_wa,   -- Input port-A address, width defined by Port A depth
      ADDRB => counter_ra_l,   -- Input port-B address, width defined by Port B depth
      CLKA => sysclk,     -- 1-bit input port-A clock
      CLKB => ipb_clk,     -- 1-bit input port-B clock
      DIA => CounterDi(31 downto 0),       -- Input port-A data, width defined by WRITE_WIDTH_A parameter
      DIB => (others => '0'),       -- Input port-B data, width defined by WRITE_WIDTH_B parameter
      ENA => '1',       -- 1-bit input port-A enable
      ENB => '1',       -- 1-bit input port-B enable
      REGCEA => '1', -- 1-bit input port-A output register enable
      REGCEB => '1', -- 1-bit input port-B output register enable
      RSTA => '0',     -- 1-bit input port-A reset
      RSTB => '0',     -- 1-bit input port-B reset
      WEA => counter_we,       -- Input port-A write enable, width defined by Port A depth
      WEB => x"0"        -- Input port-B write enable, width defined by Port B depth
   );
i_counter_H : BRAM_TDP_MACRO
   generic map (
      BRAM_SIZE => "18Kb", -- Target BRAM, "18Kb" or "36Kb" 
      DEVICE => "7SERIES", -- Target Device: "VIRTEX5", "VIRTEX6", "7SERIES", "SPARTAN6" 
      DOA_REG => 0, -- Optional port A output register (0 or 1)
      DOB_REG => 0, -- Optional port B output register (0 or 1)
      INIT_A => X"000000000", -- Initial values on A output port
      INIT_B => X"000000000", -- Initial values on B output port
      INIT_FILE => "NONE",
      READ_WIDTH_A => 16,   -- Valid values are 1-36 (19-36 only valid when BRAM_SIZE="36Kb")
      READ_WIDTH_B => 16,   -- Valid values are 1-36 (19-36 only valid when BRAM_SIZE="36Kb")
      SIM_COLLISION_CHECK => "NONE", -- Collision check enable "ALL", "WARNING_ONLY", 
                                    -- "GENERATE_X_ONLY" or "NONE" 
      SRVAL_A => X"000000000",   -- Set/Reset value for A port output
      SRVAL_B => X"000000000",   -- Set/Reset value for B port output
      WRITE_MODE_A => "WRITE_FIRST", -- "WRITE_FIRST", "READ_FIRST" or "NO_CHANGE" 
      WRITE_MODE_B => "WRITE_FIRST", -- "WRITE_FIRST", "READ_FIRST" or "NO_CHANGE" 
      WRITE_WIDTH_A => 16, -- Valid values are 1-36 (19-36 only valid when BRAM_SIZE="36Kb")
      WRITE_WIDTH_B => 16) -- Valid values are 1-36 (19-36 only valid when BRAM_SIZE="36Kb")
   port map (
      DOA => CounterDoA(47 downto 32),       -- Output port-A data, width defined by READ_WIDTH_A parameter
      DOB => CounterDoB(47 downto 32),       -- Output port-B data, width defined by READ_WIDTH_B parameter
      ADDRA => counter_wa,   -- Input port-A address, width defined by Port A depth
      ADDRB => counter_ra_h,   -- Input port-B address, width defined by Port B depth
      CLKA => sysclk,     -- 1-bit input port-A clock
      CLKB => ipb_clk,     -- 1-bit input port-B clock
      DIA => CounterDi(47 downto 32),       -- Input port-A data, width defined by WRITE_WIDTH_A parameter
      DIB => (others => '0'),       -- Input port-B data, width defined by WRITE_WIDTH_B parameter
      ENA => '1',       -- 1-bit input port-A enable
      ENB => '1',       -- 1-bit input port-B enable
      REGCEA => '1', -- 1-bit input port-A output register enable
      REGCEB => '1', -- 1-bit input port-B output register enable
      RSTA => '0',     -- 1-bit input port-A reset
      RSTB => '0',     -- 1-bit input port-B reset
      WEA => counter_we(1 downto 0),       -- Input port-A write enable, width defined by Port A depth
      WEB => "00"        -- Input port-B write enable, width defined by Port B depth
   );
counter_we <= x"f" when div(1 downto 0) = "11" else x"0";
--process(sysclk)
--begin
--	if(sysClk'event and sysClk = '1')then
--		CounterDoA(31 downto 0) <= counter_L(conv_integer(counter_wa));
--		CounterDoA(47 downto 32) <= counter_H(conv_integer(counter_wa));
--		if(div(1 downto 0) = "11")then
--			counter_L(conv_integer(counter_wa)) <= CounterDi(31 downto 0);
--		end if;
--		if(div(1 downto 0) = "11")then
--			counter_H(conv_integer(counter_wa)) <= CounterDi(47 downto 32);
--		end if;
--	end if;
--end process;
process(ipb_clk)
begin
	if(ipb_clk'event and ipb_clk = '1')then
		newIPADDRSyncRegs <= newIPADDRSyncRegs(1 downto 0) & newIPADDR;
		rst_ipbus <= not newIPADDRSyncRegs(2) and newIPADDR;
	end if;
end process;
CounterDi(47 downto 8) <= (others => '0') when CntrRstCycle = '1' else
CounterDoA(47 downto 8) + 1 when CounterDi(7 downto 0) < CounterDoA(7 downto 0) else CounterDoA(47 downto 8);
counter_wa <= "00000" & div(6 downto 2);
counter_ra_l(4 downto 0) <= ipb_master_out.ipb_addr(5 downto 1);
counter_ra_h(4 downto 0) <= ipb_master_out.ipb_addr(5 downto 1);
counter_ra_l(5) <= ipb_master_out.ipb_addr(0);
counter_ra_h(5) <= not ipb_master_out.ipb_addr(0);
counter_ra_l(9 downto 6) <= x"0" when ipb_master_out.ipb_addr(15 downto 6) = misc_cntr_addr(15 downto 6) else x"1";
counter_ra_h(9 downto 6) <= x"0" when ipb_master_out.ipb_addr(15 downto 6) = misc_cntr_addr(15 downto 6) else x"1";
process(sysClk)
begin
	if(sysclk'event and sysclk = '1')then
		if(CntrRst = '1')then
			div <= (others => '0');
		else
			div <= div + 1;
		end if;
		resetCntr_SyncRegs <= resetCntr_SyncRegs(1 downto 0) & rst_cntr;
		CntrRst <= not resetCntr_SyncRegs(2) and resetCntr_SyncRegs(1);
		if(CntrRst = '1')then
			CntrRstCycle <= '1';
		elsif(and_reduce(div) = '1')then
			CntrRstCycle <= '0';
		end if;
		if(CntrRstCycle = '1')then
			CounterDi(7 downto 0) <= (others => '0');
		else
			case div(6 downto 2) is
				when "00000" => CounterDi(7 downto 0) <= TTC_serr_cntr;
				when "00001" => CounterDi(7 downto 0) <= TTC_derr_cntr;
				when "00010" => CounterDi(7 downto 0) <= TTC_BcntErr_cntr;
				when "00011" => CounterDi(7 downto 0) <= L1A_cntr;
				when "00100" => CounterDi(7 downto 0) <= run_cntr;
				when "00101" => CounterDi(7 downto 0) <= ready_cntr;
				when "00110" => CounterDi(7 downto 0) <= busy_cntr;
				when "00111" => CounterDi(7 downto 0) <= sync_cntr;
				when "01000" => CounterDi(7 downto 0) <= ovfl_cntr;
				when "01001" => CounterDi(7 downto 0) <= SLINKword_cntr;
				when "01010" => CounterDi(7 downto 0) <= SLINKevent_cntr;
				when "01011" => CounterDi(7 downto 0) <= monitorEvent_cntr;
				when others => CounterDi(7 downto 0) <= (others => '0');
			end case;
		end if;
	end if;
end process;
i_DNA_PORT : DNA_PORT
   generic map (
      SIM_DNA_VALUE => X"00123456789abcd"  -- Specifies a sample 57-bit DNA value for simulation
   )
   port map (
      DOUT => DNA_out,   -- 1-bit output: DNA output data.
      CLK => ipb_clk,     -- 1-bit input: Clock input.
      DIN => '0',     -- 1-bit input: User data input pin.
      READ => load_DNA,   -- 1-bit input: Active high load DNA, active low read input.
      SHIFT => shift_DNA(1)  -- 1-bit input: Active high shift enable input.
   );
process(ipb_clk)
begin
	if(ipb_clk'event and ipb_clk = '1')then
		load_DNA <= not sys_lock;
		if(sys_lock = '0')then
			shift_DNA(0) <= '0';
		elsif(load_DNA = '1')then
			shift_DNA(0) <= '1';
		elsif(shift_DNA(2) = '1' and or_reduce(DNA_cntr(5 downto 1)) = '0')then
			shift_DNA(0) <= '0';
		end if;
		shift_DNA(2) <= shift_DNA(0);
		if(shift_DNA(2) = '1')then
			DNA_cntr <= DNA_cntr - 1;
		elsif(shift_DNA(0) = '1')then
			DNA_cntr <= "110111";
		end if;
		if(shift_DNA(2) = '1')then
			DNA <= DNA(55 downto 0) & DNA_OUT;
		end if;
	end if;
end process;
process(ipb_clk)
begin
	if(ipb_clk'event and ipb_clk = '0')then
		shift_DNA(1) <= shift_DNA(0);
	end if;
end process;
end Behavioral;

