----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    15:55:15 07/09/2010 
-- Design Name: 
-- Module Name:    AMC_if - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
use IEEE.std_logic_misc.all;
use work.amc13_pack.all;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
library UNISIM;
use UNISIM.VComponents.all;
Library UNIMACRO;
use UNIMACRO.vcomponents.all;

entity AMC_if is
		Generic (simulation : boolean := false);
    Port ( sysclk : in  STD_LOGIC;
					 ipb_clk : in std_logic;
					 DRPclk : in std_logic;
					 GTXreset : in  STD_LOGIC;
					 reset : in  STD_LOGIC;
					 resetCntr : in  STD_LOGIC;
					 run : in  STD_LOGIC;
					 en_localL1A : IN std_logic;
					 test : in  STD_LOGIC;
					 fake_length	: in   std_logic_vector(11 downto 0);
           T1_version : in  STD_LOGIC_VECTOR(7 downto 0);
           Source_ID : in  STD_LOGIC_VECTOR(19 downto 0);
           AMC_en : in  STD_LOGIC_VECTOR(11 downto 0);
           AMC_Ready : out  STD_LOGIC_VECTOR(11 downto 0);
           BC0_lock : out  STD_LOGIC_VECTOR(11 downto 0);
					 AMC_REFCLK_P : in  STD_LOGIC;
					 AMC_REFCLK_N : in  STD_LOGIC;
           AMC_RXN : in  STD_LOGIC_VECTOR(12 downto 1);
           AMC_RXP : in  STD_LOGIC_VECTOR(12 downto 1);
           AMC_TXN : out  STD_LOGIC_VECTOR(12 downto 1);
           AMC_TXP : out  STD_LOGIC_VECTOR(12 downto 1);
           AMC_status : out  STD_LOGIC_VECTOR(31 downto 0);
					 evt_data : out array3X65;
					 evt_data_re : in std_logic_vector(2 downto 0);
					 evt_buf_full : in std_logic_vector(2 downto 0);
					 evt_data_we : out std_logic_vector(2 downto 0);
					 evt_data_rdy : out std_logic_vector(2 downto 0);
					 event_size : out std_logic_vector(2 downto 0); -- in number of 8Kbyte blocks
					 inc_ddr_pa : in std_logic;
					 ddr_pa	: in  STD_LOGIC_VECTOR(12 downto 0);
					 mon_bufFull : out STD_LOGIC;
					 mon_bufAlmostFull : out STD_LOGIC;
					 mon_buf_empty : out STD_LOGIC;
					 inc_mon_cntr	: out STD_LOGIC;
					 mon_evt_wc	: out STD_LOGIC_VECTOR (31 downto 0);
					 mon_evt_cnt : out STD_LOGIC_VECTOR (31 downto 0);
					 mon_ctrl	: out STD_LOGIC_VECTOR (31 downto 0);
					 mon_wp	: out STD_LOGIC_VECTOR (31 downto 0);
-- buffer control
					 mon_buf_addr_we : in STD_LOGIC; -- not buf_addr(12) and buf_addr_we
					 mon_buf_avl : in STD_LOGIC; -- 
					 TCPbuf_avl : in STD_LOGIC; -- 
					 en_XGbE : in STD_LOGIC; -- 
--					 buf_full : in STD_LOGIC; -- 
					 buf_rqst	: out STD_LOGIC_VECTOR (1 downto 0);
--	ipbus signals
					 ipb_write : in  STD_LOGIC;
					 ipb_strobe : in  STD_LOGIC;
					 ipb_addr	: in  STD_LOGIC_VECTOR(31 downto 0);
					 ipb_wdata : in  STD_LOGIC_VECTOR(31 downto 0);
					 ipb_rdata : out  STD_LOGIC_VECTOR(31 downto 0);
					 ipb_ack : out  STD_LOGIC;
-- TTC & TTS signals
					 TTC_clk : in   std_logic;
					 TTC_LOS : in   std_logic;
					 BC0 : in  std_logic;
					 bcnt : in std_logic_vector(3 downto 0);
					 ttc_evcnt_reset : in std_logic;
					 event_number_avl : in std_logic;
					 event_number : in std_logic_vector(59 downto 0);
					 evn_buf_full : out std_logic;
					 ovfl_warning : out std_logic;
					 TrigData	: out  std_logic_vector(7 downto 0);
					 TTS : out  std_logic_vector(3 downto 0)
					);
end AMC_if;

architecture Behavioral of AMC_if is
COMPONENT fake_event
	PORT(
		sysclk : IN std_logic;
		UsrClk : IN std_logic;
		reset : IN std_logic;
    EventBuilt : in  STD_LOGIC;
		fake_en : IN std_logic;
		ovfl_warning : in  STD_LOGIC;
		fake_length	: in   std_logic_vector(11 downto 0);
		L1A_DATA : IN std_logic_vector(15 downto 0);
		L1A_WrEn : IN std_logic;          
		fake_header : OUT std_logic;
		fake_accept : OUT std_logic;
		empty_event_flag : out  STD_LOGIC;
		fake_DATA : OUT std_logic_vector(15 downto 0);
		fake_WrEn : OUT std_logic
		);
END COMPONENT;
COMPONENT AMC_Link
	PORT(
		sysclk : IN std_logic;
		reset : IN std_logic;
		resetCntr : IN std_logic;
		test : IN std_logic;
		UsrClk : IN std_logic;
		AMC_ID : IN std_logic_vector(3 downto 0);
    rxfsmresetdone                   		: in   std_logic;
    txfsmresetdone	                 		: in   std_logic;
    RxResetDone	                    		: in   std_logic;
    qpll_lock	                       		: in   std_logic;
    rxcommaalignen                 			: out  std_logic;
    DATA_VALID                     			: out  std_logic;
    RXDATA		                      		: in   std_logic_vector(15 downto 0);
    RXCHARISCOMMA                     	: in   std_logic_vector(1 downto 0);
    RXCHARISK		                      	: in   std_logic_vector(1 downto 0);
    RXNOTINTABLE                      	: in   std_logic_vector(1 downto 0);
    TXDATA     	                    		: out  std_logic_vector(15 downto 0);
    TXCHARISK                        		: out  std_logic_vector(1 downto 0);
		AMC_en : IN std_logic;
		AMC_DATA_RdEn : IN std_logic;
		EventInfoRdDone : IN std_logic;
		L1A_DATA : IN std_logic_vector(15 downto 0);
		L1A_WrEn : IN std_logic;
		fake_header : IN std_logic;
		fake_DATA : IN std_logic_vector(15 downto 0);
		fake_WrEn : IN std_logic;
		fake_accept : IN std_logic;
		Cntr_RdEn : IN std_logic;
		Cntr_str : IN std_logic;
		ipb_addr : IN std_logic_vector(15 downto 0);
		TTCclk : IN std_logic;
		BC0 : IN std_logic;
		bcnt : IN std_logic_vector(3 downto 0);
		TTC_LOS : IN std_logic;          
		Ready : OUT std_logic;
		EventInfo : OUT std_logic_vector(19 downto 0);
		EventInfo_dav : OUT std_logic;
		AMC_DATA : OUT std_logic_vector(63 downto 0);
		bad_AMC : OUT std_logic;
		AMC_OK : OUT std_logic;
		Cntr_DATA : OUT std_logic_vector(15 downto 0);
		ipb_rdata : OUT std_logic_vector(31 downto 0);
		debug_out : OUT std_logic_vector(255 downto 0);
		TTC_status : OUT std_logic_vector(127 downto 0);
		TrigData : OUT std_logic_vector(7 downto 0);
		TTS : OUT std_logic_vector(3 downto 0)
		);
END COMPONENT;
COMPONENT AMC_wrapper
    Port ( DRPclk : in  STD_LOGIC;
           SOFT_RESET : in  STD_LOGIC;
           UsrClk : in  STD_LOGIC;
           test : in  STD_LOGIC;
           AMC_en : in  STD_LOGIC_VECTOR(11 downto 0);
					 RXDATA : out array12X16;
           rxprbserr : out  STD_LOGIC_VECTOR(11 downto 0);
					 rxprbssel : in array12X3;
           RXNOTINTABLE : out  array12X2;
           rxcommaalignen : in  STD_LOGIC_VECTOR(11 downto 0);
					 rxchariscomma : out array12X2;
					 rxcharisk : out array12X2;
           rxresetdone : out  STD_LOGIC_VECTOR(11 downto 0);
					 txdiffctrl : in array12X4;
					 TXDATA : in array12X16;
           txoutclk : out  STD_LOGIC_VECTOR(11 downto 0);
					 txcharisk : in array12X2;
           txresetdone : out  STD_LOGIC_VECTOR(11 downto 0);
					 txprbssel : in array12X3;
           qpll_lock : out  STD_LOGIC_VECTOR(2 downto 0);
           txfsmresetdone : out  STD_LOGIC_VECTOR(11 downto 0);
           rxfsmresetdone : out  STD_LOGIC_VECTOR(11 downto 0);
           data_valid : in  STD_LOGIC_VECTOR(11 downto 0);
           AMC_REFCLK : in  STD_LOGIC;
           RXN : in  STD_LOGIC_VECTOR(11 downto 0);
           RXP : in  STD_LOGIC_VECTOR(11 downto 0);
           TXN : out  STD_LOGIC_VECTOR(11 downto 0);
           TXP : out  STD_LOGIC_VECTOR(11 downto 0)
					 );
END COMPONENT;
COMPONENT evt_bldr
	PORT(
		clk : IN std_logic;
		reset : IN std_logic;
		Source_ID : IN std_logic_vector(7 downto 0);
		AMC_wc : IN std_logic_vector(10 downto 0);
		AMC_wc_we : IN std_logic;
		channel_in : IN std_logic_vector(3 downto 0);
		AMC_header : IN std_logic_vector(63 downto 0);
		AMC_header_we : IN std_logic;
		AMC_DATA : IN array12X64;
		evt_data_re : IN std_logic;
		AMC_DATA_re : OUT std_logic_vector(11 downto 0);
		evt_data : OUT std_logic_vector(64 downto 0);
		evt_data_we : out STD_LOGIC;
		evt_buf_full : in STD_LOGIC;
		evt_data_rdy : OUT std_logic;
		channel_out : OUT std_logic_vector(3 downto 0);
		EventBuilt : out STD_LOGIC;
		busy : OUT std_logic
		);
END COMPONENT;
COMPONENT cmsCRC64
	PORT(
		clk : IN std_logic;
		reset : IN std_logic;
		data_in : IN std_logic_vector(63 downto 0);
		ctrl_in : IN std_logic;
		we_in : IN std_logic;          
		crc : OUT std_logic_vector(15 downto 0);
		crc_err : OUT std_logic;
		data_out : OUT std_logic_vector(63 downto 0);
		ctrl_out : OUT std_logic;
		we_out : OUT std_logic
		);
END COMPONENT;
type array_x12y256 is array(11 downto 0) of std_logic_vector(255 downto 0);
type array_x12y16 is array(11 downto 0) of std_logic_vector(15 downto 0);
type array_x12y20 is array(11 downto 0) of std_logic_vector(19 downto 0);
type array_x12y8 is array(11 downto 0) of std_logic_vector(7 downto 0);
type array_x12y4 is array(11 downto 0) of std_logic_vector(3 downto 0);
type array_x12y128 is array(11 downto 0) of std_logic_vector(127 downto 0);
constant AMC_ID : array_x12y4 := (x"b",x"a",x"9",x"8",x"7",x"6",x"5",x"4",x"3",x"2",x"1",x"0");
constant AMC_txdiffctrl : array12x4 := (others => x"b");
signal resetSyncRegs : std_logic_vector(2 downto 0) := (others => '0');
signal EventInfo : array_x12y20;
signal AMC_DATA : array12X64;
signal Cntr_DATA : array_x12y16;
signal AMC_TrigData : array_x12y8;
signal AMC_TTS : array_x12y4;
signal AMC_debug : array_x12y256;
signal TTC_status : array_x12y128;
signal EventInfo_dav : std_logic_vector(11 downto 0);
signal EventInfoRdDone : std_logic := '0';
signal AMC_DATA_RdEn : std_logic_vector(11 downto 0) := (others => '0');
signal Cntr_RdEn : std_logic_vector(11 downto 0) := (others => '0');
signal ipb_strobe_q : std_logic := '0';
signal CounterDoB_h : std_logic := '0';
signal Cntr_str : std_logic := '0';
signal UsrClk : std_logic := '0';
signal UsrClk_out : std_logic_vector(11 downto 0) := (others => '0');
--type RAM1024X16 is array(0 to 1023) of std_logic_vector(15 downto 0);
--signal counter_L : RAM1024X16;
--type RAM1024X32 is array(0 to 1023) of std_logic_vector(31 downto 0);
--signal counter_H : RAM1024X32;
signal counter_we_H : std_logic_vector(3 downto 0) := (others => '0');
signal counter_we_L : std_logic_vector(1 downto 0) := (others => '0');
signal counter_wa : std_logic_vector(9 downto 0) := (others => '0');
signal CounterDi : std_logic_vector(47 downto 0) := (others => '0');
signal CounterDoA : std_logic_vector(47 downto 0) := (others => '0');
signal CounterDoB : std_logic_vector(47 downto 0) := (others => '0');
signal resetCntr_SyncRegs : std_logic_vector(2 downto 0) := (others => '0');
signal CntrRst : std_logic := '0';
signal CntrRstCycle : std_logic := '0';
signal IsStatus : std_logic := '0';
signal div : std_logic_vector(11 downto 0) := (others => '0');
signal inc_div : std_logic_vector(11 downto 0) := (others => '0');
signal evn_out : std_logic_vector(59 downto 0) := (others => '0');
signal evn_wa : std_logic_vector(8 downto 0) := (others => '0');
signal evn_ra : std_logic_vector(8 downto 0) := (others => '0');
signal evn_cnt : std_logic_vector(7 downto 0) := (others => '0');
signal evn : std_logic_vector(23 downto 0) := (others => '0');
--type RAM512X72 is array(0 to 511) of std_logic_vector(71 downto 0);
--signal CDF : RAM512X72;
signal CDF_in : std_logic_vector(71 downto 0) := (others => '0');
signal CDF_out : std_logic_vector(71 downto 0) := (others => '0');
signal CDF_wa : std_logic_vector(8 downto 0) := (others => '0');
signal CDF_ra : std_logic_vector(8 downto 0) := (others => '0');
signal empty_event_flag : std_logic := '0';
signal ovfl_warning_i : std_logic := '0';
signal ovfl_warning_p : std_logic := '0';
signal init_bldr : std_logic := '0';
signal ec_sel_AMC : std_logic := '0';
signal sel_AMC : std_logic_vector(3 downto 0) := (others => '0');
signal sel_CDF : std_logic := '0';
signal evn_empty : std_logic := '0';
signal sel_evn : std_logic_vector(1 downto 0) := (others => '0');
signal L1A_WrEn : std_logic := '0';
signal L1A_DATA : std_logic_vector(15 downto 0) := (others => '0');
signal EvtTy : std_logic_vector(3 downto 0) := (others => '0');
signal CalTy : std_logic_vector(3 downto 0) := (others => '0');
signal event_avl : std_logic := '0';
--type lutsr16x3 is array (0 to 15) of std_logic_vector(2 downto 0);
--signal event_size_queue : lutsr16x3 := (others => (others => '0'));
signal event_size_di : std_logic_vector(2 downto 0) := (others => '0');
signal event_size_do : std_logic_vector(2 downto 0) := (others => '0');
signal event_size_a : std_logic_vector(3 downto 0) := (others => '0');
signal event_size_we : std_logic := '0';
signal rst_init_bldr : std_logic := '0';
signal event_size_vld : std_logic := '0';
signal Builder_busy : std_logic_vector(2 downto 0) := (others => '0');
signal ec_CDF_ra : std_logic := '0';
signal ec_summary_wc : std_logic := '0';
signal summary_wc : std_logic_vector(1 downto 0) := (others => '0');
signal summary : std_logic_vector(63 downto 0) := (others => '0');
signal dcc_header : std_logic_vector(63 downto 0) := (others => '0');
signal AMC_TTC_status : std_logic_vector(31 downto 0) := (others => '0');
signal fake_DATA : std_logic_vector(15 downto 0) := (others => '0');
--signal fake_evn : std_logic_vector(3 downto 0) := (others => '0');
signal fake_header : std_logic := '0';
signal fake_WrEn : std_logic := '0';
signal fake_accept : std_logic := '0';
signal fake_word_cnt : std_logic_vector(31 downto 0) := (others => '0');
signal fake_evt_cnt : std_logic_vector(31 downto 0) := (others => '0');
signal empty_evt_cnt : std_logic_vector(31 downto 0) := (others => '0');
signal fake_header_cnt: std_logic_vector(31 downto 0) := (others => '0');
signal EventBuilt : std_logic_vector(2 downto 0) := (others => '0');
signal next_bldr : std_logic_vector(1 downto 0) := (others => '0');
signal sel_bldr : std_logic_vector(1 downto 0) := (others => '0');
signal sel_bldr_r : std_logic_vector(1 downto 0) := (others => '0');
signal MUX_AMC_wc : std_logic_vector(12 downto 0) := (others => '0');
signal AMC_wc : std_logic_vector(12 downto 0) := (others => '0');
signal AMC_wc_we : std_logic_vector(2 downto 0) := (others => '0');
signal AMC_header : std_logic_vector(63 downto 0) := (others => '0');
signal evt_bldr_busy : std_logic_vector(2 downto 0) := (others => '0');
signal AMC_header_we : std_logic_vector(2 downto 0) := (others => '0');
type array3X12 is array(0 to 2) of std_logic_vector(11 downto 0);
signal AMC_DATA_re : array3X12;
signal AMC_REFCLK : std_logic := '0';
signal AMC_qpll_lock : std_logic_vector(2 downto 0) := (others =>'0');
signal AMC_rxprbserr : std_logic_vector(11 downto 0) := (others =>'0');
signal AMC_rxcommaalignen : std_logic_vector(11 downto 0) := (others =>'0');
signal AMC_rxresetdone : std_logic_vector(11 downto 0) := (others =>'0');
signal AMC_txfsmresetdone : std_logic_vector(11 downto 0) := (others =>'0');
signal AMC_rxfsmresetdone : std_logic_vector(11 downto 0) := (others =>'0');
signal AMC_data_valid : std_logic_vector(11 downto 0) := (others =>'0');
signal AMC_RXDATA : array12x16 := (others => (others => '0'));
signal AMC_TXDATA : array12x16 := (others => (others => '0'));
signal AMC_RXNOTINTABLE : array12x2 := (others => (others => '0'));
signal AMC_rxchariscomma : array12x2 := (others => (others => '0'));
signal AMC_rxcharisk : array12x2 := (others => (others => '0'));
signal AMC_txcharisk : array12x2 := (others => (others => '0'));
signal AMC_rxprbssel : array12x3 := (others => (others => '0'));
signal AMC_txprbssel : array12x3 := (others => (others => '0'));
type array3X4 is array(0 to 2) of std_logic_vector(3 downto 0);
signal channel : array3X4;
-- monitor signals
type RAM4096X16 is array(0 to 4095) of std_logic_vector(15 downto 0);
signal mon_wcbuf : RAM4096X16;
signal mon_wc: std_logic_vector(15 downto 0) := (others => '0');
signal mon_en: std_logic := '0';
signal scale_cntr : std_logic_vector(15 downto 0) := (others => '0');
signal ce_scale : std_logic := '0';
signal ld_scale : std_logic := '0';
signal ce_wc_reg_wap: std_logic := '0';
signal ce_wc_reg_wa: std_logic := '0';
signal wc_reg_wa: std_logic_vector(11 downto 0) := (others => '0');
signal wc_reg_ra: std_logic_vector(11 downto 0) := (others => '0');
signal mon_buf_empty_i : std_logic := '0';
signal catch_enable : std_logic := '0';
signal down_count : std_logic := '0';
signal up_count : std_logic := '0';
signal evt_cnt : std_logic_vector(12 downto 0) := (others => '0');
signal mon_mask: std_logic_vector(19 downto 0) := (others => '0');
signal sample_event: std_logic := '0';
signal scale : std_logic_vector(31 downto 0) := (others => '0');
signal pending : std_logic := '0';
signal inc_ddr_pa_SyncRegs : std_logic_vector(2 downto 0) := (others => '0');
signal htr_summary : std_logic := '0';
signal htr_summary_q : std_logic := '0';
signal ec_catch_cntr : std_logic := '0';
signal ec_catch_cntr_q : std_logic := '0';
signal catch_cntr: std_logic_vector(6 downto 0) := (others => '0');
signal AMC_Ready_i : std_logic_vector(11 downto 0);
signal AMC_OK : std_logic_vector(11 downto 0);
signal buf_rqst_i : std_logic_vector(1 downto 0) := (others => '0');
component icon2
  PORT (
    CONTROL0 : INOUT STD_LOGIC_VECTOR(35 DOWNTO 0);
    CONTROL1 : INOUT STD_LOGIC_VECTOR(35 DOWNTO 0));

end component;
component ila128x4096
  PORT (
    CONTROL : INOUT STD_LOGIC_VECTOR(35 DOWNTO 0);
    CLK : IN STD_LOGIC;
    DATA : IN STD_LOGIC_VECTOR(143 DOWNTO 0);
    TRIG0 : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
    TRIG1 : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
    TRIG2 : IN STD_LOGIC_VECTOR(7 DOWNTO 0));

end component;
signal CONTROL0 : STD_LOGIC_VECTOR(35 DOWNTO 0);
signal CONTROL1 : STD_LOGIC_VECTOR(35 DOWNTO 0);
signal DATA0 : STD_LOGIC_VECTOR(143 DOWNTO 0);
signal TRIG0 : STD_LOGIC_VECTOR(7 DOWNTO 0);
signal TRIG1 : STD_LOGIC_VECTOR(7 DOWNTO 0);
signal TRIG2 : STD_LOGIC_VECTOR(7 DOWNTO 0);
signal DATA1 : STD_LOGIC_VECTOR(143 DOWNTO 0);
signal TRIG0b : STD_LOGIC_VECTOR(7 DOWNTO 0);
signal TRIG1b : STD_LOGIC_VECTOR(7 DOWNTO 0);
signal TRIG2b : STD_LOGIC_VECTOR(7 DOWNTO 0);
begin
--i_icon : icon2
--  port map (
--    CONTROL0 => CONTROL0,
--    CONTROL1 => CONTROL1);
--i_ila : ila128x4096
--      port map (
--        CONTROL => CONTROL0,
--        CLK => UsrClk,
--        DATA => DATA0,
--        TRIG0 => TRIG0,
--        TRIG1 => x"00",
--        TRIG2 => x"00");
--DATA0(3 downto 0) <= TTC_status(10)(84 downto 81);
--DATA0(16 downto 4) <= TTC_status(10)(18 downto 6);
--DATA0(44 downto 17) <= TTC_status(10)(118 downto 91);
--DATA0(46 downto 45) <= AMC_rxchariscomma(10);
--DATA0(48 downto 47) <= AMC_rxcharisk(10);
--DATA0(64 downto 49) <= AMC_RXDATA(10);
--DATA0(66 downto 65) <= TTC_status(10)(53 downto 52);
--DATA0(70 downto 67) <= TTC_status(9)(84 downto 81);
--DATA0(83 downto 71) <= TTC_status(9)(18 downto 6);
--DATA0(85 downto 84) <= TTC_status(9)(53 downto 52);
--DATA0(87 downto 86) <= AMC_rxchariscomma(9);
--DATA0(89 downto 88) <= AMC_rxcharisk(9);
--DATA0(105 downto 90) <= AMC_RXDATA(9);
--DATA0(109 downto 106) <= TTC_status(1)(84 downto 81);
--DATA0(122 downto 110) <= TTC_status(1)(18 downto 6);
--DATA0(124 downto 123) <= TTC_status(1)(53 downto 52);
--DATA0(125) <= AMC_rxchariscomma(1)(0);
--DATA0(127 downto 126) <= AMC_rxcharisk(1);
--DATA0(143 downto 128) <= AMC_RXDATA(1);
--TRIG0(1 downto 0) <= TTC_status(10)(53 downto 52) ;
--TRIG0(3 downto 2) <= TTC_status(9)(53 downto 52) ;
--TRIG0(5 downto 4) <= TTC_status(1)(53 downto 52) ;
--TRIG0(7 downto 6) <= "00" ;
--i_ila_b : ila128x4096
--          port map (
--            CONTROL => CONTROL1,
--            CLK => TTC_clk,
--            DATA => DATA1,
--            TRIG0 => TRIG1,
--            TRIG1 => x"00",
--            TRIG2 => x"00");
--DATA1(0) <= BC0;
--DATA1(9 downto 1) <= TTC_status(10)(35 downto 27);
--DATA1(46 downto 10) <= TTC_status(10)(90 downto 54);
--DATA1(55 downto 47) <= TTC_status(9)(35 downto 27);
--DATA1(92 downto 56) <= TTC_status(9)(90 downto 54);
--DATA1(101 downto 93) <= TTC_status(1)(35 downto 27);
--DATA1(138 downto 102) <= TTC_status(1)(90 downto 54);
--DATA1(142 downto 139) <= bcnt;
--TRIG1(0) <= BC0;
--TRIG1(2 downto 1) <= TTC_status(10)(31 downto 30);
--TRIG1(4 downto 3) <= TTC_status(9)(31 downto 30);
--TRIG1(6 downto 5) <= TTC_status(1)(31 downto 30);
--TRIG1(7) <= '0';
buf_rqst <= buf_rqst_i;
AMC_Ready <= AMC_Ready_i;
EventInfoRdDone <= event_size_we;
mon_buf_empty <= mon_buf_empty_i;
mon_evt_cnt <= x"0000" & "000" & evt_cnt;
inc_mon_cntr <= ce_wc_reg_wa;
mon_ctrl <= scale;
process(sysclk,reset)
begin
	if(reset = '1')then
		resetSyncRegs <= (others => '1');
	elsif(sysclk'event and sysclk = '1')then
		resetSyncRegs <= resetSyncRegs(1 downto 0) & '0';
	end if;
end process;
-- receiving L1 information
ovfl_warning <= ovfl_warning_i;
i_evn : BRAM_SDP_MACRO
   generic map (
      BRAM_SIZE => "36Kb", -- Target BRAM, "18Kb" or "36Kb" 
      DEVICE => "7SERIES", -- Target device: "VIRTEX5", "VIRTEX6", "7SERIES", "SPARTAN6" 
      WRITE_WIDTH => 60,    -- Valid values are 1-72 (37-72 only valid when BRAM_SIZE="36Kb")
      READ_WIDTH => 60,     -- Valid values are 1-72 (37-72 only valid when BRAM_SIZE="36Kb")
      DO_REG => 0, -- Optional output register (0 or 1)
      SIM_COLLISION_CHECK => "NONE", -- Collision check enable "ALL", "WARNING_ONLY", 
                                    -- "GENERATE_X_ONLY" or "NONE"       
      WRITE_MODE => "WRITE_FIRST", -- Specify "READ_FIRST" for same clock or synchronous clocks
                                   --  Specify "WRITE_FIRST for asynchrononous clocks on ports
      INIT => X"000000000000000000") --  Initial values on output port
   port map (
      DO => evn_out,         -- Output read data port, width defined by READ_WIDTH parameter
      DI => event_number,         -- Input write data port, width defined by WRITE_WIDTH parameter
      RDADDR => evn_ra, -- Input read address, width defined by read port depth
      RDCLK => sysclk,   -- 1-bit input read clock
      RDEN => '1',     -- 1-bit input read port enable
      REGCE => '1',   -- 1-bit input read output register enable
      RST => '0',       -- 1-bit input reset 
      WE => x"ff",         -- Input write enable, width defined by write port depth
      WRADDR => evn_wa, -- Input write address, width defined by write port depth
      WRCLK => sysclk,   -- 1-bit input write clock
      WREN => event_number_avl      -- 1-bit input write port enable
   );
process(sysclk)
begin
	if(sysclk'event and sysclk = '1')then
		if(ttc_evcnt_reset = '1' or resetSyncRegs(2) = '1')then
			evn_wa <= (others => '0');
		elsif(event_number_avl = '1')then
			evn_wa <= evn_wa + 1;
		end if;
		if(ttc_evcnt_reset = '1' or resetSyncRegs(2) = '1')then
			evn <= x"000001";
			evn_ra <= (others => '0');
		elsif(sel_evn = "10")then
			evn <= evn + 1;
			evn_ra <= evn_ra + 1;
		end if;
		evn_cnt <= CDF_wa(8 downto 1) - CDF_ra(8 downto 1);
		if(and_reduce(evn_cnt(7 downto 5)) = '1')then
			evn_buf_full <= '1';
		else
			evn_buf_full <= '0';
		end if;
-- when reached 0x60, throttle L1A. Return only after go below 0x40
		if(or_reduce(evn_cnt(7 downto 6)) = '0')then
			ovfl_warning_i <= '0';
		elsif(evn_cnt(5) = '1')then
			ovfl_warning_i <= '1';
		end if;
	end if;
end process;
-- send L1info to AMC_Link
process(sysclk)
begin
	if(sysclk'event and sysclk = '1')then
		if(ttc_evcnt_reset = '1' or resetSyncRegs(2) = '1' or evn_wa = evn_ra)then
			evn_empty <= '1';
		else
			evn_empty <= '0';
		end if;
		L1A_WrEn <= not evn_empty;
		if(ttc_evcnt_reset = '1' or resetSyncRegs(2) = '1' or evn_empty = '1')then
			sel_evn <= "00";
		else
			sel_evn(1) <= sel_evn(1) xor sel_evn(0);
			sel_evn(0) <= not sel_evn(0);
		end if;
		case sel_evn is
			when "00" => L1A_DATA <= x"00" & evn(7 downto 0);
			when "01" => L1A_DATA <= evn(23 downto 8);
			when "10" => L1A_DATA <= evn_out(16 downto 12) & "00000000000";
			when others => L1A_DATA <= x"0" & evn_out(11 downto 0);
		end case;
	end if;
end process;
i_CDF : BRAM_SDP_MACRO
   generic map (
      BRAM_SIZE => "36Kb", -- Target BRAM, "18Kb" or "36Kb" 
      DEVICE => "7SERIES", -- Target device: "VIRTEX5", "VIRTEX6", "7SERIES", "SPARTAN6" 
      WRITE_WIDTH => 72,    -- Valid values are 1-72 (37-72 only valid when BRAM_SIZE="36Kb")
      READ_WIDTH => 72,     -- Valid values are 1-72 (37-72 only valid when BRAM_SIZE="36Kb")
      DO_REG => 0, -- Optional output register (0 or 1)
      SIM_COLLISION_CHECK => "NONE", -- Collision check enable "ALL", "WARNING_ONLY", 
                                    -- "GENERATE_X_ONLY" or "NONE"       
      WRITE_MODE => "WRITE_FIRST", -- Specify "READ_FIRST" for same clock or synchronous clocks
                                   --  Specify "WRITE_FIRST for asynchrononous clocks on ports
      INIT => X"000000000000000000") --  Initial values on output port
   port map (
      DO => CDF_out,         -- Output read data port, width defined by READ_WIDTH parameter
      DI => CDF_in,         -- Input write data port, width defined by WRITE_WIDTH parameter
      RDADDR => CDF_ra, -- Input read address, width defined by read port depth
      RDCLK => sysclk,   -- 1-bit input read clock
      RDEN => '1',     -- 1-bit input read port enable
      REGCE => '1',   -- 1-bit input read output register enable
      RST => '0',       -- 1-bit input reset 
      WE => x"ff",         -- Input write enable, width defined by write port depth
      WRADDR => CDF_wa, -- Input write address, width defined by write port depth
      WRCLK => sysclk,   -- 1-bit input write clock
      WREN => sel_evn(0)      -- 1-bit input write port enable
   );
process(sysclk)
begin
	if(sysclk'event and sysclk = '1')then
--		if(sel_evn(0) = '1')then
--			CDF(conv_integer(CDF_wa)) <= CDF_in;
--		end if;
--		CDF_out <= CDF(conv_integer(CDF_ra));
		if(ttc_evcnt_reset = '1' or resetSyncRegs(2) = '1')then
			CDF_wa <= (others => '0');
		elsif(sel_evn(0) = '1')then
			CDF_wa <= CDF_wa + 1;
		end if;
		if(ttc_evcnt_reset = '1' or resetSyncRegs(2) = '1')then
			CDF_ra <= (others => '0');
		elsif(ec_CDF_ra = '1')then
			CDF_ra <= CDF_ra + 1;
		end if;
		if(sel_evn(1) = '0')then
			CDF_in <= x"005" & EvtTy & evn & evn_out(11 downto 0) & Source_ID(11 downto 0) & x"08"; -- header1
		else
			CDF_in <= evn_out(55 downto 52) & x"00" & CalTy & x"00000" & evn_out(43 downto 12) & x"0"; -- header2, top nibble is TTS at L1A
		end if;
	end if;
end process;
EvtTy <= "00" & evn_out(45) & not evn_out(45);
CalTy <= evn_out(51 downto 48);
process(sysclk)
begin
	if(sysclk'event and sysclk = '1')then
		if(resetSyncRegs(2) = '1')then
			init_bldr <= '0';
			event_avl <= '0';
			next_bldr <= "00";
			sel_bldr <= "11";
			sel_bldr_r <= "11";
			ec_sel_AMC <= '0';
			AMC_wc_we <= "000";
			ec_CDF_ra <= '0';
			AMC_header_we <= "000";
			sel_CDF <= '0';
			ec_summary_wc <= '0';
			buf_rqst_i <= "00";
			summary_wc <= "00";
			htr_summary <= '0';
			sel_AMC <= x"0";
		else
			event_avl <= and_reduce(not AMC_en or EventInfo_dav) and or_reduce(AMC_en);
			if(event_avl = '1' and evt_bldr_busy(conv_integer(next_bldr)) = '0' and init_bldr = '0' and event_size_a /= x"e" and ((mon_buf_avl = '1' and mon_en = '1') or ((TCPbuf_avl = '1' or en_XGbE = '0') and mon_en = '0')))then
				init_bldr <= '1';
				ec_CDF_ra <= '1';
				ec_sel_AMC <= '1';
				sel_bldr <= next_bldr;
				next_bldr(1) <= next_bldr(0);
				next_bldr(0) <= not next_bldr(1) and not next_bldr(0);
				buf_rqst_i <= en_XGbE & mon_en;
			else
				buf_rqst_i <= "00";
			end if;
			if(rst_init_bldr = '1')then
				init_bldr <= '0';
			end if;
			if(CDF_ra(0) = '1')then
				ec_CDF_ra <= '0';
			end if;
			if(sel_AMC = x"b")then
				ec_sel_AMC <= '0';
				sel_bldr <= "11";
			end if;
			sel_bldr_r <= sel_bldr;
			AMC_wc_we(0) <= not sel_bldr_r(1) and not sel_bldr_r(0);
			AMC_wc_we(1) <= not sel_bldr_r(1) and sel_bldr_r(0);
			AMC_wc_we(2) <= sel_bldr_r(1) and not sel_bldr_r(0);
			if(sel_CDF = '1')then
				AMC_header_we(0) <= not sel_bldr(1) and not sel_bldr(0);
				AMC_header_we(1) <= not sel_bldr(1) and sel_bldr(0);
				AMC_header_we(2) <= sel_bldr(1) and not sel_bldr(0);
			elsif(sel_AMC(2 downto 0) = "111")then
				AMC_header_we <= "000";
			end if;
			sel_CDF <= ec_CDF_ra;
			if(summary_wc = "11")then
				ec_summary_wc <= '0';
			elsif(sel_CDF = '1')then
				ec_summary_wc <= '1';
			end if;
			if(ec_summary_wc = '0')then
				summary_wc <= "00";
			else
				summary_wc <= summary_wc + 1;
			end if;
			if(summary_wc = "00")then
				htr_summary <= '0';
			else
				htr_summary <= '1';
			end if;
			if(ec_sel_AMC = '0')then
				sel_AMC <= x"0";
			elsif(sel_AMC /= x"b")then
				sel_AMC <= sel_AMC + 1;
			end if;
		end if;
		for i in 0 to 11 loop
			if(EventInfo(i)(13 downto 12) = "00" and AMC_en(i) = '1')then
				dcc_header(32+i) <= '1';
			else
				dcc_header(32+i) <= '0';
			end if;
		end loop;
		case summary_wc is
			when "01" => summary(63 downto 32) <= EventInfo(3)(14) & EventInfo(3)(14 downto 0) & EventInfo(2)(14) & EventInfo(2)(14 downto 0);
									 summary(31 downto 0) <= EventInfo(1)(14) & EventInfo(1)(14 downto 0) & EventInfo(0)(14) & EventInfo(0)(14 downto 0);
			when "10" => summary(63 downto 32) <= EventInfo(7)(14) & EventInfo(7)(14 downto 0) & EventInfo(6)(14) & EventInfo(6)(14 downto 0);
									 summary(31 downto 0) <= EventInfo(5)(14) & EventInfo(5)(14 downto 0) & EventInfo(4)(14) & EventInfo(4)(14 downto 0);
			when "11" => summary(63 downto 32) <= EventInfo(11)(14) & EventInfo(11)(14 downto 0) & EventInfo(10)(14) & EventInfo(10)(14 downto 0);
									 summary(31 downto 0) <= EventInfo(9)(14) & EventInfo(9)(14 downto 0) & EventInfo(8)(14) & EventInfo(8)(14 downto 0);
			when others => summary <= dcc_header;
		end case;
		if(sel_CDF = '1')then
			AMC_header <= CDF_out(63 downto 0);
		else
			AMC_header <= summary;
		end if;
		MUX_AMC_wc <= AMC_en(conv_integer(sel_AMC)) & EventInfo(conv_integer(sel_AMC))(11 downto 0);
		AMC_wc <= MUX_AMC_wc(12) & (MUX_AMC_wc(11 downto 0) + x"003");
	end if;
end process;
dcc_header(63 downto 56) <= (others => '0');
dcc_header(55 downto 48) <= (others => '0') when simulation else T1_version; -- simulation bug?
dcc_header(47 downto 44) <= (others => '0');
dcc_header(31 downto 0) <= (others => '0') when simulation else x"00000010"; -- simulation bug?
g_evt_bldr : for i in 0 to 2 generate
	i_evt_bldr: evt_bldr PORT MAP(
		clk => sysclk,
		reset => resetSyncRegs(2),
		Source_ID => Source_ID(19 downto 12),
		AMC_wc => AMC_wc(12 downto 2),
		AMC_wc_we => AMC_wc_we(i),
		channel_in => channel((i+2) mod 3),
		AMC_header => AMC_header,
		AMC_header_we => AMC_header_we(i),
		AMC_DATA => AMC_DATA,
		AMC_DATA_re => AMC_DATA_re(i),
		evt_data => evt_data(i),
		evt_data_we => evt_data_we(i),
		evt_buf_full => evt_buf_full(i),
		evt_data_re => evt_data_re(i),
		evt_data_rdy => evt_data_rdy(i),
		channel_out => channel(i),
		EventBuilt => EventBuilt(i),
		busy => evt_bldr_busy(i)
	);
end generate;
AMC_DATA_RdEn <= AMC_DATA_re(0) or AMC_DATA_re(1) or AMC_DATA_re(2);
g_AMC_Link : for i in 0 to 11 generate
	i_AMC_Link: AMC_Link 
	PORT MAP(
		sysclk => sysclk,
		reset => resetSyncRegs(2),
		resetCntr => CntrRst,
		test => test,
		UsrClk => UsrClk,
		RXNOTINTABLE => AMC_RXNOTINTABLE(i),
		rxcommaalignen => AMC_rxcommaalignen(i),
		rxchariscomma => AMC_rxchariscomma(i),
		rxcharisk => AMC_rxcharisk(i),
		rxresetdone => AMC_rxresetdone(i),
		qpll_lock => AMC_qpll_lock(i/4),
		txfsmresetdone => AMC_txfsmresetdone(i),
		rxfsmresetdone => AMC_rxfsmresetdone(i),
		data_valid => AMC_data_valid(i),
		RXDATA => AMC_RXDATA(i),
		txcharisk => AMC_txcharisk(i),
		TXDATA => AMC_TXDATA(i),
		Ready => AMC_Ready_i(i),
		AMC_ID => AMC_ID(i),
		EventInfo => EventInfo(i),
		EventInfo_dav => EventInfo_dav(i),
		AMC_DATA_RdEn => AMC_DATA_RdEn(i),
		EventInfoRdDone => EventInfoRdDone,
		AMC_DATA => AMC_DATA(i),
		bad_AMC => AMC_status(i),
		AMC_OK => AMC_OK(i),
--		AMC_OK => AMC_status(i+16),
		L1A_DATA => L1A_DATA,
		L1A_WrEn => L1A_WrEn,
    fake_header => fake_header,
    fake_DATA	=> fake_DATA,
--    fake_evn => fake_evn,
    fake_WrEn => fake_WrEn,
    fake_accept => fake_accept,
		Cntr_RdEn => Cntr_RdEn(i),
		Cntr_str => Cntr_str,
		Cntr_DATA => Cntr_DATA(i),
		ipb_addr => (others => '0'),
		ipb_rdata => open,
		debug_out => AMC_debug(i),
		TTCclk => TTC_clk,
		BC0 => BC0,
		bcnt => bcnt,
		TTC_LOS => TTC_LOS,
--		AMC_en => AMC_en(i) or ASYNC_OUT(i),
		AMC_en => AMC_en(i),
		TTC_status => TTC_status(i),
		TrigData => AMC_TrigData(i),
		TTS => AMC_TTS(i)
	);
end generate;
i_AMC_wrapper: AMC_wrapper PORT MAP(
		DRPclk => DRPclk,
		SOFT_RESET => GTXreset,
		UsrClk => UsrClk,
		test => test,
		AMC_en => AMC_en,
		RXDATA => AMC_RXDATA,
		rxprbserr => AMC_rxprbserr,
		rxprbssel => AMC_rxprbssel,
		RXNOTINTABLE => AMC_RXNOTINTABLE,
		rxcommaalignen => AMC_rxcommaalignen,
		rxchariscomma => AMC_rxchariscomma,
		rxcharisk => AMC_rxcharisk,
		rxresetdone => AMC_rxresetdone,
		txdiffctrl => AMC_txdiffctrl,
		TXDATA => AMC_TXDATA,
		txoutclk => UsrClk_out,
		txcharisk => AMC_txcharisk,
		txresetdone => open,
		txprbssel => AMC_txprbssel,
		qpll_lock => AMC_qpll_lock,
		txfsmresetdone => AMC_txfsmresetdone,
		rxfsmresetdone => AMC_rxfsmresetdone,
		data_valid => AMC_data_valid,
		AMC_REFCLK => AMC_REFCLK,
		RXN => AMC_RXN,
		RXP => AMC_RXP,
		TXN => AMC_TXN,
		TXP => AMC_TXP
	);
process(sysclk)
begin
	if(sysclk'event and sysclk = '1')then
		ovfl_warning_p <= ovfl_warning_i and not en_localL1A;
	end if;
end process;
i_fake_event: fake_event PORT MAP(
		sysclk => sysclk,
		UsrClk => UsrClk,
		reset => resetSyncRegs(2),
		fake_en => test,
		fake_length => fake_length,
		ovfl_warning => ovfl_warning_p,
		EventBuilt => or_reduce(EventBuilt),
		L1A_DATA => L1A_DATA,
		L1A_WrEn => L1A_WrEn,
		fake_header => fake_header,
		fake_accept => fake_accept,
		empty_event_flag => empty_event_flag,
		fake_DATA => fake_DATA,
		fake_WrEn => fake_WrEn
	);
process(TTC_Clk)
begin
	if(TTC_Clk'event and TTC_Clk = '1')then
		TrigData <= AMC_TrigData(0) or AMC_TrigData(1) or AMC_TrigData(2) or AMC_TrigData(3) or AMC_TrigData(4) or AMC_TrigData(5) or
								AMC_TrigData(6) or AMC_TrigData(7) or AMC_TrigData(8) or AMC_TrigData(9) or AMC_TrigData(10) or AMC_TrigData(11);
	end if;
end process;
process(sysclk)
begin
	if(sysclk'event and sysclk = '1')then
		TTS <= AMC_TTS(0) or AMC_TTS(1) or AMC_TTS(2) or AMC_TTS(3) or AMC_TTS(4) or AMC_TTS(5) or
					 AMC_TTS(6) or AMC_TTS(7) or AMC_TTS(8) or AMC_TTS(9) or AMC_TTS(10) or AMC_TTS(11);
	end if;
end process;
i_UsrClk_buf: bufg port map(i => UsrClk_out(6), o => UsrClk);
--process(UsrClk)
--begin
--	if(UsrClk'event and UsrClk = '1')then
--		CounterDoA(15 downto 0) <= counter_L(conv_integer(counter_wa));
--		CounterDoA(47 downto 16) <= counter_H(conv_integer(counter_wa));
--		if(Cntr_str = '1')then
--			counter_L(conv_integer(counter_wa)) <= CounterDi(15 downto 0);
--		end if;
--		if(CntrRstCycle = '1' or (div(1 downto 0) = "10" and CounterDi(15 downto 0) < CounterDoA(15 downto 0)))then
--			counter_H(conv_integer(counter_wa)) <= CounterDi(47 downto 16);
--		end if;
--	end if;
--end process;
--process(ipb_clk)
--begin
--	if(ipb_clk'event and ipb_clk = '1')then
--		CounterDoB(15 downto 0) <= counter_L(conv_integer(ipb_addr(10 downto 1)));
--		CounterDoB(47 downto 16) <= counter_H(conv_integer(ipb_addr(10 downto 1)));
--	end if;
--end process;
i_counter_H : BRAM_TDP_MACRO
   generic map (
      BRAM_SIZE => "36Kb", -- Target BRAM, "18Kb" or "36Kb" 
      DEVICE => "7SERIES", -- Target Device: "VIRTEX5", "VIRTEX6", "7SERIES", "SPARTAN6" 
      DOA_REG => 0, -- Optional port A output register (0 or 1)
      DOB_REG => 0, -- Optional port B output register (0 or 1)
      INIT_A => X"000000000", -- Initial values on A output port
      INIT_B => X"000000000", -- Initial values on B output port
      INIT_FILE => "NONE",
      READ_WIDTH_A => 32,   -- Valid values are 1-36 (19-36 only valid when BRAM_SIZE="36Kb")
      READ_WIDTH_B => 32,   -- Valid values are 1-36 (19-36 only valid when BRAM_SIZE="36Kb")
      SIM_COLLISION_CHECK => "NONE", -- Collision check enable "ALL", "WARNING_ONLY", 
                                    -- "GENERATE_X_ONLY" or "NONE" 
      SRVAL_A => X"000000000",   -- Set/Reset value for A port output
      SRVAL_B => X"000000000",   -- Set/Reset value for B port output
      WRITE_MODE_A => "WRITE_FIRST", -- "WRITE_FIRST", "READ_FIRST" or "NO_CHANGE" 
      WRITE_MODE_B => "WRITE_FIRST", -- "WRITE_FIRST", "READ_FIRST" or "NO_CHANGE" 
      WRITE_WIDTH_A => 32, -- Valid values are 1-36 (19-36 only valid when BRAM_SIZE="36Kb")
      WRITE_WIDTH_B => 32) -- Valid values are 1-36 (19-36 only valid when BRAM_SIZE="36Kb")
   port map (
      DOA => CounterDoA(47 downto 16),       -- Output port-A data, width defined by READ_WIDTH_A parameter
      DOB => CounterDoB(47 downto 16),       -- Output port-B data, width defined by READ_WIDTH_B parameter
      ADDRA => counter_wa,   -- Input port-A address, width defined by Port A depth
      ADDRB => ipb_addr(10 downto 1),   -- Input port-B address, width defined by Port B depth
      CLKA => UsrClk,     -- 1-bit input port-A clock
      CLKB => ipb_clk,     -- 1-bit input port-B clock
      DIA => CounterDi(47 downto 16),       -- Input port-A data, width defined by WRITE_WIDTH_A parameter
      DIB => (others => '0'),       -- Input port-B data, width defined by WRITE_WIDTH_B parameter
      ENA => '1',       -- 1-bit input port-A enable
      ENB => '1',       -- 1-bit input port-B enable
      REGCEA => '1', -- 1-bit input port-A output register enable
      REGCEB => '1', -- 1-bit input port-B output register enable
      RSTA => '0',     -- 1-bit input port-A reset
      RSTB => '0',     -- 1-bit input port-B reset
      WEA => counter_we_H,       -- Input port-A write enable, width defined by Port A depth
      WEB => x"0"        -- Input port-B write enable, width defined by Port B depth
   );
counter_we_H <= x"f" when CntrRstCycle = '1' or (div(1 downto 0) = "10" and CounterDi(15 downto 0) < CounterDoA(15 downto 0)) else x"0";
i_counter_L : BRAM_TDP_MACRO
   generic map (
      BRAM_SIZE => "18Kb", -- Target BRAM, "18Kb" or "36Kb" 
      DEVICE => "7SERIES", -- Target Device: "VIRTEX5", "VIRTEX6", "7SERIES", "SPARTAN6" 
      DOA_REG => 0, -- Optional port A output register (0 or 1)
      DOB_REG => 0, -- Optional port B output register (0 or 1)
      INIT_A => X"000000000", -- Initial values on A output port
      INIT_B => X"000000000", -- Initial values on B output port
      INIT_FILE => "NONE",
      READ_WIDTH_A => 16,   -- Valid values are 1-36 (19-36 only valid when BRAM_SIZE="36Kb")
      READ_WIDTH_B => 16,   -- Valid values are 1-36 (19-36 only valid when BRAM_SIZE="36Kb")
      SIM_COLLISION_CHECK => "NONE", -- Collision check enable "ALL", "WARNING_ONLY", 
                                    -- "GENERATE_X_ONLY" or "NONE" 
      SRVAL_A => X"000000000",   -- Set/Reset value for A port output
      SRVAL_B => X"000000000",   -- Set/Reset value for B port output
      WRITE_MODE_A => "WRITE_FIRST", -- "WRITE_FIRST", "READ_FIRST" or "NO_CHANGE" 
      WRITE_MODE_B => "WRITE_FIRST", -- "WRITE_FIRST", "READ_FIRST" or "NO_CHANGE" 
      WRITE_WIDTH_A => 16, -- Valid values are 1-36 (19-36 only valid when BRAM_SIZE="36Kb")
      WRITE_WIDTH_B => 16) -- Valid values are 1-36 (19-36 only valid when BRAM_SIZE="36Kb")
   port map (
      DOA => CounterDoA(15 downto 0),       -- Output port-A data, width defined by READ_WIDTH_A parameter
      DOB => CounterDoB(15 downto 0),       -- Output port-B data, width defined by READ_WIDTH_B parameter
      ADDRA => counter_wa,   -- Input port-A address, width defined by Port A depth
      ADDRB => ipb_addr(10 downto 1),   -- Input port-B address, width defined by Port B depth
      CLKA => UsrClk,     -- 1-bit input port-A clock
      CLKB => ipb_clk,     -- 1-bit input port-B clock
      DIA => CounterDi(15 downto 0),       -- Input port-A data, width defined by WRITE_WIDTH_A parameter
      DIB => (others => '0'),       -- Input port-B data, width defined by WRITE_WIDTH_B parameter
      ENA => '1',       -- 1-bit input port-A enable
      ENB => '1',       -- 1-bit input port-B enable
      REGCEA => '1', -- 1-bit input port-A output register enable
      REGCEB => '1', -- 1-bit input port-B output register enable
      RSTA => '0',     -- 1-bit input port-A reset
      RSTB => '0',     -- 1-bit input port-B reset
      WEA => counter_we_L,       -- Input port-A write enable, width defined by Port A depth
      WEB => "00"        -- Input port-B write enable, width defined by Port B depth
   );
counter_we_L <= "11" when Cntr_str = '1' else "00";
process(TTC_status)
begin
	for i in 0 to 11 loop
		AMC_TTC_status(i) <= TTC_status(i)(0) and AMC_en(i);
		AMC_TTC_status(i+16) <= TTC_status(i)(1) and AMC_en(i);
	end loop;
end process;
BC0_lock <= AMC_TTC_status(11 downto 0);
AMC_TTC_status(31 downto 28) <= x"0";
AMC_TTC_status(15 downto 12) <= x"0";
process(ipb_clk)
begin
	if(ipb_clk'event and ipb_clk = '1')then
		if(ipb_strobe = '1' and ipb_write = '1' and ipb_addr(14 downto 0) = MON_ctrl_addr(14 downto 0) and ipb_addr(27) = '0')then
			scale(23 downto 0) <= ipb_wdata(23 downto 0);
		end if;
		if(run = '1' and or_reduce(scale(17 downto 16)) = '1')then
			catch_enable <= '1'; 
		else
			catch_enable <= '0'; 
		end if;
		if(catch_enable = '0' or mon_buf_empty_i = '1')then
			mon_evt_wc(31 downto 16) <= (others => '0');
		else
			mon_evt_wc(31 downto 16) <= '0' & catch_cntr & scale(23 downto 16);
		end if;
		if(ipb_addr(15 downto 11) /= AMC_reg_addr(15 downto 11))then
			ipb_rdata <= (others => '0');
		elsif(ipb_addr(10 downto 9) = "11")then
			if(ipb_addr(4) = '0')then
				case ipb_addr(3 downto 0) is
					when x"0" => ipb_rdata <= AMC_TTS(0) & AMC_TrigData(0) & EventInfo(0);
					when x"1" => ipb_rdata <= AMC_TTS(1) & AMC_TrigData(1) & EventInfo(1);
					when x"2" => ipb_rdata <= AMC_TTS(2) & AMC_TrigData(2) & EventInfo(2);
					when x"3" => ipb_rdata <= AMC_TTS(3) & AMC_TrigData(3) & EventInfo(3);
					when x"4" => ipb_rdata <= AMC_TTS(4) & AMC_TrigData(4) & EventInfo(4);
					when x"5" => ipb_rdata <= AMC_TTS(5) & AMC_TrigData(5) & EventInfo(5);
					when x"6" => ipb_rdata <= AMC_TTS(6) & AMC_TrigData(6) & EventInfo(6);
					when x"7" => ipb_rdata <= AMC_TTS(7) & AMC_TrigData(7) & EventInfo(7);
					when x"8" => ipb_rdata <= AMC_TTS(8) & AMC_TrigData(8) & EventInfo(8);
					when x"9" => ipb_rdata <= AMC_TTS(9) & AMC_TrigData(9) & EventInfo(9);
					when x"a" => ipb_rdata <= AMC_TTS(10) & AMC_TrigData(10) & EventInfo(10);
					when x"b" => ipb_rdata <= AMC_TTS(11) & AMC_TrigData(11) & EventInfo(11);
					when x"c" => ipb_rdata <= x"0000" & '0' & not AMC_qpll_lock & EventInfo_dav;
					when x"d" => ipb_rdata <= AMC_TTC_status;
					when x"f" => ipb_rdata <= x"000000"  & evn_cnt;
					when others => ipb_rdata <= (others => '0');
				end case;
			else
				case ipb_addr(3 downto 0) is
					when x"0" => ipb_rdata <= "0000000" & evn_ra & "0000000" & evn_wa;
					when x"1" => ipb_rdata <= x"00" & evn;
					when x"2" => ipb_rdata <= "0000000" & CDF_ra & "0000000" & CDF_wa;
					when x"3" => ipb_rdata <= "00000000000" & evn_empty & event_avl & evt_bldr_busy & ec_CDF_ra & AMC_wc_we & sel_CDF & AMC_header_we & sel_evn & sel_bldr & sel_AMC;
					when x"4" => ipb_rdata <= fake_word_cnt;
					when x"5" => ipb_rdata <= fake_header_cnt;
					when x"6" => ipb_rdata <= fake_evt_cnt;
					when x"7" => ipb_rdata <= empty_evt_cnt;
					when x"8" => ipb_rdata <= TTC_status(7)(5 downto 2) & TTC_status(6)(5 downto 2) & TTC_status(5)(5 downto 2) & TTC_status(4)(5 downto 2) & TTC_status(3)(5 downto 2) & TTC_status(2)(5 downto 2) & TTC_status(1)(5 downto 2) & TTC_status(0)(5 downto 2);
					when x"9" => ipb_rdata <= x"0000" & TTC_status(11)(5 downto 2) & TTC_status(10)(5 downto 2) & TTC_status(9)(5 downto 2) & TTC_status(8)(5 downto 2);
--					when x"a" => ipb_rdata <= TTC_status(10) & TTC_status(9);
					when others => ipb_rdata <= (others => '0');
				end case;
			end if;
		else
			if(CounterDoB_h = '0')then
				ipb_rdata <= CounterDoB(31 downto 0);
			else
				ipb_rdata <= x"0000" & CounterDoB(47 downto 32);
			end if;
		end if;
		if(ipb_addr(15 downto 11) = AMC_reg_addr(15 downto 11) and ipb_write = '0')then
			if(ipb_addr(10 downto 9) = "11")then
				ipb_ack <= ipb_strobe;
			else
				ipb_ack <= ipb_strobe_q;
			end if;
		else
			ipb_ack <= '0';
		end if;
		ipb_strobe_q <= ipb_strobe;
		CounterDoB_h <= ipb_addr(0);
	end if;
end process;
AMC_status(31 downto 28) <= (others => '0');
--AMC_status(27 downto 16) <= AMC_OK;
AMC_status(27 downto 16) <= AMC_data_valid;
AMC_status(15 downto 12) <= (others => '0');
inc_div <= x"004" when CntrRstCycle = '1' else x"001";
process(UsrClk)
variable CntrDataOR : std_logic_vector(15 downto 0);
begin
	CntrDataOR := (others => '0');
	for i in 0 to 11 loop
		CntrDataOR := CntrDataOR or Cntr_Data(i);
	end loop;
	if(UsrClk'event and UsrClk = '1')then
		if(CntrRst = '1')then
			fake_word_cnt <= (others => '0');
			fake_evt_cnt <= (others => '0');
			empty_evt_cnt <= (others => '0');
			fake_header_cnt <= (others => '0');
		else
			if(fake_WrEn = '1')then
				fake_word_cnt <= fake_word_cnt + 1;
			end if;
			if(fake_accept = '1')then
				fake_evt_cnt <= fake_evt_cnt + 1;
			end if;
			if(fake_accept = '1' and empty_event_flag = '1')then
				empty_evt_cnt <= empty_evt_cnt + 1;
			end if;
			if(fake_WrEn = '1' and fake_header = '1')then
				fake_header_cnt <= fake_header_cnt + 1;
			end if;
		end if;
		if(CntrRst = '1' or div = x"bff")then
			div <= (others => '0');
		else
			div <= div + inc_div;
		end if;
		if(CntrRst = '1' or CntrRstCycle = '1' or div(1 downto 0) = "01")then
			Cntr_str <= '1';
		else
			Cntr_str <= '0';
		end if;
		if(CntrRstCycle = '1' or div(1 downto 0) = "11")then
			counter_wa <= div(11 downto 2);
		end if;
		if(counter_wa(5 downto 3) = "111" or counter_wa(5 downto 4) = "01")then
			IsStatus <= '1';
		else
			IsStatus <= '0';
		end if;
		if(Cntr_str = '1')then
			case div(11 downto 8) is
				when x"0" => Cntr_RdEn <= x"001";
				when x"1" => Cntr_RdEn <= x"002";
				when x"2" => Cntr_RdEn <= x"004";
				when x"3" => Cntr_RdEn <= x"008";
				when x"4" => Cntr_RdEn <= x"010";
				when x"5" => Cntr_RdEn <= x"020";
				when x"6" => Cntr_RdEn <= x"040";
				when x"7" => Cntr_RdEn <= x"080";
				when x"8" => Cntr_RdEn <= x"100";
				when x"9" => Cntr_RdEn <= x"200";
				when x"a" => Cntr_RdEn <= x"400";
				when x"b" => Cntr_RdEn <= x"800";
				when others => Cntr_RdEn <= x"000";
			end case;
		end if;
		resetCntr_SyncRegs <= resetCntr_SyncRegs(1 downto 0) & resetCntr;
		CntrRst <= not resetCntr_SyncRegs(2) and resetCntr_SyncRegs(1);
		if(CntrRst = '1')then
			CntrRstCycle <= '1';
		elsif(div(11 downto 2) = "1011111111")then
			CntrRstCycle <= '0';
		end if;
		if(CntrRstCycle = '1')then
			CounterDi <= (others => '0');
		else
			CounterDi(47 downto 16) <= CounterDoA(47 downto 16) + 1;
			CounterDi(15 downto 0) <= CntrDataOR;
		end if;
	end if;
end process;
i_AMC_refclk: IBUFDS_GTE2
    port map
    (
        O                               => AMC_REFCLK,
        ODIV2                           => open,
        CEB                             => '0',
        I                               => AMC_REFCLK_P,  -- Connect to package pin AB6
        IB                              => AMC_REFCLK_N       -- Connect to package pin AB5
    );
-- monitoring logic
event_size_di <= "000" when mon_en = '0' and en_XGbE = '0' else mon_wc(13 downto 11) when or_reduce(mon_wc(10  downto 1)) = '0' else mon_wc(13 downto 11) + 1;
g_event_size: for i in 0 to 2 generate
	i_event_size : SRL16E
   generic map (
      INIT => X"0000")
   port map (
      Q => event_size_do(i),       -- SRL data output
      A0 => event_size_a(0),     -- Select[0] input
      A1 => event_size_a(1),     -- Select[1] input
      A2 => event_size_a(2),     -- Select[2] input
      A3 => event_size_a(3),     -- Select[3] input
      CE => event_size_we,     -- Clock enable input
      CLK => sysclk,   -- Clock input
      D => event_size_di(i)        -- SRL data input
   );
end generate;
ec_catch_cntr <= event_size_we;
process(sysclk)
begin
	if(sysclk'event and sysclk = '1')then
		case scale(22 downto 19) is
			when x"0" => mon_mask <= x"00000";
			when x"1" => mon_mask <= x"80000";
			when x"2" => mon_mask <= x"c0000";
			when x"3" => mon_mask <= x"e0000";
			when x"4" => mon_mask <= x"f0000";
			when x"5" => mon_mask <= x"f8000";
			when x"6" => mon_mask <= x"fc000";
			when x"7" => mon_mask <= x"fe000";
			when x"8" => mon_mask <= x"ff000";
			when x"9" => mon_mask <= x"ff800";
			when x"a" => mon_mask <= x"ffc00";
			when x"b" => mon_mask <= x"ffe00";
			when x"c" => mon_mask <= x"fff00";
			when x"d" => mon_mask <= x"fff80";
			when x"e" => mon_mask <= x"fffc0";
			when others => mon_mask <= x"fffe0";
		end case;
    if(sel_CDF = '1' and ec_CDF_ra = '1')then
			if(and_reduce(CDF_out(51 downto 32) or mon_mask) = '1')then
				sample_event <= '1';
			else
				sample_event <= '0';
			end if;
		end if;
    if(resetSyncRegs(2) = '1')then
-- After reset, the first event will always be recorded
      mon_en <= not scale(23);
			pending <= '0';
--    elsif(ec_catch_cntr_q = '1')then
    elsif(rst_init_bldr = '1')then
			if(scale(23) = '1')then
				mon_en <= not evt_cnt(12) and sample_event;
				pending <= '0';
			elsif(catch_enable = '1')then
				mon_en <= not evt_cnt(0);
				pending <= '0';
			else
				mon_en <= not evt_cnt(12) and (and_reduce(scale_cntr) or pending);
				pending <= evt_cnt(12) and (and_reduce(scale_cntr) or pending);
			end if;
		end if;
		if(ec_sel_AMC = '1' and AMC_wc_we = "000")then
			mon_wc <= x"000e";
		elsif(AMC_wc_we /= "000" and AMC_wc(12) = '1')then
			mon_wc(13 downto 1) <= mon_wc(13 downto 1) + ("000" & AMC_wc(11 downto 2));
		end if;
		if(ce_scale = '1')then
			if(ld_scale = '1')then
				scale_cntr <= not scale(15 downto 0);
			else
				scale_cntr <= scale_cntr + 1;
			end if;
		end if;
    if(resetSyncRegs(2) = '1')then
			ce_scale <= '0';
			ld_scale <= '0';
			up_count <= '0';
			ce_wc_reg_wap <= '0';
			ce_wc_reg_wa <= '0';
--			htr_summary_q <= '0';
--			ec_catch_cntr <= '0';
--			ec_catch_cntr_q <= '0';
		else
			ce_scale <= not sel_CDF and ec_CDF_ra;
			ld_scale <= mon_en or pending;
			if(catch_enable = '0')then
				up_count <= mon_en and buf_rqst_i(0);
			else
				up_count <= catch_cntr(6);
			end if;
			if(mon_en = '1' and ec_sel_AMC = '0' and sel_AMC(3) = '1')then
				ce_wc_reg_wap <= '1';
			else
				ce_wc_reg_wap <= '0';
			end if;
			ce_wc_reg_wa <= ce_wc_reg_wap;
--			htr_summary_q <= htr_summary;
--			ec_catch_cntr <= htr_summary_q and not htr_summary;
--			ec_catch_cntr_q <= ec_catch_cntr;
		end if;
		if(resetSyncRegs(2) = '1')then
			scale(31 downto 24) <= (others => '0');
		elsif(htr_summary = '1')then
			for i in 0 to 3 loop
				if(summary(i*16+15) = '1')then
					scale(25 downto 24) <= scale(17 downto 16) and (scale(25 downto 24) or summary(i*16+13 downto i*16+12));
				end if;
			end loop;
		end if;
		if(or_reduce(scale(25 downto 24)) = '0')then
			catch_cntr <= (others => '0');
		elsif(ec_catch_cntr = '1')then
			catch_cntr <= catch_cntr + 1;
		end if;
--		if(event_size_we = '1')then
--			event_size_queue <= event_size_di & event_size_queue(0 to 14);
--		end if;
--		if(event_size_vld = '0' or evt_data_re /= "000")then
--			event_size <= event_size_queue(conv_integer(event_size_a));
--		end if;
		if(event_size_vld = '0' or evt_data_re /= "000")then
			event_size <= event_size_do;
		end if;
		event_size_we <= not resetSyncRegs(2) and not ec_sel_AMC and sel_AMC(3);
		rst_init_bldr <= event_size_we;
		if(resetSyncRegs(2) = '1')then
			event_size_a <= (others => '1');
		elsif(event_size_we = '1' and (event_size_a = x"f" or (event_size_vld = '1' and evt_data_re = "000")))then
			event_size_a <= event_size_a + 1;
		elsif(event_size_we = '0' and event_size_a /= x"f" and (event_size_vld = '0' or evt_data_re /= "000"))then
			event_size_a <= event_size_a - 1;
		end if;
		if(resetSyncRegs(2) = '1')then
			event_size_vld <= '0';
		elsif(event_size_a /= x"f")then
			event_size_vld <= '1';
		elsif(evt_data_re /= "000")then
			event_size_vld <= '0';
		end if;
		if(ce_wc_reg_wa = '1')then
			mon_wcbuf(conv_integer(wc_reg_wa)) <= mon_wc;
		end if;
    if(resetSyncRegs(2) = '1')then
			wc_reg_wa <= (others => '0');
		elsif(ce_wc_reg_wa = '1')then
			wc_reg_wa <= wc_reg_wa + 1;
		end if;
		wc_reg_ra <= ddr_pa(11 downto 0);
		if(or_reduce(evt_cnt) = '0')then
			mon_buf_empty_i <= '1';
		else
			mon_buf_empty_i <= '0';
		end if;
		if(mon_buf_empty_i = '1')then
			mon_evt_wc(15 downto 0) <= (others => '0');
		else
			mon_evt_wc(15 downto 0) <= mon_wcbuf(conv_integer(wc_reg_ra));
		end if;
		if(resetSyncRegs(2) = '1')then
			mon_wp <= (others => '0');
		elsif(ec_catch_cntr = '1')then
			mon_wp(11 downto 0) <= wc_reg_wa;
		end if;
		if(resetSyncRegs(2) = '1')then
			inc_ddr_pa_SyncRegs <= (others => '0');
		else
			inc_ddr_pa_SyncRegs <= inc_ddr_pa_SyncRegs(1 downto 0) & inc_ddr_pa;
		end if;
		if(resetSyncRegs(2) = '1' or or_reduce(evt_cnt) = '0')then
			down_count <= '0';
		else
			down_count <= not inc_ddr_pa_SyncRegs(2) and inc_ddr_pa_SyncRegs(1) and not catch_enable;
		end if;
		if(resetSyncRegs(2) = '1')then
			evt_cnt <= (others => '0');
		elsif(up_count = '1' and down_count = '0')then
			evt_cnt <= evt_cnt + 1;
		elsif(up_count = '0' and down_count = '1')then
			evt_cnt <= evt_cnt - 1;
		end if;
		if(catch_enable = '0')then
			mon_bufFull <= evt_cnt(12);
			mon_bufAlmostFull <= evt_cnt(12) or and_reduce(evt_cnt(11 downto 0));
		else
			mon_bufFull <= evt_cnt(0);
			mon_bufAlmostFull <= evt_cnt(0) or and_reduce(catch_cntr(5 downto 0));
		end if;
--		if(mon_buf_empty_i = '1')then
--			mon_evt_wc(15 downto 0) <= (others => '0');
--		else
--			mon_evt_wc(15 downto 0) <= mon_wcbuf(conv_integer(ddr_pa));
--		end if;
	end if;
end process;
end Behavioral;

