----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    11:15:28 03/21/2013 
-- Design Name: 
-- Module Name:    AMC_wrapper - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use work.amc13_pack.all;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity AMC_wrapper is
    Port ( DRPclk : in  STD_LOGIC;
           SOFT_RESET : in  STD_LOGIC;
           UsrClk : in  STD_LOGIC;
           test : in  STD_LOGIC;
           AMC_en : in  STD_LOGIC_VECTOR(11 downto 0);
					 RXDATA : out array12X16;
           rxprbserr : out  STD_LOGIC_VECTOR(11 downto 0);
					 rxprbssel : in array12X3;
           RXNOTINTABLE : out  array12X2;
           rxcommaalignen : in  STD_LOGIC_VECTOR(11 downto 0);
					 rxchariscomma : out array12X2;
					 rxcharisk : out array12X2;
           rxresetdone : out  STD_LOGIC_VECTOR(11 downto 0);
					 txdiffctrl : in array12X4;
					 TXDATA : in array12X16;
           txoutclk : out  STD_LOGIC_VECTOR(11 downto 0);
					 txcharisk : in array12X2;
           txresetdone : out  STD_LOGIC_VECTOR(11 downto 0);
					 txprbssel : in array12X3;
           qpll_lock : out  STD_LOGIC_VECTOR(2 downto 0);
           txfsmresetdone : out  STD_LOGIC_VECTOR(11 downto 0);
           rxfsmresetdone : out  STD_LOGIC_VECTOR(11 downto 0);
           data_valid : in  STD_LOGIC_VECTOR(11 downto 0);
           AMC_REFCLK : in  STD_LOGIC;
           RXN : in  STD_LOGIC_VECTOR(11 downto 0);
           RXP : in  STD_LOGIC_VECTOR(11 downto 0);
           TXN : out  STD_LOGIC_VECTOR(11 downto 0);
           TXP : out  STD_LOGIC_VECTOR(11 downto 0)
					 );
end AMC_wrapper;
architecture Behavioral of AMC_wrapper is
component AMC_GTXv_init 
generic
(
    -- Simulation attributes
    EXAMPLE_SIM_GTRESET_SPEEDUP    : string    := "FALSE";    -- Set to 1 to speed up sim reset
    EXAMPLE_SIMULATION             : integer   := 0;          -- Set to 1 for simulation
    EXAMPLE_USE_CHIPSCOPE          : integer   := 0           -- Set to 1 to use Chipscope to drive resets

);
port
(
    SYSCLK_IN                               : in   std_logic;
    SOFT_RESET_IN                           : in   std_logic;
    GT0_TX_FSM_RESET_DONE_OUT               : out  std_logic;
    GT0_RX_FSM_RESET_DONE_OUT               : out  std_logic;
    GT0_DATA_VALID_IN                       : in   std_logic;
    GT1_TX_FSM_RESET_DONE_OUT               : out  std_logic;
    GT1_RX_FSM_RESET_DONE_OUT               : out  std_logic;
    GT1_DATA_VALID_IN                       : in   std_logic;
    GT2_TX_FSM_RESET_DONE_OUT               : out  std_logic;
    GT2_RX_FSM_RESET_DONE_OUT               : out  std_logic;
    GT2_DATA_VALID_IN                       : in   std_logic;
    GT3_TX_FSM_RESET_DONE_OUT               : out  std_logic;
    GT3_RX_FSM_RESET_DONE_OUT               : out  std_logic;
    GT3_DATA_VALID_IN                       : in   std_logic;
    GT4_TX_FSM_RESET_DONE_OUT               : out  std_logic;
    GT4_RX_FSM_RESET_DONE_OUT               : out  std_logic;
    GT4_DATA_VALID_IN                       : in   std_logic;
    GT5_TX_FSM_RESET_DONE_OUT               : out  std_logic;
    GT5_RX_FSM_RESET_DONE_OUT               : out  std_logic;
    GT5_DATA_VALID_IN                       : in   std_logic;
    GT6_TX_FSM_RESET_DONE_OUT               : out  std_logic;
    GT6_RX_FSM_RESET_DONE_OUT               : out  std_logic;
    GT6_DATA_VALID_IN                       : in   std_logic;
    GT7_TX_FSM_RESET_DONE_OUT               : out  std_logic;
    GT7_RX_FSM_RESET_DONE_OUT               : out  std_logic;
    GT7_DATA_VALID_IN                       : in   std_logic;
    GT8_TX_FSM_RESET_DONE_OUT               : out  std_logic;
    GT8_RX_FSM_RESET_DONE_OUT               : out  std_logic;
    GT8_DATA_VALID_IN                       : in   std_logic;
    GT9_TX_FSM_RESET_DONE_OUT               : out  std_logic;
    GT9_RX_FSM_RESET_DONE_OUT               : out  std_logic;
    GT9_DATA_VALID_IN                       : in   std_logic;
    GT10_TX_FSM_RESET_DONE_OUT              : out  std_logic;
    GT10_RX_FSM_RESET_DONE_OUT              : out  std_logic;
    GT10_DATA_VALID_IN                      : in   std_logic;
    GT11_TX_FSM_RESET_DONE_OUT              : out  std_logic;
    GT11_RX_FSM_RESET_DONE_OUT              : out  std_logic;
    GT11_DATA_VALID_IN                      : in   std_logic;

    --_________________________________________________________________________
    --GT0  (X1Y0)
    --____________________________CHANNEL PORTS________________________________
    ---------------------------- Channel - DRP Ports  --------------------------
    GT0_DRPADDR_IN                          : in   std_logic_vector(8 downto 0);
    GT0_DRPCLK_IN                           : in   std_logic;
    GT0_DRPDI_IN                            : in   std_logic_vector(15 downto 0);
    GT0_DRPDO_OUT                           : out  std_logic_vector(15 downto 0);
    GT0_DRPEN_IN                            : in   std_logic;
    GT0_DRPRDY_OUT                          : out  std_logic;
    GT0_DRPWE_IN                            : in   std_logic;
    ------------------------------- Loopback Ports -----------------------------
    GT0_LOOPBACK_IN                         : in   std_logic_vector(2 downto 0);
    --------------------- RX Initialization and Reset Ports --------------------
    GT0_RXUSERRDY_IN                        : in   std_logic;
    -------------------------- RX Margin Analysis Ports ------------------------
    GT0_EYESCANDATAERROR_OUT                : out  std_logic;
    ------------------------- Receive Ports - CDR Ports ------------------------
    GT0_RXCDRLOCK_OUT                       : out  std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    GT0_RXCLKCORCNT_OUT                     : out  std_logic_vector(1 downto 0);
    ------------------ Receive Ports - FPGA RX Interface Ports -----------------
    GT0_RXUSRCLK_IN                         : in   std_logic;
    GT0_RXUSRCLK2_IN                        : in   std_logic;
    ------------------ Receive Ports - FPGA RX interface Ports -----------------
    GT0_RXDATA_OUT                          : out  std_logic_vector(15 downto 0);
    ------------------- Receive Ports - Pattern Checker Ports ------------------
    GT0_RXPRBSERR_OUT                       : out  std_logic;
    GT0_RXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
    ------------------- Receive Ports - Pattern Checker ports ------------------
    GT0_RXPRBSCNTRESET_IN                   : in   std_logic;
    ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
    GT0_RXDISPERR_OUT                       : out  std_logic_vector(1 downto 0);
    GT0_RXNOTINTABLE_OUT                    : out  std_logic_vector(1 downto 0);
    --------------------------- Receive Ports - RX AFE -------------------------
    GT0_GTXRXP_IN                           : in   std_logic;
    ------------------------ Receive Ports - RX AFE Ports ----------------------
    GT0_GTXRXN_IN                           : in   std_logic;
    -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
    GT0_RXMCOMMAALIGNEN_IN                  : in   std_logic;
    GT0_RXPCOMMAALIGNEN_IN                  : in   std_logic;
    --------------------- Receive Ports - RX Equalizer Ports -------------------
    GT0_RXDFELPMRESET_IN                    : in   std_logic;
    GT0_RXMONITOROUT_OUT                    : out  std_logic_vector(6 downto 0);
    GT0_RXMONITORSEL_IN                     : in   std_logic_vector(1 downto 0);
    ------------- Receive Ports - RX Initialization and Reset Ports ------------
    GT0_GTRXRESET_IN                        : in   std_logic;
    GT0_RXPMARESET_IN                       : in   std_logic;
    ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
    GT0_RXCHARISCOMMA_OUT                   : out  std_logic_vector(1 downto 0);
    GT0_RXCHARISK_OUT                       : out  std_logic_vector(1 downto 0);
    -------------- Receive Ports -RX Initialization and Reset Ports ------------
    GT0_RXRESETDONE_OUT                     : out  std_logic;
    --------------------- TX Initialization and Reset Ports --------------------
    GT0_GTTXRESET_IN                        : in   std_logic;
    GT0_TXUSERRDY_IN                        : in   std_logic;
    ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
    GT0_TXUSRCLK_IN                         : in   std_logic;
    GT0_TXUSRCLK2_IN                        : in   std_logic;
    --------------- Transmit Ports - TX Configurable Driver Ports --------------
    GT0_TXDIFFCTRL_IN                       : in   std_logic_vector(3 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    GT0_TXDATA_IN                           : in   std_logic_vector(15 downto 0);
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    GT0_GTXTXN_OUT                          : out  std_logic;
    GT0_GTXTXP_OUT                          : out  std_logic;
    ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
    GT0_TXOUTCLK_OUT                        : out  std_logic;
    GT0_TXOUTCLKFABRIC_OUT                  : out  std_logic;
    GT0_TXOUTCLKPCS_OUT                     : out  std_logic;
    --------------------- Transmit Ports - TX Gearbox Ports --------------------
    GT0_TXCHARISK_IN                        : in   std_logic_vector(1 downto 0);
    ------------- Transmit Ports - TX Initialization and Reset Ports -----------
    GT0_TXRESETDONE_OUT                     : out  std_logic;
    ------------------ Transmit Ports - pattern Generator Ports ----------------
    GT0_TXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);

    --GT1  (X1Y1)
    --____________________________CHANNEL PORTS________________________________
    ---------------------------- Channel - DRP Ports  --------------------------
    GT1_DRPADDR_IN                          : in   std_logic_vector(8 downto 0);
    GT1_DRPCLK_IN                           : in   std_logic;
    GT1_DRPDI_IN                            : in   std_logic_vector(15 downto 0);
    GT1_DRPDO_OUT                           : out  std_logic_vector(15 downto 0);
    GT1_DRPEN_IN                            : in   std_logic;
    GT1_DRPRDY_OUT                          : out  std_logic;
    GT1_DRPWE_IN                            : in   std_logic;
    ------------------------------- Loopback Ports -----------------------------
    GT1_LOOPBACK_IN                         : in   std_logic_vector(2 downto 0);
    --------------------- RX Initialization and Reset Ports --------------------
    GT1_RXUSERRDY_IN                        : in   std_logic;
    -------------------------- RX Margin Analysis Ports ------------------------
    GT1_EYESCANDATAERROR_OUT                : out  std_logic;
    ------------------------- Receive Ports - CDR Ports ------------------------
    GT1_RXCDRLOCK_OUT                       : out  std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    GT1_RXCLKCORCNT_OUT                     : out  std_logic_vector(1 downto 0);
    ------------------ Receive Ports - FPGA RX Interface Ports -----------------
    GT1_RXUSRCLK_IN                         : in   std_logic;
    GT1_RXUSRCLK2_IN                        : in   std_logic;
    ------------------ Receive Ports - FPGA RX interface Ports -----------------
    GT1_RXDATA_OUT                          : out  std_logic_vector(15 downto 0);
    ------------------- Receive Ports - Pattern Checker Ports ------------------
    GT1_RXPRBSERR_OUT                       : out  std_logic;
    GT1_RXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
    ------------------- Receive Ports - Pattern Checker ports ------------------
    GT1_RXPRBSCNTRESET_IN                   : in   std_logic;
    ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
    GT1_RXDISPERR_OUT                       : out  std_logic_vector(1 downto 0);
    GT1_RXNOTINTABLE_OUT                    : out  std_logic_vector(1 downto 0);
    --------------------------- Receive Ports - RX AFE -------------------------
    GT1_GTXRXP_IN                           : in   std_logic;
    ------------------------ Receive Ports - RX AFE Ports ----------------------
    GT1_GTXRXN_IN                           : in   std_logic;
    -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
    GT1_RXMCOMMAALIGNEN_IN                  : in   std_logic;
    GT1_RXPCOMMAALIGNEN_IN                  : in   std_logic;
    --------------------- Receive Ports - RX Equalizer Ports -------------------
    GT1_RXDFELPMRESET_IN                    : in   std_logic;
    GT1_RXMONITOROUT_OUT                    : out  std_logic_vector(6 downto 0);
    GT1_RXMONITORSEL_IN                     : in   std_logic_vector(1 downto 0);
    ------------- Receive Ports - RX Initialization and Reset Ports ------------
    GT1_GTRXRESET_IN                        : in   std_logic;
    GT1_RXPMARESET_IN                       : in   std_logic;
    ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
    GT1_RXCHARISCOMMA_OUT                   : out  std_logic_vector(1 downto 0);
    GT1_RXCHARISK_OUT                       : out  std_logic_vector(1 downto 0);
    -------------- Receive Ports -RX Initialization and Reset Ports ------------
    GT1_RXRESETDONE_OUT                     : out  std_logic;
    --------------------- TX Initialization and Reset Ports --------------------
    GT1_GTTXRESET_IN                        : in   std_logic;
    GT1_TXUSERRDY_IN                        : in   std_logic;
    ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
    GT1_TXUSRCLK_IN                         : in   std_logic;
    GT1_TXUSRCLK2_IN                        : in   std_logic;
    --------------- Transmit Ports - TX Configurable Driver Ports --------------
    GT1_TXDIFFCTRL_IN                       : in   std_logic_vector(3 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    GT1_TXDATA_IN                           : in   std_logic_vector(15 downto 0);
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    GT1_GTXTXN_OUT                          : out  std_logic;
    GT1_GTXTXP_OUT                          : out  std_logic;
    ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
    GT1_TXOUTCLK_OUT                        : out  std_logic;
    GT1_TXOUTCLKFABRIC_OUT                  : out  std_logic;
    GT1_TXOUTCLKPCS_OUT                     : out  std_logic;
    --------------------- Transmit Ports - TX Gearbox Ports --------------------
    GT1_TXCHARISK_IN                        : in   std_logic_vector(1 downto 0);
    ------------- Transmit Ports - TX Initialization and Reset Ports -----------
    GT1_TXRESETDONE_OUT                     : out  std_logic;
    ------------------ Transmit Ports - pattern Generator Ports ----------------
    GT1_TXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);

    --GT2  (X1Y2)
    --____________________________CHANNEL PORTS________________________________
    ---------------------------- Channel - DRP Ports  --------------------------
    GT2_DRPADDR_IN                          : in   std_logic_vector(8 downto 0);
    GT2_DRPCLK_IN                           : in   std_logic;
    GT2_DRPDI_IN                            : in   std_logic_vector(15 downto 0);
    GT2_DRPDO_OUT                           : out  std_logic_vector(15 downto 0);
    GT2_DRPEN_IN                            : in   std_logic;
    GT2_DRPRDY_OUT                          : out  std_logic;
    GT2_DRPWE_IN                            : in   std_logic;
    ------------------------------- Loopback Ports -----------------------------
    GT2_LOOPBACK_IN                         : in   std_logic_vector(2 downto 0);
    --------------------- RX Initialization and Reset Ports --------------------
    GT2_RXUSERRDY_IN                        : in   std_logic;
    -------------------------- RX Margin Analysis Ports ------------------------
    GT2_EYESCANDATAERROR_OUT                : out  std_logic;
    ------------------------- Receive Ports - CDR Ports ------------------------
    GT2_RXCDRLOCK_OUT                       : out  std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    GT2_RXCLKCORCNT_OUT                     : out  std_logic_vector(1 downto 0);
    ------------------ Receive Ports - FPGA RX Interface Ports -----------------
    GT2_RXUSRCLK_IN                         : in   std_logic;
    GT2_RXUSRCLK2_IN                        : in   std_logic;
    ------------------ Receive Ports - FPGA RX interface Ports -----------------
    GT2_RXDATA_OUT                          : out  std_logic_vector(15 downto 0);
    ------------------- Receive Ports - Pattern Checker Ports ------------------
    GT2_RXPRBSERR_OUT                       : out  std_logic;
    GT2_RXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
    ------------------- Receive Ports - Pattern Checker ports ------------------
    GT2_RXPRBSCNTRESET_IN                   : in   std_logic;
    ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
    GT2_RXDISPERR_OUT                       : out  std_logic_vector(1 downto 0);
    GT2_RXNOTINTABLE_OUT                    : out  std_logic_vector(1 downto 0);
    --------------------------- Receive Ports - RX AFE -------------------------
    GT2_GTXRXP_IN                           : in   std_logic;
    ------------------------ Receive Ports - RX AFE Ports ----------------------
    GT2_GTXRXN_IN                           : in   std_logic;
    -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
    GT2_RXMCOMMAALIGNEN_IN                  : in   std_logic;
    GT2_RXPCOMMAALIGNEN_IN                  : in   std_logic;
    --------------------- Receive Ports - RX Equalizer Ports -------------------
    GT2_RXDFELPMRESET_IN                    : in   std_logic;
    GT2_RXMONITOROUT_OUT                    : out  std_logic_vector(6 downto 0);
    GT2_RXMONITORSEL_IN                     : in   std_logic_vector(1 downto 0);
    ------------- Receive Ports - RX Initialization and Reset Ports ------------
    GT2_GTRXRESET_IN                        : in   std_logic;
    GT2_RXPMARESET_IN                       : in   std_logic;
    ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
    GT2_RXCHARISCOMMA_OUT                   : out  std_logic_vector(1 downto 0);
    GT2_RXCHARISK_OUT                       : out  std_logic_vector(1 downto 0);
    -------------- Receive Ports -RX Initialization and Reset Ports ------------
    GT2_RXRESETDONE_OUT                     : out  std_logic;
    --------------------- TX Initialization and Reset Ports --------------------
    GT2_GTTXRESET_IN                        : in   std_logic;
    GT2_TXUSERRDY_IN                        : in   std_logic;
    ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
    GT2_TXUSRCLK_IN                         : in   std_logic;
    GT2_TXUSRCLK2_IN                        : in   std_logic;
    --------------- Transmit Ports - TX Configurable Driver Ports --------------
    GT2_TXDIFFCTRL_IN                       : in   std_logic_vector(3 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    GT2_TXDATA_IN                           : in   std_logic_vector(15 downto 0);
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    GT2_GTXTXN_OUT                          : out  std_logic;
    GT2_GTXTXP_OUT                          : out  std_logic;
    ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
    GT2_TXOUTCLK_OUT                        : out  std_logic;
    GT2_TXOUTCLKFABRIC_OUT                  : out  std_logic;
    GT2_TXOUTCLKPCS_OUT                     : out  std_logic;
    --------------------- Transmit Ports - TX Gearbox Ports --------------------
    GT2_TXCHARISK_IN                        : in   std_logic_vector(1 downto 0);
    ------------- Transmit Ports - TX Initialization and Reset Ports -----------
    GT2_TXRESETDONE_OUT                     : out  std_logic;
    ------------------ Transmit Ports - pattern Generator Ports ----------------
    GT2_TXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);

    --GT3  (X1Y3)
    --____________________________CHANNEL PORTS________________________________
    ---------------------------- Channel - DRP Ports  --------------------------
    GT3_DRPADDR_IN                          : in   std_logic_vector(8 downto 0);
    GT3_DRPCLK_IN                           : in   std_logic;
    GT3_DRPDI_IN                            : in   std_logic_vector(15 downto 0);
    GT3_DRPDO_OUT                           : out  std_logic_vector(15 downto 0);
    GT3_DRPEN_IN                            : in   std_logic;
    GT3_DRPRDY_OUT                          : out  std_logic;
    GT3_DRPWE_IN                            : in   std_logic;
    ------------------------------- Loopback Ports -----------------------------
    GT3_LOOPBACK_IN                         : in   std_logic_vector(2 downto 0);
    --------------------- RX Initialization and Reset Ports --------------------
    GT3_RXUSERRDY_IN                        : in   std_logic;
    -------------------------- RX Margin Analysis Ports ------------------------
    GT3_EYESCANDATAERROR_OUT                : out  std_logic;
    ------------------------- Receive Ports - CDR Ports ------------------------
    GT3_RXCDRLOCK_OUT                       : out  std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    GT3_RXCLKCORCNT_OUT                     : out  std_logic_vector(1 downto 0);
    ------------------ Receive Ports - FPGA RX Interface Ports -----------------
    GT3_RXUSRCLK_IN                         : in   std_logic;
    GT3_RXUSRCLK2_IN                        : in   std_logic;
    ------------------ Receive Ports - FPGA RX interface Ports -----------------
    GT3_RXDATA_OUT                          : out  std_logic_vector(15 downto 0);
    ------------------- Receive Ports - Pattern Checker Ports ------------------
    GT3_RXPRBSERR_OUT                       : out  std_logic;
    GT3_RXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
    ------------------- Receive Ports - Pattern Checker ports ------------------
    GT3_RXPRBSCNTRESET_IN                   : in   std_logic;
    ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
    GT3_RXDISPERR_OUT                       : out  std_logic_vector(1 downto 0);
    GT3_RXNOTINTABLE_OUT                    : out  std_logic_vector(1 downto 0);
    --------------------------- Receive Ports - RX AFE -------------------------
    GT3_GTXRXP_IN                           : in   std_logic;
    ------------------------ Receive Ports - RX AFE Ports ----------------------
    GT3_GTXRXN_IN                           : in   std_logic;
    -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
    GT3_RXMCOMMAALIGNEN_IN                  : in   std_logic;
    GT3_RXPCOMMAALIGNEN_IN                  : in   std_logic;
    --------------------- Receive Ports - RX Equalizer Ports -------------------
    GT3_RXDFELPMRESET_IN                    : in   std_logic;
    GT3_RXMONITOROUT_OUT                    : out  std_logic_vector(6 downto 0);
    GT3_RXMONITORSEL_IN                     : in   std_logic_vector(1 downto 0);
    ------------- Receive Ports - RX Initialization and Reset Ports ------------
    GT3_GTRXRESET_IN                        : in   std_logic;
    GT3_RXPMARESET_IN                       : in   std_logic;
    ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
    GT3_RXCHARISCOMMA_OUT                   : out  std_logic_vector(1 downto 0);
    GT3_RXCHARISK_OUT                       : out  std_logic_vector(1 downto 0);
    -------------- Receive Ports -RX Initialization and Reset Ports ------------
    GT3_RXRESETDONE_OUT                     : out  std_logic;
    --------------------- TX Initialization and Reset Ports --------------------
    GT3_GTTXRESET_IN                        : in   std_logic;
    GT3_TXUSERRDY_IN                        : in   std_logic;
    ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
    GT3_TXUSRCLK_IN                         : in   std_logic;
    GT3_TXUSRCLK2_IN                        : in   std_logic;
    --------------- Transmit Ports - TX Configurable Driver Ports --------------
    GT3_TXDIFFCTRL_IN                       : in   std_logic_vector(3 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    GT3_TXDATA_IN                           : in   std_logic_vector(15 downto 0);
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    GT3_GTXTXN_OUT                          : out  std_logic;
    GT3_GTXTXP_OUT                          : out  std_logic;
    ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
    GT3_TXOUTCLK_OUT                        : out  std_logic;
    GT3_TXOUTCLKFABRIC_OUT                  : out  std_logic;
    GT3_TXOUTCLKPCS_OUT                     : out  std_logic;
    --------------------- Transmit Ports - TX Gearbox Ports --------------------
    GT3_TXCHARISK_IN                        : in   std_logic_vector(1 downto 0);
    ------------- Transmit Ports - TX Initialization and Reset Ports -----------
    GT3_TXRESETDONE_OUT                     : out  std_logic;
    ------------------ Transmit Ports - pattern Generator Ports ----------------
    GT3_TXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);

    --GT4  (X1Y4)
    --____________________________CHANNEL PORTS________________________________
    ---------------------------- Channel - DRP Ports  --------------------------
    GT4_DRPADDR_IN                          : in   std_logic_vector(8 downto 0);
    GT4_DRPCLK_IN                           : in   std_logic;
    GT4_DRPDI_IN                            : in   std_logic_vector(15 downto 0);
    GT4_DRPDO_OUT                           : out  std_logic_vector(15 downto 0);
    GT4_DRPEN_IN                            : in   std_logic;
    GT4_DRPRDY_OUT                          : out  std_logic;
    GT4_DRPWE_IN                            : in   std_logic;
    ------------------------------- Loopback Ports -----------------------------
    GT4_LOOPBACK_IN                         : in   std_logic_vector(2 downto 0);
    --------------------- RX Initialization and Reset Ports --------------------
    GT4_RXUSERRDY_IN                        : in   std_logic;
    -------------------------- RX Margin Analysis Ports ------------------------
    GT4_EYESCANDATAERROR_OUT                : out  std_logic;
    ------------------------- Receive Ports - CDR Ports ------------------------
    GT4_RXCDRLOCK_OUT                       : out  std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    GT4_RXCLKCORCNT_OUT                     : out  std_logic_vector(1 downto 0);
    ------------------ Receive Ports - FPGA RX Interface Ports -----------------
    GT4_RXUSRCLK_IN                         : in   std_logic;
    GT4_RXUSRCLK2_IN                        : in   std_logic;
    ------------------ Receive Ports - FPGA RX interface Ports -----------------
    GT4_RXDATA_OUT                          : out  std_logic_vector(15 downto 0);
    ------------------- Receive Ports - Pattern Checker Ports ------------------
    GT4_RXPRBSERR_OUT                       : out  std_logic;
    GT4_RXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
    ------------------- Receive Ports - Pattern Checker ports ------------------
    GT4_RXPRBSCNTRESET_IN                   : in   std_logic;
    ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
    GT4_RXDISPERR_OUT                       : out  std_logic_vector(1 downto 0);
    GT4_RXNOTINTABLE_OUT                    : out  std_logic_vector(1 downto 0);
    --------------------------- Receive Ports - RX AFE -------------------------
    GT4_GTXRXP_IN                           : in   std_logic;
    ------------------------ Receive Ports - RX AFE Ports ----------------------
    GT4_GTXRXN_IN                           : in   std_logic;
    -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
    GT4_RXMCOMMAALIGNEN_IN                  : in   std_logic;
    GT4_RXPCOMMAALIGNEN_IN                  : in   std_logic;
    --------------------- Receive Ports - RX Equalizer Ports -------------------
    GT4_RXDFELPMRESET_IN                    : in   std_logic;
    GT4_RXMONITOROUT_OUT                    : out  std_logic_vector(6 downto 0);
    GT4_RXMONITORSEL_IN                     : in   std_logic_vector(1 downto 0);
    ------------- Receive Ports - RX Initialization and Reset Ports ------------
    GT4_GTRXRESET_IN                        : in   std_logic;
    GT4_RXPMARESET_IN                       : in   std_logic;
    ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
    GT4_RXCHARISCOMMA_OUT                   : out  std_logic_vector(1 downto 0);
    GT4_RXCHARISK_OUT                       : out  std_logic_vector(1 downto 0);
    -------------- Receive Ports -RX Initialization and Reset Ports ------------
    GT4_RXRESETDONE_OUT                     : out  std_logic;
    --------------------- TX Initialization and Reset Ports --------------------
    GT4_GTTXRESET_IN                        : in   std_logic;
    GT4_TXUSERRDY_IN                        : in   std_logic;
    ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
    GT4_TXUSRCLK_IN                         : in   std_logic;
    GT4_TXUSRCLK2_IN                        : in   std_logic;
    --------------- Transmit Ports - TX Configurable Driver Ports --------------
    GT4_TXDIFFCTRL_IN                       : in   std_logic_vector(3 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    GT4_TXDATA_IN                           : in   std_logic_vector(15 downto 0);
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    GT4_GTXTXN_OUT                          : out  std_logic;
    GT4_GTXTXP_OUT                          : out  std_logic;
    ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
    GT4_TXOUTCLK_OUT                        : out  std_logic;
    GT4_TXOUTCLKFABRIC_OUT                  : out  std_logic;
    GT4_TXOUTCLKPCS_OUT                     : out  std_logic;
    --------------------- Transmit Ports - TX Gearbox Ports --------------------
    GT4_TXCHARISK_IN                        : in   std_logic_vector(1 downto 0);
    ------------- Transmit Ports - TX Initialization and Reset Ports -----------
    GT4_TXRESETDONE_OUT                     : out  std_logic;
    ------------------ Transmit Ports - pattern Generator Ports ----------------
    GT4_TXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);

    --GT5  (X1Y5)
    --____________________________CHANNEL PORTS________________________________
    ---------------------------- Channel - DRP Ports  --------------------------
    GT5_DRPADDR_IN                          : in   std_logic_vector(8 downto 0);
    GT5_DRPCLK_IN                           : in   std_logic;
    GT5_DRPDI_IN                            : in   std_logic_vector(15 downto 0);
    GT5_DRPDO_OUT                           : out  std_logic_vector(15 downto 0);
    GT5_DRPEN_IN                            : in   std_logic;
    GT5_DRPRDY_OUT                          : out  std_logic;
    GT5_DRPWE_IN                            : in   std_logic;
    ------------------------------- Loopback Ports -----------------------------
    GT5_LOOPBACK_IN                         : in   std_logic_vector(2 downto 0);
    --------------------- RX Initialization and Reset Ports --------------------
    GT5_RXUSERRDY_IN                        : in   std_logic;
    -------------------------- RX Margin Analysis Ports ------------------------
    GT5_EYESCANDATAERROR_OUT                : out  std_logic;
    ------------------------- Receive Ports - CDR Ports ------------------------
    GT5_RXCDRLOCK_OUT                       : out  std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    GT5_RXCLKCORCNT_OUT                     : out  std_logic_vector(1 downto 0);
    ------------------ Receive Ports - FPGA RX Interface Ports -----------------
    GT5_RXUSRCLK_IN                         : in   std_logic;
    GT5_RXUSRCLK2_IN                        : in   std_logic;
    ------------------ Receive Ports - FPGA RX interface Ports -----------------
    GT5_RXDATA_OUT                          : out  std_logic_vector(15 downto 0);
    ------------------- Receive Ports - Pattern Checker Ports ------------------
    GT5_RXPRBSERR_OUT                       : out  std_logic;
    GT5_RXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
    ------------------- Receive Ports - Pattern Checker ports ------------------
    GT5_RXPRBSCNTRESET_IN                   : in   std_logic;
    ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
    GT5_RXDISPERR_OUT                       : out  std_logic_vector(1 downto 0);
    GT5_RXNOTINTABLE_OUT                    : out  std_logic_vector(1 downto 0);
    --------------------------- Receive Ports - RX AFE -------------------------
    GT5_GTXRXP_IN                           : in   std_logic;
    ------------------------ Receive Ports - RX AFE Ports ----------------------
    GT5_GTXRXN_IN                           : in   std_logic;
    -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
    GT5_RXMCOMMAALIGNEN_IN                  : in   std_logic;
    GT5_RXPCOMMAALIGNEN_IN                  : in   std_logic;
    --------------------- Receive Ports - RX Equalizer Ports -------------------
    GT5_RXDFELPMRESET_IN                    : in   std_logic;
    GT5_RXMONITOROUT_OUT                    : out  std_logic_vector(6 downto 0);
    GT5_RXMONITORSEL_IN                     : in   std_logic_vector(1 downto 0);
    ------------- Receive Ports - RX Initialization and Reset Ports ------------
    GT5_GTRXRESET_IN                        : in   std_logic;
    GT5_RXPMARESET_IN                       : in   std_logic;
    ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
    GT5_RXCHARISCOMMA_OUT                   : out  std_logic_vector(1 downto 0);
    GT5_RXCHARISK_OUT                       : out  std_logic_vector(1 downto 0);
    -------------- Receive Ports -RX Initialization and Reset Ports ------------
    GT5_RXRESETDONE_OUT                     : out  std_logic;
    --------------------- TX Initialization and Reset Ports --------------------
    GT5_GTTXRESET_IN                        : in   std_logic;
    GT5_TXUSERRDY_IN                        : in   std_logic;
    ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
    GT5_TXUSRCLK_IN                         : in   std_logic;
    GT5_TXUSRCLK2_IN                        : in   std_logic;
    --------------- Transmit Ports - TX Configurable Driver Ports --------------
    GT5_TXDIFFCTRL_IN                       : in   std_logic_vector(3 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    GT5_TXDATA_IN                           : in   std_logic_vector(15 downto 0);
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    GT5_GTXTXN_OUT                          : out  std_logic;
    GT5_GTXTXP_OUT                          : out  std_logic;
    ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
    GT5_TXOUTCLK_OUT                        : out  std_logic;
    GT5_TXOUTCLKFABRIC_OUT                  : out  std_logic;
    GT5_TXOUTCLKPCS_OUT                     : out  std_logic;
    --------------------- Transmit Ports - TX Gearbox Ports --------------------
    GT5_TXCHARISK_IN                        : in   std_logic_vector(1 downto 0);
    ------------- Transmit Ports - TX Initialization and Reset Ports -----------
    GT5_TXRESETDONE_OUT                     : out  std_logic;
    ------------------ Transmit Ports - pattern Generator Ports ----------------
    GT5_TXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);

    --GT6  (X1Y6)
    --____________________________CHANNEL PORTS________________________________
    ---------------------------- Channel - DRP Ports  --------------------------
    GT6_DRPADDR_IN                          : in   std_logic_vector(8 downto 0);
    GT6_DRPCLK_IN                           : in   std_logic;
    GT6_DRPDI_IN                            : in   std_logic_vector(15 downto 0);
    GT6_DRPDO_OUT                           : out  std_logic_vector(15 downto 0);
    GT6_DRPEN_IN                            : in   std_logic;
    GT6_DRPRDY_OUT                          : out  std_logic;
    GT6_DRPWE_IN                            : in   std_logic;
    ------------------------------- Loopback Ports -----------------------------
    GT6_LOOPBACK_IN                         : in   std_logic_vector(2 downto 0);
    --------------------- RX Initialization and Reset Ports --------------------
    GT6_RXUSERRDY_IN                        : in   std_logic;
    -------------------------- RX Margin Analysis Ports ------------------------
    GT6_EYESCANDATAERROR_OUT                : out  std_logic;
    ------------------------- Receive Ports - CDR Ports ------------------------
    GT6_RXCDRLOCK_OUT                       : out  std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    GT6_RXCLKCORCNT_OUT                     : out  std_logic_vector(1 downto 0);
    ------------------ Receive Ports - FPGA RX Interface Ports -----------------
    GT6_RXUSRCLK_IN                         : in   std_logic;
    GT6_RXUSRCLK2_IN                        : in   std_logic;
    ------------------ Receive Ports - FPGA RX interface Ports -----------------
    GT6_RXDATA_OUT                          : out  std_logic_vector(15 downto 0);
    ------------------- Receive Ports - Pattern Checker Ports ------------------
    GT6_RXPRBSERR_OUT                       : out  std_logic;
    GT6_RXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
    ------------------- Receive Ports - Pattern Checker ports ------------------
    GT6_RXPRBSCNTRESET_IN                   : in   std_logic;
    ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
    GT6_RXDISPERR_OUT                       : out  std_logic_vector(1 downto 0);
    GT6_RXNOTINTABLE_OUT                    : out  std_logic_vector(1 downto 0);
    --------------------------- Receive Ports - RX AFE -------------------------
    GT6_GTXRXP_IN                           : in   std_logic;
    ------------------------ Receive Ports - RX AFE Ports ----------------------
    GT6_GTXRXN_IN                           : in   std_logic;
    -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
    GT6_RXMCOMMAALIGNEN_IN                  : in   std_logic;
    GT6_RXPCOMMAALIGNEN_IN                  : in   std_logic;
    --------------------- Receive Ports - RX Equalizer Ports -------------------
    GT6_RXDFELPMRESET_IN                    : in   std_logic;
    GT6_RXMONITOROUT_OUT                    : out  std_logic_vector(6 downto 0);
    GT6_RXMONITORSEL_IN                     : in   std_logic_vector(1 downto 0);
    ------------- Receive Ports - RX Initialization and Reset Ports ------------
    GT6_GTRXRESET_IN                        : in   std_logic;
    GT6_RXPMARESET_IN                       : in   std_logic;
    ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
    GT6_RXCHARISCOMMA_OUT                   : out  std_logic_vector(1 downto 0);
    GT6_RXCHARISK_OUT                       : out  std_logic_vector(1 downto 0);
    -------------- Receive Ports -RX Initialization and Reset Ports ------------
    GT6_RXRESETDONE_OUT                     : out  std_logic;
    --------------------- TX Initialization and Reset Ports --------------------
    GT6_GTTXRESET_IN                        : in   std_logic;
    GT6_TXUSERRDY_IN                        : in   std_logic;
    ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
    GT6_TXUSRCLK_IN                         : in   std_logic;
    GT6_TXUSRCLK2_IN                        : in   std_logic;
    --------------- Transmit Ports - TX Configurable Driver Ports --------------
    GT6_TXDIFFCTRL_IN                       : in   std_logic_vector(3 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    GT6_TXDATA_IN                           : in   std_logic_vector(15 downto 0);
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    GT6_GTXTXN_OUT                          : out  std_logic;
    GT6_GTXTXP_OUT                          : out  std_logic;
    ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
    GT6_TXOUTCLK_OUT                        : out  std_logic;
    GT6_TXOUTCLKFABRIC_OUT                  : out  std_logic;
    GT6_TXOUTCLKPCS_OUT                     : out  std_logic;
    --------------------- Transmit Ports - TX Gearbox Ports --------------------
    GT6_TXCHARISK_IN                        : in   std_logic_vector(1 downto 0);
    ------------- Transmit Ports - TX Initialization and Reset Ports -----------
    GT6_TXRESETDONE_OUT                     : out  std_logic;
    ------------------ Transmit Ports - pattern Generator Ports ----------------
    GT6_TXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);

    --GT7  (X1Y7)
    --____________________________CHANNEL PORTS________________________________
    ---------------------------- Channel - DRP Ports  --------------------------
    GT7_DRPADDR_IN                          : in   std_logic_vector(8 downto 0);
    GT7_DRPCLK_IN                           : in   std_logic;
    GT7_DRPDI_IN                            : in   std_logic_vector(15 downto 0);
    GT7_DRPDO_OUT                           : out  std_logic_vector(15 downto 0);
    GT7_DRPEN_IN                            : in   std_logic;
    GT7_DRPRDY_OUT                          : out  std_logic;
    GT7_DRPWE_IN                            : in   std_logic;
    ------------------------------- Loopback Ports -----------------------------
    GT7_LOOPBACK_IN                         : in   std_logic_vector(2 downto 0);
    --------------------- RX Initialization and Reset Ports --------------------
    GT7_RXUSERRDY_IN                        : in   std_logic;
    -------------------------- RX Margin Analysis Ports ------------------------
    GT7_EYESCANDATAERROR_OUT                : out  std_logic;
    ------------------------- Receive Ports - CDR Ports ------------------------
    GT7_RXCDRLOCK_OUT                       : out  std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    GT7_RXCLKCORCNT_OUT                     : out  std_logic_vector(1 downto 0);
    ------------------ Receive Ports - FPGA RX Interface Ports -----------------
    GT7_RXUSRCLK_IN                         : in   std_logic;
    GT7_RXUSRCLK2_IN                        : in   std_logic;
    ------------------ Receive Ports - FPGA RX interface Ports -----------------
    GT7_RXDATA_OUT                          : out  std_logic_vector(15 downto 0);
    ------------------- Receive Ports - Pattern Checker Ports ------------------
    GT7_RXPRBSERR_OUT                       : out  std_logic;
    GT7_RXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
    ------------------- Receive Ports - Pattern Checker ports ------------------
    GT7_RXPRBSCNTRESET_IN                   : in   std_logic;
    ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
    GT7_RXDISPERR_OUT                       : out  std_logic_vector(1 downto 0);
    GT7_RXNOTINTABLE_OUT                    : out  std_logic_vector(1 downto 0);
    --------------------------- Receive Ports - RX AFE -------------------------
    GT7_GTXRXP_IN                           : in   std_logic;
    ------------------------ Receive Ports - RX AFE Ports ----------------------
    GT7_GTXRXN_IN                           : in   std_logic;
    -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
    GT7_RXMCOMMAALIGNEN_IN                  : in   std_logic;
    GT7_RXPCOMMAALIGNEN_IN                  : in   std_logic;
    --------------------- Receive Ports - RX Equalizer Ports -------------------
    GT7_RXDFELPMRESET_IN                    : in   std_logic;
    GT7_RXMONITOROUT_OUT                    : out  std_logic_vector(6 downto 0);
    GT7_RXMONITORSEL_IN                     : in   std_logic_vector(1 downto 0);
    ------------- Receive Ports - RX Initialization and Reset Ports ------------
    GT7_GTRXRESET_IN                        : in   std_logic;
    GT7_RXPMARESET_IN                       : in   std_logic;
    ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
    GT7_RXCHARISCOMMA_OUT                   : out  std_logic_vector(1 downto 0);
    GT7_RXCHARISK_OUT                       : out  std_logic_vector(1 downto 0);
    -------------- Receive Ports -RX Initialization and Reset Ports ------------
    GT7_RXRESETDONE_OUT                     : out  std_logic;
    --------------------- TX Initialization and Reset Ports --------------------
    GT7_GTTXRESET_IN                        : in   std_logic;
    GT7_TXUSERRDY_IN                        : in   std_logic;
    ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
    GT7_TXUSRCLK_IN                         : in   std_logic;
    GT7_TXUSRCLK2_IN                        : in   std_logic;
    --------------- Transmit Ports - TX Configurable Driver Ports --------------
    GT7_TXDIFFCTRL_IN                       : in   std_logic_vector(3 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    GT7_TXDATA_IN                           : in   std_logic_vector(15 downto 0);
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    GT7_GTXTXN_OUT                          : out  std_logic;
    GT7_GTXTXP_OUT                          : out  std_logic;
    ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
    GT7_TXOUTCLK_OUT                        : out  std_logic;
    GT7_TXOUTCLKFABRIC_OUT                  : out  std_logic;
    GT7_TXOUTCLKPCS_OUT                     : out  std_logic;
    --------------------- Transmit Ports - TX Gearbox Ports --------------------
    GT7_TXCHARISK_IN                        : in   std_logic_vector(1 downto 0);
    ------------- Transmit Ports - TX Initialization and Reset Ports -----------
    GT7_TXRESETDONE_OUT                     : out  std_logic;
    ------------------ Transmit Ports - pattern Generator Ports ----------------
    GT7_TXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);

    --GT8  (X1Y8)
    --____________________________CHANNEL PORTS________________________________
    ---------------------------- Channel - DRP Ports  --------------------------
    GT8_DRPADDR_IN                          : in   std_logic_vector(8 downto 0);
    GT8_DRPCLK_IN                           : in   std_logic;
    GT8_DRPDI_IN                            : in   std_logic_vector(15 downto 0);
    GT8_DRPDO_OUT                           : out  std_logic_vector(15 downto 0);
    GT8_DRPEN_IN                            : in   std_logic;
    GT8_DRPRDY_OUT                          : out  std_logic;
    GT8_DRPWE_IN                            : in   std_logic;
    ------------------------------- Loopback Ports -----------------------------
    GT8_LOOPBACK_IN                         : in   std_logic_vector(2 downto 0);
    --------------------- RX Initialization and Reset Ports --------------------
    GT8_RXUSERRDY_IN                        : in   std_logic;
    -------------------------- RX Margin Analysis Ports ------------------------
    GT8_EYESCANDATAERROR_OUT                : out  std_logic;
    ------------------------- Receive Ports - CDR Ports ------------------------
    GT8_RXCDRLOCK_OUT                       : out  std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    GT8_RXCLKCORCNT_OUT                     : out  std_logic_vector(1 downto 0);
    ------------------ Receive Ports - FPGA RX Interface Ports -----------------
    GT8_RXUSRCLK_IN                         : in   std_logic;
    GT8_RXUSRCLK2_IN                        : in   std_logic;
    ------------------ Receive Ports - FPGA RX interface Ports -----------------
    GT8_RXDATA_OUT                          : out  std_logic_vector(15 downto 0);
    ------------------- Receive Ports - Pattern Checker Ports ------------------
    GT8_RXPRBSERR_OUT                       : out  std_logic;
    GT8_RXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
    ------------------- Receive Ports - Pattern Checker ports ------------------
    GT8_RXPRBSCNTRESET_IN                   : in   std_logic;
    ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
    GT8_RXDISPERR_OUT                       : out  std_logic_vector(1 downto 0);
    GT8_RXNOTINTABLE_OUT                    : out  std_logic_vector(1 downto 0);
    --------------------------- Receive Ports - RX AFE -------------------------
    GT8_GTXRXP_IN                           : in   std_logic;
    ------------------------ Receive Ports - RX AFE Ports ----------------------
    GT8_GTXRXN_IN                           : in   std_logic;
    -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
    GT8_RXMCOMMAALIGNEN_IN                  : in   std_logic;
    GT8_RXPCOMMAALIGNEN_IN                  : in   std_logic;
    --------------------- Receive Ports - RX Equalizer Ports -------------------
    GT8_RXDFELPMRESET_IN                    : in   std_logic;
    GT8_RXMONITOROUT_OUT                    : out  std_logic_vector(6 downto 0);
    GT8_RXMONITORSEL_IN                     : in   std_logic_vector(1 downto 0);
    ------------- Receive Ports - RX Initialization and Reset Ports ------------
    GT8_GTRXRESET_IN                        : in   std_logic;
    GT8_RXPMARESET_IN                       : in   std_logic;
    ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
    GT8_RXCHARISCOMMA_OUT                   : out  std_logic_vector(1 downto 0);
    GT8_RXCHARISK_OUT                       : out  std_logic_vector(1 downto 0);
    -------------- Receive Ports -RX Initialization and Reset Ports ------------
    GT8_RXRESETDONE_OUT                     : out  std_logic;
    --------------------- TX Initialization and Reset Ports --------------------
    GT8_GTTXRESET_IN                        : in   std_logic;
    GT8_TXUSERRDY_IN                        : in   std_logic;
    ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
    GT8_TXUSRCLK_IN                         : in   std_logic;
    GT8_TXUSRCLK2_IN                        : in   std_logic;
    --------------- Transmit Ports - TX Configurable Driver Ports --------------
    GT8_TXDIFFCTRL_IN                       : in   std_logic_vector(3 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    GT8_TXDATA_IN                           : in   std_logic_vector(15 downto 0);
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    GT8_GTXTXN_OUT                          : out  std_logic;
    GT8_GTXTXP_OUT                          : out  std_logic;
    ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
    GT8_TXOUTCLK_OUT                        : out  std_logic;
    GT8_TXOUTCLKFABRIC_OUT                  : out  std_logic;
    GT8_TXOUTCLKPCS_OUT                     : out  std_logic;
    --------------------- Transmit Ports - TX Gearbox Ports --------------------
    GT8_TXCHARISK_IN                        : in   std_logic_vector(1 downto 0);
    ------------- Transmit Ports - TX Initialization and Reset Ports -----------
    GT8_TXRESETDONE_OUT                     : out  std_logic;
    ------------------ Transmit Ports - pattern Generator Ports ----------------
    GT8_TXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);

    --GT9  (X1Y9)
    --____________________________CHANNEL PORTS________________________________
    ---------------------------- Channel - DRP Ports  --------------------------
    GT9_DRPADDR_IN                          : in   std_logic_vector(8 downto 0);
    GT9_DRPCLK_IN                           : in   std_logic;
    GT9_DRPDI_IN                            : in   std_logic_vector(15 downto 0);
    GT9_DRPDO_OUT                           : out  std_logic_vector(15 downto 0);
    GT9_DRPEN_IN                            : in   std_logic;
    GT9_DRPRDY_OUT                          : out  std_logic;
    GT9_DRPWE_IN                            : in   std_logic;
    ------------------------------- Loopback Ports -----------------------------
    GT9_LOOPBACK_IN                         : in   std_logic_vector(2 downto 0);
    --------------------- RX Initialization and Reset Ports --------------------
    GT9_RXUSERRDY_IN                        : in   std_logic;
    -------------------------- RX Margin Analysis Ports ------------------------
    GT9_EYESCANDATAERROR_OUT                : out  std_logic;
    ------------------------- Receive Ports - CDR Ports ------------------------
    GT9_RXCDRLOCK_OUT                       : out  std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    GT9_RXCLKCORCNT_OUT                     : out  std_logic_vector(1 downto 0);
    ------------------ Receive Ports - FPGA RX Interface Ports -----------------
    GT9_RXUSRCLK_IN                         : in   std_logic;
    GT9_RXUSRCLK2_IN                        : in   std_logic;
    ------------------ Receive Ports - FPGA RX interface Ports -----------------
    GT9_RXDATA_OUT                          : out  std_logic_vector(15 downto 0);
    ------------------- Receive Ports - Pattern Checker Ports ------------------
    GT9_RXPRBSERR_OUT                       : out  std_logic;
    GT9_RXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
    ------------------- Receive Ports - Pattern Checker ports ------------------
    GT9_RXPRBSCNTRESET_IN                   : in   std_logic;
    ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
    GT9_RXDISPERR_OUT                       : out  std_logic_vector(1 downto 0);
    GT9_RXNOTINTABLE_OUT                    : out  std_logic_vector(1 downto 0);
    --------------------------- Receive Ports - RX AFE -------------------------
    GT9_GTXRXP_IN                           : in   std_logic;
    ------------------------ Receive Ports - RX AFE Ports ----------------------
    GT9_GTXRXN_IN                           : in   std_logic;
    -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
    GT9_RXMCOMMAALIGNEN_IN                  : in   std_logic;
    GT9_RXPCOMMAALIGNEN_IN                  : in   std_logic;
    --------------------- Receive Ports - RX Equalizer Ports -------------------
    GT9_RXDFELPMRESET_IN                    : in   std_logic;
    GT9_RXMONITOROUT_OUT                    : out  std_logic_vector(6 downto 0);
    GT9_RXMONITORSEL_IN                     : in   std_logic_vector(1 downto 0);
    ------------- Receive Ports - RX Initialization and Reset Ports ------------
    GT9_GTRXRESET_IN                        : in   std_logic;
    GT9_RXPMARESET_IN                       : in   std_logic;
    ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
    GT9_RXCHARISCOMMA_OUT                   : out  std_logic_vector(1 downto 0);
    GT9_RXCHARISK_OUT                       : out  std_logic_vector(1 downto 0);
    -------------- Receive Ports -RX Initialization and Reset Ports ------------
    GT9_RXRESETDONE_OUT                     : out  std_logic;
    --------------------- TX Initialization and Reset Ports --------------------
    GT9_GTTXRESET_IN                        : in   std_logic;
    GT9_TXUSERRDY_IN                        : in   std_logic;
    ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
    GT9_TXUSRCLK_IN                         : in   std_logic;
    GT9_TXUSRCLK2_IN                        : in   std_logic;
    --------------- Transmit Ports - TX Configurable Driver Ports --------------
    GT9_TXDIFFCTRL_IN                       : in   std_logic_vector(3 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    GT9_TXDATA_IN                           : in   std_logic_vector(15 downto 0);
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    GT9_GTXTXN_OUT                          : out  std_logic;
    GT9_GTXTXP_OUT                          : out  std_logic;
    ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
    GT9_TXOUTCLK_OUT                        : out  std_logic;
    GT9_TXOUTCLKFABRIC_OUT                  : out  std_logic;
    GT9_TXOUTCLKPCS_OUT                     : out  std_logic;
    --------------------- Transmit Ports - TX Gearbox Ports --------------------
    GT9_TXCHARISK_IN                        : in   std_logic_vector(1 downto 0);
    ------------- Transmit Ports - TX Initialization and Reset Ports -----------
    GT9_TXRESETDONE_OUT                     : out  std_logic;
    ------------------ Transmit Ports - pattern Generator Ports ----------------
    GT9_TXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);

    --GT10  (X1Y10)
    --____________________________CHANNEL PORTS________________________________
    ---------------------------- Channel - DRP Ports  --------------------------
    GT10_DRPADDR_IN                         : in   std_logic_vector(8 downto 0);
    GT10_DRPCLK_IN                          : in   std_logic;
    GT10_DRPDI_IN                           : in   std_logic_vector(15 downto 0);
    GT10_DRPDO_OUT                          : out  std_logic_vector(15 downto 0);
    GT10_DRPEN_IN                           : in   std_logic;
    GT10_DRPRDY_OUT                         : out  std_logic;
    GT10_DRPWE_IN                           : in   std_logic;
    ------------------------------- Loopback Ports -----------------------------
    GT10_LOOPBACK_IN                        : in   std_logic_vector(2 downto 0);
    --------------------- RX Initialization and Reset Ports --------------------
    GT10_RXUSERRDY_IN                       : in   std_logic;
    -------------------------- RX Margin Analysis Ports ------------------------
    GT10_EYESCANDATAERROR_OUT               : out  std_logic;
    ------------------------- Receive Ports - CDR Ports ------------------------
    GT10_RXCDRLOCK_OUT                      : out  std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    GT10_RXCLKCORCNT_OUT                    : out  std_logic_vector(1 downto 0);
    ------------------ Receive Ports - FPGA RX Interface Ports -----------------
    GT10_RXUSRCLK_IN                        : in   std_logic;
    GT10_RXUSRCLK2_IN                       : in   std_logic;
    ------------------ Receive Ports - FPGA RX interface Ports -----------------
    GT10_RXDATA_OUT                         : out  std_logic_vector(15 downto 0);
    ------------------- Receive Ports - Pattern Checker Ports ------------------
    GT10_RXPRBSERR_OUT                      : out  std_logic;
    GT10_RXPRBSSEL_IN                       : in   std_logic_vector(2 downto 0);
    ------------------- Receive Ports - Pattern Checker ports ------------------
    GT10_RXPRBSCNTRESET_IN                  : in   std_logic;
    ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
    GT10_RXDISPERR_OUT                      : out  std_logic_vector(1 downto 0);
    GT10_RXNOTINTABLE_OUT                   : out  std_logic_vector(1 downto 0);
    --------------------------- Receive Ports - RX AFE -------------------------
    GT10_GTXRXP_IN                          : in   std_logic;
    ------------------------ Receive Ports - RX AFE Ports ----------------------
    GT10_GTXRXN_IN                          : in   std_logic;
    -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
    GT10_RXMCOMMAALIGNEN_IN                 : in   std_logic;
    GT10_RXPCOMMAALIGNEN_IN                 : in   std_logic;
    --------------------- Receive Ports - RX Equalizer Ports -------------------
    GT10_RXDFELPMRESET_IN                   : in   std_logic;
    GT10_RXMONITOROUT_OUT                   : out  std_logic_vector(6 downto 0);
    GT10_RXMONITORSEL_IN                    : in   std_logic_vector(1 downto 0);
    ------------- Receive Ports - RX Initialization and Reset Ports ------------
    GT10_GTRXRESET_IN                       : in   std_logic;
    GT10_RXPMARESET_IN                      : in   std_logic;
    ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
    GT10_RXCHARISCOMMA_OUT                  : out  std_logic_vector(1 downto 0);
    GT10_RXCHARISK_OUT                      : out  std_logic_vector(1 downto 0);
    -------------- Receive Ports -RX Initialization and Reset Ports ------------
    GT10_RXRESETDONE_OUT                    : out  std_logic;
    --------------------- TX Initialization and Reset Ports --------------------
    GT10_GTTXRESET_IN                       : in   std_logic;
    GT10_TXUSERRDY_IN                       : in   std_logic;
    ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
    GT10_TXUSRCLK_IN                        : in   std_logic;
    GT10_TXUSRCLK2_IN                       : in   std_logic;
    --------------- Transmit Ports - TX Configurable Driver Ports --------------
    GT10_TXDIFFCTRL_IN                      : in   std_logic_vector(3 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    GT10_TXDATA_IN                          : in   std_logic_vector(15 downto 0);
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    GT10_GTXTXN_OUT                         : out  std_logic;
    GT10_GTXTXP_OUT                         : out  std_logic;
    ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
    GT10_TXOUTCLK_OUT                       : out  std_logic;
    GT10_TXOUTCLKFABRIC_OUT                 : out  std_logic;
    GT10_TXOUTCLKPCS_OUT                    : out  std_logic;
    --------------------- Transmit Ports - TX Gearbox Ports --------------------
    GT10_TXCHARISK_IN                       : in   std_logic_vector(1 downto 0);
    ------------- Transmit Ports - TX Initialization and Reset Ports -----------
    GT10_TXRESETDONE_OUT                    : out  std_logic;
    ------------------ Transmit Ports - pattern Generator Ports ----------------
    GT10_TXPRBSSEL_IN                       : in   std_logic_vector(2 downto 0);

    --GT11  (X1Y11)
    --____________________________CHANNEL PORTS________________________________
    ---------------------------- Channel - DRP Ports  --------------------------
    GT11_DRPADDR_IN                         : in   std_logic_vector(8 downto 0);
    GT11_DRPCLK_IN                          : in   std_logic;
    GT11_DRPDI_IN                           : in   std_logic_vector(15 downto 0);
    GT11_DRPDO_OUT                          : out  std_logic_vector(15 downto 0);
    GT11_DRPEN_IN                           : in   std_logic;
    GT11_DRPRDY_OUT                         : out  std_logic;
    GT11_DRPWE_IN                           : in   std_logic;
    ------------------------------- Loopback Ports -----------------------------
    GT11_LOOPBACK_IN                        : in   std_logic_vector(2 downto 0);
    --------------------- RX Initialization and Reset Ports --------------------
    GT11_RXUSERRDY_IN                       : in   std_logic;
    -------------------------- RX Margin Analysis Ports ------------------------
    GT11_EYESCANDATAERROR_OUT               : out  std_logic;
    ------------------------- Receive Ports - CDR Ports ------------------------
    GT11_RXCDRLOCK_OUT                      : out  std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    GT11_RXCLKCORCNT_OUT                    : out  std_logic_vector(1 downto 0);
    ------------------ Receive Ports - FPGA RX Interface Ports -----------------
    GT11_RXUSRCLK_IN                        : in   std_logic;
    GT11_RXUSRCLK2_IN                       : in   std_logic;
    ------------------ Receive Ports - FPGA RX interface Ports -----------------
    GT11_RXDATA_OUT                         : out  std_logic_vector(15 downto 0);
    ------------------- Receive Ports - Pattern Checker Ports ------------------
    GT11_RXPRBSERR_OUT                      : out  std_logic;
    GT11_RXPRBSSEL_IN                       : in   std_logic_vector(2 downto 0);
    ------------------- Receive Ports - Pattern Checker ports ------------------
    GT11_RXPRBSCNTRESET_IN                  : in   std_logic;
    ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
    GT11_RXDISPERR_OUT                      : out  std_logic_vector(1 downto 0);
    GT11_RXNOTINTABLE_OUT                   : out  std_logic_vector(1 downto 0);
    --------------------------- Receive Ports - RX AFE -------------------------
    GT11_GTXRXP_IN                          : in   std_logic;
    ------------------------ Receive Ports - RX AFE Ports ----------------------
    GT11_GTXRXN_IN                          : in   std_logic;
    -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
    GT11_RXMCOMMAALIGNEN_IN                 : in   std_logic;
    GT11_RXPCOMMAALIGNEN_IN                 : in   std_logic;
    --------------------- Receive Ports - RX Equalizer Ports -------------------
    GT11_RXDFELPMRESET_IN                   : in   std_logic;
    GT11_RXMONITOROUT_OUT                   : out  std_logic_vector(6 downto 0);
    GT11_RXMONITORSEL_IN                    : in   std_logic_vector(1 downto 0);
    ------------- Receive Ports - RX Initialization and Reset Ports ------------
    GT11_GTRXRESET_IN                       : in   std_logic;
    GT11_RXPMARESET_IN                      : in   std_logic;
    ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
    GT11_RXCHARISCOMMA_OUT                  : out  std_logic_vector(1 downto 0);
    GT11_RXCHARISK_OUT                      : out  std_logic_vector(1 downto 0);
    -------------- Receive Ports -RX Initialization and Reset Ports ------------
    GT11_RXRESETDONE_OUT                    : out  std_logic;
    --------------------- TX Initialization and Reset Ports --------------------
    GT11_GTTXRESET_IN                       : in   std_logic;
    GT11_TXUSERRDY_IN                       : in   std_logic;
    ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
    GT11_TXUSRCLK_IN                        : in   std_logic;
    GT11_TXUSRCLK2_IN                       : in   std_logic;
    --------------- Transmit Ports - TX Configurable Driver Ports --------------
    GT11_TXDIFFCTRL_IN                      : in   std_logic_vector(3 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    GT11_TXDATA_IN                          : in   std_logic_vector(15 downto 0);
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    GT11_GTXTXN_OUT                         : out  std_logic;
    GT11_GTXTXP_OUT                         : out  std_logic;
    ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
    GT11_TXOUTCLK_OUT                       : out  std_logic;
    GT11_TXOUTCLKFABRIC_OUT                 : out  std_logic;
    GT11_TXOUTCLKPCS_OUT                    : out  std_logic;
    --------------------- Transmit Ports - TX Gearbox Ports --------------------
    GT11_TXCHARISK_IN                       : in   std_logic_vector(1 downto 0);
    ------------- Transmit Ports - TX Initialization and Reset Ports -----------
    GT11_TXRESETDONE_OUT                    : out  std_logic;
    ------------------ Transmit Ports - pattern Generator Ports ----------------
    GT11_TXPRBSSEL_IN                       : in   std_logic_vector(2 downto 0);
   

    --____________________________COMMON PORTS________________________________
    ---------------------- Common Block  - Ref Clock Ports ---------------------
    GT0_GTREFCLK0_COMMON_IN                 : in   std_logic;
    ------------------------- Common Block - QPLL Ports ------------------------
    GT0_QPLLLOCK_OUT                        : out  std_logic;
    GT0_QPLLLOCKDETCLK_IN                   : in   std_logic;
    GT0_QPLLRESET_IN                        : in   std_logic;

    --____________________________COMMON PORTS________________________________
    ---------------------- Common Block  - Ref Clock Ports ---------------------
    GT1_GTREFCLK0_COMMON_IN                 : in   std_logic;
    ------------------------- Common Block - QPLL Ports ------------------------
    GT1_QPLLLOCK_OUT                        : out  std_logic;
    GT1_QPLLLOCKDETCLK_IN                   : in   std_logic;
    GT1_QPLLRESET_IN                        : in   std_logic;

    --____________________________COMMON PORTS________________________________
    ---------------------- Common Block  - Ref Clock Ports ---------------------
    GT2_GTREFCLK0_COMMON_IN                 : in   std_logic;
    ------------------------- Common Block - QPLL Ports ------------------------
    GT2_QPLLLOCK_OUT                        : out  std_logic;
    GT2_QPLLLOCKDETCLK_IN                   : in   std_logic;
    GT2_QPLLRESET_IN                        : in   std_logic


);
end component;
signal qpll_lock_i : std_logic_vector(2 downto 0) := (others =>'0');
signal loop0 : std_logic_vector(11 downto 0) := (others =>'0');
begin
qpll_lock <= qpll_lock_i;
loop0 <= x"fff" when test = '1' else not AMC_en;
i_AMC_GTX_init : AMC_GTXv_init
    generic map
    (
        EXAMPLE_SIM_GTRESET_SPEEDUP     =>      "true",
        EXAMPLE_SIMULATION              =>      0,
        EXAMPLE_USE_CHIPSCOPE           =>      0
    )
    port map
    (
        SYSCLK_IN                       =>      DRPclk,
        SOFT_RESET_IN                   =>      SOFT_RESET,
        GT0_TX_FSM_RESET_DONE_OUT       =>      txfsmresetdone(0),
        GT0_RX_FSM_RESET_DONE_OUT       =>      rxfsmresetdone(0),
        GT0_DATA_VALID_IN               =>      data_valid(0),
        GT1_TX_FSM_RESET_DONE_OUT       =>      txfsmresetdone(1),
        GT1_RX_FSM_RESET_DONE_OUT       =>      rxfsmresetdone(1),
        GT1_DATA_VALID_IN               =>      data_valid(1),
        GT2_TX_FSM_RESET_DONE_OUT       =>      txfsmresetdone(2),
        GT2_RX_FSM_RESET_DONE_OUT       =>      rxfsmresetdone(2),
        GT2_DATA_VALID_IN               =>      data_valid(2),
        GT3_TX_FSM_RESET_DONE_OUT       =>      txfsmresetdone(3),
        GT3_RX_FSM_RESET_DONE_OUT       =>      rxfsmresetdone(3),
        GT3_DATA_VALID_IN               =>      data_valid(3),
        GT4_TX_FSM_RESET_DONE_OUT       =>      txfsmresetdone(4),
        GT4_RX_FSM_RESET_DONE_OUT       =>      rxfsmresetdone(4),
        GT4_DATA_VALID_IN               =>      data_valid(4),
        GT5_TX_FSM_RESET_DONE_OUT       =>      txfsmresetdone(5),
        GT5_RX_FSM_RESET_DONE_OUT       =>      rxfsmresetdone(5),
        GT5_DATA_VALID_IN               =>      data_valid(5),
        GT6_TX_FSM_RESET_DONE_OUT       =>      txfsmresetdone(6),
        GT6_RX_FSM_RESET_DONE_OUT       =>      rxfsmresetdone(6),
        GT6_DATA_VALID_IN               =>      data_valid(6),
        GT7_TX_FSM_RESET_DONE_OUT       =>      txfsmresetdone(7),
        GT7_RX_FSM_RESET_DONE_OUT       =>      rxfsmresetdone(7),
        GT7_DATA_VALID_IN               =>      data_valid(7),
        GT8_TX_FSM_RESET_DONE_OUT       =>      txfsmresetdone(8),
        GT8_RX_FSM_RESET_DONE_OUT       =>      rxfsmresetdone(8),
        GT8_DATA_VALID_IN               =>      data_valid(8),
        GT9_TX_FSM_RESET_DONE_OUT       =>      txfsmresetdone(9),
        GT9_RX_FSM_RESET_DONE_OUT       =>      rxfsmresetdone(9),
        GT9_DATA_VALID_IN               =>      data_valid(9),
        GT10_TX_FSM_RESET_DONE_OUT      =>      txfsmresetdone(10),
        GT10_RX_FSM_RESET_DONE_OUT      =>      rxfsmresetdone(10),
        GT10_DATA_VALID_IN              =>      data_valid(10),
        GT11_TX_FSM_RESET_DONE_OUT      =>      txfsmresetdone(11),
        GT11_RX_FSM_RESET_DONE_OUT      =>      rxfsmresetdone(11),
        GT11_DATA_VALID_IN              =>      data_valid(11),

  
 
 
 
        --_____________________________________________________________________
        --_____________________________________________________________________
        --GT0  (X1Y0)

        ---------------------------- Channel - DRP Ports  --------------------------
        GT0_DRPADDR_IN                  =>      (others => '0'),
        GT0_DRPCLK_IN                   =>      DRPclk,
        GT0_DRPDI_IN                    =>      (others => '0'),
        GT0_DRPDO_OUT                   =>      open,
        GT0_DRPEN_IN                    =>      '0',
        GT0_DRPRDY_OUT                  =>      open,
        GT0_DRPWE_IN                    =>      '0',
        ------------------------------- Loopback Ports -----------------------------
        GT0_LOOPBACK_IN                 =>      "00" & loop0(0),
        --------------------- RX Initialization and Reset Ports --------------------
        GT0_RXUSERRDY_IN                =>      '0',
        -------------------------- RX Margin Analysis Ports ------------------------
        GT0_EYESCANDATAERROR_OUT        =>      open,
        ------------------------- Receive Ports - CDR Ports ------------------------
        GT0_RXCDRLOCK_OUT               =>      open,
        ------------------- Receive Ports - Clock Correction Ports -----------------
        GT0_RXCLKCORCNT_OUT             =>      open,
        ------------------ Receive Ports - FPGA RX Interface Ports -----------------
        GT0_RXUSRCLK_IN                 =>      UsrClk,
        GT0_RXUSRCLK2_IN                =>      UsrClk,
        ------------------ Receive Ports - FPGA RX interface Ports -----------------
        GT0_RXDATA_OUT                  =>      RXDATA(0),
        ------------------- Receive Ports - Pattern Checker Ports ------------------
        GT0_RXPRBSERR_OUT               =>      rxprbserr(0),
        GT0_RXPRBSSEL_IN                =>      rxprbssel(0),
        ------------------- Receive Ports - Pattern Checker ports ------------------
        GT0_RXPRBSCNTRESET_IN           =>      '0',
        ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
        GT0_RXDISPERR_OUT               =>      open,
        GT0_RXNOTINTABLE_OUT            =>      RXNOTINTABLE(0),
        --------------------------- Receive Ports - RX AFE -------------------------
        GT0_GTXRXP_IN                   =>      RXP(0),
        ------------------------ Receive Ports - RX AFE Ports ----------------------
        GT0_GTXRXN_IN                   =>      RXN(0),
        -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
        GT0_RXMCOMMAALIGNEN_IN          =>      rxcommaalignen(0),
        GT0_RXPCOMMAALIGNEN_IN          =>      rxcommaalignen(0),
        --------------------- Receive Ports - RX Equalizer Ports -------------------
        GT0_RXDFELPMRESET_IN            =>      '0',
        GT0_RXMONITORSEL_IN             =>      "00",
        ------------- Receive Ports - RX Initialization and Reset Ports ------------
        GT0_GTRXRESET_IN                =>      not qpll_lock_i(0),
        GT0_RXPMARESET_IN               =>      '0',
        ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
        GT0_RXCHARISCOMMA_OUT           =>      rxchariscomma(0),
        GT0_RXCHARISK_OUT               =>      rxcharisk(0),
        -------------- Receive Ports -RX Initialization and Reset Ports ------------
        GT0_RXRESETDONE_OUT             =>      rxresetdone(0),
        --------------------- TX Initialization and Reset Ports --------------------
        GT0_GTTXRESET_IN                =>      not qpll_lock_i(0),
        GT0_TXUSERRDY_IN                =>      '0',
        ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
        GT0_TXUSRCLK_IN                 =>      UsrClk,
        GT0_TXUSRCLK2_IN                =>      UsrClk,
        --------------- Transmit Ports - TX Configurable Driver Ports --------------
        GT0_TXDIFFCTRL_IN               =>      txdiffctrl(0),
        ------------------ Transmit Ports - TX Data Path interface -----------------
        GT0_TXDATA_IN                   =>      TXDATA(0),
        ---------------- Transmit Ports - TX Driver and OOB signaling --------------
        GT0_GTXTXN_OUT                  =>      TXN(0),
        GT0_GTXTXP_OUT                  =>      TXP(0),
        ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
        GT0_TXOUTCLK_OUT                =>      txoutclk(0),
        GT0_TXOUTCLKFABRIC_OUT          =>      open,
        GT0_TXOUTCLKPCS_OUT             =>      open,
        --------------------- Transmit Ports - TX Gearbox Ports --------------------
        GT0_TXCHARISK_IN                =>      txcharisk(0),
        ------------- Transmit Ports - TX Initialization and Reset Ports -----------
        GT0_TXRESETDONE_OUT             =>      txresetdone(0),
        ------------------ Transmit Ports - pattern Generator Ports ----------------
        GT0_TXPRBSSEL_IN                =>      txprbssel(0),

        --_____________________________________________________________________
        --_____________________________________________________________________
        --GT1  (X1Y1)

        ---------------------------- Channel - DRP Ports  --------------------------
        GT1_DRPADDR_IN                  =>      (others => '0'),
        GT1_DRPCLK_IN                   =>      DRPclk,
        GT1_DRPDI_IN                    =>      (others => '0'),
        GT1_DRPDO_OUT                   =>      open,
        GT1_DRPEN_IN                    =>      '0',
        GT1_DRPRDY_OUT                  =>      open,
        GT1_DRPWE_IN                    =>      '0',
        ------------------------------- Loopback Ports -----------------------------
        GT1_LOOPBACK_IN                 =>      "00" & loop0(1),
        --------------------- RX Initialization and Reset Ports --------------------
        GT1_RXUSERRDY_IN                =>      '0',
        -------------------------- RX Margin Analysis Ports ------------------------
        GT1_EYESCANDATAERROR_OUT        =>      open,
        ------------------------- Receive Ports - CDR Ports ------------------------
        GT1_RXCDRLOCK_OUT               =>      open,
        ------------------- Receive Ports - Clock Correction Ports -----------------
        GT1_RXCLKCORCNT_OUT             =>      open,
        ------------------ Receive Ports - FPGA RX Interface Ports -----------------
        GT1_RXUSRCLK_IN                 =>      UsrClk,
        GT1_RXUSRCLK2_IN                =>      UsrClk,
        ------------------ Receive Ports - FPGA RX interface Ports -----------------
        GT1_RXDATA_OUT                  =>      RXDATA(1),
        ------------------- Receive Ports - Pattern Checker Ports ------------------
        GT1_RXPRBSERR_OUT               =>      rxprbserr(1),
        GT1_RXPRBSSEL_IN                =>      rxprbssel(1),
        ------------------- Receive Ports - Pattern Checker ports ------------------
        GT1_RXPRBSCNTRESET_IN           =>      '0',
        ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
        GT1_RXDISPERR_OUT               =>      open,
        GT1_RXNOTINTABLE_OUT            =>      RXNOTINTABLE(1),
        --------------------------- Receive Ports - RX AFE -------------------------
        GT1_GTXRXP_IN                   =>      RXP(1),
        ------------------------ Receive Ports - RX AFE Ports ----------------------
        GT1_GTXRXN_IN                   =>      RXN(1),
        -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
        GT1_RXMCOMMAALIGNEN_IN          =>      rxcommaalignen(1),
        GT1_RXPCOMMAALIGNEN_IN          =>      rxcommaalignen(1),
        --------------------- Receive Ports - RX Equalizer Ports -------------------
        GT1_RXDFELPMRESET_IN            =>      '0',
        GT1_RXMONITORSEL_IN             =>      "00",
        ------------- Receive Ports - RX Initialization and Reset Ports ------------
        GT1_GTRXRESET_IN                =>      not qpll_lock_i(0),
        GT1_RXPMARESET_IN               =>      '0',
        ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
        GT1_RXCHARISCOMMA_OUT           =>      rxchariscomma(1),
        GT1_RXCHARISK_OUT               =>      rxcharisk(1),
        -------------- Receive Ports -RX Initialization and Reset Ports ------------
        GT1_RXRESETDONE_OUT             =>      rxresetdone(1),
        --------------------- TX Initialization and Reset Ports --------------------
        GT1_GTTXRESET_IN                =>      not qpll_lock_i(0),
        GT1_TXUSERRDY_IN                =>      '0',
        ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
        GT1_TXUSRCLK_IN                 =>      UsrClk,
        GT1_TXUSRCLK2_IN                =>      UsrClk,
        --------------- Transmit Ports - TX Configurable Driver Ports --------------
        GT1_TXDIFFCTRL_IN               =>      txdiffctrl(1),
        ------------------ Transmit Ports - TX Data Path interface -----------------
        GT1_TXDATA_IN                   =>      TXDATA(1),
        ---------------- Transmit Ports - TX Driver and OOB signaling --------------
        GT1_GTXTXN_OUT                  =>      TXN(1),
        GT1_GTXTXP_OUT                  =>      TXP(1),
        ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
        GT1_TXOUTCLK_OUT                =>      txoutclk(1),
        GT1_TXOUTCLKFABRIC_OUT          =>      open,
        GT1_TXOUTCLKPCS_OUT             =>      open,
        --------------------- Transmit Ports - TX Gearbox Ports --------------------
        GT1_TXCHARISK_IN                =>      txcharisk(1),
        ------------- Transmit Ports - TX Initialization and Reset Ports -----------
        GT1_TXRESETDONE_OUT             =>      txresetdone(1),
        ------------------ Transmit Ports - pattern Generator Ports ----------------
        GT1_TXPRBSSEL_IN                =>      txprbssel(1),
 
        --_____________________________________________________________________
        --_____________________________________________________________________
        --GT2  (X1Y2)

        ---------------------------- Channel - DRP Ports  --------------------------
        GT2_DRPADDR_IN                  =>      (others => '0'),
        GT2_DRPCLK_IN                   =>      DRPclk,
        GT2_DRPDI_IN                    =>      (others => '0'),
        GT2_DRPDO_OUT                   =>      open,
        GT2_DRPEN_IN                    =>      '0',
        GT2_DRPRDY_OUT                  =>      open,
        GT2_DRPWE_IN                    =>      '0',
        ------------------------------- Loopback Ports -----------------------------
        GT2_LOOPBACK_IN                 =>      "00" & loop0(2),
        --------------------- RX Initialization and Reset Ports --------------------
        GT2_RXUSERRDY_IN                =>      '0',
        -------------------------- RX Margin Analysis Ports ------------------------
        GT2_EYESCANDATAERROR_OUT        =>      open,
        ------------------------- Receive Ports - CDR Ports ------------------------
        GT2_RXCDRLOCK_OUT               =>      open,
        ------------------- Receive Ports - Clock Correction Ports -----------------
        GT2_RXCLKCORCNT_OUT             =>      open,
        ------------------ Receive Ports - FPGA RX Interface Ports -----------------
        GT2_RXUSRCLK_IN                 =>      UsrClk,
        GT2_RXUSRCLK2_IN                =>      UsrClk,
        ------------------ Receive Ports - FPGA RX interface Ports -----------------
        GT2_RXDATA_OUT                  =>      RXDATA(2),
        ------------------- Receive Ports - Pattern Checker Ports ------------------
        GT2_RXPRBSERR_OUT               =>      rxprbserr(2),
        GT2_RXPRBSSEL_IN                =>      rxprbssel(2),
        ------------------- Receive Ports - Pattern Checker ports ------------------
        GT2_RXPRBSCNTRESET_IN           =>      '0',
        ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
        GT2_RXDISPERR_OUT               =>      open,
        GT2_RXNOTINTABLE_OUT            =>      RXNOTINTABLE(2),
        --------------------------- Receive Ports - RX AFE -------------------------
        GT2_GTXRXP_IN                   =>      RXP(2),
        ------------------------ Receive Ports - RX AFE Ports ----------------------
        GT2_GTXRXN_IN                   =>      RXN(2),
        -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
        GT2_RXMCOMMAALIGNEN_IN          =>      rxcommaalignen(2),
        GT2_RXPCOMMAALIGNEN_IN          =>      rxcommaalignen(2),
        --------------------- Receive Ports - RX Equalizer Ports -------------------
        GT2_RXDFELPMRESET_IN            =>      '0',
        GT2_RXMONITORSEL_IN             =>      "00",
        ------------- Receive Ports - RX Initialization and Reset Ports ------------
        GT2_GTRXRESET_IN                =>      not qpll_lock_i(0),
        GT2_RXPMARESET_IN               =>      '0',
        ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
        GT2_RXCHARISCOMMA_OUT           =>      rxchariscomma(2),
        GT2_RXCHARISK_OUT               =>      rxcharisk(2),
        -------------- Receive Ports -RX Initialization and Reset Ports ------------
        GT2_RXRESETDONE_OUT             =>      rxresetdone(2),
        --------------------- TX Initialization and Reset Ports --------------------
        GT2_GTTXRESET_IN                =>      not qpll_lock_i(0),
        GT2_TXUSERRDY_IN                =>      '0',
        ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
        GT2_TXUSRCLK_IN                 =>      UsrClk,
        GT2_TXUSRCLK2_IN                =>      UsrClk,
        --------------- Transmit Ports - TX Configurable Driver Ports --------------
        GT2_TXDIFFCTRL_IN               =>      txdiffctrl(2),
        ------------------ Transmit Ports - TX Data Path interface -----------------
        GT2_TXDATA_IN                   =>      TXDATA(2),
        ---------------- Transmit Ports - TX Driver and OOB signaling --------------
        GT2_GTXTXN_OUT                  =>      TXN(2),
        GT2_GTXTXP_OUT                  =>      TXP(2),
        ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
        GT2_TXOUTCLK_OUT                =>      txoutclk(2),
        GT2_TXOUTCLKFABRIC_OUT          =>      open,
        GT2_TXOUTCLKPCS_OUT             =>      open,
        --------------------- Transmit Ports - TX Gearbox Ports --------------------
        GT2_TXCHARISK_IN                =>      txcharisk(2),
        ------------- Transmit Ports - TX Initialization and Reset Ports -----------
        GT2_TXRESETDONE_OUT             =>      txresetdone(2),
        ------------------ Transmit Ports - pattern Generator Ports ----------------
        GT2_TXPRBSSEL_IN                =>      txprbssel(2),
 
        --_____________________________________________________________________
        --_____________________________________________________________________
        --GT3  (X1Y3)

        ---------------------------- Channel - DRP Ports  --------------------------
        GT3_DRPADDR_IN                  =>      (others => '0'),
        GT3_DRPCLK_IN                   =>      DRPclk,
        GT3_DRPDI_IN                    =>      (others => '0'),
        GT3_DRPDO_OUT                   =>      open,
        GT3_DRPEN_IN                    =>      '0',
        GT3_DRPRDY_OUT                  =>      open,
        GT3_DRPWE_IN                    =>      '0',
        ------------------------------- Loopback Ports -----------------------------
        GT3_LOOPBACK_IN                 =>      "00" & loop0(3),
        --------------------- RX Initialization and Reset Ports --------------------
        GT3_RXUSERRDY_IN                =>      '0',
        -------------------------- RX Margin Analysis Ports ------------------------
        GT3_EYESCANDATAERROR_OUT        =>      open,
        ------------------------- Receive Ports - CDR Ports ------------------------
        GT3_RXCDRLOCK_OUT               =>      open,
        ------------------- Receive Ports - Clock Correction Ports -----------------
        GT3_RXCLKCORCNT_OUT             =>      open,
        ------------------ Receive Ports - FPGA RX Interface Ports -----------------
        GT3_RXUSRCLK_IN                 =>      UsrClk,
        GT3_RXUSRCLK2_IN                =>      UsrClk,
        ------------------ Receive Ports - FPGA RX interface Ports -----------------
        GT3_RXDATA_OUT                  =>      RXDATA(3),
        ------------------- Receive Ports - Pattern Checker Ports ------------------
        GT3_RXPRBSERR_OUT               =>      rxprbserr(3),
        GT3_RXPRBSSEL_IN                =>      rxprbssel(3),
        ------------------- Receive Ports - Pattern Checker ports ------------------
        GT3_RXPRBSCNTRESET_IN           =>      '0',
        ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
        GT3_RXDISPERR_OUT               =>      open,
        GT3_RXNOTINTABLE_OUT            =>      RXNOTINTABLE(3),
        --------------------------- Receive Ports - RX AFE -------------------------
        GT3_GTXRXP_IN                   =>      RXP(3),
        ------------------------ Receive Ports - RX AFE Ports ----------------------
        GT3_GTXRXN_IN                   =>      RXN(3),
        -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
        GT3_RXMCOMMAALIGNEN_IN          =>      rxcommaalignen(3),
        GT3_RXPCOMMAALIGNEN_IN          =>      rxcommaalignen(3),
        --------------------- Receive Ports - RX Equalizer Ports -------------------
        GT3_RXDFELPMRESET_IN            =>      '0',
        GT3_RXMONITORSEL_IN             =>      "00",
        ------------- Receive Ports - RX Initialization and Reset Ports ------------
        GT3_GTRXRESET_IN                =>      not qpll_lock_i(0),
        GT3_RXPMARESET_IN               =>      '0',
        ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
        GT3_RXCHARISCOMMA_OUT           =>      rxchariscomma(3),
        GT3_RXCHARISK_OUT               =>      rxcharisk(3),
        -------------- Receive Ports -RX Initialization and Reset Ports ------------
        GT3_RXRESETDONE_OUT             =>      rxresetdone(3),
        --------------------- TX Initialization and Reset Ports --------------------
        GT3_GTTXRESET_IN                =>      not qpll_lock_i(0),
        GT3_TXUSERRDY_IN                =>      '0',
        ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
        GT3_TXUSRCLK_IN                 =>      UsrClk,
        GT3_TXUSRCLK2_IN                =>      UsrClk,
        --------------- Transmit Ports - TX Configurable Driver Ports --------------
        GT3_TXDIFFCTRL_IN               =>      txdiffctrl(3),
        ------------------ Transmit Ports - TX Data Path interface -----------------
        GT3_TXDATA_IN                   =>      TXDATA(3),
        ---------------- Transmit Ports - TX Driver and OOB signaling --------------
        GT3_GTXTXN_OUT                  =>      TXN(3),
        GT3_GTXTXP_OUT                  =>      TXP(3),
        ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
        GT3_TXOUTCLK_OUT                =>      txoutclk(3),
        GT3_TXOUTCLKFABRIC_OUT          =>      open,
        GT3_TXOUTCLKPCS_OUT             =>      open,
        --------------------- Transmit Ports - TX Gearbox Ports --------------------
        GT3_TXCHARISK_IN                =>      txcharisk(3),
        ------------- Transmit Ports - TX Initialization and Reset Ports -----------
        GT3_TXRESETDONE_OUT             =>      txresetdone(3),
        ------------------ Transmit Ports - pattern Generator Ports ----------------
        GT3_TXPRBSSEL_IN                =>      txprbssel(3),
 
        --_____________________________________________________________________
        --_____________________________________________________________________
        --GT4  (X1Y4)

        ---------------------------- Channel - DRP Ports  --------------------------
        GT4_DRPADDR_IN                  =>      (others => '0'),
        GT4_DRPCLK_IN                   =>      DRPclk,
        GT4_DRPDI_IN                    =>      (others => '0'),
        GT4_DRPDO_OUT                   =>      open,
        GT4_DRPEN_IN                    =>      '0',
        GT4_DRPRDY_OUT                  =>      open,
        GT4_DRPWE_IN                    =>      '0',
        ------------------------------- Loopback Ports -----------------------------
        GT4_LOOPBACK_IN                 =>      "00" & loop0(4),
        --------------------- RX Initialization and Reset Ports --------------------
        GT4_RXUSERRDY_IN                =>      '0',
        -------------------------- RX Margin Analysis Ports ------------------------
        GT4_EYESCANDATAERROR_OUT        =>      open,
        ------------------------- Receive Ports - CDR Ports ------------------------
        GT4_RXCDRLOCK_OUT               =>      open,
        ------------------- Receive Ports - Clock Correction Ports -----------------
        GT4_RXCLKCORCNT_OUT             =>      open,
        ------------------ Receive Ports - FPGA RX Interface Ports -----------------
        GT4_RXUSRCLK_IN                 =>      UsrClk,
        GT4_RXUSRCLK2_IN                =>      UsrClk,
        ------------------ Receive Ports - FPGA RX interface Ports -----------------
        GT4_RXDATA_OUT                  =>      RXDATA(4),
        ------------------- Receive Ports - Pattern Checker Ports ------------------
        GT4_RXPRBSERR_OUT               =>      rxprbserr(4),
        GT4_RXPRBSSEL_IN                =>      rxprbssel(4),
        ------------------- Receive Ports - Pattern Checker ports ------------------
        GT4_RXPRBSCNTRESET_IN           =>      '0',
        ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
        GT4_RXDISPERR_OUT               =>      open,
        GT4_RXNOTINTABLE_OUT            =>      RXNOTINTABLE(4),
        --------------------------- Receive Ports - RX AFE -------------------------
        GT4_GTXRXP_IN                   =>      RXP(4),
        ------------------------ Receive Ports - RX AFE Ports ----------------------
        GT4_GTXRXN_IN                   =>      RXN(4),
        -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
        GT4_RXMCOMMAALIGNEN_IN          =>      rxcommaalignen(4),
        GT4_RXPCOMMAALIGNEN_IN          =>      rxcommaalignen(4),
        --------------------- Receive Ports - RX Equalizer Ports -------------------
        GT4_RXDFELPMRESET_IN            =>      '0',
        GT4_RXMONITORSEL_IN             =>      "00",
        ------------- Receive Ports - RX Initialization and Reset Ports ------------
        GT4_GTRXRESET_IN                =>      not qpll_lock_i(1),
        GT4_RXPMARESET_IN               =>      '0',
        ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
        GT4_RXCHARISCOMMA_OUT           =>      rxchariscomma(4),
        GT4_RXCHARISK_OUT               =>      rxcharisk(4),
        -------------- Receive Ports -RX Initialization and Reset Ports ------------
        GT4_RXRESETDONE_OUT             =>      rxresetdone(4),
        --------------------- TX Initialization and Reset Ports --------------------
        GT4_GTTXRESET_IN                =>      not qpll_lock_i(1),
        GT4_TXUSERRDY_IN                =>      '0',
        ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
        GT4_TXUSRCLK_IN                 =>      UsrClk,
        GT4_TXUSRCLK2_IN                =>      UsrClk,
        --------------- Transmit Ports - TX Configurable Driver Ports --------------
        GT4_TXDIFFCTRL_IN               =>      txdiffctrl(4),
        ------------------ Transmit Ports - TX Data Path interface -----------------
        GT4_TXDATA_IN                   =>      TXDATA(4),
        ---------------- Transmit Ports - TX Driver and OOB signaling --------------
        GT4_GTXTXN_OUT                  =>      TXN(4),
        GT4_GTXTXP_OUT                  =>      TXP(4),
        ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
        GT4_TXOUTCLK_OUT                =>      txoutclk(4),
        GT4_TXOUTCLKFABRIC_OUT          =>      open,
        GT4_TXOUTCLKPCS_OUT             =>      open,
        --------------------- Transmit Ports - TX Gearbox Ports --------------------
        GT4_TXCHARISK_IN                =>      txcharisk(4),
        ------------- Transmit Ports - TX Initialization and Reset Ports -----------
        GT4_TXRESETDONE_OUT             =>      txresetdone(4),
        ------------------ Transmit Ports - pattern Generator Ports ----------------
        GT4_TXPRBSSEL_IN                =>      txprbssel(4),
 
        --_____________________________________________________________________
        --_____________________________________________________________________
        --GT5  (X1Y5)

        ---------------------------- Channel - DRP Ports  --------------------------
        GT5_DRPADDR_IN                  =>      (others => '0'),
        GT5_DRPCLK_IN                   =>      DRPclk,
        GT5_DRPDI_IN                    =>      (others => '0'),
        GT5_DRPDO_OUT                   =>      open,
        GT5_DRPEN_IN                    =>      '0',
        GT5_DRPRDY_OUT                  =>      open,
        GT5_DRPWE_IN                    =>      '0',
        ------------------------------- Loopback Ports -----------------------------
        GT5_LOOPBACK_IN                 =>      "00" & loop0(5),
        --------------------- RX Initialization and Reset Ports --------------------
        GT5_RXUSERRDY_IN                =>      '0',
        -------------------------- RX Margin Analysis Ports ------------------------
        GT5_EYESCANDATAERROR_OUT        =>      open,
        ------------------------- Receive Ports - CDR Ports ------------------------
        GT5_RXCDRLOCK_OUT               =>      open,
        ------------------- Receive Ports - Clock Correction Ports -----------------
        GT5_RXCLKCORCNT_OUT             =>      open,
        ------------------ Receive Ports - FPGA RX Interface Ports -----------------
        GT5_RXUSRCLK_IN                 =>      UsrClk,
        GT5_RXUSRCLK2_IN                =>      UsrClk,
        ------------------ Receive Ports - FPGA RX interface Ports -----------------
        GT5_RXDATA_OUT                  =>      RXDATA(5),
        ------------------- Receive Ports - Pattern Checker Ports ------------------
        GT5_RXPRBSERR_OUT               =>      rxprbserr(5),
        GT5_RXPRBSSEL_IN                =>      rxprbssel(5),
        ------------------- Receive Ports - Pattern Checker ports ------------------
        GT5_RXPRBSCNTRESET_IN           =>      '0',
        ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
        GT5_RXDISPERR_OUT               =>      open,
        GT5_RXNOTINTABLE_OUT            =>      RXNOTINTABLE(5),
        --------------------------- Receive Ports - RX AFE -------------------------
        GT5_GTXRXP_IN                   =>      RXP(5),
        ------------------------ Receive Ports - RX AFE Ports ----------------------
        GT5_GTXRXN_IN                   =>      RXN(5),
        -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
        GT5_RXMCOMMAALIGNEN_IN          =>      rxcommaalignen(5),
        GT5_RXPCOMMAALIGNEN_IN          =>      rxcommaalignen(5),
        --------------------- Receive Ports - RX Equalizer Ports -------------------
        GT5_RXDFELPMRESET_IN            =>      '0',
        GT5_RXMONITORSEL_IN             =>      "00",
        ------------- Receive Ports - RX Initialization and Reset Ports ------------
        GT5_GTRXRESET_IN                =>      not qpll_lock_i(1),
        GT5_RXPMARESET_IN               =>      '0',
        ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
        GT5_RXCHARISCOMMA_OUT           =>      rxchariscomma(5),
        GT5_RXCHARISK_OUT               =>      rxcharisk(5),
        -------------- Receive Ports -RX Initialization and Reset Ports ------------
        GT5_RXRESETDONE_OUT             =>      rxresetdone(5),
        --------------------- TX Initialization and Reset Ports --------------------
        GT5_GTTXRESET_IN                =>      not qpll_lock_i(1),
        GT5_TXUSERRDY_IN                =>      '0',
        ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
        GT5_TXUSRCLK_IN                 =>      UsrClk,
        GT5_TXUSRCLK2_IN                =>      UsrClk,
        --------------- Transmit Ports - TX Configurable Driver Ports --------------
        GT5_TXDIFFCTRL_IN               =>      txdiffctrl(5),
        ------------------ Transmit Ports - TX Data Path interface -----------------
        GT5_TXDATA_IN                   =>      TXDATA(5),
        ---------------- Transmit Ports - TX Driver and OOB signaling --------------
        GT5_GTXTXN_OUT                  =>      TXN(5),
        GT5_GTXTXP_OUT                  =>      TXP(5),
        ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
        GT5_TXOUTCLK_OUT                =>      txoutclk(5),
        GT5_TXOUTCLKFABRIC_OUT          =>      open,
        GT5_TXOUTCLKPCS_OUT             =>      open,
        --------------------- Transmit Ports - TX Gearbox Ports --------------------
        GT5_TXCHARISK_IN                =>      txcharisk(5),
        ------------- Transmit Ports - TX Initialization and Reset Ports -----------
        GT5_TXRESETDONE_OUT             =>      txresetdone(5),
        ------------------ Transmit Ports - pattern Generator Ports ----------------
        GT5_TXPRBSSEL_IN                =>      txprbssel(5),
 
        --_____________________________________________________________________
        --_____________________________________________________________________
        --GT6  (X1Y6)

        ---------------------------- Channel - DRP Ports  --------------------------
        GT6_DRPADDR_IN                  =>      (others => '0'),
        GT6_DRPCLK_IN                   =>      DRPclk,
        GT6_DRPDI_IN                    =>      (others => '0'),
        GT6_DRPDO_OUT                   =>      open,
        GT6_DRPEN_IN                    =>      '0',
        GT6_DRPRDY_OUT                  =>      open,
        GT6_DRPWE_IN                    =>      '0',
        ------------------------------- Loopback Ports -----------------------------
        GT6_LOOPBACK_IN                 =>      "00" & loop0(6),
        --------------------- RX Initialization and Reset Ports --------------------
        GT6_RXUSERRDY_IN                =>      '0',
        -------------------------- RX Margin Analysis Ports ------------------------
        GT6_EYESCANDATAERROR_OUT        =>      open,
        ------------------------- Receive Ports - CDR Ports ------------------------
        GT6_RXCDRLOCK_OUT               =>      open,
        ------------------- Receive Ports - Clock Correction Ports -----------------
        GT6_RXCLKCORCNT_OUT             =>      open,
        ------------------ Receive Ports - FPGA RX Interface Ports -----------------
        GT6_RXUSRCLK_IN                 =>      UsrClk,
        GT6_RXUSRCLK2_IN                =>      UsrClk,
        ------------------ Receive Ports - FPGA RX interface Ports -----------------
        GT6_RXDATA_OUT                  =>      RXDATA(6),
        ------------------- Receive Ports - Pattern Checker Ports ------------------
        GT6_RXPRBSERR_OUT               =>      rxprbserr(6),
        GT6_RXPRBSSEL_IN                =>      rxprbssel(6),
        ------------------- Receive Ports - Pattern Checker ports ------------------
        GT6_RXPRBSCNTRESET_IN           =>      '0',
        ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
        GT6_RXDISPERR_OUT               =>      open,
        GT6_RXNOTINTABLE_OUT            =>      RXNOTINTABLE(6),
        --------------------------- Receive Ports - RX AFE -------------------------
        GT6_GTXRXP_IN                   =>      RXP(6),
        ------------------------ Receive Ports - RX AFE Ports ----------------------
        GT6_GTXRXN_IN                   =>      RXN(6),
        -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
        GT6_RXMCOMMAALIGNEN_IN          =>      rxcommaalignen(6),
        GT6_RXPCOMMAALIGNEN_IN          =>      rxcommaalignen(6),
        --------------------- Receive Ports - RX Equalizer Ports -------------------
        GT6_RXDFELPMRESET_IN            =>      '0',
        GT6_RXMONITORSEL_IN             =>      "00",
        ------------- Receive Ports - RX Initialization and Reset Ports ------------
        GT6_GTRXRESET_IN                =>      not qpll_lock_i(1),
        GT6_RXPMARESET_IN               =>      '0',
        ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
        GT6_RXCHARISCOMMA_OUT           =>      rxchariscomma(6),
        GT6_RXCHARISK_OUT               =>      rxcharisk(6),
        -------------- Receive Ports -RX Initialization and Reset Ports ------------
        GT6_RXRESETDONE_OUT             =>      rxresetdone(6),
        --------------------- TX Initialization and Reset Ports --------------------
        GT6_GTTXRESET_IN                =>      not qpll_lock_i(1),
        GT6_TXUSERRDY_IN                =>      '0',
        ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
        GT6_TXUSRCLK_IN                 =>      UsrClk,
        GT6_TXUSRCLK2_IN                =>      UsrClk,
        --------------- Transmit Ports - TX Configurable Driver Ports --------------
        GT6_TXDIFFCTRL_IN               =>      txdiffctrl(6),
        ------------------ Transmit Ports - TX Data Path interface -----------------
        GT6_TXDATA_IN                   =>      TXDATA(6),
        ---------------- Transmit Ports - TX Driver and OOB signaling --------------
        GT6_GTXTXN_OUT                  =>      TXN(6),
        GT6_GTXTXP_OUT                  =>      TXP(6),
        ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
        GT6_TXOUTCLK_OUT                =>      txoutclk(6),
        GT6_TXOUTCLKFABRIC_OUT          =>      open,
        GT6_TXOUTCLKPCS_OUT             =>      open,
        --------------------- Transmit Ports - TX Gearbox Ports --------------------
        GT6_TXCHARISK_IN                =>      txcharisk(6),
        ------------- Transmit Ports - TX Initialization and Reset Ports -----------
        GT6_TXRESETDONE_OUT             =>      txresetdone(6),
        ------------------ Transmit Ports - pattern Generator Ports ----------------
        GT6_TXPRBSSEL_IN                =>      txprbssel(6),
 
        --_____________________________________________________________________
        --_____________________________________________________________________
        --GT7  (X1Y7)

        ---------------------------- Channel - DRP Ports  --------------------------
        GT7_DRPADDR_IN                  =>      (others => '0'),
        GT7_DRPCLK_IN                   =>      DRPclk,
        GT7_DRPDI_IN                    =>      (others => '0'),
        GT7_DRPDO_OUT                   =>      open,
        GT7_DRPEN_IN                    =>      '0',
        GT7_DRPRDY_OUT                  =>      open,
        GT7_DRPWE_IN                    =>      '0',
        ------------------------------- Loopback Ports -----------------------------
        GT7_LOOPBACK_IN                 =>      "00" & loop0(7),
        --------------------- RX Initialization and Reset Ports --------------------
        GT7_RXUSERRDY_IN                =>      '0',
        -------------------------- RX Margin Analysis Ports ------------------------
        GT7_EYESCANDATAERROR_OUT        =>      open,
        ------------------------- Receive Ports - CDR Ports ------------------------
        GT7_RXCDRLOCK_OUT               =>      open,
        ------------------- Receive Ports - Clock Correction Ports -----------------
        GT7_RXCLKCORCNT_OUT             =>      open,
        ------------------ Receive Ports - FPGA RX Interface Ports -----------------
        GT7_RXUSRCLK_IN                 =>      UsrClk,
        GT7_RXUSRCLK2_IN                =>      UsrClk,
        ------------------ Receive Ports - FPGA RX interface Ports -----------------
        GT7_RXDATA_OUT                  =>      RXDATA(7),
        ------------------- Receive Ports - Pattern Checker Ports ------------------
        GT7_RXPRBSERR_OUT               =>      rxprbserr(7),
        GT7_RXPRBSSEL_IN                =>      rxprbssel(7),
        ------------------- Receive Ports - Pattern Checker ports ------------------
        GT7_RXPRBSCNTRESET_IN           =>      '0',
        ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
        GT7_RXDISPERR_OUT               =>      open,
        GT7_RXNOTINTABLE_OUT            =>      RXNOTINTABLE(7),
        --------------------------- Receive Ports - RX AFE -------------------------
        GT7_GTXRXP_IN                   =>      RXP(7),
        ------------------------ Receive Ports - RX AFE Ports ----------------------
        GT7_GTXRXN_IN                   =>      RXN(7),
        -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
        GT7_RXMCOMMAALIGNEN_IN          =>      rxcommaalignen(7),
        GT7_RXPCOMMAALIGNEN_IN          =>      rxcommaalignen(7),
        --------------------- Receive Ports - RX Equalizer Ports -------------------
        GT7_RXDFELPMRESET_IN            =>      '0',
        GT7_RXMONITORSEL_IN             =>      "00",
        ------------- Receive Ports - RX Initialization and Reset Ports ------------
        GT7_GTRXRESET_IN                =>      not qpll_lock_i(1),
        GT7_RXPMARESET_IN               =>      '0',
        ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
        GT7_RXCHARISCOMMA_OUT           =>      rxchariscomma(7),
        GT7_RXCHARISK_OUT               =>      rxcharisk(7),
        -------------- Receive Ports -RX Initialization and Reset Ports ------------
        GT7_RXRESETDONE_OUT             =>      rxresetdone(7),
        --------------------- TX Initialization and Reset Ports --------------------
        GT7_GTTXRESET_IN                =>      not qpll_lock_i(1),
        GT7_TXUSERRDY_IN                =>      '0',
        ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
        GT7_TXUSRCLK_IN                 =>      UsrClk,
        GT7_TXUSRCLK2_IN                =>      UsrClk,
        --------------- Transmit Ports - TX Configurable Driver Ports --------------
        GT7_TXDIFFCTRL_IN               =>      txdiffctrl(7),
        ------------------ Transmit Ports - TX Data Path interface -----------------
        GT7_TXDATA_IN                   =>      TXDATA(7),
        ---------------- Transmit Ports - TX Driver and OOB signaling --------------
        GT7_GTXTXN_OUT                  =>      TXN(7),
        GT7_GTXTXP_OUT                  =>      TXP(7),
        ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
        GT7_TXOUTCLK_OUT                =>      txoutclk(7),
        GT7_TXOUTCLKFABRIC_OUT          =>      open,
        GT7_TXOUTCLKPCS_OUT             =>      open,
        --------------------- Transmit Ports - TX Gearbox Ports --------------------
        GT7_TXCHARISK_IN                =>      txcharisk(7),
        ------------- Transmit Ports - TX Initialization and Reset Ports -----------
        GT7_TXRESETDONE_OUT             =>      txresetdone(7),
        ------------------ Transmit Ports - pattern Generator Ports ----------------
        GT7_TXPRBSSEL_IN                =>      txprbssel(7),
 
        --_____________________________________________________________________
        --_____________________________________________________________________
        --GT8  (X1Y8)

        ---------------------------- Channel - DRP Ports  --------------------------
        GT8_DRPADDR_IN                  =>      (others => '0'),
        GT8_DRPCLK_IN                   =>      DRPclk,
        GT8_DRPDI_IN                    =>      (others => '0'),
        GT8_DRPDO_OUT                   =>      open,
        GT8_DRPEN_IN                    =>      '0',
        GT8_DRPRDY_OUT                  =>      open,
        GT8_DRPWE_IN                    =>      '0',
        ------------------------------- Loopback Ports -----------------------------
        GT8_LOOPBACK_IN                 =>      "00" & loop0(8),
        --------------------- RX Initialization and Reset Ports --------------------
        GT8_RXUSERRDY_IN                =>      '0',
        -------------------------- RX Margin Analysis Ports ------------------------
        GT8_EYESCANDATAERROR_OUT        =>      open,
        ------------------------- Receive Ports - CDR Ports ------------------------
        GT8_RXCDRLOCK_OUT               =>      open,
        ------------------- Receive Ports - Clock Correction Ports -----------------
        GT8_RXCLKCORCNT_OUT             =>      open,
        ------------------ Receive Ports - FPGA RX Interface Ports -----------------
        GT8_RXUSRCLK_IN                 =>      UsrClk,
        GT8_RXUSRCLK2_IN                =>      UsrClk,
        ------------------ Receive Ports - FPGA RX interface Ports -----------------
        GT8_RXDATA_OUT                  =>      RXDATA(8),
        ------------------- Receive Ports - Pattern Checker Ports ------------------
        GT8_RXPRBSERR_OUT               =>      rxprbserr(8),
        GT8_RXPRBSSEL_IN                =>      rxprbssel(8),
        ------------------- Receive Ports - Pattern Checker ports ------------------
        GT8_RXPRBSCNTRESET_IN           =>      '0',
        ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
        GT8_RXDISPERR_OUT               =>      open,
        GT8_RXNOTINTABLE_OUT            =>      RXNOTINTABLE(8),
        --------------------------- Receive Ports - RX AFE -------------------------
        GT8_GTXRXP_IN                   =>      RXP(8),
        ------------------------ Receive Ports - RX AFE Ports ----------------------
        GT8_GTXRXN_IN                   =>      RXN(8),
        -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
        GT8_RXMCOMMAALIGNEN_IN          =>      rxcommaalignen(8),
        GT8_RXPCOMMAALIGNEN_IN          =>      rxcommaalignen(8),
        --------------------- Receive Ports - RX Equalizer Ports -------------------
        GT8_RXDFELPMRESET_IN            =>      '0',
        GT8_RXMONITORSEL_IN             =>      "00",
        ------------- Receive Ports - RX Initialization and Reset Ports ------------
        GT8_GTRXRESET_IN                =>      not qpll_lock_i(2),
        GT8_RXPMARESET_IN               =>      '0',
        ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
        GT8_RXCHARISCOMMA_OUT           =>      rxchariscomma(8),
        GT8_RXCHARISK_OUT               =>      rxcharisk(8),
        -------------- Receive Ports -RX Initialization and Reset Ports ------------
        GT8_RXRESETDONE_OUT             =>      rxresetdone(8),
        --------------------- TX Initialization and Reset Ports --------------------
        GT8_GTTXRESET_IN                =>      not qpll_lock_i(2),
        GT8_TXUSERRDY_IN                =>      '0',
        ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
        GT8_TXUSRCLK_IN                 =>      UsrClk,
        GT8_TXUSRCLK2_IN                =>      UsrClk,
        --------------- Transmit Ports - TX Configurable Driver Ports --------------
        GT8_TXDIFFCTRL_IN               =>      txdiffctrl(8),
        ------------------ Transmit Ports - TX Data Path interface -----------------
        GT8_TXDATA_IN                   =>      TXDATA(8),
        ---------------- Transmit Ports - TX Driver and OOB signaling --------------
        GT8_GTXTXN_OUT                  =>      TXN(8),
        GT8_GTXTXP_OUT                  =>      TXP(8),
        ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
        GT8_TXOUTCLK_OUT                =>      txoutclk(8),
        GT8_TXOUTCLKFABRIC_OUT          =>      open,
        GT8_TXOUTCLKPCS_OUT             =>      open,
        --------------------- Transmit Ports - TX Gearbox Ports --------------------
        GT8_TXCHARISK_IN                =>      txcharisk(8),
        ------------- Transmit Ports - TX Initialization and Reset Ports -----------
        GT8_TXRESETDONE_OUT             =>      txresetdone(8),
        ------------------ Transmit Ports - pattern Generator Ports ----------------
        GT8_TXPRBSSEL_IN                =>      txprbssel(8),
 
        --_____________________________________________________________________
        --_____________________________________________________________________
        --GT9  (X1Y9)

        ---------------------------- Channel - DRP Ports  --------------------------
        GT9_DRPADDR_IN                  =>      (others => '0'),
        GT9_DRPCLK_IN                   =>      DRPclk,
        GT9_DRPDI_IN                    =>      (others => '0'),
        GT9_DRPDO_OUT                   =>      open,
        GT9_DRPEN_IN                    =>      '0',
        GT9_DRPRDY_OUT                  =>      open,
        GT9_DRPWE_IN                    =>      '0',
        ------------------------------- Loopback Ports -----------------------------
        GT9_LOOPBACK_IN                 =>      "00" & loop0(9),
        --------------------- RX Initialization and Reset Ports --------------------
        GT9_RXUSERRDY_IN                =>      '0',
        -------------------------- RX Margin Analysis Ports ------------------------
        GT9_EYESCANDATAERROR_OUT        =>      open,
        ------------------------- Receive Ports - CDR Ports ------------------------
        GT9_RXCDRLOCK_OUT               =>      open,
        ------------------- Receive Ports - Clock Correction Ports -----------------
        GT9_RXCLKCORCNT_OUT             =>      open,
        ------------------ Receive Ports - FPGA RX Interface Ports -----------------
        GT9_RXUSRCLK_IN                 =>      UsrClk,
        GT9_RXUSRCLK2_IN                =>      UsrClk,
        ------------------ Receive Ports - FPGA RX interface Ports -----------------
        GT9_RXDATA_OUT                  =>      RXDATA(9),
        ------------------- Receive Ports - Pattern Checker Ports ------------------
        GT9_RXPRBSERR_OUT               =>      rxprbserr(9),
        GT9_RXPRBSSEL_IN                =>      rxprbssel(9),
        ------------------- Receive Ports - Pattern Checker ports ------------------
        GT9_RXPRBSCNTRESET_IN           =>      '0',
        ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
        GT9_RXDISPERR_OUT               =>      open,
        GT9_RXNOTINTABLE_OUT            =>      RXNOTINTABLE(9),
        --------------------------- Receive Ports - RX AFE -------------------------
        GT9_GTXRXP_IN                   =>      RXP(9),
        ------------------------ Receive Ports - RX AFE Ports ----------------------
        GT9_GTXRXN_IN                   =>      RXN(9),
        -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
        GT9_RXMCOMMAALIGNEN_IN          =>      rxcommaalignen(9),
        GT9_RXPCOMMAALIGNEN_IN          =>      rxcommaalignen(9),
        --------------------- Receive Ports - RX Equalizer Ports -------------------
        GT9_RXDFELPMRESET_IN            =>      '0',
        GT9_RXMONITORSEL_IN             =>      "00",
        ------------- Receive Ports - RX Initialization and Reset Ports ------------
        GT9_GTRXRESET_IN                =>      not qpll_lock_i(2),
        GT9_RXPMARESET_IN               =>      '0',
        ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
        GT9_RXCHARISCOMMA_OUT           =>      rxchariscomma(9),
        GT9_RXCHARISK_OUT               =>      rxcharisk(9),
        -------------- Receive Ports -RX Initialization and Reset Ports ------------
        GT9_RXRESETDONE_OUT             =>      rxresetdone(9),
        --------------------- TX Initialization and Reset Ports --------------------
        GT9_GTTXRESET_IN                =>      not qpll_lock_i(2),
        GT9_TXUSERRDY_IN                =>      '0',
        ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
        GT9_TXUSRCLK_IN                 =>      UsrClk,
        GT9_TXUSRCLK2_IN                =>      UsrClk,
        --------------- Transmit Ports - TX Configurable Driver Ports --------------
        GT9_TXDIFFCTRL_IN               =>      txdiffctrl(9),
        ------------------ Transmit Ports - TX Data Path interface -----------------
        GT9_TXDATA_IN                   =>      TXDATA(9),
        ---------------- Transmit Ports - TX Driver and OOB signaling --------------
        GT9_GTXTXN_OUT                  =>      TXN(9),
        GT9_GTXTXP_OUT                  =>      TXP(9),
        ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
        GT9_TXOUTCLK_OUT                =>      txoutclk(9),
        GT9_TXOUTCLKFABRIC_OUT          =>      open,
        GT9_TXOUTCLKPCS_OUT             =>      open,
        --------------------- Transmit Ports - TX Gearbox Ports --------------------
        GT9_TXCHARISK_IN                =>      txcharisk(9),
        ------------- Transmit Ports - TX Initialization and Reset Ports -----------
        GT9_TXRESETDONE_OUT             =>      txresetdone(9),
        ------------------ Transmit Ports - pattern Generator Ports ----------------
        GT9_TXPRBSSEL_IN                =>      txprbssel(9),
 
        --_____________________________________________________________________
        --_____________________________________________________________________
        --GT10  (X1Y10)

        ---------------------------- Channel - DRP Ports  --------------------------
        GT10_DRPADDR_IN                  =>      (others => '0'),
        GT10_DRPCLK_IN                   =>      DRPclk,
        GT10_DRPDI_IN                    =>      (others => '0'),
        GT10_DRPDO_OUT                   =>      open,
        GT10_DRPEN_IN                    =>      '0',
        GT10_DRPRDY_OUT                  =>      open,
        GT10_DRPWE_IN                    =>      '0',
        ------------------------------- Loopback Ports -----------------------------
        GT10_LOOPBACK_IN                 =>      "00" & loop0(10),
        --------------------- RX Initialization and Reset Ports --------------------
        GT10_RXUSERRDY_IN                =>      '0',
        -------------------------- RX Margin Analysis Ports ------------------------
        GT10_EYESCANDATAERROR_OUT        =>      open,
        ------------------------- Receive Ports - CDR Ports ------------------------
        GT10_RXCDRLOCK_OUT               =>      open,
        ------------------- Receive Ports - Clock Correction Ports -----------------
        GT10_RXCLKCORCNT_OUT             =>      open,
        ------------------ Receive Ports - FPGA RX Interface Ports -----------------
        GT10_RXUSRCLK_IN                 =>      UsrClk,
        GT10_RXUSRCLK2_IN                =>      UsrClk,
        ------------------ Receive Ports - FPGA RX interface Ports -----------------
        GT10_RXDATA_OUT                  =>      RXDATA(10),
        ------------------- Receive Ports - Pattern Checker Ports ------------------
        GT10_RXPRBSERR_OUT               =>      rxprbserr(10),
        GT10_RXPRBSSEL_IN                =>      rxprbssel(10),
        ------------------- Receive Ports - Pattern Checker ports ------------------
        GT10_RXPRBSCNTRESET_IN           =>      '0',
        ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
        GT10_RXDISPERR_OUT               =>      open,
        GT10_RXNOTINTABLE_OUT            =>      RXNOTINTABLE(10),
        --------------------------- Receive Ports - RX AFE -------------------------
        GT10_GTXRXP_IN                   =>      RXP(10),
        ------------------------ Receive Ports - RX AFE Ports ----------------------
        GT10_GTXRXN_IN                   =>      RXN(10),
        -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
        GT10_RXMCOMMAALIGNEN_IN          =>      rxcommaalignen(10),
        GT10_RXPCOMMAALIGNEN_IN          =>      rxcommaalignen(10),
        --------------------- Receive Ports - RX Equalizer Ports -------------------
        GT10_RXDFELPMRESET_IN            =>      '0',
        GT10_RXMONITORSEL_IN             =>      "00",
        ------------- Receive Ports - RX Initialization and Reset Ports ------------
        GT10_GTRXRESET_IN                =>      not qpll_lock_i(2),
        GT10_RXPMARESET_IN               =>      '0',
        ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
        GT10_RXCHARISCOMMA_OUT           =>      rxchariscomma(10),
        GT10_RXCHARISK_OUT               =>      rxcharisk(10),
        -------------- Receive Ports -RX Initialization and Reset Ports ------------
        GT10_RXRESETDONE_OUT             =>      rxresetdone(10),
        --------------------- TX Initialization and Reset Ports --------------------
        GT10_GTTXRESET_IN                =>      not qpll_lock_i(2),
        GT10_TXUSERRDY_IN                =>      '0',
        ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
        GT10_TXUSRCLK_IN                 =>      UsrClk,
        GT10_TXUSRCLK2_IN                =>      UsrClk,
        --------------- Transmit Ports - TX Configurable Driver Ports --------------
        GT10_TXDIFFCTRL_IN               =>      txdiffctrl(10),
        ------------------ Transmit Ports - TX Data Path interface -----------------
        GT10_TXDATA_IN                   =>      TXDATA(10),
        ---------------- Transmit Ports - TX Driver and OOB signaling --------------
        GT10_GTXTXN_OUT                  =>      TXN(10),
        GT10_GTXTXP_OUT                  =>      TXP(10),
        ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
        GT10_TXOUTCLK_OUT                =>      txoutclk(10),
        GT10_TXOUTCLKFABRIC_OUT          =>      open,
        GT10_TXOUTCLKPCS_OUT             =>      open,
        --------------------- Transmit Ports - TX Gearbox Ports --------------------
        GT10_TXCHARISK_IN                =>      txcharisk(10),
        ------------- Transmit Ports - TX Initialization and Reset Ports -----------
        GT10_TXRESETDONE_OUT             =>      txresetdone(10),
        ------------------ Transmit Ports - pattern Generator Ports ----------------
        GT10_TXPRBSSEL_IN                =>      txprbssel(10),
 
        --_____________________________________________________________________
        --_____________________________________________________________________
        --GT11  (X1Y11)

        ---------------------------- Channel - DRP Ports  --------------------------
        GT11_DRPADDR_IN                  =>      (others => '0'),
        GT11_DRPCLK_IN                   =>      DRPclk,
        GT11_DRPDI_IN                    =>      (others => '0'),
        GT11_DRPDO_OUT                   =>      open,
        GT11_DRPEN_IN                    =>      '0',
        GT11_DRPRDY_OUT                  =>      open,
        GT11_DRPWE_IN                    =>      '0',
        ------------------------------- Loopback Ports -----------------------------
        GT11_LOOPBACK_IN                 =>      "00" & loop0(11),
        --------------------- RX Initialization and Reset Ports --------------------
        GT11_RXUSERRDY_IN                =>      '0',
        -------------------------- RX Margin Analysis Ports ------------------------
        GT11_EYESCANDATAERROR_OUT        =>      open,
        ------------------------- Receive Ports - CDR Ports ------------------------
        GT11_RXCDRLOCK_OUT               =>      open,
        ------------------- Receive Ports - Clock Correction Ports -----------------
        GT11_RXCLKCORCNT_OUT             =>      open,
        ------------------ Receive Ports - FPGA RX Interface Ports -----------------
        GT11_RXUSRCLK_IN                 =>      UsrClk,
        GT11_RXUSRCLK2_IN                =>      UsrClk,
        ------------------ Receive Ports - FPGA RX interface Ports -----------------
        GT11_RXDATA_OUT                  =>      RXDATA(11),
        ------------------- Receive Ports - Pattern Checker Ports ------------------
        GT11_RXPRBSERR_OUT               =>      rxprbserr(11),
        GT11_RXPRBSSEL_IN                =>      rxprbssel(11),
        ------------------- Receive Ports - Pattern Checker ports ------------------
        GT11_RXPRBSCNTRESET_IN           =>      '0',
        ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
        GT11_RXDISPERR_OUT               =>      open,
        GT11_RXNOTINTABLE_OUT            =>      RXNOTINTABLE(11),
        --------------------------- Receive Ports - RX AFE -------------------------
        GT11_GTXRXP_IN                   =>      RXP(11),
        ------------------------ Receive Ports - RX AFE Ports ----------------------
        GT11_GTXRXN_IN                   =>      RXN(11),
        -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
        GT11_RXMCOMMAALIGNEN_IN          =>      rxcommaalignen(11),
        GT11_RXPCOMMAALIGNEN_IN          =>      rxcommaalignen(11),
        --------------------- Receive Ports - RX Equalizer Ports -------------------
        GT11_RXDFELPMRESET_IN            =>      '0',
        GT11_RXMONITORSEL_IN             =>      "00",
        ------------- Receive Ports - RX Initialization and Reset Ports ------------
        GT11_GTRXRESET_IN                =>      not qpll_lock_i(2),
        GT11_RXPMARESET_IN               =>      '0',
        ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
        GT11_RXCHARISCOMMA_OUT           =>      rxchariscomma(11),
        GT11_RXCHARISK_OUT               =>      rxcharisk(11),
        -------------- Receive Ports -RX Initialization and Reset Ports ------------
        GT11_RXRESETDONE_OUT             =>      rxresetdone(11),
        --------------------- TX Initialization and Reset Ports --------------------
        GT11_GTTXRESET_IN                =>      not qpll_lock_i(2),
        GT11_TXUSERRDY_IN                =>      '0',
        ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
        GT11_TXUSRCLK_IN                 =>      UsrClk,
        GT11_TXUSRCLK2_IN                =>      UsrClk,
        --------------- Transmit Ports - TX Configurable Driver Ports --------------
        GT11_TXDIFFCTRL_IN               =>      txdiffctrl(11),
        ------------------ Transmit Ports - TX Data Path interface -----------------
        GT11_TXDATA_IN                   =>      TXDATA(11),
        ---------------- Transmit Ports - TX Driver and OOB signaling --------------
        GT11_GTXTXN_OUT                  =>      TXN(11),
        GT11_GTXTXP_OUT                  =>      TXP(11),
        ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
        GT11_TXOUTCLK_OUT                =>      txoutclk(11),
        GT11_TXOUTCLKFABRIC_OUT          =>      open,
        GT11_TXOUTCLKPCS_OUT             =>      open,
        --------------------- Transmit Ports - TX Gearbox Ports --------------------
        GT11_TXCHARISK_IN                =>      txcharisk(11),
        ------------- Transmit Ports - TX Initialization and Reset Ports -----------
        GT11_TXRESETDONE_OUT             =>      txresetdone(11),
        ------------------ Transmit Ports - pattern Generator Ports ----------------
        GT11_TXPRBSSEL_IN                =>      txprbssel(11),

    --____________________________COMMON PORTS________________________________
        ---------------------- Common Block  - Ref Clock Ports ---------------------
        GT0_GTREFCLK0_COMMON_IN         =>      AMC_REFCLK,
        ------------------------- Common Block - QPLL Ports ------------------------
        GT0_QPLLLOCK_OUT                =>      qpll_lock_i(0),
        GT0_QPLLLOCKDETCLK_IN           =>      DRPclk,
        GT0_QPLLRESET_IN                =>      '0',


    --____________________________COMMON PORTS________________________________
        ---------------------- Common Block  - Ref Clock Ports ---------------------
        GT1_GTREFCLK0_COMMON_IN         =>      AMC_REFCLK,
        ------------------------- Common Block - QPLL Ports ------------------------
        GT1_QPLLLOCK_OUT                =>      qpll_lock_i(1),
        GT1_QPLLLOCKDETCLK_IN           =>      DRPclk,
        GT1_QPLLRESET_IN                =>      '0',


    --____________________________COMMON PORTS________________________________
        ---------------------- Common Block  - Ref Clock Ports ---------------------
        GT2_GTREFCLK0_COMMON_IN         =>      AMC_REFCLK,
        ------------------------- Common Block - QPLL Ports ------------------------
        GT2_QPLLLOCK_OUT                =>      qpll_lock_i(2),
        GT2_QPLLLOCKDETCLK_IN           =>      DRPclk,
        GT2_QPLLRESET_IN                =>      '0'

    );


end Behavioral;

