----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    10:36:54 01/16/2013 
-- Design Name: 
-- Module Name:    SFP_if - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
use IEEE.std_logic_misc.all;
use work.ipbus.ALL;
use work.amc13_pack.all;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
library UNISIM;
use UNISIM.VComponents.all;

entity SFP_if is
    Port ( DRPclk : in  STD_LOGIC; -- 50MHz clock
           reset : in  STD_LOGIC;
           rstCntr : in  STD_LOGIC;
           test : in  STD_LOGIC;
           REFCLK2X_OUT : out  STD_LOGIC;
-- SFP ports
           SFP0_RXN : in  STD_LOGIC;
           SFP0_RXP : in  STD_LOGIC;
           SFP1_RXN : in  STD_LOGIC;
           SFP1_RXP : in  STD_LOGIC;
           SFP2_RXN : in  STD_LOGIC;
           SFP2_RXP : in  STD_LOGIC;
           SFP0_TXN : out  STD_LOGIC;
           SFP0_TXP : out  STD_LOGIC;
           SFP1_TXN : out  STD_LOGIC;
           SFP1_TXP : out  STD_LOGIC;
           SFP2_TXN : out  STD_LOGIC;
           SFP2_TXP : out  STD_LOGIC;
           SFP_REFCLK_N : in  STD_LOGIC;
           SFP_REFCLK_P : in  STD_LOGIC;
--
					 SFP0_CLIENTEMACTXD : IN std_logic_vector(31 downto 0);
					 SFP0_CLIENTEMACTXDBYTECNT : IN std_logic_vector(1 downto 0);
					 SFP0_CLIENTEMACTXDVLD : IN std_logic;
					 SFP0_CLIENTEMACTXUNDERRUN : IN std_logic;
					 SFP0_EMACCLIENTRXD : OUT std_logic_vector(31 downto 0);
					 SFP0_EMACCLIENTRXDVLD : OUT std_logic;
					 SFP0_EMACCLIENTRXDBYTECNT : OUT std_logic_vector(1 downto 0);
					 SFP0_EMACCLIENTRXGOODFRAME : OUT std_logic;
					 SFP0_EMACCLIENTRXBADFRAME : OUT std_logic;
					 SFP0_EMACCLIENTTXACK : OUT std_logic;
					 SFP1_CLIENTEMACTXD : IN std_logic_vector(31 downto 0);
					 SFP1_CLIENTEMACTXDBYTECNT : IN std_logic_vector(1 downto 0);
					 SFP1_CLIENTEMACTXDVLD : IN std_logic;
					 SFP1_CLIENTEMACTXUNDERRUN : IN std_logic;
					 SFP1_EMACCLIENTRXD : OUT std_logic_vector(31 downto 0);
					 SFP1_EMACCLIENTRXDVLD : OUT std_logic;
					 SFP1_EMACCLIENTRXDBYTECNT : OUT std_logic_vector(1 downto 0);
					 SFP1_EMACCLIENTRXGOODFRAME : OUT std_logic;
					 SFP1_EMACCLIENTRXBADFRAME : OUT std_logic;
					 SFP1_EMACCLIENTTXACK : OUT std_logic;
					 SFP2_CLIENTEMACTXD : IN std_logic_vector(31 downto 0);
					 SFP2_CLIENTEMACTXDBYTECNT : IN std_logic_vector(1 downto 0);
					 SFP2_CLIENTEMACTXDVLD : IN std_logic;
					 SFP2_CLIENTEMACTXUNDERRUN : IN std_logic;
					 SFP2_EMACCLIENTRXD : OUT std_logic_vector(31 downto 0);
					 SFP2_EMACCLIENTRXDVLD : OUT std_logic;
					 SFP2_EMACCLIENTRXDBYTECNT : OUT std_logic_vector(1 downto 0);
					 SFP2_EMACCLIENTRXGOODFRAME : OUT std_logic;
					 SFP2_EMACCLIENTRXBADFRAME : OUT std_logic;
					 SFP2_EMACCLIENTTXACK : OUT std_logic;
--	ipbus signals
					 ipb_clk : in  STD_LOGIC;
					 ipb_write : in  STD_LOGIC;
					 ipb_strobe : in  STD_LOGIC;
					 ipb_addr	: in  STD_LOGIC_VECTOR(31 downto 0);
					 ipb_wdata : in  STD_LOGIC_VECTOR(31 downto 0);
					 ipb_rdata : out  STD_LOGIC_VECTOR(31 downto 0);
					 ipb_ack : out  STD_LOGIC
					 );
end SFP_if;

architecture Behavioral of SFP_if is
component SFP3_init
generic
(
    -- Simulation attributes
    EXAMPLE_SIM_GTRESET_SPEEDUP    : string    := "FALSE";    -- Set to 1 to speed up sim reset
    EXAMPLE_SIMULATION             : integer   := 0;          -- Set to 1 for simulation
    EXAMPLE_USE_CHIPSCOPE          : integer   := 0           -- Set to 1 to use Chipscope to drive resets

);
port
(
    SYSCLK_IN                               : in   std_logic;
    SOFT_RESET_IN                           : in   std_logic;
    DONT_RESET_ON_DATA_ERROR_IN             : in   std_logic;
    GT0_TX_FSM_RESET_DONE_OUT               : out  std_logic;
    GT0_RX_FSM_RESET_DONE_OUT               : out  std_logic;
    GT0_DATA_VALID_IN                       : in   std_logic;
    GT1_TX_FSM_RESET_DONE_OUT               : out  std_logic;
    GT1_RX_FSM_RESET_DONE_OUT               : out  std_logic;
    GT1_DATA_VALID_IN                       : in   std_logic;
    GT2_TX_FSM_RESET_DONE_OUT               : out  std_logic;
    GT2_RX_FSM_RESET_DONE_OUT               : out  std_logic;
    GT2_DATA_VALID_IN                       : in   std_logic;

    --_________________________________________________________________________
        --GT0  (X1Y12)
    --____________________________CHANNEL PORTS________________________________
    ---------------------------- Channel - DRP Ports  --------------------------
    GT0_DRPADDR_IN                          : in   std_logic_vector(8 downto 0);
    GT0_DRPCLK_IN                           : in   std_logic;
    GT0_DRPDI_IN                            : in   std_logic_vector(15 downto 0);
    GT0_DRPDO_OUT                           : out  std_logic_vector(15 downto 0);
    GT0_DRPEN_IN                            : in   std_logic;
    GT0_DRPRDY_OUT                          : out  std_logic;
    GT0_DRPWE_IN                            : in   std_logic;
    ------------------------------- Loopback Ports -----------------------------
    GT0_LOOPBACK_IN                         : in   std_logic_vector(2 downto 0);
    --------------------- RX Initialization and Reset Ports --------------------
    GT0_RXUSERRDY_IN                        : in   std_logic;
    -------------------------- RX Margin Analysis Ports ------------------------
    GT0_EYESCANDATAERROR_OUT                : out  std_logic;
    ------------------------- Receive Ports - CDR Ports ------------------------
    GT0_RXCDRLOCK_OUT                       : out  std_logic;
    ------------------ Receive Ports - FPGA RX Interface Ports -----------------
    GT0_RXUSRCLK_IN                         : in   std_logic;
    GT0_RXUSRCLK2_IN                        : in   std_logic;
    ------------------ Receive Ports - FPGA RX interface Ports -----------------
    GT0_RXDATA_OUT                          : out  std_logic_vector(31 downto 0);
    ------------------- Receive Ports - Pattern Checker Ports ------------------
    GT0_RXPRBSERR_OUT                       : out  std_logic;
    GT0_RXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
    ------------------- Receive Ports - Pattern Checker ports ------------------
    GT0_RXPRBSCNTRESET_IN                   : in   std_logic;
    --------------------------- Receive Ports - RX AFE -------------------------
    GT0_GTXRXP_IN                           : in   std_logic;
    ------------------------ Receive Ports - RX AFE Ports ----------------------
    GT0_GTXRXN_IN                           : in   std_logic;
    ------------------- Receive Ports - RX Buffer Bypass Ports -----------------
    GT0_RXBUFRESET_IN                       : in   std_logic;
    GT0_RXBUFSTATUS_OUT                     : out  std_logic_vector(2 downto 0);
    --------------- Receive Ports - RX Fabric Output Control Ports -------------
    GT0_RXOUTCLK_OUT                        : out  std_logic;
    ---------------------- Receive Ports - RX Gearbox Ports --------------------
    GT0_RXDATAVALID_OUT                     : out  std_logic;
    GT0_RXHEADER_OUT                        : out  std_logic_vector(1 downto 0);
    GT0_RXHEADERVALID_OUT                   : out  std_logic;
    --------------------- Receive Ports - RX Gearbox Ports  --------------------
    GT0_RXGEARBOXSLIP_IN                    : in   std_logic;
    ------------- Receive Ports - RX Initialization and Reset Ports ------------
    GT0_GTRXRESET_IN                        : in   std_logic;
    GT0_RXPMARESET_IN                       : in   std_logic;
    ------------------ Receive Ports - RX Margin Analysis ports ----------------
    GT0_RXLPMEN_IN                          : in   std_logic;
    -------------- Receive Ports -RX Initialization and Reset Ports ------------
    GT0_RXRESETDONE_OUT                     : out  std_logic;
    ------------------------ TX Configurable Driver Ports ----------------------
    GT0_TXPOSTCURSOR_IN                     : in   std_logic_vector(4 downto 0);
    GT0_TXPRECURSOR_IN                      : in   std_logic_vector(4 downto 0);
    --------------------- TX Initialization and Reset Ports --------------------
    GT0_GTTXRESET_IN                        : in   std_logic;
    GT0_TXUSERRDY_IN                        : in   std_logic;
    ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
    GT0_TXUSRCLK_IN                         : in   std_logic;
    GT0_TXUSRCLK2_IN                        : in   std_logic;
    --------------- Transmit Ports - TX Configurable Driver Ports --------------
    GT0_TXDIFFCTRL_IN                       : in   std_logic_vector(3 downto 0);
    GT0_TXINHIBIT_IN                        : in   std_logic;
    GT0_TXMAINCURSOR_IN                     : in   std_logic_vector(6 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    GT0_TXDATA_IN                           : in   std_logic_vector(31 downto 0);
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    GT0_GTXTXN_OUT                          : out  std_logic;
    GT0_GTXTXP_OUT                          : out  std_logic;
    ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
    GT0_TXOUTCLK_OUT                        : out  std_logic;
    GT0_TXOUTCLKFABRIC_OUT                  : out  std_logic;
    GT0_TXOUTCLKPCS_OUT                     : out  std_logic;
    --------------------- Transmit Ports - TX Gearbox Ports --------------------
    GT0_TXHEADER_IN                         : in   std_logic_vector(1 downto 0);
    GT0_TXSEQUENCE_IN                       : in   std_logic_vector(6 downto 0);
    ------------- Transmit Ports - TX Initialization and Reset Ports -----------
    GT0_TXRESETDONE_OUT                     : out  std_logic;
    ------------------ Transmit Ports - pattern Generator Ports ----------------
    GT0_TXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
   
    --_________________________________________________________________________
        --GT1  (X1Y13)
    --____________________________CHANNEL PORTS________________________________
    ---------------------------- Channel - DRP Ports  --------------------------
    GT1_DRPADDR_IN                          : in   std_logic_vector(8 downto 0);
    GT1_DRPCLK_IN                           : in   std_logic;
    GT1_DRPDI_IN                            : in   std_logic_vector(15 downto 0);
    GT1_DRPDO_OUT                           : out  std_logic_vector(15 downto 0);
    GT1_DRPEN_IN                            : in   std_logic;
    GT1_DRPRDY_OUT                          : out  std_logic;
    GT1_DRPWE_IN                            : in   std_logic;
    ------------------------------- Loopback Ports -----------------------------
    GT1_LOOPBACK_IN                         : in   std_logic_vector(2 downto 0);
    --------------------- RX Initialization and Reset Ports --------------------
    GT1_RXUSERRDY_IN                        : in   std_logic;
    -------------------------- RX Margin Analysis Ports ------------------------
    GT1_EYESCANDATAERROR_OUT                : out  std_logic;
    ------------------------- Receive Ports - CDR Ports ------------------------
    GT1_RXCDRLOCK_OUT                       : out  std_logic;
    ------------------ Receive Ports - FPGA RX Interface Ports -----------------
    GT1_RXUSRCLK_IN                         : in   std_logic;
    GT1_RXUSRCLK2_IN                        : in   std_logic;
    ------------------ Receive Ports - FPGA RX interface Ports -----------------
    GT1_RXDATA_OUT                          : out  std_logic_vector(31 downto 0);
    ------------------- Receive Ports - Pattern Checker Ports ------------------
    GT1_RXPRBSERR_OUT                       : out  std_logic;
    GT1_RXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
    ------------------- Receive Ports - Pattern Checker ports ------------------
    GT1_RXPRBSCNTRESET_IN                   : in   std_logic;
    --------------------------- Receive Ports - RX AFE -------------------------
    GT1_GTXRXP_IN                           : in   std_logic;
    ------------------------ Receive Ports - RX AFE Ports ----------------------
    GT1_GTXRXN_IN                           : in   std_logic;
    ------------------- Receive Ports - RX Buffer Bypass Ports -----------------
    GT1_RXBUFRESET_IN                       : in   std_logic;
    GT1_RXBUFSTATUS_OUT                     : out  std_logic_vector(2 downto 0);
    --------------- Receive Ports - RX Fabric Output Control Ports -------------
    GT1_RXOUTCLK_OUT                        : out  std_logic;
    ---------------------- Receive Ports - RX Gearbox Ports --------------------
    GT1_RXDATAVALID_OUT                     : out  std_logic;
    GT1_RXHEADER_OUT                        : out  std_logic_vector(1 downto 0);
    GT1_RXHEADERVALID_OUT                   : out  std_logic;
    --------------------- Receive Ports - RX Gearbox Ports  --------------------
    GT1_RXGEARBOXSLIP_IN                    : in   std_logic;
    ------------- Receive Ports - RX Initialization and Reset Ports ------------
    GT1_GTRXRESET_IN                        : in   std_logic;
    GT1_RXPMARESET_IN                       : in   std_logic;
    ------------------ Receive Ports - RX Margin Analysis ports ----------------
    GT1_RXLPMEN_IN                          : in   std_logic;
    -------------- Receive Ports -RX Initialization and Reset Ports ------------
    GT1_RXRESETDONE_OUT                     : out  std_logic;
    ------------------------ TX Configurable Driver Ports ----------------------
    GT1_TXPOSTCURSOR_IN                     : in   std_logic_vector(4 downto 0);
    GT1_TXPRECURSOR_IN                      : in   std_logic_vector(4 downto 0);
    --------------------- TX Initialization and Reset Ports --------------------
    GT1_GTTXRESET_IN                        : in   std_logic;
    GT1_TXUSERRDY_IN                        : in   std_logic;
    ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
    GT1_TXUSRCLK_IN                         : in   std_logic;
    GT1_TXUSRCLK2_IN                        : in   std_logic;
    --------------- Transmit Ports - TX Configurable Driver Ports --------------
    GT1_TXDIFFCTRL_IN                       : in   std_logic_vector(3 downto 0);
    GT1_TXINHIBIT_IN                        : in   std_logic;
    GT1_TXMAINCURSOR_IN                     : in   std_logic_vector(6 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    GT1_TXDATA_IN                           : in   std_logic_vector(31 downto 0);
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    GT1_GTXTXN_OUT                          : out  std_logic;
    GT1_GTXTXP_OUT                          : out  std_logic;
    ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
    GT1_TXOUTCLK_OUT                        : out  std_logic;
    GT1_TXOUTCLKFABRIC_OUT                  : out  std_logic;
    GT1_TXOUTCLKPCS_OUT                     : out  std_logic;
    --------------------- Transmit Ports - TX Gearbox Ports --------------------
    GT1_TXHEADER_IN                         : in   std_logic_vector(1 downto 0);
    GT1_TXSEQUENCE_IN                       : in   std_logic_vector(6 downto 0);
    ------------- Transmit Ports - TX Initialization and Reset Ports -----------
    GT1_TXRESETDONE_OUT                     : out  std_logic;
    ------------------ Transmit Ports - pattern Generator Ports ----------------
    GT1_TXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
   
    --_________________________________________________________________________
        --GT2  (X1Y14)
    --____________________________CHANNEL PORTS________________________________
    ---------------------------- Channel - DRP Ports  --------------------------
    GT2_DRPADDR_IN                          : in   std_logic_vector(8 downto 0);
    GT2_DRPCLK_IN                           : in   std_logic;
    GT2_DRPDI_IN                            : in   std_logic_vector(15 downto 0);
    GT2_DRPDO_OUT                           : out  std_logic_vector(15 downto 0);
    GT2_DRPEN_IN                            : in   std_logic;
    GT2_DRPRDY_OUT                          : out  std_logic;
    GT2_DRPWE_IN                            : in   std_logic;
    ------------------------------- Loopback Ports -----------------------------
    GT2_LOOPBACK_IN                         : in   std_logic_vector(2 downto 0);
    --------------------- RX Initialization and Reset Ports --------------------
    GT2_RXUSERRDY_IN                        : in   std_logic;
    -------------------------- RX Margin Analysis Ports ------------------------
    GT2_EYESCANDATAERROR_OUT                : out  std_logic;
    ------------------------- Receive Ports - CDR Ports ------------------------
    GT2_RXCDRLOCK_OUT                       : out  std_logic;
    ------------------ Receive Ports - FPGA RX Interface Ports -----------------
    GT2_RXUSRCLK_IN                         : in   std_logic;
    GT2_RXUSRCLK2_IN                        : in   std_logic;
    ------------------ Receive Ports - FPGA RX interface Ports -----------------
    GT2_RXDATA_OUT                          : out  std_logic_vector(31 downto 0);
    ------------------- Receive Ports - Pattern Checker Ports ------------------
    GT2_RXPRBSERR_OUT                       : out  std_logic;
    GT2_RXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
    ------------------- Receive Ports - Pattern Checker ports ------------------
    GT2_RXPRBSCNTRESET_IN                   : in   std_logic;
    --------------------------- Receive Ports - RX AFE -------------------------
    GT2_GTXRXP_IN                           : in   std_logic;
    ------------------------ Receive Ports - RX AFE Ports ----------------------
    GT2_GTXRXN_IN                           : in   std_logic;
    ------------------- Receive Ports - RX Buffer Bypass Ports -----------------
    GT2_RXBUFRESET_IN                       : in   std_logic;
    GT2_RXBUFSTATUS_OUT                     : out  std_logic_vector(2 downto 0);
    --------------- Receive Ports - RX Fabric Output Control Ports -------------
    GT2_RXOUTCLK_OUT                        : out  std_logic;
    ---------------------- Receive Ports - RX Gearbox Ports --------------------
    GT2_RXDATAVALID_OUT                     : out  std_logic;
    GT2_RXHEADER_OUT                        : out  std_logic_vector(1 downto 0);
    GT2_RXHEADERVALID_OUT                   : out  std_logic;
    --------------------- Receive Ports - RX Gearbox Ports  --------------------
    GT2_RXGEARBOXSLIP_IN                    : in   std_logic;
    ------------- Receive Ports - RX Initialization and Reset Ports ------------
    GT2_GTRXRESET_IN                        : in   std_logic;
    GT2_RXPMARESET_IN                       : in   std_logic;
    ------------------ Receive Ports - RX Margin Analysis ports ----------------
    GT2_RXLPMEN_IN                          : in   std_logic;
    -------------- Receive Ports -RX Initialization and Reset Ports ------------
    GT2_RXRESETDONE_OUT                     : out  std_logic;
    ------------------------ TX Configurable Driver Ports ----------------------
    GT2_TXPOSTCURSOR_IN                     : in   std_logic_vector(4 downto 0);
    GT2_TXPRECURSOR_IN                      : in   std_logic_vector(4 downto 0);
    --------------------- TX Initialization and Reset Ports --------------------
    GT2_GTTXRESET_IN                        : in   std_logic;
    GT2_TXUSERRDY_IN                        : in   std_logic;
    ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
    GT2_TXUSRCLK_IN                         : in   std_logic;
    GT2_TXUSRCLK2_IN                        : in   std_logic;
    --------------- Transmit Ports - TX Configurable Driver Ports --------------
    GT2_TXDIFFCTRL_IN                       : in   std_logic_vector(3 downto 0);
    GT2_TXINHIBIT_IN                        : in   std_logic;
    GT2_TXMAINCURSOR_IN                     : in   std_logic_vector(6 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    GT2_TXDATA_IN                           : in   std_logic_vector(31 downto 0);
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    GT2_GTXTXN_OUT                          : out  std_logic;
    GT2_GTXTXP_OUT                          : out  std_logic;
    ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
    GT2_TXOUTCLK_OUT                        : out  std_logic;
    GT2_TXOUTCLKFABRIC_OUT                  : out  std_logic;
    GT2_TXOUTCLKPCS_OUT                     : out  std_logic;
    --------------------- Transmit Ports - TX Gearbox Ports --------------------
    GT2_TXHEADER_IN                         : in   std_logic_vector(1 downto 0);
    GT2_TXSEQUENCE_IN                       : in   std_logic_vector(6 downto 0);
    ------------- Transmit Ports - TX Initialization and Reset Ports -----------
    GT2_TXRESETDONE_OUT                     : out  std_logic;
    ------------------ Transmit Ports - pattern Generator Ports ----------------
    GT2_TXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
   

    --____________________________COMMON PORTS________________________________
    ---------------------- Common Block  - Ref Clock Ports ---------------------
    GT0_GTREFCLK0_COMMON_IN                 : in   std_logic;
    ------------------------- Common Block - QPLL Ports ------------------------
    GT0_QPLLLOCK_OUT                        : out  std_logic;
    GT0_QPLLLOCKDETCLK_IN                   : in   std_logic;
    GT0_QPLLRESET_IN                        : in   std_logic


);
end component;
COMPONENT EMAC_GXPCS
	PORT(
		reset : IN std_logic;
		CLIENTCLK : IN std_logic;
		RXUSRCLK : IN std_logic;
		TXUSRCLK : IN std_logic;
		RX_FSM_RESET_DONE : IN std_logic;
		TX_FSM_RESET_DONE : IN std_logic;
		GTX_TX_READ : IN std_logic;
		GTX_RXD : IN std_logic_vector(31 downto 0);
		GTX_RXDVLD : IN std_logic;
		GTX_RXHEADER : IN std_logic_vector(1 downto 0);
		GTX_RXHEADERVLD : IN std_logic;
		CLIENTEMACTXD : IN std_logic_vector(31 downto 0);
		CLIENTEMACTXDBYTECNT : IN std_logic_vector(1 downto 0);
		CLIENTEMACTXDVLD : IN std_logic;
		CLIENTEMACTXUNDERRUN : IN std_logic;          
		GTX_TXD : OUT std_logic_vector(31 downto 0);
		GTX_TXHEADER : OUT std_logic_vector(1 downto 0);
		GTX_RXGEARBOXSLIP_OUT : OUT std_logic;
		GTX_RXGOOD : OUT std_logic;
		EMACCLIENTRXD : OUT std_logic_vector(31 downto 0);
		EMACCLIENTRXDVLD : OUT std_logic;
		EMACCLIENTRXDBYTECNT : OUT std_logic_vector(1 downto 0);
		EMACCLIENTRXGOODFRAME : OUT std_logic;
		EMACCLIENTRXBADFRAME : OUT std_logic;
		EMACCLIENTTXACK : OUT std_logic
		);
END COMPONENT;
signal resetSync : std_logic_vector(2 downto 0) := (others => '0');
signal refclk : std_logic := '0';
signal REFCLK2XPLLRST : std_logic := '0';
signal refclk2x_in : std_logic := '0';
signal refclk2x_dcm : std_logic := '0';
signal refclk2x : std_logic := '0';
signal clkfb : std_logic := '0';
signal SFP0_TXOUTCLK : std_logic := '0';
signal txusrclk : std_logic := '0';
--signal qpllrefclklost : std_logic := '0';
signal qplllock : std_logic := '0';
signal qpllreset : std_logic := '0';
signal GTX_TX_READ : std_logic := '0';
signal SFP0_rxoutclk : std_logic := '0';
signal SFP0_rxusrclk : std_logic := '0';
signal SFP0_txresetdone : std_logic := '0';
signal SFP0_gttxreset : std_logic := '0';
signal SFP0_txuserrdy : std_logic := '0';
signal SFP0_rxresetdone : std_logic := '0';
signal SFP0_gtrxreset : std_logic := '0';
signal SFP0_rxuserrdy : std_logic := '0';
signal SFP0_drprdy : std_logic := '0';
signal SFP0_drpen : std_logic := '0';
signal SFP0_drpwe : std_logic := '0';
signal SFP0_rxdfeagchold : std_logic := '0';
signal SFP0_adapt_done : std_logic := '0';
signal SFP0_rxmonitor : std_logic_vector(6 downto 0) := (others => '0');
signal SFP0_drpdo : std_logic_vector(15 downto 0) := (others => '0');
signal SFP0_rxmonitorsel : std_logic_vector(1 downto 0) := (others => '0');
signal SFP0_drpaddr : std_logic_vector(8 downto 0) := (others => '0');
signal SFP0_drpdi : std_logic_vector(15 downto 0) := (others => '0');
signal SFP0_RX_FSM_RESET_DONE : std_logic := '0';
signal SFP0_TX_FSM_RESET_DONE : std_logic := '0';
signal SFP0_RXDVLD : std_logic := '0';
signal SFP0_RXHEADERVLD : std_logic := '0';
signal SFP0_RXGEARBOXSLIP : std_logic := '0';
signal SFP0_RXGOOD : std_logic := '0';
signal SFP0_TXD : std_logic_vector(31 downto 0) := (others => '0');
signal SFP0_TXHEADER : std_logic_vector(1 downto 0) := (others => '0');
signal SFP0_RXD : std_logic_vector(31 downto 0) := (others => '0');
signal SFP0_RXHEADER : std_logic_vector(1 downto 0) := (others => '0');
signal SFP1_rxoutclk : std_logic := '0';
signal SFP1_rxusrclk : std_logic := '0';
signal SFP1_txresetdone : std_logic := '0';
signal SFP1_gttxreset : std_logic := '0';
signal SFP1_txuserrdy : std_logic := '0';
signal SFP1_rxresetdone : std_logic := '0';
signal SFP1_gtrxreset : std_logic := '0';
signal SFP1_rxuserrdy : std_logic := '0';
signal SFP1_drprdy : std_logic := '0';
signal SFP1_drpen : std_logic := '0';
signal SFP1_drpwe : std_logic := '0';
signal SFP1_rxdfeagchold : std_logic := '0';
signal SFP1_adapt_done : std_logic := '0';
signal SFP1_rxmonitor : std_logic_vector(6 downto 0) := (others => '0');
signal SFP1_drpdo : std_logic_vector(15 downto 0) := (others => '0');
signal SFP1_rxmonitorsel : std_logic_vector(1 downto 0) := (others => '0');
signal SFP1_drpaddr : std_logic_vector(8 downto 0) := (others => '0');
signal SFP1_drpdi : std_logic_vector(15 downto 0) := (others => '0');
signal SFP1_RX_FSM_RESET_DONE : std_logic := '0';
signal SFP1_TX_FSM_RESET_DONE : std_logic := '0';
signal SFP1_RXDVLD : std_logic := '0';
signal SFP1_RXHEADERVLD : std_logic := '0';
signal SFP1_RXGEARBOXSLIP : std_logic := '0';
signal SFP1_RXGOOD : std_logic := '0';
signal SFP1_TXD : std_logic_vector(31 downto 0) := (others => '0');
signal SFP1_TXHEADER : std_logic_vector(1 downto 0) := (others => '0');
signal SFP1_RXD : std_logic_vector(31 downto 0) := (others => '0');
signal SFP1_RXHEADER : std_logic_vector(1 downto 0) := (others => '0');
signal SFP2_rxoutclk : std_logic := '0';
signal SFP2_rxusrclk : std_logic := '0';
signal SFP2_txresetdone : std_logic := '0';
signal SFP2_gttxreset : std_logic := '0';
signal SFP2_txuserrdy : std_logic := '0';
signal SFP2_rxresetdone : std_logic := '0';
signal SFP2_gtrxreset : std_logic := '0';
signal SFP2_rxuserrdy : std_logic := '0';
signal SFP2_drprdy : std_logic := '0';
signal SFP2_drpen : std_logic := '0';
signal SFP2_drpwe : std_logic := '0';
signal SFP2_rxdfeagchold : std_logic := '0';
signal SFP2_adapt_done : std_logic := '0';
signal SFP2_rxmonitor : std_logic_vector(6 downto 0) := (others => '0');
signal SFP2_drpdo : std_logic_vector(15 downto 0) := (others => '0');
signal SFP2_rxmonitorsel : std_logic_vector(1 downto 0) := (others => '0');
signal SFP2_drpaddr : std_logic_vector(8 downto 0) := (others => '0');
signal SFP2_drpdi : std_logic_vector(15 downto 0) := (others => '0');
signal SFP2_RX_FSM_RESET_DONE : std_logic := '0';
signal SFP2_TX_FSM_RESET_DONE : std_logic := '0';
signal SFP2_RXDVLD : std_logic := '0';
signal SFP2_RXHEADERVLD : std_logic := '0';
signal SFP2_RXGEARBOXSLIP : std_logic := '0';
signal SFP2_RXGOOD : std_logic := '0';
signal SFP2_TXD : std_logic_vector(31 downto 0) := (others => '0');
signal SFP2_TXHEADER : std_logic_vector(1 downto 0) := (others => '0');
signal SFP2_RXD : std_logic_vector(31 downto 0) := (others => '0');
signal SFP2_RXHEADER : std_logic_vector(1 downto 0) := (others => '0');
signal TXSEQ_cntr : std_logic_vector(6 downto 0) := (others => '0');
signal TXSEQUENCE : std_logic_vector(6 downto 0) := (others => '0');
signal SFP0_LOOPBACK_IN : std_logic_vector(2 downto 0) := (others => '0');
signal SFP0_RXPRBSERR_OUT : std_logic := '0';
signal SFP0_RXPRBSSEL_IN : std_logic_vector(2 downto 0) := (others => '0');
signal SFP0_TXPRBSSEL_IN : std_logic_vector(2 downto 0) := (others => '0');
signal SFP0_EYESCANDATAERROR_OUT : std_logic := '0';
signal SFP1_LOOPBACK_IN : std_logic_vector(2 downto 0) := (others => '0');
signal SFP1_RXPRBSERR_OUT : std_logic := '0';
signal SFP1_RXPRBSSEL_IN : std_logic_vector(2 downto 0) := (others => '0');
signal SFP1_TXPRBSSEL_IN : std_logic_vector(2 downto 0) := (others => '0');
signal SFP1_EYESCANDATAERROR_OUT : std_logic := '0';
signal SFP2_LOOPBACK_IN : std_logic_vector(2 downto 0) := (others => '0');
signal SFP2_RXPRBSERR_OUT : std_logic := '0';
signal SFP2_RXPRBSSEL_IN : std_logic_vector(2 downto 0) := (others => '0');
signal SFP2_TXPRBSSEL_IN : std_logic_vector(2 downto 0) := (others => '0');
signal SFP2_EYESCANDATAERROR_OUT : std_logic := '0';
signal SFP0_err_cntr : std_logic_vector(15 downto 0) := (others => '0');
signal SFP1_err_cntr : std_logic_vector(15 downto 0) := (others => '0');
signal SFP2_err_cntr : std_logic_vector(15 downto 0) := (others => '0');
signal status : std_logic_vector(31 downto 0) := (others => '0');

begin
status(0) <= SFP0_txresetdone;
status(1) <= SFP0_gttxreset;
status(2) <= SFP0_txuserrdy;
status(3) <= SFP0_TX_FSM_RESET_DONE;
status(4) <= SFP0_rxresetdone;
status(5) <= SFP0_RXGOOD;
status(6) <= SFP0_RX_FSM_RESET_DONE;
status(7) <= SFP0_gtrxreset;
status(8) <= SFP0_rxuserrdy;
status(9) <= SFP0_adapt_done;
status(10) <= SFP1_txresetdone;
status(11) <= SFP1_gttxreset;
status(12) <= SFP1_txuserrdy;
status(13) <= SFP1_TX_FSM_RESET_DONE;
status(14) <= SFP1_rxresetdone;
status(15) <= SFP1_RXGOOD;
status(16) <= SFP1_RX_FSM_RESET_DONE;
status(17) <= SFP1_gtrxreset;
status(18) <= SFP1_rxuserrdy;
status(19) <= SFP1_adapt_done;
status(20) <= SFP2_txresetdone;
status(21) <= SFP2_gttxreset;
status(22) <= SFP2_txuserrdy;
status(23) <= SFP2_TX_FSM_RESET_DONE;
status(24) <= SFP2_rxresetdone;
status(25) <= SFP2_RXGOOD;
status(26) <= SFP2_RX_FSM_RESET_DONE;
status(27) <= SFP2_gtrxreset;
status(28) <= SFP2_rxuserrdy;
status(29) <= SFP2_adapt_done;
--status(30) <= qpllrefclklost;
status(31) <= qplllock;
process(REFCLK2X,reset)
begin
	if(reset = '1')then
		resetSync <= (others => '1');
	elsif(REFCLK2X'event and REFCLK2X = '1')then
		resetSync <= resetSync(1 downto 0) & '0';
	end if;
end process;
SFP0_EMAC_GXPCS: EMAC_GXPCS PORT MAP(
		reset => resetSync(2),
		CLIENTCLK => REFCLK2X,
		RXUSRCLK => SFP0_rxusrclk,
		TXUSRCLK => txusrclk,
		RX_FSM_RESET_DONE => SFP0_RX_FSM_RESET_DONE,
		TX_FSM_RESET_DONE => SFP0_TX_FSM_RESET_DONE,
		GTX_TXD => SFP0_TXD,
		GTX_TXHEADER => SFP0_TXHEADER,
		GTX_TX_READ => GTX_TX_READ,
		GTX_RXD => SFP0_RXD,
		GTX_RXDVLD => SFP0_RXDVLD,
		GTX_RXHEADER => SFP0_RXHEADER,
		GTX_RXHEADERVLD => SFP0_RXHEADERVLD,
		GTX_RXGEARBOXSLIP_OUT => SFP0_RXGEARBOXSLIP,
		GTX_RXGOOD => SFP0_RXGOOD,
		CLIENTEMACTXD => SFP0_CLIENTEMACTXD,
		CLIENTEMACTXDBYTECNT => SFP0_CLIENTEMACTXDBYTECNT,
		CLIENTEMACTXDVLD => SFP0_CLIENTEMACTXDVLD,
		CLIENTEMACTXUNDERRUN => SFP0_CLIENTEMACTXUNDERRUN,
		EMACCLIENTRXD => SFP0_EMACCLIENTRXD,
		EMACCLIENTRXDVLD => SFP0_EMACCLIENTRXDVLD,
		EMACCLIENTRXDBYTECNT => SFP0_EMACCLIENTRXDBYTECNT,
		EMACCLIENTRXGOODFRAME => SFP0_EMACCLIENTRXGOODFRAME,
		EMACCLIENTRXBADFRAME => SFP0_EMACCLIENTRXBADFRAME,
		EMACCLIENTTXACK => SFP0_EMACCLIENTTXACK
	);
SFP1_EMAC_GXPCS: EMAC_GXPCS PORT MAP(
		reset => resetSync(2),
		CLIENTCLK => REFCLK2X,
		RXUSRCLK => SFP1_rxusrclk,
		TXUSRCLK => txusrclk,
		RX_FSM_RESET_DONE => SFP1_RX_FSM_RESET_DONE,
		TX_FSM_RESET_DONE => SFP1_TX_FSM_RESET_DONE,
		GTX_TXD => SFP1_TXD,
		GTX_TXHEADER => SFP1_TXHEADER,
		GTX_TX_READ => GTX_TX_READ,
		GTX_RXD => SFP1_RXD,
		GTX_RXDVLD => SFP1_RXDVLD,
		GTX_RXHEADER => SFP1_RXHEADER,
		GTX_RXHEADERVLD => SFP1_RXHEADERVLD,
		GTX_RXGEARBOXSLIP_OUT => SFP1_RXGEARBOXSLIP,
		GTX_RXGOOD => SFP1_RXGOOD,
		CLIENTEMACTXD => SFP1_CLIENTEMACTXD,
		CLIENTEMACTXDBYTECNT => SFP1_CLIENTEMACTXDBYTECNT,
		CLIENTEMACTXDVLD => SFP1_CLIENTEMACTXDVLD,
		CLIENTEMACTXUNDERRUN => SFP1_CLIENTEMACTXUNDERRUN,
		EMACCLIENTRXD => SFP1_EMACCLIENTRXD,
		EMACCLIENTRXDVLD => SFP1_EMACCLIENTRXDVLD,
		EMACCLIENTRXDBYTECNT => SFP1_EMACCLIENTRXDBYTECNT,
		EMACCLIENTRXGOODFRAME => SFP1_EMACCLIENTRXGOODFRAME,
		EMACCLIENTRXBADFRAME => SFP1_EMACCLIENTRXBADFRAME,
		EMACCLIENTTXACK => SFP1_EMACCLIENTTXACK
	);
SFP2_EMAC_GXPCS: EMAC_GXPCS PORT MAP(
		reset => resetSync(2),
		CLIENTCLK => REFCLK2X,
		RXUSRCLK => SFP2_rxusrclk,
		TXUSRCLK => txusrclk,
		RX_FSM_RESET_DONE => SFP2_RX_FSM_RESET_DONE,
		TX_FSM_RESET_DONE => SFP2_TX_FSM_RESET_DONE,
		GTX_TXD => SFP2_TXD,
		GTX_TXHEADER => SFP2_TXHEADER,
		GTX_TX_READ => GTX_TX_READ,
		GTX_RXD => SFP2_RXD,
		GTX_RXDVLD => SFP2_RXDVLD,
		GTX_RXHEADER => SFP2_RXHEADER,
		GTX_RXHEADERVLD => SFP2_RXHEADERVLD,
		GTX_RXGEARBOXSLIP_OUT => SFP2_RXGEARBOXSLIP,
		GTX_RXGOOD => SFP2_RXGOOD,
		CLIENTEMACTXD => SFP2_CLIENTEMACTXD,
		CLIENTEMACTXDBYTECNT => SFP2_CLIENTEMACTXDBYTECNT,
		CLIENTEMACTXDVLD => SFP2_CLIENTEMACTXDVLD,
		CLIENTEMACTXUNDERRUN => SFP2_CLIENTEMACTXUNDERRUN,
		EMACCLIENTRXD => SFP2_EMACCLIENTRXD,
		EMACCLIENTRXDVLD => SFP2_EMACCLIENTRXDVLD,
		EMACCLIENTRXDBYTECNT => SFP2_EMACCLIENTRXDBYTECNT,
		EMACCLIENTRXGOODFRAME => SFP2_EMACCLIENTRXGOODFRAME,
		EMACCLIENTRXBADFRAME => SFP2_EMACCLIENTRXBADFRAME,
		EMACCLIENTTXACK => SFP2_EMACCLIENTTXACK
	);
process(txusrclk,reset)
begin
	if(reset = '1')then
		TXSEQ_cntr <= (others => '0');
	elsif(txusrclk'event and txusrclk = '1')then
		if(TXSEQ_cntr = "1000001")then
			TXSEQ_cntr <= (others => '0');
		else
			TXSEQ_cntr <= TXSEQ_cntr + 1;
		end if;
	end if;
end process;
TXSEQUENCE <= '0' & TXSEQ_cntr(6 downto 1);
GTX_TX_READ <= and_reduce(TXSEQUENCE(4 downto 0));
process(SFP0_rxusrclk,rstCntr)
begin
	if(rstCntr = '1')then
		SFP0_err_cntr <= (others => '0');
	elsif(SFP0_rxusrclk'event and SFP0_rxusrclk = '1')then
		if(SFP0_RXPRBSSEL_IN = "000")then
			SFP0_err_cntr <= (others => '0');
		elsif(SFP0_RXPRBSERR_OUT = '1')then
			SFP0_err_cntr <= SFP0_err_cntr + 1;
		end if;
	end if;
end process;
process(SFP1_rxusrclk,rstCntr)
begin
	if(rstCntr = '1')then
		SFP1_err_cntr <= (others => '0');
	elsif(SFP1_rxusrclk'event and SFP1_rxusrclk = '1')then
		if(SFP1_RXPRBSSEL_IN = "000")then
			SFP1_err_cntr <= (others => '0');
		elsif(SFP1_RXPRBSERR_OUT = '1')then
			SFP1_err_cntr <= SFP1_err_cntr + 1;
		end if;
	end if;
end process;
process(SFP2_rxusrclk,rstCntr)
begin
	if(rstCntr = '1')then
		SFP2_err_cntr <= (others => '0');
	elsif(SFP2_rxusrclk'event and SFP2_rxusrclk = '1')then
		if(SFP2_RXPRBSSEL_IN = "000")then
			SFP2_err_cntr <= (others => '0');
		elsif(SFP2_RXPRBSERR_OUT = '1')then
			SFP2_err_cntr <= SFP2_err_cntr + 1;
		end if;
	end if;
end process;
i_SFP3_init : SFP3_init
    port map
    (
        SYSCLK_IN                       =>      DRPclk,
        SOFT_RESET_IN                   =>      '0',
        DONT_RESET_ON_DATA_ERROR_IN     =>      '0',
        GT0_TX_FSM_RESET_DONE_OUT       =>      SFP0_TX_FSM_RESET_DONE,
        GT0_RX_FSM_RESET_DONE_OUT       =>      SFP0_RX_FSM_RESET_DONE,
        GT0_DATA_VALID_IN               =>      SFP0_RXGOOD,
        GT1_TX_FSM_RESET_DONE_OUT       =>      SFP1_TX_FSM_RESET_DONE,
        GT1_RX_FSM_RESET_DONE_OUT       =>      SFP1_RX_FSM_RESET_DONE,
        GT1_DATA_VALID_IN               =>      SFP1_RXGOOD,
        GT2_TX_FSM_RESET_DONE_OUT       =>      SFP2_TX_FSM_RESET_DONE,
        GT2_RX_FSM_RESET_DONE_OUT       =>      SFP2_RX_FSM_RESET_DONE,
        GT2_DATA_VALID_IN               =>      SFP2_RXGOOD,

  
 
 
 
        --_____________________________________________________________________
        --_____________________________________________________________________
        --GT0  (X1Y12)

        ---------------------------- Channel - DRP Ports  --------------------------
        GT0_DRPADDR_IN                  => SFP0_drpaddr,
        GT0_DRPCLK_IN                   => DRPclk,
        GT0_DRPDI_IN                    => SFP0_drpdi,
        GT0_DRPDO_OUT                   => SFP0_drpdo,
        GT0_DRPEN_IN                    => SFP0_drpen,
        GT0_DRPRDY_OUT                  => SFP0_drprdy,
        GT0_DRPWE_IN                    => SFP0_drpwe,
        ------------------------------- Loopback Ports -----------------------------
        GT0_LOOPBACK_IN                 => SFP0_LOOPBACK_IN,
        --------------------- RX Initialization and Reset Ports --------------------
        GT0_RXUSERRDY_IN                => SFP0_rxuserrdy,
        -------------------------- RX Margin Analysis Ports ------------------------
        GT0_EYESCANDATAERROR_OUT        => SFP0_EYESCANDATAERROR_OUT,
        ------------------------- Receive Ports - CDR Ports ------------------------
        GT0_RXCDRLOCK_OUT               =>      open,
        ------------------ Receive Ports - FPGA RX Interface Ports -----------------
        GT0_RXUSRCLK_IN                 => SFP0_RXUSRCLK,
        GT0_RXUSRCLK2_IN                => SFP0_RXUSRCLK,
        ------------------ Receive Ports - FPGA RX interface Ports -----------------
        GT0_RXDATA_OUT                  => SFP0_RXD,
        ------------------- Receive Ports - Pattern Checker Ports ------------------
        GT0_RXPRBSERR_OUT               => SFP0_RXPRBSERR_OUT,
        GT0_RXPRBSSEL_IN                => SFP0_RXPRBSSEL_IN,
        ------------------- Receive Ports - Pattern Checker ports ------------------
        GT0_RXPRBSCNTRESET_IN           =>      '0',
        --------------------------- Receive Ports - RX AFE -------------------------
        GT0_GTXRXP_IN                   => SFP0_RXP,
        ------------------------ Receive Ports - RX AFE Ports ----------------------
        GT0_GTXRXN_IN                   => SFP0_RXN,
        ------------------- Receive Ports - RX Buffer Bypass Ports -----------------
        GT0_RXBUFRESET_IN               => '0',
        GT0_RXBUFSTATUS_OUT             => open,
        --------------- Receive Ports - RX Fabric Output Control Ports -------------
        GT0_RXOUTCLK_OUT                => SFP0_rxoutclk,
        ---------------------- Receive Ports - RX Gearbox Ports --------------------
        GT0_RXDATAVALID_OUT             => SFP0_RXDVLD,
        GT0_RXHEADER_OUT                => SFP0_RXHEADER,
        GT0_RXHEADERVALID_OUT           => SFP0_RXHEADERVLD,
        --------------------- Receive Ports - RX Gearbox Ports  --------------------
        GT0_RXGEARBOXSLIP_IN            => SFP0_RXGEARBOXSLIP,
        ------------- Receive Ports - RX Initialization and Reset Ports ------------
        GT0_GTRXRESET_IN                => SFP0_gtrxreset,
        GT0_RXPMARESET_IN               => '0',
        ------------------ Receive Ports - RX Margin Analysis ports ----------------
        GT0_RXLPMEN_IN                  => '0',
        -------------- Receive Ports -RX Initialization and Reset Ports ------------
        GT0_RXRESETDONE_OUT             => SFP0_rxresetdone,
        ------------------------ TX Configurable Driver Ports ----------------------
        GT0_TXPOSTCURSOR_IN             => (others => '0'),
        GT0_TXPRECURSOR_IN              => (others => '0'),
        --------------------- TX Initialization and Reset Ports --------------------
        GT0_GTTXRESET_IN                => SFP0_gttxreset,
        GT0_TXUSERRDY_IN                => SFP0_txuserrdy,
        ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
        GT0_TXUSRCLK_IN                 => txusrclk,
        GT0_TXUSRCLK2_IN                => txusrclk,
        --------------- Transmit Ports - TX Configurable Driver Ports --------------
        GT0_TXDIFFCTRL_IN               => "1110",
        GT0_TXINHIBIT_IN                => '0',
        GT0_TXMAINCURSOR_IN             => (others => '0'),
        ------------------ Transmit Ports - TX Data Path interface -----------------
        GT0_TXDATA_IN                   => SFP0_TXD,
        ---------------- Transmit Ports - TX Driver and OOB signaling --------------
        GT0_GTXTXN_OUT                  => SFP0_TXN,
        GT0_GTXTXP_OUT                  => SFP0_TXP,
        ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
        GT0_TXOUTCLK_OUT                => SFP0_TXOUTCLK,
        GT0_TXOUTCLKFABRIC_OUT          => open,
        GT0_TXOUTCLKPCS_OUT             => open,
        --------------------- Transmit Ports - TX Gearbox Ports --------------------
        GT0_TXHEADER_IN                 => SFP0_TXHEADER,
        GT0_TXSEQUENCE_IN               => TXSEQUENCE,
        ------------- Transmit Ports - TX Initialization and Reset Ports -----------
        GT0_TXRESETDONE_OUT             => SFP0_txresetdone,
        ------------------ Transmit Ports - pattern Generator Ports ----------------
        GT0_TXPRBSSEL_IN                => SFP0_TXPRBSSEL_IN,


  
 
 
 
        --_____________________________________________________________________
        --_____________________________________________________________________
        --GT1  (X1Y13)

        ---------------------------- Channel - DRP Ports  --------------------------
        GT1_DRPADDR_IN                  => SFP1_drpaddr,
        GT1_DRPCLK_IN                   => DRPclk,
        GT1_DRPDI_IN                    => SFP1_drpdi,
        GT1_DRPDO_OUT                   => SFP1_drpdo,
        GT1_DRPEN_IN                    => SFP1_drpen,
        GT1_DRPRDY_OUT                  => SFP1_drprdy,
        GT1_DRPWE_IN                    => SFP1_drpwe,
        ------------------------------- Loopback Ports -----------------------------
        GT1_LOOPBACK_IN                 => SFP1_LOOPBACK_IN,
        --------------------- RX Initialization and Reset Ports --------------------
        GT1_RXUSERRDY_IN                => SFP1_rxuserrdy,
        -------------------------- RX Margin Analysis Ports ------------------------
        GT1_EYESCANDATAERROR_OUT        => SFP1_EYESCANDATAERROR_OUT,
        ------------------------- Receive Ports - CDR Ports ------------------------
        GT1_RXCDRLOCK_OUT               =>      open,
        ------------------ Receive Ports - FPGA RX Interface Ports -----------------
        GT1_RXUSRCLK_IN                 => SFP1_RXUSRCLK,
        GT1_RXUSRCLK2_IN                => SFP1_RXUSRCLK,
        ------------------ Receive Ports - FPGA RX interface Ports -----------------
        GT1_RXDATA_OUT                  => SFP1_RXD,
        ------------------- Receive Ports - Pattern Checker Ports ------------------
        GT1_RXPRBSERR_OUT               => SFP1_RXPRBSERR_OUT,
        GT1_RXPRBSSEL_IN                => SFP1_RXPRBSSEL_IN,
        ------------------- Receive Ports - Pattern Checker ports ------------------
        GT1_RXPRBSCNTRESET_IN           =>      '0',
        --------------------------- Receive Ports - RX AFE -------------------------
        GT1_GTXRXP_IN                   => SFP1_RXP,
        ------------------------ Receive Ports - RX AFE Ports ----------------------
        GT1_GTXRXN_IN                   => SFP1_RXN,
        ------------------- Receive Ports - RX Buffer Bypass Ports -----------------
        GT1_RXBUFRESET_IN               => '0',
        GT1_RXBUFSTATUS_OUT             => open,
        --------------- Receive Ports - RX Fabric Output Control Ports -------------
        GT1_RXOUTCLK_OUT                => SFP1_rxoutclk,
        ---------------------- Receive Ports - RX Gearbox Ports --------------------
        GT1_RXDATAVALID_OUT             => SFP1_RXDVLD,
        GT1_RXHEADER_OUT                => SFP1_RXHEADER,
        GT1_RXHEADERVALID_OUT           => SFP1_RXHEADERVLD,
        --------------------- Receive Ports - RX Gearbox Ports  --------------------
        GT1_RXGEARBOXSLIP_IN            => SFP1_RXGEARBOXSLIP,
        ------------- Receive Ports - RX Initialization and Reset Ports ------------
        GT1_GTRXRESET_IN                => SFP1_gtrxreset,
        GT1_RXPMARESET_IN               => '0',
        ------------------ Receive Ports - RX Margin Analysis ports ----------------
        GT1_RXLPMEN_IN                  => '0',
        -------------- Receive Ports -RX Initialization and Reset Ports ------------
        GT1_RXRESETDONE_OUT             => SFP1_rxresetdone,
        ------------------------ TX Configurable Driver Ports ----------------------
        GT1_TXPOSTCURSOR_IN             => (others => '0'),
        GT1_TXPRECURSOR_IN              => (others => '0'),
        --------------------- TX Initialization and Reset Ports --------------------
        GT1_GTTXRESET_IN                => SFP1_gttxreset,
        GT1_TXUSERRDY_IN                => SFP1_txuserrdy,
        ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
        GT1_TXUSRCLK_IN                 => txusrclk,
        GT1_TXUSRCLK2_IN                => txusrclk,
        --------------- Transmit Ports - TX Configurable Driver Ports --------------
        GT1_TXDIFFCTRL_IN               => "1110",
        GT1_TXINHIBIT_IN                => '0',
        GT1_TXMAINCURSOR_IN             => (others => '0'),
        ------------------ Transmit Ports - TX Data Path interface -----------------
        GT1_TXDATA_IN                   => SFP1_TXD,
        ---------------- Transmit Ports - TX Driver and OOB signaling --------------
        GT1_GTXTXN_OUT                  => SFP1_TXN,
        GT1_GTXTXP_OUT                  => SFP1_TXP,
        ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
        GT1_TXOUTCLK_OUT                => open,
        GT1_TXOUTCLKFABRIC_OUT          => open,
        GT1_TXOUTCLKPCS_OUT             => open,
        --------------------- Transmit Ports - TX Gearbox Ports --------------------
        GT1_TXHEADER_IN                 => SFP1_TXHEADER,
        GT1_TXSEQUENCE_IN               => TXSEQUENCE,
        ------------- Transmit Ports - TX Initialization and Reset Ports -----------
        GT1_TXRESETDONE_OUT             => SFP1_txresetdone,
        ------------------ Transmit Ports - pattern Generator Ports ----------------
        GT1_TXPRBSSEL_IN                => SFP1_TXPRBSSEL_IN,


  
 
 
 
        --_____________________________________________________________________
        --_____________________________________________________________________
        --GT2  (X1Y14)

        ---------------------------- Channel - DRP Ports  --------------------------
        GT2_DRPADDR_IN                  => SFP2_drpaddr,
        GT2_DRPCLK_IN                   => DRPclk,
        GT2_DRPDI_IN                    => SFP2_drpdi,
        GT2_DRPDO_OUT                   => SFP2_drpdo,
        GT2_DRPEN_IN                    => SFP2_drpen,
        GT2_DRPRDY_OUT                  => SFP2_drprdy,
        GT2_DRPWE_IN                    => SFP2_drpwe,
        ------------------------------- Loopback Ports -----------------------------
        GT2_LOOPBACK_IN                 => SFP2_LOOPBACK_IN,
        --------------------- RX Initialization and Reset Ports --------------------
        GT2_RXUSERRDY_IN                => SFP2_rxuserrdy,
        -------------------------- RX Margin Analysis Ports ------------------------
        GT2_EYESCANDATAERROR_OUT        => SFP2_EYESCANDATAERROR_OUT,
        ------------------------- Receive Ports - CDR Ports ------------------------
        GT2_RXCDRLOCK_OUT               =>      open,
        ------------------ Receive Ports - FPGA RX Interface Ports -----------------
        GT2_RXUSRCLK_IN                 => SFP2_RXUSRCLK,
        GT2_RXUSRCLK2_IN                => SFP2_RXUSRCLK,
        ------------------ Receive Ports - FPGA RX interface Ports -----------------
        GT2_RXDATA_OUT                  => SFP2_RXD,
        ------------------- Receive Ports - Pattern Checker Ports ------------------
        GT2_RXPRBSERR_OUT               => SFP2_RXPRBSERR_OUT,
        GT2_RXPRBSSEL_IN                => SFP2_RXPRBSSEL_IN,
        ------------------- Receive Ports - Pattern Checker ports ------------------
        GT2_RXPRBSCNTRESET_IN           =>      '0',
        --------------------------- Receive Ports - RX AFE -------------------------
        GT2_GTXRXP_IN                   => SFP2_RXP,
        ------------------------ Receive Ports - RX AFE Ports ----------------------
        GT2_GTXRXN_IN                   => SFP2_RXN,
        ------------------- Receive Ports - RX Buffer Bypass Ports -----------------
        GT2_RXBUFRESET_IN               => '0',
        GT2_RXBUFSTATUS_OUT             => open,
        --------------- Receive Ports - RX Fabric Output Control Ports -------------
        GT2_RXOUTCLK_OUT                => SFP2_rxoutclk,
        ---------------------- Receive Ports - RX Gearbox Ports --------------------
        GT2_RXDATAVALID_OUT             => SFP2_RXDVLD,
        GT2_RXHEADER_OUT                => SFP2_RXHEADER,
        GT2_RXHEADERVALID_OUT           => SFP2_RXHEADERVLD,
        --------------------- Receive Ports - RX Gearbox Ports  --------------------
        GT2_RXGEARBOXSLIP_IN            => SFP2_RXGEARBOXSLIP,
        ------------- Receive Ports - RX Initialization and Reset Ports ------------
        GT2_GTRXRESET_IN                => SFP2_gtrxreset,
        GT2_RXPMARESET_IN               => '0',
        ------------------ Receive Ports - RX Margin Analysis ports ----------------
        GT2_RXLPMEN_IN                  => '0',
        -------------- Receive Ports -RX Initialization and Reset Ports ------------
        GT2_RXRESETDONE_OUT             => SFP2_rxresetdone,
        ------------------------ TX Configurable Driver Ports ----------------------
        GT2_TXPOSTCURSOR_IN             => (others => '0'),
        GT2_TXPRECURSOR_IN              => (others => '0'),
        --------------------- TX Initialization and Reset Ports --------------------
        GT2_GTTXRESET_IN                => SFP2_gttxreset,
        GT2_TXUSERRDY_IN                => SFP2_txuserrdy,
        ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
        GT2_TXUSRCLK_IN                 => txusrclk,
        GT2_TXUSRCLK2_IN                => txusrclk,
        --------------- Transmit Ports - TX Configurable Driver Ports --------------
        GT2_TXDIFFCTRL_IN               => "1110",
        GT2_TXINHIBIT_IN                => '0',
        GT2_TXMAINCURSOR_IN             => (others => '0'),
        ------------------ Transmit Ports - TX Data Path interface -----------------
        GT2_TXDATA_IN                   => SFP2_TXD,
        ---------------- Transmit Ports - TX Driver and OOB signaling --------------
        GT2_GTXTXN_OUT                  => SFP2_TXN,
        GT2_GTXTXP_OUT                  => SFP2_TXP,
        ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
        GT2_TXOUTCLK_OUT                => open,
        GT2_TXOUTCLKFABRIC_OUT          => open,
        GT2_TXOUTCLKPCS_OUT             => open,
        --------------------- Transmit Ports - TX Gearbox Ports --------------------
        GT2_TXHEADER_IN                 => SFP2_TXHEADER,
        GT2_TXSEQUENCE_IN               => TXSEQUENCE,
        ------------- Transmit Ports - TX Initialization and Reset Ports -----------
        GT2_TXRESETDONE_OUT             => SFP2_txresetdone,
        ------------------ Transmit Ports - pattern Generator Ports ----------------
        GT2_TXPRBSSEL_IN                => SFP2_TXPRBSSEL_IN,




    --____________________________COMMON PORTS________________________________
        ---------------------- Common Block  - Ref Clock Ports ---------------------
        GT0_GTREFCLK0_COMMON_IN         => REFCLK,
        ------------------------- Common Block - QPLL Ports ------------------------
        GT0_QPLLLOCK_OUT                => qplllock,
        GT0_QPLLLOCKDETCLK_IN           => DRPclk,
        GT0_QPLLRESET_IN                => qpllreset

    );
i_REFCLK : IBUFDS_GTE2 port map(O => REFCLK, ODIV2 => open, CEB => '0', I => SFP_REFCLK_P, IB => SFP_REFCLK_N);
i_txusrclk : BUFG port map (I => SFP0_TXOUTCLK, O => txusrclk);
i_SFP0_rxusrclk : BUFG port map (I => SFP0_RXOUTCLK, O => SFP0_rxusrclk);
i_SFP1_rxusrclk : BUFG port map (I => SFP1_RXOUTCLK, O => SFP1_rxusrclk);
i_SFP2_rxusrclk : BUFG port map (I => SFP2_RXOUTCLK, O => SFP2_rxusrclk);
i_REFCLK2X_in: bufg port map(i => REFCLK, o => REFCLK2X_in);
i_REFCLK2X : BUFG port map (I => REFCLK2X_dcm, O => REFCLK2X);
REFCLK2X_OUT <= REFCLK2X;
i_REFCLK2XPLLRST : SRL16 generic map(INIT => x"ffff")
   port map (
      Q => REFCLK2XPLLRST,       -- SRL data output
      A0 => '1',     -- Select[0] input
      A1 => '1',     -- Select[1] input
      A2 => '1',     -- Select[2] input
      A3 => '1',     -- Select[3] input
      CLK => REFCLK2X_in,   -- Clock input
      D => '0'        -- SRL data input
   );
i_REFCLK2XPLL : PLLE2_BASE
   generic map (
      BANDWIDTH => "OPTIMIZED",  -- OPTIMIZED, HIGH, LOW
      CLKFBOUT_MULT => 8,        -- Multiply value for all CLKOUT, (2-64)
      CLKFBOUT_PHASE => 0.0,     -- Phase offset in degrees of CLKFB, (-360.000-360.000).
      CLKIN1_PERIOD => 6.4,      -- Input clock period in ns to ps resolution (i.e. 33.333 is 30 MHz).
      -- CLKOUT0_DIVIDE - CLKOUT5_DIVIDE: Divide amount for each CLKOUT (1-128)
      CLKOUT0_DIVIDE => 4,
      DIVCLK_DIVIDE => 1,        -- Master division value, (1-56)
      REF_JITTER1 => 0.0,        -- Reference input jitter in UI, (0.000-0.999).
      STARTUP_WAIT => "FALSE"    -- Delay DONE until PLL Locks, ("TRUE"/"FALSE")
   )
   port map (
      -- Clock Outputs: 1-bit (each) output: User configurable clock outputs
      CLKOUT0 => REFCLK2X_dcm,
     -- Feedback Clocks: 1-bit (each) output: Clock feedback ports
      CLKFBOUT => clkfb, -- 1-bit output: Feedback clock
      -- Status Port: 1-bit (each) output: PLL status ports
      LOCKED => open,     -- 1-bit output: LOCK
      -- Clock Input: 1-bit (each) input: Clock input
      CLKIN1 => REFCLK2X_in,     -- 1-bit input: Input clock
      -- Control Ports: 1-bit (each) input: PLL control ports
      PWRDWN => '0',     -- 1-bit input: Power-down
      RST => REFCLK2XPLLRST,           -- 1-bit input: Reset
      -- Feedback Clocks: 1-bit (each) input: Clock feedback ports
      CLKFBIN => clkfb    -- 1-bit input: Feedback clock
   );
process(ipb_clk)
begin
	if(ipb_clk'event and ipb_clk = '1')then
		if(ipb_addr(15 downto 2) = SFP_reg_addr(15 downto 2))then
			ipb_ack <= ipb_strobe;
			case ipb_addr(1 downto 0) is
				when "00" => ipb_rdata <= SFP0_err_cntr & x"0" & '0' & SFP0_LOOPBACK_IN & '0' & SFP0_TXPRBSSEL_IN & '0' & SFP0_RXPRBSSEL_IN;
				when "01" => ipb_rdata <= SFP1_err_cntr & x"0" & '0' & SFP1_LOOPBACK_IN & '0' & SFP1_TXPRBSSEL_IN & '0' & SFP1_RXPRBSSEL_IN;
				when "10" => ipb_rdata <= SFP2_err_cntr & x"0" & '0' & SFP2_LOOPBACK_IN & '0' & SFP2_TXPRBSSEL_IN & '0' & SFP2_RXPRBSSEL_IN;
				when others => ipb_rdata <= status;
			end case;
		else
			ipb_ack <= '0';
			ipb_rdata <= (others => '0');
		end if;
	end if;
end process;
process(ipb_clk)
begin
	if(test = '0')then
		SFP0_LOOPBACK_IN <= (others => '0');
		SFP0_TXPRBSSEL_IN <= (others => '0');
		SFP0_RXPRBSSEL_IN <= (others => '0');
		SFP1_LOOPBACK_IN <= (others => '0');
		SFP1_TXPRBSSEL_IN <= (others => '0');
		SFP1_RXPRBSSEL_IN <= (others => '0');
		SFP2_LOOPBACK_IN <= (others => '0');
		SFP2_TXPRBSSEL_IN <= (others => '0');
		SFP2_RXPRBSSEL_IN <= (others => '0');
	elsif(ipb_clk'event and ipb_clk = '1')then
		if(ipb_addr(15 downto 2) = SFP_reg_addr(15 downto 2) and ipb_write = '1' and ipb_strobe = '1')then
			if(ipb_addr(1 downto 0) = "00")then
				SFP0_LOOPBACK_IN <= ipb_wdata(10 downto 8);
				SFP0_TXPRBSSEL_IN <= ipb_wdata(6 downto 4);
				SFP0_RXPRBSSEL_IN <= ipb_wdata(2 downto 0);
			end if;
			if(ipb_addr(1 downto 0) = "01")then
				SFP1_LOOPBACK_IN <= ipb_wdata(10 downto 8);
				SFP1_TXPRBSSEL_IN <= ipb_wdata(6 downto 4);
				SFP1_RXPRBSSEL_IN <= ipb_wdata(2 downto 0);
			end if;
			if(ipb_addr(1 downto 0) = "10")then
				SFP2_LOOPBACK_IN <= ipb_wdata(10 downto 8);
				SFP2_TXPRBSSEL_IN <= ipb_wdata(6 downto 4);
				SFP2_RXPRBSSEL_IN <= ipb_wdata(2 downto 0);
			end if;
		end if;
	end if;
end process;
end Behavioral;

