----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    16:38:30 02/22/2013 
-- Design Name: 
-- Module Name:    TCP_if - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
use IEEE.std_logic_misc.all;
use work.amc13_pack.all;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
library UNISIM;
use UNISIM.VComponents.all;
Library UNIMACRO;
use UNIMACRO.vcomponents.all;

entity TCP_if is
    Port ( sysclk : in  STD_LOGIC;
           SFP_clk : in  STD_LOGIC;
           reset : in  STD_LOGIC;
           en_XGbE : in  STD_LOGIC;
-- signal from ddr_buf_ctrl
           buf_addr : in  STD_LOGIC_VECTOR (12 downto 0);
           buf_addr_avl : in  STD_LOGIC;
-- signal from AMC_if
					 wport_rdy : in std_logic_vector(2 downto 0);
					 evt_data_rdy : in std_logic_vector(2 downto 0);
					 event_size : in std_logic_vector(2 downto 0); -- in number of 8Kbyte blocks
					 EventData : in array3X65;
					 EventData_we : in   std_logic_VECTOR(2 downto 0);
-- signal to AMC_if to start moving data
					 evt_data_re : out std_logic_vector(2 downto 0);
-- signal to ddr_if, ddr_buf_ctrl to start moving data
					 EventBufAddr_we : out   std_logic_VECTOR(2 downto 0);
					 EventBufAddrRe : out   std_logic;
           TCP_din : out  array3X32; -- TCP data are written in unit of 32-bit words
           TCP_waddr : out  array3X13; -- each XGbE channel can store 8192 entries
           TCP_wrqst : out  STD_LOGIC_VECTOR (2 downto 0);
           TCP_re : in  STD_LOGIC_VECTOR (2 downto 0);
           TCP_ReleaseAddr : out  array3X13; -- each XGbE channel can store 8192 entries
           TCP_ReleaseRqst : out  STD_LOGIC_VECTOR (2 downto 0);
           TCP_ReleaseAck : in  STD_LOGIC_VECTOR (2 downto 0);
-- each TCP segment sent will have dest IP address (32-bit), TCP port(2x16-bit), SEQ number(32-bit), length(16 bit), time stamp(16 bit), control bits(6)
-- and memory starting address of the segment payload data(24-bit)
-- for alignment purposes, each entry occupies 32 bytes of memory space (256 bits)
           TCP_dout : in  STD_LOGIC_VECTOR(31 downto 0); -- TCP data are written in unit of 32-bit words
           TCP_raddr : out  array3X24;
           TCP_length : out  array3X14; -- in 32 bit word
           TCP_dout_valid : in  STD_LOGIC_VECTOR (2 downto 0);
           TCP_rrqst : out  STD_LOGIC_VECTOR (2 downto 0);
           TCP_rack : in  STD_LOGIC_VECTOR (2 downto 0);
					 TCP_lastword : in  STD_LOGIC;
--	ipbus signals
					 ipb_clk : in  STD_LOGIC;
					 ipb_write : in  STD_LOGIC;
					 ipb_strobe	: in  STD_LOGIC;
					 ipb_addr	: in  STD_LOGIC_VECTOR(31 downto 0);
					 ipb_rdata : out  STD_LOGIC_VECTOR(31 downto 0);
					 ipb_ack : out  STD_LOGIC;
-- signal from/to
					 Link_established : in std_logic_vector(2 downto 0);
					 SFP0_CLIENTEMACTXD : out std_logic_vector(31 downto 0);
					 SFP0_CLIENTEMACTXDBYTECNT : out std_logic_vector(1 downto 0);
					 SFP0_CLIENTEMACTXDVLD : out std_logic;
					 SFP0_CLIENTEMACTXUNDERRUN : out std_logic;
					 SFP0_EMACCLIENTRXD : in std_logic_vector(31 downto 0);
					 SFP0_EMACCLIENTRXDVLD : in std_logic;
					 SFP0_EMACCLIENTRXDBYTECNT : in std_logic_vector(1 downto 0);
					 SFP0_EMACCLIENTRXGOODFRAME : in std_logic;
					 SFP0_EMACCLIENTRXBADFRAME : in std_logic;
					 SFP0_EMACCLIENTTXACK : in std_logic;
					 SFP1_CLIENTEMACTXD : out std_logic_vector(31 downto 0);
					 SFP1_CLIENTEMACTXDBYTECNT : out std_logic_vector(1 downto 0);
					 SFP1_CLIENTEMACTXDVLD : out std_logic;
					 SFP1_CLIENTEMACTXUNDERRUN : out std_logic;
					 SFP1_EMACCLIENTRXD : in std_logic_vector(31 downto 0);
					 SFP1_EMACCLIENTRXDVLD : in std_logic;
					 SFP1_EMACCLIENTRXDBYTECNT : in std_logic_vector(1 downto 0);
					 SFP1_EMACCLIENTRXGOODFRAME : in std_logic;
					 SFP1_EMACCLIENTRXBADFRAME : in std_logic;
					 SFP1_EMACCLIENTTXACK : in std_logic;
					 SFP2_CLIENTEMACTXD : out std_logic_vector(31 downto 0);
					 SFP2_CLIENTEMACTXDBYTECNT : out std_logic_vector(1 downto 0);
					 SFP2_CLIENTEMACTXDVLD : out std_logic;
					 SFP2_CLIENTEMACTXUNDERRUN : out std_logic;
					 SFP2_EMACCLIENTRXD : in std_logic_vector(31 downto 0);
					 SFP2_EMACCLIENTRXDVLD : in std_logic;
					 SFP2_EMACCLIENTRXDBYTECNT : in std_logic_vector(1 downto 0);
					 SFP2_EMACCLIENTRXGOODFRAME : in std_logic;
					 SFP2_EMACCLIENTRXBADFRAME : in std_logic;
					 SFP2_EMACCLIENTTXACK : in std_logic
           );
end TCP_if;

architecture Behavioral of TCP_if is
COMPONENT SDP8KX65
	PORT(
		wclk : IN std_logic;
		we : IN std_logic;
		waddr : IN std_logic_vector(12 downto 0);
		din : IN std_logic_vector(64 downto 0);
		rclk : IN std_logic;
		rden : IN std_logic;
		regce : IN std_logic;
		raddr : IN std_logic_vector(12 downto 0);          
		dout : OUT std_logic_vector(64 downto 0)
		);
END COMPONENT;
signal evt_buf_din : array3X65 := (others => (others => '0'));
signal evt_buf_dout : array3X65 := (others => (others => '0'));
signal evt_buf_space : array3X14 := (others => (others => '0'));
signal evt_buf_wa : array3X14 := (others => (others => '0'));
signal evt_buf_ra : array3X14 := (others => (others => '0'));
signal evt_buf_we : std_logic_vector(2 downto 0) := (others => '0');
signal evt_buf_re : std_logic_vector(2 downto 0) := (others => '1');
signal evt_buf_regce : std_logic_vector(2 downto 0) := (others => '1');
signal last_dest : std_logic_vector(1 downto 0) := (others => '0');
signal EventBufAddr_we_i : std_logic_vector(2 downto 0) := (others => '0');
signal resetSyncRegs : std_logic_vector(2 downto 0) := (others => '0');
signal evt_data_re_i : std_logic_vector(2 downto 0) := (others => '0');
--signal evt_data_re_q : std_logic_vector(2 downto 0) := (others => '0');
signal src_busy : std_logic_vector(2 downto 0) := (others => '0');
signal dest_busy : std_logic_vector(2 downto 0) := (others => '0');
signal dest_avl : std_logic_vector(2 downto 0) := (others => '0');
type array3X2 is array(0 to 2) of std_logic_vector(1 downto 0);
signal sel_src : array3X2 := (others => (others => '0'));
signal next_src : std_logic_vector(1 downto 0) := (others => '0');
signal SFP0_CLIENTEMACTXDVLD_i : std_logic := '0';
signal SFP1_CLIENTEMACTXDVLD_i : std_logic := '0';
signal SFP2_CLIENTEMACTXDVLD_i : std_logic := '0';
signal resetSyncRegsSFP : std_logic_vector(2 downto 0) := (others => '0');
signal dest_busy0SyncRegs : std_logic_vector(3 downto 0) := (others => '0');
signal dest_busy1SyncRegs : std_logic_vector(3 downto 0) := (others => '0');
signal dest_busy2SyncRegs : std_logic_vector(3 downto 0) := (others => '0');
signal hw : std_logic_vector(2 downto 0) := (others => '0');
type array3X4 is array(0 to 2) of std_logic_vector(3 downto 0);
signal Rxbuf_we : array3X4 := (others => (others => '0'));
type array3X9 is array(0 to 2) of std_logic_vector(8 downto 0);
signal Rxbuf_wa : array3X9 := (others => (others => '0'));
signal Rxbuf_ra : array3X9 := (others => (others => '0'));
signal SFP0_GOODFRAMEtoggleSyncRegs : std_logic_vector(3 downto 0) := (others => '0');
signal SFP1_GOODFRAMEtoggleSyncRegs : std_logic_vector(3 downto 0) := (others => '0');
signal SFP2_GOODFRAMEtoggleSyncRegs : std_logic_vector(3 downto 0) := (others => '0');
signal SFP0_GOODFRAMEtoggle : std_logic := '0';
signal SFP1_GOODFRAMEtoggle : std_logic := '0';
signal SFP2_GOODFRAMEtoggle : std_logic := '0';
signal TCP_waddr_i : array3X13 := (others => (others => '0'));
signal TCP_ReleaseAddr_i : array3X13 := (others => (others => '0'));
signal Readbuf_wa : std_logic_vector(8 downto 0) := (others => '0');
signal Readbuf_we : std_logic := '0';
signal Readbuf_RST : std_logic := '0';
signal TCP_raddr_i : array3X24 := (others => (others => '0'));
signal TCP_length_i : array3X14 := (others => (others => '0'));
--signal  : std_logic_vector(2 downto 0) := (others => '0');
begin
--EventBufAddr_we <= evt_data_re_i and not evt_data_re_q;
--evt_data_re <= evt_data_re_i and not evt_data_re_q;
--EventBufAddr_we <= "000" when event_size = "000" else evt_data_re_i;
evt_data_re <= evt_data_re_i;
TCP_waddr <= TCP_waddr_i;
TCP_raddr <= TCP_raddr_i;
TCP_length <= TCP_length_i;
process(sysclk,reset)
begin
	if(reset = '1')then
		resetSyncRegs <= (others => '1');
	elsif(sysclk'event and sysclk = '1')then
		resetSyncRegs <= resetSyncRegs(1 downto 0) & '0';
	end if;
end process;
g_evt_buf: for i in 0 to 2 generate
	i_evt_buf: SDP8KX65 PORT MAP(
		wclk => sysclk,
		we => evt_buf_we(i),
		waddr => evt_buf_wa(i)(12 downto 0),
		din => evt_buf_din(i),
		rclk => SFP_clk,
		rden => evt_buf_re(i),
		regce => evt_buf_regce(i),
		raddr => evt_buf_ra(i)(12 downto 0),
		dout => evt_buf_dout(i)
	);
end generate;
process(sysclk)
variable sel_dest : std_logic_vector(4 downto 0);
begin
sel_dest := last_dest & dest_avl;
	if(sysclk'event and sysclk = '1')then
		if(resetSyncRegs(2) = '1')then
			evt_data_re_i <= "000";
			EventBufAddrRe <= '0';
			EventBufAddr_we <= "000";
			src_busy <= "000";
			next_src <= "00";
			dest_busy <= "000";
			dest_avl <= "111";
			last_dest <= "10";
			evt_buf_wa <= (others => (others => '0'));
		else
			evt_data_re_i <= "000";
			EventBufAddrRe <= '0';
			EventBufAddr_we <= "000";
			if((buf_addr_avl = '1' or or_reduce(event_size) = '0') and evt_data_re_i = "000" and src_busy(conv_integer(next_src)) = '0' and evt_data_rdy(conv_integer(next_src)) = '1' and wport_rdy(conv_integer(next_src)) = '1' and (en_XGbE = '0' or dest_avl /= "000"))then
				evt_data_re_i(conv_integer(next_src)) <= '1';
				EventBufAddrRe <= or_reduce(event_size);
				EventBufAddr_we(conv_integer(next_src)) <= or_reduce(event_size);
				case sel_dest is
					when "00001" | "01001" | "01011" | "10001" | "10011" | "10101" | "10111"  => last_dest <= "00";
					when "00010" | "00011" | "00110" | "00111" | "01010" | "10010" | "10110" => last_dest <= "01";
					when others => last_dest <= "10";
				end case;
			end if;
			if(evt_data_re_i /= "000")then
				next_src(1) <= next_src(0);
				next_src(0) <= not next_src(1) and not next_src(0);
			end if;
			for i in 0 to 2 loop
				if(evt_data_re_i(i) = '1')then
					src_busy(i) <= '1';
				elsif(EventData_we(i) = '1' and EventData(i)(64) = '1')then
					src_busy(i) <= '0';
				end if;
				if(evt_data_re_i(i) = '1')then
					dest_busy(conv_integer(last_dest)) <= en_XGbE;
				elsif(evt_buf_we(i) = '1' and evt_buf_din(i)(64) = '1')then
					dest_busy(conv_integer(sel_src(i))) <= '0';
				end if;
			end loop;
		end if;
		if(evt_data_re_i /= "000")then
			sel_src(conv_integer(last_dest)) <= next_src;
		end if;
		for i in 0 to 2 loop
			evt_buf_din(i) <= EventData(conv_integer(sel_src(i)));
			evt_buf_we(i) <= en_XGbE and EventData_we(conv_integer(sel_src(i)));
			if(evt_buf_we(i) = '1')then
				if(evt_buf_din(i)(64) = '1' and and_reduce(evt_buf_wa(i)(9 downto 0)) = '0')then
					evt_buf_wa(i)(13 downto 10) <= evt_buf_wa(i)(13 downto 10) + 1;
					evt_buf_wa(i)(9 downto 0) <= (others => '0');
				else
					evt_buf_wa(i) <= evt_buf_wa(i) + 1;
				end if;
			end if;
			if(Link_established(i) = '0' or dest_busy(i) = '1')then
				evt_buf_space(i) <= (others => '0');
			else
				evt_buf_space(i) <= evt_buf_ra(i) - evt_buf_wa(i);
			end if;
			if(evt_buf_space(i)(13 downto 10) >= ('0' & event_size))then
				dest_avl(i) <= '1';
			else
				dest_avl(i) <= '0';
			end if;
		end loop;
	end if;
end process;
SFP0_CLIENTEMACTXDVLD <= SFP0_CLIENTEMACTXDVLD_i;
SFP1_CLIENTEMACTXDVLD <= SFP1_CLIENTEMACTXDVLD_i;
SFP2_CLIENTEMACTXDVLD <= SFP2_CLIENTEMACTXDVLD_i;
SFP0_CLIENTEMACTXDBYTECNT <= "00";
SFP1_CLIENTEMACTXDBYTECNT <= "00";
SFP2_CLIENTEMACTXDBYTECNT <= "00";
SFP0_CLIENTEMACTXUNDERRUN <= resetSyncRegsSFP(2);
SFP1_CLIENTEMACTXUNDERRUN <= resetSyncRegsSFP(2);
SFP2_CLIENTEMACTXUNDERRUN <= resetSyncRegsSFP(2);
process(SFP_clk,reset)
begin
	if(reset = '1')then
		resetSyncRegsSFP <= (others => '1');
	elsif(SFP_clk'event and SFP_clk = '1')then
		resetSyncRegsSFP <= resetSyncRegsSFP(1 downto 0) & '0';
	end if;
end process;
process(SFP_clk)
begin
	if(SFP_clk'event and SFP_clk = '1')then
		dest_busy0SyncRegs <= dest_busy0SyncRegs(2 downto 0) & dest_busy(0);
		if(dest_busy0SyncRegs(3 downto 2) = "10" and SFP0_EMACCLIENTTXACK = '1')then
			SFP0_CLIENTEMACTXDVLD_i <= '1';
		elsif(hw(0) = '1' and evt_buf_dout(0)(64) = '1')then
			SFP0_CLIENTEMACTXDVLD_i <= '0';
		end if;
		if(resetSyncRegsSFP(2) = '1')then
			hw(0) <= '0';
			evt_buf_ra(0)(13) <= '1';			
			evt_buf_ra(0)(12 downto 0) <= (others => '0');			
		elsif(SFP0_CLIENTEMACTXDVLD_i = '1')then
			hw(0) <= not hw(0);
			if(hw(0) = '1')then
				evt_buf_ra(0) <= evt_buf_ra(0) + 1;
			end if;
		end if;
		if(hw(0) = '0')then
			SFP0_CLIENTEMACTXD <= evt_buf_dout(0)(31 downto 0);
		else
			SFP0_CLIENTEMACTXD <= evt_buf_dout(0)(63 downto 32);
		end if;
		dest_busy1SyncRegs <= dest_busy1SyncRegs(2 downto 0) & dest_busy(1);
		if(dest_busy1SyncRegs(3 downto 2) = "10" and SFP1_EMACCLIENTTXACK = '1')then
			SFP1_CLIENTEMACTXDVLD_i <= '1';
		elsif(hw(0) = '1' and evt_buf_dout(1)(64) = '1')then
			SFP1_CLIENTEMACTXDVLD_i <= '0';
		end if;
		if(resetSyncRegsSFP(2) = '1')then
			hw(1) <= '0';
			evt_buf_ra(1)(13) <= '1';			
			evt_buf_ra(1)(12 downto 0) <= (others => '0');			
		elsif(SFP1_CLIENTEMACTXDVLD_i = '1')then
			hw(1) <= not hw(1);
			if(hw(1) = '1')then
				evt_buf_ra(1) <= evt_buf_ra(1) + 1;
			end if;
		end if;
		if(hw(1) = '0')then
			SFP1_CLIENTEMACTXD <= evt_buf_dout(1)(31 downto 0);
		else
			SFP1_CLIENTEMACTXD <= evt_buf_dout(1)(63 downto 32);
		end if;
		dest_busy2SyncRegs <= dest_busy2SyncRegs(2 downto 0) & dest_busy(2);
		if(dest_busy2SyncRegs(3 downto 2) = "10" and SFP2_EMACCLIENTTXACK = '1')then
			SFP2_CLIENTEMACTXDVLD_i <= '1';
		elsif(hw(2) = '1' and evt_buf_dout(2)(64) = '1')then
			SFP2_CLIENTEMACTXDVLD_i <= '0';
		end if;
		if(resetSyncRegsSFP(2) = '1')then
			hw(2) <= '0';
			evt_buf_ra(2)(13) <= '1';			
			evt_buf_ra(2)(12 downto 0) <= (others => '0');			
		elsif(SFP2_CLIENTEMACTXDVLD_i = '1')then
			hw(2) <= not hw(2);
			if(hw(2) = '1')then
				evt_buf_ra(2) <= evt_buf_ra(2) + 1;
			end if;
		end if;
		if(hw(2) = '0')then
			SFP2_CLIENTEMACTXD <= evt_buf_dout(2)(31 downto 0);
		else
			SFP2_CLIENTEMACTXD <= evt_buf_dout(2)(63 downto 32);
		end if;
		if(resetSyncRegsSFP(2) = '1' or SFP0_EMACCLIENTRXBADFRAME = '1')then
			Rxbuf_wa(0) <= (others => '0');
		elsif(SFP0_EMACCLIENTRXDVLD = '1')then
			Rxbuf_wa(0) <= Rxbuf_wa(0) + 1;
		end if;
		if(resetSyncRegsSFP(2) = '1')then
			SFP0_GOODFRAMEtoggle <= '0';
		elsif(SFP0_EMACCLIENTRXGOODFRAME = '1')then
			SFP0_GOODFRAMEtoggle <= not SFP0_GOODFRAMEtoggle;
		end if;
		if(resetSyncRegsSFP(2) = '1' or SFP1_EMACCLIENTRXBADFRAME = '1')then
			Rxbuf_wa(1) <= (others => '0');
		elsif(SFP1_EMACCLIENTRXDVLD = '1')then
			Rxbuf_wa(1) <= Rxbuf_wa(1) + 1;
		end if;
		if(resetSyncRegsSFP(2) = '1')then
			SFP1_GOODFRAMEtoggle <= '0';
		elsif(SFP1_EMACCLIENTRXGOODFRAME = '1')then
			SFP1_GOODFRAMEtoggle <= not SFP1_GOODFRAMEtoggle;
		end if;
		if(resetSyncRegsSFP(2) = '1' or SFP2_EMACCLIENTRXBADFRAME = '1')then
			Rxbuf_wa(2) <= (others => '0');
		elsif(SFP2_EMACCLIENTRXDVLD = '1')then
			Rxbuf_wa(2) <= Rxbuf_wa(2) + 1;
		end if;
		if(resetSyncRegsSFP(2) = '1')then
			SFP2_GOODFRAMEtoggle <= '0';
		elsif(SFP2_EMACCLIENTRXGOODFRAME = '1')then
			SFP2_GOODFRAMEtoggle <= not SFP2_GOODFRAMEtoggle;
		end if;
	end if;
end process;
i_SFP0_Rxbuf : BRAM_SDP_MACRO
   generic map (
      BRAM_SIZE => "18Kb", -- Target BRAM, "18Kb" or "36Kb" 
      DEVICE => "7SERIES", -- Target device: "VIRTEX5", "VIRTEX6", "7SERIES", "SPARTAN6" 
      WRITE_WIDTH => 32,    -- Valid values are 1-72 (37-72 only valid when BRAM_SIZE="36Kb")
      READ_WIDTH => 32,     -- Valid values are 1-72 (37-72 only valid when BRAM_SIZE="36Kb")
      DO_REG => 0, -- Optional output register (0 or 1)
      INIT_FILE => "NONE",
      SIM_COLLISION_CHECK => "NONE") -- Collision check enable "ALL", "WARNING_ONLY", 
                                    -- "GENERATE_X_ONLY" or "NONE"       
   port map (
      DO => TCP_din(0),         -- Output read data port, width defined by READ_WIDTH parameter
      DI => SFP0_EMACCLIENTRXD,         -- Input write data port, width defined by WRITE_WIDTH parameter
      RDADDR => Rxbuf_ra(0), -- Input read address, width defined by read port depth
      RDCLK => sysclk,   -- 1-bit input read clock
      RDEN => '1',     -- 1-bit input read port enable
      REGCE => '1',   -- 1-bit input read output register enable
      RST => '0',       -- 1-bit input reset 
      WE => Rxbuf_we(0),         -- Input write enable, width defined by write port depth
      WRADDR => Rxbuf_wa(0), -- Input write address, width defined by write port depth
      WRCLK => SFP_clk,   -- 1-bit input write clock
      WREN => SFP0_EMACCLIENTRXDVLD      -- 1-bit input write port enable
   );
i_SFP1_Rxbuf : BRAM_SDP_MACRO
   generic map (
      BRAM_SIZE => "18Kb", -- Target BRAM, "18Kb" or "36Kb" 
      DEVICE => "7SERIES", -- Target device: "VIRTEX5", "VIRTEX6", "7SERIES", "SPARTAN6" 
      WRITE_WIDTH => 32,    -- Valid values are 1-72 (37-72 only valid when BRAM_SIZE="36Kb")
      READ_WIDTH => 32,     -- Valid values are 1-72 (37-72 only valid when BRAM_SIZE="36Kb")
      DO_REG => 0, -- Optional output register (0 or 1)
      INIT_FILE => "NONE",
      SIM_COLLISION_CHECK => "NONE") -- Collision check enable "ALL", "WARNING_ONLY", 
                                    -- "GENERATE_X_ONLY" or "NONE"       
   port map (
      DO => TCP_din(1),         -- Output read data port, width defined by READ_WIDTH parameter
      DI => SFP1_EMACCLIENTRXD,         -- Input write data port, width defined by WRITE_WIDTH parameter
      RDADDR => Rxbuf_ra(1), -- Input read address, width defined by read port depth
      RDCLK => sysclk,   -- 1-bit input read clock
      RDEN => '1',     -- 1-bit input read port enable
      REGCE => '1',   -- 1-bit input read output register enable
      RST => '0',       -- 1-bit input reset 
      WE => Rxbuf_we(1),         -- Input write enable, width defined by write port depth
      WRADDR => Rxbuf_wa(1), -- Input write address, width defined by write port depth
      WRCLK => SFP_clk,   -- 1-bit input write clock
      WREN => SFP1_EMACCLIENTRXDVLD      -- 1-bit input write port enable
   );
i_SFP2_Rxbuf : BRAM_SDP_MACRO
   generic map (
      BRAM_SIZE => "18Kb", -- Target BRAM, "18Kb" or "36Kb" 
      DEVICE => "7SERIES", -- Target device: "VIRTEX5", "VIRTEX6", "7SERIES", "SPARTAN6" 
      WRITE_WIDTH => 32,    -- Valid values are 1-72 (37-72 only valid when BRAM_SIZE="36Kb")
      READ_WIDTH => 32,     -- Valid values are 1-72 (37-72 only valid when BRAM_SIZE="36Kb")
      DO_REG => 0, -- Optional output register (0 or 1)
      INIT_FILE => "NONE",
      SIM_COLLISION_CHECK => "NONE") -- Collision check enable "ALL", "WARNING_ONLY", 
                                    -- "GENERATE_X_ONLY" or "NONE"       
   port map (
      DO => TCP_din(2),         -- Output read data port, width defined by READ_WIDTH parameter
      DI => SFP2_EMACCLIENTRXD,         -- Input write data port, width defined by WRITE_WIDTH parameter
      RDADDR => Rxbuf_ra(2), -- Input read address, width defined by read port depth
      RDCLK => sysclk,   -- 1-bit input read clock
      RDEN => '1',     -- 1-bit input read port enable
      REGCE => '1',   -- 1-bit input read output register enable
      RST => '0',       -- 1-bit input reset 
      WE => Rxbuf_we(2),         -- Input write enable, width defined by write port depth
      WRADDR => Rxbuf_wa(2), -- Input write address, width defined by write port depth
      WRCLK => SFP_clk,   -- 1-bit input write clock
      WREN => SFP2_EMACCLIENTRXDVLD      -- 1-bit input write port enable
   );
process(SFP0_EMACCLIENTRXDBYTECNT,SFP1_EMACCLIENTRXDBYTECNT,SFP2_EMACCLIENTRXDBYTECNT)
begin
	case SFP0_EMACCLIENTRXDBYTECNT is
		when "00" => Rxbuf_we(0) <= x"f";
		when "01" => Rxbuf_we(0) <= x"1";
		when "10" => Rxbuf_we(0) <= x"3";
		when others => Rxbuf_we(0) <= x"7";
	end case;
	case SFP1_EMACCLIENTRXDBYTECNT is
		when "00" => Rxbuf_we(1) <= x"f";
		when "01" => Rxbuf_we(1) <= x"1";
		when "10" => Rxbuf_we(1) <= x"3";
		when others => Rxbuf_we(1) <= x"7";
	end case;
	case SFP2_EMACCLIENTRXDBYTECNT is
		when "00" => Rxbuf_we(2) <= x"f";
		when "01" => Rxbuf_we(2) <= x"1";
		when "10" => Rxbuf_we(2) <= x"3";
		when others => Rxbuf_we(2) <= x"7";
	end case;
end process;
process(sysclk)
begin
	if(sysclk'event and sysclk = '1')then
		if(resetSyncRegs(2) = '1')then
			SFP0_GOODFRAMEtoggleSyncRegs <= (others => '0');
			SFP1_GOODFRAMEtoggleSyncRegs <= (others => '0');
			SFP2_GOODFRAMEtoggleSyncRegs <= (others => '0');
			TCP_waddr_i <= (others => (others => '0'));
		else
			SFP0_GOODFRAMEtoggleSyncRegs <= SFP0_GOODFRAMEtoggleSyncRegs(2 downto 0) & SFP0_GOODFRAMEtoggle;
			SFP1_GOODFRAMEtoggleSyncRegs <= SFP1_GOODFRAMEtoggleSyncRegs(2 downto 0) & SFP1_GOODFRAMEtoggle;
			SFP2_GOODFRAMEtoggleSyncRegs <= SFP2_GOODFRAMEtoggleSyncRegs(2 downto 0) & SFP2_GOODFRAMEtoggle;
		end if;
		if(SFP0_GOODFRAMEtoggleSyncRegs(3) /= SFP0_GOODFRAMEtoggleSyncRegs(2))then
			TCP_wrqst(0) <= '1';
		elsif(TCP_re(0) = '1')then
			TCP_wrqst(0) <= '0';
			TCP_waddr_i(0)(12 downto 3) <= TCP_waddr_i(0)(12 downto 3) + 1;
		end if;
		if(resetSyncRegs(2) = '1')then
			Rxbuf_ra(0) <= (others => '0');
		elsif(TCP_re(0) = '1')then
			Rxbuf_ra(0) <= Rxbuf_ra(0) + 1;
		end if;
		if(SFP1_GOODFRAMEtoggleSyncRegs(3) /= SFP1_GOODFRAMEtoggleSyncRegs(2))then
			TCP_wrqst(1) <= '1';
		elsif(TCP_re(1) = '1')then
			TCP_wrqst(1) <= '0';
			TCP_waddr_i(1)(12 downto 3) <= TCP_waddr_i(1)(12 downto 3) + 1;
		end if;
		if(resetSyncRegs(2) = '1')then
			Rxbuf_ra(1) <= (others => '0');
		elsif(TCP_re(1) = '1')then
			Rxbuf_ra(1) <= Rxbuf_ra(1) + 1;
		end if;
		if(SFP2_GOODFRAMEtoggleSyncRegs(3) /= SFP2_GOODFRAMEtoggleSyncRegs(2))then
			TCP_wrqst(2) <= '1';
		elsif(TCP_re(2) = '1')then
			TCP_wrqst(2) <= '0';
			TCP_waddr_i(2)(12 downto 3) <= TCP_waddr_i(2)(12 downto 3) + 1;
		end if;
		if(resetSyncRegs(2) = '1')then
			Rxbuf_ra(2) <= (others => '0');
		elsif(TCP_re(2) = '1')then
			Rxbuf_ra(2) <= Rxbuf_ra(2) + 1;
		end if;
	end if;
end process;
i_Readbuf : BRAM_SDP_MACRO
   generic map (
      BRAM_SIZE => "18Kb", -- Target BRAM, "18Kb" or "36Kb" 
      DEVICE => "7SERIES", -- Target device: "VIRTEX5", "VIRTEX6", "7SERIES", "SPARTAN6" 
      WRITE_WIDTH => 32,    -- Valid values are 1-72 (37-72 only valid when BRAM_SIZE="36Kb")
      READ_WIDTH => 32,     -- Valid values are 1-72 (37-72 only valid when BRAM_SIZE="36Kb")
      DO_REG => 0, -- Optional output register (0 or 1)
      INIT_FILE => "NONE",
      SIM_COLLISION_CHECK => "NONE") -- Collision check enable "ALL", "WARNING_ONLY", 
                                    -- "GENERATE_X_ONLY" or "NONE"       
   port map (
      DO => ipb_rdata,         -- Output read data port, width defined by READ_WIDTH parameter
      DI => TCP_dout,         -- Input write data port, width defined by WRITE_WIDTH parameter
      RDADDR => ipb_addr(8 downto 0), -- Input read address, width defined by read port depth
      RDCLK => ipb_clk,   -- 1-bit input read clock
      RDEN => '1',     -- 1-bit input read port enable
      REGCE => '1',   -- 1-bit input read output register enable
      RST => Readbuf_RST,       -- 1-bit input reset 
      WE => x"f",         -- Input write enable, width defined by write port depth
      WRADDR => Readbuf_wa, -- Input write address, width defined by write port depth
      WRCLK => sysclk,   -- 1-bit input write clock
      WREN => Readbuf_we      -- 1-bit input write port enable
   );
Readbuf_RST <= ipb_addr(14) or not ipb_addr(12) or not ipb_addr(11);
Readbuf_we <= TCP_dout_valid(0) or TCP_dout_valid(1) or TCP_dout_valid(2);
Readbuf_wa(8) <= TCP_dout_valid(2);
Readbuf_wa(7) <= TCP_dout_valid(1);
TCP_raddr_i(0)(23 downto 22) <= "01";
TCP_raddr_i(1)(23 downto 22) <= "10";
TCP_raddr_i(2)(23 downto 22) <= "11";
process(sysclk)
begin
	if(sysclk'event and sysclk = '1')then
		if(SFP0_GOODFRAMEtoggleSyncRegs(3) /= SFP0_GOODFRAMEtoggleSyncRegs(2))then
			TCP_rrqst(0) <= '1';
			TCP_length_i(0) <= TCP_length_i(0) + 1;
		elsif(TCP_rack(0) = '1')then
			TCP_rrqst(0) <= '0';
			TCP_raddr_i(0)(21 downto 0) <= TCP_raddr_i(0)(21 downto 0) + 1;
		end if;
		if(SFP1_GOODFRAMEtoggleSyncRegs(3) /= SFP1_GOODFRAMEtoggleSyncRegs(2))then
			TCP_rrqst(1) <= '1';
			TCP_length_i(1) <= TCP_length_i(1) + 1;
		elsif(TCP_rack(1) = '1')then
			TCP_rrqst(1) <= '0';
			TCP_raddr_i(1)(21 downto 0) <= TCP_raddr_i(1)(21 downto 0) + 1;
		end if;
		if(SFP2_GOODFRAMEtoggleSyncRegs(3) /= SFP2_GOODFRAMEtoggleSyncRegs(2))then
			TCP_rrqst(2) <= '1';
			TCP_length_i(2) <= TCP_length_i(2) + 1;
		elsif(TCP_rack(2) = '1')then
			TCP_rrqst(2) <= '0';
			TCP_raddr_i(2)(21 downto 0) <= TCP_raddr_i(2)(21 downto 0) + 1;
		end if;
		if(resetSyncRegs(2) = '1')then
			Readbuf_wa(6 downto 0) <= (others => '0');
		elsif(Readbuf_we = '1')then
			Readbuf_wa(6 downto 0) <= Readbuf_wa(6 downto 0) + 1;
		end if;
		if(SFP0_GOODFRAMEtoggleSyncRegs(3) /= SFP0_GOODFRAMEtoggleSyncRegs(2))then
			TCP_ReleaseRqst(0) <= '1';
		elsif(TCP_ReleaseAck(0) = '1')then
			TCP_ReleaseRqst(0) <= '0';
			TCP_ReleaseAddr_i(0) <= TCP_ReleaseAddr_i(0) + 1;
		end if;
		if(SFP1_GOODFRAMEtoggleSyncRegs(3) /= SFP1_GOODFRAMEtoggleSyncRegs(2))then
			TCP_ReleaseRqst(1) <= '1';
		elsif(TCP_ReleaseAck(1) = '1')then
			TCP_ReleaseRqst(1) <= '0';
			TCP_ReleaseAddr_i(1) <= TCP_ReleaseAddr_i(1) + 1;
		end if;
		if(SFP0_GOODFRAMEtoggleSyncRegs(3) /= SFP0_GOODFRAMEtoggleSyncRegs(2))then
			TCP_ReleaseRqst(2) <= '1';
		elsif(TCP_ReleaseAck(2) = '1')then
			TCP_ReleaseRqst(2) <= '0';
			TCP_ReleaseAddr_i(2) <= TCP_ReleaseAddr_i(2) + 1;
		end if;
	end if;
end process;
TCP_ReleaseAddr <= TCP_ReleaseAddr_i;
process(ipb_clk)
begin
	if(ipb_clk'event and ipb_clk = '1')then
		if(ipb_addr(14) = '0' and ipb_addr(12) = '1' and ipb_addr(11) = '1' and ipb_write = '0' and ipb_strobe = '1')then
			ipb_ack <= '1';
		else
			ipb_ack <= '0';
		end if;
	end if;
end process;
end Behavioral;

