----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    09:48:48 02/18/2013 
-- Design Name: 
-- Module Name:    ddr_buf_ctrl - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
use IEEE.std_logic_misc.all;
use work.amc13_pack.all;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
library UNISIM;
use UNISIM.VComponents.all;
Library UNIMACRO;
use UNIMACRO.vcomponents.all;

entity ddr_buf_ctrl is
    Port ( clk : in  STD_LOGIC;
           reset : in  STD_LOGIC;
           buf_rqst : in  STD_LOGIC_VECTOR (1 downto 0);-- bit 0 is for monitor buffer, bit 1 is for TCP buffer
--           buf_full : out  STD_LOGIC;
           TCP_rqst : in  STD_LOGIC_VECTOR (2 downto 0);
           TCP_ack : out STD_LOGIC_VECTOR (2 downto 0);
           TCP_addr : in  array3X13;
           buf_addr_re : in  STD_LOGIC;
           buf_addr_avl : out  STD_LOGIC;
           buf_addr : out  STD_LOGIC_VECTOR (12 downto 0);
           TCPbuf_avl : out  STD_LOGIC;
           mon_buf_avl : out  STD_LOGIC);
end ddr_buf_ctrl;

architecture Behavioral of ddr_buf_ctrl is
signal TCP_ack_i : std_logic_vector(2 downto 0) := (others => '0');
signal ec_TCPbuf_do : std_logic := '0';
signal TCPbuf_we : std_logic_vector(1 downto 0) := (others => '0');
signal TCPbuf_do_vld : std_logic := '0';
signal TCPbuf_wren : std_logic := '0';
signal init_TCPbuf : std_logic := '0';
signal TCPbuf_di : std_logic_vector(15 downto 0) := (others => '0');
signal TCPbuf_do : std_logic_vector(15 downto 0) := (others => '0');
signal TCPbuf_wa : std_logic_vector(10 downto 0) := (others => '0');
signal TCPbuf_ra : std_logic_vector(10 downto 0) := (others => '0');
--type lutsr16x13 is array (0 to 15) of std_logic_vector(12 downto 0);
--signal addrqueue : lutsr16x13 := (others => (others => '0'));
signal addrqueue_a : std_logic_vector(3 downto 0) := (others => '1');
signal addrqueue_di : std_logic_vector(12 downto 0) := (others => '0');
signal addrqueue_do : std_logic_vector(12 downto 0) := (others => '0');
signal addr_vld : std_logic := '0';
signal addrqueue_do_vld : std_logic := '0';
signal addrqueue_we : std_logic := '0';
signal Mon_buf_weA : std_logic_vector(0 downto 0) := (others => '0');
signal Mon_buf_di : std_logic_vector(1 downto 0) := (others => '0');
signal Mon_buf_do : std_logic_vector(1 downto 0) := (others => '0');
signal Mon_buf_addrA : std_logic_vector(12 downto 0) := (others => '0');

begin
TCPbuf_avl <= TCPbuf_do_vld;
buf_addr_avl <= addr_vld;
TCP_ack <= TCP_ack_i;
i_TCPbuf : BRAM_SDP_MACRO
   generic map (
      BRAM_SIZE => "36Kb", -- Target BRAM, "18Kb" or "36Kb" 
      DEVICE => "7SERIES", -- Target device: "VIRTEX5", "VIRTEX6", "7SERIES", "SPARTAN6" 
      WRITE_WIDTH => 16,    -- Valid values are 1-72 (37-72 only valid when BRAM_SIZE="36Kb")
      READ_WIDTH => 16,     -- Valid values are 1-72 (37-72 only valid when BRAM_SIZE="36Kb")
      DO_REG => 0, -- Optional output register (0 or 1)
      SIM_COLLISION_CHECK => "NONE", -- Collision check enable "ALL", "WARNING_ONLY", 
                                    -- "GENERATE_X_ONLY" or "NONE"       
      WRITE_MODE => "WRITE_FIRST", -- Specify "READ_FIRST" for same clock or synchronous clocks
                                   --  Specify "WRITE_FIRST for asynchrononous clocks on ports
      INIT => X"000000000000000000") --  Initial values on output port
   port map (
      DO => TCPbuf_do,         -- Output read data port, width defined by READ_WIDTH parameter
      DI => TCPbuf_di,         -- Input write data port, width defined by WRITE_WIDTH parameter
      RDADDR => TCPbuf_ra, -- Input read address, width defined by read port depth
      RDCLK => clk,   -- 1-bit input read clock
      RDEN => ec_TCPbuf_do,     -- 1-bit input read port enable
      REGCE => '1',   -- 1-bit input read output register enable
      RST => '0',       -- 1-bit input reset 
      WE => TCPbuf_we,         -- Input write enable, width defined by write port depth
      WRADDR => TCPbuf_wa, -- Input write address, width defined by write port depth
      WRCLK => clk,   -- 1-bit input write clock
      WREN => TCPbuf_wren      -- 1-bit input write port enable
   );
TCPbuf_we <= "11" when init_TCPbuf = '1' or TCPbuf_di(12 downto 11) = "10" else "00";
ec_TCPbuf_do <= '1' when TCPbuf_do_vld = '0' or buf_rqst = "10" else '0';
process(clk)
variable s_TCP : std_logic_vector(1 downto 0);
--variable TCPbuf_wc : std_logic_vector(10 downto 0);
begin
	s_TCP(1) := TCP_ack_i(2);
	s_TCP(0) := TCP_ack_i(1);
--	TCPbuf_wc := TCPbuf_wa - TCPbuf_ra;
	if(clk'event and clk = '1')then
		if(reset = '1')then
			TCP_ack_i <= "000";
		elsif(TCP_ack_i = "000")then
			if(TCP_rqst(0) = '1')then
				TCP_ack_i(0) <= '1';
			elsif(TCP_rqst(1) = '1')then
				TCP_ack_i(1) <= '1';
			elsif(TCP_rqst(2) = '1')then
				TCP_ack_i(2) <= '1';
			end if;
		elsif((TCP_rqst and TCP_ack_i) = "000")then
			TCP_ack_i <= "000";
		end if;
		if(reset = '1')then
			init_TCPbuf <= '1';
		elsif(and_reduce(TCPbuf_di(11 downto 0)) = '1')then
			init_TCPbuf <= '0';
		end if;
		if(reset = '1')then
			TCPbuf_wa <= (others => '0');
		elsif(TCPbuf_wren = '1')then
			TCPbuf_wa <= TCPbuf_wa + 1;
		end if;
		if(reset = '1' or (init_TCPbuf = '1' and and_reduce(TCPbuf_di(11 downto 0)) = '0'))then
			TCPbuf_wren <= '1';
		else
			TCPbuf_wren <= or_reduce(TCP_rqst and TCP_ack_i);
		end if;
		if(init_TCPbuf = '1')then
			TCPbuf_do_vld <= '0';
		elsif(TCPbuf_wa /= TCPbuf_ra)then
			TCPbuf_do_vld <= '1';
		elsif(buf_rqst = "10")then
			TCPbuf_do_vld <= '0';
		end if;
		if(reset = '1')then
			TCPbuf_di <= (others => '0');
		elsif(init_TCPbuf = '1')then
			TCPbuf_di(11 downto 0) <= TCPbuf_di(11 downto 0) + 1;
		else
			TCPbuf_di(12 downto 0) <= TCP_addr(conv_integer(s_TCP));
		end if;
		if(reset = '1')then
			TCPbuf_ra <= (others => '0');
		elsif((buf_rqst = "10" or TCPbuf_do_vld = '0') and TCPbuf_wa /= TCPbuf_ra)then
			TCPbuf_ra <= TCPbuf_ra + 1;
		end if;
		addrqueue_we <= buf_rqst(1) or buf_rqst(0);
--		if(addrqueue_we = '1')then
--			addrqueue <= addrqueue_di & addrqueue(0 to 14);
--		end if;
		if(buf_rqst(0) = '1')then
			addrqueue_di <= Mon_buf_addrA;
		else
			addrqueue_di <= "10" & TCPbuf_do(10 downto 0);
		end if;
		if(reset = '1')then
			addrqueue_a <= x"f";
		elsif(addrqueue_we = '1' and ((buf_addr_re = '0' and addr_vld = '1') or addrqueue_a = x"f"))then
			addrqueue_a <= addrqueue_a + 1;
		elsif(addrqueue_we = '0' and addrqueue_a /= x"f" and (addr_vld = '0' or buf_addr_re = '1'))then
			addrqueue_a <= addrqueue_a - 1;
		end if;
--		if(addr_vld = '0' or addrqueue_do_vld = '0' or buf_addr_re = '1')then
--			addrqueue_do <= addrqueue(conv_integer(addrqueue_a));
--		end if;
		if(addr_vld = '0' or buf_addr_re = '1')then
			buf_addr <= addrqueue_do;
		end if;
--		if(reset = '1')then
--			addrqueue_do_vld <= '0';
--		elsif(addrqueue_a /= x"f")then
--			addrqueue_do_vld <= '1';
--		elsif(addr_vld = '0' or buf_addr_re = '1')then
--			addrqueue_do_vld <= '0';
--		end if;
		if(reset = '1')then
			addr_vld <= '0';
		elsif(addrqueue_a /= x"f")then
			addr_vld <= '1';
		elsif(buf_addr_re = '1')then
			addr_vld <= '0';
		end if;
--		if(addrqueue_a(3 downto 2) = "11" and addrqueue_a(1 downto 0) /= "11")then
--			buf_full <= '1';
--		else
--			buf_full <= '0';
--		end if;
		if(reset = '1')then
			Mon_buf_addrA <= (others => '0');
		elsif(Mon_buf_weA = "1")then
			Mon_buf_addrA(11 downto 0) <= Mon_buf_addrA(11 downto 0) + 1;
		end if;
		mon_buf_avl <= not Mon_buf_do(1) and not init_TCPbuf;
	end if;
end process;
g_addrqueue: for i in 0 to 12 generate
	i_addrqueue : SRL16E
   generic map (
      INIT => X"0000")
   port map (
      Q => addrqueue_do(i),       -- SRL data output
      A0 => addrqueue_a(0),     -- Select[0] input
      A1 => addrqueue_a(1),     -- Select[1] input
      A2 => addrqueue_a(2),     -- Select[2] input
      A3 => addrqueue_a(3),     -- Select[3] input
      CE => addrqueue_we,     -- Clock enable input
      CLK => clk,   -- Clock input
      D => addrqueue_di(i)        -- SRL data input
   );
end generate;
i_Mon_buf : BRAM_TDP_MACRO
   generic map (
      BRAM_SIZE => "18Kb", -- Target BRAM, "18Kb" or "36Kb" 
      DEVICE => "7SERIES", -- Target Device: "VIRTEX5", "VIRTEX6", "7SERIES", "SPARTAN6" 
      DOA_REG => 0, -- Optional port A output register (0 or 1)
      DOB_REG => 0, -- Optional port B output register (0 or 1)
      INIT_A => X"000000000", -- Initial values on A output port
      INIT_B => X"000000000", -- Initial values on B output port
      INIT_FILE => "NONE",
      READ_WIDTH_A => 2,   -- Valid values are 1-36 (19-36 only valid when BRAM_SIZE="36Kb")
      READ_WIDTH_B => 2,   -- Valid values are 1-36 (19-36 only valid when BRAM_SIZE="36Kb")
      SIM_COLLISION_CHECK => "NONE", -- Collision check enable "ALL", "WARNING_ONLY", 
                                    -- "GENERATE_X_ONLY" or "NONE" 
      SRVAL_A => X"000000000",   -- Set/Reset value for A port output
      SRVAL_B => X"000000000",   -- Set/Reset value for B port output
      WRITE_MODE_A => "NO_CHANGE", -- "WRITE_FIRST", "READ_FIRST" or "NO_CHANGE" 
      WRITE_MODE_B => "WRITE_FIRST", -- "WRITE_FIRST", "READ_FIRST" or "NO_CHANGE" 
      WRITE_WIDTH_A => 2, -- Valid values are 1-36 (19-36 only valid when BRAM_SIZE="36Kb")
      WRITE_WIDTH_B => 2) -- Valid values are 1-36 (19-36 only valid when BRAM_SIZE="36Kb")
   port map (
      DOA => Mon_buf_do,       -- Output port-A data, width defined by READ_WIDTH_A parameter
      DOB => open,       -- Output port-B data, width defined by READ_WIDTH_B parameter
      ADDRA => Mon_buf_addrA,   -- Input port-A address, width defined by Port A depth
      ADDRB => TCPbuf_di(12 downto 0),   -- Input port-B address, width defined by Port B depth
      CLKA => clk,     -- 1-bit input port-A clock
      CLKB => clk,     -- 1-bit input port-B clock
      DIA => Mon_buf_di,       -- Input port-A data, width defined by WRITE_WIDTH_A parameter
      DIB => "00",       -- Input port-B data, width defined by WRITE_WIDTH_B parameter
      ENA => '1',       -- 1-bit input port-A enable
      ENB => TCPbuf_wren,       -- 1-bit input port-B enable
      REGCEA => '1', -- 1-bit input port-A output register enable
      REGCEB => '1', -- 1-bit input port-B output register enable
      RSTA => '0',     -- 1-bit input port-A reset
      RSTB => '0',     -- 1-bit input port-B reset
      WEA => Mon_buf_weA,       -- Input port-A write enable, width defined by Port A depth
      WEB => "1"        -- Input port-B write enable, width defined by Port B depth
   );
Mon_buf_weA <= "1" when buf_rqst(0) = '1' and reset = '0' and init_TCPbuf = '0' else "0";
end Behavioral;

