----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    11:04:26 11/15/2012 
-- Design Name: 
-- Module Name:    dpbr_8_32 - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;
Library UNIMACRO;
use UNIMACRO.vcomponents.all;

entity dpbr_8_32 is
    Port ( clka : in  STD_LOGIC;
           wea : in  STD_LOGIC;
           addra : in  STD_LOGIC_VECTOR (9 downto 0);
           dina : in  STD_LOGIC_VECTOR (31 downto 0);
           douta : out  STD_LOGIC_VECTOR (31 downto 0);
           clkb : in  STD_LOGIC;
           web : in  STD_LOGIC;
           addrb : in  STD_LOGIC_VECTOR (11 downto 0);
           dinb : in  STD_LOGIC_VECTOR (7 downto 0);
           doutb : out  STD_LOGIC_VECTOR (7 downto 0));
end dpbr_8_32;

architecture Behavioral of dpbr_8_32 is
signal WrEnA : std_logic_vector(3 downto 0) := (others => '0');
signal WrEnB : std_logic_vector(0 downto 0) := (others => '0');
begin
   BRAM_TDP_MACRO_inst : BRAM_TDP_MACRO
   generic map (
      BRAM_SIZE => "36Kb", -- Target BRAM, "18Kb" or "36Kb" 
      DEVICE => "7SERIES", -- Target Device: "VIRTEX5", "VIRTEX6", "7SERIES", "SPARTAN6" 
      DOA_REG => 0, -- Optional port A output register (0 or 1)
      DOB_REG => 0, -- Optional port B output register (0 or 1)
      INIT_A => X"000000000", -- Initial values on A output port
      INIT_B => X"000000000", -- Initial values on B output port
      INIT_FILE => "NONE",
      READ_WIDTH_A => 32,   -- Valid values are 1-36 (19-36 only valid when BRAM_SIZE="36Kb")
      READ_WIDTH_B => 8,   -- Valid values are 1-36 (19-36 only valid when BRAM_SIZE="36Kb")
      SIM_COLLISION_CHECK => "ALL", -- Collision check enable "ALL", "WARNING_ONLY", 
                                    -- "GENERATE_X_ONLY" or "NONE" 
      SRVAL_A => X"000000000",   -- Set/Reset value for A port output
      SRVAL_B => X"000000000",   -- Set/Reset value for B port output
      WRITE_MODE_A => "WRITE_FIRST", -- "WRITE_FIRST", "READ_FIRST" or "NO_CHANGE" 
      WRITE_MODE_B => "WRITE_FIRST", -- "WRITE_FIRST", "READ_FIRST" or "NO_CHANGE" 
      WRITE_WIDTH_A => 32, -- Valid values are 1-36 (19-36 only valid when BRAM_SIZE="36Kb")
      WRITE_WIDTH_B => 8) -- Valid values are 1-36 (19-36 only valid when BRAM_SIZE="36Kb")
   port map (
      DOA => douta,       -- Output port-A data, width defined by READ_WIDTH_A parameter
      DOB => doutb,       -- Output port-B data, width defined by READ_WIDTH_B parameter
      ADDRA => addra,   -- Input port-A address, width defined by Port A depth
      ADDRB => addrb,   -- Input port-B address, width defined by Port B depth
      CLKA => clka,     -- 1-bit input port-A clock
      CLKB => clkb,     -- 1-bit input port-B clock
      DIA => dina,       -- Input port-A data, width defined by WRITE_WIDTH_A parameter
      DIB => dinb,       -- Input port-B data, width defined by WRITE_WIDTH_B parameter
      ENA => '1',       -- 1-bit input port-A enable
      ENB => '1',       -- 1-bit input port-B enable
      REGCEA => '1', -- 1-bit input port-A output register enable
      REGCEB => '1', -- 1-bit input port-B output register enable
      RSTA => '0',     -- 1-bit input port-A reset
      RSTB => '0',     -- 1-bit input port-B reset
      WEA => WrEnA,       -- Input port-A write enable, width defined by Port A depth
      WEB => WrEnB        -- Input port-B write enable, width defined by Port B depth
   );
WrEnA <= x"f" when wea = '1' else x"0";
WrEnB <= "1" when web = '1' else "0";
end Behavioral;

