----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    11:26:30 01/23/2013 
-- Design Name: 
-- Module Name:    evt_bldr - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
use IEEE.std_logic_misc.all;
use work.amc13_pack.all;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
library UNISIM;
use UNISIM.VComponents.all;
Library UNIMACRO;
use UNIMACRO.vcomponents.all;

entity evt_bldr is
    Port ( clk : in  STD_LOGIC;
					 reset : in STD_LOGIC;
           Source_ID : in  STD_LOGIC_VECTOR (7 downto 0);
           AMC_wc : in  STD_LOGIC_VECTOR (10 downto 0); -- bit 9-0 64bit word count, bit 10 is AMC enable bit
					 AMC_wc_we : in STD_LOGIC;
           channel_in : in  STD_LOGIC_VECTOR (3 downto 0);
           AMC_header : in  STD_LOGIC_VECTOR (63 downto 0);
					 AMC_header_we : in STD_LOGIC;
					 AMC_DATA : in array12X64;
					 AMC_DATA_re : out STD_LOGIC_VECTOR (11 downto 0);
           evt_data : out  STD_LOGIC_VECTOR (64 downto 0);
					 evt_data_we : out STD_LOGIC;
					 evt_buf_full : in STD_LOGIC;
					 evt_data_re : in STD_LOGIC;
					 evt_data_rdy : out STD_LOGIC;
           channel_out : out  STD_LOGIC_VECTOR (3 downto 0);
					 EventBuilt : out STD_LOGIC;
           busy : out  STD_LOGIC);
end evt_bldr;

architecture Behavioral of evt_bldr is
COMPONENT cmsCRC64
	PORT(
		clk : IN std_logic;
		reset : IN std_logic;
		crc_init : IN std_logic;
		trailer : IN std_logic;
		crc_d : IN std_logic_vector(63 downto 0);
		crc_ce : IN std_logic;          
		crc : OUT std_logic_vector(15 downto 0);
		crc_err : OUT std_logic;
		dout : OUT std_logic_vector(63 downto 0);
		dout_vld : OUT std_logic
		);
END COMPONENT;
COMPONENT SDP8KX65
	PORT(
		wclk : IN std_logic;
		we : IN std_logic;
		waddr : IN std_logic_vector(12 downto 0);
		din : IN std_logic_vector(64 downto 0);
		rclk : IN std_logic;
		rden : IN std_logic;
		regce : IN std_logic;
		raddr : IN std_logic_vector(12 downto 0);          
		dout : OUT std_logic_vector(64 downto 0)
		);
END COMPONENT;
signal fifo_rst : std_logic := '0';
signal fifo_en : std_logic := '0';
signal reset_dl1 : std_logic := '0';
signal reset_dl2 : std_logic := '0';
signal fifo_we : std_logic := '0';
signal fifo_re : std_logic := '0';
signal fifo_empty : std_logic_vector(7 downto 0) := (others => '0');
signal FIFO_di : std_logic_vector(71 downto 0) := (others => '0');
signal FIFO_do : std_logic_vector(71 downto 0) := (others => '0');
signal channel : std_logic_vector(3 downto 0) := (others => '0');
signal next_channel : std_logic_vector(3 downto 0) := (others => '0');
signal evt_data_we_i : std_logic := '0';
signal en_output : std_logic := '0';
signal evt_data_vld : std_logic := '0';
signal evt_buf_do_vld : std_logic := '0';
signal evt_buf_re : std_logic := '0';
signal evt_cnt : std_logic_vector(3 downto 0) := (others => '0');
signal evt_buf_regce : std_logic := '0';
signal evt_data_rdy_i : std_logic := '0';
signal evt_buf_we : std_logic := '0';
signal buf_full : std_logic := '0';
signal got_eoe : std_logic := '0';
signal AMC_DATA_re_i : std_logic := '0';
signal evt_buf_space : std_logic_vector(12 downto 0) := (others => '0');
signal evt_buf_wa : std_logic_vector(12 downto 0) := (others => '0');
signal evt_buf_din : std_logic_vector(65 downto 0) := (others => '0');
signal evt_buf_ra : std_logic_vector(12 downto 0) := (others => '0');
signal evt_buf_dout : std_logic_vector(64 downto 0) := (others => '0');
--type lutsr16X11 is array(0 to 15) of std_logic_vector(10 downto 0);
--signal wc_fifo : lutsr16X11 := (others => (others => '0'));
signal wc_fifo_a : std_logic_vector(3 downto 0) := (others => '0');
signal wc_fifo_do : std_logic_vector(10 downto 0) := (others => '0');
signal ld_wc : std_logic := '0';
signal wc : std_logic_vector(9 downto 0) := (others => '0');
signal crc_init : std_logic := '0';
signal crc_ce : std_logic := '0';
signal crc_data : std_logic_vector(63 downto 0) := (others => '0');
signal trailer_we : std_logic := '0';
signal trailer_we_q : std_logic := '0';
signal trailer : std_logic_vector(63 downto 0) := (others => '0');
signal trailer_dl : std_logic_vector(2 downto 0) := (others => '0');
type array8X12 is array (0 to 7) of std_logic_vector(11 downto 0);
signal rdcount : array8X12 := (others => (others => '0'));
signal wrcount : array8X12 := (others => (others => '0'));
begin
channel_out <= channel;
evt_data <= evt_buf_dout;
evt_data_we <= evt_data_we_i;
EventBuilt <= trailer_we;
evt_data_rdy <= evt_data_rdy_i;
process(clk)
begin
	if(clk'event and clk = '1')then
		crc_ce <= not reset and fifo_en and (AMC_header_we or AMC_DATA_re_i or trailer_we);
		if(AMC_DATA_re_i = '1')then
			crc_data <= AMC_DATA(CONV_INTEGER(channel));
		elsif(trailer_we = '1')then
			crc_data <= trailer;
		else
			crc_data <= AMC_header;
		end if;
		trailer_we_q <= trailer_we;
		crc_init <= reset or trailer_we_q;
		if(reset = '1')then
			next_channel <= x"c";
		elsif(next_channel(3 downto 2) = "11" and AMC_header_we = '1')then
			next_channel <= x"0";
		elsif(next_channel(3 downto 2) /= "11" and next_channel /= channel_in and (wc_fifo_do(10) = '0' or (next_channel = channel and AMC_DATA_re_i = '1')))then
			next_channel <= next_channel + 1;
		end if;
		if(reset = '1')then
			channel <= x"c";
		elsif(AMC_DATA_re_i = '0')then
			channel <= next_channel;
		end if;
--		if(AMC_wc_we = '1')then
--			wc_fifo <= AMC_wc & wc_fifo(0 to 14);
--		end if;
		if(reset = '1')then
			wc_fifo_a <= x"f";
		elsif(AMC_wc_we = '1' and (and_reduce(wc_fifo_a) = '1' or next_channel = channel_in or (wc_fifo_do(10) = '1' and (next_channel /= channel or AMC_DATA_re_i = '0'))))then
			wc_fifo_a <= wc_fifo_a + 1;
		elsif(AMC_wc_we = '0' and and_reduce(wc_fifo_a) = '0' and (next_channel(3 downto 2) /= "11" and next_channel /= channel_in and (wc_fifo_do(10) = '0' or (next_channel = channel and AMC_DATA_re_i = '1'))))then
			wc_fifo_a <= wc_fifo_a - 1;
		end if;
	end if;
end process;
i_EventCRC: cmsCRC64 PORT MAP(
		clk => clk,
		reset => reset,
		crc_init => crc_init,
		trailer => trailer_we_q,
		crc_d => crc_data,
		crc_ce => crc_ce,
		crc => open,
		crc_err => open,
		dout => FIFO_di(63 downto 0),
		dout_vld => FIFO_we
	);
i_fifo_rst : SRL16E
   generic map (
      INIT => X"0000")
   port map (
      Q => fifo_rst,       -- SRL data output
      A0 => '1',     -- Select[0] input
      A1 => '1',     -- Select[1] input
      A2 => '1',     -- Select[2] input
      A3 => '0',     -- Select[3] input
      CE => '1',     -- Clock enable input
      CLK => clk,   -- Clock input
      D => reset        -- SRL data input
   );
i_reset_dl1 : SRL16E
   generic map (
      INIT => X"0000")
   port map (
      Q => reset_dl1,       -- SRL data output
      A0 => '1',     -- Select[0] input
      A1 => '1',     -- Select[1] input
      A2 => '1',     -- Select[2] input
      A3 => '0',     -- Select[3] input
      CE => '1',     -- Clock enable input
      CLK => clk,   -- Clock input
      D => fifo_rst        -- SRL data input
   );
process(clk)
begin
	if(clk'event and clk = '1')then
		if(reset = '1')then
			fifo_en <= '0';
		elsif(reset_dl1 = '0' and reset_dl2 = '1')then
			fifo_en <= '1';
		end if;
		reset_dl2 <= reset_dl1;
	end if;
end process;
g_evt_FIFO: for i in 0 to 7 generate
   i_evt_FIFO : FIFO_DUALCLOCK_MACRO
   generic map (
      DEVICE => "7SERIES",            -- Target Device: "VIRTEX5", "VIRTEX6", "7SERIES" 
      ALMOST_FULL_OFFSET => X"0080",  -- Sets almost full threshold
      ALMOST_EMPTY_OFFSET => X"0080", -- Sets the almost empty threshold
      DATA_WIDTH => 9,   -- Valid values are 1-72 (37-72 only valid when FIFO_SIZE="36Kb")
      FIFO_SIZE => "36Kb",            -- Target BRAM, "18Kb" or "36Kb" 
      FIRST_WORD_FALL_THROUGH => TRUE) -- Sets the FIFO FWFT to TRUE or FALSE
   port map (
      ALMOSTEMPTY => open,   -- 1-bit output almost empty
      ALMOSTFULL => open,     -- 1-bit output almost full
      DO => FIFO_do(i*9+8 downto i*9),                     -- Output data, width defined by DATA_WIDTH parameter
      EMPTY => FIFO_empty(i),               -- 1-bit output empty
      FULL => open,                 -- 1-bit output full
      RDCOUNT => rdcount(i),           -- Output read count, width determined by FIFO depth
      RDERR => open,               -- 1-bit output read error
      WRCOUNT => wrcount(i),           -- Output write count, width determined by FIFO depth
      WRERR => open,               -- 1-bit output write error
      DI => FIFO_di(i*9+8 downto i*9),                     -- Input data, width defined by DATA_WIDTH parameter
      RDCLK => clk,               -- 1-bit input read clock
      RDEN => FIFO_re,                 -- 1-bit input read enable
      RST => fifo_rst,                   -- 1-bit input reset
      WRCLK => clk,               -- 1-bit input write clock
      WREN => FIFO_we                  -- 1-bit input write enable
   );
end generate;
FIFO_di(64) <= trailer_dl(2);
FIFO_re <= fifo_en and not FIFO_empty(0);
process(clk)
begin
	if(clk'event and clk = '1')then
		if(reset = '1')then
			evt_buf_wa <= (others => '0');
		elsif(evt_buf_we = '1')then
			evt_buf_wa <= evt_buf_wa + 1;
		end if;
		if(reset = '1')then
			en_output <= '0';
		elsif(evt_data_re = '1')then
			en_output <= '1';
		elsif(evt_data_we_i = '1' and evt_buf_dout(64) = '1')then
			en_output <= '0';
		end if;
		if(reset = '1' or (evt_data_we_i = '1' and evt_buf_dout(64) = '1'))then
			evt_data_we_i <= '0';
		else
			evt_data_we_i <= en_output and not evt_buf_full;
		end if;
		if(reset = '1')then
			evt_data_vld <= '0';
		elsif(evt_buf_do_vld = '1')then
			evt_data_vld <= '1';
		elsif(evt_data_we_i = '1')then
			evt_data_vld <= '0';
		end if;
		if(reset = '1')then
			evt_buf_do_vld <= '0';
		elsif(evt_buf_wa /= evt_buf_ra)then
			evt_buf_do_vld <= '1';
		elsif(evt_data_vld = '0' or evt_data_we_i = '1')then
			evt_buf_do_vld <= '0';
		end if;
		if(reset = '1')then
			evt_buf_ra <= (others => '0');
		elsif(evt_buf_wa /= evt_buf_ra and evt_buf_re = '1')then
			evt_buf_ra <= evt_buf_ra + 1;
		end if;
		trailer_dl <= trailer_dl(1 downto 0) & trailer_we;
		if(reset = '1')then
			evt_cnt <= (others => '0');
		elsif(evt_buf_we = '1' and FIFO_do(64) = '1' and evt_data_re = '0')then
			evt_cnt <= evt_cnt + 1;
		elsif((evt_buf_we = '0' or FIFO_do(64) = '0') and evt_data_re = '1')then
			evt_cnt <= evt_cnt - 1;
		end if;
		if(reset = '1')then
			evt_data_rdy_i <= '0';
		else
			evt_data_rdy_i <= or_reduce(evt_cnt);
		end if;
		if(reset = '1' or AMC_wc_we = '1')then
			got_eoe <= '0';
		elsif(FIFO_do(64) = '1' and FIFO_empty(0) = '0')then
			got_eoe <= '1';
		end if;
		if(reset = '0')then
			evt_buf_space <= "1111111110000";
		elsif(evt_buf_wa /= evt_buf_ra and evt_buf_re = '1' and evt_buf_we = '0')then
			evt_buf_space <= evt_buf_space + 1;
		elsif((evt_buf_wa = evt_buf_ra or evt_buf_re = '0') and evt_buf_we = '1')then
			evt_buf_space <= evt_buf_space - 1;
		end if;
		if(reset = '1' or (got_eoe = '1' and evt_buf_space(12) = '1' and evt_buf_space(11) = '1'))then
			busy <= '0';
		elsif(AMC_wc_we = '1')then
			busy <= '1';
		end if;
	end if;
end process;
i_evt_buf: SDP8KX65 PORT MAP(
		wclk => clk,
		we => evt_buf_we,
		waddr => evt_buf_wa,
		din => FIFO_do(64 downto 0),
		rclk => clk,
		rden => evt_buf_re,
		regce => evt_buf_regce,
		raddr => evt_buf_ra,
		dout => evt_buf_dout
	);
evt_buf_regce <= not evt_data_vld or evt_data_we_i;
evt_buf_re <= not evt_buf_do_vld or not evt_data_vld or evt_data_we_i;
evt_buf_we <= FIFO_re;
g_wc_fifo: for i in 0 to 10 generate
	i_wc_fifo : SRL16E
   generic map (
      INIT => X"0000")
   port map (
      Q => wc_fifo_do(i),       -- SRL data output
      A0 => wc_fifo_a(0),     -- Select[0] input
      A1 => wc_fifo_a(1),     -- Select[1] input
      A2 => wc_fifo_a(2),     -- Select[2] input
      A3 => wc_fifo_a(3),     -- Select[3] input
      CE => AMC_wc_we,     -- Clock enable input
      CLK => clk,   -- Clock input
      D => AMC_wc(i)        -- SRL data input
   );
end generate;
--wc_fifo_do <= wc_fifo(conv_integer(wc_fifo_a));
-- event word count and trailer
process(clk)
begin
	if(clk'event and clk = '1')then
		if(reset = '1')then
			trailer_we <= '0';
		elsif(next_channel = x"c" and ld_wc = '1' and trailer_we = '0')then
			trailer_we <= '1';
		else
			trailer_we <= '0';
		end if;
		if(reset = '1' or trailer_we = '1')then
			trailer(45 downto 32) <= "00000000000111";				
		elsif(AMC_wc_we = '1' and AMC_wc(10) = '1')then
			trailer(45 downto 32) <= trailer(45 downto 32) + (x"0" & AMC_wc(9 downto 0));				
		end if;
	end if;
end process;
trailer(63 downto 60) <= x"a";
trailer(59 downto 46) <= (others => '0');
trailer(31 downto 16) <= x"0000";
trailer(15 downto 8) <= Source_ID;
trailer(7 downto 0) <= x"00";
process(clk)
begin
	if(clk'event and clk = '1')then
		if(reset = '1')then
			ld_wc <= '0';
		elsif((or_reduce(wc(9 downto 1)) = '0' and AMC_DATA_re_i = '1') or (channel(3 downto 2) /= "11" and channel /= channel_in and AMC_header_we = '0' and (wc_fifo_do(10) = '0' or ld_wc = '0') and AMC_DATA_re_i = '0'))then
			ld_wc <= '1';
		else
			ld_wc <= '0';
		end if;
		if(reset = '1' or (or_reduce(wc(9 downto 1)) = '0' and AMC_DATA_re_i = '1'))then
			AMC_DATA_re_i <= '0';
			AMC_DATA_re <= (others => '0');
		elsif(ld_wc = '1' and wc_fifo_do(10) = '1' and and_reduce(wc_fifo_a) = '0')then
			AMC_DATA_re_i <= '1';
			AMC_DATA_re <= (others => '0');
			AMC_DATA_re(conv_integer(next_channel)) <= '1';
		end if;
		if(ld_wc = '1')then
			wc <= wc_fifo_do(9 downto 0);
		elsif(AMC_DATA_re_i = '1')then
			wc <= wc - 1;
		end if;
	end if;
end process;
end Behavioral;

