################################################################################
##   ____  ____
##  /   /\/   /
## /___/  \  /    Vendor: Xilinx
## \   \   \/     Version : 2.5
##  \   \         Application : 7 Series FPGAs Transceivers Wizard
##  /   /         Filename : AMC_GTXv_exdes.xdc
## /___/   /\     
## \   \  /  \ 
##  \___\/\___\
##
##
## USER CONSTRAINTS FILE FOR MGT WRAPPER EXAMPLE DESIGN
## Generated by Xilinx 7 Series FPGAs Transceivers Wizard
##
## Device:  xc7k325t
## Package: ffg900
##
## (c) Copyright 2010-2012 Xilinx, Inc. All rights reserved.
##
## This file contains confidential and proprietary information
## of Xilinx, Inc. and is protected under U.S. and
## international copyright and other intellectual property
## laws.
##
## DISCLAIMER
## This disclaimer is not a license and does not grant any
## rights to the materials distributed herewith. Except as
## otherwise provided in a valid license issued to you by
## Xilinx, and to the maximum extent permitted by applicable
## law: (1) THESE MATERIALS ARE MADE AVAILABLE "AS IS" AND
## WITH ALL FAULTS, AND XILINX HEREBY DISCLAIMS ALL WARRANTIES
## AND CONDITIONS, EXPRESS, IMPLIED, OR STATUTORY, INCLUDING
## BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, NON-
## INFRINGEMENT, OR FITNESS FOR ANY PARTICULAR PURPOSE; and
## (2) Xilinx shall not be liable (whether in contract or tort,
## including negligence, or under any other theory of
## liability) for any loss or damage of any kind or nature
## related to, arising under or in connection with these
## materials, including for any direct, or any indirect,
## special, incidental, or consequential loss or damage
## (including loss of data, profits, goodwill, or any type of
## loss or damage suffered as a result of any action brought
## by a third party) even if such damage or loss was
## reasonably foreseeable or Xilinx had been advised of the
## possibility of the same.
##
## CRITICAL APPLICATIONS
## Xilinx products are not designed or intended to be fail-
## safe, or for use in any application requiring fail-safe
## performance, such as life-support or safety devices or
## systems, Class III medical devices, nuclear facilities,
## applications related to the deployment of airbags, or any
## other applications that could lead to death, personal
## injury, or severe property or environmental damage
## (individually and collectively, "Critical
## Applications"). Customer assumes the sole risk and
## liability of any use of Xilinx products in Critical
## Applications, subject only to applicable laws and
## regulations governing limitations on product liability.
## 
## THIS COPYRIGHT NOTICE AND DISCLAIMER MUST BE RETAINED AS
## PART OF THIS FILE AT ALL TIMES.


################################## Clock Constraints ##########################


####################### GT reference clock constraints #######################
# create_clock -name  q1_clk1_refclk_i -period 4.0  q1_clk1_refclk_i  

# DRP Clock Constraint
create_clock -name drpclk_in_i -period 20.0 [get_ports DRP_CLK_IN]
create_clock -name SYSCLK_IN -period 10.0 [get_ports SYSCLK_IN]

# User Clock Constraints
create_clock -name gt0_txusrclk_i -period 8.0 [get_pins -hier -filter {name=~*gt0_AMC_GTXv_i*gtxe2_i*TXOUTCLK}]
create_clock -name gt0_rxusrclk_i -period 8.0 [get_pins -hier -filter {name=~*gt0_AMC_GTXv_i*gtxe2_i*RXOUTCLK}]
create_clock -name gt1_txusrclk_i -period 8.0 [get_pins -hier -filter {name=~*gt1_AMC_GTXv_i*gtxe2_i*TXOUTCLK}]
create_clock -name gt1_rxusrclk_i -period 8.0 [get_pins -hier -filter {name=~*gt1_AMC_GTXv_i*gtxe2_i*RXOUTCLK}]
create_clock -name gt2_txusrclk_i -period 8.0 [get_pins -hier -filter {name=~*gt2_AMC_GTXv_i*gtxe2_i*TXOUTCLK}]
create_clock -name gt2_rxusrclk_i -period 8.0 [get_pins -hier -filter {name=~*gt2_AMC_GTXv_i*gtxe2_i*RXOUTCLK}]
create_clock -name gt3_txusrclk_i -period 8.0 [get_pins -hier -filter {name=~*gt3_AMC_GTXv_i*gtxe2_i*TXOUTCLK}]
create_clock -name gt3_rxusrclk_i -period 8.0 [get_pins -hier -filter {name=~*gt3_AMC_GTXv_i*gtxe2_i*RXOUTCLK}]
create_clock -name gt4_txusrclk_i -period 8.0 [get_pins -hier -filter {name=~*gt4_AMC_GTXv_i*gtxe2_i*TXOUTCLK}]
create_clock -name gt4_rxusrclk_i -period 8.0 [get_pins -hier -filter {name=~*gt4_AMC_GTXv_i*gtxe2_i*RXOUTCLK}]
create_clock -name gt5_txusrclk_i -period 8.0 [get_pins -hier -filter {name=~*gt5_AMC_GTXv_i*gtxe2_i*TXOUTCLK}]
create_clock -name gt5_rxusrclk_i -period 8.0 [get_pins -hier -filter {name=~*gt5_AMC_GTXv_i*gtxe2_i*RXOUTCLK}]
create_clock -name gt6_txusrclk_i -period 8.0 [get_pins -hier -filter {name=~*gt6_AMC_GTXv_i*gtxe2_i*TXOUTCLK}]
create_clock -name gt6_rxusrclk_i -period 8.0 [get_pins -hier -filter {name=~*gt6_AMC_GTXv_i*gtxe2_i*RXOUTCLK}]
create_clock -name gt7_txusrclk_i -period 8.0 [get_pins -hier -filter {name=~*gt7_AMC_GTXv_i*gtxe2_i*TXOUTCLK}]
create_clock -name gt7_rxusrclk_i -period 8.0 [get_pins -hier -filter {name=~*gt7_AMC_GTXv_i*gtxe2_i*RXOUTCLK}]
create_clock -name gt8_txusrclk_i -period 8.0 [get_pins -hier -filter {name=~*gt8_AMC_GTXv_i*gtxe2_i*TXOUTCLK}]
create_clock -name gt8_rxusrclk_i -period 8.0 [get_pins -hier -filter {name=~*gt8_AMC_GTXv_i*gtxe2_i*RXOUTCLK}]
create_clock -name gt9_txusrclk_i -period 8.0 [get_pins -hier -filter {name=~*gt9_AMC_GTXv_i*gtxe2_i*TXOUTCLK}]
create_clock -name gt9_rxusrclk_i -period 8.0 [get_pins -hier -filter {name=~*gt9_AMC_GTXv_i*gtxe2_i*RXOUTCLK}]
create_clock -name gt10_txusrclk_i -period 8.0 [get_pins -hier -filter {name=~*gt10_AMC_GTXv_i*gtxe2_i*TXOUTCLK}]
create_clock -name gt10_rxusrclk_i -period 8.0 [get_pins -hier -filter {name=~*gt10_AMC_GTXv_i*gtxe2_i*RXOUTCLK}]
create_clock -name gt11_txusrclk_i -period 8.0 [get_pins -hier -filter {name=~*gt11_AMC_GTXv_i*gtxe2_i*TXOUTCLK}]
create_clock -name gt11_rxusrclk_i -period 8.0 [get_pins -hier -filter {name=~*gt11_AMC_GTXv_i*gtxe2_i*RXOUTCLK}]

################################# RefClk Location constraints #####################
set_property LOC N7 [get_ports  Q1_CLK1_GTREFCLK_PAD_N_IN ] 
set_property LOC N8 [get_ports  Q1_CLK1_GTREFCLK_PAD_P_IN ]

################################# mgt wrapper constraints #####################

##---------- Set placement for gt0_gtx_wrapper_i/GTXE2_CHANNEL ------
set_property LOC GTXE2_CHANNEL_X0Y0 [get_cells AMC_GTXv_init_i/AMC_GTXv_i/U0/gt0_AMC_GTXv_i/gtxe2_i]
##---------- Set placement for gt1_gtx_wrapper_i/GTXE2_CHANNEL ------
set_property LOC GTXE2_CHANNEL_X0Y1 [get_cells AMC_GTXv_init_i/AMC_GTXv_i/U0/gt1_AMC_GTXv_i/gtxe2_i]
##---------- Set placement for gt2_gtx_wrapper_i/GTXE2_CHANNEL ------
set_property LOC GTXE2_CHANNEL_X0Y2 [get_cells AMC_GTXv_init_i/AMC_GTXv_i/U0/gt2_AMC_GTXv_i/gtxe2_i]
##---------- Set placement for gt3_gtx_wrapper_i/GTXE2_CHANNEL ------
set_property LOC GTXE2_CHANNEL_X0Y3 [get_cells AMC_GTXv_init_i/AMC_GTXv_i/U0/gt3_AMC_GTXv_i/gtxe2_i]
##---------- Set placement for gt4_gtx_wrapper_i/GTXE2_CHANNEL ------
set_property LOC GTXE2_CHANNEL_X0Y4 [get_cells AMC_GTXv_init_i/AMC_GTXv_i/U0/gt4_AMC_GTXv_i/gtxe2_i]
##---------- Set placement for gt5_gtx_wrapper_i/GTXE2_CHANNEL ------
set_property LOC GTXE2_CHANNEL_X0Y5 [get_cells AMC_GTXv_init_i/AMC_GTXv_i/U0/gt5_AMC_GTXv_i/gtxe2_i]
##---------- Set placement for gt6_gtx_wrapper_i/GTXE2_CHANNEL ------
set_property LOC GTXE2_CHANNEL_X0Y6 [get_cells AMC_GTXv_init_i/AMC_GTXv_i/U0/gt6_AMC_GTXv_i/gtxe2_i]
##---------- Set placement for gt7_gtx_wrapper_i/GTXE2_CHANNEL ------
set_property LOC GTXE2_CHANNEL_X0Y7 [get_cells AMC_GTXv_init_i/AMC_GTXv_i/U0/gt7_AMC_GTXv_i/gtxe2_i]
##---------- Set placement for gt8_gtx_wrapper_i/GTXE2_CHANNEL ------
set_property LOC GTXE2_CHANNEL_X0Y8 [get_cells AMC_GTXv_init_i/AMC_GTXv_i/U0/gt8_AMC_GTXv_i/gtxe2_i]
##---------- Set placement for gt9_gtx_wrapper_i/GTXE2_CHANNEL ------
set_property LOC GTXE2_CHANNEL_X0Y9 [get_cells AMC_GTXv_init_i/AMC_GTXv_i/U0/gt9_AMC_GTXv_i/gtxe2_i]
##---------- Set placement for gt10_gtx_wrapper_i/GTXE2_CHANNEL ------
set_property LOC GTXE2_CHANNEL_X0Y10 [get_cells AMC_GTXv_init_i/AMC_GTXv_i/U0/gt10_AMC_GTXv_i/gtxe2_i]
##---------- Set placement for gt11_gtx_wrapper_i/GTXE2_CHANNEL ------
set_property LOC GTXE2_CHANNEL_X0Y11 [get_cells AMC_GTXv_init_i/AMC_GTXv_i/U0/gt11_AMC_GTXv_i/gtxe2_i]

##---------- Set ASYNC_REG for flop which have async input ----------
set_property ASYNC_REG TRUE [get_cells -hier -filter {name=~*gt0_frame_gen*system_reset_r_reg}]
set_property ASYNC_REG TRUE [get_cells -hier -filter {name=~*gt0_frame_check*system_reset_r_reg}]
set_property ASYNC_REG TRUE [get_cells -hier -filter {name=~*gt1_frame_gen*system_reset_r_reg}]
set_property ASYNC_REG TRUE [get_cells -hier -filter {name=~*gt1_frame_check*system_reset_r_reg}]
set_property ASYNC_REG TRUE [get_cells -hier -filter {name=~*gt2_frame_gen*system_reset_r_reg}]
set_property ASYNC_REG TRUE [get_cells -hier -filter {name=~*gt2_frame_check*system_reset_r_reg}]
set_property ASYNC_REG TRUE [get_cells -hier -filter {name=~*gt3_frame_gen*system_reset_r_reg}]
set_property ASYNC_REG TRUE [get_cells -hier -filter {name=~*gt3_frame_check*system_reset_r_reg}]
set_property ASYNC_REG TRUE [get_cells -hier -filter {name=~*gt4_frame_gen*system_reset_r_reg}]
set_property ASYNC_REG TRUE [get_cells -hier -filter {name=~*gt4_frame_check*system_reset_r_reg}]
set_property ASYNC_REG TRUE [get_cells -hier -filter {name=~*gt5_frame_gen*system_reset_r_reg}]
set_property ASYNC_REG TRUE [get_cells -hier -filter {name=~*gt5_frame_check*system_reset_r_reg}]
set_property ASYNC_REG TRUE [get_cells -hier -filter {name=~*gt6_frame_gen*system_reset_r_reg}]
set_property ASYNC_REG TRUE [get_cells -hier -filter {name=~*gt6_frame_check*system_reset_r_reg}]
set_property ASYNC_REG TRUE [get_cells -hier -filter {name=~*gt7_frame_gen*system_reset_r_reg}]
set_property ASYNC_REG TRUE [get_cells -hier -filter {name=~*gt7_frame_check*system_reset_r_reg}]
set_property ASYNC_REG TRUE [get_cells -hier -filter {name=~*gt8_frame_gen*system_reset_r_reg}]
set_property ASYNC_REG TRUE [get_cells -hier -filter {name=~*gt8_frame_check*system_reset_r_reg}]
set_property ASYNC_REG TRUE [get_cells -hier -filter {name=~*gt9_frame_gen*system_reset_r_reg}]
set_property ASYNC_REG TRUE [get_cells -hier -filter {name=~*gt9_frame_check*system_reset_r_reg}]
set_property ASYNC_REG TRUE [get_cells -hier -filter {name=~*gt10_frame_gen*system_reset_r_reg}]
set_property ASYNC_REG TRUE [get_cells -hier -filter {name=~*gt10_frame_check*system_reset_r_reg}]
set_property ASYNC_REG TRUE [get_cells -hier -filter {name=~*gt11_frame_gen*system_reset_r_reg}]
set_property ASYNC_REG TRUE [get_cells -hier -filter {name=~*gt11_frame_check*system_reset_r_reg}]

##---------- Set False Path from one clock to other ----------
set_false_path -from [get_clocks "SYSCLK_IN"] -to [get_clocks -include_generated_clocks "gt0_txusrclk_i"]
set_false_path -from [get_clocks -include_generated_clocks "gt0_txusrclk_i"] -to [get_clocks "SYSCLK_IN"]

set_false_path -from [get_clocks "SYSCLK_IN"] -to [get_clocks -include_generated_clocks "gt0_rxusrclk_i"]
set_false_path -from [get_clocks -include_generated_clocks "gt0_rxusrclk_i"] -to [get_clocks "SYSCLK_IN"]


set_false_path -from [get_clocks "drpclk_in_i"] -to [get_clocks -include_generated_clocks "gt0_txusrclk_i"]
set_false_path -from [get_clocks -include_generated_clocks "gt0_txusrclk_i"] -to [get_clocks "drpclk_in_i"]

set_false_path -from [get_clocks "drpclk_in_i"] -to [get_clocks -include_generated_clocks "gt0_rxusrclk_i"]
set_false_path -from [get_clocks -include_generated_clocks "gt0_rxusrclk_i"] -to [get_clocks "drpclk_in_i"]


set_false_path -from [get_clocks "SYSCLK_IN"] -to [get_clocks -include_generated_clocks "gt1_txusrclk_i"]
set_false_path -from [get_clocks -include_generated_clocks "gt1_txusrclk_i"] -to [get_clocks "SYSCLK_IN"]

set_false_path -from [get_clocks "SYSCLK_IN"] -to [get_clocks -include_generated_clocks "gt1_rxusrclk_i"]
set_false_path -from [get_clocks -include_generated_clocks "gt1_rxusrclk_i"] -to [get_clocks "SYSCLK_IN"]


set_false_path -from [get_clocks "drpclk_in_i"] -to [get_clocks -include_generated_clocks "gt1_txusrclk_i"]
set_false_path -from [get_clocks -include_generated_clocks "gt1_txusrclk_i"] -to [get_clocks "drpclk_in_i"]

set_false_path -from [get_clocks "drpclk_in_i"] -to [get_clocks -include_generated_clocks "gt1_rxusrclk_i"]
set_false_path -from [get_clocks -include_generated_clocks "gt1_rxusrclk_i"] -to [get_clocks "drpclk_in_i"]


set_false_path -from [get_clocks "SYSCLK_IN"] -to [get_clocks -include_generated_clocks "gt2_txusrclk_i"]
set_false_path -from [get_clocks -include_generated_clocks "gt2_txusrclk_i"] -to [get_clocks "SYSCLK_IN"]

set_false_path -from [get_clocks "SYSCLK_IN"] -to [get_clocks -include_generated_clocks "gt2_rxusrclk_i"]
set_false_path -from [get_clocks -include_generated_clocks "gt2_rxusrclk_i"] -to [get_clocks "SYSCLK_IN"]


set_false_path -from [get_clocks "drpclk_in_i"] -to [get_clocks -include_generated_clocks "gt2_txusrclk_i"]
set_false_path -from [get_clocks -include_generated_clocks "gt2_txusrclk_i"] -to [get_clocks "drpclk_in_i"]

set_false_path -from [get_clocks "drpclk_in_i"] -to [get_clocks -include_generated_clocks "gt2_rxusrclk_i"]
set_false_path -from [get_clocks -include_generated_clocks "gt2_rxusrclk_i"] -to [get_clocks "drpclk_in_i"]


set_false_path -from [get_clocks "SYSCLK_IN"] -to [get_clocks -include_generated_clocks "gt3_txusrclk_i"]
set_false_path -from [get_clocks -include_generated_clocks "gt3_txusrclk_i"] -to [get_clocks "SYSCLK_IN"]

set_false_path -from [get_clocks "SYSCLK_IN"] -to [get_clocks -include_generated_clocks "gt3_rxusrclk_i"]
set_false_path -from [get_clocks -include_generated_clocks "gt3_rxusrclk_i"] -to [get_clocks "SYSCLK_IN"]


set_false_path -from [get_clocks "drpclk_in_i"] -to [get_clocks -include_generated_clocks "gt3_txusrclk_i"]
set_false_path -from [get_clocks -include_generated_clocks "gt3_txusrclk_i"] -to [get_clocks "drpclk_in_i"]

set_false_path -from [get_clocks "drpclk_in_i"] -to [get_clocks -include_generated_clocks "gt3_rxusrclk_i"]
set_false_path -from [get_clocks -include_generated_clocks "gt3_rxusrclk_i"] -to [get_clocks "drpclk_in_i"]


set_false_path -from [get_clocks "SYSCLK_IN"] -to [get_clocks -include_generated_clocks "gt4_txusrclk_i"]
set_false_path -from [get_clocks -include_generated_clocks "gt4_txusrclk_i"] -to [get_clocks "SYSCLK_IN"]

set_false_path -from [get_clocks "SYSCLK_IN"] -to [get_clocks -include_generated_clocks "gt4_rxusrclk_i"]
set_false_path -from [get_clocks -include_generated_clocks "gt4_rxusrclk_i"] -to [get_clocks "SYSCLK_IN"]


set_false_path -from [get_clocks "drpclk_in_i"] -to [get_clocks -include_generated_clocks "gt4_txusrclk_i"]
set_false_path -from [get_clocks -include_generated_clocks "gt4_txusrclk_i"] -to [get_clocks "drpclk_in_i"]

set_false_path -from [get_clocks "drpclk_in_i"] -to [get_clocks -include_generated_clocks "gt4_rxusrclk_i"]
set_false_path -from [get_clocks -include_generated_clocks "gt4_rxusrclk_i"] -to [get_clocks "drpclk_in_i"]


set_false_path -from [get_clocks "SYSCLK_IN"] -to [get_clocks -include_generated_clocks "gt5_txusrclk_i"]
set_false_path -from [get_clocks -include_generated_clocks "gt5_txusrclk_i"] -to [get_clocks "SYSCLK_IN"]

set_false_path -from [get_clocks "SYSCLK_IN"] -to [get_clocks -include_generated_clocks "gt5_rxusrclk_i"]
set_false_path -from [get_clocks -include_generated_clocks "gt5_rxusrclk_i"] -to [get_clocks "SYSCLK_IN"]


set_false_path -from [get_clocks "drpclk_in_i"] -to [get_clocks -include_generated_clocks "gt5_txusrclk_i"]
set_false_path -from [get_clocks -include_generated_clocks "gt5_txusrclk_i"] -to [get_clocks "drpclk_in_i"]

set_false_path -from [get_clocks "drpclk_in_i"] -to [get_clocks -include_generated_clocks "gt5_rxusrclk_i"]
set_false_path -from [get_clocks -include_generated_clocks "gt5_rxusrclk_i"] -to [get_clocks "drpclk_in_i"]


set_false_path -from [get_clocks "SYSCLK_IN"] -to [get_clocks -include_generated_clocks "gt6_txusrclk_i"]
set_false_path -from [get_clocks -include_generated_clocks "gt6_txusrclk_i"] -to [get_clocks "SYSCLK_IN"]

set_false_path -from [get_clocks "SYSCLK_IN"] -to [get_clocks -include_generated_clocks "gt6_rxusrclk_i"]
set_false_path -from [get_clocks -include_generated_clocks "gt6_rxusrclk_i"] -to [get_clocks "SYSCLK_IN"]


set_false_path -from [get_clocks "drpclk_in_i"] -to [get_clocks -include_generated_clocks "gt6_txusrclk_i"]
set_false_path -from [get_clocks -include_generated_clocks "gt6_txusrclk_i"] -to [get_clocks "drpclk_in_i"]

set_false_path -from [get_clocks "drpclk_in_i"] -to [get_clocks -include_generated_clocks "gt6_rxusrclk_i"]
set_false_path -from [get_clocks -include_generated_clocks "gt6_rxusrclk_i"] -to [get_clocks "drpclk_in_i"]


set_false_path -from [get_clocks "SYSCLK_IN"] -to [get_clocks -include_generated_clocks "gt7_txusrclk_i"]
set_false_path -from [get_clocks -include_generated_clocks "gt7_txusrclk_i"] -to [get_clocks "SYSCLK_IN"]

set_false_path -from [get_clocks "SYSCLK_IN"] -to [get_clocks -include_generated_clocks "gt7_rxusrclk_i"]
set_false_path -from [get_clocks -include_generated_clocks "gt7_rxusrclk_i"] -to [get_clocks "SYSCLK_IN"]


set_false_path -from [get_clocks "drpclk_in_i"] -to [get_clocks -include_generated_clocks "gt7_txusrclk_i"]
set_false_path -from [get_clocks -include_generated_clocks "gt7_txusrclk_i"] -to [get_clocks "drpclk_in_i"]

set_false_path -from [get_clocks "drpclk_in_i"] -to [get_clocks -include_generated_clocks "gt7_rxusrclk_i"]
set_false_path -from [get_clocks -include_generated_clocks "gt7_rxusrclk_i"] -to [get_clocks "drpclk_in_i"]


set_false_path -from [get_clocks "SYSCLK_IN"] -to [get_clocks -include_generated_clocks "gt8_txusrclk_i"]
set_false_path -from [get_clocks -include_generated_clocks "gt8_txusrclk_i"] -to [get_clocks "SYSCLK_IN"]

set_false_path -from [get_clocks "SYSCLK_IN"] -to [get_clocks -include_generated_clocks "gt8_rxusrclk_i"]
set_false_path -from [get_clocks -include_generated_clocks "gt8_rxusrclk_i"] -to [get_clocks "SYSCLK_IN"]


set_false_path -from [get_clocks "drpclk_in_i"] -to [get_clocks -include_generated_clocks "gt8_txusrclk_i"]
set_false_path -from [get_clocks -include_generated_clocks "gt8_txusrclk_i"] -to [get_clocks "drpclk_in_i"]

set_false_path -from [get_clocks "drpclk_in_i"] -to [get_clocks -include_generated_clocks "gt8_rxusrclk_i"]
set_false_path -from [get_clocks -include_generated_clocks "gt8_rxusrclk_i"] -to [get_clocks "drpclk_in_i"]


set_false_path -from [get_clocks "SYSCLK_IN"] -to [get_clocks -include_generated_clocks "gt9_txusrclk_i"]
set_false_path -from [get_clocks -include_generated_clocks "gt9_txusrclk_i"] -to [get_clocks "SYSCLK_IN"]

set_false_path -from [get_clocks "SYSCLK_IN"] -to [get_clocks -include_generated_clocks "gt9_rxusrclk_i"]
set_false_path -from [get_clocks -include_generated_clocks "gt9_rxusrclk_i"] -to [get_clocks "SYSCLK_IN"]


set_false_path -from [get_clocks "drpclk_in_i"] -to [get_clocks -include_generated_clocks "gt9_txusrclk_i"]
set_false_path -from [get_clocks -include_generated_clocks "gt9_txusrclk_i"] -to [get_clocks "drpclk_in_i"]

set_false_path -from [get_clocks "drpclk_in_i"] -to [get_clocks -include_generated_clocks "gt9_rxusrclk_i"]
set_false_path -from [get_clocks -include_generated_clocks "gt9_rxusrclk_i"] -to [get_clocks "drpclk_in_i"]


set_false_path -from [get_clocks "SYSCLK_IN"] -to [get_clocks -include_generated_clocks "gt10_txusrclk_i"]
set_false_path -from [get_clocks -include_generated_clocks "gt10_txusrclk_i"] -to [get_clocks "SYSCLK_IN"]

set_false_path -from [get_clocks "SYSCLK_IN"] -to [get_clocks -include_generated_clocks "gt10_rxusrclk_i"]
set_false_path -from [get_clocks -include_generated_clocks "gt10_rxusrclk_i"] -to [get_clocks "SYSCLK_IN"]


set_false_path -from [get_clocks "drpclk_in_i"] -to [get_clocks -include_generated_clocks "gt10_txusrclk_i"]
set_false_path -from [get_clocks -include_generated_clocks "gt10_txusrclk_i"] -to [get_clocks "drpclk_in_i"]

set_false_path -from [get_clocks "drpclk_in_i"] -to [get_clocks -include_generated_clocks "gt10_rxusrclk_i"]
set_false_path -from [get_clocks -include_generated_clocks "gt10_rxusrclk_i"] -to [get_clocks "drpclk_in_i"]


set_false_path -from [get_clocks "SYSCLK_IN"] -to [get_clocks -include_generated_clocks "gt11_txusrclk_i"]
set_false_path -from [get_clocks -include_generated_clocks "gt11_txusrclk_i"] -to [get_clocks "SYSCLK_IN"]

set_false_path -from [get_clocks "SYSCLK_IN"] -to [get_clocks -include_generated_clocks "gt11_rxusrclk_i"]
set_false_path -from [get_clocks -include_generated_clocks "gt11_rxusrclk_i"] -to [get_clocks "SYSCLK_IN"]


set_false_path -from [get_clocks "drpclk_in_i"] -to [get_clocks -include_generated_clocks "gt11_txusrclk_i"]
set_false_path -from [get_clocks -include_generated_clocks "gt11_txusrclk_i"] -to [get_clocks "drpclk_in_i"]

set_false_path -from [get_clocks "drpclk_in_i"] -to [get_clocks -include_generated_clocks "gt11_rxusrclk_i"]
set_false_path -from [get_clocks -include_generated_clocks "gt11_rxusrclk_i"] -to [get_clocks "drpclk_in_i"]



