------------------------------------------------------------------------------
--   ____  ____
--  /   /\/   /
-- /___/  \  /    Vendor: Xilinx
-- \   \   \/     Version : 2.5
--  \   \         Application : 7 Series FPGAs Transceivers Wizard 
--  /   /         Filename : amc_gtx_init.vhd
-- /___/   /\      
-- \   \  /  \ 
--  \___\/\___\
--
--  Description : This module instantiates the modules required for
--                reset and initialisation of the Transceiver
--
-- Module AMC_GTX_init
-- Generated by Xilinx 7 Series FPGAs Transceivers Wizard
-- 
-- 
-- (c) Copyright 2010-2012 Xilinx, Inc. All rights reserved.
-- 
-- This file contains confidential and proprietary information
-- of Xilinx, Inc. and is protected under U.S. and
-- international copyright and other intellectual property
-- laws.
-- 
-- DISCLAIMER
-- This disclaimer is not a license and does not grant any
-- rights to the materials distributed herewith. Except as
-- otherwise provided in a valid license issued to you by
-- Xilinx, and to the maximum extent permitted by applicable
-- law: (1) THESE MATERIALS ARE MADE AVAILABLE "AS IS" AND
-- WITH ALL FAULTS, AND XILINX HEREBY DISCLAIMS ALL WARRANTIES
-- AND CONDITIONS, EXPRESS, IMPLIED, OR STATUTORY, INCLUDING
-- BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, NON-
-- INFRINGEMENT, OR FITNESS FOR ANY PARTICULAR PURPOSE; and
-- (2) Xilinx shall not be liable (whether in contract or tort,
-- including negligence, or under any other theory of
-- liability) for any loss or damage of any kind or nature
-- related to, arising under or in connection with these
-- materials, including for any direct, or any indirect,
-- special, incidental, or consequential loss or damage
-- (including loss of data, profits, goodwill, or any type of
-- loss or damage suffered as a result of any action brought
-- by a third party) even if such damage or loss was
-- reasonably foreseeable or Xilinx had been advised of the
-- possibility of the same.
-- 
-- CRITICAL APPLICATIONS
-- Xilinx products are not designed or intended to be fail-
-- safe, or for use in any application requiring fail-safe
-- performance, such as life-support or safety devices or
-- systems, Class III medical devices, nuclear facilities,
-- applications related to the deployment of airbags, or any
-- other applications that could lead to death, personal
-- injury, or severe property or environmental damage
-- (individually and collectively, "Critical
-- Applications"). Customer assumes the sole risk and
-- liability of any use of Xilinx products in Critical
-- Applications, subject only to applicable laws and
-- regulations governing limitations on product liability.
-- 
-- THIS COPYRIGHT NOTICE AND DISCLAIMER MUST BE RETAINED AS
-- PART OF THIS FILE AT ALL TIMES. 


library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
use ieee.std_logic_unsigned.all;
library UNISIM;
use UNISIM.VCOMPONENTS.ALL;

--***********************************Entity Declaration************************

entity AMC_GTX_init is
generic
(
    EXAMPLE_SIM_GTRESET_SPEEDUP             : string    := "TRUE";     -- simulation setting for GT SecureIP model
    EXAMPLE_SIMULATION                      : integer   := 0;          -- Set to 1 for simulation
    EQ_MODE                                 : string    := "LPM";         -- Rx Equalization Mode - Set to DFE or LPM
    EXAMPLE_USE_CHIPSCOPE                   : integer   := 0           -- Set to 1 to use Chipscope to drive resets

);
port
(
    SYSCLK_IN                               : in   std_logic;
    SOFT_RESET_IN                           : in   std_logic;
    GT0_TX_FSM_RESET_DONE_OUT               : out  std_logic;
    GT0_RX_FSM_RESET_DONE_OUT               : out  std_logic;
    GT0_DATA_VALID_IN                       : in   std_logic;
    GT1_TX_FSM_RESET_DONE_OUT               : out  std_logic;
    GT1_RX_FSM_RESET_DONE_OUT               : out  std_logic;
    GT1_DATA_VALID_IN                       : in   std_logic;
    GT2_TX_FSM_RESET_DONE_OUT               : out  std_logic;
    GT2_RX_FSM_RESET_DONE_OUT               : out  std_logic;
    GT2_DATA_VALID_IN                       : in   std_logic;
    GT3_TX_FSM_RESET_DONE_OUT               : out  std_logic;
    GT3_RX_FSM_RESET_DONE_OUT               : out  std_logic;
    GT3_DATA_VALID_IN                       : in   std_logic;
    GT4_TX_FSM_RESET_DONE_OUT               : out  std_logic;
    GT4_RX_FSM_RESET_DONE_OUT               : out  std_logic;
    GT4_DATA_VALID_IN                       : in   std_logic;
    GT5_TX_FSM_RESET_DONE_OUT               : out  std_logic;
    GT5_RX_FSM_RESET_DONE_OUT               : out  std_logic;
    GT5_DATA_VALID_IN                       : in   std_logic;
    GT6_TX_FSM_RESET_DONE_OUT               : out  std_logic;
    GT6_RX_FSM_RESET_DONE_OUT               : out  std_logic;
    GT6_DATA_VALID_IN                       : in   std_logic;
    GT7_TX_FSM_RESET_DONE_OUT               : out  std_logic;
    GT7_RX_FSM_RESET_DONE_OUT               : out  std_logic;
    GT7_DATA_VALID_IN                       : in   std_logic;
    GT8_TX_FSM_RESET_DONE_OUT               : out  std_logic;
    GT8_RX_FSM_RESET_DONE_OUT               : out  std_logic;
    GT8_DATA_VALID_IN                       : in   std_logic;
    GT9_TX_FSM_RESET_DONE_OUT               : out  std_logic;
    GT9_RX_FSM_RESET_DONE_OUT               : out  std_logic;
    GT9_DATA_VALID_IN                       : in   std_logic;
    GT10_TX_FSM_RESET_DONE_OUT              : out  std_logic;
    GT10_RX_FSM_RESET_DONE_OUT              : out  std_logic;
    GT10_DATA_VALID_IN                      : in   std_logic;
    GT11_TX_FSM_RESET_DONE_OUT              : out  std_logic;
    GT11_RX_FSM_RESET_DONE_OUT              : out  std_logic;
    GT11_DATA_VALID_IN                      : in   std_logic;

    --_________________________________________________________________________
    --GT0  (X1Y0)
    --____________________________CHANNEL PORTS________________________________
    ---------------------------- Channel - DRP Ports  --------------------------
    GT0_DRPADDR_IN                          : in   std_logic_vector(8 downto 0);
    GT0_DRPCLK_IN                           : in   std_logic;
    GT0_DRPDI_IN                            : in   std_logic_vector(15 downto 0);
    GT0_DRPDO_OUT                           : out  std_logic_vector(15 downto 0);
    GT0_DRPEN_IN                            : in   std_logic;
    GT0_DRPRDY_OUT                          : out  std_logic;
    GT0_DRPWE_IN                            : in   std_logic;
    ------------------------------- Loopback Ports -----------------------------
    GT0_LOOPBACK_IN                         : in   std_logic_vector(2 downto 0);
    --------------------- RX Initialization and Reset Ports --------------------
    GT0_RXUSERRDY_IN                        : in   std_logic;
    -------------------------- RX Margin Analysis Ports ------------------------
    GT0_EYESCANDATAERROR_OUT                : out  std_logic;
    ------------------------- Receive Ports - CDR Ports ------------------------
    GT0_RXCDRLOCK_OUT                       : out  std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    GT0_RXCLKCORCNT_OUT                     : out  std_logic_vector(1 downto 0);
    ------------------ Receive Ports - FPGA RX Interface Ports -----------------
    GT0_RXUSRCLK_IN                         : in   std_logic;
    GT0_RXUSRCLK2_IN                        : in   std_logic;
    ------------------ Receive Ports - FPGA RX interface Ports -----------------
    GT0_RXDATA_OUT                          : out  std_logic_vector(15 downto 0);
    ------------------- Receive Ports - Pattern Checker Ports ------------------
    GT0_RXPRBSERR_OUT                       : out  std_logic;
    GT0_RXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
    ------------------- Receive Ports - Pattern Checker ports ------------------
    GT0_RXPRBSCNTRESET_IN                   : in   std_logic;
    ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
    GT0_RXDISPERR_OUT                       : out  std_logic_vector(1 downto 0);
    GT0_RXNOTINTABLE_OUT                    : out  std_logic_vector(1 downto 0);
    --------------------------- Receive Ports - RX AFE -------------------------
    GT0_GTXRXP_IN                           : in   std_logic;
    ------------------------ Receive Ports - RX AFE Ports ----------------------
    GT0_GTXRXN_IN                           : in   std_logic;
    -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
    GT0_RXMCOMMAALIGNEN_IN                  : in   std_logic;
    GT0_RXPCOMMAALIGNEN_IN                  : in   std_logic;
    --------------------- Receive Ports - RX Equalizer Ports -------------------
    GT0_RXDFELPMRESET_IN                    : in   std_logic;
    ------------- Receive Ports - RX Initialization and Reset Ports ------------
    GT0_GTRXRESET_IN                        : in   std_logic;
    GT0_RXPMARESET_IN                       : in   std_logic;
    ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
    GT0_RXCHARISCOMMA_OUT                   : out  std_logic_vector(1 downto 0);
    GT0_RXCHARISK_OUT                       : out  std_logic_vector(1 downto 0);
    -------------- Receive Ports -RX Initialization and Reset Ports ------------
    GT0_RXRESETDONE_OUT                     : out  std_logic;
    --------------------- TX Initialization and Reset Ports --------------------
    GT0_GTTXRESET_IN                        : in   std_logic;
    GT0_TXUSERRDY_IN                        : in   std_logic;
    ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
    GT0_TXUSRCLK_IN                         : in   std_logic;
    GT0_TXUSRCLK2_IN                        : in   std_logic;
    --------------- Transmit Ports - TX Configurable Driver Ports --------------
    GT0_TXDIFFCTRL_IN                       : in   std_logic_vector(3 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    GT0_TXDATA_IN                           : in   std_logic_vector(15 downto 0);
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    GT0_GTXTXN_OUT                          : out  std_logic;
    GT0_GTXTXP_OUT                          : out  std_logic;
    ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
    GT0_TXOUTCLK_OUT                        : out  std_logic;
    GT0_TXOUTCLKFABRIC_OUT                  : out  std_logic;
    GT0_TXOUTCLKPCS_OUT                     : out  std_logic;
    --------------------- Transmit Ports - TX Gearbox Ports --------------------
    GT0_TXCHARISK_IN                        : in   std_logic_vector(1 downto 0);
    ------------- Transmit Ports - TX Initialization and Reset Ports -----------
    GT0_TXRESETDONE_OUT                     : out  std_logic;
    ------------------ Transmit Ports - pattern Generator Ports ----------------
    GT0_TXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);

    --GT1  (X1Y1)
    --____________________________CHANNEL PORTS________________________________
    ---------------------------- Channel - DRP Ports  --------------------------
    GT1_DRPADDR_IN                          : in   std_logic_vector(8 downto 0);
    GT1_DRPCLK_IN                           : in   std_logic;
    GT1_DRPDI_IN                            : in   std_logic_vector(15 downto 0);
    GT1_DRPDO_OUT                           : out  std_logic_vector(15 downto 0);
    GT1_DRPEN_IN                            : in   std_logic;
    GT1_DRPRDY_OUT                          : out  std_logic;
    GT1_DRPWE_IN                            : in   std_logic;
    ------------------------------- Loopback Ports -----------------------------
    GT1_LOOPBACK_IN                         : in   std_logic_vector(2 downto 0);
    --------------------- RX Initialization and Reset Ports --------------------
    GT1_RXUSERRDY_IN                        : in   std_logic;
    -------------------------- RX Margin Analysis Ports ------------------------
    GT1_EYESCANDATAERROR_OUT                : out  std_logic;
    ------------------------- Receive Ports - CDR Ports ------------------------
    GT1_RXCDRLOCK_OUT                       : out  std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    GT1_RXCLKCORCNT_OUT                     : out  std_logic_vector(1 downto 0);
    ------------------ Receive Ports - FPGA RX Interface Ports -----------------
    GT1_RXUSRCLK_IN                         : in   std_logic;
    GT1_RXUSRCLK2_IN                        : in   std_logic;
    ------------------ Receive Ports - FPGA RX interface Ports -----------------
    GT1_RXDATA_OUT                          : out  std_logic_vector(15 downto 0);
    ------------------- Receive Ports - Pattern Checker Ports ------------------
    GT1_RXPRBSERR_OUT                       : out  std_logic;
    GT1_RXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
    ------------------- Receive Ports - Pattern Checker ports ------------------
    GT1_RXPRBSCNTRESET_IN                   : in   std_logic;
    ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
    GT1_RXDISPERR_OUT                       : out  std_logic_vector(1 downto 0);
    GT1_RXNOTINTABLE_OUT                    : out  std_logic_vector(1 downto 0);
    --------------------------- Receive Ports - RX AFE -------------------------
    GT1_GTXRXP_IN                           : in   std_logic;
    ------------------------ Receive Ports - RX AFE Ports ----------------------
    GT1_GTXRXN_IN                           : in   std_logic;
    -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
    GT1_RXMCOMMAALIGNEN_IN                  : in   std_logic;
    GT1_RXPCOMMAALIGNEN_IN                  : in   std_logic;
    --------------------- Receive Ports - RX Equalizer Ports -------------------
    GT1_RXDFELPMRESET_IN                    : in   std_logic;
    ------------- Receive Ports - RX Initialization and Reset Ports ------------
    GT1_GTRXRESET_IN                        : in   std_logic;
    GT1_RXPMARESET_IN                       : in   std_logic;
    ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
    GT1_RXCHARISCOMMA_OUT                   : out  std_logic_vector(1 downto 0);
    GT1_RXCHARISK_OUT                       : out  std_logic_vector(1 downto 0);
    -------------- Receive Ports -RX Initialization and Reset Ports ------------
    GT1_RXRESETDONE_OUT                     : out  std_logic;
    --------------------- TX Initialization and Reset Ports --------------------
    GT1_GTTXRESET_IN                        : in   std_logic;
    GT1_TXUSERRDY_IN                        : in   std_logic;
    ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
    GT1_TXUSRCLK_IN                         : in   std_logic;
    GT1_TXUSRCLK2_IN                        : in   std_logic;
    --------------- Transmit Ports - TX Configurable Driver Ports --------------
    GT1_TXDIFFCTRL_IN                       : in   std_logic_vector(3 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    GT1_TXDATA_IN                           : in   std_logic_vector(15 downto 0);
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    GT1_GTXTXN_OUT                          : out  std_logic;
    GT1_GTXTXP_OUT                          : out  std_logic;
    ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
    GT1_TXOUTCLK_OUT                        : out  std_logic;
    GT1_TXOUTCLKFABRIC_OUT                  : out  std_logic;
    GT1_TXOUTCLKPCS_OUT                     : out  std_logic;
    --------------------- Transmit Ports - TX Gearbox Ports --------------------
    GT1_TXCHARISK_IN                        : in   std_logic_vector(1 downto 0);
    ------------- Transmit Ports - TX Initialization and Reset Ports -----------
    GT1_TXRESETDONE_OUT                     : out  std_logic;
    ------------------ Transmit Ports - pattern Generator Ports ----------------
    GT1_TXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);

    --GT2  (X1Y2)
    --____________________________CHANNEL PORTS________________________________
    ---------------------------- Channel - DRP Ports  --------------------------
    GT2_DRPADDR_IN                          : in   std_logic_vector(8 downto 0);
    GT2_DRPCLK_IN                           : in   std_logic;
    GT2_DRPDI_IN                            : in   std_logic_vector(15 downto 0);
    GT2_DRPDO_OUT                           : out  std_logic_vector(15 downto 0);
    GT2_DRPEN_IN                            : in   std_logic;
    GT2_DRPRDY_OUT                          : out  std_logic;
    GT2_DRPWE_IN                            : in   std_logic;
    ------------------------------- Loopback Ports -----------------------------
    GT2_LOOPBACK_IN                         : in   std_logic_vector(2 downto 0);
    --------------------- RX Initialization and Reset Ports --------------------
    GT2_RXUSERRDY_IN                        : in   std_logic;
    -------------------------- RX Margin Analysis Ports ------------------------
    GT2_EYESCANDATAERROR_OUT                : out  std_logic;
    ------------------------- Receive Ports - CDR Ports ------------------------
    GT2_RXCDRLOCK_OUT                       : out  std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    GT2_RXCLKCORCNT_OUT                     : out  std_logic_vector(1 downto 0);
    ------------------ Receive Ports - FPGA RX Interface Ports -----------------
    GT2_RXUSRCLK_IN                         : in   std_logic;
    GT2_RXUSRCLK2_IN                        : in   std_logic;
    ------------------ Receive Ports - FPGA RX interface Ports -----------------
    GT2_RXDATA_OUT                          : out  std_logic_vector(15 downto 0);
    ------------------- Receive Ports - Pattern Checker Ports ------------------
    GT2_RXPRBSERR_OUT                       : out  std_logic;
    GT2_RXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
    ------------------- Receive Ports - Pattern Checker ports ------------------
    GT2_RXPRBSCNTRESET_IN                   : in   std_logic;
    ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
    GT2_RXDISPERR_OUT                       : out  std_logic_vector(1 downto 0);
    GT2_RXNOTINTABLE_OUT                    : out  std_logic_vector(1 downto 0);
    --------------------------- Receive Ports - RX AFE -------------------------
    GT2_GTXRXP_IN                           : in   std_logic;
    ------------------------ Receive Ports - RX AFE Ports ----------------------
    GT2_GTXRXN_IN                           : in   std_logic;
    -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
    GT2_RXMCOMMAALIGNEN_IN                  : in   std_logic;
    GT2_RXPCOMMAALIGNEN_IN                  : in   std_logic;
    --------------------- Receive Ports - RX Equalizer Ports -------------------
    GT2_RXDFELPMRESET_IN                    : in   std_logic;
    ------------- Receive Ports - RX Initialization and Reset Ports ------------
    GT2_GTRXRESET_IN                        : in   std_logic;
    GT2_RXPMARESET_IN                       : in   std_logic;
    ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
    GT2_RXCHARISCOMMA_OUT                   : out  std_logic_vector(1 downto 0);
    GT2_RXCHARISK_OUT                       : out  std_logic_vector(1 downto 0);
    -------------- Receive Ports -RX Initialization and Reset Ports ------------
    GT2_RXRESETDONE_OUT                     : out  std_logic;
    --------------------- TX Initialization and Reset Ports --------------------
    GT2_GTTXRESET_IN                        : in   std_logic;
    GT2_TXUSERRDY_IN                        : in   std_logic;
    ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
    GT2_TXUSRCLK_IN                         : in   std_logic;
    GT2_TXUSRCLK2_IN                        : in   std_logic;
    --------------- Transmit Ports - TX Configurable Driver Ports --------------
    GT2_TXDIFFCTRL_IN                       : in   std_logic_vector(3 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    GT2_TXDATA_IN                           : in   std_logic_vector(15 downto 0);
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    GT2_GTXTXN_OUT                          : out  std_logic;
    GT2_GTXTXP_OUT                          : out  std_logic;
    ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
    GT2_TXOUTCLK_OUT                        : out  std_logic;
    GT2_TXOUTCLKFABRIC_OUT                  : out  std_logic;
    GT2_TXOUTCLKPCS_OUT                     : out  std_logic;
    --------------------- Transmit Ports - TX Gearbox Ports --------------------
    GT2_TXCHARISK_IN                        : in   std_logic_vector(1 downto 0);
    ------------- Transmit Ports - TX Initialization and Reset Ports -----------
    GT2_TXRESETDONE_OUT                     : out  std_logic;
    ------------------ Transmit Ports - pattern Generator Ports ----------------
    GT2_TXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);

    --GT3  (X1Y3)
    --____________________________CHANNEL PORTS________________________________
    ---------------------------- Channel - DRP Ports  --------------------------
    GT3_DRPADDR_IN                          : in   std_logic_vector(8 downto 0);
    GT3_DRPCLK_IN                           : in   std_logic;
    GT3_DRPDI_IN                            : in   std_logic_vector(15 downto 0);
    GT3_DRPDO_OUT                           : out  std_logic_vector(15 downto 0);
    GT3_DRPEN_IN                            : in   std_logic;
    GT3_DRPRDY_OUT                          : out  std_logic;
    GT3_DRPWE_IN                            : in   std_logic;
    ------------------------------- Loopback Ports -----------------------------
    GT3_LOOPBACK_IN                         : in   std_logic_vector(2 downto 0);
    --------------------- RX Initialization and Reset Ports --------------------
    GT3_RXUSERRDY_IN                        : in   std_logic;
    -------------------------- RX Margin Analysis Ports ------------------------
    GT3_EYESCANDATAERROR_OUT                : out  std_logic;
    ------------------------- Receive Ports - CDR Ports ------------------------
    GT3_RXCDRLOCK_OUT                       : out  std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    GT3_RXCLKCORCNT_OUT                     : out  std_logic_vector(1 downto 0);
    ------------------ Receive Ports - FPGA RX Interface Ports -----------------
    GT3_RXUSRCLK_IN                         : in   std_logic;
    GT3_RXUSRCLK2_IN                        : in   std_logic;
    ------------------ Receive Ports - FPGA RX interface Ports -----------------
    GT3_RXDATA_OUT                          : out  std_logic_vector(15 downto 0);
    ------------------- Receive Ports - Pattern Checker Ports ------------------
    GT3_RXPRBSERR_OUT                       : out  std_logic;
    GT3_RXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
    ------------------- Receive Ports - Pattern Checker ports ------------------
    GT3_RXPRBSCNTRESET_IN                   : in   std_logic;
    ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
    GT3_RXDISPERR_OUT                       : out  std_logic_vector(1 downto 0);
    GT3_RXNOTINTABLE_OUT                    : out  std_logic_vector(1 downto 0);
    --------------------------- Receive Ports - RX AFE -------------------------
    GT3_GTXRXP_IN                           : in   std_logic;
    ------------------------ Receive Ports - RX AFE Ports ----------------------
    GT3_GTXRXN_IN                           : in   std_logic;
    -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
    GT3_RXMCOMMAALIGNEN_IN                  : in   std_logic;
    GT3_RXPCOMMAALIGNEN_IN                  : in   std_logic;
    --------------------- Receive Ports - RX Equalizer Ports -------------------
    GT3_RXDFELPMRESET_IN                    : in   std_logic;
    ------------- Receive Ports - RX Initialization and Reset Ports ------------
    GT3_GTRXRESET_IN                        : in   std_logic;
    GT3_RXPMARESET_IN                       : in   std_logic;
    ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
    GT3_RXCHARISCOMMA_OUT                   : out  std_logic_vector(1 downto 0);
    GT3_RXCHARISK_OUT                       : out  std_logic_vector(1 downto 0);
    -------------- Receive Ports -RX Initialization and Reset Ports ------------
    GT3_RXRESETDONE_OUT                     : out  std_logic;
    --------------------- TX Initialization and Reset Ports --------------------
    GT3_GTTXRESET_IN                        : in   std_logic;
    GT3_TXUSERRDY_IN                        : in   std_logic;
    ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
    GT3_TXUSRCLK_IN                         : in   std_logic;
    GT3_TXUSRCLK2_IN                        : in   std_logic;
    --------------- Transmit Ports - TX Configurable Driver Ports --------------
    GT3_TXDIFFCTRL_IN                       : in   std_logic_vector(3 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    GT3_TXDATA_IN                           : in   std_logic_vector(15 downto 0);
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    GT3_GTXTXN_OUT                          : out  std_logic;
    GT3_GTXTXP_OUT                          : out  std_logic;
    ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
    GT3_TXOUTCLK_OUT                        : out  std_logic;
    GT3_TXOUTCLKFABRIC_OUT                  : out  std_logic;
    GT3_TXOUTCLKPCS_OUT                     : out  std_logic;
    --------------------- Transmit Ports - TX Gearbox Ports --------------------
    GT3_TXCHARISK_IN                        : in   std_logic_vector(1 downto 0);
    ------------- Transmit Ports - TX Initialization and Reset Ports -----------
    GT3_TXRESETDONE_OUT                     : out  std_logic;
    ------------------ Transmit Ports - pattern Generator Ports ----------------
    GT3_TXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);

    --GT4  (X1Y4)
    --____________________________CHANNEL PORTS________________________________
    ---------------------------- Channel - DRP Ports  --------------------------
    GT4_DRPADDR_IN                          : in   std_logic_vector(8 downto 0);
    GT4_DRPCLK_IN                           : in   std_logic;
    GT4_DRPDI_IN                            : in   std_logic_vector(15 downto 0);
    GT4_DRPDO_OUT                           : out  std_logic_vector(15 downto 0);
    GT4_DRPEN_IN                            : in   std_logic;
    GT4_DRPRDY_OUT                          : out  std_logic;
    GT4_DRPWE_IN                            : in   std_logic;
    ------------------------------- Loopback Ports -----------------------------
    GT4_LOOPBACK_IN                         : in   std_logic_vector(2 downto 0);
    --------------------- RX Initialization and Reset Ports --------------------
    GT4_RXUSERRDY_IN                        : in   std_logic;
    -------------------------- RX Margin Analysis Ports ------------------------
    GT4_EYESCANDATAERROR_OUT                : out  std_logic;
    ------------------------- Receive Ports - CDR Ports ------------------------
    GT4_RXCDRLOCK_OUT                       : out  std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    GT4_RXCLKCORCNT_OUT                     : out  std_logic_vector(1 downto 0);
    ------------------ Receive Ports - FPGA RX Interface Ports -----------------
    GT4_RXUSRCLK_IN                         : in   std_logic;
    GT4_RXUSRCLK2_IN                        : in   std_logic;
    ------------------ Receive Ports - FPGA RX interface Ports -----------------
    GT4_RXDATA_OUT                          : out  std_logic_vector(15 downto 0);
    ------------------- Receive Ports - Pattern Checker Ports ------------------
    GT4_RXPRBSERR_OUT                       : out  std_logic;
    GT4_RXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
    ------------------- Receive Ports - Pattern Checker ports ------------------
    GT4_RXPRBSCNTRESET_IN                   : in   std_logic;
    ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
    GT4_RXDISPERR_OUT                       : out  std_logic_vector(1 downto 0);
    GT4_RXNOTINTABLE_OUT                    : out  std_logic_vector(1 downto 0);
    --------------------------- Receive Ports - RX AFE -------------------------
    GT4_GTXRXP_IN                           : in   std_logic;
    ------------------------ Receive Ports - RX AFE Ports ----------------------
    GT4_GTXRXN_IN                           : in   std_logic;
    -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
    GT4_RXMCOMMAALIGNEN_IN                  : in   std_logic;
    GT4_RXPCOMMAALIGNEN_IN                  : in   std_logic;
    --------------------- Receive Ports - RX Equalizer Ports -------------------
    GT4_RXDFELPMRESET_IN                    : in   std_logic;
    ------------- Receive Ports - RX Initialization and Reset Ports ------------
    GT4_GTRXRESET_IN                        : in   std_logic;
    GT4_RXPMARESET_IN                       : in   std_logic;
    ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
    GT4_RXCHARISCOMMA_OUT                   : out  std_logic_vector(1 downto 0);
    GT4_RXCHARISK_OUT                       : out  std_logic_vector(1 downto 0);
    -------------- Receive Ports -RX Initialization and Reset Ports ------------
    GT4_RXRESETDONE_OUT                     : out  std_logic;
    --------------------- TX Initialization and Reset Ports --------------------
    GT4_GTTXRESET_IN                        : in   std_logic;
    GT4_TXUSERRDY_IN                        : in   std_logic;
    ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
    GT4_TXUSRCLK_IN                         : in   std_logic;
    GT4_TXUSRCLK2_IN                        : in   std_logic;
    --------------- Transmit Ports - TX Configurable Driver Ports --------------
    GT4_TXDIFFCTRL_IN                       : in   std_logic_vector(3 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    GT4_TXDATA_IN                           : in   std_logic_vector(15 downto 0);
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    GT4_GTXTXN_OUT                          : out  std_logic;
    GT4_GTXTXP_OUT                          : out  std_logic;
    ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
    GT4_TXOUTCLK_OUT                        : out  std_logic;
    GT4_TXOUTCLKFABRIC_OUT                  : out  std_logic;
    GT4_TXOUTCLKPCS_OUT                     : out  std_logic;
    --------------------- Transmit Ports - TX Gearbox Ports --------------------
    GT4_TXCHARISK_IN                        : in   std_logic_vector(1 downto 0);
    ------------- Transmit Ports - TX Initialization and Reset Ports -----------
    GT4_TXRESETDONE_OUT                     : out  std_logic;
    ------------------ Transmit Ports - pattern Generator Ports ----------------
    GT4_TXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);

    --GT5  (X1Y5)
    --____________________________CHANNEL PORTS________________________________
    ---------------------------- Channel - DRP Ports  --------------------------
    GT5_DRPADDR_IN                          : in   std_logic_vector(8 downto 0);
    GT5_DRPCLK_IN                           : in   std_logic;
    GT5_DRPDI_IN                            : in   std_logic_vector(15 downto 0);
    GT5_DRPDO_OUT                           : out  std_logic_vector(15 downto 0);
    GT5_DRPEN_IN                            : in   std_logic;
    GT5_DRPRDY_OUT                          : out  std_logic;
    GT5_DRPWE_IN                            : in   std_logic;
    ------------------------------- Loopback Ports -----------------------------
    GT5_LOOPBACK_IN                         : in   std_logic_vector(2 downto 0);
    --------------------- RX Initialization and Reset Ports --------------------
    GT5_RXUSERRDY_IN                        : in   std_logic;
    -------------------------- RX Margin Analysis Ports ------------------------
    GT5_EYESCANDATAERROR_OUT                : out  std_logic;
    ------------------------- Receive Ports - CDR Ports ------------------------
    GT5_RXCDRLOCK_OUT                       : out  std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    GT5_RXCLKCORCNT_OUT                     : out  std_logic_vector(1 downto 0);
    ------------------ Receive Ports - FPGA RX Interface Ports -----------------
    GT5_RXUSRCLK_IN                         : in   std_logic;
    GT5_RXUSRCLK2_IN                        : in   std_logic;
    ------------------ Receive Ports - FPGA RX interface Ports -----------------
    GT5_RXDATA_OUT                          : out  std_logic_vector(15 downto 0);
    ------------------- Receive Ports - Pattern Checker Ports ------------------
    GT5_RXPRBSERR_OUT                       : out  std_logic;
    GT5_RXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
    ------------------- Receive Ports - Pattern Checker ports ------------------
    GT5_RXPRBSCNTRESET_IN                   : in   std_logic;
    ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
    GT5_RXDISPERR_OUT                       : out  std_logic_vector(1 downto 0);
    GT5_RXNOTINTABLE_OUT                    : out  std_logic_vector(1 downto 0);
    --------------------------- Receive Ports - RX AFE -------------------------
    GT5_GTXRXP_IN                           : in   std_logic;
    ------------------------ Receive Ports - RX AFE Ports ----------------------
    GT5_GTXRXN_IN                           : in   std_logic;
    -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
    GT5_RXMCOMMAALIGNEN_IN                  : in   std_logic;
    GT5_RXPCOMMAALIGNEN_IN                  : in   std_logic;
    --------------------- Receive Ports - RX Equalizer Ports -------------------
    GT5_RXDFELPMRESET_IN                    : in   std_logic;
    ------------- Receive Ports - RX Initialization and Reset Ports ------------
    GT5_GTRXRESET_IN                        : in   std_logic;
    GT5_RXPMARESET_IN                       : in   std_logic;
    ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
    GT5_RXCHARISCOMMA_OUT                   : out  std_logic_vector(1 downto 0);
    GT5_RXCHARISK_OUT                       : out  std_logic_vector(1 downto 0);
    -------------- Receive Ports -RX Initialization and Reset Ports ------------
    GT5_RXRESETDONE_OUT                     : out  std_logic;
    --------------------- TX Initialization and Reset Ports --------------------
    GT5_GTTXRESET_IN                        : in   std_logic;
    GT5_TXUSERRDY_IN                        : in   std_logic;
    ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
    GT5_TXUSRCLK_IN                         : in   std_logic;
    GT5_TXUSRCLK2_IN                        : in   std_logic;
    --------------- Transmit Ports - TX Configurable Driver Ports --------------
    GT5_TXDIFFCTRL_IN                       : in   std_logic_vector(3 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    GT5_TXDATA_IN                           : in   std_logic_vector(15 downto 0);
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    GT5_GTXTXN_OUT                          : out  std_logic;
    GT5_GTXTXP_OUT                          : out  std_logic;
    ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
    GT5_TXOUTCLK_OUT                        : out  std_logic;
    GT5_TXOUTCLKFABRIC_OUT                  : out  std_logic;
    GT5_TXOUTCLKPCS_OUT                     : out  std_logic;
    --------------------- Transmit Ports - TX Gearbox Ports --------------------
    GT5_TXCHARISK_IN                        : in   std_logic_vector(1 downto 0);
    ------------- Transmit Ports - TX Initialization and Reset Ports -----------
    GT5_TXRESETDONE_OUT                     : out  std_logic;
    ------------------ Transmit Ports - pattern Generator Ports ----------------
    GT5_TXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);

    --GT6  (X1Y6)
    --____________________________CHANNEL PORTS________________________________
    ---------------------------- Channel - DRP Ports  --------------------------
    GT6_DRPADDR_IN                          : in   std_logic_vector(8 downto 0);
    GT6_DRPCLK_IN                           : in   std_logic;
    GT6_DRPDI_IN                            : in   std_logic_vector(15 downto 0);
    GT6_DRPDO_OUT                           : out  std_logic_vector(15 downto 0);
    GT6_DRPEN_IN                            : in   std_logic;
    GT6_DRPRDY_OUT                          : out  std_logic;
    GT6_DRPWE_IN                            : in   std_logic;
    ------------------------------- Loopback Ports -----------------------------
    GT6_LOOPBACK_IN                         : in   std_logic_vector(2 downto 0);
    --------------------- RX Initialization and Reset Ports --------------------
    GT6_RXUSERRDY_IN                        : in   std_logic;
    -------------------------- RX Margin Analysis Ports ------------------------
    GT6_EYESCANDATAERROR_OUT                : out  std_logic;
    ------------------------- Receive Ports - CDR Ports ------------------------
    GT6_RXCDRLOCK_OUT                       : out  std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    GT6_RXCLKCORCNT_OUT                     : out  std_logic_vector(1 downto 0);
    ------------------ Receive Ports - FPGA RX Interface Ports -----------------
    GT6_RXUSRCLK_IN                         : in   std_logic;
    GT6_RXUSRCLK2_IN                        : in   std_logic;
    ------------------ Receive Ports - FPGA RX interface Ports -----------------
    GT6_RXDATA_OUT                          : out  std_logic_vector(15 downto 0);
    ------------------- Receive Ports - Pattern Checker Ports ------------------
    GT6_RXPRBSERR_OUT                       : out  std_logic;
    GT6_RXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
    ------------------- Receive Ports - Pattern Checker ports ------------------
    GT6_RXPRBSCNTRESET_IN                   : in   std_logic;
    ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
    GT6_RXDISPERR_OUT                       : out  std_logic_vector(1 downto 0);
    GT6_RXNOTINTABLE_OUT                    : out  std_logic_vector(1 downto 0);
    --------------------------- Receive Ports - RX AFE -------------------------
    GT6_GTXRXP_IN                           : in   std_logic;
    ------------------------ Receive Ports - RX AFE Ports ----------------------
    GT6_GTXRXN_IN                           : in   std_logic;
    -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
    GT6_RXMCOMMAALIGNEN_IN                  : in   std_logic;
    GT6_RXPCOMMAALIGNEN_IN                  : in   std_logic;
    --------------------- Receive Ports - RX Equalizer Ports -------------------
    GT6_RXDFELPMRESET_IN                    : in   std_logic;
    ------------- Receive Ports - RX Initialization and Reset Ports ------------
    GT6_GTRXRESET_IN                        : in   std_logic;
    GT6_RXPMARESET_IN                       : in   std_logic;
    ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
    GT6_RXCHARISCOMMA_OUT                   : out  std_logic_vector(1 downto 0);
    GT6_RXCHARISK_OUT                       : out  std_logic_vector(1 downto 0);
    -------------- Receive Ports -RX Initialization and Reset Ports ------------
    GT6_RXRESETDONE_OUT                     : out  std_logic;
    --------------------- TX Initialization and Reset Ports --------------------
    GT6_GTTXRESET_IN                        : in   std_logic;
    GT6_TXUSERRDY_IN                        : in   std_logic;
    ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
    GT6_TXUSRCLK_IN                         : in   std_logic;
    GT6_TXUSRCLK2_IN                        : in   std_logic;
    --------------- Transmit Ports - TX Configurable Driver Ports --------------
    GT6_TXDIFFCTRL_IN                       : in   std_logic_vector(3 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    GT6_TXDATA_IN                           : in   std_logic_vector(15 downto 0);
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    GT6_GTXTXN_OUT                          : out  std_logic;
    GT6_GTXTXP_OUT                          : out  std_logic;
    ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
    GT6_TXOUTCLK_OUT                        : out  std_logic;
    GT6_TXOUTCLKFABRIC_OUT                  : out  std_logic;
    GT6_TXOUTCLKPCS_OUT                     : out  std_logic;
    --------------------- Transmit Ports - TX Gearbox Ports --------------------
    GT6_TXCHARISK_IN                        : in   std_logic_vector(1 downto 0);
    ------------- Transmit Ports - TX Initialization and Reset Ports -----------
    GT6_TXRESETDONE_OUT                     : out  std_logic;
    ------------------ Transmit Ports - pattern Generator Ports ----------------
    GT6_TXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);

    --GT7  (X1Y7)
    --____________________________CHANNEL PORTS________________________________
    ---------------------------- Channel - DRP Ports  --------------------------
    GT7_DRPADDR_IN                          : in   std_logic_vector(8 downto 0);
    GT7_DRPCLK_IN                           : in   std_logic;
    GT7_DRPDI_IN                            : in   std_logic_vector(15 downto 0);
    GT7_DRPDO_OUT                           : out  std_logic_vector(15 downto 0);
    GT7_DRPEN_IN                            : in   std_logic;
    GT7_DRPRDY_OUT                          : out  std_logic;
    GT7_DRPWE_IN                            : in   std_logic;
    ------------------------------- Loopback Ports -----------------------------
    GT7_LOOPBACK_IN                         : in   std_logic_vector(2 downto 0);
    --------------------- RX Initialization and Reset Ports --------------------
    GT7_RXUSERRDY_IN                        : in   std_logic;
    -------------------------- RX Margin Analysis Ports ------------------------
    GT7_EYESCANDATAERROR_OUT                : out  std_logic;
    ------------------------- Receive Ports - CDR Ports ------------------------
    GT7_RXCDRLOCK_OUT                       : out  std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    GT7_RXCLKCORCNT_OUT                     : out  std_logic_vector(1 downto 0);
    ------------------ Receive Ports - FPGA RX Interface Ports -----------------
    GT7_RXUSRCLK_IN                         : in   std_logic;
    GT7_RXUSRCLK2_IN                        : in   std_logic;
    ------------------ Receive Ports - FPGA RX interface Ports -----------------
    GT7_RXDATA_OUT                          : out  std_logic_vector(15 downto 0);
    ------------------- Receive Ports - Pattern Checker Ports ------------------
    GT7_RXPRBSERR_OUT                       : out  std_logic;
    GT7_RXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
    ------------------- Receive Ports - Pattern Checker ports ------------------
    GT7_RXPRBSCNTRESET_IN                   : in   std_logic;
    ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
    GT7_RXDISPERR_OUT                       : out  std_logic_vector(1 downto 0);
    GT7_RXNOTINTABLE_OUT                    : out  std_logic_vector(1 downto 0);
    --------------------------- Receive Ports - RX AFE -------------------------
    GT7_GTXRXP_IN                           : in   std_logic;
    ------------------------ Receive Ports - RX AFE Ports ----------------------
    GT7_GTXRXN_IN                           : in   std_logic;
    -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
    GT7_RXMCOMMAALIGNEN_IN                  : in   std_logic;
    GT7_RXPCOMMAALIGNEN_IN                  : in   std_logic;
    --------------------- Receive Ports - RX Equalizer Ports -------------------
    GT7_RXDFELPMRESET_IN                    : in   std_logic;
    ------------- Receive Ports - RX Initialization and Reset Ports ------------
    GT7_GTRXRESET_IN                        : in   std_logic;
    GT7_RXPMARESET_IN                       : in   std_logic;
    ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
    GT7_RXCHARISCOMMA_OUT                   : out  std_logic_vector(1 downto 0);
    GT7_RXCHARISK_OUT                       : out  std_logic_vector(1 downto 0);
    -------------- Receive Ports -RX Initialization and Reset Ports ------------
    GT7_RXRESETDONE_OUT                     : out  std_logic;
    --------------------- TX Initialization and Reset Ports --------------------
    GT7_GTTXRESET_IN                        : in   std_logic;
    GT7_TXUSERRDY_IN                        : in   std_logic;
    ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
    GT7_TXUSRCLK_IN                         : in   std_logic;
    GT7_TXUSRCLK2_IN                        : in   std_logic;
    --------------- Transmit Ports - TX Configurable Driver Ports --------------
    GT7_TXDIFFCTRL_IN                       : in   std_logic_vector(3 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    GT7_TXDATA_IN                           : in   std_logic_vector(15 downto 0);
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    GT7_GTXTXN_OUT                          : out  std_logic;
    GT7_GTXTXP_OUT                          : out  std_logic;
    ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
    GT7_TXOUTCLK_OUT                        : out  std_logic;
    GT7_TXOUTCLKFABRIC_OUT                  : out  std_logic;
    GT7_TXOUTCLKPCS_OUT                     : out  std_logic;
    --------------------- Transmit Ports - TX Gearbox Ports --------------------
    GT7_TXCHARISK_IN                        : in   std_logic_vector(1 downto 0);
    ------------- Transmit Ports - TX Initialization and Reset Ports -----------
    GT7_TXRESETDONE_OUT                     : out  std_logic;
    ------------------ Transmit Ports - pattern Generator Ports ----------------
    GT7_TXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);

    --GT8  (X1Y8)
    --____________________________CHANNEL PORTS________________________________
    ---------------------------- Channel - DRP Ports  --------------------------
    GT8_DRPADDR_IN                          : in   std_logic_vector(8 downto 0);
    GT8_DRPCLK_IN                           : in   std_logic;
    GT8_DRPDI_IN                            : in   std_logic_vector(15 downto 0);
    GT8_DRPDO_OUT                           : out  std_logic_vector(15 downto 0);
    GT8_DRPEN_IN                            : in   std_logic;
    GT8_DRPRDY_OUT                          : out  std_logic;
    GT8_DRPWE_IN                            : in   std_logic;
    ------------------------------- Loopback Ports -----------------------------
    GT8_LOOPBACK_IN                         : in   std_logic_vector(2 downto 0);
    --------------------- RX Initialization and Reset Ports --------------------
    GT8_RXUSERRDY_IN                        : in   std_logic;
    -------------------------- RX Margin Analysis Ports ------------------------
    GT8_EYESCANDATAERROR_OUT                : out  std_logic;
    ------------------------- Receive Ports - CDR Ports ------------------------
    GT8_RXCDRLOCK_OUT                       : out  std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    GT8_RXCLKCORCNT_OUT                     : out  std_logic_vector(1 downto 0);
    ------------------ Receive Ports - FPGA RX Interface Ports -----------------
    GT8_RXUSRCLK_IN                         : in   std_logic;
    GT8_RXUSRCLK2_IN                        : in   std_logic;
    ------------------ Receive Ports - FPGA RX interface Ports -----------------
    GT8_RXDATA_OUT                          : out  std_logic_vector(15 downto 0);
    ------------------- Receive Ports - Pattern Checker Ports ------------------
    GT8_RXPRBSERR_OUT                       : out  std_logic;
    GT8_RXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
    ------------------- Receive Ports - Pattern Checker ports ------------------
    GT8_RXPRBSCNTRESET_IN                   : in   std_logic;
    ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
    GT8_RXDISPERR_OUT                       : out  std_logic_vector(1 downto 0);
    GT8_RXNOTINTABLE_OUT                    : out  std_logic_vector(1 downto 0);
    --------------------------- Receive Ports - RX AFE -------------------------
    GT8_GTXRXP_IN                           : in   std_logic;
    ------------------------ Receive Ports - RX AFE Ports ----------------------
    GT8_GTXRXN_IN                           : in   std_logic;
    -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
    GT8_RXMCOMMAALIGNEN_IN                  : in   std_logic;
    GT8_RXPCOMMAALIGNEN_IN                  : in   std_logic;
    --------------------- Receive Ports - RX Equalizer Ports -------------------
    GT8_RXDFELPMRESET_IN                    : in   std_logic;
    ------------- Receive Ports - RX Initialization and Reset Ports ------------
    GT8_GTRXRESET_IN                        : in   std_logic;
    GT8_RXPMARESET_IN                       : in   std_logic;
    ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
    GT8_RXCHARISCOMMA_OUT                   : out  std_logic_vector(1 downto 0);
    GT8_RXCHARISK_OUT                       : out  std_logic_vector(1 downto 0);
    -------------- Receive Ports -RX Initialization and Reset Ports ------------
    GT8_RXRESETDONE_OUT                     : out  std_logic;
    --------------------- TX Initialization and Reset Ports --------------------
    GT8_GTTXRESET_IN                        : in   std_logic;
    GT8_TXUSERRDY_IN                        : in   std_logic;
    ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
    GT8_TXUSRCLK_IN                         : in   std_logic;
    GT8_TXUSRCLK2_IN                        : in   std_logic;
    --------------- Transmit Ports - TX Configurable Driver Ports --------------
    GT8_TXDIFFCTRL_IN                       : in   std_logic_vector(3 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    GT8_TXDATA_IN                           : in   std_logic_vector(15 downto 0);
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    GT8_GTXTXN_OUT                          : out  std_logic;
    GT8_GTXTXP_OUT                          : out  std_logic;
    ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
    GT8_TXOUTCLK_OUT                        : out  std_logic;
    GT8_TXOUTCLKFABRIC_OUT                  : out  std_logic;
    GT8_TXOUTCLKPCS_OUT                     : out  std_logic;
    --------------------- Transmit Ports - TX Gearbox Ports --------------------
    GT8_TXCHARISK_IN                        : in   std_logic_vector(1 downto 0);
    ------------- Transmit Ports - TX Initialization and Reset Ports -----------
    GT8_TXRESETDONE_OUT                     : out  std_logic;
    ------------------ Transmit Ports - pattern Generator Ports ----------------
    GT8_TXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);

    --GT9  (X1Y9)
    --____________________________CHANNEL PORTS________________________________
    ---------------------------- Channel - DRP Ports  --------------------------
    GT9_DRPADDR_IN                          : in   std_logic_vector(8 downto 0);
    GT9_DRPCLK_IN                           : in   std_logic;
    GT9_DRPDI_IN                            : in   std_logic_vector(15 downto 0);
    GT9_DRPDO_OUT                           : out  std_logic_vector(15 downto 0);
    GT9_DRPEN_IN                            : in   std_logic;
    GT9_DRPRDY_OUT                          : out  std_logic;
    GT9_DRPWE_IN                            : in   std_logic;
    ------------------------------- Loopback Ports -----------------------------
    GT9_LOOPBACK_IN                         : in   std_logic_vector(2 downto 0);
    --------------------- RX Initialization and Reset Ports --------------------
    GT9_RXUSERRDY_IN                        : in   std_logic;
    -------------------------- RX Margin Analysis Ports ------------------------
    GT9_EYESCANDATAERROR_OUT                : out  std_logic;
    ------------------------- Receive Ports - CDR Ports ------------------------
    GT9_RXCDRLOCK_OUT                       : out  std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    GT9_RXCLKCORCNT_OUT                     : out  std_logic_vector(1 downto 0);
    ------------------ Receive Ports - FPGA RX Interface Ports -----------------
    GT9_RXUSRCLK_IN                         : in   std_logic;
    GT9_RXUSRCLK2_IN                        : in   std_logic;
    ------------------ Receive Ports - FPGA RX interface Ports -----------------
    GT9_RXDATA_OUT                          : out  std_logic_vector(15 downto 0);
    ------------------- Receive Ports - Pattern Checker Ports ------------------
    GT9_RXPRBSERR_OUT                       : out  std_logic;
    GT9_RXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
    ------------------- Receive Ports - Pattern Checker ports ------------------
    GT9_RXPRBSCNTRESET_IN                   : in   std_logic;
    ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
    GT9_RXDISPERR_OUT                       : out  std_logic_vector(1 downto 0);
    GT9_RXNOTINTABLE_OUT                    : out  std_logic_vector(1 downto 0);
    --------------------------- Receive Ports - RX AFE -------------------------
    GT9_GTXRXP_IN                           : in   std_logic;
    ------------------------ Receive Ports - RX AFE Ports ----------------------
    GT9_GTXRXN_IN                           : in   std_logic;
    -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
    GT9_RXMCOMMAALIGNEN_IN                  : in   std_logic;
    GT9_RXPCOMMAALIGNEN_IN                  : in   std_logic;
    --------------------- Receive Ports - RX Equalizer Ports -------------------
    GT9_RXDFELPMRESET_IN                    : in   std_logic;
    ------------- Receive Ports - RX Initialization and Reset Ports ------------
    GT9_GTRXRESET_IN                        : in   std_logic;
    GT9_RXPMARESET_IN                       : in   std_logic;
    ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
    GT9_RXCHARISCOMMA_OUT                   : out  std_logic_vector(1 downto 0);
    GT9_RXCHARISK_OUT                       : out  std_logic_vector(1 downto 0);
    -------------- Receive Ports -RX Initialization and Reset Ports ------------
    GT9_RXRESETDONE_OUT                     : out  std_logic;
    --------------------- TX Initialization and Reset Ports --------------------
    GT9_GTTXRESET_IN                        : in   std_logic;
    GT9_TXUSERRDY_IN                        : in   std_logic;
    ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
    GT9_TXUSRCLK_IN                         : in   std_logic;
    GT9_TXUSRCLK2_IN                        : in   std_logic;
    --------------- Transmit Ports - TX Configurable Driver Ports --------------
    GT9_TXDIFFCTRL_IN                       : in   std_logic_vector(3 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    GT9_TXDATA_IN                           : in   std_logic_vector(15 downto 0);
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    GT9_GTXTXN_OUT                          : out  std_logic;
    GT9_GTXTXP_OUT                          : out  std_logic;
    ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
    GT9_TXOUTCLK_OUT                        : out  std_logic;
    GT9_TXOUTCLKFABRIC_OUT                  : out  std_logic;
    GT9_TXOUTCLKPCS_OUT                     : out  std_logic;
    --------------------- Transmit Ports - TX Gearbox Ports --------------------
    GT9_TXCHARISK_IN                        : in   std_logic_vector(1 downto 0);
    ------------- Transmit Ports - TX Initialization and Reset Ports -----------
    GT9_TXRESETDONE_OUT                     : out  std_logic;
    ------------------ Transmit Ports - pattern Generator Ports ----------------
    GT9_TXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);

    --GT10  (X1Y10)
    --____________________________CHANNEL PORTS________________________________
    ---------------------------- Channel - DRP Ports  --------------------------
    GT10_DRPADDR_IN                         : in   std_logic_vector(8 downto 0);
    GT10_DRPCLK_IN                          : in   std_logic;
    GT10_DRPDI_IN                           : in   std_logic_vector(15 downto 0);
    GT10_DRPDO_OUT                          : out  std_logic_vector(15 downto 0);
    GT10_DRPEN_IN                           : in   std_logic;
    GT10_DRPRDY_OUT                         : out  std_logic;
    GT10_DRPWE_IN                           : in   std_logic;
    ------------------------------- Loopback Ports -----------------------------
    GT10_LOOPBACK_IN                        : in   std_logic_vector(2 downto 0);
    --------------------- RX Initialization and Reset Ports --------------------
    GT10_RXUSERRDY_IN                       : in   std_logic;
    -------------------------- RX Margin Analysis Ports ------------------------
    GT10_EYESCANDATAERROR_OUT               : out  std_logic;
    ------------------------- Receive Ports - CDR Ports ------------------------
    GT10_RXCDRLOCK_OUT                      : out  std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    GT10_RXCLKCORCNT_OUT                    : out  std_logic_vector(1 downto 0);
    ------------------ Receive Ports - FPGA RX Interface Ports -----------------
    GT10_RXUSRCLK_IN                        : in   std_logic;
    GT10_RXUSRCLK2_IN                       : in   std_logic;
    ------------------ Receive Ports - FPGA RX interface Ports -----------------
    GT10_RXDATA_OUT                         : out  std_logic_vector(15 downto 0);
    ------------------- Receive Ports - Pattern Checker Ports ------------------
    GT10_RXPRBSERR_OUT                      : out  std_logic;
    GT10_RXPRBSSEL_IN                       : in   std_logic_vector(2 downto 0);
    ------------------- Receive Ports - Pattern Checker ports ------------------
    GT10_RXPRBSCNTRESET_IN                  : in   std_logic;
    ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
    GT10_RXDISPERR_OUT                      : out  std_logic_vector(1 downto 0);
    GT10_RXNOTINTABLE_OUT                   : out  std_logic_vector(1 downto 0);
    --------------------------- Receive Ports - RX AFE -------------------------
    GT10_GTXRXP_IN                          : in   std_logic;
    ------------------------ Receive Ports - RX AFE Ports ----------------------
    GT10_GTXRXN_IN                          : in   std_logic;
    -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
    GT10_RXMCOMMAALIGNEN_IN                 : in   std_logic;
    GT10_RXPCOMMAALIGNEN_IN                 : in   std_logic;
    --------------------- Receive Ports - RX Equalizer Ports -------------------
    GT10_RXDFELPMRESET_IN                   : in   std_logic;
    ------------- Receive Ports - RX Initialization and Reset Ports ------------
    GT10_GTRXRESET_IN                       : in   std_logic;
    GT10_RXPMARESET_IN                      : in   std_logic;
    ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
    GT10_RXCHARISCOMMA_OUT                  : out  std_logic_vector(1 downto 0);
    GT10_RXCHARISK_OUT                      : out  std_logic_vector(1 downto 0);
    -------------- Receive Ports -RX Initialization and Reset Ports ------------
    GT10_RXRESETDONE_OUT                    : out  std_logic;
    --------------------- TX Initialization and Reset Ports --------------------
    GT10_GTTXRESET_IN                       : in   std_logic;
    GT10_TXUSERRDY_IN                       : in   std_logic;
    ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
    GT10_TXUSRCLK_IN                        : in   std_logic;
    GT10_TXUSRCLK2_IN                       : in   std_logic;
    --------------- Transmit Ports - TX Configurable Driver Ports --------------
    GT10_TXDIFFCTRL_IN                      : in   std_logic_vector(3 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    GT10_TXDATA_IN                          : in   std_logic_vector(15 downto 0);
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    GT10_GTXTXN_OUT                         : out  std_logic;
    GT10_GTXTXP_OUT                         : out  std_logic;
    ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
    GT10_TXOUTCLK_OUT                       : out  std_logic;
    GT10_TXOUTCLKFABRIC_OUT                 : out  std_logic;
    GT10_TXOUTCLKPCS_OUT                    : out  std_logic;
    --------------------- Transmit Ports - TX Gearbox Ports --------------------
    GT10_TXCHARISK_IN                       : in   std_logic_vector(1 downto 0);
    ------------- Transmit Ports - TX Initialization and Reset Ports -----------
    GT10_TXRESETDONE_OUT                    : out  std_logic;
    ------------------ Transmit Ports - pattern Generator Ports ----------------
    GT10_TXPRBSSEL_IN                       : in   std_logic_vector(2 downto 0);

    --GT11  (X1Y11)
    --____________________________CHANNEL PORTS________________________________
    ---------------------------- Channel - DRP Ports  --------------------------
    GT11_DRPADDR_IN                         : in   std_logic_vector(8 downto 0);
    GT11_DRPCLK_IN                          : in   std_logic;
    GT11_DRPDI_IN                           : in   std_logic_vector(15 downto 0);
    GT11_DRPDO_OUT                          : out  std_logic_vector(15 downto 0);
    GT11_DRPEN_IN                           : in   std_logic;
    GT11_DRPRDY_OUT                         : out  std_logic;
    GT11_DRPWE_IN                           : in   std_logic;
    ------------------------------- Loopback Ports -----------------------------
    GT11_LOOPBACK_IN                        : in   std_logic_vector(2 downto 0);
    --------------------- RX Initialization and Reset Ports --------------------
    GT11_RXUSERRDY_IN                       : in   std_logic;
    -------------------------- RX Margin Analysis Ports ------------------------
    GT11_EYESCANDATAERROR_OUT               : out  std_logic;
    ------------------------- Receive Ports - CDR Ports ------------------------
    GT11_RXCDRLOCK_OUT                      : out  std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    GT11_RXCLKCORCNT_OUT                    : out  std_logic_vector(1 downto 0);
    ------------------ Receive Ports - FPGA RX Interface Ports -----------------
    GT11_RXUSRCLK_IN                        : in   std_logic;
    GT11_RXUSRCLK2_IN                       : in   std_logic;
    ------------------ Receive Ports - FPGA RX interface Ports -----------------
    GT11_RXDATA_OUT                         : out  std_logic_vector(15 downto 0);
    ------------------- Receive Ports - Pattern Checker Ports ------------------
    GT11_RXPRBSERR_OUT                      : out  std_logic;
    GT11_RXPRBSSEL_IN                       : in   std_logic_vector(2 downto 0);
    ------------------- Receive Ports - Pattern Checker ports ------------------
    GT11_RXPRBSCNTRESET_IN                  : in   std_logic;
    ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
    GT11_RXDISPERR_OUT                      : out  std_logic_vector(1 downto 0);
    GT11_RXNOTINTABLE_OUT                   : out  std_logic_vector(1 downto 0);
    --------------------------- Receive Ports - RX AFE -------------------------
    GT11_GTXRXP_IN                          : in   std_logic;
    ------------------------ Receive Ports - RX AFE Ports ----------------------
    GT11_GTXRXN_IN                          : in   std_logic;
    -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
    GT11_RXMCOMMAALIGNEN_IN                 : in   std_logic;
    GT11_RXPCOMMAALIGNEN_IN                 : in   std_logic;
    --------------------- Receive Ports - RX Equalizer Ports -------------------
    GT11_RXDFELPMRESET_IN                   : in   std_logic;
    ------------- Receive Ports - RX Initialization and Reset Ports ------------
    GT11_GTRXRESET_IN                       : in   std_logic;
    GT11_RXPMARESET_IN                      : in   std_logic;
    ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
    GT11_RXCHARISCOMMA_OUT                  : out  std_logic_vector(1 downto 0);
    GT11_RXCHARISK_OUT                      : out  std_logic_vector(1 downto 0);
    -------------- Receive Ports -RX Initialization and Reset Ports ------------
    GT11_RXRESETDONE_OUT                    : out  std_logic;
    --------------------- TX Initialization and Reset Ports --------------------
    GT11_GTTXRESET_IN                       : in   std_logic;
    GT11_TXUSERRDY_IN                       : in   std_logic;
    ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
    GT11_TXUSRCLK_IN                        : in   std_logic;
    GT11_TXUSRCLK2_IN                       : in   std_logic;
    --------------- Transmit Ports - TX Configurable Driver Ports --------------
    GT11_TXDIFFCTRL_IN                      : in   std_logic_vector(3 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    GT11_TXDATA_IN                          : in   std_logic_vector(15 downto 0);
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    GT11_GTXTXN_OUT                         : out  std_logic;
    GT11_GTXTXP_OUT                         : out  std_logic;
    ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
    GT11_TXOUTCLK_OUT                       : out  std_logic;
    GT11_TXOUTCLKFABRIC_OUT                 : out  std_logic;
    GT11_TXOUTCLKPCS_OUT                    : out  std_logic;
    --------------------- Transmit Ports - TX Gearbox Ports --------------------
    GT11_TXCHARISK_IN                       : in   std_logic_vector(1 downto 0);
    ------------- Transmit Ports - TX Initialization and Reset Ports -----------
    GT11_TXRESETDONE_OUT                    : out  std_logic;
    ------------------ Transmit Ports - pattern Generator Ports ----------------
    GT11_TXPRBSSEL_IN                       : in   std_logic_vector(2 downto 0);


    --____________________________COMMON PORTS________________________________
    ---------------------- Common Block  - Ref Clock Ports ---------------------
    GT0_GTREFCLK0_COMMON_IN                 : in   std_logic;
    ------------------------- Common Block - QPLL Ports ------------------------
    GT0_QPLLLOCK_OUT                        : out  std_logic;
    GT0_QPLLLOCKDETCLK_IN                   : in   std_logic;
    GT0_QPLLRESET_IN                        : in   std_logic;

    --____________________________COMMON PORTS________________________________
    ---------------------- Common Block  - Ref Clock Ports ---------------------
    GT1_GTREFCLK0_COMMON_IN                 : in   std_logic;
    ------------------------- Common Block - QPLL Ports ------------------------
    GT1_QPLLLOCK_OUT                        : out  std_logic;
    GT1_QPLLLOCKDETCLK_IN                   : in   std_logic;
    GT1_QPLLRESET_IN                        : in   std_logic;

    --____________________________COMMON PORTS________________________________
    ---------------------- Common Block  - Ref Clock Ports ---------------------
    GT2_GTREFCLK0_COMMON_IN                 : in   std_logic;
    ------------------------- Common Block - QPLL Ports ------------------------
    GT2_QPLLLOCK_OUT                        : out  std_logic;
    GT2_QPLLLOCKDETCLK_IN                   : in   std_logic;
    GT2_QPLLRESET_IN                        : in   std_logic


);

end AMC_GTX_init;
    
architecture RTL of AMC_GTX_init is

--**************************Component Declarations*****************************


component AMC_GTX 
generic
(
    -- Simulation attributes
    WRAPPER_SIM_GTRESET_SPEEDUP    : string    := "FALSE" -- Set to 1 to speed up sim reset

);
port
(

    --_________________________________________________________________________
    --_________________________________________________________________________
    --GT0  (X1Y0)
    --____________________________CHANNEL PORTS________________________________
    ---------------------------- Channel - DRP Ports  --------------------------
    GT0_DRPADDR_IN                          : in   std_logic_vector(8 downto 0);
    GT0_DRPCLK_IN                           : in   std_logic;
    GT0_DRPDI_IN                            : in   std_logic_vector(15 downto 0);
    GT0_DRPDO_OUT                           : out  std_logic_vector(15 downto 0);
    GT0_DRPEN_IN                            : in   std_logic;
    GT0_DRPRDY_OUT                          : out  std_logic;
    GT0_DRPWE_IN                            : in   std_logic;
    ------------------------------- Loopback Ports -----------------------------
    GT0_LOOPBACK_IN                         : in   std_logic_vector(2 downto 0);
    --------------------- RX Initialization and Reset Ports --------------------
    GT0_RXUSERRDY_IN                        : in   std_logic;
    -------------------------- RX Margin Analysis Ports ------------------------
    GT0_EYESCANDATAERROR_OUT                : out  std_logic;
    ------------------------- Receive Ports - CDR Ports ------------------------
    GT0_RXCDRLOCK_OUT                       : out  std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    GT0_RXCLKCORCNT_OUT                     : out  std_logic_vector(1 downto 0);
    ------------------ Receive Ports - FPGA RX Interface Ports -----------------
    GT0_RXUSRCLK_IN                         : in   std_logic;
    GT0_RXUSRCLK2_IN                        : in   std_logic;
    ------------------ Receive Ports - FPGA RX interface Ports -----------------
    GT0_RXDATA_OUT                          : out  std_logic_vector(15 downto 0);
    ------------------- Receive Ports - Pattern Checker Ports ------------------
    GT0_RXPRBSERR_OUT                       : out  std_logic;
    GT0_RXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
    ------------------- Receive Ports - Pattern Checker ports ------------------
    GT0_RXPRBSCNTRESET_IN                   : in   std_logic;
    ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
    GT0_RXDISPERR_OUT                       : out  std_logic_vector(1 downto 0);
    GT0_RXNOTINTABLE_OUT                    : out  std_logic_vector(1 downto 0);
    --------------------------- Receive Ports - RX AFE -------------------------
    GT0_GTXRXP_IN                           : in   std_logic;
    ------------------------ Receive Ports - RX AFE Ports ----------------------
    GT0_GTXRXN_IN                           : in   std_logic;
    -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
    GT0_RXMCOMMAALIGNEN_IN                  : in   std_logic;
    GT0_RXPCOMMAALIGNEN_IN                  : in   std_logic;
    --------------------- Receive Ports - RX Equalizer Ports -------------------
    GT0_RXDFELPMRESET_IN                    : in   std_logic;
    --------------------- Receive Ports - RX Equilizer Ports -------------------
    GT0_RXLPMHFHOLD_IN                      : in   std_logic;
    GT0_RXLPMLFHOLD_IN                      : in   std_logic;
    --------------- Receive Ports - RX Fabric Output Control Ports -------------
    GT0_RXOUTCLK_OUT                        : out  std_logic;
    ------------- Receive Ports - RX Initialization and Reset Ports ------------
    GT0_GTRXRESET_IN                        : in   std_logic;
    GT0_RXPMARESET_IN                       : in   std_logic;
    ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
    GT0_RXCHARISCOMMA_OUT                   : out  std_logic_vector(1 downto 0);
    GT0_RXCHARISK_OUT                       : out  std_logic_vector(1 downto 0);
    -------------- Receive Ports -RX Initialization and Reset Ports ------------
    GT0_RXRESETDONE_OUT                     : out  std_logic;
    --------------------- TX Initialization and Reset Ports --------------------
    GT0_GTTXRESET_IN                        : in   std_logic;
    GT0_TXUSERRDY_IN                        : in   std_logic;
    ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
    GT0_TXUSRCLK_IN                         : in   std_logic;
    GT0_TXUSRCLK2_IN                        : in   std_logic;
    --------------- Transmit Ports - TX Configurable Driver Ports --------------
    GT0_TXDIFFCTRL_IN                       : in   std_logic_vector(3 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    GT0_TXDATA_IN                           : in   std_logic_vector(15 downto 0);
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    GT0_GTXTXN_OUT                          : out  std_logic;
    GT0_GTXTXP_OUT                          : out  std_logic;
    ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
    GT0_TXOUTCLK_OUT                        : out  std_logic;
    GT0_TXOUTCLKFABRIC_OUT                  : out  std_logic;
    GT0_TXOUTCLKPCS_OUT                     : out  std_logic;
    --------------------- Transmit Ports - TX Gearbox Ports --------------------
    GT0_TXCHARISK_IN                        : in   std_logic_vector(1 downto 0);
    ------------- Transmit Ports - TX Initialization and Reset Ports -----------
    GT0_TXRESETDONE_OUT                     : out  std_logic;
    ------------------ Transmit Ports - pattern Generator Ports ----------------
    GT0_TXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
   
    --_________________________________________________________________________
    --_________________________________________________________________________
    --GT1  (X1Y1)
    --____________________________CHANNEL PORTS________________________________
    ---------------------------- Channel - DRP Ports  --------------------------
    GT1_DRPADDR_IN                          : in   std_logic_vector(8 downto 0);
    GT1_DRPCLK_IN                           : in   std_logic;
    GT1_DRPDI_IN                            : in   std_logic_vector(15 downto 0);
    GT1_DRPDO_OUT                           : out  std_logic_vector(15 downto 0);
    GT1_DRPEN_IN                            : in   std_logic;
    GT1_DRPRDY_OUT                          : out  std_logic;
    GT1_DRPWE_IN                            : in   std_logic;
    ------------------------------- Loopback Ports -----------------------------
    GT1_LOOPBACK_IN                         : in   std_logic_vector(2 downto 0);
    --------------------- RX Initialization and Reset Ports --------------------
    GT1_RXUSERRDY_IN                        : in   std_logic;
    -------------------------- RX Margin Analysis Ports ------------------------
    GT1_EYESCANDATAERROR_OUT                : out  std_logic;
    ------------------------- Receive Ports - CDR Ports ------------------------
    GT1_RXCDRLOCK_OUT                       : out  std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    GT1_RXCLKCORCNT_OUT                     : out  std_logic_vector(1 downto 0);
    ------------------ Receive Ports - FPGA RX Interface Ports -----------------
    GT1_RXUSRCLK_IN                         : in   std_logic;
    GT1_RXUSRCLK2_IN                        : in   std_logic;
    ------------------ Receive Ports - FPGA RX interface Ports -----------------
    GT1_RXDATA_OUT                          : out  std_logic_vector(15 downto 0);
    ------------------- Receive Ports - Pattern Checker Ports ------------------
    GT1_RXPRBSERR_OUT                       : out  std_logic;
    GT1_RXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
    ------------------- Receive Ports - Pattern Checker ports ------------------
    GT1_RXPRBSCNTRESET_IN                   : in   std_logic;
    ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
    GT1_RXDISPERR_OUT                       : out  std_logic_vector(1 downto 0);
    GT1_RXNOTINTABLE_OUT                    : out  std_logic_vector(1 downto 0);
    --------------------------- Receive Ports - RX AFE -------------------------
    GT1_GTXRXP_IN                           : in   std_logic;
    ------------------------ Receive Ports - RX AFE Ports ----------------------
    GT1_GTXRXN_IN                           : in   std_logic;
    -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
    GT1_RXMCOMMAALIGNEN_IN                  : in   std_logic;
    GT1_RXPCOMMAALIGNEN_IN                  : in   std_logic;
    --------------------- Receive Ports - RX Equalizer Ports -------------------
    GT1_RXDFELPMRESET_IN                    : in   std_logic;
    --------------------- Receive Ports - RX Equilizer Ports -------------------
    GT1_RXLPMHFHOLD_IN                      : in   std_logic;
    GT1_RXLPMLFHOLD_IN                      : in   std_logic;
    --------------- Receive Ports - RX Fabric Output Control Ports -------------
    GT1_RXOUTCLK_OUT                        : out  std_logic;
    ------------- Receive Ports - RX Initialization and Reset Ports ------------
    GT1_GTRXRESET_IN                        : in   std_logic;
    GT1_RXPMARESET_IN                       : in   std_logic;
    ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
    GT1_RXCHARISCOMMA_OUT                   : out  std_logic_vector(1 downto 0);
    GT1_RXCHARISK_OUT                       : out  std_logic_vector(1 downto 0);
    -------------- Receive Ports -RX Initialization and Reset Ports ------------
    GT1_RXRESETDONE_OUT                     : out  std_logic;
    --------------------- TX Initialization and Reset Ports --------------------
    GT1_GTTXRESET_IN                        : in   std_logic;
    GT1_TXUSERRDY_IN                        : in   std_logic;
    ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
    GT1_TXUSRCLK_IN                         : in   std_logic;
    GT1_TXUSRCLK2_IN                        : in   std_logic;
    --------------- Transmit Ports - TX Configurable Driver Ports --------------
    GT1_TXDIFFCTRL_IN                       : in   std_logic_vector(3 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    GT1_TXDATA_IN                           : in   std_logic_vector(15 downto 0);
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    GT1_GTXTXN_OUT                          : out  std_logic;
    GT1_GTXTXP_OUT                          : out  std_logic;
    ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
    GT1_TXOUTCLK_OUT                        : out  std_logic;
    GT1_TXOUTCLKFABRIC_OUT                  : out  std_logic;
    GT1_TXOUTCLKPCS_OUT                     : out  std_logic;
    --------------------- Transmit Ports - TX Gearbox Ports --------------------
    GT1_TXCHARISK_IN                        : in   std_logic_vector(1 downto 0);
    ------------- Transmit Ports - TX Initialization and Reset Ports -----------
    GT1_TXRESETDONE_OUT                     : out  std_logic;
    ------------------ Transmit Ports - pattern Generator Ports ----------------
    GT1_TXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
   
    --_________________________________________________________________________
    --_________________________________________________________________________
    --GT2  (X1Y2)
    --____________________________CHANNEL PORTS________________________________
    ---------------------------- Channel - DRP Ports  --------------------------
    GT2_DRPADDR_IN                          : in   std_logic_vector(8 downto 0);
    GT2_DRPCLK_IN                           : in   std_logic;
    GT2_DRPDI_IN                            : in   std_logic_vector(15 downto 0);
    GT2_DRPDO_OUT                           : out  std_logic_vector(15 downto 0);
    GT2_DRPEN_IN                            : in   std_logic;
    GT2_DRPRDY_OUT                          : out  std_logic;
    GT2_DRPWE_IN                            : in   std_logic;
    ------------------------------- Loopback Ports -----------------------------
    GT2_LOOPBACK_IN                         : in   std_logic_vector(2 downto 0);
    --------------------- RX Initialization and Reset Ports --------------------
    GT2_RXUSERRDY_IN                        : in   std_logic;
    -------------------------- RX Margin Analysis Ports ------------------------
    GT2_EYESCANDATAERROR_OUT                : out  std_logic;
    ------------------------- Receive Ports - CDR Ports ------------------------
    GT2_RXCDRLOCK_OUT                       : out  std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    GT2_RXCLKCORCNT_OUT                     : out  std_logic_vector(1 downto 0);
    ------------------ Receive Ports - FPGA RX Interface Ports -----------------
    GT2_RXUSRCLK_IN                         : in   std_logic;
    GT2_RXUSRCLK2_IN                        : in   std_logic;
    ------------------ Receive Ports - FPGA RX interface Ports -----------------
    GT2_RXDATA_OUT                          : out  std_logic_vector(15 downto 0);
    ------------------- Receive Ports - Pattern Checker Ports ------------------
    GT2_RXPRBSERR_OUT                       : out  std_logic;
    GT2_RXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
    ------------------- Receive Ports - Pattern Checker ports ------------------
    GT2_RXPRBSCNTRESET_IN                   : in   std_logic;
    ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
    GT2_RXDISPERR_OUT                       : out  std_logic_vector(1 downto 0);
    GT2_RXNOTINTABLE_OUT                    : out  std_logic_vector(1 downto 0);
    --------------------------- Receive Ports - RX AFE -------------------------
    GT2_GTXRXP_IN                           : in   std_logic;
    ------------------------ Receive Ports - RX AFE Ports ----------------------
    GT2_GTXRXN_IN                           : in   std_logic;
    -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
    GT2_RXMCOMMAALIGNEN_IN                  : in   std_logic;
    GT2_RXPCOMMAALIGNEN_IN                  : in   std_logic;
    --------------------- Receive Ports - RX Equalizer Ports -------------------
    GT2_RXDFELPMRESET_IN                    : in   std_logic;
    --------------------- Receive Ports - RX Equilizer Ports -------------------
    GT2_RXLPMHFHOLD_IN                      : in   std_logic;
    GT2_RXLPMLFHOLD_IN                      : in   std_logic;
    --------------- Receive Ports - RX Fabric Output Control Ports -------------
    GT2_RXOUTCLK_OUT                        : out  std_logic;
    ------------- Receive Ports - RX Initialization and Reset Ports ------------
    GT2_GTRXRESET_IN                        : in   std_logic;
    GT2_RXPMARESET_IN                       : in   std_logic;
    ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
    GT2_RXCHARISCOMMA_OUT                   : out  std_logic_vector(1 downto 0);
    GT2_RXCHARISK_OUT                       : out  std_logic_vector(1 downto 0);
    -------------- Receive Ports -RX Initialization and Reset Ports ------------
    GT2_RXRESETDONE_OUT                     : out  std_logic;
    --------------------- TX Initialization and Reset Ports --------------------
    GT2_GTTXRESET_IN                        : in   std_logic;
    GT2_TXUSERRDY_IN                        : in   std_logic;
    ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
    GT2_TXUSRCLK_IN                         : in   std_logic;
    GT2_TXUSRCLK2_IN                        : in   std_logic;
    --------------- Transmit Ports - TX Configurable Driver Ports --------------
    GT2_TXDIFFCTRL_IN                       : in   std_logic_vector(3 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    GT2_TXDATA_IN                           : in   std_logic_vector(15 downto 0);
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    GT2_GTXTXN_OUT                          : out  std_logic;
    GT2_GTXTXP_OUT                          : out  std_logic;
    ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
    GT2_TXOUTCLK_OUT                        : out  std_logic;
    GT2_TXOUTCLKFABRIC_OUT                  : out  std_logic;
    GT2_TXOUTCLKPCS_OUT                     : out  std_logic;
    --------------------- Transmit Ports - TX Gearbox Ports --------------------
    GT2_TXCHARISK_IN                        : in   std_logic_vector(1 downto 0);
    ------------- Transmit Ports - TX Initialization and Reset Ports -----------
    GT2_TXRESETDONE_OUT                     : out  std_logic;
    ------------------ Transmit Ports - pattern Generator Ports ----------------
    GT2_TXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
   
    --_________________________________________________________________________
    --_________________________________________________________________________
    --GT3  (X1Y3)
    --____________________________CHANNEL PORTS________________________________
    ---------------------------- Channel - DRP Ports  --------------------------
    GT3_DRPADDR_IN                          : in   std_logic_vector(8 downto 0);
    GT3_DRPCLK_IN                           : in   std_logic;
    GT3_DRPDI_IN                            : in   std_logic_vector(15 downto 0);
    GT3_DRPDO_OUT                           : out  std_logic_vector(15 downto 0);
    GT3_DRPEN_IN                            : in   std_logic;
    GT3_DRPRDY_OUT                          : out  std_logic;
    GT3_DRPWE_IN                            : in   std_logic;
    ------------------------------- Loopback Ports -----------------------------
    GT3_LOOPBACK_IN                         : in   std_logic_vector(2 downto 0);
    --------------------- RX Initialization and Reset Ports --------------------
    GT3_RXUSERRDY_IN                        : in   std_logic;
    -------------------------- RX Margin Analysis Ports ------------------------
    GT3_EYESCANDATAERROR_OUT                : out  std_logic;
    ------------------------- Receive Ports - CDR Ports ------------------------
    GT3_RXCDRLOCK_OUT                       : out  std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    GT3_RXCLKCORCNT_OUT                     : out  std_logic_vector(1 downto 0);
    ------------------ Receive Ports - FPGA RX Interface Ports -----------------
    GT3_RXUSRCLK_IN                         : in   std_logic;
    GT3_RXUSRCLK2_IN                        : in   std_logic;
    ------------------ Receive Ports - FPGA RX interface Ports -----------------
    GT3_RXDATA_OUT                          : out  std_logic_vector(15 downto 0);
    ------------------- Receive Ports - Pattern Checker Ports ------------------
    GT3_RXPRBSERR_OUT                       : out  std_logic;
    GT3_RXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
    ------------------- Receive Ports - Pattern Checker ports ------------------
    GT3_RXPRBSCNTRESET_IN                   : in   std_logic;
    ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
    GT3_RXDISPERR_OUT                       : out  std_logic_vector(1 downto 0);
    GT3_RXNOTINTABLE_OUT                    : out  std_logic_vector(1 downto 0);
    --------------------------- Receive Ports - RX AFE -------------------------
    GT3_GTXRXP_IN                           : in   std_logic;
    ------------------------ Receive Ports - RX AFE Ports ----------------------
    GT3_GTXRXN_IN                           : in   std_logic;
    -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
    GT3_RXMCOMMAALIGNEN_IN                  : in   std_logic;
    GT3_RXPCOMMAALIGNEN_IN                  : in   std_logic;
    --------------------- Receive Ports - RX Equalizer Ports -------------------
    GT3_RXDFELPMRESET_IN                    : in   std_logic;
    --------------------- Receive Ports - RX Equilizer Ports -------------------
    GT3_RXLPMHFHOLD_IN                      : in   std_logic;
    GT3_RXLPMLFHOLD_IN                      : in   std_logic;
    --------------- Receive Ports - RX Fabric Output Control Ports -------------
    GT3_RXOUTCLK_OUT                        : out  std_logic;
    ------------- Receive Ports - RX Initialization and Reset Ports ------------
    GT3_GTRXRESET_IN                        : in   std_logic;
    GT3_RXPMARESET_IN                       : in   std_logic;
    ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
    GT3_RXCHARISCOMMA_OUT                   : out  std_logic_vector(1 downto 0);
    GT3_RXCHARISK_OUT                       : out  std_logic_vector(1 downto 0);
    -------------- Receive Ports -RX Initialization and Reset Ports ------------
    GT3_RXRESETDONE_OUT                     : out  std_logic;
    --------------------- TX Initialization and Reset Ports --------------------
    GT3_GTTXRESET_IN                        : in   std_logic;
    GT3_TXUSERRDY_IN                        : in   std_logic;
    ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
    GT3_TXUSRCLK_IN                         : in   std_logic;
    GT3_TXUSRCLK2_IN                        : in   std_logic;
    --------------- Transmit Ports - TX Configurable Driver Ports --------------
    GT3_TXDIFFCTRL_IN                       : in   std_logic_vector(3 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    GT3_TXDATA_IN                           : in   std_logic_vector(15 downto 0);
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    GT3_GTXTXN_OUT                          : out  std_logic;
    GT3_GTXTXP_OUT                          : out  std_logic;
    ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
    GT3_TXOUTCLK_OUT                        : out  std_logic;
    GT3_TXOUTCLKFABRIC_OUT                  : out  std_logic;
    GT3_TXOUTCLKPCS_OUT                     : out  std_logic;
    --------------------- Transmit Ports - TX Gearbox Ports --------------------
    GT3_TXCHARISK_IN                        : in   std_logic_vector(1 downto 0);
    ------------- Transmit Ports - TX Initialization and Reset Ports -----------
    GT3_TXRESETDONE_OUT                     : out  std_logic;
    ------------------ Transmit Ports - pattern Generator Ports ----------------
    GT3_TXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
   
    --_________________________________________________________________________
    --_________________________________________________________________________
    --GT4  (X1Y4)
    --____________________________CHANNEL PORTS________________________________
    ---------------------------- Channel - DRP Ports  --------------------------
    GT4_DRPADDR_IN                          : in   std_logic_vector(8 downto 0);
    GT4_DRPCLK_IN                           : in   std_logic;
    GT4_DRPDI_IN                            : in   std_logic_vector(15 downto 0);
    GT4_DRPDO_OUT                           : out  std_logic_vector(15 downto 0);
    GT4_DRPEN_IN                            : in   std_logic;
    GT4_DRPRDY_OUT                          : out  std_logic;
    GT4_DRPWE_IN                            : in   std_logic;
    ------------------------------- Loopback Ports -----------------------------
    GT4_LOOPBACK_IN                         : in   std_logic_vector(2 downto 0);
    --------------------- RX Initialization and Reset Ports --------------------
    GT4_RXUSERRDY_IN                        : in   std_logic;
    -------------------------- RX Margin Analysis Ports ------------------------
    GT4_EYESCANDATAERROR_OUT                : out  std_logic;
    ------------------------- Receive Ports - CDR Ports ------------------------
    GT4_RXCDRLOCK_OUT                       : out  std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    GT4_RXCLKCORCNT_OUT                     : out  std_logic_vector(1 downto 0);
    ------------------ Receive Ports - FPGA RX Interface Ports -----------------
    GT4_RXUSRCLK_IN                         : in   std_logic;
    GT4_RXUSRCLK2_IN                        : in   std_logic;
    ------------------ Receive Ports - FPGA RX interface Ports -----------------
    GT4_RXDATA_OUT                          : out  std_logic_vector(15 downto 0);
    ------------------- Receive Ports - Pattern Checker Ports ------------------
    GT4_RXPRBSERR_OUT                       : out  std_logic;
    GT4_RXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
    ------------------- Receive Ports - Pattern Checker ports ------------------
    GT4_RXPRBSCNTRESET_IN                   : in   std_logic;
    ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
    GT4_RXDISPERR_OUT                       : out  std_logic_vector(1 downto 0);
    GT4_RXNOTINTABLE_OUT                    : out  std_logic_vector(1 downto 0);
    --------------------------- Receive Ports - RX AFE -------------------------
    GT4_GTXRXP_IN                           : in   std_logic;
    ------------------------ Receive Ports - RX AFE Ports ----------------------
    GT4_GTXRXN_IN                           : in   std_logic;
    -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
    GT4_RXMCOMMAALIGNEN_IN                  : in   std_logic;
    GT4_RXPCOMMAALIGNEN_IN                  : in   std_logic;
    --------------------- Receive Ports - RX Equalizer Ports -------------------
    GT4_RXDFELPMRESET_IN                    : in   std_logic;
    --------------------- Receive Ports - RX Equilizer Ports -------------------
    GT4_RXLPMHFHOLD_IN                      : in   std_logic;
    GT4_RXLPMLFHOLD_IN                      : in   std_logic;
    --------------- Receive Ports - RX Fabric Output Control Ports -------------
    GT4_RXOUTCLK_OUT                        : out  std_logic;
    ------------- Receive Ports - RX Initialization and Reset Ports ------------
    GT4_GTRXRESET_IN                        : in   std_logic;
    GT4_RXPMARESET_IN                       : in   std_logic;
    ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
    GT4_RXCHARISCOMMA_OUT                   : out  std_logic_vector(1 downto 0);
    GT4_RXCHARISK_OUT                       : out  std_logic_vector(1 downto 0);
    -------------- Receive Ports -RX Initialization and Reset Ports ------------
    GT4_RXRESETDONE_OUT                     : out  std_logic;
    --------------------- TX Initialization and Reset Ports --------------------
    GT4_GTTXRESET_IN                        : in   std_logic;
    GT4_TXUSERRDY_IN                        : in   std_logic;
    ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
    GT4_TXUSRCLK_IN                         : in   std_logic;
    GT4_TXUSRCLK2_IN                        : in   std_logic;
    --------------- Transmit Ports - TX Configurable Driver Ports --------------
    GT4_TXDIFFCTRL_IN                       : in   std_logic_vector(3 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    GT4_TXDATA_IN                           : in   std_logic_vector(15 downto 0);
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    GT4_GTXTXN_OUT                          : out  std_logic;
    GT4_GTXTXP_OUT                          : out  std_logic;
    ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
    GT4_TXOUTCLK_OUT                        : out  std_logic;
    GT4_TXOUTCLKFABRIC_OUT                  : out  std_logic;
    GT4_TXOUTCLKPCS_OUT                     : out  std_logic;
    --------------------- Transmit Ports - TX Gearbox Ports --------------------
    GT4_TXCHARISK_IN                        : in   std_logic_vector(1 downto 0);
    ------------- Transmit Ports - TX Initialization and Reset Ports -----------
    GT4_TXRESETDONE_OUT                     : out  std_logic;
    ------------------ Transmit Ports - pattern Generator Ports ----------------
    GT4_TXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
   
    --_________________________________________________________________________
    --_________________________________________________________________________
    --GT5  (X1Y5)
    --____________________________CHANNEL PORTS________________________________
    ---------------------------- Channel - DRP Ports  --------------------------
    GT5_DRPADDR_IN                          : in   std_logic_vector(8 downto 0);
    GT5_DRPCLK_IN                           : in   std_logic;
    GT5_DRPDI_IN                            : in   std_logic_vector(15 downto 0);
    GT5_DRPDO_OUT                           : out  std_logic_vector(15 downto 0);
    GT5_DRPEN_IN                            : in   std_logic;
    GT5_DRPRDY_OUT                          : out  std_logic;
    GT5_DRPWE_IN                            : in   std_logic;
    ------------------------------- Loopback Ports -----------------------------
    GT5_LOOPBACK_IN                         : in   std_logic_vector(2 downto 0);
    --------------------- RX Initialization and Reset Ports --------------------
    GT5_RXUSERRDY_IN                        : in   std_logic;
    -------------------------- RX Margin Analysis Ports ------------------------
    GT5_EYESCANDATAERROR_OUT                : out  std_logic;
    ------------------------- Receive Ports - CDR Ports ------------------------
    GT5_RXCDRLOCK_OUT                       : out  std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    GT5_RXCLKCORCNT_OUT                     : out  std_logic_vector(1 downto 0);
    ------------------ Receive Ports - FPGA RX Interface Ports -----------------
    GT5_RXUSRCLK_IN                         : in   std_logic;
    GT5_RXUSRCLK2_IN                        : in   std_logic;
    ------------------ Receive Ports - FPGA RX interface Ports -----------------
    GT5_RXDATA_OUT                          : out  std_logic_vector(15 downto 0);
    ------------------- Receive Ports - Pattern Checker Ports ------------------
    GT5_RXPRBSERR_OUT                       : out  std_logic;
    GT5_RXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
    ------------------- Receive Ports - Pattern Checker ports ------------------
    GT5_RXPRBSCNTRESET_IN                   : in   std_logic;
    ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
    GT5_RXDISPERR_OUT                       : out  std_logic_vector(1 downto 0);
    GT5_RXNOTINTABLE_OUT                    : out  std_logic_vector(1 downto 0);
    --------------------------- Receive Ports - RX AFE -------------------------
    GT5_GTXRXP_IN                           : in   std_logic;
    ------------------------ Receive Ports - RX AFE Ports ----------------------
    GT5_GTXRXN_IN                           : in   std_logic;
    -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
    GT5_RXMCOMMAALIGNEN_IN                  : in   std_logic;
    GT5_RXPCOMMAALIGNEN_IN                  : in   std_logic;
    --------------------- Receive Ports - RX Equalizer Ports -------------------
    GT5_RXDFELPMRESET_IN                    : in   std_logic;
    --------------------- Receive Ports - RX Equilizer Ports -------------------
    GT5_RXLPMHFHOLD_IN                      : in   std_logic;
    GT5_RXLPMLFHOLD_IN                      : in   std_logic;
    --------------- Receive Ports - RX Fabric Output Control Ports -------------
    GT5_RXOUTCLK_OUT                        : out  std_logic;
    ------------- Receive Ports - RX Initialization and Reset Ports ------------
    GT5_GTRXRESET_IN                        : in   std_logic;
    GT5_RXPMARESET_IN                       : in   std_logic;
    ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
    GT5_RXCHARISCOMMA_OUT                   : out  std_logic_vector(1 downto 0);
    GT5_RXCHARISK_OUT                       : out  std_logic_vector(1 downto 0);
    -------------- Receive Ports -RX Initialization and Reset Ports ------------
    GT5_RXRESETDONE_OUT                     : out  std_logic;
    --------------------- TX Initialization and Reset Ports --------------------
    GT5_GTTXRESET_IN                        : in   std_logic;
    GT5_TXUSERRDY_IN                        : in   std_logic;
    ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
    GT5_TXUSRCLK_IN                         : in   std_logic;
    GT5_TXUSRCLK2_IN                        : in   std_logic;
    --------------- Transmit Ports - TX Configurable Driver Ports --------------
    GT5_TXDIFFCTRL_IN                       : in   std_logic_vector(3 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    GT5_TXDATA_IN                           : in   std_logic_vector(15 downto 0);
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    GT5_GTXTXN_OUT                          : out  std_logic;
    GT5_GTXTXP_OUT                          : out  std_logic;
    ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
    GT5_TXOUTCLK_OUT                        : out  std_logic;
    GT5_TXOUTCLKFABRIC_OUT                  : out  std_logic;
    GT5_TXOUTCLKPCS_OUT                     : out  std_logic;
    --------------------- Transmit Ports - TX Gearbox Ports --------------------
    GT5_TXCHARISK_IN                        : in   std_logic_vector(1 downto 0);
    ------------- Transmit Ports - TX Initialization and Reset Ports -----------
    GT5_TXRESETDONE_OUT                     : out  std_logic;
    ------------------ Transmit Ports - pattern Generator Ports ----------------
    GT5_TXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
   
    --_________________________________________________________________________
    --_________________________________________________________________________
    --GT6  (X1Y6)
    --____________________________CHANNEL PORTS________________________________
    ---------------------------- Channel - DRP Ports  --------------------------
    GT6_DRPADDR_IN                          : in   std_logic_vector(8 downto 0);
    GT6_DRPCLK_IN                           : in   std_logic;
    GT6_DRPDI_IN                            : in   std_logic_vector(15 downto 0);
    GT6_DRPDO_OUT                           : out  std_logic_vector(15 downto 0);
    GT6_DRPEN_IN                            : in   std_logic;
    GT6_DRPRDY_OUT                          : out  std_logic;
    GT6_DRPWE_IN                            : in   std_logic;
    ------------------------------- Loopback Ports -----------------------------
    GT6_LOOPBACK_IN                         : in   std_logic_vector(2 downto 0);
    --------------------- RX Initialization and Reset Ports --------------------
    GT6_RXUSERRDY_IN                        : in   std_logic;
    -------------------------- RX Margin Analysis Ports ------------------------
    GT6_EYESCANDATAERROR_OUT                : out  std_logic;
    ------------------------- Receive Ports - CDR Ports ------------------------
    GT6_RXCDRLOCK_OUT                       : out  std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    GT6_RXCLKCORCNT_OUT                     : out  std_logic_vector(1 downto 0);
    ------------------ Receive Ports - FPGA RX Interface Ports -----------------
    GT6_RXUSRCLK_IN                         : in   std_logic;
    GT6_RXUSRCLK2_IN                        : in   std_logic;
    ------------------ Receive Ports - FPGA RX interface Ports -----------------
    GT6_RXDATA_OUT                          : out  std_logic_vector(15 downto 0);
    ------------------- Receive Ports - Pattern Checker Ports ------------------
    GT6_RXPRBSERR_OUT                       : out  std_logic;
    GT6_RXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
    ------------------- Receive Ports - Pattern Checker ports ------------------
    GT6_RXPRBSCNTRESET_IN                   : in   std_logic;
    ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
    GT6_RXDISPERR_OUT                       : out  std_logic_vector(1 downto 0);
    GT6_RXNOTINTABLE_OUT                    : out  std_logic_vector(1 downto 0);
    --------------------------- Receive Ports - RX AFE -------------------------
    GT6_GTXRXP_IN                           : in   std_logic;
    ------------------------ Receive Ports - RX AFE Ports ----------------------
    GT6_GTXRXN_IN                           : in   std_logic;
    -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
    GT6_RXMCOMMAALIGNEN_IN                  : in   std_logic;
    GT6_RXPCOMMAALIGNEN_IN                  : in   std_logic;
    --------------------- Receive Ports - RX Equalizer Ports -------------------
    GT6_RXDFELPMRESET_IN                    : in   std_logic;
    --------------------- Receive Ports - RX Equilizer Ports -------------------
    GT6_RXLPMHFHOLD_IN                      : in   std_logic;
    GT6_RXLPMLFHOLD_IN                      : in   std_logic;
    --------------- Receive Ports - RX Fabric Output Control Ports -------------
    GT6_RXOUTCLK_OUT                        : out  std_logic;
    ------------- Receive Ports - RX Initialization and Reset Ports ------------
    GT6_GTRXRESET_IN                        : in   std_logic;
    GT6_RXPMARESET_IN                       : in   std_logic;
    ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
    GT6_RXCHARISCOMMA_OUT                   : out  std_logic_vector(1 downto 0);
    GT6_RXCHARISK_OUT                       : out  std_logic_vector(1 downto 0);
    -------------- Receive Ports -RX Initialization and Reset Ports ------------
    GT6_RXRESETDONE_OUT                     : out  std_logic;
    --------------------- TX Initialization and Reset Ports --------------------
    GT6_GTTXRESET_IN                        : in   std_logic;
    GT6_TXUSERRDY_IN                        : in   std_logic;
    ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
    GT6_TXUSRCLK_IN                         : in   std_logic;
    GT6_TXUSRCLK2_IN                        : in   std_logic;
    --------------- Transmit Ports - TX Configurable Driver Ports --------------
    GT6_TXDIFFCTRL_IN                       : in   std_logic_vector(3 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    GT6_TXDATA_IN                           : in   std_logic_vector(15 downto 0);
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    GT6_GTXTXN_OUT                          : out  std_logic;
    GT6_GTXTXP_OUT                          : out  std_logic;
    ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
    GT6_TXOUTCLK_OUT                        : out  std_logic;
    GT6_TXOUTCLKFABRIC_OUT                  : out  std_logic;
    GT6_TXOUTCLKPCS_OUT                     : out  std_logic;
    --------------------- Transmit Ports - TX Gearbox Ports --------------------
    GT6_TXCHARISK_IN                        : in   std_logic_vector(1 downto 0);
    ------------- Transmit Ports - TX Initialization and Reset Ports -----------
    GT6_TXRESETDONE_OUT                     : out  std_logic;
    ------------------ Transmit Ports - pattern Generator Ports ----------------
    GT6_TXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
   
    --_________________________________________________________________________
    --_________________________________________________________________________
    --GT7  (X1Y7)
    --____________________________CHANNEL PORTS________________________________
    ---------------------------- Channel - DRP Ports  --------------------------
    GT7_DRPADDR_IN                          : in   std_logic_vector(8 downto 0);
    GT7_DRPCLK_IN                           : in   std_logic;
    GT7_DRPDI_IN                            : in   std_logic_vector(15 downto 0);
    GT7_DRPDO_OUT                           : out  std_logic_vector(15 downto 0);
    GT7_DRPEN_IN                            : in   std_logic;
    GT7_DRPRDY_OUT                          : out  std_logic;
    GT7_DRPWE_IN                            : in   std_logic;
    ------------------------------- Loopback Ports -----------------------------
    GT7_LOOPBACK_IN                         : in   std_logic_vector(2 downto 0);
    --------------------- RX Initialization and Reset Ports --------------------
    GT7_RXUSERRDY_IN                        : in   std_logic;
    -------------------------- RX Margin Analysis Ports ------------------------
    GT7_EYESCANDATAERROR_OUT                : out  std_logic;
    ------------------------- Receive Ports - CDR Ports ------------------------
    GT7_RXCDRLOCK_OUT                       : out  std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    GT7_RXCLKCORCNT_OUT                     : out  std_logic_vector(1 downto 0);
    ------------------ Receive Ports - FPGA RX Interface Ports -----------------
    GT7_RXUSRCLK_IN                         : in   std_logic;
    GT7_RXUSRCLK2_IN                        : in   std_logic;
    ------------------ Receive Ports - FPGA RX interface Ports -----------------
    GT7_RXDATA_OUT                          : out  std_logic_vector(15 downto 0);
    ------------------- Receive Ports - Pattern Checker Ports ------------------
    GT7_RXPRBSERR_OUT                       : out  std_logic;
    GT7_RXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
    ------------------- Receive Ports - Pattern Checker ports ------------------
    GT7_RXPRBSCNTRESET_IN                   : in   std_logic;
    ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
    GT7_RXDISPERR_OUT                       : out  std_logic_vector(1 downto 0);
    GT7_RXNOTINTABLE_OUT                    : out  std_logic_vector(1 downto 0);
    --------------------------- Receive Ports - RX AFE -------------------------
    GT7_GTXRXP_IN                           : in   std_logic;
    ------------------------ Receive Ports - RX AFE Ports ----------------------
    GT7_GTXRXN_IN                           : in   std_logic;
    -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
    GT7_RXMCOMMAALIGNEN_IN                  : in   std_logic;
    GT7_RXPCOMMAALIGNEN_IN                  : in   std_logic;
    --------------------- Receive Ports - RX Equalizer Ports -------------------
    GT7_RXDFELPMRESET_IN                    : in   std_logic;
    --------------------- Receive Ports - RX Equilizer Ports -------------------
    GT7_RXLPMHFHOLD_IN                      : in   std_logic;
    GT7_RXLPMLFHOLD_IN                      : in   std_logic;
    --------------- Receive Ports - RX Fabric Output Control Ports -------------
    GT7_RXOUTCLK_OUT                        : out  std_logic;
    ------------- Receive Ports - RX Initialization and Reset Ports ------------
    GT7_GTRXRESET_IN                        : in   std_logic;
    GT7_RXPMARESET_IN                       : in   std_logic;
    ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
    GT7_RXCHARISCOMMA_OUT                   : out  std_logic_vector(1 downto 0);
    GT7_RXCHARISK_OUT                       : out  std_logic_vector(1 downto 0);
    -------------- Receive Ports -RX Initialization and Reset Ports ------------
    GT7_RXRESETDONE_OUT                     : out  std_logic;
    --------------------- TX Initialization and Reset Ports --------------------
    GT7_GTTXRESET_IN                        : in   std_logic;
    GT7_TXUSERRDY_IN                        : in   std_logic;
    ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
    GT7_TXUSRCLK_IN                         : in   std_logic;
    GT7_TXUSRCLK2_IN                        : in   std_logic;
    --------------- Transmit Ports - TX Configurable Driver Ports --------------
    GT7_TXDIFFCTRL_IN                       : in   std_logic_vector(3 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    GT7_TXDATA_IN                           : in   std_logic_vector(15 downto 0);
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    GT7_GTXTXN_OUT                          : out  std_logic;
    GT7_GTXTXP_OUT                          : out  std_logic;
    ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
    GT7_TXOUTCLK_OUT                        : out  std_logic;
    GT7_TXOUTCLKFABRIC_OUT                  : out  std_logic;
    GT7_TXOUTCLKPCS_OUT                     : out  std_logic;
    --------------------- Transmit Ports - TX Gearbox Ports --------------------
    GT7_TXCHARISK_IN                        : in   std_logic_vector(1 downto 0);
    ------------- Transmit Ports - TX Initialization and Reset Ports -----------
    GT7_TXRESETDONE_OUT                     : out  std_logic;
    ------------------ Transmit Ports - pattern Generator Ports ----------------
    GT7_TXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
   
    --_________________________________________________________________________
    --_________________________________________________________________________
    --GT8  (X1Y8)
    --____________________________CHANNEL PORTS________________________________
    ---------------------------- Channel - DRP Ports  --------------------------
    GT8_DRPADDR_IN                          : in   std_logic_vector(8 downto 0);
    GT8_DRPCLK_IN                           : in   std_logic;
    GT8_DRPDI_IN                            : in   std_logic_vector(15 downto 0);
    GT8_DRPDO_OUT                           : out  std_logic_vector(15 downto 0);
    GT8_DRPEN_IN                            : in   std_logic;
    GT8_DRPRDY_OUT                          : out  std_logic;
    GT8_DRPWE_IN                            : in   std_logic;
    ------------------------------- Loopback Ports -----------------------------
    GT8_LOOPBACK_IN                         : in   std_logic_vector(2 downto 0);
    --------------------- RX Initialization and Reset Ports --------------------
    GT8_RXUSERRDY_IN                        : in   std_logic;
    -------------------------- RX Margin Analysis Ports ------------------------
    GT8_EYESCANDATAERROR_OUT                : out  std_logic;
    ------------------------- Receive Ports - CDR Ports ------------------------
    GT8_RXCDRLOCK_OUT                       : out  std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    GT8_RXCLKCORCNT_OUT                     : out  std_logic_vector(1 downto 0);
    ------------------ Receive Ports - FPGA RX Interface Ports -----------------
    GT8_RXUSRCLK_IN                         : in   std_logic;
    GT8_RXUSRCLK2_IN                        : in   std_logic;
    ------------------ Receive Ports - FPGA RX interface Ports -----------------
    GT8_RXDATA_OUT                          : out  std_logic_vector(15 downto 0);
    ------------------- Receive Ports - Pattern Checker Ports ------------------
    GT8_RXPRBSERR_OUT                       : out  std_logic;
    GT8_RXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
    ------------------- Receive Ports - Pattern Checker ports ------------------
    GT8_RXPRBSCNTRESET_IN                   : in   std_logic;
    ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
    GT8_RXDISPERR_OUT                       : out  std_logic_vector(1 downto 0);
    GT8_RXNOTINTABLE_OUT                    : out  std_logic_vector(1 downto 0);
    --------------------------- Receive Ports - RX AFE -------------------------
    GT8_GTXRXP_IN                           : in   std_logic;
    ------------------------ Receive Ports - RX AFE Ports ----------------------
    GT8_GTXRXN_IN                           : in   std_logic;
    -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
    GT8_RXMCOMMAALIGNEN_IN                  : in   std_logic;
    GT8_RXPCOMMAALIGNEN_IN                  : in   std_logic;
    --------------------- Receive Ports - RX Equalizer Ports -------------------
    GT8_RXDFELPMRESET_IN                    : in   std_logic;
    --------------------- Receive Ports - RX Equilizer Ports -------------------
    GT8_RXLPMHFHOLD_IN                      : in   std_logic;
    GT8_RXLPMLFHOLD_IN                      : in   std_logic;
    --------------- Receive Ports - RX Fabric Output Control Ports -------------
    GT8_RXOUTCLK_OUT                        : out  std_logic;
    ------------- Receive Ports - RX Initialization and Reset Ports ------------
    GT8_GTRXRESET_IN                        : in   std_logic;
    GT8_RXPMARESET_IN                       : in   std_logic;
    ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
    GT8_RXCHARISCOMMA_OUT                   : out  std_logic_vector(1 downto 0);
    GT8_RXCHARISK_OUT                       : out  std_logic_vector(1 downto 0);
    -------------- Receive Ports -RX Initialization and Reset Ports ------------
    GT8_RXRESETDONE_OUT                     : out  std_logic;
    --------------------- TX Initialization and Reset Ports --------------------
    GT8_GTTXRESET_IN                        : in   std_logic;
    GT8_TXUSERRDY_IN                        : in   std_logic;
    ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
    GT8_TXUSRCLK_IN                         : in   std_logic;
    GT8_TXUSRCLK2_IN                        : in   std_logic;
    --------------- Transmit Ports - TX Configurable Driver Ports --------------
    GT8_TXDIFFCTRL_IN                       : in   std_logic_vector(3 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    GT8_TXDATA_IN                           : in   std_logic_vector(15 downto 0);
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    GT8_GTXTXN_OUT                          : out  std_logic;
    GT8_GTXTXP_OUT                          : out  std_logic;
    ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
    GT8_TXOUTCLK_OUT                        : out  std_logic;
    GT8_TXOUTCLKFABRIC_OUT                  : out  std_logic;
    GT8_TXOUTCLKPCS_OUT                     : out  std_logic;
    --------------------- Transmit Ports - TX Gearbox Ports --------------------
    GT8_TXCHARISK_IN                        : in   std_logic_vector(1 downto 0);
    ------------- Transmit Ports - TX Initialization and Reset Ports -----------
    GT8_TXRESETDONE_OUT                     : out  std_logic;
    ------------------ Transmit Ports - pattern Generator Ports ----------------
    GT8_TXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
   
    --_________________________________________________________________________
    --_________________________________________________________________________
    --GT9  (X1Y9)
    --____________________________CHANNEL PORTS________________________________
    ---------------------------- Channel - DRP Ports  --------------------------
    GT9_DRPADDR_IN                          : in   std_logic_vector(8 downto 0);
    GT9_DRPCLK_IN                           : in   std_logic;
    GT9_DRPDI_IN                            : in   std_logic_vector(15 downto 0);
    GT9_DRPDO_OUT                           : out  std_logic_vector(15 downto 0);
    GT9_DRPEN_IN                            : in   std_logic;
    GT9_DRPRDY_OUT                          : out  std_logic;
    GT9_DRPWE_IN                            : in   std_logic;
    ------------------------------- Loopback Ports -----------------------------
    GT9_LOOPBACK_IN                         : in   std_logic_vector(2 downto 0);
    --------------------- RX Initialization and Reset Ports --------------------
    GT9_RXUSERRDY_IN                        : in   std_logic;
    -------------------------- RX Margin Analysis Ports ------------------------
    GT9_EYESCANDATAERROR_OUT                : out  std_logic;
    ------------------------- Receive Ports - CDR Ports ------------------------
    GT9_RXCDRLOCK_OUT                       : out  std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    GT9_RXCLKCORCNT_OUT                     : out  std_logic_vector(1 downto 0);
    ------------------ Receive Ports - FPGA RX Interface Ports -----------------
    GT9_RXUSRCLK_IN                         : in   std_logic;
    GT9_RXUSRCLK2_IN                        : in   std_logic;
    ------------------ Receive Ports - FPGA RX interface Ports -----------------
    GT9_RXDATA_OUT                          : out  std_logic_vector(15 downto 0);
    ------------------- Receive Ports - Pattern Checker Ports ------------------
    GT9_RXPRBSERR_OUT                       : out  std_logic;
    GT9_RXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
    ------------------- Receive Ports - Pattern Checker ports ------------------
    GT9_RXPRBSCNTRESET_IN                   : in   std_logic;
    ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
    GT9_RXDISPERR_OUT                       : out  std_logic_vector(1 downto 0);
    GT9_RXNOTINTABLE_OUT                    : out  std_logic_vector(1 downto 0);
    --------------------------- Receive Ports - RX AFE -------------------------
    GT9_GTXRXP_IN                           : in   std_logic;
    ------------------------ Receive Ports - RX AFE Ports ----------------------
    GT9_GTXRXN_IN                           : in   std_logic;
    -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
    GT9_RXMCOMMAALIGNEN_IN                  : in   std_logic;
    GT9_RXPCOMMAALIGNEN_IN                  : in   std_logic;
    --------------------- Receive Ports - RX Equalizer Ports -------------------
    GT9_RXDFELPMRESET_IN                    : in   std_logic;
    --------------------- Receive Ports - RX Equilizer Ports -------------------
    GT9_RXLPMHFHOLD_IN                      : in   std_logic;
    GT9_RXLPMLFHOLD_IN                      : in   std_logic;
    --------------- Receive Ports - RX Fabric Output Control Ports -------------
    GT9_RXOUTCLK_OUT                        : out  std_logic;
    ------------- Receive Ports - RX Initialization and Reset Ports ------------
    GT9_GTRXRESET_IN                        : in   std_logic;
    GT9_RXPMARESET_IN                       : in   std_logic;
    ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
    GT9_RXCHARISCOMMA_OUT                   : out  std_logic_vector(1 downto 0);
    GT9_RXCHARISK_OUT                       : out  std_logic_vector(1 downto 0);
    -------------- Receive Ports -RX Initialization and Reset Ports ------------
    GT9_RXRESETDONE_OUT                     : out  std_logic;
    --------------------- TX Initialization and Reset Ports --------------------
    GT9_GTTXRESET_IN                        : in   std_logic;
    GT9_TXUSERRDY_IN                        : in   std_logic;
    ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
    GT9_TXUSRCLK_IN                         : in   std_logic;
    GT9_TXUSRCLK2_IN                        : in   std_logic;
    --------------- Transmit Ports - TX Configurable Driver Ports --------------
    GT9_TXDIFFCTRL_IN                       : in   std_logic_vector(3 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    GT9_TXDATA_IN                           : in   std_logic_vector(15 downto 0);
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    GT9_GTXTXN_OUT                          : out  std_logic;
    GT9_GTXTXP_OUT                          : out  std_logic;
    ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
    GT9_TXOUTCLK_OUT                        : out  std_logic;
    GT9_TXOUTCLKFABRIC_OUT                  : out  std_logic;
    GT9_TXOUTCLKPCS_OUT                     : out  std_logic;
    --------------------- Transmit Ports - TX Gearbox Ports --------------------
    GT9_TXCHARISK_IN                        : in   std_logic_vector(1 downto 0);
    ------------- Transmit Ports - TX Initialization and Reset Ports -----------
    GT9_TXRESETDONE_OUT                     : out  std_logic;
    ------------------ Transmit Ports - pattern Generator Ports ----------------
    GT9_TXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
   
    --_________________________________________________________________________
    --_________________________________________________________________________
    --GT10  (X1Y10)
    --____________________________CHANNEL PORTS________________________________
    ---------------------------- Channel - DRP Ports  --------------------------
    GT10_DRPADDR_IN                         : in   std_logic_vector(8 downto 0);
    GT10_DRPCLK_IN                          : in   std_logic;
    GT10_DRPDI_IN                           : in   std_logic_vector(15 downto 0);
    GT10_DRPDO_OUT                          : out  std_logic_vector(15 downto 0);
    GT10_DRPEN_IN                           : in   std_logic;
    GT10_DRPRDY_OUT                         : out  std_logic;
    GT10_DRPWE_IN                           : in   std_logic;
    ------------------------------- Loopback Ports -----------------------------
    GT10_LOOPBACK_IN                        : in   std_logic_vector(2 downto 0);
    --------------------- RX Initialization and Reset Ports --------------------
    GT10_RXUSERRDY_IN                       : in   std_logic;
    -------------------------- RX Margin Analysis Ports ------------------------
    GT10_EYESCANDATAERROR_OUT               : out  std_logic;
    ------------------------- Receive Ports - CDR Ports ------------------------
    GT10_RXCDRLOCK_OUT                      : out  std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    GT10_RXCLKCORCNT_OUT                    : out  std_logic_vector(1 downto 0);
    ------------------ Receive Ports - FPGA RX Interface Ports -----------------
    GT10_RXUSRCLK_IN                        : in   std_logic;
    GT10_RXUSRCLK2_IN                       : in   std_logic;
    ------------------ Receive Ports - FPGA RX interface Ports -----------------
    GT10_RXDATA_OUT                         : out  std_logic_vector(15 downto 0);
    ------------------- Receive Ports - Pattern Checker Ports ------------------
    GT10_RXPRBSERR_OUT                      : out  std_logic;
    GT10_RXPRBSSEL_IN                       : in   std_logic_vector(2 downto 0);
    ------------------- Receive Ports - Pattern Checker ports ------------------
    GT10_RXPRBSCNTRESET_IN                  : in   std_logic;
    ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
    GT10_RXDISPERR_OUT                      : out  std_logic_vector(1 downto 0);
    GT10_RXNOTINTABLE_OUT                   : out  std_logic_vector(1 downto 0);
    --------------------------- Receive Ports - RX AFE -------------------------
    GT10_GTXRXP_IN                          : in   std_logic;
    ------------------------ Receive Ports - RX AFE Ports ----------------------
    GT10_GTXRXN_IN                          : in   std_logic;
    -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
    GT10_RXMCOMMAALIGNEN_IN                 : in   std_logic;
    GT10_RXPCOMMAALIGNEN_IN                 : in   std_logic;
    --------------------- Receive Ports - RX Equalizer Ports -------------------
    GT10_RXDFELPMRESET_IN                   : in   std_logic;
    --------------------- Receive Ports - RX Equilizer Ports -------------------
    GT10_RXLPMHFHOLD_IN                     : in   std_logic;
    GT10_RXLPMLFHOLD_IN                     : in   std_logic;
    --------------- Receive Ports - RX Fabric Output Control Ports -------------
    GT10_RXOUTCLK_OUT                       : out  std_logic;
    ------------- Receive Ports - RX Initialization and Reset Ports ------------
    GT10_GTRXRESET_IN                       : in   std_logic;
    GT10_RXPMARESET_IN                      : in   std_logic;
    ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
    GT10_RXCHARISCOMMA_OUT                  : out  std_logic_vector(1 downto 0);
    GT10_RXCHARISK_OUT                      : out  std_logic_vector(1 downto 0);
    -------------- Receive Ports -RX Initialization and Reset Ports ------------
    GT10_RXRESETDONE_OUT                    : out  std_logic;
    --------------------- TX Initialization and Reset Ports --------------------
    GT10_GTTXRESET_IN                       : in   std_logic;
    GT10_TXUSERRDY_IN                       : in   std_logic;
    ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
    GT10_TXUSRCLK_IN                        : in   std_logic;
    GT10_TXUSRCLK2_IN                       : in   std_logic;
    --------------- Transmit Ports - TX Configurable Driver Ports --------------
    GT10_TXDIFFCTRL_IN                      : in   std_logic_vector(3 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    GT10_TXDATA_IN                          : in   std_logic_vector(15 downto 0);
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    GT10_GTXTXN_OUT                         : out  std_logic;
    GT10_GTXTXP_OUT                         : out  std_logic;
    ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
    GT10_TXOUTCLK_OUT                       : out  std_logic;
    GT10_TXOUTCLKFABRIC_OUT                 : out  std_logic;
    GT10_TXOUTCLKPCS_OUT                    : out  std_logic;
    --------------------- Transmit Ports - TX Gearbox Ports --------------------
    GT10_TXCHARISK_IN                       : in   std_logic_vector(1 downto 0);
    ------------- Transmit Ports - TX Initialization and Reset Ports -----------
    GT10_TXRESETDONE_OUT                    : out  std_logic;
    ------------------ Transmit Ports - pattern Generator Ports ----------------
    GT10_TXPRBSSEL_IN                       : in   std_logic_vector(2 downto 0);
   
    --_________________________________________________________________________
    --_________________________________________________________________________
    --GT11  (X1Y11)
    --____________________________CHANNEL PORTS________________________________
    ---------------------------- Channel - DRP Ports  --------------------------
    GT11_DRPADDR_IN                         : in   std_logic_vector(8 downto 0);
    GT11_DRPCLK_IN                          : in   std_logic;
    GT11_DRPDI_IN                           : in   std_logic_vector(15 downto 0);
    GT11_DRPDO_OUT                          : out  std_logic_vector(15 downto 0);
    GT11_DRPEN_IN                           : in   std_logic;
    GT11_DRPRDY_OUT                         : out  std_logic;
    GT11_DRPWE_IN                           : in   std_logic;
    ------------------------------- Loopback Ports -----------------------------
    GT11_LOOPBACK_IN                        : in   std_logic_vector(2 downto 0);
    --------------------- RX Initialization and Reset Ports --------------------
    GT11_RXUSERRDY_IN                       : in   std_logic;
    -------------------------- RX Margin Analysis Ports ------------------------
    GT11_EYESCANDATAERROR_OUT               : out  std_logic;
    ------------------------- Receive Ports - CDR Ports ------------------------
    GT11_RXCDRLOCK_OUT                      : out  std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    GT11_RXCLKCORCNT_OUT                    : out  std_logic_vector(1 downto 0);
    ------------------ Receive Ports - FPGA RX Interface Ports -----------------
    GT11_RXUSRCLK_IN                        : in   std_logic;
    GT11_RXUSRCLK2_IN                       : in   std_logic;
    ------------------ Receive Ports - FPGA RX interface Ports -----------------
    GT11_RXDATA_OUT                         : out  std_logic_vector(15 downto 0);
    ------------------- Receive Ports - Pattern Checker Ports ------------------
    GT11_RXPRBSERR_OUT                      : out  std_logic;
    GT11_RXPRBSSEL_IN                       : in   std_logic_vector(2 downto 0);
    ------------------- Receive Ports - Pattern Checker ports ------------------
    GT11_RXPRBSCNTRESET_IN                  : in   std_logic;
    ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
    GT11_RXDISPERR_OUT                      : out  std_logic_vector(1 downto 0);
    GT11_RXNOTINTABLE_OUT                   : out  std_logic_vector(1 downto 0);
    --------------------------- Receive Ports - RX AFE -------------------------
    GT11_GTXRXP_IN                          : in   std_logic;
    ------------------------ Receive Ports - RX AFE Ports ----------------------
    GT11_GTXRXN_IN                          : in   std_logic;
    -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
    GT11_RXMCOMMAALIGNEN_IN                 : in   std_logic;
    GT11_RXPCOMMAALIGNEN_IN                 : in   std_logic;
    --------------------- Receive Ports - RX Equalizer Ports -------------------
    GT11_RXDFELPMRESET_IN                   : in   std_logic;
    --------------------- Receive Ports - RX Equilizer Ports -------------------
    GT11_RXLPMHFHOLD_IN                     : in   std_logic;
    GT11_RXLPMLFHOLD_IN                     : in   std_logic;
    --------------- Receive Ports - RX Fabric Output Control Ports -------------
    GT11_RXOUTCLK_OUT                       : out  std_logic;
    ------------- Receive Ports - RX Initialization and Reset Ports ------------
    GT11_GTRXRESET_IN                       : in   std_logic;
    GT11_RXPMARESET_IN                      : in   std_logic;
    ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
    GT11_RXCHARISCOMMA_OUT                  : out  std_logic_vector(1 downto 0);
    GT11_RXCHARISK_OUT                      : out  std_logic_vector(1 downto 0);
    -------------- Receive Ports -RX Initialization and Reset Ports ------------
    GT11_RXRESETDONE_OUT                    : out  std_logic;
    --------------------- TX Initialization and Reset Ports --------------------
    GT11_GTTXRESET_IN                       : in   std_logic;
    GT11_TXUSERRDY_IN                       : in   std_logic;
    ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
    GT11_TXUSRCLK_IN                        : in   std_logic;
    GT11_TXUSRCLK2_IN                       : in   std_logic;
    --------------- Transmit Ports - TX Configurable Driver Ports --------------
    GT11_TXDIFFCTRL_IN                      : in   std_logic_vector(3 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    GT11_TXDATA_IN                          : in   std_logic_vector(15 downto 0);
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    GT11_GTXTXN_OUT                         : out  std_logic;
    GT11_GTXTXP_OUT                         : out  std_logic;
    ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
    GT11_TXOUTCLK_OUT                       : out  std_logic;
    GT11_TXOUTCLKFABRIC_OUT                 : out  std_logic;
    GT11_TXOUTCLKPCS_OUT                    : out  std_logic;
    --------------------- Transmit Ports - TX Gearbox Ports --------------------
    GT11_TXCHARISK_IN                       : in   std_logic_vector(1 downto 0);
    ------------- Transmit Ports - TX Initialization and Reset Ports -----------
    GT11_TXRESETDONE_OUT                    : out  std_logic;
    ------------------ Transmit Ports - pattern Generator Ports ----------------
    GT11_TXPRBSSEL_IN                       : in   std_logic_vector(2 downto 0);
   

    --____________________________COMMON PORTS________________________________
    ---------------------- Common Block  - Ref Clock Ports ---------------------
    GT0_GTREFCLK0_COMMON_IN                 : in   std_logic;
    ------------------------- Common Block - QPLL Ports ------------------------
    GT0_QPLLLOCK_OUT                        : out  std_logic;
    GT0_QPLLLOCKDETCLK_IN                   : in   std_logic;
    GT0_QPLLREFCLKLOST_OUT                  : out  std_logic;
    GT0_QPLLRESET_IN                        : in   std_logic;

    --____________________________COMMON PORTS________________________________
    ---------------------- Common Block  - Ref Clock Ports ---------------------
    GT1_GTREFCLK0_COMMON_IN                 : in   std_logic;
    ------------------------- Common Block - QPLL Ports ------------------------
    GT1_QPLLLOCK_OUT                        : out  std_logic;
    GT1_QPLLLOCKDETCLK_IN                   : in   std_logic;
    GT1_QPLLREFCLKLOST_OUT                  : out  std_logic;
    GT1_QPLLRESET_IN                        : in   std_logic;

    --____________________________COMMON PORTS________________________________
    ---------------------- Common Block  - Ref Clock Ports ---------------------
    GT2_GTREFCLK0_COMMON_IN                 : in   std_logic;
    ------------------------- Common Block - QPLL Ports ------------------------
    GT2_QPLLLOCK_OUT                        : out  std_logic;
    GT2_QPLLLOCKDETCLK_IN                   : in   std_logic;
    GT2_QPLLREFCLKLOST_OUT                  : out  std_logic;
    GT2_QPLLRESET_IN                        : in   std_logic


);
end component;

component AMC_GTX_TX_STARTUP_FSM
  Generic(
           GT_TYPE                  : string := "GTX";
           STABLE_CLOCK_PERIOD      : integer range 4 to 20 := 8; --Period of the stable clock driving this state-machine, unit is [ns]
           RETRY_COUNTER_BITWIDTH   : integer range 2 to 8  := 8; 
            TX_QPLL_USED             : boolean := False;           -- the TX and RX Reset FSMs must
           RX_QPLL_USED             : boolean := False;           -- share these two generic values
           PHASE_ALIGNMENT_MANUAL   : boolean := True             -- Decision if a manual phase-alignment is necessary or the automatic 
                                                                  -- is enough. For single-lane applications the automatic alignment is 
                                                                  -- sufficient              
         );     
    Port ( STABLE_CLOCK             : in  STD_LOGIC;              --Stable Clock, either a stable clock from the PCB
                                                                  --or reference-clock present at startup.
           TXUSERCLK                : in  STD_LOGIC;              --TXUSERCLK as used in the design
           SOFT_RESET               : in  STD_LOGIC;              --User Reset, can be pulled any time
           QPLLREFCLKLOST           : in  STD_LOGIC;              --QPLL Reference-clock for the GT is lost
           CPLLREFCLKLOST           : in  STD_LOGIC;              --CPLL Reference-clock for the GT is lost
           QPLLLOCK                 : in  STD_LOGIC;              --Lock Detect from the QPLL of the GT
           CPLLLOCK                 : in  STD_LOGIC;              --Lock Detect from the CPLL of the GT
           TXRESETDONE              : in  STD_LOGIC;      
           MMCM_LOCK                : in  STD_LOGIC;      
           GTTXRESET                : out STD_LOGIC:='0';      
           MMCM_RESET               : out STD_LOGIC:='0';      
           QPLL_RESET               : out STD_LOGIC:='0';        --Reset QPLL
           CPLL_RESET               : out STD_LOGIC:='0';        --Reset CPLL
           TX_FSM_RESET_DONE        : out STD_LOGIC:='0';        --Reset-sequence has sucessfully been finished.
           TXUSERRDY                : out STD_LOGIC:='0';
           RUN_PHALIGNMENT          : out STD_LOGIC:='0';
           RESET_PHALIGNMENT        : out STD_LOGIC:='0';
           PHALIGNMENT_DONE         : in  STD_LOGIC;
           
           RETRY_COUNTER            : out  STD_LOGIC_VECTOR (RETRY_COUNTER_BITWIDTH-1 downto 0):=(others=>'0')-- Number of 
                                                            -- Retries it took to get the transceiver up and running
           );
end component;

component AMC_GTX_RX_STARTUP_FSM
  Generic(
           EXAMPLE_SIMULATION       : integer := 0;
           EQ_MODE                  : string := "DFE";
           GT_TYPE                  : string := "GTX";
           STABLE_CLOCK_PERIOD      : integer range 4 to 20 := 8; --Period of the stable clock driving this state-machine, unit is [ns]
           RETRY_COUNTER_BITWIDTH   : integer range 2 to 8  := 8; 
           TX_QPLL_USED             : boolean := False;           -- the TX and RX Reset FSMs must
           RX_QPLL_USED             : boolean := False;           -- share these two generic values
           PHASE_ALIGNMENT_MANUAL   : boolean := True             -- Decision if a manual phase-alignment is necessary or the automatic 
                                                                  -- is enough. For single-lane applications the automatic alignment is 
                                                                  -- sufficient                         
         );     
    Port ( STABLE_CLOCK             : in  STD_LOGIC;        --Stable Clock, either a stable clock from the PCB
                                                            --or reference-clock present at startup.
           RXUSERCLK                : in  STD_LOGIC;        --RXUSERCLK as used in the design
           SOFT_RESET               : in  STD_LOGIC;        --User Reset, can be pulled any time
           QPLLREFCLKLOST           : in  STD_LOGIC;        --QPLL Reference-clock for the GT is lost
           CPLLREFCLKLOST           : in  STD_LOGIC;        --CPLL Reference-clock for the GT is lost
           QPLLLOCK                 : in  STD_LOGIC;        --Lock Detect from the QPLL of the GT
           CPLLLOCK                 : in  STD_LOGIC;        --Lock Detect from the CPLL of the GT
           RXRESETDONE              : in  STD_LOGIC;
           MMCM_LOCK                : in  STD_LOGIC;
           RECCLK_STABLE            : in  STD_LOGIC;
           RECCLK_MONITOR_RESTART   : in  STD_LOGIC;
           DATA_VALID               : in  STD_LOGIC;
           TXUSERRDY                : in  STD_LOGIC;       --TXUSERRDY from GT 
           GTRXRESET                : out STD_LOGIC:='0';
           MMCM_RESET               : out STD_LOGIC:='0';
           QPLL_RESET               : out STD_LOGIC:='0';  --Reset QPLL (only if RX uses QPLL)
           CPLL_RESET               : out STD_LOGIC:='0';  --Reset CPLL (only if RX uses CPLL)
           RX_FSM_RESET_DONE        : out STD_LOGIC:='0';  --Reset-sequence has sucessfully been finished.
           RXUSERRDY                : out STD_LOGIC:='0';
           RUN_PHALIGNMENT          : out STD_LOGIC;
           PHALIGNMENT_DONE         : in  STD_LOGIC; 
           RESET_PHALIGNMENT        : out STD_LOGIC:='0';           
           RXDFEAGCHOLD             : out STD_LOGIC;
           RXDFELFHOLD              : out STD_LOGIC;
           RXLPMLFHOLD              : out STD_LOGIC;
           RXLPMHFHOLD              : out STD_LOGIC;
           RETRY_COUNTER            : out STD_LOGIC_VECTOR (RETRY_COUNTER_BITWIDTH-1 downto 0):=(others=>'0')-- Number of 
                                                            -- Retries it took to get the transceiver up and running
           );
end component;

component AMC_GTX_ADAPT_TOP_DFE is
 generic (
	AGC_TIMER : integer range 0 to 4095:= 150
 );
 port (
	EN                   :  in  STD_LOGIC;
	CTLE3_COMP_EN        :  in  STD_LOGIC;
	GTRXRESET            :  in  STD_LOGIC;
	RXPMARESET           :  in  STD_LOGIC;
	RXDFELPMRESET        :  in  STD_LOGIC;
	DCLK                 :  in  STD_LOGIC;
	DO                   :  in  STD_LOGIC_VECTOR(15 downto 0); 
	DRDY                 :  in  STD_LOGIC;
	DADDR                :  out STD_LOGIC_VECTOR(8 downto 0); 
	DI                   :  out STD_LOGIC_VECTOR(15 downto 0); 
	DEN                  :  out STD_LOGIC;
	DWE                  :  out STD_LOGIC;
	RXMONITOR            :  in  STD_LOGIC_VECTOR(6 downto 0); 
	RXMONITORSEL         :  out STD_LOGIC_VECTOR(1 downto 0);
	AGCHOLD              :  out STD_LOGIC;
	KLHOLD               :  out STD_LOGIC;
	KHHOLD               :  out STD_LOGIC;
	DONE                 :  out STD_LOGIC;
	DEBUG                :  out STD_LOGIC_VECTOR(53 downto 0) 
 );
end component;

component AMC_GTX_ADAPT_TOP_LPM is
generic (
	TIMER : integer range 0 to 4095:= 150
);
port 
 (
	EN                :  in  STD_LOGIC;
	GTRXRESET         :  in  STD_LOGIC;
	RXPMARESET        :  in  STD_LOGIC;
	RXDFELPMRESET     :  in  STD_LOGIC;
	--DRP
	DCLK              :  in  STD_LOGIC;
	DO                :  in  STD_LOGIC_VECTOR(15 downto 0);
	DRDY              :  in  STD_LOGIC;
	DADDR             :  out STD_LOGIC_VECTOR(8 downto 0);
	DI                :  out STD_LOGIC_VECTOR(15 downto 0);
	DEN               :  out STD_LOGIC;
	DWE               :  out STD_LOGIC;

	KLHOLD            :  out STD_LOGIC;
	KHHOLD            :  out STD_LOGIC;
	--DONE	
	DONE              :  out STD_LOGIC;
	--Debug
	DEBUG             :  out STD_LOGIC_VECTOR(53 downto 0)
);
end component;







  function get_cdrlock_time(is_sim : in integer) return integer is
    variable lock_time: integer;
  begin
    if (is_sim = 1) then
      lock_time := 1000;
    else
      lock_time := 50000 / integer(2.5); --Typical CDR lock time is 50,000UI as per DS183
    end if;
    return lock_time;
  end function;

  function get_lpm_adapt_lock_time(is_sim : in integer) return integer is
    variable lock_time: integer;
  begin
    if (is_sim = 1) then
      lock_time := 5;
    else
      lock_time := integer(13 * integer(50) / integer(2.5)); --Typical CDR lock time is 50,000UI as per DS183
    end if;
    return lock_time;
  end function;

--***********************************Parameter Declarations********************

    constant DLY : time := 1 ns;
    constant STABLE_CLOCK_PERIOD  : integer := 20;  --Period of the stable clock driving this state-machine, unit is [ns]
    constant RX_CDRLOCK_TIME      : integer := get_cdrlock_time(EXAMPLE_SIMULATION);       -- 200us
    constant WAIT_TIME_CDRLOCK    : integer := RX_CDRLOCK_TIME / STABLE_CLOCK_PERIOD;      -- 200 us time-out
    constant LPM_ADAPT_LOCK_TIMER : integer := get_lpm_adapt_lock_time(EXAMPLE_SIMULATION);
    constant DFE_ADAPT_LOCK_TIMER : integer := integer((13 * integer(50)) / integer(2.5));

    -------------------------- GT Wrapper Wires ------------------------------
    signal   gt0_txresetdone_i               : std_logic;
    signal   gt0_rxresetdone_i               : std_logic;
    signal   gt0_gttxreset_i                 : std_logic;
    signal   gt0_gttxreset_t                 : std_logic;
    signal   gt0_gtrxreset_i                 : std_logic;
    signal   gt0_gtrxreset_t                 : std_logic;
    signal   gt0_rxdfelpmreset_i             : std_logic;
    signal   gt0_txuserrdy_i                 : std_logic;
    signal   gt0_txuserrdy_t                 : std_logic;
    signal   gt0_rxuserrdy_i                 : std_logic;
    signal   gt0_rxuserrdy_t                 : std_logic;

    signal   gt0_rxdfeagchold_i              : std_logic;
    signal   gt0_rxdfelfhold_i               : std_logic;
    signal   gt0_rxlpmlfhold_i               : std_logic;
    signal   gt0_rxlpmhfhold_i               : std_logic;


    signal   gt0_drpaddr_i                   : std_logic_vector(8 downto 0);
    signal   gt0_drpdi_i                     : std_logic_vector(15 downto 0);
    signal   gt0_drpdo_o                     : std_logic_vector(15 downto 0);
    signal   gt0_drpen_i                     : std_logic;
    signal   gt0_drpwe_i                     : std_logic;
    signal   gt0_drprdy_o                    : std_logic;

    signal   gt0_drpaddr_int                 : std_logic_vector(8 downto 0);
    signal   gt0_drpdi_int                   : std_logic_vector(15 downto 0);
    signal   gt0_drpdo_int                   : std_logic_vector(15 downto 0);
    signal   gt0_drpen_int                   : std_logic;
    signal   gt0_drpwe_int                   : std_logic;
    signal   gt0_drprdy_int                  : std_logic;
    
    signal   gt0_rxmonitorout_o              : std_logic_vector(6 downto 0);
    signal   gt0_rxmonitorsel_i              : std_logic_vector(1 downto 0);
    signal   gt0_adapt_done                  : std_logic;
    signal   gt1_txresetdone_i               : std_logic;
    signal   gt1_rxresetdone_i               : std_logic;
    signal   gt1_gttxreset_i                 : std_logic;
    signal   gt1_gttxreset_t                 : std_logic;
    signal   gt1_gtrxreset_i                 : std_logic;
    signal   gt1_gtrxreset_t                 : std_logic;
    signal   gt1_rxdfelpmreset_i             : std_logic;
    signal   gt1_txuserrdy_i                 : std_logic;
    signal   gt1_txuserrdy_t                 : std_logic;
    signal   gt1_rxuserrdy_i                 : std_logic;
    signal   gt1_rxuserrdy_t                 : std_logic;

    signal   gt1_rxdfeagchold_i              : std_logic;
    signal   gt1_rxdfelfhold_i               : std_logic;
    signal   gt1_rxlpmlfhold_i               : std_logic;
    signal   gt1_rxlpmhfhold_i               : std_logic;


    signal   gt1_drpaddr_i                   : std_logic_vector(8 downto 0);
    signal   gt1_drpdi_i                     : std_logic_vector(15 downto 0);
    signal   gt1_drpdo_o                     : std_logic_vector(15 downto 0);
    signal   gt1_drpen_i                     : std_logic;
    signal   gt1_drpwe_i                     : std_logic;
    signal   gt1_drprdy_o                    : std_logic;

    signal   gt1_drpaddr_int                 : std_logic_vector(8 downto 0);
    signal   gt1_drpdi_int                   : std_logic_vector(15 downto 0);
    signal   gt1_drpdo_int                   : std_logic_vector(15 downto 0);
    signal   gt1_drpen_int                   : std_logic;
    signal   gt1_drpwe_int                   : std_logic;
    signal   gt1_drprdy_int                  : std_logic;
    
    signal   gt1_rxmonitorout_o              : std_logic_vector(6 downto 0);
    signal   gt1_rxmonitorsel_i              : std_logic_vector(1 downto 0);
    signal   gt1_adapt_done                  : std_logic;
    signal   gt2_txresetdone_i               : std_logic;
    signal   gt2_rxresetdone_i               : std_logic;
    signal   gt2_gttxreset_i                 : std_logic;
    signal   gt2_gttxreset_t                 : std_logic;
    signal   gt2_gtrxreset_i                 : std_logic;
    signal   gt2_gtrxreset_t                 : std_logic;
    signal   gt2_rxdfelpmreset_i             : std_logic;
    signal   gt2_txuserrdy_i                 : std_logic;
    signal   gt2_txuserrdy_t                 : std_logic;
    signal   gt2_rxuserrdy_i                 : std_logic;
    signal   gt2_rxuserrdy_t                 : std_logic;

    signal   gt2_rxdfeagchold_i              : std_logic;
    signal   gt2_rxdfelfhold_i               : std_logic;
    signal   gt2_rxlpmlfhold_i               : std_logic;
    signal   gt2_rxlpmhfhold_i               : std_logic;


    signal   gt2_drpaddr_i                   : std_logic_vector(8 downto 0);
    signal   gt2_drpdi_i                     : std_logic_vector(15 downto 0);
    signal   gt2_drpdo_o                     : std_logic_vector(15 downto 0);
    signal   gt2_drpen_i                     : std_logic;
    signal   gt2_drpwe_i                     : std_logic;
    signal   gt2_drprdy_o                    : std_logic;

    signal   gt2_drpaddr_int                 : std_logic_vector(8 downto 0);
    signal   gt2_drpdi_int                   : std_logic_vector(15 downto 0);
    signal   gt2_drpdo_int                   : std_logic_vector(15 downto 0);
    signal   gt2_drpen_int                   : std_logic;
    signal   gt2_drpwe_int                   : std_logic;
    signal   gt2_drprdy_int                  : std_logic;
    
    signal   gt2_rxmonitorout_o              : std_logic_vector(6 downto 0);
    signal   gt2_rxmonitorsel_i              : std_logic_vector(1 downto 0);
    signal   gt2_adapt_done                  : std_logic;
    signal   gt3_txresetdone_i               : std_logic;
    signal   gt3_rxresetdone_i               : std_logic;
    signal   gt3_gttxreset_i                 : std_logic;
    signal   gt3_gttxreset_t                 : std_logic;
    signal   gt3_gtrxreset_i                 : std_logic;
    signal   gt3_gtrxreset_t                 : std_logic;
    signal   gt3_rxdfelpmreset_i             : std_logic;
    signal   gt3_txuserrdy_i                 : std_logic;
    signal   gt3_txuserrdy_t                 : std_logic;
    signal   gt3_rxuserrdy_i                 : std_logic;
    signal   gt3_rxuserrdy_t                 : std_logic;

    signal   gt3_rxdfeagchold_i              : std_logic;
    signal   gt3_rxdfelfhold_i               : std_logic;
    signal   gt3_rxlpmlfhold_i               : std_logic;
    signal   gt3_rxlpmhfhold_i               : std_logic;


    signal   gt3_drpaddr_i                   : std_logic_vector(8 downto 0);
    signal   gt3_drpdi_i                     : std_logic_vector(15 downto 0);
    signal   gt3_drpdo_o                     : std_logic_vector(15 downto 0);
    signal   gt3_drpen_i                     : std_logic;
    signal   gt3_drpwe_i                     : std_logic;
    signal   gt3_drprdy_o                    : std_logic;

    signal   gt3_drpaddr_int                 : std_logic_vector(8 downto 0);
    signal   gt3_drpdi_int                   : std_logic_vector(15 downto 0);
    signal   gt3_drpdo_int                   : std_logic_vector(15 downto 0);
    signal   gt3_drpen_int                   : std_logic;
    signal   gt3_drpwe_int                   : std_logic;
    signal   gt3_drprdy_int                  : std_logic;
    
    signal   gt3_rxmonitorout_o              : std_logic_vector(6 downto 0);
    signal   gt3_rxmonitorsel_i              : std_logic_vector(1 downto 0);
    signal   gt3_adapt_done                  : std_logic;
    signal   gt4_txresetdone_i               : std_logic;
    signal   gt4_rxresetdone_i               : std_logic;
    signal   gt4_gttxreset_i                 : std_logic;
    signal   gt4_gttxreset_t                 : std_logic;
    signal   gt4_gtrxreset_i                 : std_logic;
    signal   gt4_gtrxreset_t                 : std_logic;
    signal   gt4_rxdfelpmreset_i             : std_logic;
    signal   gt4_txuserrdy_i                 : std_logic;
    signal   gt4_txuserrdy_t                 : std_logic;
    signal   gt4_rxuserrdy_i                 : std_logic;
    signal   gt4_rxuserrdy_t                 : std_logic;

    signal   gt4_rxdfeagchold_i              : std_logic;
    signal   gt4_rxdfelfhold_i               : std_logic;
    signal   gt4_rxlpmlfhold_i               : std_logic;
    signal   gt4_rxlpmhfhold_i               : std_logic;


    signal   gt4_drpaddr_i                   : std_logic_vector(8 downto 0);
    signal   gt4_drpdi_i                     : std_logic_vector(15 downto 0);
    signal   gt4_drpdo_o                     : std_logic_vector(15 downto 0);
    signal   gt4_drpen_i                     : std_logic;
    signal   gt4_drpwe_i                     : std_logic;
    signal   gt4_drprdy_o                    : std_logic;

    signal   gt4_drpaddr_int                 : std_logic_vector(8 downto 0);
    signal   gt4_drpdi_int                   : std_logic_vector(15 downto 0);
    signal   gt4_drpdo_int                   : std_logic_vector(15 downto 0);
    signal   gt4_drpen_int                   : std_logic;
    signal   gt4_drpwe_int                   : std_logic;
    signal   gt4_drprdy_int                  : std_logic;
    
    signal   gt4_rxmonitorout_o              : std_logic_vector(6 downto 0);
    signal   gt4_rxmonitorsel_i              : std_logic_vector(1 downto 0);
    signal   gt4_adapt_done                  : std_logic;
    signal   gt5_txresetdone_i               : std_logic;
    signal   gt5_rxresetdone_i               : std_logic;
    signal   gt5_gttxreset_i                 : std_logic;
    signal   gt5_gttxreset_t                 : std_logic;
    signal   gt5_gtrxreset_i                 : std_logic;
    signal   gt5_gtrxreset_t                 : std_logic;
    signal   gt5_rxdfelpmreset_i             : std_logic;
    signal   gt5_txuserrdy_i                 : std_logic;
    signal   gt5_txuserrdy_t                 : std_logic;
    signal   gt5_rxuserrdy_i                 : std_logic;
    signal   gt5_rxuserrdy_t                 : std_logic;

    signal   gt5_rxdfeagchold_i              : std_logic;
    signal   gt5_rxdfelfhold_i               : std_logic;
    signal   gt5_rxlpmlfhold_i               : std_logic;
    signal   gt5_rxlpmhfhold_i               : std_logic;


    signal   gt5_drpaddr_i                   : std_logic_vector(8 downto 0);
    signal   gt5_drpdi_i                     : std_logic_vector(15 downto 0);
    signal   gt5_drpdo_o                     : std_logic_vector(15 downto 0);
    signal   gt5_drpen_i                     : std_logic;
    signal   gt5_drpwe_i                     : std_logic;
    signal   gt5_drprdy_o                    : std_logic;

    signal   gt5_drpaddr_int                 : std_logic_vector(8 downto 0);
    signal   gt5_drpdi_int                   : std_logic_vector(15 downto 0);
    signal   gt5_drpdo_int                   : std_logic_vector(15 downto 0);
    signal   gt5_drpen_int                   : std_logic;
    signal   gt5_drpwe_int                   : std_logic;
    signal   gt5_drprdy_int                  : std_logic;
    
    signal   gt5_rxmonitorout_o              : std_logic_vector(6 downto 0);
    signal   gt5_rxmonitorsel_i              : std_logic_vector(1 downto 0);
    signal   gt5_adapt_done                  : std_logic;
    signal   gt6_txresetdone_i               : std_logic;
    signal   gt6_rxresetdone_i               : std_logic;
    signal   gt6_gttxreset_i                 : std_logic;
    signal   gt6_gttxreset_t                 : std_logic;
    signal   gt6_gtrxreset_i                 : std_logic;
    signal   gt6_gtrxreset_t                 : std_logic;
    signal   gt6_rxdfelpmreset_i             : std_logic;
    signal   gt6_txuserrdy_i                 : std_logic;
    signal   gt6_txuserrdy_t                 : std_logic;
    signal   gt6_rxuserrdy_i                 : std_logic;
    signal   gt6_rxuserrdy_t                 : std_logic;

    signal   gt6_rxdfeagchold_i              : std_logic;
    signal   gt6_rxdfelfhold_i               : std_logic;
    signal   gt6_rxlpmlfhold_i               : std_logic;
    signal   gt6_rxlpmhfhold_i               : std_logic;


    signal   gt6_drpaddr_i                   : std_logic_vector(8 downto 0);
    signal   gt6_drpdi_i                     : std_logic_vector(15 downto 0);
    signal   gt6_drpdo_o                     : std_logic_vector(15 downto 0);
    signal   gt6_drpen_i                     : std_logic;
    signal   gt6_drpwe_i                     : std_logic;
    signal   gt6_drprdy_o                    : std_logic;

    signal   gt6_drpaddr_int                 : std_logic_vector(8 downto 0);
    signal   gt6_drpdi_int                   : std_logic_vector(15 downto 0);
    signal   gt6_drpdo_int                   : std_logic_vector(15 downto 0);
    signal   gt6_drpen_int                   : std_logic;
    signal   gt6_drpwe_int                   : std_logic;
    signal   gt6_drprdy_int                  : std_logic;
    
    signal   gt6_rxmonitorout_o              : std_logic_vector(6 downto 0);
    signal   gt6_rxmonitorsel_i              : std_logic_vector(1 downto 0);
    signal   gt6_adapt_done                  : std_logic;
    signal   gt7_txresetdone_i               : std_logic;
    signal   gt7_rxresetdone_i               : std_logic;
    signal   gt7_gttxreset_i                 : std_logic;
    signal   gt7_gttxreset_t                 : std_logic;
    signal   gt7_gtrxreset_i                 : std_logic;
    signal   gt7_gtrxreset_t                 : std_logic;
    signal   gt7_rxdfelpmreset_i             : std_logic;
    signal   gt7_txuserrdy_i                 : std_logic;
    signal   gt7_txuserrdy_t                 : std_logic;
    signal   gt7_rxuserrdy_i                 : std_logic;
    signal   gt7_rxuserrdy_t                 : std_logic;

    signal   gt7_rxdfeagchold_i              : std_logic;
    signal   gt7_rxdfelfhold_i               : std_logic;
    signal   gt7_rxlpmlfhold_i               : std_logic;
    signal   gt7_rxlpmhfhold_i               : std_logic;


    signal   gt7_drpaddr_i                   : std_logic_vector(8 downto 0);
    signal   gt7_drpdi_i                     : std_logic_vector(15 downto 0);
    signal   gt7_drpdo_o                     : std_logic_vector(15 downto 0);
    signal   gt7_drpen_i                     : std_logic;
    signal   gt7_drpwe_i                     : std_logic;
    signal   gt7_drprdy_o                    : std_logic;

    signal   gt7_drpaddr_int                 : std_logic_vector(8 downto 0);
    signal   gt7_drpdi_int                   : std_logic_vector(15 downto 0);
    signal   gt7_drpdo_int                   : std_logic_vector(15 downto 0);
    signal   gt7_drpen_int                   : std_logic;
    signal   gt7_drpwe_int                   : std_logic;
    signal   gt7_drprdy_int                  : std_logic;
    
    signal   gt7_rxmonitorout_o              : std_logic_vector(6 downto 0);
    signal   gt7_rxmonitorsel_i              : std_logic_vector(1 downto 0);
    signal   gt7_adapt_done                  : std_logic;
    signal   gt8_txresetdone_i               : std_logic;
    signal   gt8_rxresetdone_i               : std_logic;
    signal   gt8_gttxreset_i                 : std_logic;
    signal   gt8_gttxreset_t                 : std_logic;
    signal   gt8_gtrxreset_i                 : std_logic;
    signal   gt8_gtrxreset_t                 : std_logic;
    signal   gt8_rxdfelpmreset_i             : std_logic;
    signal   gt8_txuserrdy_i                 : std_logic;
    signal   gt8_txuserrdy_t                 : std_logic;
    signal   gt8_rxuserrdy_i                 : std_logic;
    signal   gt8_rxuserrdy_t                 : std_logic;

    signal   gt8_rxdfeagchold_i              : std_logic;
    signal   gt8_rxdfelfhold_i               : std_logic;
    signal   gt8_rxlpmlfhold_i               : std_logic;
    signal   gt8_rxlpmhfhold_i               : std_logic;


    signal   gt8_drpaddr_i                   : std_logic_vector(8 downto 0);
    signal   gt8_drpdi_i                     : std_logic_vector(15 downto 0);
    signal   gt8_drpdo_o                     : std_logic_vector(15 downto 0);
    signal   gt8_drpen_i                     : std_logic;
    signal   gt8_drpwe_i                     : std_logic;
    signal   gt8_drprdy_o                    : std_logic;

    signal   gt8_drpaddr_int                 : std_logic_vector(8 downto 0);
    signal   gt8_drpdi_int                   : std_logic_vector(15 downto 0);
    signal   gt8_drpdo_int                   : std_logic_vector(15 downto 0);
    signal   gt8_drpen_int                   : std_logic;
    signal   gt8_drpwe_int                   : std_logic;
    signal   gt8_drprdy_int                  : std_logic;
    
    signal   gt8_rxmonitorout_o              : std_logic_vector(6 downto 0);
    signal   gt8_rxmonitorsel_i              : std_logic_vector(1 downto 0);
    signal   gt8_adapt_done                  : std_logic;
    signal   gt9_txresetdone_i               : std_logic;
    signal   gt9_rxresetdone_i               : std_logic;
    signal   gt9_gttxreset_i                 : std_logic;
    signal   gt9_gttxreset_t                 : std_logic;
    signal   gt9_gtrxreset_i                 : std_logic;
    signal   gt9_gtrxreset_t                 : std_logic;
    signal   gt9_rxdfelpmreset_i             : std_logic;
    signal   gt9_txuserrdy_i                 : std_logic;
    signal   gt9_txuserrdy_t                 : std_logic;
    signal   gt9_rxuserrdy_i                 : std_logic;
    signal   gt9_rxuserrdy_t                 : std_logic;

    signal   gt9_rxdfeagchold_i              : std_logic;
    signal   gt9_rxdfelfhold_i               : std_logic;
    signal   gt9_rxlpmlfhold_i               : std_logic;
    signal   gt9_rxlpmhfhold_i               : std_logic;


    signal   gt9_drpaddr_i                   : std_logic_vector(8 downto 0);
    signal   gt9_drpdi_i                     : std_logic_vector(15 downto 0);
    signal   gt9_drpdo_o                     : std_logic_vector(15 downto 0);
    signal   gt9_drpen_i                     : std_logic;
    signal   gt9_drpwe_i                     : std_logic;
    signal   gt9_drprdy_o                    : std_logic;

    signal   gt9_drpaddr_int                 : std_logic_vector(8 downto 0);
    signal   gt9_drpdi_int                   : std_logic_vector(15 downto 0);
    signal   gt9_drpdo_int                   : std_logic_vector(15 downto 0);
    signal   gt9_drpen_int                   : std_logic;
    signal   gt9_drpwe_int                   : std_logic;
    signal   gt9_drprdy_int                  : std_logic;
    
    signal   gt9_rxmonitorout_o              : std_logic_vector(6 downto 0);
    signal   gt9_rxmonitorsel_i              : std_logic_vector(1 downto 0);
    signal   gt9_adapt_done                  : std_logic;
    signal   gt10_txresetdone_i              : std_logic;
    signal   gt10_rxresetdone_i              : std_logic;
    signal   gt10_gttxreset_i                : std_logic;
    signal   gt10_gttxreset_t                : std_logic;
    signal   gt10_gtrxreset_i                : std_logic;
    signal   gt10_gtrxreset_t                : std_logic;
    signal   gt10_rxdfelpmreset_i            : std_logic;
    signal   gt10_txuserrdy_i                : std_logic;
    signal   gt10_txuserrdy_t                : std_logic;
    signal   gt10_rxuserrdy_i                : std_logic;
    signal   gt10_rxuserrdy_t                : std_logic;

    signal   gt10_rxdfeagchold_i             : std_logic;
    signal   gt10_rxdfelfhold_i              : std_logic;
    signal   gt10_rxlpmlfhold_i              : std_logic;
    signal   gt10_rxlpmhfhold_i              : std_logic;


    signal   gt10_drpaddr_i                  : std_logic_vector(8 downto 0);
    signal   gt10_drpdi_i                    : std_logic_vector(15 downto 0);
    signal   gt10_drpdo_o                    : std_logic_vector(15 downto 0);
    signal   gt10_drpen_i                    : std_logic;
    signal   gt10_drpwe_i                    : std_logic;
    signal   gt10_drprdy_o                   : std_logic;

    signal   gt10_drpaddr_int                : std_logic_vector(8 downto 0);
    signal   gt10_drpdi_int                  : std_logic_vector(15 downto 0);
    signal   gt10_drpdo_int                  : std_logic_vector(15 downto 0);
    signal   gt10_drpen_int                  : std_logic;
    signal   gt10_drpwe_int                  : std_logic;
    signal   gt10_drprdy_int                 : std_logic;
    
    signal   gt10_rxmonitorout_o             : std_logic_vector(6 downto 0);
    signal   gt10_rxmonitorsel_i             : std_logic_vector(1 downto 0);
    signal   gt10_adapt_done                 : std_logic;
    signal   gt11_txresetdone_i              : std_logic;
    signal   gt11_rxresetdone_i              : std_logic;
    signal   gt11_gttxreset_i                : std_logic;
    signal   gt11_gttxreset_t                : std_logic;
    signal   gt11_gtrxreset_i                : std_logic;
    signal   gt11_gtrxreset_t                : std_logic;
    signal   gt11_rxdfelpmreset_i            : std_logic;
    signal   gt11_txuserrdy_i                : std_logic;
    signal   gt11_txuserrdy_t                : std_logic;
    signal   gt11_rxuserrdy_i                : std_logic;
    signal   gt11_rxuserrdy_t                : std_logic;

    signal   gt11_rxdfeagchold_i             : std_logic;
    signal   gt11_rxdfelfhold_i              : std_logic;
    signal   gt11_rxlpmlfhold_i              : std_logic;
    signal   gt11_rxlpmhfhold_i              : std_logic;


    signal   gt11_drpaddr_i                  : std_logic_vector(8 downto 0);
    signal   gt11_drpdi_i                    : std_logic_vector(15 downto 0);
    signal   gt11_drpdo_o                    : std_logic_vector(15 downto 0);
    signal   gt11_drpen_i                    : std_logic;
    signal   gt11_drpwe_i                    : std_logic;
    signal   gt11_drprdy_o                   : std_logic;

    signal   gt11_drpaddr_int                : std_logic_vector(8 downto 0);
    signal   gt11_drpdi_int                  : std_logic_vector(15 downto 0);
    signal   gt11_drpdo_int                  : std_logic_vector(15 downto 0);
    signal   gt11_drpen_int                  : std_logic;
    signal   gt11_drpwe_int                  : std_logic;
    signal   gt11_drprdy_int                 : std_logic;
    
    signal   gt11_rxmonitorout_o             : std_logic_vector(6 downto 0);
    signal   gt11_rxmonitorsel_i             : std_logic_vector(1 downto 0);
    signal   gt11_adapt_done                 : std_logic;

    signal   gt0_qpllreset_i                 : std_logic;
    signal   gt0_qpllreset_t                 : std_logic;
    signal   gt0_qpllrefclklost_i            : std_logic;
    signal   gt0_qplllock_i                  : std_logic;
    signal   gt1_qpllreset_i                 : std_logic;
    signal   gt1_qpllreset_t                 : std_logic;
    signal   gt1_qpllrefclklost_i            : std_logic;
    signal   gt1_qplllock_i                  : std_logic;
    signal   gt2_qpllreset_i                 : std_logic;
    signal   gt2_qpllreset_t                 : std_logic;
    signal   gt2_qpllrefclklost_i            : std_logic;
    signal   gt2_qplllock_i                  : std_logic;


    ------------------------------- Global Signals -----------------------------
    signal  tied_to_ground_i                : std_logic;
    signal  tied_to_vcc_i                   : std_logic;

    signal   gt0_rxoutclk_i                  : std_logic;
    signal   gt0_recclk_stable_i             : std_logic;

    signal   gt1_rxoutclk_i                  : std_logic;
    signal   gt1_recclk_stable_i             : std_logic;

    signal   gt2_rxoutclk_i                  : std_logic;
    signal   gt2_recclk_stable_i             : std_logic;

    signal   gt3_rxoutclk_i                  : std_logic;
    signal   gt3_recclk_stable_i             : std_logic;

    signal   gt4_rxoutclk_i                  : std_logic;
    signal   gt4_recclk_stable_i             : std_logic;

    signal   gt5_rxoutclk_i                  : std_logic;
    signal   gt5_recclk_stable_i             : std_logic;

    signal   gt6_rxoutclk_i                  : std_logic;
    signal   gt6_recclk_stable_i             : std_logic;

    signal   gt7_rxoutclk_i                  : std_logic;
    signal   gt7_recclk_stable_i             : std_logic;

    signal   gt8_rxoutclk_i                  : std_logic;
    signal   gt8_recclk_stable_i             : std_logic;

    signal   gt9_rxoutclk_i                  : std_logic;
    signal   gt9_recclk_stable_i             : std_logic;

    signal   gt10_rxoutclk_i                 : std_logic;
    signal   gt10_recclk_stable_i            : std_logic;

    signal   gt11_rxoutclk_i                 : std_logic;
    signal   gt11_recclk_stable_i            : std_logic;






    signal   rx_cdrlock_counter  :   integer range 0 to WAIT_TIME_CDRLOCK:= 0 ;
    signal      rx_cdrlocked                    : std_logic;


 


--**************************** Main Body of Code *******************************
begin
    --  Static signal Assigments
    tied_to_ground_i                             <= '0';
    tied_to_vcc_i                                <= '1';

    ----------------------------- The GT Wrapper -----------------------------
    
    -- Use the instantiation template in the example directory to add the GT wrapper to your design.
    -- In this example, the wrapper is wired up for basic operation with a frame generator and frame 
    -- checker. The GTs will reset, then attempt to align and transmit data. If channel bonding is 
    -- enabled, bonding should occur after alignment.


    AMC_GTX_i : AMC_GTX
    generic map
    (
        WRAPPER_SIM_GTRESET_SPEEDUP     =>      EXAMPLE_SIM_GTRESET_SPEEDUP
    )
    port map
    (
  
        --_____________________________________________________________________
        --_____________________________________________________________________
        --GT0  (X1Y0)

        ---------------------------- Channel - DRP Ports  --------------------------
        GT0_DRPADDR_IN                  =>      gt0_drpaddr_i,
        GT0_DRPCLK_IN                   =>      GT0_DRPCLK_IN,
        GT0_DRPDI_IN                    =>      gt0_drpdi_i,
        GT0_DRPDO_OUT                   =>      gt0_drpdo_o,
        GT0_DRPEN_IN                    =>      gt0_drpen_i,
        GT0_DRPRDY_OUT                  =>      gt0_drprdy_o,
        GT0_DRPWE_IN                    =>      gt0_drpwe_i,
        ------------------------------- Loopback Ports -----------------------------
        GT0_LOOPBACK_IN                 =>      GT0_LOOPBACK_IN,
        --------------------- RX Initialization and Reset Ports --------------------
        GT0_RXUSERRDY_IN                =>      gt0_rxuserrdy_i,
        -------------------------- RX Margin Analysis Ports ------------------------
        GT0_EYESCANDATAERROR_OUT        =>      GT0_EYESCANDATAERROR_OUT,
        ------------------------- Receive Ports - CDR Ports ------------------------
        GT0_RXCDRLOCK_OUT               =>      GT0_RXCDRLOCK_OUT,
        ------------------- Receive Ports - Clock Correction Ports -----------------
        GT0_RXCLKCORCNT_OUT             =>      GT0_RXCLKCORCNT_OUT,
        ------------------ Receive Ports - FPGA RX Interface Ports -----------------
        GT0_RXUSRCLK_IN                 =>      GT0_RXUSRCLK_IN,
        GT0_RXUSRCLK2_IN                =>      GT0_RXUSRCLK2_IN,
        ------------------ Receive Ports - FPGA RX interface Ports -----------------
        GT0_RXDATA_OUT                  =>      GT0_RXDATA_OUT,
        ------------------- Receive Ports - Pattern Checker Ports ------------------
        GT0_RXPRBSERR_OUT               =>      GT0_RXPRBSERR_OUT,
        GT0_RXPRBSSEL_IN                =>      GT0_RXPRBSSEL_IN,
        ------------------- Receive Ports - Pattern Checker ports ------------------
        GT0_RXPRBSCNTRESET_IN           =>      GT0_RXPRBSCNTRESET_IN,
        ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
        GT0_RXDISPERR_OUT               =>      GT0_RXDISPERR_OUT,
        GT0_RXNOTINTABLE_OUT            =>      GT0_RXNOTINTABLE_OUT,
        --------------------------- Receive Ports - RX AFE -------------------------
        GT0_GTXRXP_IN                   =>      GT0_GTXRXP_IN,
        ------------------------ Receive Ports - RX AFE Ports ----------------------
        GT0_GTXRXN_IN                   =>      GT0_GTXRXN_IN,
        -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
        GT0_RXMCOMMAALIGNEN_IN          =>      GT0_RXMCOMMAALIGNEN_IN,
        GT0_RXPCOMMAALIGNEN_IN          =>      GT0_RXPCOMMAALIGNEN_IN,
        --------------------- Receive Ports - RX Equalizer Ports -------------------
        GT0_RXDFELPMRESET_IN            =>      gt0_rxdfelpmreset_i,
        --------------------- Receive Ports - RX Equilizer Ports -------------------
        GT0_RXLPMHFHOLD_IN              =>      gt0_rxlpmhfhold_i,
        GT0_RXLPMLFHOLD_IN              =>      gt0_rxlpmlfhold_i,
        --------------- Receive Ports - RX Fabric Output Control Ports -------------
        GT0_RXOUTCLK_OUT                =>      gt0_rxoutclk_i,
        ------------- Receive Ports - RX Initialization and Reset Ports ------------
        GT0_GTRXRESET_IN                =>      gt0_gtrxreset_i,
        GT0_RXPMARESET_IN               =>      GT0_RXPMARESET_IN,
        ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
        GT0_RXCHARISCOMMA_OUT           =>      GT0_RXCHARISCOMMA_OUT,
        GT0_RXCHARISK_OUT               =>      GT0_RXCHARISK_OUT,
        -------------- Receive Ports -RX Initialization and Reset Ports ------------
        GT0_RXRESETDONE_OUT             =>      gt0_rxresetdone_i,
        --------------------- TX Initialization and Reset Ports --------------------
        GT0_GTTXRESET_IN                =>      gt0_gttxreset_i,
        GT0_TXUSERRDY_IN                =>      gt0_txuserrdy_i,
        ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
        GT0_TXUSRCLK_IN                 =>      GT0_TXUSRCLK_IN,
        GT0_TXUSRCLK2_IN                =>      GT0_TXUSRCLK2_IN,
        --------------- Transmit Ports - TX Configurable Driver Ports --------------
        GT0_TXDIFFCTRL_IN               =>      GT0_TXDIFFCTRL_IN,
        ------------------ Transmit Ports - TX Data Path interface -----------------
        GT0_TXDATA_IN                   =>      GT0_TXDATA_IN,
        ---------------- Transmit Ports - TX Driver and OOB signaling --------------
        GT0_GTXTXN_OUT                  =>      GT0_GTXTXN_OUT,
        GT0_GTXTXP_OUT                  =>      GT0_GTXTXP_OUT,
        ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
        GT0_TXOUTCLK_OUT                =>      GT0_TXOUTCLK_OUT,
        GT0_TXOUTCLKFABRIC_OUT          =>      GT0_TXOUTCLKFABRIC_OUT,
        GT0_TXOUTCLKPCS_OUT             =>      GT0_TXOUTCLKPCS_OUT,
        --------------------- Transmit Ports - TX Gearbox Ports --------------------
        GT0_TXCHARISK_IN                =>      GT0_TXCHARISK_IN,
        ------------- Transmit Ports - TX Initialization and Reset Ports -----------
        GT0_TXRESETDONE_OUT             =>      gt0_txresetdone_i,
        ------------------ Transmit Ports - pattern Generator Ports ----------------
        GT0_TXPRBSSEL_IN                =>      GT0_TXPRBSSEL_IN,


  
        --_____________________________________________________________________
        --_____________________________________________________________________
        --GT1  (X1Y1)

        ---------------------------- Channel - DRP Ports  --------------------------
        GT1_DRPADDR_IN                  =>      gt1_drpaddr_i,
        GT1_DRPCLK_IN                   =>      GT1_DRPCLK_IN,
        GT1_DRPDI_IN                    =>      gt1_drpdi_i,
        GT1_DRPDO_OUT                   =>      gt1_drpdo_o,
        GT1_DRPEN_IN                    =>      gt1_drpen_i,
        GT1_DRPRDY_OUT                  =>      gt1_drprdy_o,
        GT1_DRPWE_IN                    =>      gt1_drpwe_i,
        ------------------------------- Loopback Ports -----------------------------
        GT1_LOOPBACK_IN                 =>      GT1_LOOPBACK_IN,
        --------------------- RX Initialization and Reset Ports --------------------
        GT1_RXUSERRDY_IN                =>      gt1_rxuserrdy_i,
        -------------------------- RX Margin Analysis Ports ------------------------
        GT1_EYESCANDATAERROR_OUT        =>      GT1_EYESCANDATAERROR_OUT,
        ------------------------- Receive Ports - CDR Ports ------------------------
        GT1_RXCDRLOCK_OUT               =>      GT1_RXCDRLOCK_OUT,
        ------------------- Receive Ports - Clock Correction Ports -----------------
        GT1_RXCLKCORCNT_OUT             =>      GT1_RXCLKCORCNT_OUT,
        ------------------ Receive Ports - FPGA RX Interface Ports -----------------
        GT1_RXUSRCLK_IN                 =>      GT1_RXUSRCLK_IN,
        GT1_RXUSRCLK2_IN                =>      GT1_RXUSRCLK2_IN,
        ------------------ Receive Ports - FPGA RX interface Ports -----------------
        GT1_RXDATA_OUT                  =>      GT1_RXDATA_OUT,
        ------------------- Receive Ports - Pattern Checker Ports ------------------
        GT1_RXPRBSERR_OUT               =>      GT1_RXPRBSERR_OUT,
        GT1_RXPRBSSEL_IN                =>      GT1_RXPRBSSEL_IN,
        ------------------- Receive Ports - Pattern Checker ports ------------------
        GT1_RXPRBSCNTRESET_IN           =>      GT1_RXPRBSCNTRESET_IN,
        ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
        GT1_RXDISPERR_OUT               =>      GT1_RXDISPERR_OUT,
        GT1_RXNOTINTABLE_OUT            =>      GT1_RXNOTINTABLE_OUT,
        --------------------------- Receive Ports - RX AFE -------------------------
        GT1_GTXRXP_IN                   =>      GT1_GTXRXP_IN,
        ------------------------ Receive Ports - RX AFE Ports ----------------------
        GT1_GTXRXN_IN                   =>      GT1_GTXRXN_IN,
        -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
        GT1_RXMCOMMAALIGNEN_IN          =>      GT1_RXMCOMMAALIGNEN_IN,
        GT1_RXPCOMMAALIGNEN_IN          =>      GT1_RXPCOMMAALIGNEN_IN,
        --------------------- Receive Ports - RX Equalizer Ports -------------------
        GT1_RXDFELPMRESET_IN            =>      gt1_rxdfelpmreset_i,
        --------------------- Receive Ports - RX Equilizer Ports -------------------
        GT1_RXLPMHFHOLD_IN              =>      gt1_rxlpmhfhold_i,
        GT1_RXLPMLFHOLD_IN              =>      gt1_rxlpmlfhold_i,
        --------------- Receive Ports - RX Fabric Output Control Ports -------------
        GT1_RXOUTCLK_OUT                =>      gt1_rxoutclk_i,
        ------------- Receive Ports - RX Initialization and Reset Ports ------------
        GT1_GTRXRESET_IN                =>      gt1_gtrxreset_i,
        GT1_RXPMARESET_IN               =>      GT1_RXPMARESET_IN,
        ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
        GT1_RXCHARISCOMMA_OUT           =>      GT1_RXCHARISCOMMA_OUT,
        GT1_RXCHARISK_OUT               =>      GT1_RXCHARISK_OUT,
        -------------- Receive Ports -RX Initialization and Reset Ports ------------
        GT1_RXRESETDONE_OUT             =>      gt1_rxresetdone_i,
        --------------------- TX Initialization and Reset Ports --------------------
        GT1_GTTXRESET_IN                =>      gt1_gttxreset_i,
        GT1_TXUSERRDY_IN                =>      gt1_txuserrdy_i,
        ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
        GT1_TXUSRCLK_IN                 =>      GT1_TXUSRCLK_IN,
        GT1_TXUSRCLK2_IN                =>      GT1_TXUSRCLK2_IN,
        --------------- Transmit Ports - TX Configurable Driver Ports --------------
        GT1_TXDIFFCTRL_IN               =>      GT1_TXDIFFCTRL_IN,
        ------------------ Transmit Ports - TX Data Path interface -----------------
        GT1_TXDATA_IN                   =>      GT1_TXDATA_IN,
        ---------------- Transmit Ports - TX Driver and OOB signaling --------------
        GT1_GTXTXN_OUT                  =>      GT1_GTXTXN_OUT,
        GT1_GTXTXP_OUT                  =>      GT1_GTXTXP_OUT,
        ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
        GT1_TXOUTCLK_OUT                =>      GT1_TXOUTCLK_OUT,
        GT1_TXOUTCLKFABRIC_OUT          =>      GT1_TXOUTCLKFABRIC_OUT,
        GT1_TXOUTCLKPCS_OUT             =>      GT1_TXOUTCLKPCS_OUT,
        --------------------- Transmit Ports - TX Gearbox Ports --------------------
        GT1_TXCHARISK_IN                =>      GT1_TXCHARISK_IN,
        ------------- Transmit Ports - TX Initialization and Reset Ports -----------
        GT1_TXRESETDONE_OUT             =>      gt1_txresetdone_i,
        ------------------ Transmit Ports - pattern Generator Ports ----------------
        GT1_TXPRBSSEL_IN                =>      GT1_TXPRBSSEL_IN,


  
        --_____________________________________________________________________
        --_____________________________________________________________________
        --GT2  (X1Y2)

        ---------------------------- Channel - DRP Ports  --------------------------
        GT2_DRPADDR_IN                  =>      gt2_drpaddr_i,
        GT2_DRPCLK_IN                   =>      GT2_DRPCLK_IN,
        GT2_DRPDI_IN                    =>      gt2_drpdi_i,
        GT2_DRPDO_OUT                   =>      gt2_drpdo_o,
        GT2_DRPEN_IN                    =>      gt2_drpen_i,
        GT2_DRPRDY_OUT                  =>      gt2_drprdy_o,
        GT2_DRPWE_IN                    =>      gt2_drpwe_i,
        ------------------------------- Loopback Ports -----------------------------
        GT2_LOOPBACK_IN                 =>      GT2_LOOPBACK_IN,
        --------------------- RX Initialization and Reset Ports --------------------
        GT2_RXUSERRDY_IN                =>      gt2_rxuserrdy_i,
        -------------------------- RX Margin Analysis Ports ------------------------
        GT2_EYESCANDATAERROR_OUT        =>      GT2_EYESCANDATAERROR_OUT,
        ------------------------- Receive Ports - CDR Ports ------------------------
        GT2_RXCDRLOCK_OUT               =>      GT2_RXCDRLOCK_OUT,
        ------------------- Receive Ports - Clock Correction Ports -----------------
        GT2_RXCLKCORCNT_OUT             =>      GT2_RXCLKCORCNT_OUT,
        ------------------ Receive Ports - FPGA RX Interface Ports -----------------
        GT2_RXUSRCLK_IN                 =>      GT2_RXUSRCLK_IN,
        GT2_RXUSRCLK2_IN                =>      GT2_RXUSRCLK2_IN,
        ------------------ Receive Ports - FPGA RX interface Ports -----------------
        GT2_RXDATA_OUT                  =>      GT2_RXDATA_OUT,
        ------------------- Receive Ports - Pattern Checker Ports ------------------
        GT2_RXPRBSERR_OUT               =>      GT2_RXPRBSERR_OUT,
        GT2_RXPRBSSEL_IN                =>      GT2_RXPRBSSEL_IN,
        ------------------- Receive Ports - Pattern Checker ports ------------------
        GT2_RXPRBSCNTRESET_IN           =>      GT2_RXPRBSCNTRESET_IN,
        ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
        GT2_RXDISPERR_OUT               =>      GT2_RXDISPERR_OUT,
        GT2_RXNOTINTABLE_OUT            =>      GT2_RXNOTINTABLE_OUT,
        --------------------------- Receive Ports - RX AFE -------------------------
        GT2_GTXRXP_IN                   =>      GT2_GTXRXP_IN,
        ------------------------ Receive Ports - RX AFE Ports ----------------------
        GT2_GTXRXN_IN                   =>      GT2_GTXRXN_IN,
        -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
        GT2_RXMCOMMAALIGNEN_IN          =>      GT2_RXMCOMMAALIGNEN_IN,
        GT2_RXPCOMMAALIGNEN_IN          =>      GT2_RXPCOMMAALIGNEN_IN,
        --------------------- Receive Ports - RX Equalizer Ports -------------------
        GT2_RXDFELPMRESET_IN            =>      gt2_rxdfelpmreset_i,
        --------------------- Receive Ports - RX Equilizer Ports -------------------
        GT2_RXLPMHFHOLD_IN              =>      gt2_rxlpmhfhold_i,
        GT2_RXLPMLFHOLD_IN              =>      gt2_rxlpmlfhold_i,
        --------------- Receive Ports - RX Fabric Output Control Ports -------------
        GT2_RXOUTCLK_OUT                =>      gt2_rxoutclk_i,
        ------------- Receive Ports - RX Initialization and Reset Ports ------------
        GT2_GTRXRESET_IN                =>      gt2_gtrxreset_i,
        GT2_RXPMARESET_IN               =>      GT2_RXPMARESET_IN,
        ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
        GT2_RXCHARISCOMMA_OUT           =>      GT2_RXCHARISCOMMA_OUT,
        GT2_RXCHARISK_OUT               =>      GT2_RXCHARISK_OUT,
        -------------- Receive Ports -RX Initialization and Reset Ports ------------
        GT2_RXRESETDONE_OUT             =>      gt2_rxresetdone_i,
        --------------------- TX Initialization and Reset Ports --------------------
        GT2_GTTXRESET_IN                =>      gt2_gttxreset_i,
        GT2_TXUSERRDY_IN                =>      gt2_txuserrdy_i,
        ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
        GT2_TXUSRCLK_IN                 =>      GT2_TXUSRCLK_IN,
        GT2_TXUSRCLK2_IN                =>      GT2_TXUSRCLK2_IN,
        --------------- Transmit Ports - TX Configurable Driver Ports --------------
        GT2_TXDIFFCTRL_IN               =>      GT2_TXDIFFCTRL_IN,
        ------------------ Transmit Ports - TX Data Path interface -----------------
        GT2_TXDATA_IN                   =>      GT2_TXDATA_IN,
        ---------------- Transmit Ports - TX Driver and OOB signaling --------------
        GT2_GTXTXN_OUT                  =>      GT2_GTXTXN_OUT,
        GT2_GTXTXP_OUT                  =>      GT2_GTXTXP_OUT,
        ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
        GT2_TXOUTCLK_OUT                =>      GT2_TXOUTCLK_OUT,
        GT2_TXOUTCLKFABRIC_OUT          =>      GT2_TXOUTCLKFABRIC_OUT,
        GT2_TXOUTCLKPCS_OUT             =>      GT2_TXOUTCLKPCS_OUT,
        --------------------- Transmit Ports - TX Gearbox Ports --------------------
        GT2_TXCHARISK_IN                =>      GT2_TXCHARISK_IN,
        ------------- Transmit Ports - TX Initialization and Reset Ports -----------
        GT2_TXRESETDONE_OUT             =>      gt2_txresetdone_i,
        ------------------ Transmit Ports - pattern Generator Ports ----------------
        GT2_TXPRBSSEL_IN                =>      GT2_TXPRBSSEL_IN,


  
        --_____________________________________________________________________
        --_____________________________________________________________________
        --GT3  (X1Y3)

        ---------------------------- Channel - DRP Ports  --------------------------
        GT3_DRPADDR_IN                  =>      gt3_drpaddr_i,
        GT3_DRPCLK_IN                   =>      GT3_DRPCLK_IN,
        GT3_DRPDI_IN                    =>      gt3_drpdi_i,
        GT3_DRPDO_OUT                   =>      gt3_drpdo_o,
        GT3_DRPEN_IN                    =>      gt3_drpen_i,
        GT3_DRPRDY_OUT                  =>      gt3_drprdy_o,
        GT3_DRPWE_IN                    =>      gt3_drpwe_i,
        ------------------------------- Loopback Ports -----------------------------
        GT3_LOOPBACK_IN                 =>      GT3_LOOPBACK_IN,
        --------------------- RX Initialization and Reset Ports --------------------
        GT3_RXUSERRDY_IN                =>      gt3_rxuserrdy_i,
        -------------------------- RX Margin Analysis Ports ------------------------
        GT3_EYESCANDATAERROR_OUT        =>      GT3_EYESCANDATAERROR_OUT,
        ------------------------- Receive Ports - CDR Ports ------------------------
        GT3_RXCDRLOCK_OUT               =>      GT3_RXCDRLOCK_OUT,
        ------------------- Receive Ports - Clock Correction Ports -----------------
        GT3_RXCLKCORCNT_OUT             =>      GT3_RXCLKCORCNT_OUT,
        ------------------ Receive Ports - FPGA RX Interface Ports -----------------
        GT3_RXUSRCLK_IN                 =>      GT3_RXUSRCLK_IN,
        GT3_RXUSRCLK2_IN                =>      GT3_RXUSRCLK2_IN,
        ------------------ Receive Ports - FPGA RX interface Ports -----------------
        GT3_RXDATA_OUT                  =>      GT3_RXDATA_OUT,
        ------------------- Receive Ports - Pattern Checker Ports ------------------
        GT3_RXPRBSERR_OUT               =>      GT3_RXPRBSERR_OUT,
        GT3_RXPRBSSEL_IN                =>      GT3_RXPRBSSEL_IN,
        ------------------- Receive Ports - Pattern Checker ports ------------------
        GT3_RXPRBSCNTRESET_IN           =>      GT3_RXPRBSCNTRESET_IN,
        ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
        GT3_RXDISPERR_OUT               =>      GT3_RXDISPERR_OUT,
        GT3_RXNOTINTABLE_OUT            =>      GT3_RXNOTINTABLE_OUT,
        --------------------------- Receive Ports - RX AFE -------------------------
        GT3_GTXRXP_IN                   =>      GT3_GTXRXP_IN,
        ------------------------ Receive Ports - RX AFE Ports ----------------------
        GT3_GTXRXN_IN                   =>      GT3_GTXRXN_IN,
        -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
        GT3_RXMCOMMAALIGNEN_IN          =>      GT3_RXMCOMMAALIGNEN_IN,
        GT3_RXPCOMMAALIGNEN_IN          =>      GT3_RXPCOMMAALIGNEN_IN,
        --------------------- Receive Ports - RX Equalizer Ports -------------------
        GT3_RXDFELPMRESET_IN            =>      gt3_rxdfelpmreset_i,
        --------------------- Receive Ports - RX Equilizer Ports -------------------
        GT3_RXLPMHFHOLD_IN              =>      gt3_rxlpmhfhold_i,
        GT3_RXLPMLFHOLD_IN              =>      gt3_rxlpmlfhold_i,
        --------------- Receive Ports - RX Fabric Output Control Ports -------------
        GT3_RXOUTCLK_OUT                =>      gt3_rxoutclk_i,
        ------------- Receive Ports - RX Initialization and Reset Ports ------------
        GT3_GTRXRESET_IN                =>      gt3_gtrxreset_i,
        GT3_RXPMARESET_IN               =>      GT3_RXPMARESET_IN,
        ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
        GT3_RXCHARISCOMMA_OUT           =>      GT3_RXCHARISCOMMA_OUT,
        GT3_RXCHARISK_OUT               =>      GT3_RXCHARISK_OUT,
        -------------- Receive Ports -RX Initialization and Reset Ports ------------
        GT3_RXRESETDONE_OUT             =>      gt3_rxresetdone_i,
        --------------------- TX Initialization and Reset Ports --------------------
        GT3_GTTXRESET_IN                =>      gt3_gttxreset_i,
        GT3_TXUSERRDY_IN                =>      gt3_txuserrdy_i,
        ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
        GT3_TXUSRCLK_IN                 =>      GT3_TXUSRCLK_IN,
        GT3_TXUSRCLK2_IN                =>      GT3_TXUSRCLK2_IN,
        --------------- Transmit Ports - TX Configurable Driver Ports --------------
        GT3_TXDIFFCTRL_IN               =>      GT3_TXDIFFCTRL_IN,
        ------------------ Transmit Ports - TX Data Path interface -----------------
        GT3_TXDATA_IN                   =>      GT3_TXDATA_IN,
        ---------------- Transmit Ports - TX Driver and OOB signaling --------------
        GT3_GTXTXN_OUT                  =>      GT3_GTXTXN_OUT,
        GT3_GTXTXP_OUT                  =>      GT3_GTXTXP_OUT,
        ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
        GT3_TXOUTCLK_OUT                =>      GT3_TXOUTCLK_OUT,
        GT3_TXOUTCLKFABRIC_OUT          =>      GT3_TXOUTCLKFABRIC_OUT,
        GT3_TXOUTCLKPCS_OUT             =>      GT3_TXOUTCLKPCS_OUT,
        --------------------- Transmit Ports - TX Gearbox Ports --------------------
        GT3_TXCHARISK_IN                =>      GT3_TXCHARISK_IN,
        ------------- Transmit Ports - TX Initialization and Reset Ports -----------
        GT3_TXRESETDONE_OUT             =>      gt3_txresetdone_i,
        ------------------ Transmit Ports - pattern Generator Ports ----------------
        GT3_TXPRBSSEL_IN                =>      GT3_TXPRBSSEL_IN,


  
        --_____________________________________________________________________
        --_____________________________________________________________________
        --GT4  (X1Y4)

        ---------------------------- Channel - DRP Ports  --------------------------
        GT4_DRPADDR_IN                  =>      gt4_drpaddr_i,
        GT4_DRPCLK_IN                   =>      GT4_DRPCLK_IN,
        GT4_DRPDI_IN                    =>      gt4_drpdi_i,
        GT4_DRPDO_OUT                   =>      gt4_drpdo_o,
        GT4_DRPEN_IN                    =>      gt4_drpen_i,
        GT4_DRPRDY_OUT                  =>      gt4_drprdy_o,
        GT4_DRPWE_IN                    =>      gt4_drpwe_i,
        ------------------------------- Loopback Ports -----------------------------
        GT4_LOOPBACK_IN                 =>      GT4_LOOPBACK_IN,
        --------------------- RX Initialization and Reset Ports --------------------
        GT4_RXUSERRDY_IN                =>      gt4_rxuserrdy_i,
        -------------------------- RX Margin Analysis Ports ------------------------
        GT4_EYESCANDATAERROR_OUT        =>      GT4_EYESCANDATAERROR_OUT,
        ------------------------- Receive Ports - CDR Ports ------------------------
        GT4_RXCDRLOCK_OUT               =>      GT4_RXCDRLOCK_OUT,
        ------------------- Receive Ports - Clock Correction Ports -----------------
        GT4_RXCLKCORCNT_OUT             =>      GT4_RXCLKCORCNT_OUT,
        ------------------ Receive Ports - FPGA RX Interface Ports -----------------
        GT4_RXUSRCLK_IN                 =>      GT4_RXUSRCLK_IN,
        GT4_RXUSRCLK2_IN                =>      GT4_RXUSRCLK2_IN,
        ------------------ Receive Ports - FPGA RX interface Ports -----------------
        GT4_RXDATA_OUT                  =>      GT4_RXDATA_OUT,
        ------------------- Receive Ports - Pattern Checker Ports ------------------
        GT4_RXPRBSERR_OUT               =>      GT4_RXPRBSERR_OUT,
        GT4_RXPRBSSEL_IN                =>      GT4_RXPRBSSEL_IN,
        ------------------- Receive Ports - Pattern Checker ports ------------------
        GT4_RXPRBSCNTRESET_IN           =>      GT4_RXPRBSCNTRESET_IN,
        ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
        GT4_RXDISPERR_OUT               =>      GT4_RXDISPERR_OUT,
        GT4_RXNOTINTABLE_OUT            =>      GT4_RXNOTINTABLE_OUT,
        --------------------------- Receive Ports - RX AFE -------------------------
        GT4_GTXRXP_IN                   =>      GT4_GTXRXP_IN,
        ------------------------ Receive Ports - RX AFE Ports ----------------------
        GT4_GTXRXN_IN                   =>      GT4_GTXRXN_IN,
        -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
        GT4_RXMCOMMAALIGNEN_IN          =>      GT4_RXMCOMMAALIGNEN_IN,
        GT4_RXPCOMMAALIGNEN_IN          =>      GT4_RXPCOMMAALIGNEN_IN,
        --------------------- Receive Ports - RX Equalizer Ports -------------------
        GT4_RXDFELPMRESET_IN            =>      gt4_rxdfelpmreset_i,
        --------------------- Receive Ports - RX Equilizer Ports -------------------
        GT4_RXLPMHFHOLD_IN              =>      gt4_rxlpmhfhold_i,
        GT4_RXLPMLFHOLD_IN              =>      gt4_rxlpmlfhold_i,
        --------------- Receive Ports - RX Fabric Output Control Ports -------------
        GT4_RXOUTCLK_OUT                =>      gt4_rxoutclk_i,
        ------------- Receive Ports - RX Initialization and Reset Ports ------------
        GT4_GTRXRESET_IN                =>      gt4_gtrxreset_i,
        GT4_RXPMARESET_IN               =>      GT4_RXPMARESET_IN,
        ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
        GT4_RXCHARISCOMMA_OUT           =>      GT4_RXCHARISCOMMA_OUT,
        GT4_RXCHARISK_OUT               =>      GT4_RXCHARISK_OUT,
        -------------- Receive Ports -RX Initialization and Reset Ports ------------
        GT4_RXRESETDONE_OUT             =>      gt4_rxresetdone_i,
        --------------------- TX Initialization and Reset Ports --------------------
        GT4_GTTXRESET_IN                =>      gt4_gttxreset_i,
        GT4_TXUSERRDY_IN                =>      gt4_txuserrdy_i,
        ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
        GT4_TXUSRCLK_IN                 =>      GT4_TXUSRCLK_IN,
        GT4_TXUSRCLK2_IN                =>      GT4_TXUSRCLK2_IN,
        --------------- Transmit Ports - TX Configurable Driver Ports --------------
        GT4_TXDIFFCTRL_IN               =>      GT4_TXDIFFCTRL_IN,
        ------------------ Transmit Ports - TX Data Path interface -----------------
        GT4_TXDATA_IN                   =>      GT4_TXDATA_IN,
        ---------------- Transmit Ports - TX Driver and OOB signaling --------------
        GT4_GTXTXN_OUT                  =>      GT4_GTXTXN_OUT,
        GT4_GTXTXP_OUT                  =>      GT4_GTXTXP_OUT,
        ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
        GT4_TXOUTCLK_OUT                =>      GT4_TXOUTCLK_OUT,
        GT4_TXOUTCLKFABRIC_OUT          =>      GT4_TXOUTCLKFABRIC_OUT,
        GT4_TXOUTCLKPCS_OUT             =>      GT4_TXOUTCLKPCS_OUT,
        --------------------- Transmit Ports - TX Gearbox Ports --------------------
        GT4_TXCHARISK_IN                =>      GT4_TXCHARISK_IN,
        ------------- Transmit Ports - TX Initialization and Reset Ports -----------
        GT4_TXRESETDONE_OUT             =>      gt4_txresetdone_i,
        ------------------ Transmit Ports - pattern Generator Ports ----------------
        GT4_TXPRBSSEL_IN                =>      GT4_TXPRBSSEL_IN,


  
        --_____________________________________________________________________
        --_____________________________________________________________________
        --GT5  (X1Y5)

        ---------------------------- Channel - DRP Ports  --------------------------
        GT5_DRPADDR_IN                  =>      gt5_drpaddr_i,
        GT5_DRPCLK_IN                   =>      GT5_DRPCLK_IN,
        GT5_DRPDI_IN                    =>      gt5_drpdi_i,
        GT5_DRPDO_OUT                   =>      gt5_drpdo_o,
        GT5_DRPEN_IN                    =>      gt5_drpen_i,
        GT5_DRPRDY_OUT                  =>      gt5_drprdy_o,
        GT5_DRPWE_IN                    =>      gt5_drpwe_i,
        ------------------------------- Loopback Ports -----------------------------
        GT5_LOOPBACK_IN                 =>      GT5_LOOPBACK_IN,
        --------------------- RX Initialization and Reset Ports --------------------
        GT5_RXUSERRDY_IN                =>      gt5_rxuserrdy_i,
        -------------------------- RX Margin Analysis Ports ------------------------
        GT5_EYESCANDATAERROR_OUT        =>      GT5_EYESCANDATAERROR_OUT,
        ------------------------- Receive Ports - CDR Ports ------------------------
        GT5_RXCDRLOCK_OUT               =>      GT5_RXCDRLOCK_OUT,
        ------------------- Receive Ports - Clock Correction Ports -----------------
        GT5_RXCLKCORCNT_OUT             =>      GT5_RXCLKCORCNT_OUT,
        ------------------ Receive Ports - FPGA RX Interface Ports -----------------
        GT5_RXUSRCLK_IN                 =>      GT5_RXUSRCLK_IN,
        GT5_RXUSRCLK2_IN                =>      GT5_RXUSRCLK2_IN,
        ------------------ Receive Ports - FPGA RX interface Ports -----------------
        GT5_RXDATA_OUT                  =>      GT5_RXDATA_OUT,
        ------------------- Receive Ports - Pattern Checker Ports ------------------
        GT5_RXPRBSERR_OUT               =>      GT5_RXPRBSERR_OUT,
        GT5_RXPRBSSEL_IN                =>      GT5_RXPRBSSEL_IN,
        ------------------- Receive Ports - Pattern Checker ports ------------------
        GT5_RXPRBSCNTRESET_IN           =>      GT5_RXPRBSCNTRESET_IN,
        ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
        GT5_RXDISPERR_OUT               =>      GT5_RXDISPERR_OUT,
        GT5_RXNOTINTABLE_OUT            =>      GT5_RXNOTINTABLE_OUT,
        --------------------------- Receive Ports - RX AFE -------------------------
        GT5_GTXRXP_IN                   =>      GT5_GTXRXP_IN,
        ------------------------ Receive Ports - RX AFE Ports ----------------------
        GT5_GTXRXN_IN                   =>      GT5_GTXRXN_IN,
        -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
        GT5_RXMCOMMAALIGNEN_IN          =>      GT5_RXMCOMMAALIGNEN_IN,
        GT5_RXPCOMMAALIGNEN_IN          =>      GT5_RXPCOMMAALIGNEN_IN,
        --------------------- Receive Ports - RX Equalizer Ports -------------------
        GT5_RXDFELPMRESET_IN            =>      gt5_rxdfelpmreset_i,
        --------------------- Receive Ports - RX Equilizer Ports -------------------
        GT5_RXLPMHFHOLD_IN              =>      gt5_rxlpmhfhold_i,
        GT5_RXLPMLFHOLD_IN              =>      gt5_rxlpmlfhold_i,
        --------------- Receive Ports - RX Fabric Output Control Ports -------------
        GT5_RXOUTCLK_OUT                =>      gt5_rxoutclk_i,
        ------------- Receive Ports - RX Initialization and Reset Ports ------------
        GT5_GTRXRESET_IN                =>      gt5_gtrxreset_i,
        GT5_RXPMARESET_IN               =>      GT5_RXPMARESET_IN,
        ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
        GT5_RXCHARISCOMMA_OUT           =>      GT5_RXCHARISCOMMA_OUT,
        GT5_RXCHARISK_OUT               =>      GT5_RXCHARISK_OUT,
        -------------- Receive Ports -RX Initialization and Reset Ports ------------
        GT5_RXRESETDONE_OUT             =>      gt5_rxresetdone_i,
        --------------------- TX Initialization and Reset Ports --------------------
        GT5_GTTXRESET_IN                =>      gt5_gttxreset_i,
        GT5_TXUSERRDY_IN                =>      gt5_txuserrdy_i,
        ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
        GT5_TXUSRCLK_IN                 =>      GT5_TXUSRCLK_IN,
        GT5_TXUSRCLK2_IN                =>      GT5_TXUSRCLK2_IN,
        --------------- Transmit Ports - TX Configurable Driver Ports --------------
        GT5_TXDIFFCTRL_IN               =>      GT5_TXDIFFCTRL_IN,
        ------------------ Transmit Ports - TX Data Path interface -----------------
        GT5_TXDATA_IN                   =>      GT5_TXDATA_IN,
        ---------------- Transmit Ports - TX Driver and OOB signaling --------------
        GT5_GTXTXN_OUT                  =>      GT5_GTXTXN_OUT,
        GT5_GTXTXP_OUT                  =>      GT5_GTXTXP_OUT,
        ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
        GT5_TXOUTCLK_OUT                =>      GT5_TXOUTCLK_OUT,
        GT5_TXOUTCLKFABRIC_OUT          =>      GT5_TXOUTCLKFABRIC_OUT,
        GT5_TXOUTCLKPCS_OUT             =>      GT5_TXOUTCLKPCS_OUT,
        --------------------- Transmit Ports - TX Gearbox Ports --------------------
        GT5_TXCHARISK_IN                =>      GT5_TXCHARISK_IN,
        ------------- Transmit Ports - TX Initialization and Reset Ports -----------
        GT5_TXRESETDONE_OUT             =>      gt5_txresetdone_i,
        ------------------ Transmit Ports - pattern Generator Ports ----------------
        GT5_TXPRBSSEL_IN                =>      GT5_TXPRBSSEL_IN,


  
        --_____________________________________________________________________
        --_____________________________________________________________________
        --GT6  (X1Y6)

        ---------------------------- Channel - DRP Ports  --------------------------
        GT6_DRPADDR_IN                  =>      gt6_drpaddr_i,
        GT6_DRPCLK_IN                   =>      GT6_DRPCLK_IN,
        GT6_DRPDI_IN                    =>      gt6_drpdi_i,
        GT6_DRPDO_OUT                   =>      gt6_drpdo_o,
        GT6_DRPEN_IN                    =>      gt6_drpen_i,
        GT6_DRPRDY_OUT                  =>      gt6_drprdy_o,
        GT6_DRPWE_IN                    =>      gt6_drpwe_i,
        ------------------------------- Loopback Ports -----------------------------
        GT6_LOOPBACK_IN                 =>      GT6_LOOPBACK_IN,
        --------------------- RX Initialization and Reset Ports --------------------
        GT6_RXUSERRDY_IN                =>      gt6_rxuserrdy_i,
        -------------------------- RX Margin Analysis Ports ------------------------
        GT6_EYESCANDATAERROR_OUT        =>      GT6_EYESCANDATAERROR_OUT,
        ------------------------- Receive Ports - CDR Ports ------------------------
        GT6_RXCDRLOCK_OUT               =>      GT6_RXCDRLOCK_OUT,
        ------------------- Receive Ports - Clock Correction Ports -----------------
        GT6_RXCLKCORCNT_OUT             =>      GT6_RXCLKCORCNT_OUT,
        ------------------ Receive Ports - FPGA RX Interface Ports -----------------
        GT6_RXUSRCLK_IN                 =>      GT6_RXUSRCLK_IN,
        GT6_RXUSRCLK2_IN                =>      GT6_RXUSRCLK2_IN,
        ------------------ Receive Ports - FPGA RX interface Ports -----------------
        GT6_RXDATA_OUT                  =>      GT6_RXDATA_OUT,
        ------------------- Receive Ports - Pattern Checker Ports ------------------
        GT6_RXPRBSERR_OUT               =>      GT6_RXPRBSERR_OUT,
        GT6_RXPRBSSEL_IN                =>      GT6_RXPRBSSEL_IN,
        ------------------- Receive Ports - Pattern Checker ports ------------------
        GT6_RXPRBSCNTRESET_IN           =>      GT6_RXPRBSCNTRESET_IN,
        ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
        GT6_RXDISPERR_OUT               =>      GT6_RXDISPERR_OUT,
        GT6_RXNOTINTABLE_OUT            =>      GT6_RXNOTINTABLE_OUT,
        --------------------------- Receive Ports - RX AFE -------------------------
        GT6_GTXRXP_IN                   =>      GT6_GTXRXP_IN,
        ------------------------ Receive Ports - RX AFE Ports ----------------------
        GT6_GTXRXN_IN                   =>      GT6_GTXRXN_IN,
        -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
        GT6_RXMCOMMAALIGNEN_IN          =>      GT6_RXMCOMMAALIGNEN_IN,
        GT6_RXPCOMMAALIGNEN_IN          =>      GT6_RXPCOMMAALIGNEN_IN,
        --------------------- Receive Ports - RX Equalizer Ports -------------------
        GT6_RXDFELPMRESET_IN            =>      gt6_rxdfelpmreset_i,
        --------------------- Receive Ports - RX Equilizer Ports -------------------
        GT6_RXLPMHFHOLD_IN              =>      gt6_rxlpmhfhold_i,
        GT6_RXLPMLFHOLD_IN              =>      gt6_rxlpmlfhold_i,
        --------------- Receive Ports - RX Fabric Output Control Ports -------------
        GT6_RXOUTCLK_OUT                =>      gt6_rxoutclk_i,
        ------------- Receive Ports - RX Initialization and Reset Ports ------------
        GT6_GTRXRESET_IN                =>      gt6_gtrxreset_i,
        GT6_RXPMARESET_IN               =>      GT6_RXPMARESET_IN,
        ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
        GT6_RXCHARISCOMMA_OUT           =>      GT6_RXCHARISCOMMA_OUT,
        GT6_RXCHARISK_OUT               =>      GT6_RXCHARISK_OUT,
        -------------- Receive Ports -RX Initialization and Reset Ports ------------
        GT6_RXRESETDONE_OUT             =>      gt6_rxresetdone_i,
        --------------------- TX Initialization and Reset Ports --------------------
        GT6_GTTXRESET_IN                =>      gt6_gttxreset_i,
        GT6_TXUSERRDY_IN                =>      gt6_txuserrdy_i,
        ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
        GT6_TXUSRCLK_IN                 =>      GT6_TXUSRCLK_IN,
        GT6_TXUSRCLK2_IN                =>      GT6_TXUSRCLK2_IN,
        --------------- Transmit Ports - TX Configurable Driver Ports --------------
        GT6_TXDIFFCTRL_IN               =>      GT6_TXDIFFCTRL_IN,
        ------------------ Transmit Ports - TX Data Path interface -----------------
        GT6_TXDATA_IN                   =>      GT6_TXDATA_IN,
        ---------------- Transmit Ports - TX Driver and OOB signaling --------------
        GT6_GTXTXN_OUT                  =>      GT6_GTXTXN_OUT,
        GT6_GTXTXP_OUT                  =>      GT6_GTXTXP_OUT,
        ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
        GT6_TXOUTCLK_OUT                =>      GT6_TXOUTCLK_OUT,
        GT6_TXOUTCLKFABRIC_OUT          =>      GT6_TXOUTCLKFABRIC_OUT,
        GT6_TXOUTCLKPCS_OUT             =>      GT6_TXOUTCLKPCS_OUT,
        --------------------- Transmit Ports - TX Gearbox Ports --------------------
        GT6_TXCHARISK_IN                =>      GT6_TXCHARISK_IN,
        ------------- Transmit Ports - TX Initialization and Reset Ports -----------
        GT6_TXRESETDONE_OUT             =>      gt6_txresetdone_i,
        ------------------ Transmit Ports - pattern Generator Ports ----------------
        GT6_TXPRBSSEL_IN                =>      GT6_TXPRBSSEL_IN,


  
        --_____________________________________________________________________
        --_____________________________________________________________________
        --GT7  (X1Y7)

        ---------------------------- Channel - DRP Ports  --------------------------
        GT7_DRPADDR_IN                  =>      gt7_drpaddr_i,
        GT7_DRPCLK_IN                   =>      GT7_DRPCLK_IN,
        GT7_DRPDI_IN                    =>      gt7_drpdi_i,
        GT7_DRPDO_OUT                   =>      gt7_drpdo_o,
        GT7_DRPEN_IN                    =>      gt7_drpen_i,
        GT7_DRPRDY_OUT                  =>      gt7_drprdy_o,
        GT7_DRPWE_IN                    =>      gt7_drpwe_i,
        ------------------------------- Loopback Ports -----------------------------
        GT7_LOOPBACK_IN                 =>      GT7_LOOPBACK_IN,
        --------------------- RX Initialization and Reset Ports --------------------
        GT7_RXUSERRDY_IN                =>      gt7_rxuserrdy_i,
        -------------------------- RX Margin Analysis Ports ------------------------
        GT7_EYESCANDATAERROR_OUT        =>      GT7_EYESCANDATAERROR_OUT,
        ------------------------- Receive Ports - CDR Ports ------------------------
        GT7_RXCDRLOCK_OUT               =>      GT7_RXCDRLOCK_OUT,
        ------------------- Receive Ports - Clock Correction Ports -----------------
        GT7_RXCLKCORCNT_OUT             =>      GT7_RXCLKCORCNT_OUT,
        ------------------ Receive Ports - FPGA RX Interface Ports -----------------
        GT7_RXUSRCLK_IN                 =>      GT7_RXUSRCLK_IN,
        GT7_RXUSRCLK2_IN                =>      GT7_RXUSRCLK2_IN,
        ------------------ Receive Ports - FPGA RX interface Ports -----------------
        GT7_RXDATA_OUT                  =>      GT7_RXDATA_OUT,
        ------------------- Receive Ports - Pattern Checker Ports ------------------
        GT7_RXPRBSERR_OUT               =>      GT7_RXPRBSERR_OUT,
        GT7_RXPRBSSEL_IN                =>      GT7_RXPRBSSEL_IN,
        ------------------- Receive Ports - Pattern Checker ports ------------------
        GT7_RXPRBSCNTRESET_IN           =>      GT7_RXPRBSCNTRESET_IN,
        ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
        GT7_RXDISPERR_OUT               =>      GT7_RXDISPERR_OUT,
        GT7_RXNOTINTABLE_OUT            =>      GT7_RXNOTINTABLE_OUT,
        --------------------------- Receive Ports - RX AFE -------------------------
        GT7_GTXRXP_IN                   =>      GT7_GTXRXP_IN,
        ------------------------ Receive Ports - RX AFE Ports ----------------------
        GT7_GTXRXN_IN                   =>      GT7_GTXRXN_IN,
        -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
        GT7_RXMCOMMAALIGNEN_IN          =>      GT7_RXMCOMMAALIGNEN_IN,
        GT7_RXPCOMMAALIGNEN_IN          =>      GT7_RXPCOMMAALIGNEN_IN,
        --------------------- Receive Ports - RX Equalizer Ports -------------------
        GT7_RXDFELPMRESET_IN            =>      gt7_rxdfelpmreset_i,
        --------------------- Receive Ports - RX Equilizer Ports -------------------
        GT7_RXLPMHFHOLD_IN              =>      gt7_rxlpmhfhold_i,
        GT7_RXLPMLFHOLD_IN              =>      gt7_rxlpmlfhold_i,
        --------------- Receive Ports - RX Fabric Output Control Ports -------------
        GT7_RXOUTCLK_OUT                =>      gt7_rxoutclk_i,
        ------------- Receive Ports - RX Initialization and Reset Ports ------------
        GT7_GTRXRESET_IN                =>      gt7_gtrxreset_i,
        GT7_RXPMARESET_IN               =>      GT7_RXPMARESET_IN,
        ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
        GT7_RXCHARISCOMMA_OUT           =>      GT7_RXCHARISCOMMA_OUT,
        GT7_RXCHARISK_OUT               =>      GT7_RXCHARISK_OUT,
        -------------- Receive Ports -RX Initialization and Reset Ports ------------
        GT7_RXRESETDONE_OUT             =>      gt7_rxresetdone_i,
        --------------------- TX Initialization and Reset Ports --------------------
        GT7_GTTXRESET_IN                =>      gt7_gttxreset_i,
        GT7_TXUSERRDY_IN                =>      gt7_txuserrdy_i,
        ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
        GT7_TXUSRCLK_IN                 =>      GT7_TXUSRCLK_IN,
        GT7_TXUSRCLK2_IN                =>      GT7_TXUSRCLK2_IN,
        --------------- Transmit Ports - TX Configurable Driver Ports --------------
        GT7_TXDIFFCTRL_IN               =>      GT7_TXDIFFCTRL_IN,
        ------------------ Transmit Ports - TX Data Path interface -----------------
        GT7_TXDATA_IN                   =>      GT7_TXDATA_IN,
        ---------------- Transmit Ports - TX Driver and OOB signaling --------------
        GT7_GTXTXN_OUT                  =>      GT7_GTXTXN_OUT,
        GT7_GTXTXP_OUT                  =>      GT7_GTXTXP_OUT,
        ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
        GT7_TXOUTCLK_OUT                =>      GT7_TXOUTCLK_OUT,
        GT7_TXOUTCLKFABRIC_OUT          =>      GT7_TXOUTCLKFABRIC_OUT,
        GT7_TXOUTCLKPCS_OUT             =>      GT7_TXOUTCLKPCS_OUT,
        --------------------- Transmit Ports - TX Gearbox Ports --------------------
        GT7_TXCHARISK_IN                =>      GT7_TXCHARISK_IN,
        ------------- Transmit Ports - TX Initialization and Reset Ports -----------
        GT7_TXRESETDONE_OUT             =>      gt7_txresetdone_i,
        ------------------ Transmit Ports - pattern Generator Ports ----------------
        GT7_TXPRBSSEL_IN                =>      GT7_TXPRBSSEL_IN,


  
        --_____________________________________________________________________
        --_____________________________________________________________________
        --GT8  (X1Y8)

        ---------------------------- Channel - DRP Ports  --------------------------
        GT8_DRPADDR_IN                  =>      gt8_drpaddr_i,
        GT8_DRPCLK_IN                   =>      GT8_DRPCLK_IN,
        GT8_DRPDI_IN                    =>      gt8_drpdi_i,
        GT8_DRPDO_OUT                   =>      gt8_drpdo_o,
        GT8_DRPEN_IN                    =>      gt8_drpen_i,
        GT8_DRPRDY_OUT                  =>      gt8_drprdy_o,
        GT8_DRPWE_IN                    =>      gt8_drpwe_i,
        ------------------------------- Loopback Ports -----------------------------
        GT8_LOOPBACK_IN                 =>      GT8_LOOPBACK_IN,
        --------------------- RX Initialization and Reset Ports --------------------
        GT8_RXUSERRDY_IN                =>      gt8_rxuserrdy_i,
        -------------------------- RX Margin Analysis Ports ------------------------
        GT8_EYESCANDATAERROR_OUT        =>      GT8_EYESCANDATAERROR_OUT,
        ------------------------- Receive Ports - CDR Ports ------------------------
        GT8_RXCDRLOCK_OUT               =>      GT8_RXCDRLOCK_OUT,
        ------------------- Receive Ports - Clock Correction Ports -----------------
        GT8_RXCLKCORCNT_OUT             =>      GT8_RXCLKCORCNT_OUT,
        ------------------ Receive Ports - FPGA RX Interface Ports -----------------
        GT8_RXUSRCLK_IN                 =>      GT8_RXUSRCLK_IN,
        GT8_RXUSRCLK2_IN                =>      GT8_RXUSRCLK2_IN,
        ------------------ Receive Ports - FPGA RX interface Ports -----------------
        GT8_RXDATA_OUT                  =>      GT8_RXDATA_OUT,
        ------------------- Receive Ports - Pattern Checker Ports ------------------
        GT8_RXPRBSERR_OUT               =>      GT8_RXPRBSERR_OUT,
        GT8_RXPRBSSEL_IN                =>      GT8_RXPRBSSEL_IN,
        ------------------- Receive Ports - Pattern Checker ports ------------------
        GT8_RXPRBSCNTRESET_IN           =>      GT8_RXPRBSCNTRESET_IN,
        ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
        GT8_RXDISPERR_OUT               =>      GT8_RXDISPERR_OUT,
        GT8_RXNOTINTABLE_OUT            =>      GT8_RXNOTINTABLE_OUT,
        --------------------------- Receive Ports - RX AFE -------------------------
        GT8_GTXRXP_IN                   =>      GT8_GTXRXP_IN,
        ------------------------ Receive Ports - RX AFE Ports ----------------------
        GT8_GTXRXN_IN                   =>      GT8_GTXRXN_IN,
        -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
        GT8_RXMCOMMAALIGNEN_IN          =>      GT8_RXMCOMMAALIGNEN_IN,
        GT8_RXPCOMMAALIGNEN_IN          =>      GT8_RXPCOMMAALIGNEN_IN,
        --------------------- Receive Ports - RX Equalizer Ports -------------------
        GT8_RXDFELPMRESET_IN            =>      gt8_rxdfelpmreset_i,
        --------------------- Receive Ports - RX Equilizer Ports -------------------
        GT8_RXLPMHFHOLD_IN              =>      gt8_rxlpmhfhold_i,
        GT8_RXLPMLFHOLD_IN              =>      gt8_rxlpmlfhold_i,
        --------------- Receive Ports - RX Fabric Output Control Ports -------------
        GT8_RXOUTCLK_OUT                =>      gt8_rxoutclk_i,
        ------------- Receive Ports - RX Initialization and Reset Ports ------------
        GT8_GTRXRESET_IN                =>      gt8_gtrxreset_i,
        GT8_RXPMARESET_IN               =>      GT8_RXPMARESET_IN,
        ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
        GT8_RXCHARISCOMMA_OUT           =>      GT8_RXCHARISCOMMA_OUT,
        GT8_RXCHARISK_OUT               =>      GT8_RXCHARISK_OUT,
        -------------- Receive Ports -RX Initialization and Reset Ports ------------
        GT8_RXRESETDONE_OUT             =>      gt8_rxresetdone_i,
        --------------------- TX Initialization and Reset Ports --------------------
        GT8_GTTXRESET_IN                =>      gt8_gttxreset_i,
        GT8_TXUSERRDY_IN                =>      gt8_txuserrdy_i,
        ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
        GT8_TXUSRCLK_IN                 =>      GT8_TXUSRCLK_IN,
        GT8_TXUSRCLK2_IN                =>      GT8_TXUSRCLK2_IN,
        --------------- Transmit Ports - TX Configurable Driver Ports --------------
        GT8_TXDIFFCTRL_IN               =>      GT8_TXDIFFCTRL_IN,
        ------------------ Transmit Ports - TX Data Path interface -----------------
        GT8_TXDATA_IN                   =>      GT8_TXDATA_IN,
        ---------------- Transmit Ports - TX Driver and OOB signaling --------------
        GT8_GTXTXN_OUT                  =>      GT8_GTXTXN_OUT,
        GT8_GTXTXP_OUT                  =>      GT8_GTXTXP_OUT,
        ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
        GT8_TXOUTCLK_OUT                =>      GT8_TXOUTCLK_OUT,
        GT8_TXOUTCLKFABRIC_OUT          =>      GT8_TXOUTCLKFABRIC_OUT,
        GT8_TXOUTCLKPCS_OUT             =>      GT8_TXOUTCLKPCS_OUT,
        --------------------- Transmit Ports - TX Gearbox Ports --------------------
        GT8_TXCHARISK_IN                =>      GT8_TXCHARISK_IN,
        ------------- Transmit Ports - TX Initialization and Reset Ports -----------
        GT8_TXRESETDONE_OUT             =>      gt8_txresetdone_i,
        ------------------ Transmit Ports - pattern Generator Ports ----------------
        GT8_TXPRBSSEL_IN                =>      GT8_TXPRBSSEL_IN,


  
        --_____________________________________________________________________
        --_____________________________________________________________________
        --GT9  (X1Y9)

        ---------------------------- Channel - DRP Ports  --------------------------
        GT9_DRPADDR_IN                  =>      gt9_drpaddr_i,
        GT9_DRPCLK_IN                   =>      GT9_DRPCLK_IN,
        GT9_DRPDI_IN                    =>      gt9_drpdi_i,
        GT9_DRPDO_OUT                   =>      gt9_drpdo_o,
        GT9_DRPEN_IN                    =>      gt9_drpen_i,
        GT9_DRPRDY_OUT                  =>      gt9_drprdy_o,
        GT9_DRPWE_IN                    =>      gt9_drpwe_i,
        ------------------------------- Loopback Ports -----------------------------
        GT9_LOOPBACK_IN                 =>      GT9_LOOPBACK_IN,
        --------------------- RX Initialization and Reset Ports --------------------
        GT9_RXUSERRDY_IN                =>      gt9_rxuserrdy_i,
        -------------------------- RX Margin Analysis Ports ------------------------
        GT9_EYESCANDATAERROR_OUT        =>      GT9_EYESCANDATAERROR_OUT,
        ------------------------- Receive Ports - CDR Ports ------------------------
        GT9_RXCDRLOCK_OUT               =>      GT9_RXCDRLOCK_OUT,
        ------------------- Receive Ports - Clock Correction Ports -----------------
        GT9_RXCLKCORCNT_OUT             =>      GT9_RXCLKCORCNT_OUT,
        ------------------ Receive Ports - FPGA RX Interface Ports -----------------
        GT9_RXUSRCLK_IN                 =>      GT9_RXUSRCLK_IN,
        GT9_RXUSRCLK2_IN                =>      GT9_RXUSRCLK2_IN,
        ------------------ Receive Ports - FPGA RX interface Ports -----------------
        GT9_RXDATA_OUT                  =>      GT9_RXDATA_OUT,
        ------------------- Receive Ports - Pattern Checker Ports ------------------
        GT9_RXPRBSERR_OUT               =>      GT9_RXPRBSERR_OUT,
        GT9_RXPRBSSEL_IN                =>      GT9_RXPRBSSEL_IN,
        ------------------- Receive Ports - Pattern Checker ports ------------------
        GT9_RXPRBSCNTRESET_IN           =>      GT9_RXPRBSCNTRESET_IN,
        ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
        GT9_RXDISPERR_OUT               =>      GT9_RXDISPERR_OUT,
        GT9_RXNOTINTABLE_OUT            =>      GT9_RXNOTINTABLE_OUT,
        --------------------------- Receive Ports - RX AFE -------------------------
        GT9_GTXRXP_IN                   =>      GT9_GTXRXP_IN,
        ------------------------ Receive Ports - RX AFE Ports ----------------------
        GT9_GTXRXN_IN                   =>      GT9_GTXRXN_IN,
        -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
        GT9_RXMCOMMAALIGNEN_IN          =>      GT9_RXMCOMMAALIGNEN_IN,
        GT9_RXPCOMMAALIGNEN_IN          =>      GT9_RXPCOMMAALIGNEN_IN,
        --------------------- Receive Ports - RX Equalizer Ports -------------------
        GT9_RXDFELPMRESET_IN            =>      gt9_rxdfelpmreset_i,
        --------------------- Receive Ports - RX Equilizer Ports -------------------
        GT9_RXLPMHFHOLD_IN              =>      gt9_rxlpmhfhold_i,
        GT9_RXLPMLFHOLD_IN              =>      gt9_rxlpmlfhold_i,
        --------------- Receive Ports - RX Fabric Output Control Ports -------------
        GT9_RXOUTCLK_OUT                =>      gt9_rxoutclk_i,
        ------------- Receive Ports - RX Initialization and Reset Ports ------------
        GT9_GTRXRESET_IN                =>      gt9_gtrxreset_i,
        GT9_RXPMARESET_IN               =>      GT9_RXPMARESET_IN,
        ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
        GT9_RXCHARISCOMMA_OUT           =>      GT9_RXCHARISCOMMA_OUT,
        GT9_RXCHARISK_OUT               =>      GT9_RXCHARISK_OUT,
        -------------- Receive Ports -RX Initialization and Reset Ports ------------
        GT9_RXRESETDONE_OUT             =>      gt9_rxresetdone_i,
        --------------------- TX Initialization and Reset Ports --------------------
        GT9_GTTXRESET_IN                =>      gt9_gttxreset_i,
        GT9_TXUSERRDY_IN                =>      gt9_txuserrdy_i,
        ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
        GT9_TXUSRCLK_IN                 =>      GT9_TXUSRCLK_IN,
        GT9_TXUSRCLK2_IN                =>      GT9_TXUSRCLK2_IN,
        --------------- Transmit Ports - TX Configurable Driver Ports --------------
        GT9_TXDIFFCTRL_IN               =>      GT9_TXDIFFCTRL_IN,
        ------------------ Transmit Ports - TX Data Path interface -----------------
        GT9_TXDATA_IN                   =>      GT9_TXDATA_IN,
        ---------------- Transmit Ports - TX Driver and OOB signaling --------------
        GT9_GTXTXN_OUT                  =>      GT9_GTXTXN_OUT,
        GT9_GTXTXP_OUT                  =>      GT9_GTXTXP_OUT,
        ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
        GT9_TXOUTCLK_OUT                =>      GT9_TXOUTCLK_OUT,
        GT9_TXOUTCLKFABRIC_OUT          =>      GT9_TXOUTCLKFABRIC_OUT,
        GT9_TXOUTCLKPCS_OUT             =>      GT9_TXOUTCLKPCS_OUT,
        --------------------- Transmit Ports - TX Gearbox Ports --------------------
        GT9_TXCHARISK_IN                =>      GT9_TXCHARISK_IN,
        ------------- Transmit Ports - TX Initialization and Reset Ports -----------
        GT9_TXRESETDONE_OUT             =>      gt9_txresetdone_i,
        ------------------ Transmit Ports - pattern Generator Ports ----------------
        GT9_TXPRBSSEL_IN                =>      GT9_TXPRBSSEL_IN,


  
        --_____________________________________________________________________
        --_____________________________________________________________________
        --GT10  (X1Y10)

        ---------------------------- Channel - DRP Ports  --------------------------
        GT10_DRPADDR_IN                 =>      gt10_drpaddr_i,
        GT10_DRPCLK_IN                  =>      GT10_DRPCLK_IN,
        GT10_DRPDI_IN                   =>      gt10_drpdi_i,
        GT10_DRPDO_OUT                  =>      gt10_drpdo_o,
        GT10_DRPEN_IN                   =>      gt10_drpen_i,
        GT10_DRPRDY_OUT                 =>      gt10_drprdy_o,
        GT10_DRPWE_IN                   =>      gt10_drpwe_i,
        ------------------------------- Loopback Ports -----------------------------
        GT10_LOOPBACK_IN                =>      GT10_LOOPBACK_IN,
        --------------------- RX Initialization and Reset Ports --------------------
        GT10_RXUSERRDY_IN               =>      gt10_rxuserrdy_i,
        -------------------------- RX Margin Analysis Ports ------------------------
        GT10_EYESCANDATAERROR_OUT       =>      GT10_EYESCANDATAERROR_OUT,
        ------------------------- Receive Ports - CDR Ports ------------------------
        GT10_RXCDRLOCK_OUT              =>      GT10_RXCDRLOCK_OUT,
        ------------------- Receive Ports - Clock Correction Ports -----------------
        GT10_RXCLKCORCNT_OUT            =>      GT10_RXCLKCORCNT_OUT,
        ------------------ Receive Ports - FPGA RX Interface Ports -----------------
        GT10_RXUSRCLK_IN                =>      GT10_RXUSRCLK_IN,
        GT10_RXUSRCLK2_IN               =>      GT10_RXUSRCLK2_IN,
        ------------------ Receive Ports - FPGA RX interface Ports -----------------
        GT10_RXDATA_OUT                 =>      GT10_RXDATA_OUT,
        ------------------- Receive Ports - Pattern Checker Ports ------------------
        GT10_RXPRBSERR_OUT              =>      GT10_RXPRBSERR_OUT,
        GT10_RXPRBSSEL_IN               =>      GT10_RXPRBSSEL_IN,
        ------------------- Receive Ports - Pattern Checker ports ------------------
        GT10_RXPRBSCNTRESET_IN          =>      GT10_RXPRBSCNTRESET_IN,
        ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
        GT10_RXDISPERR_OUT              =>      GT10_RXDISPERR_OUT,
        GT10_RXNOTINTABLE_OUT           =>      GT10_RXNOTINTABLE_OUT,
        --------------------------- Receive Ports - RX AFE -------------------------
        GT10_GTXRXP_IN                  =>      GT10_GTXRXP_IN,
        ------------------------ Receive Ports - RX AFE Ports ----------------------
        GT10_GTXRXN_IN                  =>      GT10_GTXRXN_IN,
        -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
        GT10_RXMCOMMAALIGNEN_IN         =>      GT10_RXMCOMMAALIGNEN_IN,
        GT10_RXPCOMMAALIGNEN_IN         =>      GT10_RXPCOMMAALIGNEN_IN,
        --------------------- Receive Ports - RX Equalizer Ports -------------------
        GT10_RXDFELPMRESET_IN           =>      gt10_rxdfelpmreset_i,
        --------------------- Receive Ports - RX Equilizer Ports -------------------
        GT10_RXLPMHFHOLD_IN             =>      gt10_rxlpmhfhold_i,
        GT10_RXLPMLFHOLD_IN             =>      gt10_rxlpmlfhold_i,
        --------------- Receive Ports - RX Fabric Output Control Ports -------------
        GT10_RXOUTCLK_OUT               =>      gt10_rxoutclk_i,
        ------------- Receive Ports - RX Initialization and Reset Ports ------------
        GT10_GTRXRESET_IN               =>      gt10_gtrxreset_i,
        GT10_RXPMARESET_IN              =>      GT10_RXPMARESET_IN,
        ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
        GT10_RXCHARISCOMMA_OUT          =>      GT10_RXCHARISCOMMA_OUT,
        GT10_RXCHARISK_OUT              =>      GT10_RXCHARISK_OUT,
        -------------- Receive Ports -RX Initialization and Reset Ports ------------
        GT10_RXRESETDONE_OUT            =>      gt10_rxresetdone_i,
        --------------------- TX Initialization and Reset Ports --------------------
        GT10_GTTXRESET_IN               =>      gt10_gttxreset_i,
        GT10_TXUSERRDY_IN               =>      gt10_txuserrdy_i,
        ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
        GT10_TXUSRCLK_IN                =>      GT10_TXUSRCLK_IN,
        GT10_TXUSRCLK2_IN               =>      GT10_TXUSRCLK2_IN,
        --------------- Transmit Ports - TX Configurable Driver Ports --------------
        GT10_TXDIFFCTRL_IN              =>      GT10_TXDIFFCTRL_IN,
        ------------------ Transmit Ports - TX Data Path interface -----------------
        GT10_TXDATA_IN                  =>      GT10_TXDATA_IN,
        ---------------- Transmit Ports - TX Driver and OOB signaling --------------
        GT10_GTXTXN_OUT                 =>      GT10_GTXTXN_OUT,
        GT10_GTXTXP_OUT                 =>      GT10_GTXTXP_OUT,
        ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
        GT10_TXOUTCLK_OUT               =>      GT10_TXOUTCLK_OUT,
        GT10_TXOUTCLKFABRIC_OUT         =>      GT10_TXOUTCLKFABRIC_OUT,
        GT10_TXOUTCLKPCS_OUT            =>      GT10_TXOUTCLKPCS_OUT,
        --------------------- Transmit Ports - TX Gearbox Ports --------------------
        GT10_TXCHARISK_IN               =>      GT10_TXCHARISK_IN,
        ------------- Transmit Ports - TX Initialization and Reset Ports -----------
        GT10_TXRESETDONE_OUT            =>      gt10_txresetdone_i,
        ------------------ Transmit Ports - pattern Generator Ports ----------------
        GT10_TXPRBSSEL_IN               =>      GT10_TXPRBSSEL_IN,


  
        --_____________________________________________________________________
        --_____________________________________________________________________
        --GT11  (X1Y11)

        ---------------------------- Channel - DRP Ports  --------------------------
        GT11_DRPADDR_IN                 =>      gt11_drpaddr_i,
        GT11_DRPCLK_IN                  =>      GT11_DRPCLK_IN,
        GT11_DRPDI_IN                   =>      gt11_drpdi_i,
        GT11_DRPDO_OUT                  =>      gt11_drpdo_o,
        GT11_DRPEN_IN                   =>      gt11_drpen_i,
        GT11_DRPRDY_OUT                 =>      gt11_drprdy_o,
        GT11_DRPWE_IN                   =>      gt11_drpwe_i,
        ------------------------------- Loopback Ports -----------------------------
        GT11_LOOPBACK_IN                =>      GT11_LOOPBACK_IN,
        --------------------- RX Initialization and Reset Ports --------------------
        GT11_RXUSERRDY_IN               =>      gt11_rxuserrdy_i,
        -------------------------- RX Margin Analysis Ports ------------------------
        GT11_EYESCANDATAERROR_OUT       =>      GT11_EYESCANDATAERROR_OUT,
        ------------------------- Receive Ports - CDR Ports ------------------------
        GT11_RXCDRLOCK_OUT              =>      GT11_RXCDRLOCK_OUT,
        ------------------- Receive Ports - Clock Correction Ports -----------------
        GT11_RXCLKCORCNT_OUT            =>      GT11_RXCLKCORCNT_OUT,
        ------------------ Receive Ports - FPGA RX Interface Ports -----------------
        GT11_RXUSRCLK_IN                =>      GT11_RXUSRCLK_IN,
        GT11_RXUSRCLK2_IN               =>      GT11_RXUSRCLK2_IN,
        ------------------ Receive Ports - FPGA RX interface Ports -----------------
        GT11_RXDATA_OUT                 =>      GT11_RXDATA_OUT,
        ------------------- Receive Ports - Pattern Checker Ports ------------------
        GT11_RXPRBSERR_OUT              =>      GT11_RXPRBSERR_OUT,
        GT11_RXPRBSSEL_IN               =>      GT11_RXPRBSSEL_IN,
        ------------------- Receive Ports - Pattern Checker ports ------------------
        GT11_RXPRBSCNTRESET_IN          =>      GT11_RXPRBSCNTRESET_IN,
        ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
        GT11_RXDISPERR_OUT              =>      GT11_RXDISPERR_OUT,
        GT11_RXNOTINTABLE_OUT           =>      GT11_RXNOTINTABLE_OUT,
        --------------------------- Receive Ports - RX AFE -------------------------
        GT11_GTXRXP_IN                  =>      GT11_GTXRXP_IN,
        ------------------------ Receive Ports - RX AFE Ports ----------------------
        GT11_GTXRXN_IN                  =>      GT11_GTXRXN_IN,
        -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
        GT11_RXMCOMMAALIGNEN_IN         =>      GT11_RXMCOMMAALIGNEN_IN,
        GT11_RXPCOMMAALIGNEN_IN         =>      GT11_RXPCOMMAALIGNEN_IN,
        --------------------- Receive Ports - RX Equalizer Ports -------------------
        GT11_RXDFELPMRESET_IN           =>      gt11_rxdfelpmreset_i,
        --------------------- Receive Ports - RX Equilizer Ports -------------------
        GT11_RXLPMHFHOLD_IN             =>      gt11_rxlpmhfhold_i,
        GT11_RXLPMLFHOLD_IN             =>      gt11_rxlpmlfhold_i,
        --------------- Receive Ports - RX Fabric Output Control Ports -------------
        GT11_RXOUTCLK_OUT               =>      gt11_rxoutclk_i,
        ------------- Receive Ports - RX Initialization and Reset Ports ------------
        GT11_GTRXRESET_IN               =>      gt11_gtrxreset_i,
        GT11_RXPMARESET_IN              =>      GT11_RXPMARESET_IN,
        ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
        GT11_RXCHARISCOMMA_OUT          =>      GT11_RXCHARISCOMMA_OUT,
        GT11_RXCHARISK_OUT              =>      GT11_RXCHARISK_OUT,
        -------------- Receive Ports -RX Initialization and Reset Ports ------------
        GT11_RXRESETDONE_OUT            =>      gt11_rxresetdone_i,
        --------------------- TX Initialization and Reset Ports --------------------
        GT11_GTTXRESET_IN               =>      gt11_gttxreset_i,
        GT11_TXUSERRDY_IN               =>      gt11_txuserrdy_i,
        ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
        GT11_TXUSRCLK_IN                =>      GT11_TXUSRCLK_IN,
        GT11_TXUSRCLK2_IN               =>      GT11_TXUSRCLK2_IN,
        --------------- Transmit Ports - TX Configurable Driver Ports --------------
        GT11_TXDIFFCTRL_IN              =>      GT11_TXDIFFCTRL_IN,
        ------------------ Transmit Ports - TX Data Path interface -----------------
        GT11_TXDATA_IN                  =>      GT11_TXDATA_IN,
        ---------------- Transmit Ports - TX Driver and OOB signaling --------------
        GT11_GTXTXN_OUT                 =>      GT11_GTXTXN_OUT,
        GT11_GTXTXP_OUT                 =>      GT11_GTXTXP_OUT,
        ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
        GT11_TXOUTCLK_OUT               =>      GT11_TXOUTCLK_OUT,
        GT11_TXOUTCLKFABRIC_OUT         =>      GT11_TXOUTCLKFABRIC_OUT,
        GT11_TXOUTCLKPCS_OUT            =>      GT11_TXOUTCLKPCS_OUT,
        --------------------- Transmit Ports - TX Gearbox Ports --------------------
        GT11_TXCHARISK_IN               =>      GT11_TXCHARISK_IN,
        ------------- Transmit Ports - TX Initialization and Reset Ports -----------
        GT11_TXRESETDONE_OUT            =>      gt11_txresetdone_i,
        ------------------ Transmit Ports - pattern Generator Ports ----------------
        GT11_TXPRBSSEL_IN               =>      GT11_TXPRBSSEL_IN,




    --____________________________COMMON PORTS________________________________
        ---------------------- Common Block  - Ref Clock Ports ---------------------
        GT0_GTREFCLK0_COMMON_IN         =>      GT0_GTREFCLK0_COMMON_IN,
        ------------------------- Common Block - QPLL Ports ------------------------
        GT0_QPLLLOCK_OUT                =>      gt0_qplllock_i,
        GT0_QPLLLOCKDETCLK_IN           =>      GT0_QPLLLOCKDETCLK_IN,
        GT0_QPLLREFCLKLOST_OUT          =>      gt0_qpllrefclklost_i,
        GT0_QPLLRESET_IN                =>      gt0_qpllreset_i,


    --____________________________COMMON PORTS________________________________
        ---------------------- Common Block  - Ref Clock Ports ---------------------
        GT1_GTREFCLK0_COMMON_IN         =>      GT1_GTREFCLK0_COMMON_IN,
        ------------------------- Common Block - QPLL Ports ------------------------
        GT1_QPLLLOCK_OUT                =>      gt1_qplllock_i,
        GT1_QPLLLOCKDETCLK_IN           =>      GT1_QPLLLOCKDETCLK_IN,
        GT1_QPLLREFCLKLOST_OUT          =>      gt1_qpllrefclklost_i,
        GT1_QPLLRESET_IN                =>      gt1_qpllreset_i,


    --____________________________COMMON PORTS________________________________
        ---------------------- Common Block  - Ref Clock Ports ---------------------
        GT2_GTREFCLK0_COMMON_IN         =>      GT2_GTREFCLK0_COMMON_IN,
        ------------------------- Common Block - QPLL Ports ------------------------
        GT2_QPLLLOCK_OUT                =>      gt2_qplllock_i,
        GT2_QPLLLOCKDETCLK_IN           =>      GT2_QPLLLOCKDETCLK_IN,
        GT2_QPLLREFCLKLOST_OUT          =>      gt2_qpllrefclklost_i,
        GT2_QPLLRESET_IN                =>      gt2_qpllreset_i

    );


    gt0_rxdfelpmreset_i                          <= tied_to_ground_i;
    gt1_rxdfelpmreset_i                          <= tied_to_ground_i;
    gt2_rxdfelpmreset_i                          <= tied_to_ground_i;
    gt3_rxdfelpmreset_i                          <= tied_to_ground_i;
    gt4_rxdfelpmreset_i                          <= tied_to_ground_i;
    gt5_rxdfelpmreset_i                          <= tied_to_ground_i;
    gt6_rxdfelpmreset_i                          <= tied_to_ground_i;
    gt7_rxdfelpmreset_i                          <= tied_to_ground_i;
    gt8_rxdfelpmreset_i                          <= tied_to_ground_i;
    gt9_rxdfelpmreset_i                          <= tied_to_ground_i;
    gt10_rxdfelpmreset_i                         <= tied_to_ground_i;
    gt11_rxdfelpmreset_i                         <= tied_to_ground_i;




    GT0_TXRESETDONE_OUT                          <= gt0_txresetdone_i;
    GT0_RXRESETDONE_OUT                          <= gt0_rxresetdone_i;
    GT1_TXRESETDONE_OUT                          <= gt1_txresetdone_i;
    GT1_RXRESETDONE_OUT                          <= gt1_rxresetdone_i;
    GT2_TXRESETDONE_OUT                          <= gt2_txresetdone_i;
    GT2_RXRESETDONE_OUT                          <= gt2_rxresetdone_i;
    GT3_TXRESETDONE_OUT                          <= gt3_txresetdone_i;
    GT3_RXRESETDONE_OUT                          <= gt3_rxresetdone_i;
    GT4_TXRESETDONE_OUT                          <= gt4_txresetdone_i;
    GT4_RXRESETDONE_OUT                          <= gt4_rxresetdone_i;
    GT5_TXRESETDONE_OUT                          <= gt5_txresetdone_i;
    GT5_RXRESETDONE_OUT                          <= gt5_rxresetdone_i;
    GT6_TXRESETDONE_OUT                          <= gt6_txresetdone_i;
    GT6_RXRESETDONE_OUT                          <= gt6_rxresetdone_i;
    GT7_TXRESETDONE_OUT                          <= gt7_txresetdone_i;
    GT7_RXRESETDONE_OUT                          <= gt7_rxresetdone_i;
    GT8_TXRESETDONE_OUT                          <= gt8_txresetdone_i;
    GT8_RXRESETDONE_OUT                          <= gt8_rxresetdone_i;
    GT9_TXRESETDONE_OUT                          <= gt9_txresetdone_i;
    GT9_RXRESETDONE_OUT                          <= gt9_rxresetdone_i;
    GT10_TXRESETDONE_OUT                         <= gt10_txresetdone_i;
    GT10_RXRESETDONE_OUT                         <= gt10_rxresetdone_i;
    GT11_TXRESETDONE_OUT                         <= gt11_txresetdone_i;
    GT11_RXRESETDONE_OUT                         <= gt11_rxresetdone_i;
    GT0_QPLLLOCK_OUT                             <= gt0_qplllock_i;
    GT1_QPLLLOCK_OUT                             <= gt1_qplllock_i;
    GT2_QPLLLOCK_OUT                             <= gt2_qplllock_i;

chipscope : if EXAMPLE_USE_CHIPSCOPE = 1 generate
    gt0_gttxreset_i                              <= GT0_GTTXRESET_IN;
    gt0_gtrxreset_i                              <= GT0_GTRXRESET_IN;
    gt0_txuserrdy_i                              <= GT0_TXUSERRDY_IN;
    gt0_rxuserrdy_i                              <= GT0_RXUSERRDY_IN;
    gt1_gttxreset_i                              <= GT1_GTTXRESET_IN;
    gt1_gtrxreset_i                              <= GT1_GTRXRESET_IN;
    gt1_txuserrdy_i                              <= GT1_TXUSERRDY_IN;
    gt1_rxuserrdy_i                              <= GT1_RXUSERRDY_IN;
    gt2_gttxreset_i                              <= GT2_GTTXRESET_IN;
    gt2_gtrxreset_i                              <= GT2_GTRXRESET_IN;
    gt2_txuserrdy_i                              <= GT2_TXUSERRDY_IN;
    gt2_rxuserrdy_i                              <= GT2_RXUSERRDY_IN;
    gt3_gttxreset_i                              <= GT3_GTTXRESET_IN;
    gt3_gtrxreset_i                              <= GT3_GTRXRESET_IN;
    gt3_txuserrdy_i                              <= GT3_TXUSERRDY_IN;
    gt3_rxuserrdy_i                              <= GT3_RXUSERRDY_IN;
    gt4_gttxreset_i                              <= GT4_GTTXRESET_IN;
    gt4_gtrxreset_i                              <= GT4_GTRXRESET_IN;
    gt4_txuserrdy_i                              <= GT4_TXUSERRDY_IN;
    gt4_rxuserrdy_i                              <= GT4_RXUSERRDY_IN;
    gt5_gttxreset_i                              <= GT5_GTTXRESET_IN;
    gt5_gtrxreset_i                              <= GT5_GTRXRESET_IN;
    gt5_txuserrdy_i                              <= GT5_TXUSERRDY_IN;
    gt5_rxuserrdy_i                              <= GT5_RXUSERRDY_IN;
    gt6_gttxreset_i                              <= GT6_GTTXRESET_IN;
    gt6_gtrxreset_i                              <= GT6_GTRXRESET_IN;
    gt6_txuserrdy_i                              <= GT6_TXUSERRDY_IN;
    gt6_rxuserrdy_i                              <= GT6_RXUSERRDY_IN;
    gt7_gttxreset_i                              <= GT7_GTTXRESET_IN;
    gt7_gtrxreset_i                              <= GT7_GTRXRESET_IN;
    gt7_txuserrdy_i                              <= GT7_TXUSERRDY_IN;
    gt7_rxuserrdy_i                              <= GT7_RXUSERRDY_IN;
    gt8_gttxreset_i                              <= GT8_GTTXRESET_IN;
    gt8_gtrxreset_i                              <= GT8_GTRXRESET_IN;
    gt8_txuserrdy_i                              <= GT8_TXUSERRDY_IN;
    gt8_rxuserrdy_i                              <= GT8_RXUSERRDY_IN;
    gt9_gttxreset_i                              <= GT9_GTTXRESET_IN;
    gt9_gtrxreset_i                              <= GT9_GTRXRESET_IN;
    gt9_txuserrdy_i                              <= GT9_TXUSERRDY_IN;
    gt9_rxuserrdy_i                              <= GT9_RXUSERRDY_IN;
    gt10_gttxreset_i                             <= GT10_GTTXRESET_IN;
    gt10_gtrxreset_i                             <= GT10_GTRXRESET_IN;
    gt10_txuserrdy_i                             <= GT10_TXUSERRDY_IN;
    gt10_rxuserrdy_i                             <= GT10_RXUSERRDY_IN;
    gt11_gttxreset_i                             <= GT11_GTTXRESET_IN;
    gt11_gtrxreset_i                             <= GT11_GTRXRESET_IN;
    gt11_txuserrdy_i                             <= GT11_TXUSERRDY_IN;
    gt11_rxuserrdy_i                             <= GT11_RXUSERRDY_IN;
    gt0_qpllreset_i                              <= GT0_QPLLRESET_IN;
    gt1_qpllreset_i                              <= GT1_QPLLRESET_IN;
    gt2_qpllreset_i                              <= GT2_QPLLRESET_IN;
end generate chipscope;

no_chipscope : if EXAMPLE_USE_CHIPSCOPE = 0 generate
    gt0_gttxreset_i                              <= gt0_gttxreset_t;
    gt0_gtrxreset_i                              <= gt0_gtrxreset_t;
    gt0_txuserrdy_i                              <= gt0_txuserrdy_t;
    gt0_rxuserrdy_i                              <= gt0_rxuserrdy_t;
    gt1_gttxreset_i                              <= gt1_gttxreset_t;
    gt1_gtrxreset_i                              <= gt1_gtrxreset_t;
    gt1_txuserrdy_i                              <= gt1_txuserrdy_t;
    gt1_rxuserrdy_i                              <= gt1_rxuserrdy_t;
    gt2_gttxreset_i                              <= gt2_gttxreset_t;
    gt2_gtrxreset_i                              <= gt2_gtrxreset_t;
    gt2_txuserrdy_i                              <= gt2_txuserrdy_t;
    gt2_rxuserrdy_i                              <= gt2_rxuserrdy_t;
    gt3_gttxreset_i                              <= gt3_gttxreset_t;
    gt3_gtrxreset_i                              <= gt3_gtrxreset_t;
    gt3_txuserrdy_i                              <= gt3_txuserrdy_t;
    gt3_rxuserrdy_i                              <= gt3_rxuserrdy_t;
    gt4_gttxreset_i                              <= gt4_gttxreset_t;
    gt4_gtrxreset_i                              <= gt4_gtrxreset_t;
    gt4_txuserrdy_i                              <= gt4_txuserrdy_t;
    gt4_rxuserrdy_i                              <= gt4_rxuserrdy_t;
    gt5_gttxreset_i                              <= gt5_gttxreset_t;
    gt5_gtrxreset_i                              <= gt5_gtrxreset_t;
    gt5_txuserrdy_i                              <= gt5_txuserrdy_t;
    gt5_rxuserrdy_i                              <= gt5_rxuserrdy_t;
    gt6_gttxreset_i                              <= gt6_gttxreset_t;
    gt6_gtrxreset_i                              <= gt6_gtrxreset_t;
    gt6_txuserrdy_i                              <= gt6_txuserrdy_t;
    gt6_rxuserrdy_i                              <= gt6_rxuserrdy_t;
    gt7_gttxreset_i                              <= gt7_gttxreset_t;
    gt7_gtrxreset_i                              <= gt7_gtrxreset_t;
    gt7_txuserrdy_i                              <= gt7_txuserrdy_t;
    gt7_rxuserrdy_i                              <= gt7_rxuserrdy_t;
    gt8_gttxreset_i                              <= gt8_gttxreset_t;
    gt8_gtrxreset_i                              <= gt8_gtrxreset_t;
    gt8_txuserrdy_i                              <= gt8_txuserrdy_t;
    gt8_rxuserrdy_i                              <= gt8_rxuserrdy_t;
    gt9_gttxreset_i                              <= gt9_gttxreset_t;
    gt9_gtrxreset_i                              <= gt9_gtrxreset_t;
    gt9_txuserrdy_i                              <= gt9_txuserrdy_t;
    gt9_rxuserrdy_i                              <= gt9_rxuserrdy_t;
    gt10_gttxreset_i                             <= gt10_gttxreset_t;
    gt10_gtrxreset_i                             <= gt10_gtrxreset_t;
    gt10_txuserrdy_i                             <= gt10_txuserrdy_t;
    gt10_rxuserrdy_i                             <= gt10_rxuserrdy_t;
    gt11_gttxreset_i                             <= gt11_gttxreset_t;
    gt11_gtrxreset_i                             <= gt11_gtrxreset_t;
    gt11_txuserrdy_i                             <= gt11_txuserrdy_t;
    gt11_rxuserrdy_i                             <= gt11_rxuserrdy_t;
    gt0_qpllreset_i                              <= gt0_qpllreset_t;
    gt1_qpllreset_i                              <= gt1_qpllreset_t;
    gt2_qpllreset_i                              <= gt2_qpllreset_t;
end generate no_chipscope;


gt0_txresetfsm_i:  AMC_GTX_TX_STARTUP_FSM 

  generic map(
           GT_TYPE                  => "GTX", --GTX or GTH or GTP
           STABLE_CLOCK_PERIOD      => STABLE_CLOCK_PERIOD,           -- Period of the stable clock driving this state-machine, unit is [ns]
           RETRY_COUNTER_BITWIDTH   => 8, 
           TX_QPLL_USED             => TRUE ,                        -- the TX and RX Reset FSMs must 
           RX_QPLL_USED             => TRUE,                         -- share these two generic values
           PHASE_ALIGNMENT_MANUAL   => FALSE                 -- Decision if a manual phase-alignment is necessary or the automatic 
                                                                     -- is enough. For single-lane applications the automatic alignment is 
                                                                     -- sufficient              
             )     
    port map ( 
        STABLE_CLOCK                    =>      SYSCLK_IN,
        TXUSERCLK                       =>      GT0_TXUSRCLK_IN,
        SOFT_RESET                      =>      SOFT_RESET_IN,
        QPLLREFCLKLOST                  =>      gt0_qpllrefclklost_i,
        CPLLREFCLKLOST                  =>      tied_to_ground_i,
        QPLLLOCK                        =>      gt0_qplllock_i,
        CPLLLOCK                        =>      tied_to_vcc_i,
        TXRESETDONE                     =>      gt0_txresetdone_i,
        MMCM_LOCK                       =>      tied_to_vcc_i,
        GTTXRESET                       =>      gt0_gttxreset_t,
        MMCM_RESET                      =>      open,
        QPLL_RESET                      =>      gt0_qpllreset_t,
        CPLL_RESET                      =>      open,
        TX_FSM_RESET_DONE               =>      GT0_TX_FSM_RESET_DONE_OUT,
        TXUSERRDY                       =>      gt0_txuserrdy_t,
        RUN_PHALIGNMENT                 =>      open,
        RESET_PHALIGNMENT               =>      open,
        PHALIGNMENT_DONE                =>      tied_to_vcc_i,
        RETRY_COUNTER                   =>      open
           );


gt1_txresetfsm_i:  AMC_GTX_TX_STARTUP_FSM 

  generic map(
           GT_TYPE                  => "GTX", --GTX or GTH or GTP
           STABLE_CLOCK_PERIOD      => STABLE_CLOCK_PERIOD,           -- Period of the stable clock driving this state-machine, unit is [ns]
           RETRY_COUNTER_BITWIDTH   => 8, 
           TX_QPLL_USED             => TRUE ,                        -- the TX and RX Reset FSMs must 
           RX_QPLL_USED             => TRUE,                         -- share these two generic values
           PHASE_ALIGNMENT_MANUAL   => FALSE                 -- Decision if a manual phase-alignment is necessary or the automatic 
                                                                     -- is enough. For single-lane applications the automatic alignment is 
                                                                     -- sufficient              
             )     
    port map ( 
        STABLE_CLOCK                    =>      SYSCLK_IN,
        TXUSERCLK                       =>      GT1_TXUSRCLK_IN,
        SOFT_RESET                      =>      SOFT_RESET_IN,
        QPLLREFCLKLOST                  =>      gt0_qpllrefclklost_i,
        CPLLREFCLKLOST                  =>      tied_to_ground_i,
        QPLLLOCK                        =>      gt0_qplllock_i,
        CPLLLOCK                        =>      tied_to_vcc_i,
        TXRESETDONE                     =>      gt1_txresetdone_i,
        MMCM_LOCK                       =>      tied_to_vcc_i,
        GTTXRESET                       =>      gt1_gttxreset_t,
        MMCM_RESET                      =>      open,
        QPLL_RESET                      =>      open,
        CPLL_RESET                      =>      open,
        TX_FSM_RESET_DONE               =>      GT1_TX_FSM_RESET_DONE_OUT,
        TXUSERRDY                       =>      gt1_txuserrdy_t,
        RUN_PHALIGNMENT                 =>      open,
        RESET_PHALIGNMENT               =>      open,
        PHALIGNMENT_DONE                =>      tied_to_vcc_i,
        RETRY_COUNTER                   =>      open
           );


gt2_txresetfsm_i:  AMC_GTX_TX_STARTUP_FSM 

  generic map(
           GT_TYPE                  => "GTX", --GTX or GTH or GTP
           STABLE_CLOCK_PERIOD      => STABLE_CLOCK_PERIOD,           -- Period of the stable clock driving this state-machine, unit is [ns]
           RETRY_COUNTER_BITWIDTH   => 8, 
           TX_QPLL_USED             => TRUE ,                        -- the TX and RX Reset FSMs must 
           RX_QPLL_USED             => TRUE,                         -- share these two generic values
           PHASE_ALIGNMENT_MANUAL   => FALSE                 -- Decision if a manual phase-alignment is necessary or the automatic 
                                                                     -- is enough. For single-lane applications the automatic alignment is 
                                                                     -- sufficient              
             )     
    port map ( 
        STABLE_CLOCK                    =>      SYSCLK_IN,
        TXUSERCLK                       =>      GT2_TXUSRCLK_IN,
        SOFT_RESET                      =>      SOFT_RESET_IN,
        QPLLREFCLKLOST                  =>      gt0_qpllrefclklost_i,
        CPLLREFCLKLOST                  =>      tied_to_ground_i,
        QPLLLOCK                        =>      gt0_qplllock_i,
        CPLLLOCK                        =>      tied_to_vcc_i,
        TXRESETDONE                     =>      gt2_txresetdone_i,
        MMCM_LOCK                       =>      tied_to_vcc_i,
        GTTXRESET                       =>      gt2_gttxreset_t,
        MMCM_RESET                      =>      open,
        QPLL_RESET                      =>      open,
        CPLL_RESET                      =>      open,
        TX_FSM_RESET_DONE               =>      GT2_TX_FSM_RESET_DONE_OUT,
        TXUSERRDY                       =>      gt2_txuserrdy_t,
        RUN_PHALIGNMENT                 =>      open,
        RESET_PHALIGNMENT               =>      open,
        PHALIGNMENT_DONE                =>      tied_to_vcc_i,
        RETRY_COUNTER                   =>      open
           );


gt3_txresetfsm_i:  AMC_GTX_TX_STARTUP_FSM 

  generic map(
           GT_TYPE                  => "GTX", --GTX or GTH or GTP
           STABLE_CLOCK_PERIOD      => STABLE_CLOCK_PERIOD,           -- Period of the stable clock driving this state-machine, unit is [ns]
           RETRY_COUNTER_BITWIDTH   => 8, 
           TX_QPLL_USED             => TRUE ,                        -- the TX and RX Reset FSMs must 
           RX_QPLL_USED             => TRUE,                         -- share these two generic values
           PHASE_ALIGNMENT_MANUAL   => FALSE                 -- Decision if a manual phase-alignment is necessary or the automatic 
                                                                     -- is enough. For single-lane applications the automatic alignment is 
                                                                     -- sufficient              
             )     
    port map ( 
        STABLE_CLOCK                    =>      SYSCLK_IN,
        TXUSERCLK                       =>      GT3_TXUSRCLK_IN,
        SOFT_RESET                      =>      SOFT_RESET_IN,
        QPLLREFCLKLOST                  =>      gt0_qpllrefclklost_i,
        CPLLREFCLKLOST                  =>      tied_to_ground_i,
        QPLLLOCK                        =>      gt0_qplllock_i,
        CPLLLOCK                        =>      tied_to_vcc_i,
        TXRESETDONE                     =>      gt3_txresetdone_i,
        MMCM_LOCK                       =>      tied_to_vcc_i,
        GTTXRESET                       =>      gt3_gttxreset_t,
        MMCM_RESET                      =>      open,
        QPLL_RESET                      =>      open,
        CPLL_RESET                      =>      open,
        TX_FSM_RESET_DONE               =>      GT3_TX_FSM_RESET_DONE_OUT,
        TXUSERRDY                       =>      gt3_txuserrdy_t,
        RUN_PHALIGNMENT                 =>      open,
        RESET_PHALIGNMENT               =>      open,
        PHALIGNMENT_DONE                =>      tied_to_vcc_i,
        RETRY_COUNTER                   =>      open
           );


gt4_txresetfsm_i:  AMC_GTX_TX_STARTUP_FSM 

  generic map(
           GT_TYPE                  => "GTX", --GTX or GTH or GTP
           STABLE_CLOCK_PERIOD      => STABLE_CLOCK_PERIOD,           -- Period of the stable clock driving this state-machine, unit is [ns]
           RETRY_COUNTER_BITWIDTH   => 8, 
           TX_QPLL_USED             => TRUE ,                        -- the TX and RX Reset FSMs must 
           RX_QPLL_USED             => TRUE,                         -- share these two generic values
           PHASE_ALIGNMENT_MANUAL   => FALSE                 -- Decision if a manual phase-alignment is necessary or the automatic 
                                                                     -- is enough. For single-lane applications the automatic alignment is 
                                                                     -- sufficient              
             )     
    port map ( 
        STABLE_CLOCK                    =>      SYSCLK_IN,
        TXUSERCLK                       =>      GT4_TXUSRCLK_IN,
        SOFT_RESET                      =>      SOFT_RESET_IN,
        QPLLREFCLKLOST                  =>      gt1_qpllrefclklost_i,
        CPLLREFCLKLOST                  =>      tied_to_ground_i,
        QPLLLOCK                        =>      gt1_qplllock_i,
        CPLLLOCK                        =>      tied_to_vcc_i,
        TXRESETDONE                     =>      gt4_txresetdone_i,
        MMCM_LOCK                       =>      tied_to_vcc_i,
        GTTXRESET                       =>      gt4_gttxreset_t,
        MMCM_RESET                      =>      open,
        QPLL_RESET                      =>      gt1_qpllreset_t,
        CPLL_RESET                      =>      open,
        TX_FSM_RESET_DONE               =>      GT4_TX_FSM_RESET_DONE_OUT,
        TXUSERRDY                       =>      gt4_txuserrdy_t,
        RUN_PHALIGNMENT                 =>      open,
        RESET_PHALIGNMENT               =>      open,
        PHALIGNMENT_DONE                =>      tied_to_vcc_i,
        RETRY_COUNTER                   =>      open
           );


gt5_txresetfsm_i:  AMC_GTX_TX_STARTUP_FSM 

  generic map(
           GT_TYPE                  => "GTX", --GTX or GTH or GTP
           STABLE_CLOCK_PERIOD      => STABLE_CLOCK_PERIOD,           -- Period of the stable clock driving this state-machine, unit is [ns]
           RETRY_COUNTER_BITWIDTH   => 8, 
           TX_QPLL_USED             => TRUE ,                        -- the TX and RX Reset FSMs must 
           RX_QPLL_USED             => TRUE,                         -- share these two generic values
           PHASE_ALIGNMENT_MANUAL   => FALSE                 -- Decision if a manual phase-alignment is necessary or the automatic 
                                                                     -- is enough. For single-lane applications the automatic alignment is 
                                                                     -- sufficient              
             )     
    port map ( 
        STABLE_CLOCK                    =>      SYSCLK_IN,
        TXUSERCLK                       =>      GT5_TXUSRCLK_IN,
        SOFT_RESET                      =>      SOFT_RESET_IN,
        QPLLREFCLKLOST                  =>      gt1_qpllrefclklost_i,
        CPLLREFCLKLOST                  =>      tied_to_ground_i,
        QPLLLOCK                        =>      gt1_qplllock_i,
        CPLLLOCK                        =>      tied_to_vcc_i,
        TXRESETDONE                     =>      gt5_txresetdone_i,
        MMCM_LOCK                       =>      tied_to_vcc_i,
        GTTXRESET                       =>      gt5_gttxreset_t,
        MMCM_RESET                      =>      open,
        QPLL_RESET                      =>      open,
        CPLL_RESET                      =>      open,
        TX_FSM_RESET_DONE               =>      GT5_TX_FSM_RESET_DONE_OUT,
        TXUSERRDY                       =>      gt5_txuserrdy_t,
        RUN_PHALIGNMENT                 =>      open,
        RESET_PHALIGNMENT               =>      open,
        PHALIGNMENT_DONE                =>      tied_to_vcc_i,
        RETRY_COUNTER                   =>      open
           );


gt6_txresetfsm_i:  AMC_GTX_TX_STARTUP_FSM 

  generic map(
           GT_TYPE                  => "GTX", --GTX or GTH or GTP
           STABLE_CLOCK_PERIOD      => STABLE_CLOCK_PERIOD,           -- Period of the stable clock driving this state-machine, unit is [ns]
           RETRY_COUNTER_BITWIDTH   => 8, 
           TX_QPLL_USED             => TRUE ,                        -- the TX and RX Reset FSMs must 
           RX_QPLL_USED             => TRUE,                         -- share these two generic values
           PHASE_ALIGNMENT_MANUAL   => FALSE                 -- Decision if a manual phase-alignment is necessary or the automatic 
                                                                     -- is enough. For single-lane applications the automatic alignment is 
                                                                     -- sufficient              
             )     
    port map ( 
        STABLE_CLOCK                    =>      SYSCLK_IN,
        TXUSERCLK                       =>      GT6_TXUSRCLK_IN,
        SOFT_RESET                      =>      SOFT_RESET_IN,
        QPLLREFCLKLOST                  =>      gt1_qpllrefclklost_i,
        CPLLREFCLKLOST                  =>      tied_to_ground_i,
        QPLLLOCK                        =>      gt1_qplllock_i,
        CPLLLOCK                        =>      tied_to_vcc_i,
        TXRESETDONE                     =>      gt6_txresetdone_i,
        MMCM_LOCK                       =>      tied_to_vcc_i,
        GTTXRESET                       =>      gt6_gttxreset_t,
        MMCM_RESET                      =>      open,
        QPLL_RESET                      =>      open,
        CPLL_RESET                      =>      open,
        TX_FSM_RESET_DONE               =>      GT6_TX_FSM_RESET_DONE_OUT,
        TXUSERRDY                       =>      gt6_txuserrdy_t,
        RUN_PHALIGNMENT                 =>      open,
        RESET_PHALIGNMENT               =>      open,
        PHALIGNMENT_DONE                =>      tied_to_vcc_i,
        RETRY_COUNTER                   =>      open
           );


gt7_txresetfsm_i:  AMC_GTX_TX_STARTUP_FSM 

  generic map(
           GT_TYPE                  => "GTX", --GTX or GTH or GTP
           STABLE_CLOCK_PERIOD      => STABLE_CLOCK_PERIOD,           -- Period of the stable clock driving this state-machine, unit is [ns]
           RETRY_COUNTER_BITWIDTH   => 8, 
           TX_QPLL_USED             => TRUE ,                        -- the TX and RX Reset FSMs must 
           RX_QPLL_USED             => TRUE,                         -- share these two generic values
           PHASE_ALIGNMENT_MANUAL   => FALSE                 -- Decision if a manual phase-alignment is necessary or the automatic 
                                                                     -- is enough. For single-lane applications the automatic alignment is 
                                                                     -- sufficient              
             )     
    port map ( 
        STABLE_CLOCK                    =>      SYSCLK_IN,
        TXUSERCLK                       =>      GT7_TXUSRCLK_IN,
        SOFT_RESET                      =>      SOFT_RESET_IN,
        QPLLREFCLKLOST                  =>      gt1_qpllrefclklost_i,
        CPLLREFCLKLOST                  =>      tied_to_ground_i,
        QPLLLOCK                        =>      gt1_qplllock_i,
        CPLLLOCK                        =>      tied_to_vcc_i,
        TXRESETDONE                     =>      gt7_txresetdone_i,
        MMCM_LOCK                       =>      tied_to_vcc_i,
        GTTXRESET                       =>      gt7_gttxreset_t,
        MMCM_RESET                      =>      open,
        QPLL_RESET                      =>      open,
        CPLL_RESET                      =>      open,
        TX_FSM_RESET_DONE               =>      GT7_TX_FSM_RESET_DONE_OUT,
        TXUSERRDY                       =>      gt7_txuserrdy_t,
        RUN_PHALIGNMENT                 =>      open,
        RESET_PHALIGNMENT               =>      open,
        PHALIGNMENT_DONE                =>      tied_to_vcc_i,
        RETRY_COUNTER                   =>      open
           );


gt8_txresetfsm_i:  AMC_GTX_TX_STARTUP_FSM 

  generic map(
           GT_TYPE                  => "GTX", --GTX or GTH or GTP
           STABLE_CLOCK_PERIOD      => STABLE_CLOCK_PERIOD,           -- Period of the stable clock driving this state-machine, unit is [ns]
           RETRY_COUNTER_BITWIDTH   => 8, 
           TX_QPLL_USED             => TRUE ,                        -- the TX and RX Reset FSMs must 
           RX_QPLL_USED             => TRUE,                         -- share these two generic values
           PHASE_ALIGNMENT_MANUAL   => FALSE                 -- Decision if a manual phase-alignment is necessary or the automatic 
                                                                     -- is enough. For single-lane applications the automatic alignment is 
                                                                     -- sufficient              
             )     
    port map ( 
        STABLE_CLOCK                    =>      SYSCLK_IN,
        TXUSERCLK                       =>      GT8_TXUSRCLK_IN,
        SOFT_RESET                      =>      SOFT_RESET_IN,
        QPLLREFCLKLOST                  =>      gt2_qpllrefclklost_i,
        CPLLREFCLKLOST                  =>      tied_to_ground_i,
        QPLLLOCK                        =>      gt2_qplllock_i,
        CPLLLOCK                        =>      tied_to_vcc_i,
        TXRESETDONE                     =>      gt8_txresetdone_i,
        MMCM_LOCK                       =>      tied_to_vcc_i,
        GTTXRESET                       =>      gt8_gttxreset_t,
        MMCM_RESET                      =>      open,
        QPLL_RESET                      =>      gt2_qpllreset_t,
        CPLL_RESET                      =>      open,
        TX_FSM_RESET_DONE               =>      GT8_TX_FSM_RESET_DONE_OUT,
        TXUSERRDY                       =>      gt8_txuserrdy_t,
        RUN_PHALIGNMENT                 =>      open,
        RESET_PHALIGNMENT               =>      open,
        PHALIGNMENT_DONE                =>      tied_to_vcc_i,
        RETRY_COUNTER                   =>      open
           );


gt9_txresetfsm_i:  AMC_GTX_TX_STARTUP_FSM 

  generic map(
           GT_TYPE                  => "GTX", --GTX or GTH or GTP
           STABLE_CLOCK_PERIOD      => STABLE_CLOCK_PERIOD,           -- Period of the stable clock driving this state-machine, unit is [ns]
           RETRY_COUNTER_BITWIDTH   => 8, 
           TX_QPLL_USED             => TRUE ,                        -- the TX and RX Reset FSMs must 
           RX_QPLL_USED             => TRUE,                         -- share these two generic values
           PHASE_ALIGNMENT_MANUAL   => FALSE                 -- Decision if a manual phase-alignment is necessary or the automatic 
                                                                     -- is enough. For single-lane applications the automatic alignment is 
                                                                     -- sufficient              
             )     
    port map ( 
        STABLE_CLOCK                    =>      SYSCLK_IN,
        TXUSERCLK                       =>      GT9_TXUSRCLK_IN,
        SOFT_RESET                      =>      SOFT_RESET_IN,
        QPLLREFCLKLOST                  =>      gt2_qpllrefclklost_i,
        CPLLREFCLKLOST                  =>      tied_to_ground_i,
        QPLLLOCK                        =>      gt2_qplllock_i,
        CPLLLOCK                        =>      tied_to_vcc_i,
        TXRESETDONE                     =>      gt9_txresetdone_i,
        MMCM_LOCK                       =>      tied_to_vcc_i,
        GTTXRESET                       =>      gt9_gttxreset_t,
        MMCM_RESET                      =>      open,
        QPLL_RESET                      =>      open,
        CPLL_RESET                      =>      open,
        TX_FSM_RESET_DONE               =>      GT9_TX_FSM_RESET_DONE_OUT,
        TXUSERRDY                       =>      gt9_txuserrdy_t,
        RUN_PHALIGNMENT                 =>      open,
        RESET_PHALIGNMENT               =>      open,
        PHALIGNMENT_DONE                =>      tied_to_vcc_i,
        RETRY_COUNTER                   =>      open
           );


gt10_txresetfsm_i:  AMC_GTX_TX_STARTUP_FSM 

  generic map(
           GT_TYPE                  => "GTX", --GTX or GTH or GTP
           STABLE_CLOCK_PERIOD      => STABLE_CLOCK_PERIOD,           -- Period of the stable clock driving this state-machine, unit is [ns]
           RETRY_COUNTER_BITWIDTH   => 8, 
           TX_QPLL_USED             => TRUE ,                        -- the TX and RX Reset FSMs must 
           RX_QPLL_USED             => TRUE,                         -- share these two generic values
           PHASE_ALIGNMENT_MANUAL   => FALSE                 -- Decision if a manual phase-alignment is necessary or the automatic 
                                                                     -- is enough. For single-lane applications the automatic alignment is 
                                                                     -- sufficient              
             )     
    port map ( 
        STABLE_CLOCK                    =>      SYSCLK_IN,
        TXUSERCLK                       =>      GT10_TXUSRCLK_IN,
        SOFT_RESET                      =>      SOFT_RESET_IN,
        QPLLREFCLKLOST                  =>      gt2_qpllrefclklost_i,
        CPLLREFCLKLOST                  =>      tied_to_ground_i,
        QPLLLOCK                        =>      gt2_qplllock_i,
        CPLLLOCK                        =>      tied_to_vcc_i,
        TXRESETDONE                     =>      gt10_txresetdone_i,
        MMCM_LOCK                       =>      tied_to_vcc_i,
        GTTXRESET                       =>      gt10_gttxreset_t,
        MMCM_RESET                      =>      open,
        QPLL_RESET                      =>      open,
        CPLL_RESET                      =>      open,
        TX_FSM_RESET_DONE               =>      GT10_TX_FSM_RESET_DONE_OUT,
        TXUSERRDY                       =>      gt10_txuserrdy_t,
        RUN_PHALIGNMENT                 =>      open,
        RESET_PHALIGNMENT               =>      open,
        PHALIGNMENT_DONE                =>      tied_to_vcc_i,
        RETRY_COUNTER                   =>      open
           );


gt11_txresetfsm_i:  AMC_GTX_TX_STARTUP_FSM 

  generic map(
           GT_TYPE                  => "GTX", --GTX or GTH or GTP
           STABLE_CLOCK_PERIOD      => STABLE_CLOCK_PERIOD,           -- Period of the stable clock driving this state-machine, unit is [ns]
           RETRY_COUNTER_BITWIDTH   => 8, 
           TX_QPLL_USED             => TRUE ,                        -- the TX and RX Reset FSMs must 
           RX_QPLL_USED             => TRUE,                         -- share these two generic values
           PHASE_ALIGNMENT_MANUAL   => FALSE                 -- Decision if a manual phase-alignment is necessary or the automatic 
                                                                     -- is enough. For single-lane applications the automatic alignment is 
                                                                     -- sufficient              
             )     
    port map ( 
        STABLE_CLOCK                    =>      SYSCLK_IN,
        TXUSERCLK                       =>      GT11_TXUSRCLK_IN,
        SOFT_RESET                      =>      SOFT_RESET_IN,
        QPLLREFCLKLOST                  =>      gt2_qpllrefclklost_i,
        CPLLREFCLKLOST                  =>      tied_to_ground_i,
        QPLLLOCK                        =>      gt2_qplllock_i,
        CPLLLOCK                        =>      tied_to_vcc_i,
        TXRESETDONE                     =>      gt11_txresetdone_i,
        MMCM_LOCK                       =>      tied_to_vcc_i,
        GTTXRESET                       =>      gt11_gttxreset_t,
        MMCM_RESET                      =>      open,
        QPLL_RESET                      =>      open,
        CPLL_RESET                      =>      open,
        TX_FSM_RESET_DONE               =>      GT11_TX_FSM_RESET_DONE_OUT,
        TXUSERRDY                       =>      gt11_txuserrdy_t,
        RUN_PHALIGNMENT                 =>      open,
        RESET_PHALIGNMENT               =>      open,
        PHALIGNMENT_DONE                =>      tied_to_vcc_i,
        RETRY_COUNTER                   =>      open
           );






gt0_rxresetfsm_i:  AMC_GTX_RX_STARTUP_FSM 

  generic map(
           EXAMPLE_SIMULATION       => EXAMPLE_SIMULATION,
           GT_TYPE                  => "GTX", --GTX or GTH or GTP
           EQ_MODE                  => EQ_MODE,                        --Rx Equalization Mode - Set to DFE or LPM
           STABLE_CLOCK_PERIOD      => STABLE_CLOCK_PERIOD,           --Period of the stable clock driving this state-machine, unit is [ns]
           RETRY_COUNTER_BITWIDTH   => 8, 
           TX_QPLL_USED             => TRUE ,                        -- the TX and RX Reset FSMs must 
           RX_QPLL_USED             => TRUE,                         -- share these two generic values
           PHASE_ALIGNMENT_MANUAL   =>  FALSE                        -- Decision if a manual phase-alignment is necessary or the automatic 
                                                                     -- is enough. For single-lane applications the automatic alignment is 
                                                                     -- sufficient              
             )     
    port map ( 
        STABLE_CLOCK                    =>      SYSCLK_IN,
        RXUSERCLK                       =>      GT0_RXUSRCLK_IN,
        SOFT_RESET                      =>      SOFT_RESET_IN,
        QPLLREFCLKLOST                  =>      gt0_qpllrefclklost_i,
        CPLLREFCLKLOST                  =>      tied_to_ground_i,
        QPLLLOCK                        =>      gt0_qplllock_i,
        CPLLLOCK                        =>      tied_to_vcc_i,
        RXRESETDONE                     =>      gt0_rxresetdone_i,
        MMCM_LOCK                       =>      tied_to_vcc_i,
        RECCLK_STABLE                   =>      gt0_recclk_stable_i,
        RECCLK_MONITOR_RESTART          =>      tied_to_ground_i,
        DATA_VALID                      =>      GT0_DATA_VALID_IN,
        TXUSERRDY                       =>      gt0_txuserrdy_i,
        GTRXRESET                       =>      gt0_gtrxreset_t,
        MMCM_RESET                      =>      open,
        QPLL_RESET                      =>      open,
        CPLL_RESET                      =>      open,
        RX_FSM_RESET_DONE               =>      GT0_RX_FSM_RESET_DONE_OUT,
        RXUSERRDY                       =>      gt0_rxuserrdy_t,
        RUN_PHALIGNMENT                 =>      open,
        RESET_PHALIGNMENT               =>      open,
        PHALIGNMENT_DONE                =>      tied_to_vcc_i,
        RXDFELFHOLD                     =>      gt0_rxdfelfhold_i,
        RXLPMLFHOLD                     =>      gt0_rxlpmlfhold_i,
        RXLPMHFHOLD                     =>      gt0_rxlpmhfhold_i,
        RXDFEAGCHOLD                    =>      open,
        RETRY_COUNTER                   =>      open
           );

gt0_eq_dfe_mode: if EQ_MODE = "DFE" generate
gt0_adapt_top_dfe_i: AMC_GTX_ADAPT_TOP_DFE
  generic map (
              AGC_TIMER => DFE_ADAPT_LOCK_TIMER
              )
  port map (
            EN            => '1',
            CTLE3_COMP_EN => '1',
            GTRXRESET     => gt0_gtrxreset_i, --reset going to the GT, coming from either chipscope or TB
            RXPMARESET    => GT0_RXPMARESET_IN,--tied to ground, going to GT
            RXDFELPMRESET => gt0_rxdfelpmreset_i,--tied to ground, going to GT
            DCLK          => GT0_DRPCLK_IN,
            DO            => gt0_drpdo_int,
            DRDY          => gt0_drprdy_int,
            DADDR         => gt0_drpaddr_int,
            DI            => gt0_drpdi_int,
            DEN           => gt0_drpen_int,
            DWE           => gt0_drpwe_int,
            RXMONITOR     => gt0_rxmonitorout_o,
            RXMONITORSEL  => gt0_rxmonitorsel_i,
            AGCHOLD       => gt0_rxdfeagchold_i,
            KLHOLD        => open,
            KHHOLD        => open,
            DONE          => gt0_adapt_done,
            DEBUG         => open
           );
  
end generate gt0_eq_dfe_mode;               

gt0_eq_lpm_mode: if EQ_MODE = "LPM" generate
gt0_adapt_top_lpm_i: AMC_GTX_ADAPT_TOP_LPM
  generic map (
              TIMER => LPM_ADAPT_LOCK_TIMER
              )
  port map (
            EN            => '1',
            GTRXRESET     => gt0_gtrxreset_i, --reset going to the GT, coming from either chipscope or TB
            RXPMARESET    => GT0_RXPMARESET_IN,--tied to ground, going to GT
            RXDFELPMRESET => gt0_rxdfelpmreset_i,--tied to ground, going to GT
            DCLK          => GT0_DRPCLK_IN,
            DO            => gt0_drpdo_int,
            DRDY          => gt0_drprdy_int,
            DADDR         => gt0_drpaddr_int,
            DI            => gt0_drpdi_int,
            DEN           => gt0_drpen_int,
            DWE           => gt0_drpwe_int,
            KLHOLD        => open,
            KHHOLD        => open,
            DONE          => gt0_adapt_done,
            DEBUG         => open
           );
  
end generate gt0_eq_lpm_mode;               

   gt0_drpaddr_i <=  GT0_DRPADDR_IN when (gt0_adapt_done='1') else gt0_drpaddr_int;
   gt0_drpdi_i <= GT0_DRPDI_IN when (gt0_adapt_done='1') else gt0_drpdi_int;
   gt0_drpen_i <= GT0_DRPEN_IN when (gt0_adapt_done='1') else gt0_drpen_int;
   gt0_drpwe_i <= GT0_DRPWE_IN when (gt0_adapt_done='1') else gt0_drpwe_int;
   GT0_DRPDO_OUT <= gt0_drpdo_o when (gt0_adapt_done='1') else "0000000000000000";
   GT0_DRPRDY_OUT <= gt0_drprdy_o when (gt0_adapt_done='1') else '0';

   gt0_drpdo_int <= gt0_drpdo_o;
   gt0_drprdy_int <= gt0_drprdy_o;


gt1_rxresetfsm_i:  AMC_GTX_RX_STARTUP_FSM 

  generic map(
           EXAMPLE_SIMULATION       => EXAMPLE_SIMULATION,
           GT_TYPE                  => "GTX", --GTX or GTH or GTP
           EQ_MODE                  => EQ_MODE,                        --Rx Equalization Mode - Set to DFE or LPM
           STABLE_CLOCK_PERIOD      => STABLE_CLOCK_PERIOD,           --Period of the stable clock driving this state-machine, unit is [ns]
           RETRY_COUNTER_BITWIDTH   => 8, 
           TX_QPLL_USED             => TRUE ,                        -- the TX and RX Reset FSMs must 
           RX_QPLL_USED             => TRUE,                         -- share these two generic values
           PHASE_ALIGNMENT_MANUAL   =>  FALSE                        -- Decision if a manual phase-alignment is necessary or the automatic 
                                                                     -- is enough. For single-lane applications the automatic alignment is 
                                                                     -- sufficient              
             )     
    port map ( 
        STABLE_CLOCK                    =>      SYSCLK_IN,
        RXUSERCLK                       =>      GT1_RXUSRCLK_IN,
        SOFT_RESET                      =>      SOFT_RESET_IN,
        QPLLREFCLKLOST                  =>      gt0_qpllrefclklost_i,
        CPLLREFCLKLOST                  =>      tied_to_ground_i,
        QPLLLOCK                        =>      gt0_qplllock_i,
        CPLLLOCK                        =>      tied_to_vcc_i,
        RXRESETDONE                     =>      gt1_rxresetdone_i,
        MMCM_LOCK                       =>      tied_to_vcc_i,
        RECCLK_STABLE                   =>      gt1_recclk_stable_i,
        RECCLK_MONITOR_RESTART          =>      tied_to_ground_i,
        DATA_VALID                      =>      GT1_DATA_VALID_IN,
        TXUSERRDY                       =>      gt1_txuserrdy_i,
        GTRXRESET                       =>      gt1_gtrxreset_t,
        MMCM_RESET                      =>      open,
        QPLL_RESET                      =>      open,
        CPLL_RESET                      =>      open,
        RX_FSM_RESET_DONE               =>      GT1_RX_FSM_RESET_DONE_OUT,
        RXUSERRDY                       =>      gt1_rxuserrdy_t,
        RUN_PHALIGNMENT                 =>      open,
        RESET_PHALIGNMENT               =>      open,
        PHALIGNMENT_DONE                =>      tied_to_vcc_i,
        RXDFELFHOLD                     =>      gt1_rxdfelfhold_i,
        RXLPMLFHOLD                     =>      gt1_rxlpmlfhold_i,
        RXLPMHFHOLD                     =>      gt1_rxlpmhfhold_i,
        RXDFEAGCHOLD                    =>      open,
        RETRY_COUNTER                   =>      open
           );

gt1_eq_dfe_mode: if EQ_MODE = "DFE" generate
gt1_adapt_top_dfe_i: AMC_GTX_ADAPT_TOP_DFE
  generic map (
              AGC_TIMER => DFE_ADAPT_LOCK_TIMER
              )
  port map (
            EN            => '1',
            CTLE3_COMP_EN => '1',
            GTRXRESET     => gt1_gtrxreset_i, --reset going to the GT, coming from either chipscope or TB
            RXPMARESET    => GT1_RXPMARESET_IN,--tied to ground, going to GT
            RXDFELPMRESET => gt1_rxdfelpmreset_i,--tied to ground, going to GT
            DCLK          => GT1_DRPCLK_IN,
            DO            => gt1_drpdo_int,
            DRDY          => gt1_drprdy_int,
            DADDR         => gt1_drpaddr_int,
            DI            => gt1_drpdi_int,
            DEN           => gt1_drpen_int,
            DWE           => gt1_drpwe_int,
            RXMONITOR     => gt1_rxmonitorout_o,
            RXMONITORSEL  => gt1_rxmonitorsel_i,
            AGCHOLD       => gt1_rxdfeagchold_i,
            KLHOLD        => open,
            KHHOLD        => open,
            DONE          => gt1_adapt_done,
            DEBUG         => open
           );
  
end generate gt1_eq_dfe_mode;               

gt1_eq_lpm_mode: if EQ_MODE = "LPM" generate
gt1_adapt_top_lpm_i: AMC_GTX_ADAPT_TOP_LPM
  generic map (
              TIMER => LPM_ADAPT_LOCK_TIMER
              )
  port map (
            EN            => '1',
            GTRXRESET     => gt1_gtrxreset_i, --reset going to the GT, coming from either chipscope or TB
            RXPMARESET    => GT1_RXPMARESET_IN,--tied to ground, going to GT
            RXDFELPMRESET => gt1_rxdfelpmreset_i,--tied to ground, going to GT
            DCLK          => GT1_DRPCLK_IN,
            DO            => gt1_drpdo_int,
            DRDY          => gt1_drprdy_int,
            DADDR         => gt1_drpaddr_int,
            DI            => gt1_drpdi_int,
            DEN           => gt1_drpen_int,
            DWE           => gt1_drpwe_int,
            KLHOLD        => open,
            KHHOLD        => open,
            DONE          => gt1_adapt_done,
            DEBUG         => open
           );
  
end generate gt1_eq_lpm_mode;               

   gt1_drpaddr_i <=  GT1_DRPADDR_IN when (gt1_adapt_done='1') else gt1_drpaddr_int;
   gt1_drpdi_i <= GT1_DRPDI_IN when (gt1_adapt_done='1') else gt1_drpdi_int;
   gt1_drpen_i <= GT1_DRPEN_IN when (gt1_adapt_done='1') else gt1_drpen_int;
   gt1_drpwe_i <= GT1_DRPWE_IN when (gt1_adapt_done='1') else gt1_drpwe_int;
   GT1_DRPDO_OUT <= gt1_drpdo_o when (gt1_adapt_done='1') else "0000000000000000";
   GT1_DRPRDY_OUT <= gt1_drprdy_o when (gt1_adapt_done='1') else '0';

   gt1_drpdo_int <= gt1_drpdo_o;
   gt1_drprdy_int <= gt1_drprdy_o;


gt2_rxresetfsm_i:  AMC_GTX_RX_STARTUP_FSM 

  generic map(
           EXAMPLE_SIMULATION       => EXAMPLE_SIMULATION,
           GT_TYPE                  => "GTX", --GTX or GTH or GTP
           EQ_MODE                  => EQ_MODE,                        --Rx Equalization Mode - Set to DFE or LPM
           STABLE_CLOCK_PERIOD      => STABLE_CLOCK_PERIOD,           --Period of the stable clock driving this state-machine, unit is [ns]
           RETRY_COUNTER_BITWIDTH   => 8, 
           TX_QPLL_USED             => TRUE ,                        -- the TX and RX Reset FSMs must 
           RX_QPLL_USED             => TRUE,                         -- share these two generic values
           PHASE_ALIGNMENT_MANUAL   =>  FALSE                        -- Decision if a manual phase-alignment is necessary or the automatic 
                                                                     -- is enough. For single-lane applications the automatic alignment is 
                                                                     -- sufficient              
             )     
    port map ( 
        STABLE_CLOCK                    =>      SYSCLK_IN,
        RXUSERCLK                       =>      GT2_RXUSRCLK_IN,
        SOFT_RESET                      =>      SOFT_RESET_IN,
        QPLLREFCLKLOST                  =>      gt0_qpllrefclklost_i,
        CPLLREFCLKLOST                  =>      tied_to_ground_i,
        QPLLLOCK                        =>      gt0_qplllock_i,
        CPLLLOCK                        =>      tied_to_vcc_i,
        RXRESETDONE                     =>      gt2_rxresetdone_i,
        MMCM_LOCK                       =>      tied_to_vcc_i,
        RECCLK_STABLE                   =>      gt2_recclk_stable_i,
        RECCLK_MONITOR_RESTART          =>      tied_to_ground_i,
        DATA_VALID                      =>      GT2_DATA_VALID_IN,
        TXUSERRDY                       =>      gt2_txuserrdy_i,
        GTRXRESET                       =>      gt2_gtrxreset_t,
        MMCM_RESET                      =>      open,
        QPLL_RESET                      =>      open,
        CPLL_RESET                      =>      open,
        RX_FSM_RESET_DONE               =>      GT2_RX_FSM_RESET_DONE_OUT,
        RXUSERRDY                       =>      gt2_rxuserrdy_t,
        RUN_PHALIGNMENT                 =>      open,
        RESET_PHALIGNMENT               =>      open,
        PHALIGNMENT_DONE                =>      tied_to_vcc_i,
        RXDFELFHOLD                     =>      gt2_rxdfelfhold_i,
        RXLPMLFHOLD                     =>      gt2_rxlpmlfhold_i,
        RXLPMHFHOLD                     =>      gt2_rxlpmhfhold_i,
        RXDFEAGCHOLD                    =>      open,
        RETRY_COUNTER                   =>      open
           );

gt2_eq_dfe_mode: if EQ_MODE = "DFE" generate
gt2_adapt_top_dfe_i: AMC_GTX_ADAPT_TOP_DFE
  generic map (
              AGC_TIMER => DFE_ADAPT_LOCK_TIMER
              )
  port map (
            EN            => '1',
            CTLE3_COMP_EN => '1',
            GTRXRESET     => gt2_gtrxreset_i, --reset going to the GT, coming from either chipscope or TB
            RXPMARESET    => GT2_RXPMARESET_IN,--tied to ground, going to GT
            RXDFELPMRESET => gt2_rxdfelpmreset_i,--tied to ground, going to GT
            DCLK          => GT2_DRPCLK_IN,
            DO            => gt2_drpdo_int,
            DRDY          => gt2_drprdy_int,
            DADDR         => gt2_drpaddr_int,
            DI            => gt2_drpdi_int,
            DEN           => gt2_drpen_int,
            DWE           => gt2_drpwe_int,
            RXMONITOR     => gt2_rxmonitorout_o,
            RXMONITORSEL  => gt2_rxmonitorsel_i,
            AGCHOLD       => gt2_rxdfeagchold_i,
            KLHOLD        => open,
            KHHOLD        => open,
            DONE          => gt2_adapt_done,
            DEBUG         => open
           );
  
end generate gt2_eq_dfe_mode;               

gt2_eq_lpm_mode: if EQ_MODE = "LPM" generate
gt2_adapt_top_lpm_i: AMC_GTX_ADAPT_TOP_LPM
  generic map (
              TIMER => LPM_ADAPT_LOCK_TIMER
              )
  port map (
            EN            => '1',
            GTRXRESET     => gt2_gtrxreset_i, --reset going to the GT, coming from either chipscope or TB
            RXPMARESET    => GT2_RXPMARESET_IN,--tied to ground, going to GT
            RXDFELPMRESET => gt2_rxdfelpmreset_i,--tied to ground, going to GT
            DCLK          => GT2_DRPCLK_IN,
            DO            => gt2_drpdo_int,
            DRDY          => gt2_drprdy_int,
            DADDR         => gt2_drpaddr_int,
            DI            => gt2_drpdi_int,
            DEN           => gt2_drpen_int,
            DWE           => gt2_drpwe_int,
            KLHOLD        => open,
            KHHOLD        => open,
            DONE          => gt2_adapt_done,
            DEBUG         => open
           );
  
end generate gt2_eq_lpm_mode;               

   gt2_drpaddr_i <=  GT2_DRPADDR_IN when (gt2_adapt_done='1') else gt2_drpaddr_int;
   gt2_drpdi_i <= GT2_DRPDI_IN when (gt2_adapt_done='1') else gt2_drpdi_int;
   gt2_drpen_i <= GT2_DRPEN_IN when (gt2_adapt_done='1') else gt2_drpen_int;
   gt2_drpwe_i <= GT2_DRPWE_IN when (gt2_adapt_done='1') else gt2_drpwe_int;
   GT2_DRPDO_OUT <= gt2_drpdo_o when (gt2_adapt_done='1') else "0000000000000000";
   GT2_DRPRDY_OUT <= gt2_drprdy_o when (gt2_adapt_done='1') else '0';

   gt2_drpdo_int <= gt2_drpdo_o;
   gt2_drprdy_int <= gt2_drprdy_o;


gt3_rxresetfsm_i:  AMC_GTX_RX_STARTUP_FSM 

  generic map(
           EXAMPLE_SIMULATION       => EXAMPLE_SIMULATION,
           GT_TYPE                  => "GTX", --GTX or GTH or GTP
           EQ_MODE                  => EQ_MODE,                        --Rx Equalization Mode - Set to DFE or LPM
           STABLE_CLOCK_PERIOD      => STABLE_CLOCK_PERIOD,           --Period of the stable clock driving this state-machine, unit is [ns]
           RETRY_COUNTER_BITWIDTH   => 8, 
           TX_QPLL_USED             => TRUE ,                        -- the TX and RX Reset FSMs must 
           RX_QPLL_USED             => TRUE,                         -- share these two generic values
           PHASE_ALIGNMENT_MANUAL   =>  FALSE                        -- Decision if a manual phase-alignment is necessary or the automatic 
                                                                     -- is enough. For single-lane applications the automatic alignment is 
                                                                     -- sufficient              
             )     
    port map ( 
        STABLE_CLOCK                    =>      SYSCLK_IN,
        RXUSERCLK                       =>      GT3_RXUSRCLK_IN,
        SOFT_RESET                      =>      SOFT_RESET_IN,
        QPLLREFCLKLOST                  =>      gt0_qpllrefclklost_i,
        CPLLREFCLKLOST                  =>      tied_to_ground_i,
        QPLLLOCK                        =>      gt0_qplllock_i,
        CPLLLOCK                        =>      tied_to_vcc_i,
        RXRESETDONE                     =>      gt3_rxresetdone_i,
        MMCM_LOCK                       =>      tied_to_vcc_i,
        RECCLK_STABLE                   =>      gt3_recclk_stable_i,
        RECCLK_MONITOR_RESTART          =>      tied_to_ground_i,
        DATA_VALID                      =>      GT3_DATA_VALID_IN,
        TXUSERRDY                       =>      gt3_txuserrdy_i,
        GTRXRESET                       =>      gt3_gtrxreset_t,
        MMCM_RESET                      =>      open,
        QPLL_RESET                      =>      open,
        CPLL_RESET                      =>      open,
        RX_FSM_RESET_DONE               =>      GT3_RX_FSM_RESET_DONE_OUT,
        RXUSERRDY                       =>      gt3_rxuserrdy_t,
        RUN_PHALIGNMENT                 =>      open,
        RESET_PHALIGNMENT               =>      open,
        PHALIGNMENT_DONE                =>      tied_to_vcc_i,
        RXDFELFHOLD                     =>      gt3_rxdfelfhold_i,
        RXLPMLFHOLD                     =>      gt3_rxlpmlfhold_i,
        RXLPMHFHOLD                     =>      gt3_rxlpmhfhold_i,
        RXDFEAGCHOLD                    =>      open,
        RETRY_COUNTER                   =>      open
           );

gt3_eq_dfe_mode: if EQ_MODE = "DFE" generate
gt3_adapt_top_dfe_i: AMC_GTX_ADAPT_TOP_DFE
  generic map (
              AGC_TIMER => DFE_ADAPT_LOCK_TIMER
              )
  port map (
            EN            => '1',
            CTLE3_COMP_EN => '1',
            GTRXRESET     => gt3_gtrxreset_i, --reset going to the GT, coming from either chipscope or TB
            RXPMARESET    => GT3_RXPMARESET_IN,--tied to ground, going to GT
            RXDFELPMRESET => gt3_rxdfelpmreset_i,--tied to ground, going to GT
            DCLK          => GT3_DRPCLK_IN,
            DO            => gt3_drpdo_int,
            DRDY          => gt3_drprdy_int,
            DADDR         => gt3_drpaddr_int,
            DI            => gt3_drpdi_int,
            DEN           => gt3_drpen_int,
            DWE           => gt3_drpwe_int,
            RXMONITOR     => gt3_rxmonitorout_o,
            RXMONITORSEL  => gt3_rxmonitorsel_i,
            AGCHOLD       => gt3_rxdfeagchold_i,
            KLHOLD        => open,
            KHHOLD        => open,
            DONE          => gt3_adapt_done,
            DEBUG         => open
           );
  
end generate gt3_eq_dfe_mode;               

gt3_eq_lpm_mode: if EQ_MODE = "LPM" generate
gt3_adapt_top_lpm_i: AMC_GTX_ADAPT_TOP_LPM
  generic map (
              TIMER => LPM_ADAPT_LOCK_TIMER
              )
  port map (
            EN            => '1',
            GTRXRESET     => gt3_gtrxreset_i, --reset going to the GT, coming from either chipscope or TB
            RXPMARESET    => GT3_RXPMARESET_IN,--tied to ground, going to GT
            RXDFELPMRESET => gt3_rxdfelpmreset_i,--tied to ground, going to GT
            DCLK          => GT3_DRPCLK_IN,
            DO            => gt3_drpdo_int,
            DRDY          => gt3_drprdy_int,
            DADDR         => gt3_drpaddr_int,
            DI            => gt3_drpdi_int,
            DEN           => gt3_drpen_int,
            DWE           => gt3_drpwe_int,
            KLHOLD        => open,
            KHHOLD        => open,
            DONE          => gt3_adapt_done,
            DEBUG         => open
           );
  
end generate gt3_eq_lpm_mode;               

   gt3_drpaddr_i <=  GT3_DRPADDR_IN when (gt3_adapt_done='1') else gt3_drpaddr_int;
   gt3_drpdi_i <= GT3_DRPDI_IN when (gt3_adapt_done='1') else gt3_drpdi_int;
   gt3_drpen_i <= GT3_DRPEN_IN when (gt3_adapt_done='1') else gt3_drpen_int;
   gt3_drpwe_i <= GT3_DRPWE_IN when (gt3_adapt_done='1') else gt3_drpwe_int;
   GT3_DRPDO_OUT <= gt3_drpdo_o when (gt3_adapt_done='1') else "0000000000000000";
   GT3_DRPRDY_OUT <= gt3_drprdy_o when (gt3_adapt_done='1') else '0';

   gt3_drpdo_int <= gt3_drpdo_o;
   gt3_drprdy_int <= gt3_drprdy_o;


gt4_rxresetfsm_i:  AMC_GTX_RX_STARTUP_FSM 

  generic map(
           EXAMPLE_SIMULATION       => EXAMPLE_SIMULATION,
           GT_TYPE                  => "GTX", --GTX or GTH or GTP
           EQ_MODE                  => EQ_MODE,                        --Rx Equalization Mode - Set to DFE or LPM
           STABLE_CLOCK_PERIOD      => STABLE_CLOCK_PERIOD,           --Period of the stable clock driving this state-machine, unit is [ns]
           RETRY_COUNTER_BITWIDTH   => 8, 
           TX_QPLL_USED             => TRUE ,                        -- the TX and RX Reset FSMs must 
           RX_QPLL_USED             => TRUE,                         -- share these two generic values
           PHASE_ALIGNMENT_MANUAL   =>  FALSE                        -- Decision if a manual phase-alignment is necessary or the automatic 
                                                                     -- is enough. For single-lane applications the automatic alignment is 
                                                                     -- sufficient              
             )     
    port map ( 
        STABLE_CLOCK                    =>      SYSCLK_IN,
        RXUSERCLK                       =>      GT4_RXUSRCLK_IN,
        SOFT_RESET                      =>      SOFT_RESET_IN,
        QPLLREFCLKLOST                  =>      gt1_qpllrefclklost_i,
        CPLLREFCLKLOST                  =>      tied_to_ground_i,
        QPLLLOCK                        =>      gt1_qplllock_i,
        CPLLLOCK                        =>      tied_to_vcc_i,
        RXRESETDONE                     =>      gt4_rxresetdone_i,
        MMCM_LOCK                       =>      tied_to_vcc_i,
        RECCLK_STABLE                   =>      gt4_recclk_stable_i,
        RECCLK_MONITOR_RESTART          =>      tied_to_ground_i,
        DATA_VALID                      =>      GT4_DATA_VALID_IN,
        TXUSERRDY                       =>      gt4_txuserrdy_i,
        GTRXRESET                       =>      gt4_gtrxreset_t,
        MMCM_RESET                      =>      open,
        QPLL_RESET                      =>      open,
        CPLL_RESET                      =>      open,
        RX_FSM_RESET_DONE               =>      GT4_RX_FSM_RESET_DONE_OUT,
        RXUSERRDY                       =>      gt4_rxuserrdy_t,
        RUN_PHALIGNMENT                 =>      open,
        RESET_PHALIGNMENT               =>      open,
        PHALIGNMENT_DONE                =>      tied_to_vcc_i,
        RXDFELFHOLD                     =>      gt4_rxdfelfhold_i,
        RXLPMLFHOLD                     =>      gt4_rxlpmlfhold_i,
        RXLPMHFHOLD                     =>      gt4_rxlpmhfhold_i,
        RXDFEAGCHOLD                    =>      open,
        RETRY_COUNTER                   =>      open
           );

gt4_eq_dfe_mode: if EQ_MODE = "DFE" generate
gt4_adapt_top_dfe_i: AMC_GTX_ADAPT_TOP_DFE
  generic map (
              AGC_TIMER => DFE_ADAPT_LOCK_TIMER
              )
  port map (
            EN            => '1',
            CTLE3_COMP_EN => '1',
            GTRXRESET     => gt4_gtrxreset_i, --reset going to the GT, coming from either chipscope or TB
            RXPMARESET    => GT4_RXPMARESET_IN,--tied to ground, going to GT
            RXDFELPMRESET => gt4_rxdfelpmreset_i,--tied to ground, going to GT
            DCLK          => GT4_DRPCLK_IN,
            DO            => gt4_drpdo_int,
            DRDY          => gt4_drprdy_int,
            DADDR         => gt4_drpaddr_int,
            DI            => gt4_drpdi_int,
            DEN           => gt4_drpen_int,
            DWE           => gt4_drpwe_int,
            RXMONITOR     => gt4_rxmonitorout_o,
            RXMONITORSEL  => gt4_rxmonitorsel_i,
            AGCHOLD       => gt4_rxdfeagchold_i,
            KLHOLD        => open,
            KHHOLD        => open,
            DONE          => gt4_adapt_done,
            DEBUG         => open
           );
  
end generate gt4_eq_dfe_mode;               

gt4_eq_lpm_mode: if EQ_MODE = "LPM" generate
gt4_adapt_top_lpm_i: AMC_GTX_ADAPT_TOP_LPM
  generic map (
              TIMER => LPM_ADAPT_LOCK_TIMER
              )
  port map (
            EN            => '1',
            GTRXRESET     => gt4_gtrxreset_i, --reset going to the GT, coming from either chipscope or TB
            RXPMARESET    => GT4_RXPMARESET_IN,--tied to ground, going to GT
            RXDFELPMRESET => gt4_rxdfelpmreset_i,--tied to ground, going to GT
            DCLK          => GT4_DRPCLK_IN,
            DO            => gt4_drpdo_int,
            DRDY          => gt4_drprdy_int,
            DADDR         => gt4_drpaddr_int,
            DI            => gt4_drpdi_int,
            DEN           => gt4_drpen_int,
            DWE           => gt4_drpwe_int,
            KLHOLD        => open,
            KHHOLD        => open,
            DONE          => gt4_adapt_done,
            DEBUG         => open
           );
  
end generate gt4_eq_lpm_mode;               

   gt4_drpaddr_i <=  GT4_DRPADDR_IN when (gt4_adapt_done='1') else gt4_drpaddr_int;
   gt4_drpdi_i <= GT4_DRPDI_IN when (gt4_adapt_done='1') else gt4_drpdi_int;
   gt4_drpen_i <= GT4_DRPEN_IN when (gt4_adapt_done='1') else gt4_drpen_int;
   gt4_drpwe_i <= GT4_DRPWE_IN when (gt4_adapt_done='1') else gt4_drpwe_int;
   GT4_DRPDO_OUT <= gt4_drpdo_o when (gt4_adapt_done='1') else "0000000000000000";
   GT4_DRPRDY_OUT <= gt4_drprdy_o when (gt4_adapt_done='1') else '0';

   gt4_drpdo_int <= gt4_drpdo_o;
   gt4_drprdy_int <= gt4_drprdy_o;


gt5_rxresetfsm_i:  AMC_GTX_RX_STARTUP_FSM 

  generic map(
           EXAMPLE_SIMULATION       => EXAMPLE_SIMULATION,
           GT_TYPE                  => "GTX", --GTX or GTH or GTP
           EQ_MODE                  => EQ_MODE,                        --Rx Equalization Mode - Set to DFE or LPM
           STABLE_CLOCK_PERIOD      => STABLE_CLOCK_PERIOD,           --Period of the stable clock driving this state-machine, unit is [ns]
           RETRY_COUNTER_BITWIDTH   => 8, 
           TX_QPLL_USED             => TRUE ,                        -- the TX and RX Reset FSMs must 
           RX_QPLL_USED             => TRUE,                         -- share these two generic values
           PHASE_ALIGNMENT_MANUAL   =>  FALSE                        -- Decision if a manual phase-alignment is necessary or the automatic 
                                                                     -- is enough. For single-lane applications the automatic alignment is 
                                                                     -- sufficient              
             )     
    port map ( 
        STABLE_CLOCK                    =>      SYSCLK_IN,
        RXUSERCLK                       =>      GT5_RXUSRCLK_IN,
        SOFT_RESET                      =>      SOFT_RESET_IN,
        QPLLREFCLKLOST                  =>      gt1_qpllrefclklost_i,
        CPLLREFCLKLOST                  =>      tied_to_ground_i,
        QPLLLOCK                        =>      gt1_qplllock_i,
        CPLLLOCK                        =>      tied_to_vcc_i,
        RXRESETDONE                     =>      gt5_rxresetdone_i,
        MMCM_LOCK                       =>      tied_to_vcc_i,
        RECCLK_STABLE                   =>      gt5_recclk_stable_i,
        RECCLK_MONITOR_RESTART          =>      tied_to_ground_i,
        DATA_VALID                      =>      GT5_DATA_VALID_IN,
        TXUSERRDY                       =>      gt5_txuserrdy_i,
        GTRXRESET                       =>      gt5_gtrxreset_t,
        MMCM_RESET                      =>      open,
        QPLL_RESET                      =>      open,
        CPLL_RESET                      =>      open,
        RX_FSM_RESET_DONE               =>      GT5_RX_FSM_RESET_DONE_OUT,
        RXUSERRDY                       =>      gt5_rxuserrdy_t,
        RUN_PHALIGNMENT                 =>      open,
        RESET_PHALIGNMENT               =>      open,
        PHALIGNMENT_DONE                =>      tied_to_vcc_i,
        RXDFELFHOLD                     =>      gt5_rxdfelfhold_i,
        RXLPMLFHOLD                     =>      gt5_rxlpmlfhold_i,
        RXLPMHFHOLD                     =>      gt5_rxlpmhfhold_i,
        RXDFEAGCHOLD                    =>      open,
        RETRY_COUNTER                   =>      open
           );

gt5_eq_dfe_mode: if EQ_MODE = "DFE" generate
gt5_adapt_top_dfe_i: AMC_GTX_ADAPT_TOP_DFE
  generic map (
              AGC_TIMER => DFE_ADAPT_LOCK_TIMER
              )
  port map (
            EN            => '1',
            CTLE3_COMP_EN => '1',
            GTRXRESET     => gt5_gtrxreset_i, --reset going to the GT, coming from either chipscope or TB
            RXPMARESET    => GT5_RXPMARESET_IN,--tied to ground, going to GT
            RXDFELPMRESET => gt5_rxdfelpmreset_i,--tied to ground, going to GT
            DCLK          => GT5_DRPCLK_IN,
            DO            => gt5_drpdo_int,
            DRDY          => gt5_drprdy_int,
            DADDR         => gt5_drpaddr_int,
            DI            => gt5_drpdi_int,
            DEN           => gt5_drpen_int,
            DWE           => gt5_drpwe_int,
            RXMONITOR     => gt5_rxmonitorout_o,
            RXMONITORSEL  => gt5_rxmonitorsel_i,
            AGCHOLD       => gt5_rxdfeagchold_i,
            KLHOLD        => open,
            KHHOLD        => open,
            DONE          => gt5_adapt_done,
            DEBUG         => open
           );
  
end generate gt5_eq_dfe_mode;               

gt5_eq_lpm_mode: if EQ_MODE = "LPM" generate
gt5_adapt_top_lpm_i: AMC_GTX_ADAPT_TOP_LPM
  generic map (
              TIMER => LPM_ADAPT_LOCK_TIMER
              )
  port map (
            EN            => '1',
            GTRXRESET     => gt5_gtrxreset_i, --reset going to the GT, coming from either chipscope or TB
            RXPMARESET    => GT5_RXPMARESET_IN,--tied to ground, going to GT
            RXDFELPMRESET => gt5_rxdfelpmreset_i,--tied to ground, going to GT
            DCLK          => GT5_DRPCLK_IN,
            DO            => gt5_drpdo_int,
            DRDY          => gt5_drprdy_int,
            DADDR         => gt5_drpaddr_int,
            DI            => gt5_drpdi_int,
            DEN           => gt5_drpen_int,
            DWE           => gt5_drpwe_int,
            KLHOLD        => open,
            KHHOLD        => open,
            DONE          => gt5_adapt_done,
            DEBUG         => open
           );
  
end generate gt5_eq_lpm_mode;               

   gt5_drpaddr_i <=  GT5_DRPADDR_IN when (gt5_adapt_done='1') else gt5_drpaddr_int;
   gt5_drpdi_i <= GT5_DRPDI_IN when (gt5_adapt_done='1') else gt5_drpdi_int;
   gt5_drpen_i <= GT5_DRPEN_IN when (gt5_adapt_done='1') else gt5_drpen_int;
   gt5_drpwe_i <= GT5_DRPWE_IN when (gt5_adapt_done='1') else gt5_drpwe_int;
   GT5_DRPDO_OUT <= gt5_drpdo_o when (gt5_adapt_done='1') else "0000000000000000";
   GT5_DRPRDY_OUT <= gt5_drprdy_o when (gt5_adapt_done='1') else '0';

   gt5_drpdo_int <= gt5_drpdo_o;
   gt5_drprdy_int <= gt5_drprdy_o;


gt6_rxresetfsm_i:  AMC_GTX_RX_STARTUP_FSM 

  generic map(
           EXAMPLE_SIMULATION       => EXAMPLE_SIMULATION,
           GT_TYPE                  => "GTX", --GTX or GTH or GTP
           EQ_MODE                  => EQ_MODE,                        --Rx Equalization Mode - Set to DFE or LPM
           STABLE_CLOCK_PERIOD      => STABLE_CLOCK_PERIOD,           --Period of the stable clock driving this state-machine, unit is [ns]
           RETRY_COUNTER_BITWIDTH   => 8, 
           TX_QPLL_USED             => TRUE ,                        -- the TX and RX Reset FSMs must 
           RX_QPLL_USED             => TRUE,                         -- share these two generic values
           PHASE_ALIGNMENT_MANUAL   =>  FALSE                        -- Decision if a manual phase-alignment is necessary or the automatic 
                                                                     -- is enough. For single-lane applications the automatic alignment is 
                                                                     -- sufficient              
             )     
    port map ( 
        STABLE_CLOCK                    =>      SYSCLK_IN,
        RXUSERCLK                       =>      GT6_RXUSRCLK_IN,
        SOFT_RESET                      =>      SOFT_RESET_IN,
        QPLLREFCLKLOST                  =>      gt1_qpllrefclklost_i,
        CPLLREFCLKLOST                  =>      tied_to_ground_i,
        QPLLLOCK                        =>      gt1_qplllock_i,
        CPLLLOCK                        =>      tied_to_vcc_i,
        RXRESETDONE                     =>      gt6_rxresetdone_i,
        MMCM_LOCK                       =>      tied_to_vcc_i,
        RECCLK_STABLE                   =>      gt6_recclk_stable_i,
        RECCLK_MONITOR_RESTART          =>      tied_to_ground_i,
        DATA_VALID                      =>      GT6_DATA_VALID_IN,
        TXUSERRDY                       =>      gt6_txuserrdy_i,
        GTRXRESET                       =>      gt6_gtrxreset_t,
        MMCM_RESET                      =>      open,
        QPLL_RESET                      =>      open,
        CPLL_RESET                      =>      open,
        RX_FSM_RESET_DONE               =>      GT6_RX_FSM_RESET_DONE_OUT,
        RXUSERRDY                       =>      gt6_rxuserrdy_t,
        RUN_PHALIGNMENT                 =>      open,
        RESET_PHALIGNMENT               =>      open,
        PHALIGNMENT_DONE                =>      tied_to_vcc_i,
        RXDFELFHOLD                     =>      gt6_rxdfelfhold_i,
        RXLPMLFHOLD                     =>      gt6_rxlpmlfhold_i,
        RXLPMHFHOLD                     =>      gt6_rxlpmhfhold_i,
        RXDFEAGCHOLD                    =>      open,
        RETRY_COUNTER                   =>      open
           );

gt6_eq_dfe_mode: if EQ_MODE = "DFE" generate
gt6_adapt_top_dfe_i: AMC_GTX_ADAPT_TOP_DFE
  generic map (
              AGC_TIMER => DFE_ADAPT_LOCK_TIMER
              )
  port map (
            EN            => '1',
            CTLE3_COMP_EN => '1',
            GTRXRESET     => gt6_gtrxreset_i, --reset going to the GT, coming from either chipscope or TB
            RXPMARESET    => GT6_RXPMARESET_IN,--tied to ground, going to GT
            RXDFELPMRESET => gt6_rxdfelpmreset_i,--tied to ground, going to GT
            DCLK          => GT6_DRPCLK_IN,
            DO            => gt6_drpdo_int,
            DRDY          => gt6_drprdy_int,
            DADDR         => gt6_drpaddr_int,
            DI            => gt6_drpdi_int,
            DEN           => gt6_drpen_int,
            DWE           => gt6_drpwe_int,
            RXMONITOR     => gt6_rxmonitorout_o,
            RXMONITORSEL  => gt6_rxmonitorsel_i,
            AGCHOLD       => gt6_rxdfeagchold_i,
            KLHOLD        => open,
            KHHOLD        => open,
            DONE          => gt6_adapt_done,
            DEBUG         => open
           );
  
end generate gt6_eq_dfe_mode;               

gt6_eq_lpm_mode: if EQ_MODE = "LPM" generate
gt6_adapt_top_lpm_i: AMC_GTX_ADAPT_TOP_LPM
  generic map (
              TIMER => LPM_ADAPT_LOCK_TIMER
              )
  port map (
            EN            => '1',
            GTRXRESET     => gt6_gtrxreset_i, --reset going to the GT, coming from either chipscope or TB
            RXPMARESET    => GT6_RXPMARESET_IN,--tied to ground, going to GT
            RXDFELPMRESET => gt6_rxdfelpmreset_i,--tied to ground, going to GT
            DCLK          => GT6_DRPCLK_IN,
            DO            => gt6_drpdo_int,
            DRDY          => gt6_drprdy_int,
            DADDR         => gt6_drpaddr_int,
            DI            => gt6_drpdi_int,
            DEN           => gt6_drpen_int,
            DWE           => gt6_drpwe_int,
            KLHOLD        => open,
            KHHOLD        => open,
            DONE          => gt6_adapt_done,
            DEBUG         => open
           );
  
end generate gt6_eq_lpm_mode;               

   gt6_drpaddr_i <=  GT6_DRPADDR_IN when (gt6_adapt_done='1') else gt6_drpaddr_int;
   gt6_drpdi_i <= GT6_DRPDI_IN when (gt6_adapt_done='1') else gt6_drpdi_int;
   gt6_drpen_i <= GT6_DRPEN_IN when (gt6_adapt_done='1') else gt6_drpen_int;
   gt6_drpwe_i <= GT6_DRPWE_IN when (gt6_adapt_done='1') else gt6_drpwe_int;
   GT6_DRPDO_OUT <= gt6_drpdo_o when (gt6_adapt_done='1') else "0000000000000000";
   GT6_DRPRDY_OUT <= gt6_drprdy_o when (gt6_adapt_done='1') else '0';

   gt6_drpdo_int <= gt6_drpdo_o;
   gt6_drprdy_int <= gt6_drprdy_o;


gt7_rxresetfsm_i:  AMC_GTX_RX_STARTUP_FSM 

  generic map(
           EXAMPLE_SIMULATION       => EXAMPLE_SIMULATION,
           GT_TYPE                  => "GTX", --GTX or GTH or GTP
           EQ_MODE                  => EQ_MODE,                        --Rx Equalization Mode - Set to DFE or LPM
           STABLE_CLOCK_PERIOD      => STABLE_CLOCK_PERIOD,           --Period of the stable clock driving this state-machine, unit is [ns]
           RETRY_COUNTER_BITWIDTH   => 8, 
           TX_QPLL_USED             => TRUE ,                        -- the TX and RX Reset FSMs must 
           RX_QPLL_USED             => TRUE,                         -- share these two generic values
           PHASE_ALIGNMENT_MANUAL   =>  FALSE                        -- Decision if a manual phase-alignment is necessary or the automatic 
                                                                     -- is enough. For single-lane applications the automatic alignment is 
                                                                     -- sufficient              
             )     
    port map ( 
        STABLE_CLOCK                    =>      SYSCLK_IN,
        RXUSERCLK                       =>      GT7_RXUSRCLK_IN,
        SOFT_RESET                      =>      SOFT_RESET_IN,
        QPLLREFCLKLOST                  =>      gt1_qpllrefclklost_i,
        CPLLREFCLKLOST                  =>      tied_to_ground_i,
        QPLLLOCK                        =>      gt1_qplllock_i,
        CPLLLOCK                        =>      tied_to_vcc_i,
        RXRESETDONE                     =>      gt7_rxresetdone_i,
        MMCM_LOCK                       =>      tied_to_vcc_i,
        RECCLK_STABLE                   =>      gt7_recclk_stable_i,
        RECCLK_MONITOR_RESTART          =>      tied_to_ground_i,
        DATA_VALID                      =>      GT7_DATA_VALID_IN,
        TXUSERRDY                       =>      gt7_txuserrdy_i,
        GTRXRESET                       =>      gt7_gtrxreset_t,
        MMCM_RESET                      =>      open,
        QPLL_RESET                      =>      open,
        CPLL_RESET                      =>      open,
        RX_FSM_RESET_DONE               =>      GT7_RX_FSM_RESET_DONE_OUT,
        RXUSERRDY                       =>      gt7_rxuserrdy_t,
        RUN_PHALIGNMENT                 =>      open,
        RESET_PHALIGNMENT               =>      open,
        PHALIGNMENT_DONE                =>      tied_to_vcc_i,
        RXDFELFHOLD                     =>      gt7_rxdfelfhold_i,
        RXLPMLFHOLD                     =>      gt7_rxlpmlfhold_i,
        RXLPMHFHOLD                     =>      gt7_rxlpmhfhold_i,
        RXDFEAGCHOLD                    =>      open,
        RETRY_COUNTER                   =>      open
           );

gt7_eq_dfe_mode: if EQ_MODE = "DFE" generate
gt7_adapt_top_dfe_i: AMC_GTX_ADAPT_TOP_DFE
  generic map (
              AGC_TIMER => DFE_ADAPT_LOCK_TIMER
              )
  port map (
            EN            => '1',
            CTLE3_COMP_EN => '1',
            GTRXRESET     => gt7_gtrxreset_i, --reset going to the GT, coming from either chipscope or TB
            RXPMARESET    => GT7_RXPMARESET_IN,--tied to ground, going to GT
            RXDFELPMRESET => gt7_rxdfelpmreset_i,--tied to ground, going to GT
            DCLK          => GT7_DRPCLK_IN,
            DO            => gt7_drpdo_int,
            DRDY          => gt7_drprdy_int,
            DADDR         => gt7_drpaddr_int,
            DI            => gt7_drpdi_int,
            DEN           => gt7_drpen_int,
            DWE           => gt7_drpwe_int,
            RXMONITOR     => gt7_rxmonitorout_o,
            RXMONITORSEL  => gt7_rxmonitorsel_i,
            AGCHOLD       => gt7_rxdfeagchold_i,
            KLHOLD        => open,
            KHHOLD        => open,
            DONE          => gt7_adapt_done,
            DEBUG         => open
           );
  
end generate gt7_eq_dfe_mode;               

gt7_eq_lpm_mode: if EQ_MODE = "LPM" generate
gt7_adapt_top_lpm_i: AMC_GTX_ADAPT_TOP_LPM
  generic map (
              TIMER => LPM_ADAPT_LOCK_TIMER
              )
  port map (
            EN            => '1',
            GTRXRESET     => gt7_gtrxreset_i, --reset going to the GT, coming from either chipscope or TB
            RXPMARESET    => GT7_RXPMARESET_IN,--tied to ground, going to GT
            RXDFELPMRESET => gt7_rxdfelpmreset_i,--tied to ground, going to GT
            DCLK          => GT7_DRPCLK_IN,
            DO            => gt7_drpdo_int,
            DRDY          => gt7_drprdy_int,
            DADDR         => gt7_drpaddr_int,
            DI            => gt7_drpdi_int,
            DEN           => gt7_drpen_int,
            DWE           => gt7_drpwe_int,
            KLHOLD        => open,
            KHHOLD        => open,
            DONE          => gt7_adapt_done,
            DEBUG         => open
           );
  
end generate gt7_eq_lpm_mode;               

   gt7_drpaddr_i <=  GT7_DRPADDR_IN when (gt7_adapt_done='1') else gt7_drpaddr_int;
   gt7_drpdi_i <= GT7_DRPDI_IN when (gt7_adapt_done='1') else gt7_drpdi_int;
   gt7_drpen_i <= GT7_DRPEN_IN when (gt7_adapt_done='1') else gt7_drpen_int;
   gt7_drpwe_i <= GT7_DRPWE_IN when (gt7_adapt_done='1') else gt7_drpwe_int;
   GT7_DRPDO_OUT <= gt7_drpdo_o when (gt7_adapt_done='1') else "0000000000000000";
   GT7_DRPRDY_OUT <= gt7_drprdy_o when (gt7_adapt_done='1') else '0';

   gt7_drpdo_int <= gt7_drpdo_o;
   gt7_drprdy_int <= gt7_drprdy_o;


gt8_rxresetfsm_i:  AMC_GTX_RX_STARTUP_FSM 

  generic map(
           EXAMPLE_SIMULATION       => EXAMPLE_SIMULATION,
           GT_TYPE                  => "GTX", --GTX or GTH or GTP
           EQ_MODE                  => EQ_MODE,                        --Rx Equalization Mode - Set to DFE or LPM
           STABLE_CLOCK_PERIOD      => STABLE_CLOCK_PERIOD,           --Period of the stable clock driving this state-machine, unit is [ns]
           RETRY_COUNTER_BITWIDTH   => 8, 
           TX_QPLL_USED             => TRUE ,                        -- the TX and RX Reset FSMs must 
           RX_QPLL_USED             => TRUE,                         -- share these two generic values
           PHASE_ALIGNMENT_MANUAL   =>  FALSE                        -- Decision if a manual phase-alignment is necessary or the automatic 
                                                                     -- is enough. For single-lane applications the automatic alignment is 
                                                                     -- sufficient              
             )     
    port map ( 
        STABLE_CLOCK                    =>      SYSCLK_IN,
        RXUSERCLK                       =>      GT8_RXUSRCLK_IN,
        SOFT_RESET                      =>      SOFT_RESET_IN,
        QPLLREFCLKLOST                  =>      gt2_qpllrefclklost_i,
        CPLLREFCLKLOST                  =>      tied_to_ground_i,
        QPLLLOCK                        =>      gt2_qplllock_i,
        CPLLLOCK                        =>      tied_to_vcc_i,
        RXRESETDONE                     =>      gt8_rxresetdone_i,
        MMCM_LOCK                       =>      tied_to_vcc_i,
        RECCLK_STABLE                   =>      gt8_recclk_stable_i,
        RECCLK_MONITOR_RESTART          =>      tied_to_ground_i,
        DATA_VALID                      =>      GT8_DATA_VALID_IN,
        TXUSERRDY                       =>      gt8_txuserrdy_i,
        GTRXRESET                       =>      gt8_gtrxreset_t,
        MMCM_RESET                      =>      open,
        QPLL_RESET                      =>      open,
        CPLL_RESET                      =>      open,
        RX_FSM_RESET_DONE               =>      GT8_RX_FSM_RESET_DONE_OUT,
        RXUSERRDY                       =>      gt8_rxuserrdy_t,
        RUN_PHALIGNMENT                 =>      open,
        RESET_PHALIGNMENT               =>      open,
        PHALIGNMENT_DONE                =>      tied_to_vcc_i,
        RXDFELFHOLD                     =>      gt8_rxdfelfhold_i,
        RXLPMLFHOLD                     =>      gt8_rxlpmlfhold_i,
        RXLPMHFHOLD                     =>      gt8_rxlpmhfhold_i,
        RXDFEAGCHOLD                    =>      open,
        RETRY_COUNTER                   =>      open
           );

gt8_eq_dfe_mode: if EQ_MODE = "DFE" generate
gt8_adapt_top_dfe_i: AMC_GTX_ADAPT_TOP_DFE
  generic map (
              AGC_TIMER => DFE_ADAPT_LOCK_TIMER
              )
  port map (
            EN            => '1',
            CTLE3_COMP_EN => '1',
            GTRXRESET     => gt8_gtrxreset_i, --reset going to the GT, coming from either chipscope or TB
            RXPMARESET    => GT8_RXPMARESET_IN,--tied to ground, going to GT
            RXDFELPMRESET => gt8_rxdfelpmreset_i,--tied to ground, going to GT
            DCLK          => GT8_DRPCLK_IN,
            DO            => gt8_drpdo_int,
            DRDY          => gt8_drprdy_int,
            DADDR         => gt8_drpaddr_int,
            DI            => gt8_drpdi_int,
            DEN           => gt8_drpen_int,
            DWE           => gt8_drpwe_int,
            RXMONITOR     => gt8_rxmonitorout_o,
            RXMONITORSEL  => gt8_rxmonitorsel_i,
            AGCHOLD       => gt8_rxdfeagchold_i,
            KLHOLD        => open,
            KHHOLD        => open,
            DONE          => gt8_adapt_done,
            DEBUG         => open
           );
  
end generate gt8_eq_dfe_mode;               

gt8_eq_lpm_mode: if EQ_MODE = "LPM" generate
gt8_adapt_top_lpm_i: AMC_GTX_ADAPT_TOP_LPM
  generic map (
              TIMER => LPM_ADAPT_LOCK_TIMER
              )
  port map (
            EN            => '1',
            GTRXRESET     => gt8_gtrxreset_i, --reset going to the GT, coming from either chipscope or TB
            RXPMARESET    => GT8_RXPMARESET_IN,--tied to ground, going to GT
            RXDFELPMRESET => gt8_rxdfelpmreset_i,--tied to ground, going to GT
            DCLK          => GT8_DRPCLK_IN,
            DO            => gt8_drpdo_int,
            DRDY          => gt8_drprdy_int,
            DADDR         => gt8_drpaddr_int,
            DI            => gt8_drpdi_int,
            DEN           => gt8_drpen_int,
            DWE           => gt8_drpwe_int,
            KLHOLD        => open,
            KHHOLD        => open,
            DONE          => gt8_adapt_done,
            DEBUG         => open
           );
  
end generate gt8_eq_lpm_mode;               

   gt8_drpaddr_i <=  GT8_DRPADDR_IN when (gt8_adapt_done='1') else gt8_drpaddr_int;
   gt8_drpdi_i <= GT8_DRPDI_IN when (gt8_adapt_done='1') else gt8_drpdi_int;
   gt8_drpen_i <= GT8_DRPEN_IN when (gt8_adapt_done='1') else gt8_drpen_int;
   gt8_drpwe_i <= GT8_DRPWE_IN when (gt8_adapt_done='1') else gt8_drpwe_int;
   GT8_DRPDO_OUT <= gt8_drpdo_o when (gt8_adapt_done='1') else "0000000000000000";
   GT8_DRPRDY_OUT <= gt8_drprdy_o when (gt8_adapt_done='1') else '0';

   gt8_drpdo_int <= gt8_drpdo_o;
   gt8_drprdy_int <= gt8_drprdy_o;


gt9_rxresetfsm_i:  AMC_GTX_RX_STARTUP_FSM 

  generic map(
           EXAMPLE_SIMULATION       => EXAMPLE_SIMULATION,
           GT_TYPE                  => "GTX", --GTX or GTH or GTP
           EQ_MODE                  => EQ_MODE,                        --Rx Equalization Mode - Set to DFE or LPM
           STABLE_CLOCK_PERIOD      => STABLE_CLOCK_PERIOD,           --Period of the stable clock driving this state-machine, unit is [ns]
           RETRY_COUNTER_BITWIDTH   => 8, 
           TX_QPLL_USED             => TRUE ,                        -- the TX and RX Reset FSMs must 
           RX_QPLL_USED             => TRUE,                         -- share these two generic values
           PHASE_ALIGNMENT_MANUAL   =>  FALSE                        -- Decision if a manual phase-alignment is necessary or the automatic 
                                                                     -- is enough. For single-lane applications the automatic alignment is 
                                                                     -- sufficient              
             )     
    port map ( 
        STABLE_CLOCK                    =>      SYSCLK_IN,
        RXUSERCLK                       =>      GT9_RXUSRCLK_IN,
        SOFT_RESET                      =>      SOFT_RESET_IN,
        QPLLREFCLKLOST                  =>      gt2_qpllrefclklost_i,
        CPLLREFCLKLOST                  =>      tied_to_ground_i,
        QPLLLOCK                        =>      gt2_qplllock_i,
        CPLLLOCK                        =>      tied_to_vcc_i,
        RXRESETDONE                     =>      gt9_rxresetdone_i,
        MMCM_LOCK                       =>      tied_to_vcc_i,
        RECCLK_STABLE                   =>      gt9_recclk_stable_i,
        RECCLK_MONITOR_RESTART          =>      tied_to_ground_i,
        DATA_VALID                      =>      GT9_DATA_VALID_IN,
        TXUSERRDY                       =>      gt9_txuserrdy_i,
        GTRXRESET                       =>      gt9_gtrxreset_t,
        MMCM_RESET                      =>      open,
        QPLL_RESET                      =>      open,
        CPLL_RESET                      =>      open,
        RX_FSM_RESET_DONE               =>      GT9_RX_FSM_RESET_DONE_OUT,
        RXUSERRDY                       =>      gt9_rxuserrdy_t,
        RUN_PHALIGNMENT                 =>      open,
        RESET_PHALIGNMENT               =>      open,
        PHALIGNMENT_DONE                =>      tied_to_vcc_i,
        RXDFELFHOLD                     =>      gt9_rxdfelfhold_i,
        RXLPMLFHOLD                     =>      gt9_rxlpmlfhold_i,
        RXLPMHFHOLD                     =>      gt9_rxlpmhfhold_i,
        RXDFEAGCHOLD                    =>      open,
        RETRY_COUNTER                   =>      open
           );

gt9_eq_dfe_mode: if EQ_MODE = "DFE" generate
gt9_adapt_top_dfe_i: AMC_GTX_ADAPT_TOP_DFE
  generic map (
              AGC_TIMER => DFE_ADAPT_LOCK_TIMER
              )
  port map (
            EN            => '1',
            CTLE3_COMP_EN => '1',
            GTRXRESET     => gt9_gtrxreset_i, --reset going to the GT, coming from either chipscope or TB
            RXPMARESET    => GT9_RXPMARESET_IN,--tied to ground, going to GT
            RXDFELPMRESET => gt9_rxdfelpmreset_i,--tied to ground, going to GT
            DCLK          => GT9_DRPCLK_IN,
            DO            => gt9_drpdo_int,
            DRDY          => gt9_drprdy_int,
            DADDR         => gt9_drpaddr_int,
            DI            => gt9_drpdi_int,
            DEN           => gt9_drpen_int,
            DWE           => gt9_drpwe_int,
            RXMONITOR     => gt9_rxmonitorout_o,
            RXMONITORSEL  => gt9_rxmonitorsel_i,
            AGCHOLD       => gt9_rxdfeagchold_i,
            KLHOLD        => open,
            KHHOLD        => open,
            DONE          => gt9_adapt_done,
            DEBUG         => open
           );
  
end generate gt9_eq_dfe_mode;               

gt9_eq_lpm_mode: if EQ_MODE = "LPM" generate
gt9_adapt_top_lpm_i: AMC_GTX_ADAPT_TOP_LPM
  generic map (
              TIMER => LPM_ADAPT_LOCK_TIMER
              )
  port map (
            EN            => '1',
            GTRXRESET     => gt9_gtrxreset_i, --reset going to the GT, coming from either chipscope or TB
            RXPMARESET    => GT9_RXPMARESET_IN,--tied to ground, going to GT
            RXDFELPMRESET => gt9_rxdfelpmreset_i,--tied to ground, going to GT
            DCLK          => GT9_DRPCLK_IN,
            DO            => gt9_drpdo_int,
            DRDY          => gt9_drprdy_int,
            DADDR         => gt9_drpaddr_int,
            DI            => gt9_drpdi_int,
            DEN           => gt9_drpen_int,
            DWE           => gt9_drpwe_int,
            KLHOLD        => open,
            KHHOLD        => open,
            DONE          => gt9_adapt_done,
            DEBUG         => open
           );
  
end generate gt9_eq_lpm_mode;               

   gt9_drpaddr_i <=  GT9_DRPADDR_IN when (gt9_adapt_done='1') else gt9_drpaddr_int;
   gt9_drpdi_i <= GT9_DRPDI_IN when (gt9_adapt_done='1') else gt9_drpdi_int;
   gt9_drpen_i <= GT9_DRPEN_IN when (gt9_adapt_done='1') else gt9_drpen_int;
   gt9_drpwe_i <= GT9_DRPWE_IN when (gt9_adapt_done='1') else gt9_drpwe_int;
   GT9_DRPDO_OUT <= gt9_drpdo_o when (gt9_adapt_done='1') else "0000000000000000";
   GT9_DRPRDY_OUT <= gt9_drprdy_o when (gt9_adapt_done='1') else '0';

   gt9_drpdo_int <= gt9_drpdo_o;
   gt9_drprdy_int <= gt9_drprdy_o;


gt10_rxresetfsm_i:  AMC_GTX_RX_STARTUP_FSM 

  generic map(
           EXAMPLE_SIMULATION       => EXAMPLE_SIMULATION,
           GT_TYPE                  => "GTX", --GTX or GTH or GTP
           EQ_MODE                  => EQ_MODE,                        --Rx Equalization Mode - Set to DFE or LPM
           STABLE_CLOCK_PERIOD      => STABLE_CLOCK_PERIOD,           --Period of the stable clock driving this state-machine, unit is [ns]
           RETRY_COUNTER_BITWIDTH   => 8, 
           TX_QPLL_USED             => TRUE ,                        -- the TX and RX Reset FSMs must 
           RX_QPLL_USED             => TRUE,                         -- share these two generic values
           PHASE_ALIGNMENT_MANUAL   =>  FALSE                        -- Decision if a manual phase-alignment is necessary or the automatic 
                                                                     -- is enough. For single-lane applications the automatic alignment is 
                                                                     -- sufficient              
             )     
    port map ( 
        STABLE_CLOCK                    =>      SYSCLK_IN,
        RXUSERCLK                       =>      GT10_RXUSRCLK_IN,
        SOFT_RESET                      =>      SOFT_RESET_IN,
        QPLLREFCLKLOST                  =>      gt2_qpllrefclklost_i,
        CPLLREFCLKLOST                  =>      tied_to_ground_i,
        QPLLLOCK                        =>      gt2_qplllock_i,
        CPLLLOCK                        =>      tied_to_vcc_i,
        RXRESETDONE                     =>      gt10_rxresetdone_i,
        MMCM_LOCK                       =>      tied_to_vcc_i,
        RECCLK_STABLE                   =>      gt10_recclk_stable_i,
        RECCLK_MONITOR_RESTART          =>      tied_to_ground_i,
        DATA_VALID                      =>      GT10_DATA_VALID_IN,
        TXUSERRDY                       =>      gt10_txuserrdy_i,
        GTRXRESET                       =>      gt10_gtrxreset_t,
        MMCM_RESET                      =>      open,
        QPLL_RESET                      =>      open,
        CPLL_RESET                      =>      open,
        RX_FSM_RESET_DONE               =>      GT10_RX_FSM_RESET_DONE_OUT,
        RXUSERRDY                       =>      gt10_rxuserrdy_t,
        RUN_PHALIGNMENT                 =>      open,
        RESET_PHALIGNMENT               =>      open,
        PHALIGNMENT_DONE                =>      tied_to_vcc_i,
        RXDFELFHOLD                     =>      gt10_rxdfelfhold_i,
        RXLPMLFHOLD                     =>      gt10_rxlpmlfhold_i,
        RXLPMHFHOLD                     =>      gt10_rxlpmhfhold_i,
        RXDFEAGCHOLD                    =>      open,
        RETRY_COUNTER                   =>      open
           );

gt10_eq_dfe_mode: if EQ_MODE = "DFE" generate
gt10_adapt_top_dfe_i: AMC_GTX_ADAPT_TOP_DFE
  generic map (
              AGC_TIMER => DFE_ADAPT_LOCK_TIMER
              )
  port map (
            EN            => '1',
            CTLE3_COMP_EN => '1',
            GTRXRESET     => gt10_gtrxreset_i, --reset going to the GT, coming from either chipscope or TB
            RXPMARESET    => GT10_RXPMARESET_IN,--tied to ground, going to GT
            RXDFELPMRESET => gt10_rxdfelpmreset_i,--tied to ground, going to GT
            DCLK          => GT10_DRPCLK_IN,
            DO            => gt10_drpdo_int,
            DRDY          => gt10_drprdy_int,
            DADDR         => gt10_drpaddr_int,
            DI            => gt10_drpdi_int,
            DEN           => gt10_drpen_int,
            DWE           => gt10_drpwe_int,
            RXMONITOR     => gt10_rxmonitorout_o,
            RXMONITORSEL  => gt10_rxmonitorsel_i,
            AGCHOLD       => gt10_rxdfeagchold_i,
            KLHOLD        => open,
            KHHOLD        => open,
            DONE          => gt10_adapt_done,
            DEBUG         => open
           );
  
end generate gt10_eq_dfe_mode;               

gt10_eq_lpm_mode: if EQ_MODE = "LPM" generate
gt10_adapt_top_lpm_i: AMC_GTX_ADAPT_TOP_LPM
  generic map (
              TIMER => LPM_ADAPT_LOCK_TIMER
              )
  port map (
            EN            => '1',
            GTRXRESET     => gt10_gtrxreset_i, --reset going to the GT, coming from either chipscope or TB
            RXPMARESET    => GT10_RXPMARESET_IN,--tied to ground, going to GT
            RXDFELPMRESET => gt10_rxdfelpmreset_i,--tied to ground, going to GT
            DCLK          => GT10_DRPCLK_IN,
            DO            => gt10_drpdo_int,
            DRDY          => gt10_drprdy_int,
            DADDR         => gt10_drpaddr_int,
            DI            => gt10_drpdi_int,
            DEN           => gt10_drpen_int,
            DWE           => gt10_drpwe_int,
            KLHOLD        => open,
            KHHOLD        => open,
            DONE          => gt10_adapt_done,
            DEBUG         => open
           );
  
end generate gt10_eq_lpm_mode;               

   gt10_drpaddr_i <=  GT10_DRPADDR_IN when (gt10_adapt_done='1') else gt10_drpaddr_int;
   gt10_drpdi_i <= GT10_DRPDI_IN when (gt10_adapt_done='1') else gt10_drpdi_int;
   gt10_drpen_i <= GT10_DRPEN_IN when (gt10_adapt_done='1') else gt10_drpen_int;
   gt10_drpwe_i <= GT10_DRPWE_IN when (gt10_adapt_done='1') else gt10_drpwe_int;
   GT10_DRPDO_OUT <= gt10_drpdo_o when (gt10_adapt_done='1') else "0000000000000000";
   GT10_DRPRDY_OUT <= gt10_drprdy_o when (gt10_adapt_done='1') else '0';

   gt10_drpdo_int <= gt10_drpdo_o;
   gt10_drprdy_int <= gt10_drprdy_o;


gt11_rxresetfsm_i:  AMC_GTX_RX_STARTUP_FSM 

  generic map(
           EXAMPLE_SIMULATION       => EXAMPLE_SIMULATION,
           GT_TYPE                  => "GTX", --GTX or GTH or GTP
           EQ_MODE                  => EQ_MODE,                        --Rx Equalization Mode - Set to DFE or LPM
           STABLE_CLOCK_PERIOD      => STABLE_CLOCK_PERIOD,           --Period of the stable clock driving this state-machine, unit is [ns]
           RETRY_COUNTER_BITWIDTH   => 8, 
           TX_QPLL_USED             => TRUE ,                        -- the TX and RX Reset FSMs must 
           RX_QPLL_USED             => TRUE,                         -- share these two generic values
           PHASE_ALIGNMENT_MANUAL   =>  FALSE                        -- Decision if a manual phase-alignment is necessary or the automatic 
                                                                     -- is enough. For single-lane applications the automatic alignment is 
                                                                     -- sufficient              
             )     
    port map ( 
        STABLE_CLOCK                    =>      SYSCLK_IN,
        RXUSERCLK                       =>      GT11_RXUSRCLK_IN,
        SOFT_RESET                      =>      SOFT_RESET_IN,
        QPLLREFCLKLOST                  =>      gt2_qpllrefclklost_i,
        CPLLREFCLKLOST                  =>      tied_to_ground_i,
        QPLLLOCK                        =>      gt2_qplllock_i,
        CPLLLOCK                        =>      tied_to_vcc_i,
        RXRESETDONE                     =>      gt11_rxresetdone_i,
        MMCM_LOCK                       =>      tied_to_vcc_i,
        RECCLK_STABLE                   =>      gt11_recclk_stable_i,
        RECCLK_MONITOR_RESTART          =>      tied_to_ground_i,
        DATA_VALID                      =>      GT11_DATA_VALID_IN,
        TXUSERRDY                       =>      gt11_txuserrdy_i,
        GTRXRESET                       =>      gt11_gtrxreset_t,
        MMCM_RESET                      =>      open,
        QPLL_RESET                      =>      open,
        CPLL_RESET                      =>      open,
        RX_FSM_RESET_DONE               =>      GT11_RX_FSM_RESET_DONE_OUT,
        RXUSERRDY                       =>      gt11_rxuserrdy_t,
        RUN_PHALIGNMENT                 =>      open,
        RESET_PHALIGNMENT               =>      open,
        PHALIGNMENT_DONE                =>      tied_to_vcc_i,
        RXDFELFHOLD                     =>      gt11_rxdfelfhold_i,
        RXLPMLFHOLD                     =>      gt11_rxlpmlfhold_i,
        RXLPMHFHOLD                     =>      gt11_rxlpmhfhold_i,
        RXDFEAGCHOLD                    =>      open,
        RETRY_COUNTER                   =>      open
           );

gt11_eq_dfe_mode: if EQ_MODE = "DFE" generate
gt11_adapt_top_dfe_i: AMC_GTX_ADAPT_TOP_DFE
  generic map (
              AGC_TIMER => DFE_ADAPT_LOCK_TIMER
              )
  port map (
            EN            => '1',
            CTLE3_COMP_EN => '1',
            GTRXRESET     => gt11_gtrxreset_i, --reset going to the GT, coming from either chipscope or TB
            RXPMARESET    => GT11_RXPMARESET_IN,--tied to ground, going to GT
            RXDFELPMRESET => gt11_rxdfelpmreset_i,--tied to ground, going to GT
            DCLK          => GT11_DRPCLK_IN,
            DO            => gt11_drpdo_int,
            DRDY          => gt11_drprdy_int,
            DADDR         => gt11_drpaddr_int,
            DI            => gt11_drpdi_int,
            DEN           => gt11_drpen_int,
            DWE           => gt11_drpwe_int,
            RXMONITOR     => gt11_rxmonitorout_o,
            RXMONITORSEL  => gt11_rxmonitorsel_i,
            AGCHOLD       => gt11_rxdfeagchold_i,
            KLHOLD        => open,
            KHHOLD        => open,
            DONE          => gt11_adapt_done,
            DEBUG         => open
           );
  
end generate gt11_eq_dfe_mode;               

gt11_eq_lpm_mode: if EQ_MODE = "LPM" generate
gt11_adapt_top_lpm_i: AMC_GTX_ADAPT_TOP_LPM
  generic map (
              TIMER => LPM_ADAPT_LOCK_TIMER
              )
  port map (
            EN            => '1',
            GTRXRESET     => gt11_gtrxreset_i, --reset going to the GT, coming from either chipscope or TB
            RXPMARESET    => GT11_RXPMARESET_IN,--tied to ground, going to GT
            RXDFELPMRESET => gt11_rxdfelpmreset_i,--tied to ground, going to GT
            DCLK          => GT11_DRPCLK_IN,
            DO            => gt11_drpdo_int,
            DRDY          => gt11_drprdy_int,
            DADDR         => gt11_drpaddr_int,
            DI            => gt11_drpdi_int,
            DEN           => gt11_drpen_int,
            DWE           => gt11_drpwe_int,
            KLHOLD        => open,
            KHHOLD        => open,
            DONE          => gt11_adapt_done,
            DEBUG         => open
           );
  
end generate gt11_eq_lpm_mode;               

   gt11_drpaddr_i <=  GT11_DRPADDR_IN when (gt11_adapt_done='1') else gt11_drpaddr_int;
   gt11_drpdi_i <= GT11_DRPDI_IN when (gt11_adapt_done='1') else gt11_drpdi_int;
   gt11_drpen_i <= GT11_DRPEN_IN when (gt11_adapt_done='1') else gt11_drpen_int;
   gt11_drpwe_i <= GT11_DRPWE_IN when (gt11_adapt_done='1') else gt11_drpwe_int;
   GT11_DRPDO_OUT <= gt11_drpdo_o when (gt11_adapt_done='1') else "0000000000000000";
   GT11_DRPRDY_OUT <= gt11_drprdy_o when (gt11_adapt_done='1') else '0';

   gt11_drpdo_int <= gt11_drpdo_o;
   gt11_drprdy_int <= gt11_drprdy_o;




  cdrlock_timeout:process(SYSCLK_IN)
  begin
    if rising_edge(SYSCLK_IN) then
        if(gt0_gtrxreset_i = '1') then
          rx_cdrlocked       <= '0';
          rx_cdrlock_counter <=  0                        after DLY;
        elsif (rx_cdrlock_counter = WAIT_TIME_CDRLOCK) then
          rx_cdrlocked       <= '1';
          rx_cdrlock_counter <= rx_cdrlock_counter        after DLY;
        else
          rx_cdrlock_counter <= rx_cdrlock_counter + 1    after DLY;
        end if;
    end if;
  end process;

gt0_recclk_stable_i                          <= rx_cdrlocked;
gt1_recclk_stable_i                          <= rx_cdrlocked;
gt2_recclk_stable_i                          <= rx_cdrlocked;
gt3_recclk_stable_i                          <= rx_cdrlocked;
gt4_recclk_stable_i                          <= rx_cdrlocked;
gt5_recclk_stable_i                          <= rx_cdrlocked;
gt6_recclk_stable_i                          <= rx_cdrlocked;
gt7_recclk_stable_i                          <= rx_cdrlocked;
gt8_recclk_stable_i                          <= rx_cdrlocked;
gt9_recclk_stable_i                          <= rx_cdrlocked;
gt10_recclk_stable_i                         <= rx_cdrlocked;
gt11_recclk_stable_i                         <= rx_cdrlocked;







end RTL;


