------------------------------------------------------------------------------
--   ____  ____
--  /   /\/   /
-- /___/  \  /    Vendor: Xilinx
-- \   \   \/     Version : 2.5
--  \   \         Application : 7 Series FPGAs Transceivers Wizard 
--  /   /         Filename : amc_gtxv_exdes.vhd
-- /___/   /\      
-- \   \  /  \ 
--  \___\/\___\
--
--
-- Module AMC_GTXv_exdes
-- Generated by Xilinx 7 Series FPGAs Transceivers Wizard
-- 
-- 
-- (c) Copyright 2010-2012 Xilinx, Inc. All rights reserved.
-- 
-- This file contains confidential and proprietary information
-- of Xilinx, Inc. and is protected under U.S. and
-- international copyright and other intellectual property
-- laws.
-- 
-- DISCLAIMER
-- This disclaimer is not a license and does not grant any
-- rights to the materials distributed herewith. Except as
-- otherwise provided in a valid license issued to you by
-- Xilinx, and to the maximum extent permitted by applicable
-- law: (1) THESE MATERIALS ARE MADE AVAILABLE "AS IS" AND
-- WITH ALL FAULTS, AND XILINX HEREBY DISCLAIMS ALL WARRANTIES
-- AND CONDITIONS, EXPRESS, IMPLIED, OR STATUTORY, INCLUDING
-- BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, NON-
-- INFRINGEMENT, OR FITNESS FOR ANY PARTICULAR PURPOSE; and
-- (2) Xilinx shall not be liable (whether in contract or tort,
-- including negligence, or under any other theory of
-- liability) for any loss or damage of any kind or nature
-- related to, arising under or in connection with these
-- materials, including for any direct, or any indirect,
-- special, incidental, or consequential loss or damage
-- (including loss of data, profits, goodwill, or any type of
-- loss or damage suffered as a result of any action brought
-- by a third party) even if such damage or loss was
-- reasonably foreseeable or Xilinx had been advised of the
-- possibility of the same.
-- 
-- CRITICAL APPLICATIONS
-- Xilinx products are not designed or intended to be fail-
-- safe, or for use in any application requiring fail-safe
-- performance, such as life-support or safety devices or
-- systems, Class III medical devices, nuclear facilities,
-- applications related to the deployment of airbags, or any
-- other applications that could lead to death, personal
-- injury, or severe property or environmental damage
-- (individually and collectively, "Critical
-- Applications"). Customer assumes the sole risk and
-- liability of any use of Xilinx products in Critical
-- Applications, subject only to applicable laws and
-- regulations governing limitations on product liability.
-- 
-- THIS COPYRIGHT NOTICE AND DISCLAIMER MUST BE RETAINED AS
-- PART OF THIS FILE AT ALL TIMES. 


library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
use ieee.std_logic_unsigned.all;
use ieee.std_logic_misc.all;
library UNISIM;
use UNISIM.VCOMPONENTS.ALL;

--***********************************Entity Declaration************************

entity AMC_GTXv_exdes is
generic
(
    EXAMPLE_CONFIG_INDEPENDENT_LANES        : integer   := 1;
    EXAMPLE_LANE_WITH_START_CHAR            : integer   := 0;    -- specifies lane with unique start frame ch
    EXAMPLE_WORDS_IN_BRAM                   : integer   := 512;  -- specifies amount of data in BRAM
    EXAMPLE_SIM_GTRESET_SPEEDUP             : string    := "TRUE";    -- simulation setting for GT SecureIP model
    EXAMPLE_SIMULATION                      : integer   := 1;             -- Set to 1 for simulation
    EXAMPLE_USE_CHIPSCOPE                   : integer   := 0           -- Set to 1 to use Chipscope to drive resets
);
port
(
    Q1_CLK1_GTREFCLK_PAD_N_IN               : in   std_logic;
    Q1_CLK1_GTREFCLK_PAD_P_IN               : in   std_logic;
    DRP_CLK_IN                              : in   std_logic;
    SYSCLK_IN                               : in   std_logic;
    TRACK_DATA_OUT                          : out  std_logic;
    RXN_IN                                  : in   std_logic_vector(11 downto 0);
    RXP_IN                                  : in   std_logic_vector(11 downto 0);
    TXN_OUT                                 : out  std_logic_vector(11 downto 0);
    TXP_OUT                                 : out  std_logic_vector(11 downto 0)
    
);


end AMC_GTXv_exdes;
    
architecture RTL of AMC_GTXv_exdes is

    attribute CORE_GENERATION_INFO : string;
    attribute CORE_GENERATION_INFO of RTL : architecture is "AMC_GTXv,gtwizard_v2_5,{protocol_file=Start_from_scratch}";

--**************************Component Declarations*****************************


component AMC_GTXv_init
generic
(
    -- Simulation attributes
    EXAMPLE_SIM_GTRESET_SPEEDUP    : string    := "FALSE";    -- Set to 1 to speed up sim reset
    EXAMPLE_SIMULATION             : integer   := 0;          -- Set to 1 for simulation
    EXAMPLE_USE_CHIPSCOPE          : integer   := 0           -- Set to 1 to use Chipscope to drive resets

);
port
(
    SYSCLK_IN                               : in   std_logic;
    SOFT_RESET_IN                           : in   std_logic;
    DONT_RESET_ON_DATA_ERROR_IN             : in   std_logic;
    GT0_TX_FSM_RESET_DONE_OUT               : out  std_logic;
    GT0_RX_FSM_RESET_DONE_OUT               : out  std_logic;
    GT0_DATA_VALID_IN                       : in   std_logic;
    GT1_TX_FSM_RESET_DONE_OUT               : out  std_logic;
    GT1_RX_FSM_RESET_DONE_OUT               : out  std_logic;
    GT1_DATA_VALID_IN                       : in   std_logic;
    GT2_TX_FSM_RESET_DONE_OUT               : out  std_logic;
    GT2_RX_FSM_RESET_DONE_OUT               : out  std_logic;
    GT2_DATA_VALID_IN                       : in   std_logic;
    GT3_TX_FSM_RESET_DONE_OUT               : out  std_logic;
    GT3_RX_FSM_RESET_DONE_OUT               : out  std_logic;
    GT3_DATA_VALID_IN                       : in   std_logic;
    GT4_TX_FSM_RESET_DONE_OUT               : out  std_logic;
    GT4_RX_FSM_RESET_DONE_OUT               : out  std_logic;
    GT4_DATA_VALID_IN                       : in   std_logic;
    GT5_TX_FSM_RESET_DONE_OUT               : out  std_logic;
    GT5_RX_FSM_RESET_DONE_OUT               : out  std_logic;
    GT5_DATA_VALID_IN                       : in   std_logic;
    GT6_TX_FSM_RESET_DONE_OUT               : out  std_logic;
    GT6_RX_FSM_RESET_DONE_OUT               : out  std_logic;
    GT6_DATA_VALID_IN                       : in   std_logic;
    GT7_TX_FSM_RESET_DONE_OUT               : out  std_logic;
    GT7_RX_FSM_RESET_DONE_OUT               : out  std_logic;
    GT7_DATA_VALID_IN                       : in   std_logic;
    GT8_TX_FSM_RESET_DONE_OUT               : out  std_logic;
    GT8_RX_FSM_RESET_DONE_OUT               : out  std_logic;
    GT8_DATA_VALID_IN                       : in   std_logic;
    GT9_TX_FSM_RESET_DONE_OUT               : out  std_logic;
    GT9_RX_FSM_RESET_DONE_OUT               : out  std_logic;
    GT9_DATA_VALID_IN                       : in   std_logic;
    GT10_TX_FSM_RESET_DONE_OUT              : out  std_logic;
    GT10_RX_FSM_RESET_DONE_OUT              : out  std_logic;
    GT10_DATA_VALID_IN                      : in   std_logic;
    GT11_TX_FSM_RESET_DONE_OUT              : out  std_logic;
    GT11_RX_FSM_RESET_DONE_OUT              : out  std_logic;
    GT11_DATA_VALID_IN                      : in   std_logic;

    --_________________________________________________________________________
        --GT0  (X1Y0)
    --____________________________CHANNEL PORTS________________________________
    ---------------------------- Channel - DRP Ports  --------------------------
    GT0_DRPADDR_IN                          : in   std_logic_vector(8 downto 0);
    GT0_DRPCLK_IN                           : in   std_logic;
    GT0_DRPDI_IN                            : in   std_logic_vector(15 downto 0);
    GT0_DRPDO_OUT                           : out  std_logic_vector(15 downto 0);
    GT0_DRPEN_IN                            : in   std_logic;
    GT0_DRPRDY_OUT                          : out  std_logic;
    GT0_DRPWE_IN                            : in   std_logic;
    ------------------------------- Loopback Ports -----------------------------
    GT0_LOOPBACK_IN                         : in   std_logic_vector(2 downto 0);
    --------------------- RX Initialization and Reset Ports --------------------
    GT0_RXUSERRDY_IN                        : in   std_logic;
    -------------------------- RX Margin Analysis Ports ------------------------
    GT0_EYESCANDATAERROR_OUT                : out  std_logic;
    ------------------------- Receive Ports - CDR Ports ------------------------
    GT0_RXCDRLOCK_OUT                       : out  std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    GT0_RXCLKCORCNT_OUT                     : out  std_logic_vector(1 downto 0);
    ------------------ Receive Ports - FPGA RX Interface Ports -----------------
    GT0_RXUSRCLK_IN                         : in   std_logic;
    GT0_RXUSRCLK2_IN                        : in   std_logic;
    ------------------ Receive Ports - FPGA RX interface Ports -----------------
    GT0_RXDATA_OUT                          : out  std_logic_vector(15 downto 0);
    ------------------- Receive Ports - Pattern Checker Ports ------------------
    GT0_RXPRBSERR_OUT                       : out  std_logic;
    GT0_RXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
    ------------------- Receive Ports - Pattern Checker ports ------------------
    GT0_RXPRBSCNTRESET_IN                   : in   std_logic;
    ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
    GT0_RXDISPERR_OUT                       : out  std_logic_vector(1 downto 0);
    GT0_RXNOTINTABLE_OUT                    : out  std_logic_vector(1 downto 0);
    --------------------------- Receive Ports - RX AFE -------------------------
    GT0_GTXRXP_IN                           : in   std_logic;
    ------------------------ Receive Ports - RX AFE Ports ----------------------
    GT0_GTXRXN_IN                           : in   std_logic;
    -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
    GT0_RXMCOMMAALIGNEN_IN                  : in   std_logic;
    GT0_RXPCOMMAALIGNEN_IN                  : in   std_logic;
    --------------------- Receive Ports - RX Equalizer Ports -------------------
    GT0_RXDFELPMRESET_IN                    : in   std_logic;
    GT0_RXMONITOROUT_OUT                    : out  std_logic_vector(6 downto 0);
    GT0_RXMONITORSEL_IN                     : in   std_logic_vector(1 downto 0);
    ------------- Receive Ports - RX Initialization and Reset Ports ------------
    GT0_GTRXRESET_IN                        : in   std_logic;
    GT0_RXPMARESET_IN                       : in   std_logic;
    ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
    GT0_RXCHARISCOMMA_OUT                   : out  std_logic_vector(1 downto 0);
    GT0_RXCHARISK_OUT                       : out  std_logic_vector(1 downto 0);
    -------------- Receive Ports -RX Initialization and Reset Ports ------------
    GT0_RXRESETDONE_OUT                     : out  std_logic;
    --------------------- TX Initialization and Reset Ports --------------------
    GT0_GTTXRESET_IN                        : in   std_logic;
    GT0_TXUSERRDY_IN                        : in   std_logic;
    ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
    GT0_TXUSRCLK_IN                         : in   std_logic;
    GT0_TXUSRCLK2_IN                        : in   std_logic;
    --------------- Transmit Ports - TX Configurable Driver Ports --------------
    GT0_TXDIFFCTRL_IN                       : in   std_logic_vector(3 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    GT0_TXDATA_IN                           : in   std_logic_vector(15 downto 0);
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    GT0_GTXTXN_OUT                          : out  std_logic;
    GT0_GTXTXP_OUT                          : out  std_logic;
    ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
    GT0_TXOUTCLK_OUT                        : out  std_logic;
    GT0_TXOUTCLKFABRIC_OUT                  : out  std_logic;
    GT0_TXOUTCLKPCS_OUT                     : out  std_logic;
    --------------------- Transmit Ports - TX Gearbox Ports --------------------
    GT0_TXCHARISK_IN                        : in   std_logic_vector(1 downto 0);
    ------------- Transmit Ports - TX Initialization and Reset Ports -----------
    GT0_TXRESETDONE_OUT                     : out  std_logic;
    ------------------ Transmit Ports - pattern Generator Ports ----------------
    GT0_TXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
   
    --_________________________________________________________________________
        --GT1  (X1Y1)
    --____________________________CHANNEL PORTS________________________________
    ---------------------------- Channel - DRP Ports  --------------------------
    GT1_DRPADDR_IN                          : in   std_logic_vector(8 downto 0);
    GT1_DRPCLK_IN                           : in   std_logic;
    GT1_DRPDI_IN                            : in   std_logic_vector(15 downto 0);
    GT1_DRPDO_OUT                           : out  std_logic_vector(15 downto 0);
    GT1_DRPEN_IN                            : in   std_logic;
    GT1_DRPRDY_OUT                          : out  std_logic;
    GT1_DRPWE_IN                            : in   std_logic;
    ------------------------------- Loopback Ports -----------------------------
    GT1_LOOPBACK_IN                         : in   std_logic_vector(2 downto 0);
    --------------------- RX Initialization and Reset Ports --------------------
    GT1_RXUSERRDY_IN                        : in   std_logic;
    -------------------------- RX Margin Analysis Ports ------------------------
    GT1_EYESCANDATAERROR_OUT                : out  std_logic;
    ------------------------- Receive Ports - CDR Ports ------------------------
    GT1_RXCDRLOCK_OUT                       : out  std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    GT1_RXCLKCORCNT_OUT                     : out  std_logic_vector(1 downto 0);
    ------------------ Receive Ports - FPGA RX Interface Ports -----------------
    GT1_RXUSRCLK_IN                         : in   std_logic;
    GT1_RXUSRCLK2_IN                        : in   std_logic;
    ------------------ Receive Ports - FPGA RX interface Ports -----------------
    GT1_RXDATA_OUT                          : out  std_logic_vector(15 downto 0);
    ------------------- Receive Ports - Pattern Checker Ports ------------------
    GT1_RXPRBSERR_OUT                       : out  std_logic;
    GT1_RXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
    ------------------- Receive Ports - Pattern Checker ports ------------------
    GT1_RXPRBSCNTRESET_IN                   : in   std_logic;
    ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
    GT1_RXDISPERR_OUT                       : out  std_logic_vector(1 downto 0);
    GT1_RXNOTINTABLE_OUT                    : out  std_logic_vector(1 downto 0);
    --------------------------- Receive Ports - RX AFE -------------------------
    GT1_GTXRXP_IN                           : in   std_logic;
    ------------------------ Receive Ports - RX AFE Ports ----------------------
    GT1_GTXRXN_IN                           : in   std_logic;
    -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
    GT1_RXMCOMMAALIGNEN_IN                  : in   std_logic;
    GT1_RXPCOMMAALIGNEN_IN                  : in   std_logic;
    --------------------- Receive Ports - RX Equalizer Ports -------------------
    GT1_RXDFELPMRESET_IN                    : in   std_logic;
    GT1_RXMONITOROUT_OUT                    : out  std_logic_vector(6 downto 0);
    GT1_RXMONITORSEL_IN                     : in   std_logic_vector(1 downto 0);
    ------------- Receive Ports - RX Initialization and Reset Ports ------------
    GT1_GTRXRESET_IN                        : in   std_logic;
    GT1_RXPMARESET_IN                       : in   std_logic;
    ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
    GT1_RXCHARISCOMMA_OUT                   : out  std_logic_vector(1 downto 0);
    GT1_RXCHARISK_OUT                       : out  std_logic_vector(1 downto 0);
    -------------- Receive Ports -RX Initialization and Reset Ports ------------
    GT1_RXRESETDONE_OUT                     : out  std_logic;
    --------------------- TX Initialization and Reset Ports --------------------
    GT1_GTTXRESET_IN                        : in   std_logic;
    GT1_TXUSERRDY_IN                        : in   std_logic;
    ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
    GT1_TXUSRCLK_IN                         : in   std_logic;
    GT1_TXUSRCLK2_IN                        : in   std_logic;
    --------------- Transmit Ports - TX Configurable Driver Ports --------------
    GT1_TXDIFFCTRL_IN                       : in   std_logic_vector(3 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    GT1_TXDATA_IN                           : in   std_logic_vector(15 downto 0);
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    GT1_GTXTXN_OUT                          : out  std_logic;
    GT1_GTXTXP_OUT                          : out  std_logic;
    ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
    GT1_TXOUTCLK_OUT                        : out  std_logic;
    GT1_TXOUTCLKFABRIC_OUT                  : out  std_logic;
    GT1_TXOUTCLKPCS_OUT                     : out  std_logic;
    --------------------- Transmit Ports - TX Gearbox Ports --------------------
    GT1_TXCHARISK_IN                        : in   std_logic_vector(1 downto 0);
    ------------- Transmit Ports - TX Initialization and Reset Ports -----------
    GT1_TXRESETDONE_OUT                     : out  std_logic;
    ------------------ Transmit Ports - pattern Generator Ports ----------------
    GT1_TXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
   
    --_________________________________________________________________________
        --GT2  (X1Y2)
    --____________________________CHANNEL PORTS________________________________
    ---------------------------- Channel - DRP Ports  --------------------------
    GT2_DRPADDR_IN                          : in   std_logic_vector(8 downto 0);
    GT2_DRPCLK_IN                           : in   std_logic;
    GT2_DRPDI_IN                            : in   std_logic_vector(15 downto 0);
    GT2_DRPDO_OUT                           : out  std_logic_vector(15 downto 0);
    GT2_DRPEN_IN                            : in   std_logic;
    GT2_DRPRDY_OUT                          : out  std_logic;
    GT2_DRPWE_IN                            : in   std_logic;
    ------------------------------- Loopback Ports -----------------------------
    GT2_LOOPBACK_IN                         : in   std_logic_vector(2 downto 0);
    --------------------- RX Initialization and Reset Ports --------------------
    GT2_RXUSERRDY_IN                        : in   std_logic;
    -------------------------- RX Margin Analysis Ports ------------------------
    GT2_EYESCANDATAERROR_OUT                : out  std_logic;
    ------------------------- Receive Ports - CDR Ports ------------------------
    GT2_RXCDRLOCK_OUT                       : out  std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    GT2_RXCLKCORCNT_OUT                     : out  std_logic_vector(1 downto 0);
    ------------------ Receive Ports - FPGA RX Interface Ports -----------------
    GT2_RXUSRCLK_IN                         : in   std_logic;
    GT2_RXUSRCLK2_IN                        : in   std_logic;
    ------------------ Receive Ports - FPGA RX interface Ports -----------------
    GT2_RXDATA_OUT                          : out  std_logic_vector(15 downto 0);
    ------------------- Receive Ports - Pattern Checker Ports ------------------
    GT2_RXPRBSERR_OUT                       : out  std_logic;
    GT2_RXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
    ------------------- Receive Ports - Pattern Checker ports ------------------
    GT2_RXPRBSCNTRESET_IN                   : in   std_logic;
    ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
    GT2_RXDISPERR_OUT                       : out  std_logic_vector(1 downto 0);
    GT2_RXNOTINTABLE_OUT                    : out  std_logic_vector(1 downto 0);
    --------------------------- Receive Ports - RX AFE -------------------------
    GT2_GTXRXP_IN                           : in   std_logic;
    ------------------------ Receive Ports - RX AFE Ports ----------------------
    GT2_GTXRXN_IN                           : in   std_logic;
    -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
    GT2_RXMCOMMAALIGNEN_IN                  : in   std_logic;
    GT2_RXPCOMMAALIGNEN_IN                  : in   std_logic;
    --------------------- Receive Ports - RX Equalizer Ports -------------------
    GT2_RXDFELPMRESET_IN                    : in   std_logic;
    GT2_RXMONITOROUT_OUT                    : out  std_logic_vector(6 downto 0);
    GT2_RXMONITORSEL_IN                     : in   std_logic_vector(1 downto 0);
    ------------- Receive Ports - RX Initialization and Reset Ports ------------
    GT2_GTRXRESET_IN                        : in   std_logic;
    GT2_RXPMARESET_IN                       : in   std_logic;
    ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
    GT2_RXCHARISCOMMA_OUT                   : out  std_logic_vector(1 downto 0);
    GT2_RXCHARISK_OUT                       : out  std_logic_vector(1 downto 0);
    -------------- Receive Ports -RX Initialization and Reset Ports ------------
    GT2_RXRESETDONE_OUT                     : out  std_logic;
    --------------------- TX Initialization and Reset Ports --------------------
    GT2_GTTXRESET_IN                        : in   std_logic;
    GT2_TXUSERRDY_IN                        : in   std_logic;
    ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
    GT2_TXUSRCLK_IN                         : in   std_logic;
    GT2_TXUSRCLK2_IN                        : in   std_logic;
    --------------- Transmit Ports - TX Configurable Driver Ports --------------
    GT2_TXDIFFCTRL_IN                       : in   std_logic_vector(3 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    GT2_TXDATA_IN                           : in   std_logic_vector(15 downto 0);
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    GT2_GTXTXN_OUT                          : out  std_logic;
    GT2_GTXTXP_OUT                          : out  std_logic;
    ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
    GT2_TXOUTCLK_OUT                        : out  std_logic;
    GT2_TXOUTCLKFABRIC_OUT                  : out  std_logic;
    GT2_TXOUTCLKPCS_OUT                     : out  std_logic;
    --------------------- Transmit Ports - TX Gearbox Ports --------------------
    GT2_TXCHARISK_IN                        : in   std_logic_vector(1 downto 0);
    ------------- Transmit Ports - TX Initialization and Reset Ports -----------
    GT2_TXRESETDONE_OUT                     : out  std_logic;
    ------------------ Transmit Ports - pattern Generator Ports ----------------
    GT2_TXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
   
    --_________________________________________________________________________
        --GT3  (X1Y3)
    --____________________________CHANNEL PORTS________________________________
    ---------------------------- Channel - DRP Ports  --------------------------
    GT3_DRPADDR_IN                          : in   std_logic_vector(8 downto 0);
    GT3_DRPCLK_IN                           : in   std_logic;
    GT3_DRPDI_IN                            : in   std_logic_vector(15 downto 0);
    GT3_DRPDO_OUT                           : out  std_logic_vector(15 downto 0);
    GT3_DRPEN_IN                            : in   std_logic;
    GT3_DRPRDY_OUT                          : out  std_logic;
    GT3_DRPWE_IN                            : in   std_logic;
    ------------------------------- Loopback Ports -----------------------------
    GT3_LOOPBACK_IN                         : in   std_logic_vector(2 downto 0);
    --------------------- RX Initialization and Reset Ports --------------------
    GT3_RXUSERRDY_IN                        : in   std_logic;
    -------------------------- RX Margin Analysis Ports ------------------------
    GT3_EYESCANDATAERROR_OUT                : out  std_logic;
    ------------------------- Receive Ports - CDR Ports ------------------------
    GT3_RXCDRLOCK_OUT                       : out  std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    GT3_RXCLKCORCNT_OUT                     : out  std_logic_vector(1 downto 0);
    ------------------ Receive Ports - FPGA RX Interface Ports -----------------
    GT3_RXUSRCLK_IN                         : in   std_logic;
    GT3_RXUSRCLK2_IN                        : in   std_logic;
    ------------------ Receive Ports - FPGA RX interface Ports -----------------
    GT3_RXDATA_OUT                          : out  std_logic_vector(15 downto 0);
    ------------------- Receive Ports - Pattern Checker Ports ------------------
    GT3_RXPRBSERR_OUT                       : out  std_logic;
    GT3_RXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
    ------------------- Receive Ports - Pattern Checker ports ------------------
    GT3_RXPRBSCNTRESET_IN                   : in   std_logic;
    ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
    GT3_RXDISPERR_OUT                       : out  std_logic_vector(1 downto 0);
    GT3_RXNOTINTABLE_OUT                    : out  std_logic_vector(1 downto 0);
    --------------------------- Receive Ports - RX AFE -------------------------
    GT3_GTXRXP_IN                           : in   std_logic;
    ------------------------ Receive Ports - RX AFE Ports ----------------------
    GT3_GTXRXN_IN                           : in   std_logic;
    -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
    GT3_RXMCOMMAALIGNEN_IN                  : in   std_logic;
    GT3_RXPCOMMAALIGNEN_IN                  : in   std_logic;
    --------------------- Receive Ports - RX Equalizer Ports -------------------
    GT3_RXDFELPMRESET_IN                    : in   std_logic;
    GT3_RXMONITOROUT_OUT                    : out  std_logic_vector(6 downto 0);
    GT3_RXMONITORSEL_IN                     : in   std_logic_vector(1 downto 0);
    ------------- Receive Ports - RX Initialization and Reset Ports ------------
    GT3_GTRXRESET_IN                        : in   std_logic;
    GT3_RXPMARESET_IN                       : in   std_logic;
    ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
    GT3_RXCHARISCOMMA_OUT                   : out  std_logic_vector(1 downto 0);
    GT3_RXCHARISK_OUT                       : out  std_logic_vector(1 downto 0);
    -------------- Receive Ports -RX Initialization and Reset Ports ------------
    GT3_RXRESETDONE_OUT                     : out  std_logic;
    --------------------- TX Initialization and Reset Ports --------------------
    GT3_GTTXRESET_IN                        : in   std_logic;
    GT3_TXUSERRDY_IN                        : in   std_logic;
    ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
    GT3_TXUSRCLK_IN                         : in   std_logic;
    GT3_TXUSRCLK2_IN                        : in   std_logic;
    --------------- Transmit Ports - TX Configurable Driver Ports --------------
    GT3_TXDIFFCTRL_IN                       : in   std_logic_vector(3 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    GT3_TXDATA_IN                           : in   std_logic_vector(15 downto 0);
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    GT3_GTXTXN_OUT                          : out  std_logic;
    GT3_GTXTXP_OUT                          : out  std_logic;
    ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
    GT3_TXOUTCLK_OUT                        : out  std_logic;
    GT3_TXOUTCLKFABRIC_OUT                  : out  std_logic;
    GT3_TXOUTCLKPCS_OUT                     : out  std_logic;
    --------------------- Transmit Ports - TX Gearbox Ports --------------------
    GT3_TXCHARISK_IN                        : in   std_logic_vector(1 downto 0);
    ------------- Transmit Ports - TX Initialization and Reset Ports -----------
    GT3_TXRESETDONE_OUT                     : out  std_logic;
    ------------------ Transmit Ports - pattern Generator Ports ----------------
    GT3_TXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
   
    --_________________________________________________________________________
        --GT4  (X1Y4)
    --____________________________CHANNEL PORTS________________________________
    ---------------------------- Channel - DRP Ports  --------------------------
    GT4_DRPADDR_IN                          : in   std_logic_vector(8 downto 0);
    GT4_DRPCLK_IN                           : in   std_logic;
    GT4_DRPDI_IN                            : in   std_logic_vector(15 downto 0);
    GT4_DRPDO_OUT                           : out  std_logic_vector(15 downto 0);
    GT4_DRPEN_IN                            : in   std_logic;
    GT4_DRPRDY_OUT                          : out  std_logic;
    GT4_DRPWE_IN                            : in   std_logic;
    ------------------------------- Loopback Ports -----------------------------
    GT4_LOOPBACK_IN                         : in   std_logic_vector(2 downto 0);
    --------------------- RX Initialization and Reset Ports --------------------
    GT4_RXUSERRDY_IN                        : in   std_logic;
    -------------------------- RX Margin Analysis Ports ------------------------
    GT4_EYESCANDATAERROR_OUT                : out  std_logic;
    ------------------------- Receive Ports - CDR Ports ------------------------
    GT4_RXCDRLOCK_OUT                       : out  std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    GT4_RXCLKCORCNT_OUT                     : out  std_logic_vector(1 downto 0);
    ------------------ Receive Ports - FPGA RX Interface Ports -----------------
    GT4_RXUSRCLK_IN                         : in   std_logic;
    GT4_RXUSRCLK2_IN                        : in   std_logic;
    ------------------ Receive Ports - FPGA RX interface Ports -----------------
    GT4_RXDATA_OUT                          : out  std_logic_vector(15 downto 0);
    ------------------- Receive Ports - Pattern Checker Ports ------------------
    GT4_RXPRBSERR_OUT                       : out  std_logic;
    GT4_RXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
    ------------------- Receive Ports - Pattern Checker ports ------------------
    GT4_RXPRBSCNTRESET_IN                   : in   std_logic;
    ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
    GT4_RXDISPERR_OUT                       : out  std_logic_vector(1 downto 0);
    GT4_RXNOTINTABLE_OUT                    : out  std_logic_vector(1 downto 0);
    --------------------------- Receive Ports - RX AFE -------------------------
    GT4_GTXRXP_IN                           : in   std_logic;
    ------------------------ Receive Ports - RX AFE Ports ----------------------
    GT4_GTXRXN_IN                           : in   std_logic;
    -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
    GT4_RXMCOMMAALIGNEN_IN                  : in   std_logic;
    GT4_RXPCOMMAALIGNEN_IN                  : in   std_logic;
    --------------------- Receive Ports - RX Equalizer Ports -------------------
    GT4_RXDFELPMRESET_IN                    : in   std_logic;
    GT4_RXMONITOROUT_OUT                    : out  std_logic_vector(6 downto 0);
    GT4_RXMONITORSEL_IN                     : in   std_logic_vector(1 downto 0);
    ------------- Receive Ports - RX Initialization and Reset Ports ------------
    GT4_GTRXRESET_IN                        : in   std_logic;
    GT4_RXPMARESET_IN                       : in   std_logic;
    ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
    GT4_RXCHARISCOMMA_OUT                   : out  std_logic_vector(1 downto 0);
    GT4_RXCHARISK_OUT                       : out  std_logic_vector(1 downto 0);
    -------------- Receive Ports -RX Initialization and Reset Ports ------------
    GT4_RXRESETDONE_OUT                     : out  std_logic;
    --------------------- TX Initialization and Reset Ports --------------------
    GT4_GTTXRESET_IN                        : in   std_logic;
    GT4_TXUSERRDY_IN                        : in   std_logic;
    ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
    GT4_TXUSRCLK_IN                         : in   std_logic;
    GT4_TXUSRCLK2_IN                        : in   std_logic;
    --------------- Transmit Ports - TX Configurable Driver Ports --------------
    GT4_TXDIFFCTRL_IN                       : in   std_logic_vector(3 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    GT4_TXDATA_IN                           : in   std_logic_vector(15 downto 0);
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    GT4_GTXTXN_OUT                          : out  std_logic;
    GT4_GTXTXP_OUT                          : out  std_logic;
    ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
    GT4_TXOUTCLK_OUT                        : out  std_logic;
    GT4_TXOUTCLKFABRIC_OUT                  : out  std_logic;
    GT4_TXOUTCLKPCS_OUT                     : out  std_logic;
    --------------------- Transmit Ports - TX Gearbox Ports --------------------
    GT4_TXCHARISK_IN                        : in   std_logic_vector(1 downto 0);
    ------------- Transmit Ports - TX Initialization and Reset Ports -----------
    GT4_TXRESETDONE_OUT                     : out  std_logic;
    ------------------ Transmit Ports - pattern Generator Ports ----------------
    GT4_TXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
   
    --_________________________________________________________________________
        --GT5  (X1Y5)
    --____________________________CHANNEL PORTS________________________________
    ---------------------------- Channel - DRP Ports  --------------------------
    GT5_DRPADDR_IN                          : in   std_logic_vector(8 downto 0);
    GT5_DRPCLK_IN                           : in   std_logic;
    GT5_DRPDI_IN                            : in   std_logic_vector(15 downto 0);
    GT5_DRPDO_OUT                           : out  std_logic_vector(15 downto 0);
    GT5_DRPEN_IN                            : in   std_logic;
    GT5_DRPRDY_OUT                          : out  std_logic;
    GT5_DRPWE_IN                            : in   std_logic;
    ------------------------------- Loopback Ports -----------------------------
    GT5_LOOPBACK_IN                         : in   std_logic_vector(2 downto 0);
    --------------------- RX Initialization and Reset Ports --------------------
    GT5_RXUSERRDY_IN                        : in   std_logic;
    -------------------------- RX Margin Analysis Ports ------------------------
    GT5_EYESCANDATAERROR_OUT                : out  std_logic;
    ------------------------- Receive Ports - CDR Ports ------------------------
    GT5_RXCDRLOCK_OUT                       : out  std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    GT5_RXCLKCORCNT_OUT                     : out  std_logic_vector(1 downto 0);
    ------------------ Receive Ports - FPGA RX Interface Ports -----------------
    GT5_RXUSRCLK_IN                         : in   std_logic;
    GT5_RXUSRCLK2_IN                        : in   std_logic;
    ------------------ Receive Ports - FPGA RX interface Ports -----------------
    GT5_RXDATA_OUT                          : out  std_logic_vector(15 downto 0);
    ------------------- Receive Ports - Pattern Checker Ports ------------------
    GT5_RXPRBSERR_OUT                       : out  std_logic;
    GT5_RXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
    ------------------- Receive Ports - Pattern Checker ports ------------------
    GT5_RXPRBSCNTRESET_IN                   : in   std_logic;
    ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
    GT5_RXDISPERR_OUT                       : out  std_logic_vector(1 downto 0);
    GT5_RXNOTINTABLE_OUT                    : out  std_logic_vector(1 downto 0);
    --------------------------- Receive Ports - RX AFE -------------------------
    GT5_GTXRXP_IN                           : in   std_logic;
    ------------------------ Receive Ports - RX AFE Ports ----------------------
    GT5_GTXRXN_IN                           : in   std_logic;
    -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
    GT5_RXMCOMMAALIGNEN_IN                  : in   std_logic;
    GT5_RXPCOMMAALIGNEN_IN                  : in   std_logic;
    --------------------- Receive Ports - RX Equalizer Ports -------------------
    GT5_RXDFELPMRESET_IN                    : in   std_logic;
    GT5_RXMONITOROUT_OUT                    : out  std_logic_vector(6 downto 0);
    GT5_RXMONITORSEL_IN                     : in   std_logic_vector(1 downto 0);
    ------------- Receive Ports - RX Initialization and Reset Ports ------------
    GT5_GTRXRESET_IN                        : in   std_logic;
    GT5_RXPMARESET_IN                       : in   std_logic;
    ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
    GT5_RXCHARISCOMMA_OUT                   : out  std_logic_vector(1 downto 0);
    GT5_RXCHARISK_OUT                       : out  std_logic_vector(1 downto 0);
    -------------- Receive Ports -RX Initialization and Reset Ports ------------
    GT5_RXRESETDONE_OUT                     : out  std_logic;
    --------------------- TX Initialization and Reset Ports --------------------
    GT5_GTTXRESET_IN                        : in   std_logic;
    GT5_TXUSERRDY_IN                        : in   std_logic;
    ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
    GT5_TXUSRCLK_IN                         : in   std_logic;
    GT5_TXUSRCLK2_IN                        : in   std_logic;
    --------------- Transmit Ports - TX Configurable Driver Ports --------------
    GT5_TXDIFFCTRL_IN                       : in   std_logic_vector(3 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    GT5_TXDATA_IN                           : in   std_logic_vector(15 downto 0);
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    GT5_GTXTXN_OUT                          : out  std_logic;
    GT5_GTXTXP_OUT                          : out  std_logic;
    ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
    GT5_TXOUTCLK_OUT                        : out  std_logic;
    GT5_TXOUTCLKFABRIC_OUT                  : out  std_logic;
    GT5_TXOUTCLKPCS_OUT                     : out  std_logic;
    --------------------- Transmit Ports - TX Gearbox Ports --------------------
    GT5_TXCHARISK_IN                        : in   std_logic_vector(1 downto 0);
    ------------- Transmit Ports - TX Initialization and Reset Ports -----------
    GT5_TXRESETDONE_OUT                     : out  std_logic;
    ------------------ Transmit Ports - pattern Generator Ports ----------------
    GT5_TXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
   
    --_________________________________________________________________________
        --GT6  (X1Y6)
    --____________________________CHANNEL PORTS________________________________
    ---------------------------- Channel - DRP Ports  --------------------------
    GT6_DRPADDR_IN                          : in   std_logic_vector(8 downto 0);
    GT6_DRPCLK_IN                           : in   std_logic;
    GT6_DRPDI_IN                            : in   std_logic_vector(15 downto 0);
    GT6_DRPDO_OUT                           : out  std_logic_vector(15 downto 0);
    GT6_DRPEN_IN                            : in   std_logic;
    GT6_DRPRDY_OUT                          : out  std_logic;
    GT6_DRPWE_IN                            : in   std_logic;
    ------------------------------- Loopback Ports -----------------------------
    GT6_LOOPBACK_IN                         : in   std_logic_vector(2 downto 0);
    --------------------- RX Initialization and Reset Ports --------------------
    GT6_RXUSERRDY_IN                        : in   std_logic;
    -------------------------- RX Margin Analysis Ports ------------------------
    GT6_EYESCANDATAERROR_OUT                : out  std_logic;
    ------------------------- Receive Ports - CDR Ports ------------------------
    GT6_RXCDRLOCK_OUT                       : out  std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    GT6_RXCLKCORCNT_OUT                     : out  std_logic_vector(1 downto 0);
    ------------------ Receive Ports - FPGA RX Interface Ports -----------------
    GT6_RXUSRCLK_IN                         : in   std_logic;
    GT6_RXUSRCLK2_IN                        : in   std_logic;
    ------------------ Receive Ports - FPGA RX interface Ports -----------------
    GT6_RXDATA_OUT                          : out  std_logic_vector(15 downto 0);
    ------------------- Receive Ports - Pattern Checker Ports ------------------
    GT6_RXPRBSERR_OUT                       : out  std_logic;
    GT6_RXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
    ------------------- Receive Ports - Pattern Checker ports ------------------
    GT6_RXPRBSCNTRESET_IN                   : in   std_logic;
    ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
    GT6_RXDISPERR_OUT                       : out  std_logic_vector(1 downto 0);
    GT6_RXNOTINTABLE_OUT                    : out  std_logic_vector(1 downto 0);
    --------------------------- Receive Ports - RX AFE -------------------------
    GT6_GTXRXP_IN                           : in   std_logic;
    ------------------------ Receive Ports - RX AFE Ports ----------------------
    GT6_GTXRXN_IN                           : in   std_logic;
    -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
    GT6_RXMCOMMAALIGNEN_IN                  : in   std_logic;
    GT6_RXPCOMMAALIGNEN_IN                  : in   std_logic;
    --------------------- Receive Ports - RX Equalizer Ports -------------------
    GT6_RXDFELPMRESET_IN                    : in   std_logic;
    GT6_RXMONITOROUT_OUT                    : out  std_logic_vector(6 downto 0);
    GT6_RXMONITORSEL_IN                     : in   std_logic_vector(1 downto 0);
    ------------- Receive Ports - RX Initialization and Reset Ports ------------
    GT6_GTRXRESET_IN                        : in   std_logic;
    GT6_RXPMARESET_IN                       : in   std_logic;
    ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
    GT6_RXCHARISCOMMA_OUT                   : out  std_logic_vector(1 downto 0);
    GT6_RXCHARISK_OUT                       : out  std_logic_vector(1 downto 0);
    -------------- Receive Ports -RX Initialization and Reset Ports ------------
    GT6_RXRESETDONE_OUT                     : out  std_logic;
    --------------------- TX Initialization and Reset Ports --------------------
    GT6_GTTXRESET_IN                        : in   std_logic;
    GT6_TXUSERRDY_IN                        : in   std_logic;
    ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
    GT6_TXUSRCLK_IN                         : in   std_logic;
    GT6_TXUSRCLK2_IN                        : in   std_logic;
    --------------- Transmit Ports - TX Configurable Driver Ports --------------
    GT6_TXDIFFCTRL_IN                       : in   std_logic_vector(3 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    GT6_TXDATA_IN                           : in   std_logic_vector(15 downto 0);
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    GT6_GTXTXN_OUT                          : out  std_logic;
    GT6_GTXTXP_OUT                          : out  std_logic;
    ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
    GT6_TXOUTCLK_OUT                        : out  std_logic;
    GT6_TXOUTCLKFABRIC_OUT                  : out  std_logic;
    GT6_TXOUTCLKPCS_OUT                     : out  std_logic;
    --------------------- Transmit Ports - TX Gearbox Ports --------------------
    GT6_TXCHARISK_IN                        : in   std_logic_vector(1 downto 0);
    ------------- Transmit Ports - TX Initialization and Reset Ports -----------
    GT6_TXRESETDONE_OUT                     : out  std_logic;
    ------------------ Transmit Ports - pattern Generator Ports ----------------
    GT6_TXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
   
    --_________________________________________________________________________
        --GT7  (X1Y7)
    --____________________________CHANNEL PORTS________________________________
    ---------------------------- Channel - DRP Ports  --------------------------
    GT7_DRPADDR_IN                          : in   std_logic_vector(8 downto 0);
    GT7_DRPCLK_IN                           : in   std_logic;
    GT7_DRPDI_IN                            : in   std_logic_vector(15 downto 0);
    GT7_DRPDO_OUT                           : out  std_logic_vector(15 downto 0);
    GT7_DRPEN_IN                            : in   std_logic;
    GT7_DRPRDY_OUT                          : out  std_logic;
    GT7_DRPWE_IN                            : in   std_logic;
    ------------------------------- Loopback Ports -----------------------------
    GT7_LOOPBACK_IN                         : in   std_logic_vector(2 downto 0);
    --------------------- RX Initialization and Reset Ports --------------------
    GT7_RXUSERRDY_IN                        : in   std_logic;
    -------------------------- RX Margin Analysis Ports ------------------------
    GT7_EYESCANDATAERROR_OUT                : out  std_logic;
    ------------------------- Receive Ports - CDR Ports ------------------------
    GT7_RXCDRLOCK_OUT                       : out  std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    GT7_RXCLKCORCNT_OUT                     : out  std_logic_vector(1 downto 0);
    ------------------ Receive Ports - FPGA RX Interface Ports -----------------
    GT7_RXUSRCLK_IN                         : in   std_logic;
    GT7_RXUSRCLK2_IN                        : in   std_logic;
    ------------------ Receive Ports - FPGA RX interface Ports -----------------
    GT7_RXDATA_OUT                          : out  std_logic_vector(15 downto 0);
    ------------------- Receive Ports - Pattern Checker Ports ------------------
    GT7_RXPRBSERR_OUT                       : out  std_logic;
    GT7_RXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
    ------------------- Receive Ports - Pattern Checker ports ------------------
    GT7_RXPRBSCNTRESET_IN                   : in   std_logic;
    ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
    GT7_RXDISPERR_OUT                       : out  std_logic_vector(1 downto 0);
    GT7_RXNOTINTABLE_OUT                    : out  std_logic_vector(1 downto 0);
    --------------------------- Receive Ports - RX AFE -------------------------
    GT7_GTXRXP_IN                           : in   std_logic;
    ------------------------ Receive Ports - RX AFE Ports ----------------------
    GT7_GTXRXN_IN                           : in   std_logic;
    -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
    GT7_RXMCOMMAALIGNEN_IN                  : in   std_logic;
    GT7_RXPCOMMAALIGNEN_IN                  : in   std_logic;
    --------------------- Receive Ports - RX Equalizer Ports -------------------
    GT7_RXDFELPMRESET_IN                    : in   std_logic;
    GT7_RXMONITOROUT_OUT                    : out  std_logic_vector(6 downto 0);
    GT7_RXMONITORSEL_IN                     : in   std_logic_vector(1 downto 0);
    ------------- Receive Ports - RX Initialization and Reset Ports ------------
    GT7_GTRXRESET_IN                        : in   std_logic;
    GT7_RXPMARESET_IN                       : in   std_logic;
    ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
    GT7_RXCHARISCOMMA_OUT                   : out  std_logic_vector(1 downto 0);
    GT7_RXCHARISK_OUT                       : out  std_logic_vector(1 downto 0);
    -------------- Receive Ports -RX Initialization and Reset Ports ------------
    GT7_RXRESETDONE_OUT                     : out  std_logic;
    --------------------- TX Initialization and Reset Ports --------------------
    GT7_GTTXRESET_IN                        : in   std_logic;
    GT7_TXUSERRDY_IN                        : in   std_logic;
    ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
    GT7_TXUSRCLK_IN                         : in   std_logic;
    GT7_TXUSRCLK2_IN                        : in   std_logic;
    --------------- Transmit Ports - TX Configurable Driver Ports --------------
    GT7_TXDIFFCTRL_IN                       : in   std_logic_vector(3 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    GT7_TXDATA_IN                           : in   std_logic_vector(15 downto 0);
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    GT7_GTXTXN_OUT                          : out  std_logic;
    GT7_GTXTXP_OUT                          : out  std_logic;
    ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
    GT7_TXOUTCLK_OUT                        : out  std_logic;
    GT7_TXOUTCLKFABRIC_OUT                  : out  std_logic;
    GT7_TXOUTCLKPCS_OUT                     : out  std_logic;
    --------------------- Transmit Ports - TX Gearbox Ports --------------------
    GT7_TXCHARISK_IN                        : in   std_logic_vector(1 downto 0);
    ------------- Transmit Ports - TX Initialization and Reset Ports -----------
    GT7_TXRESETDONE_OUT                     : out  std_logic;
    ------------------ Transmit Ports - pattern Generator Ports ----------------
    GT7_TXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
   
    --_________________________________________________________________________
        --GT8  (X1Y8)
    --____________________________CHANNEL PORTS________________________________
    ---------------------------- Channel - DRP Ports  --------------------------
    GT8_DRPADDR_IN                          : in   std_logic_vector(8 downto 0);
    GT8_DRPCLK_IN                           : in   std_logic;
    GT8_DRPDI_IN                            : in   std_logic_vector(15 downto 0);
    GT8_DRPDO_OUT                           : out  std_logic_vector(15 downto 0);
    GT8_DRPEN_IN                            : in   std_logic;
    GT8_DRPRDY_OUT                          : out  std_logic;
    GT8_DRPWE_IN                            : in   std_logic;
    ------------------------------- Loopback Ports -----------------------------
    GT8_LOOPBACK_IN                         : in   std_logic_vector(2 downto 0);
    --------------------- RX Initialization and Reset Ports --------------------
    GT8_RXUSERRDY_IN                        : in   std_logic;
    -------------------------- RX Margin Analysis Ports ------------------------
    GT8_EYESCANDATAERROR_OUT                : out  std_logic;
    ------------------------- Receive Ports - CDR Ports ------------------------
    GT8_RXCDRLOCK_OUT                       : out  std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    GT8_RXCLKCORCNT_OUT                     : out  std_logic_vector(1 downto 0);
    ------------------ Receive Ports - FPGA RX Interface Ports -----------------
    GT8_RXUSRCLK_IN                         : in   std_logic;
    GT8_RXUSRCLK2_IN                        : in   std_logic;
    ------------------ Receive Ports - FPGA RX interface Ports -----------------
    GT8_RXDATA_OUT                          : out  std_logic_vector(15 downto 0);
    ------------------- Receive Ports - Pattern Checker Ports ------------------
    GT8_RXPRBSERR_OUT                       : out  std_logic;
    GT8_RXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
    ------------------- Receive Ports - Pattern Checker ports ------------------
    GT8_RXPRBSCNTRESET_IN                   : in   std_logic;
    ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
    GT8_RXDISPERR_OUT                       : out  std_logic_vector(1 downto 0);
    GT8_RXNOTINTABLE_OUT                    : out  std_logic_vector(1 downto 0);
    --------------------------- Receive Ports - RX AFE -------------------------
    GT8_GTXRXP_IN                           : in   std_logic;
    ------------------------ Receive Ports - RX AFE Ports ----------------------
    GT8_GTXRXN_IN                           : in   std_logic;
    -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
    GT8_RXMCOMMAALIGNEN_IN                  : in   std_logic;
    GT8_RXPCOMMAALIGNEN_IN                  : in   std_logic;
    --------------------- Receive Ports - RX Equalizer Ports -------------------
    GT8_RXDFELPMRESET_IN                    : in   std_logic;
    GT8_RXMONITOROUT_OUT                    : out  std_logic_vector(6 downto 0);
    GT8_RXMONITORSEL_IN                     : in   std_logic_vector(1 downto 0);
    ------------- Receive Ports - RX Initialization and Reset Ports ------------
    GT8_GTRXRESET_IN                        : in   std_logic;
    GT8_RXPMARESET_IN                       : in   std_logic;
    ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
    GT8_RXCHARISCOMMA_OUT                   : out  std_logic_vector(1 downto 0);
    GT8_RXCHARISK_OUT                       : out  std_logic_vector(1 downto 0);
    -------------- Receive Ports -RX Initialization and Reset Ports ------------
    GT8_RXRESETDONE_OUT                     : out  std_logic;
    --------------------- TX Initialization and Reset Ports --------------------
    GT8_GTTXRESET_IN                        : in   std_logic;
    GT8_TXUSERRDY_IN                        : in   std_logic;
    ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
    GT8_TXUSRCLK_IN                         : in   std_logic;
    GT8_TXUSRCLK2_IN                        : in   std_logic;
    --------------- Transmit Ports - TX Configurable Driver Ports --------------
    GT8_TXDIFFCTRL_IN                       : in   std_logic_vector(3 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    GT8_TXDATA_IN                           : in   std_logic_vector(15 downto 0);
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    GT8_GTXTXN_OUT                          : out  std_logic;
    GT8_GTXTXP_OUT                          : out  std_logic;
    ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
    GT8_TXOUTCLK_OUT                        : out  std_logic;
    GT8_TXOUTCLKFABRIC_OUT                  : out  std_logic;
    GT8_TXOUTCLKPCS_OUT                     : out  std_logic;
    --------------------- Transmit Ports - TX Gearbox Ports --------------------
    GT8_TXCHARISK_IN                        : in   std_logic_vector(1 downto 0);
    ------------- Transmit Ports - TX Initialization and Reset Ports -----------
    GT8_TXRESETDONE_OUT                     : out  std_logic;
    ------------------ Transmit Ports - pattern Generator Ports ----------------
    GT8_TXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
   
    --_________________________________________________________________________
        --GT9  (X1Y9)
    --____________________________CHANNEL PORTS________________________________
    ---------------------------- Channel - DRP Ports  --------------------------
    GT9_DRPADDR_IN                          : in   std_logic_vector(8 downto 0);
    GT9_DRPCLK_IN                           : in   std_logic;
    GT9_DRPDI_IN                            : in   std_logic_vector(15 downto 0);
    GT9_DRPDO_OUT                           : out  std_logic_vector(15 downto 0);
    GT9_DRPEN_IN                            : in   std_logic;
    GT9_DRPRDY_OUT                          : out  std_logic;
    GT9_DRPWE_IN                            : in   std_logic;
    ------------------------------- Loopback Ports -----------------------------
    GT9_LOOPBACK_IN                         : in   std_logic_vector(2 downto 0);
    --------------------- RX Initialization and Reset Ports --------------------
    GT9_RXUSERRDY_IN                        : in   std_logic;
    -------------------------- RX Margin Analysis Ports ------------------------
    GT9_EYESCANDATAERROR_OUT                : out  std_logic;
    ------------------------- Receive Ports - CDR Ports ------------------------
    GT9_RXCDRLOCK_OUT                       : out  std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    GT9_RXCLKCORCNT_OUT                     : out  std_logic_vector(1 downto 0);
    ------------------ Receive Ports - FPGA RX Interface Ports -----------------
    GT9_RXUSRCLK_IN                         : in   std_logic;
    GT9_RXUSRCLK2_IN                        : in   std_logic;
    ------------------ Receive Ports - FPGA RX interface Ports -----------------
    GT9_RXDATA_OUT                          : out  std_logic_vector(15 downto 0);
    ------------------- Receive Ports - Pattern Checker Ports ------------------
    GT9_RXPRBSERR_OUT                       : out  std_logic;
    GT9_RXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
    ------------------- Receive Ports - Pattern Checker ports ------------------
    GT9_RXPRBSCNTRESET_IN                   : in   std_logic;
    ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
    GT9_RXDISPERR_OUT                       : out  std_logic_vector(1 downto 0);
    GT9_RXNOTINTABLE_OUT                    : out  std_logic_vector(1 downto 0);
    --------------------------- Receive Ports - RX AFE -------------------------
    GT9_GTXRXP_IN                           : in   std_logic;
    ------------------------ Receive Ports - RX AFE Ports ----------------------
    GT9_GTXRXN_IN                           : in   std_logic;
    -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
    GT9_RXMCOMMAALIGNEN_IN                  : in   std_logic;
    GT9_RXPCOMMAALIGNEN_IN                  : in   std_logic;
    --------------------- Receive Ports - RX Equalizer Ports -------------------
    GT9_RXDFELPMRESET_IN                    : in   std_logic;
    GT9_RXMONITOROUT_OUT                    : out  std_logic_vector(6 downto 0);
    GT9_RXMONITORSEL_IN                     : in   std_logic_vector(1 downto 0);
    ------------- Receive Ports - RX Initialization and Reset Ports ------------
    GT9_GTRXRESET_IN                        : in   std_logic;
    GT9_RXPMARESET_IN                       : in   std_logic;
    ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
    GT9_RXCHARISCOMMA_OUT                   : out  std_logic_vector(1 downto 0);
    GT9_RXCHARISK_OUT                       : out  std_logic_vector(1 downto 0);
    -------------- Receive Ports -RX Initialization and Reset Ports ------------
    GT9_RXRESETDONE_OUT                     : out  std_logic;
    --------------------- TX Initialization and Reset Ports --------------------
    GT9_GTTXRESET_IN                        : in   std_logic;
    GT9_TXUSERRDY_IN                        : in   std_logic;
    ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
    GT9_TXUSRCLK_IN                         : in   std_logic;
    GT9_TXUSRCLK2_IN                        : in   std_logic;
    --------------- Transmit Ports - TX Configurable Driver Ports --------------
    GT9_TXDIFFCTRL_IN                       : in   std_logic_vector(3 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    GT9_TXDATA_IN                           : in   std_logic_vector(15 downto 0);
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    GT9_GTXTXN_OUT                          : out  std_logic;
    GT9_GTXTXP_OUT                          : out  std_logic;
    ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
    GT9_TXOUTCLK_OUT                        : out  std_logic;
    GT9_TXOUTCLKFABRIC_OUT                  : out  std_logic;
    GT9_TXOUTCLKPCS_OUT                     : out  std_logic;
    --------------------- Transmit Ports - TX Gearbox Ports --------------------
    GT9_TXCHARISK_IN                        : in   std_logic_vector(1 downto 0);
    ------------- Transmit Ports - TX Initialization and Reset Ports -----------
    GT9_TXRESETDONE_OUT                     : out  std_logic;
    ------------------ Transmit Ports - pattern Generator Ports ----------------
    GT9_TXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);
   
    --_________________________________________________________________________
        --GT10  (X1Y10)
    --____________________________CHANNEL PORTS________________________________
    ---------------------------- Channel - DRP Ports  --------------------------
    GT10_DRPADDR_IN                         : in   std_logic_vector(8 downto 0);
    GT10_DRPCLK_IN                          : in   std_logic;
    GT10_DRPDI_IN                           : in   std_logic_vector(15 downto 0);
    GT10_DRPDO_OUT                          : out  std_logic_vector(15 downto 0);
    GT10_DRPEN_IN                           : in   std_logic;
    GT10_DRPRDY_OUT                         : out  std_logic;
    GT10_DRPWE_IN                           : in   std_logic;
    ------------------------------- Loopback Ports -----------------------------
    GT10_LOOPBACK_IN                        : in   std_logic_vector(2 downto 0);
    --------------------- RX Initialization and Reset Ports --------------------
    GT10_RXUSERRDY_IN                       : in   std_logic;
    -------------------------- RX Margin Analysis Ports ------------------------
    GT10_EYESCANDATAERROR_OUT               : out  std_logic;
    ------------------------- Receive Ports - CDR Ports ------------------------
    GT10_RXCDRLOCK_OUT                      : out  std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    GT10_RXCLKCORCNT_OUT                    : out  std_logic_vector(1 downto 0);
    ------------------ Receive Ports - FPGA RX Interface Ports -----------------
    GT10_RXUSRCLK_IN                        : in   std_logic;
    GT10_RXUSRCLK2_IN                       : in   std_logic;
    ------------------ Receive Ports - FPGA RX interface Ports -----------------
    GT10_RXDATA_OUT                         : out  std_logic_vector(15 downto 0);
    ------------------- Receive Ports - Pattern Checker Ports ------------------
    GT10_RXPRBSERR_OUT                      : out  std_logic;
    GT10_RXPRBSSEL_IN                       : in   std_logic_vector(2 downto 0);
    ------------------- Receive Ports - Pattern Checker ports ------------------
    GT10_RXPRBSCNTRESET_IN                  : in   std_logic;
    ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
    GT10_RXDISPERR_OUT                      : out  std_logic_vector(1 downto 0);
    GT10_RXNOTINTABLE_OUT                   : out  std_logic_vector(1 downto 0);
    --------------------------- Receive Ports - RX AFE -------------------------
    GT10_GTXRXP_IN                          : in   std_logic;
    ------------------------ Receive Ports - RX AFE Ports ----------------------
    GT10_GTXRXN_IN                          : in   std_logic;
    -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
    GT10_RXMCOMMAALIGNEN_IN                 : in   std_logic;
    GT10_RXPCOMMAALIGNEN_IN                 : in   std_logic;
    --------------------- Receive Ports - RX Equalizer Ports -------------------
    GT10_RXDFELPMRESET_IN                   : in   std_logic;
    GT10_RXMONITOROUT_OUT                   : out  std_logic_vector(6 downto 0);
    GT10_RXMONITORSEL_IN                    : in   std_logic_vector(1 downto 0);
    ------------- Receive Ports - RX Initialization and Reset Ports ------------
    GT10_GTRXRESET_IN                       : in   std_logic;
    GT10_RXPMARESET_IN                      : in   std_logic;
    ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
    GT10_RXCHARISCOMMA_OUT                  : out  std_logic_vector(1 downto 0);
    GT10_RXCHARISK_OUT                      : out  std_logic_vector(1 downto 0);
    -------------- Receive Ports -RX Initialization and Reset Ports ------------
    GT10_RXRESETDONE_OUT                    : out  std_logic;
    --------------------- TX Initialization and Reset Ports --------------------
    GT10_GTTXRESET_IN                       : in   std_logic;
    GT10_TXUSERRDY_IN                       : in   std_logic;
    ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
    GT10_TXUSRCLK_IN                        : in   std_logic;
    GT10_TXUSRCLK2_IN                       : in   std_logic;
    --------------- Transmit Ports - TX Configurable Driver Ports --------------
    GT10_TXDIFFCTRL_IN                      : in   std_logic_vector(3 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    GT10_TXDATA_IN                          : in   std_logic_vector(15 downto 0);
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    GT10_GTXTXN_OUT                         : out  std_logic;
    GT10_GTXTXP_OUT                         : out  std_logic;
    ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
    GT10_TXOUTCLK_OUT                       : out  std_logic;
    GT10_TXOUTCLKFABRIC_OUT                 : out  std_logic;
    GT10_TXOUTCLKPCS_OUT                    : out  std_logic;
    --------------------- Transmit Ports - TX Gearbox Ports --------------------
    GT10_TXCHARISK_IN                       : in   std_logic_vector(1 downto 0);
    ------------- Transmit Ports - TX Initialization and Reset Ports -----------
    GT10_TXRESETDONE_OUT                    : out  std_logic;
    ------------------ Transmit Ports - pattern Generator Ports ----------------
    GT10_TXPRBSSEL_IN                       : in   std_logic_vector(2 downto 0);
   
    --_________________________________________________________________________
        --GT11  (X1Y11)
    --____________________________CHANNEL PORTS________________________________
    ---------------------------- Channel - DRP Ports  --------------------------
    GT11_DRPADDR_IN                         : in   std_logic_vector(8 downto 0);
    GT11_DRPCLK_IN                          : in   std_logic;
    GT11_DRPDI_IN                           : in   std_logic_vector(15 downto 0);
    GT11_DRPDO_OUT                          : out  std_logic_vector(15 downto 0);
    GT11_DRPEN_IN                           : in   std_logic;
    GT11_DRPRDY_OUT                         : out  std_logic;
    GT11_DRPWE_IN                           : in   std_logic;
    ------------------------------- Loopback Ports -----------------------------
    GT11_LOOPBACK_IN                        : in   std_logic_vector(2 downto 0);
    --------------------- RX Initialization and Reset Ports --------------------
    GT11_RXUSERRDY_IN                       : in   std_logic;
    -------------------------- RX Margin Analysis Ports ------------------------
    GT11_EYESCANDATAERROR_OUT               : out  std_logic;
    ------------------------- Receive Ports - CDR Ports ------------------------
    GT11_RXCDRLOCK_OUT                      : out  std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    GT11_RXCLKCORCNT_OUT                    : out  std_logic_vector(1 downto 0);
    ------------------ Receive Ports - FPGA RX Interface Ports -----------------
    GT11_RXUSRCLK_IN                        : in   std_logic;
    GT11_RXUSRCLK2_IN                       : in   std_logic;
    ------------------ Receive Ports - FPGA RX interface Ports -----------------
    GT11_RXDATA_OUT                         : out  std_logic_vector(15 downto 0);
    ------------------- Receive Ports - Pattern Checker Ports ------------------
    GT11_RXPRBSERR_OUT                      : out  std_logic;
    GT11_RXPRBSSEL_IN                       : in   std_logic_vector(2 downto 0);
    ------------------- Receive Ports - Pattern Checker ports ------------------
    GT11_RXPRBSCNTRESET_IN                  : in   std_logic;
    ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
    GT11_RXDISPERR_OUT                      : out  std_logic_vector(1 downto 0);
    GT11_RXNOTINTABLE_OUT                   : out  std_logic_vector(1 downto 0);
    --------------------------- Receive Ports - RX AFE -------------------------
    GT11_GTXRXP_IN                          : in   std_logic;
    ------------------------ Receive Ports - RX AFE Ports ----------------------
    GT11_GTXRXN_IN                          : in   std_logic;
    -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
    GT11_RXMCOMMAALIGNEN_IN                 : in   std_logic;
    GT11_RXPCOMMAALIGNEN_IN                 : in   std_logic;
    --------------------- Receive Ports - RX Equalizer Ports -------------------
    GT11_RXDFELPMRESET_IN                   : in   std_logic;
    GT11_RXMONITOROUT_OUT                   : out  std_logic_vector(6 downto 0);
    GT11_RXMONITORSEL_IN                    : in   std_logic_vector(1 downto 0);
    ------------- Receive Ports - RX Initialization and Reset Ports ------------
    GT11_GTRXRESET_IN                       : in   std_logic;
    GT11_RXPMARESET_IN                      : in   std_logic;
    ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
    GT11_RXCHARISCOMMA_OUT                  : out  std_logic_vector(1 downto 0);
    GT11_RXCHARISK_OUT                      : out  std_logic_vector(1 downto 0);
    -------------- Receive Ports -RX Initialization and Reset Ports ------------
    GT11_RXRESETDONE_OUT                    : out  std_logic;
    --------------------- TX Initialization and Reset Ports --------------------
    GT11_GTTXRESET_IN                       : in   std_logic;
    GT11_TXUSERRDY_IN                       : in   std_logic;
    ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
    GT11_TXUSRCLK_IN                        : in   std_logic;
    GT11_TXUSRCLK2_IN                       : in   std_logic;
    --------------- Transmit Ports - TX Configurable Driver Ports --------------
    GT11_TXDIFFCTRL_IN                      : in   std_logic_vector(3 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    GT11_TXDATA_IN                          : in   std_logic_vector(15 downto 0);
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    GT11_GTXTXN_OUT                         : out  std_logic;
    GT11_GTXTXP_OUT                         : out  std_logic;
    ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
    GT11_TXOUTCLK_OUT                       : out  std_logic;
    GT11_TXOUTCLKFABRIC_OUT                 : out  std_logic;
    GT11_TXOUTCLKPCS_OUT                    : out  std_logic;
    --------------------- Transmit Ports - TX Gearbox Ports --------------------
    GT11_TXCHARISK_IN                       : in   std_logic_vector(1 downto 0);
    ------------- Transmit Ports - TX Initialization and Reset Ports -----------
    GT11_TXRESETDONE_OUT                    : out  std_logic;
    ------------------ Transmit Ports - pattern Generator Ports ----------------
    GT11_TXPRBSSEL_IN                       : in   std_logic_vector(2 downto 0);
   

    --____________________________COMMON PORTS________________________________
    ---------------------- Common Block  - Ref Clock Ports ---------------------
    GT0_GTREFCLK0_COMMON_IN                 : in   std_logic;
    ------------------------- Common Block - QPLL Ports ------------------------
    GT0_QPLLLOCK_OUT                        : out  std_logic;
    GT0_QPLLLOCKDETCLK_IN                   : in   std_logic;
    GT0_QPLLRESET_IN                        : in   std_logic;

    --____________________________COMMON PORTS________________________________
    ---------------------- Common Block  - Ref Clock Ports ---------------------
    GT1_GTREFCLK0_COMMON_IN                 : in   std_logic;
    ------------------------- Common Block - QPLL Ports ------------------------
    GT1_QPLLLOCK_OUT                        : out  std_logic;
    GT1_QPLLLOCKDETCLK_IN                   : in   std_logic;
    GT1_QPLLRESET_IN                        : in   std_logic;

    --____________________________COMMON PORTS________________________________
    ---------------------- Common Block  - Ref Clock Ports ---------------------
    GT2_GTREFCLK0_COMMON_IN                 : in   std_logic;
    ------------------------- Common Block - QPLL Ports ------------------------
    GT2_QPLLLOCK_OUT                        : out  std_logic;
    GT2_QPLLLOCKDETCLK_IN                   : in   std_logic;
    GT2_QPLLRESET_IN                        : in   std_logic


);
end component;

component AMC_GTXv_GT_USRCLK_SOURCE 
port
(
    Q1_CLK1_GTREFCLK_PAD_N_IN               : in   std_logic;
    Q1_CLK1_GTREFCLK_PAD_P_IN               : in   std_logic;
    Q1_CLK1_GTREFCLK_OUT                    : out  std_logic;
 
    GT0_TXUSRCLK_OUT             : out std_logic;
    GT0_TXUSRCLK2_OUT            : out std_logic;
    GT0_TXOUTCLK_IN              : in  std_logic;
    GT0_RXUSRCLK_OUT             : out std_logic;
    GT0_RXUSRCLK2_OUT            : out std_logic;
 
    GT1_TXUSRCLK_OUT             : out std_logic;
    GT1_TXUSRCLK2_OUT            : out std_logic;
    GT1_TXOUTCLK_IN              : in  std_logic;
    GT1_RXUSRCLK_OUT             : out std_logic;
    GT1_RXUSRCLK2_OUT            : out std_logic;
 
    GT2_TXUSRCLK_OUT             : out std_logic;
    GT2_TXUSRCLK2_OUT            : out std_logic;
    GT2_TXOUTCLK_IN              : in  std_logic;
    GT2_RXUSRCLK_OUT             : out std_logic;
    GT2_RXUSRCLK2_OUT            : out std_logic;
 
    GT3_TXUSRCLK_OUT             : out std_logic;
    GT3_TXUSRCLK2_OUT            : out std_logic;
    GT3_TXOUTCLK_IN              : in  std_logic;
    GT3_RXUSRCLK_OUT             : out std_logic;
    GT3_RXUSRCLK2_OUT            : out std_logic;
 
    GT4_TXUSRCLK_OUT             : out std_logic;
    GT4_TXUSRCLK2_OUT            : out std_logic;
    GT4_TXOUTCLK_IN              : in  std_logic;
    GT4_RXUSRCLK_OUT             : out std_logic;
    GT4_RXUSRCLK2_OUT            : out std_logic;
 
    GT5_TXUSRCLK_OUT             : out std_logic;
    GT5_TXUSRCLK2_OUT            : out std_logic;
    GT5_TXOUTCLK_IN              : in  std_logic;
    GT5_RXUSRCLK_OUT             : out std_logic;
    GT5_RXUSRCLK2_OUT            : out std_logic;
 
    GT6_TXUSRCLK_OUT             : out std_logic;
    GT6_TXUSRCLK2_OUT            : out std_logic;
    GT6_TXOUTCLK_IN              : in  std_logic;
    GT6_RXUSRCLK_OUT             : out std_logic;
    GT6_RXUSRCLK2_OUT            : out std_logic;
 
    GT7_TXUSRCLK_OUT             : out std_logic;
    GT7_TXUSRCLK2_OUT            : out std_logic;
    GT7_TXOUTCLK_IN              : in  std_logic;
    GT7_RXUSRCLK_OUT             : out std_logic;
    GT7_RXUSRCLK2_OUT            : out std_logic;
 
    GT8_TXUSRCLK_OUT             : out std_logic;
    GT8_TXUSRCLK2_OUT            : out std_logic;
    GT8_TXOUTCLK_IN              : in  std_logic;
    GT8_RXUSRCLK_OUT             : out std_logic;
    GT8_RXUSRCLK2_OUT            : out std_logic;
 
    GT9_TXUSRCLK_OUT             : out std_logic;
    GT9_TXUSRCLK2_OUT            : out std_logic;
    GT9_TXOUTCLK_IN              : in  std_logic;
    GT9_RXUSRCLK_OUT             : out std_logic;
    GT9_RXUSRCLK2_OUT            : out std_logic;
 
    GT10_TXUSRCLK_OUT             : out std_logic;
    GT10_TXUSRCLK2_OUT            : out std_logic;
    GT10_TXOUTCLK_IN              : in  std_logic;
    GT10_RXUSRCLK_OUT             : out std_logic;
    GT10_RXUSRCLK2_OUT            : out std_logic;
 
    GT11_TXUSRCLK_OUT             : out std_logic;
    GT11_TXUSRCLK2_OUT            : out std_logic;
    GT11_TXOUTCLK_IN              : in  std_logic;
    GT11_RXUSRCLK_OUT             : out std_logic;
    GT11_RXUSRCLK2_OUT            : out std_logic;
    DRPCLK_IN                          : in  std_logic;
    DRPCLK_OUT                         : out std_logic
);
end component;




component AMC_GTXv_GT_FRAME_GEN 
generic
(
     WORDS_IN_BRAM    : integer := 512
);
port
(
    -- User Interface
    TX_DATA_OUT             : out   std_logic_vector(79 downto 0);
    TXCTRL_OUT              : out   std_logic_vector(7 downto 0); 
    -- System Interface
    USER_CLK                : in    std_logic;      
    SYSTEM_RESET            : in    std_logic
); 
end component;

component AMC_GTXv_GT_FRAME_CHECK 
generic
(
    RX_DATA_WIDTH            : integer := 16;
    RXCTRL_WIDTH             : integer := 2; 
    WORDS_IN_BRAM            : integer := 256;
    CHANBOND_SEQ_LEN         : integer := 1;
    COMMA_DOUBLE             : std_logic_vector(15 downto 0) := x"f628";
    START_OF_PACKET_CHAR     : std_logic_vector(15 downto 0) := x"02bc"
);
port
(
    -- User Interface
    RX_DATA_IN               : in  std_logic_vector((RX_DATA_WIDTH-1) downto 0);
    RXCTRL_IN                : in  std_logic_vector((RXCTRL_WIDTH-1) downto 0); 
    RXENMCOMMADET_OUT        : out std_logic;
    RXENPCOMMADET_OUT        : out std_logic;
    RX_ENCHAN_SYNC_OUT       : out std_logic;
    RX_CHANBOND_SEQ_IN       : in  std_logic;

    -- Control Interface
    INC_IN                   : in  std_logic; 
    INC_OUT                  : out std_logic; 
    PATTERN_MATCHB_OUT       : out std_logic;
    RESET_ON_ERROR_IN        : in  std_logic;


    -- Error Monitoring
    ERROR_COUNT_OUT          : out std_logic_vector(7 downto 0);

    -- Track Data
    TRACK_DATA_OUT           : out std_logic;

 

    -- System Interface
    USER_CLK                 : in std_logic;       
    SYSTEM_RESET             : in std_logic
);
end component;

--***********************************Parameter Declarations********************

    constant DLY : time := 1 ns;

--************************** Register Declarations ****************************

    signal   gt0_txfsmresetdone_i            : std_logic;
signal   gt0_rxfsmresetdone_i            : std_logic;
    signal   gt0_txfsmresetdone_r            : std_logic;
    signal   gt0_txfsmresetdone_r2           : std_logic;
signal   gt0_rxresetdone_r               : std_logic;
signal   gt0_rxresetdone_r2              : std_logic;
signal   gt0_rxresetdone_r3              : std_logic;


    signal   gt1_txfsmresetdone_i            : std_logic;
signal   gt1_rxfsmresetdone_i            : std_logic;
    signal   gt1_txfsmresetdone_r            : std_logic;
    signal   gt1_txfsmresetdone_r2           : std_logic;
signal   gt1_rxresetdone_r               : std_logic;
signal   gt1_rxresetdone_r2              : std_logic;
signal   gt1_rxresetdone_r3              : std_logic;


    signal   gt2_txfsmresetdone_i            : std_logic;
signal   gt2_rxfsmresetdone_i            : std_logic;
    signal   gt2_txfsmresetdone_r            : std_logic;
    signal   gt2_txfsmresetdone_r2           : std_logic;
signal   gt2_rxresetdone_r               : std_logic;
signal   gt2_rxresetdone_r2              : std_logic;
signal   gt2_rxresetdone_r3              : std_logic;


    signal   gt3_txfsmresetdone_i            : std_logic;
signal   gt3_rxfsmresetdone_i            : std_logic;
    signal   gt3_txfsmresetdone_r            : std_logic;
    signal   gt3_txfsmresetdone_r2           : std_logic;
signal   gt3_rxresetdone_r               : std_logic;
signal   gt3_rxresetdone_r2              : std_logic;
signal   gt3_rxresetdone_r3              : std_logic;


    signal   gt4_txfsmresetdone_i            : std_logic;
signal   gt4_rxfsmresetdone_i            : std_logic;
    signal   gt4_txfsmresetdone_r            : std_logic;
    signal   gt4_txfsmresetdone_r2           : std_logic;
signal   gt4_rxresetdone_r               : std_logic;
signal   gt4_rxresetdone_r2              : std_logic;
signal   gt4_rxresetdone_r3              : std_logic;


    signal   gt5_txfsmresetdone_i            : std_logic;
signal   gt5_rxfsmresetdone_i            : std_logic;
    signal   gt5_txfsmresetdone_r            : std_logic;
    signal   gt5_txfsmresetdone_r2           : std_logic;
signal   gt5_rxresetdone_r               : std_logic;
signal   gt5_rxresetdone_r2              : std_logic;
signal   gt5_rxresetdone_r3              : std_logic;


    signal   gt6_txfsmresetdone_i            : std_logic;
signal   gt6_rxfsmresetdone_i            : std_logic;
    signal   gt6_txfsmresetdone_r            : std_logic;
    signal   gt6_txfsmresetdone_r2           : std_logic;
signal   gt6_rxresetdone_r               : std_logic;
signal   gt6_rxresetdone_r2              : std_logic;
signal   gt6_rxresetdone_r3              : std_logic;


    signal   gt7_txfsmresetdone_i            : std_logic;
signal   gt7_rxfsmresetdone_i            : std_logic;
    signal   gt7_txfsmresetdone_r            : std_logic;
    signal   gt7_txfsmresetdone_r2           : std_logic;
signal   gt7_rxresetdone_r               : std_logic;
signal   gt7_rxresetdone_r2              : std_logic;
signal   gt7_rxresetdone_r3              : std_logic;


    signal   gt8_txfsmresetdone_i            : std_logic;
signal   gt8_rxfsmresetdone_i            : std_logic;
    signal   gt8_txfsmresetdone_r            : std_logic;
    signal   gt8_txfsmresetdone_r2           : std_logic;
signal   gt8_rxresetdone_r               : std_logic;
signal   gt8_rxresetdone_r2              : std_logic;
signal   gt8_rxresetdone_r3              : std_logic;


    signal   gt9_txfsmresetdone_i            : std_logic;
signal   gt9_rxfsmresetdone_i            : std_logic;
    signal   gt9_txfsmresetdone_r            : std_logic;
    signal   gt9_txfsmresetdone_r2           : std_logic;
signal   gt9_rxresetdone_r               : std_logic;
signal   gt9_rxresetdone_r2              : std_logic;
signal   gt9_rxresetdone_r3              : std_logic;


    signal   gt10_txfsmresetdone_i           : std_logic;
signal   gt10_rxfsmresetdone_i           : std_logic;
    signal   gt10_txfsmresetdone_r           : std_logic;
    signal   gt10_txfsmresetdone_r2          : std_logic;
signal   gt10_rxresetdone_r              : std_logic;
signal   gt10_rxresetdone_r2             : std_logic;
signal   gt10_rxresetdone_r3             : std_logic;


    signal   gt11_txfsmresetdone_i           : std_logic;
signal   gt11_rxfsmresetdone_i           : std_logic;
    signal   gt11_txfsmresetdone_r           : std_logic;
    signal   gt11_txfsmresetdone_r2          : std_logic;
signal   gt11_rxresetdone_r              : std_logic;
signal   gt11_rxresetdone_r2             : std_logic;
signal   gt11_rxresetdone_r3             : std_logic;


signal   reset_pulse                     : std_logic_vector(3 downto 0);
    signal   reset_counter  :   unsigned(5 downto 0) := "000000";


--**************************** Wire Declarations ******************************
    -------------------------- GT Wrapper Wires ------------------------------
    --________________________________________________________________________
    --________________________________________________________________________
    --GT0  (X1Y0)

    ---------------------------- Channel - DRP Ports  --------------------------
    signal  gt0_drpaddr_i                   : std_logic_vector(8 downto 0);
    signal  gt0_drpdi_i                     : std_logic_vector(15 downto 0);
    signal  gt0_drpdo_i                     : std_logic_vector(15 downto 0);
    signal  gt0_drpen_i                     : std_logic;
    signal  gt0_drprdy_i                    : std_logic;
    signal  gt0_drpwe_i                     : std_logic;
    ------------------------------- Loopback Ports -----------------------------
    signal  gt0_loopback_i                  : std_logic_vector(2 downto 0);
    --------------------- RX Initialization and Reset Ports --------------------
    signal  gt0_rxuserrdy_i                 : std_logic;
    -------------------------- RX Margin Analysis Ports ------------------------
    signal  gt0_eyescandataerror_i          : std_logic;
    ------------------------- Receive Ports - CDR Ports ------------------------
    signal  gt0_rxcdrlock_i                 : std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    signal  gt0_rxclkcorcnt_i               : std_logic_vector(1 downto 0);
    ------------------ Receive Ports - FPGA RX interface Ports -----------------
    signal  gt0_rxdata_i                    : std_logic_vector(15 downto 0);
    ------------------- Receive Ports - Pattern Checker Ports ------------------
    signal  gt0_rxprbserr_i                 : std_logic;
    signal  gt0_rxprbssel_i                 : std_logic_vector(2 downto 0);
    ------------------- Receive Ports - Pattern Checker ports ------------------
    signal  gt0_rxprbscntreset_i            : std_logic;
    ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
    signal  gt0_rxdisperr_i                 : std_logic_vector(1 downto 0);
    signal  gt0_rxnotintable_i              : std_logic_vector(1 downto 0);
    --------------------------- Receive Ports - RX AFE -------------------------
    signal  gt0_gtxrxp_i                    : std_logic;
    ------------------------ Receive Ports - RX AFE Ports ----------------------
    signal  gt0_gtxrxn_i                    : std_logic;
    -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
    signal  gt0_rxmcommaalignen_i           : std_logic;
    signal  gt0_rxpcommaalignen_i           : std_logic;
    --------------------- Receive Ports - RX Equalizer Ports -------------------
    signal  gt0_rxdfeagchold_i              : std_logic;
    signal  gt0_rxdfelpmreset_i             : std_logic;
    signal  gt0_rxmonitorout_i              : std_logic_vector(6 downto 0);
    signal  gt0_rxmonitorsel_i              : std_logic_vector(1 downto 0);
    --------------- Receive Ports - RX Fabric Output Control Ports -------------
    signal  gt0_rxoutclk_i                  : std_logic;
    ------------- Receive Ports - RX Initialization and Reset Ports ------------
    signal  gt0_gtrxreset_i                 : std_logic;
    signal  gt0_rxpmareset_i                : std_logic;
    ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
    signal  gt0_rxchariscomma_i             : std_logic_vector(1 downto 0);
    signal  gt0_rxcharisk_i                 : std_logic_vector(1 downto 0);
    -------------- Receive Ports -RX Initialization and Reset Ports ------------
    signal  gt0_rxresetdone_i               : std_logic;
    --------------------- TX Initialization and Reset Ports --------------------
    signal  gt0_gttxreset_i                 : std_logic;
    signal  gt0_txuserrdy_i                 : std_logic;
    --------------- Transmit Ports - TX Configurable Driver Ports --------------
    signal  gt0_txdiffctrl_i                : std_logic_vector(3 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    signal  gt0_txdata_i                    : std_logic_vector(15 downto 0);
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    signal  gt0_gtxtxn_i                    : std_logic;
    signal  gt0_gtxtxp_i                    : std_logic;
    ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
    signal  gt0_txoutclk_i                  : std_logic;
    signal  gt0_txoutclkfabric_i            : std_logic;
    signal  gt0_txoutclkpcs_i               : std_logic;
    --------------------- Transmit Ports - TX Gearbox Ports --------------------
    signal  gt0_txcharisk_i                 : std_logic_vector(1 downto 0);
    ------------- Transmit Ports - TX Initialization and Reset Ports -----------
    signal  gt0_txresetdone_i               : std_logic;
    ------------------ Transmit Ports - pattern Generator Ports ----------------
    signal  gt0_txprbssel_i                 : std_logic_vector(2 downto 0);

    --________________________________________________________________________
    --________________________________________________________________________
    --GT1  (X1Y1)

    ---------------------------- Channel - DRP Ports  --------------------------
    signal  gt1_drpaddr_i                   : std_logic_vector(8 downto 0);
    signal  gt1_drpdi_i                     : std_logic_vector(15 downto 0);
    signal  gt1_drpdo_i                     : std_logic_vector(15 downto 0);
    signal  gt1_drpen_i                     : std_logic;
    signal  gt1_drprdy_i                    : std_logic;
    signal  gt1_drpwe_i                     : std_logic;
    ------------------------------- Loopback Ports -----------------------------
    signal  gt1_loopback_i                  : std_logic_vector(2 downto 0);
    --------------------- RX Initialization and Reset Ports --------------------
    signal  gt1_rxuserrdy_i                 : std_logic;
    -------------------------- RX Margin Analysis Ports ------------------------
    signal  gt1_eyescandataerror_i          : std_logic;
    ------------------------- Receive Ports - CDR Ports ------------------------
    signal  gt1_rxcdrlock_i                 : std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    signal  gt1_rxclkcorcnt_i               : std_logic_vector(1 downto 0);
    ------------------ Receive Ports - FPGA RX interface Ports -----------------
    signal  gt1_rxdata_i                    : std_logic_vector(15 downto 0);
    ------------------- Receive Ports - Pattern Checker Ports ------------------
    signal  gt1_rxprbserr_i                 : std_logic;
    signal  gt1_rxprbssel_i                 : std_logic_vector(2 downto 0);
    ------------------- Receive Ports - Pattern Checker ports ------------------
    signal  gt1_rxprbscntreset_i            : std_logic;
    ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
    signal  gt1_rxdisperr_i                 : std_logic_vector(1 downto 0);
    signal  gt1_rxnotintable_i              : std_logic_vector(1 downto 0);
    --------------------------- Receive Ports - RX AFE -------------------------
    signal  gt1_gtxrxp_i                    : std_logic;
    ------------------------ Receive Ports - RX AFE Ports ----------------------
    signal  gt1_gtxrxn_i                    : std_logic;
    -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
    signal  gt1_rxmcommaalignen_i           : std_logic;
    signal  gt1_rxpcommaalignen_i           : std_logic;
    --------------------- Receive Ports - RX Equalizer Ports -------------------
    signal  gt1_rxdfeagchold_i              : std_logic;
    signal  gt1_rxdfelpmreset_i             : std_logic;
    signal  gt1_rxmonitorout_i              : std_logic_vector(6 downto 0);
    signal  gt1_rxmonitorsel_i              : std_logic_vector(1 downto 0);
    --------------- Receive Ports - RX Fabric Output Control Ports -------------
    signal  gt1_rxoutclk_i                  : std_logic;
    ------------- Receive Ports - RX Initialization and Reset Ports ------------
    signal  gt1_gtrxreset_i                 : std_logic;
    signal  gt1_rxpmareset_i                : std_logic;
    ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
    signal  gt1_rxchariscomma_i             : std_logic_vector(1 downto 0);
    signal  gt1_rxcharisk_i                 : std_logic_vector(1 downto 0);
    -------------- Receive Ports -RX Initialization and Reset Ports ------------
    signal  gt1_rxresetdone_i               : std_logic;
    --------------------- TX Initialization and Reset Ports --------------------
    signal  gt1_gttxreset_i                 : std_logic;
    signal  gt1_txuserrdy_i                 : std_logic;
    --------------- Transmit Ports - TX Configurable Driver Ports --------------
    signal  gt1_txdiffctrl_i                : std_logic_vector(3 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    signal  gt1_txdata_i                    : std_logic_vector(15 downto 0);
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    signal  gt1_gtxtxn_i                    : std_logic;
    signal  gt1_gtxtxp_i                    : std_logic;
    ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
    signal  gt1_txoutclk_i                  : std_logic;
    signal  gt1_txoutclkfabric_i            : std_logic;
    signal  gt1_txoutclkpcs_i               : std_logic;
    --------------------- Transmit Ports - TX Gearbox Ports --------------------
    signal  gt1_txcharisk_i                 : std_logic_vector(1 downto 0);
    ------------- Transmit Ports - TX Initialization and Reset Ports -----------
    signal  gt1_txresetdone_i               : std_logic;
    ------------------ Transmit Ports - pattern Generator Ports ----------------
    signal  gt1_txprbssel_i                 : std_logic_vector(2 downto 0);

    --________________________________________________________________________
    --________________________________________________________________________
    --GT2  (X1Y2)

    ---------------------------- Channel - DRP Ports  --------------------------
    signal  gt2_drpaddr_i                   : std_logic_vector(8 downto 0);
    signal  gt2_drpdi_i                     : std_logic_vector(15 downto 0);
    signal  gt2_drpdo_i                     : std_logic_vector(15 downto 0);
    signal  gt2_drpen_i                     : std_logic;
    signal  gt2_drprdy_i                    : std_logic;
    signal  gt2_drpwe_i                     : std_logic;
    ------------------------------- Loopback Ports -----------------------------
    signal  gt2_loopback_i                  : std_logic_vector(2 downto 0);
    --------------------- RX Initialization and Reset Ports --------------------
    signal  gt2_rxuserrdy_i                 : std_logic;
    -------------------------- RX Margin Analysis Ports ------------------------
    signal  gt2_eyescandataerror_i          : std_logic;
    ------------------------- Receive Ports - CDR Ports ------------------------
    signal  gt2_rxcdrlock_i                 : std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    signal  gt2_rxclkcorcnt_i               : std_logic_vector(1 downto 0);
    ------------------ Receive Ports - FPGA RX interface Ports -----------------
    signal  gt2_rxdata_i                    : std_logic_vector(15 downto 0);
    ------------------- Receive Ports - Pattern Checker Ports ------------------
    signal  gt2_rxprbserr_i                 : std_logic;
    signal  gt2_rxprbssel_i                 : std_logic_vector(2 downto 0);
    ------------------- Receive Ports - Pattern Checker ports ------------------
    signal  gt2_rxprbscntreset_i            : std_logic;
    ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
    signal  gt2_rxdisperr_i                 : std_logic_vector(1 downto 0);
    signal  gt2_rxnotintable_i              : std_logic_vector(1 downto 0);
    --------------------------- Receive Ports - RX AFE -------------------------
    signal  gt2_gtxrxp_i                    : std_logic;
    ------------------------ Receive Ports - RX AFE Ports ----------------------
    signal  gt2_gtxrxn_i                    : std_logic;
    -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
    signal  gt2_rxmcommaalignen_i           : std_logic;
    signal  gt2_rxpcommaalignen_i           : std_logic;
    --------------------- Receive Ports - RX Equalizer Ports -------------------
    signal  gt2_rxdfeagchold_i              : std_logic;
    signal  gt2_rxdfelpmreset_i             : std_logic;
    signal  gt2_rxmonitorout_i              : std_logic_vector(6 downto 0);
    signal  gt2_rxmonitorsel_i              : std_logic_vector(1 downto 0);
    --------------- Receive Ports - RX Fabric Output Control Ports -------------
    signal  gt2_rxoutclk_i                  : std_logic;
    ------------- Receive Ports - RX Initialization and Reset Ports ------------
    signal  gt2_gtrxreset_i                 : std_logic;
    signal  gt2_rxpmareset_i                : std_logic;
    ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
    signal  gt2_rxchariscomma_i             : std_logic_vector(1 downto 0);
    signal  gt2_rxcharisk_i                 : std_logic_vector(1 downto 0);
    -------------- Receive Ports -RX Initialization and Reset Ports ------------
    signal  gt2_rxresetdone_i               : std_logic;
    --------------------- TX Initialization and Reset Ports --------------------
    signal  gt2_gttxreset_i                 : std_logic;
    signal  gt2_txuserrdy_i                 : std_logic;
    --------------- Transmit Ports - TX Configurable Driver Ports --------------
    signal  gt2_txdiffctrl_i                : std_logic_vector(3 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    signal  gt2_txdata_i                    : std_logic_vector(15 downto 0);
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    signal  gt2_gtxtxn_i                    : std_logic;
    signal  gt2_gtxtxp_i                    : std_logic;
    ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
    signal  gt2_txoutclk_i                  : std_logic;
    signal  gt2_txoutclkfabric_i            : std_logic;
    signal  gt2_txoutclkpcs_i               : std_logic;
    --------------------- Transmit Ports - TX Gearbox Ports --------------------
    signal  gt2_txcharisk_i                 : std_logic_vector(1 downto 0);
    ------------- Transmit Ports - TX Initialization and Reset Ports -----------
    signal  gt2_txresetdone_i               : std_logic;
    ------------------ Transmit Ports - pattern Generator Ports ----------------
    signal  gt2_txprbssel_i                 : std_logic_vector(2 downto 0);

    --________________________________________________________________________
    --________________________________________________________________________
    --GT3  (X1Y3)

    ---------------------------- Channel - DRP Ports  --------------------------
    signal  gt3_drpaddr_i                   : std_logic_vector(8 downto 0);
    signal  gt3_drpdi_i                     : std_logic_vector(15 downto 0);
    signal  gt3_drpdo_i                     : std_logic_vector(15 downto 0);
    signal  gt3_drpen_i                     : std_logic;
    signal  gt3_drprdy_i                    : std_logic;
    signal  gt3_drpwe_i                     : std_logic;
    ------------------------------- Loopback Ports -----------------------------
    signal  gt3_loopback_i                  : std_logic_vector(2 downto 0);
    --------------------- RX Initialization and Reset Ports --------------------
    signal  gt3_rxuserrdy_i                 : std_logic;
    -------------------------- RX Margin Analysis Ports ------------------------
    signal  gt3_eyescandataerror_i          : std_logic;
    ------------------------- Receive Ports - CDR Ports ------------------------
    signal  gt3_rxcdrlock_i                 : std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    signal  gt3_rxclkcorcnt_i               : std_logic_vector(1 downto 0);
    ------------------ Receive Ports - FPGA RX interface Ports -----------------
    signal  gt3_rxdata_i                    : std_logic_vector(15 downto 0);
    ------------------- Receive Ports - Pattern Checker Ports ------------------
    signal  gt3_rxprbserr_i                 : std_logic;
    signal  gt3_rxprbssel_i                 : std_logic_vector(2 downto 0);
    ------------------- Receive Ports - Pattern Checker ports ------------------
    signal  gt3_rxprbscntreset_i            : std_logic;
    ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
    signal  gt3_rxdisperr_i                 : std_logic_vector(1 downto 0);
    signal  gt3_rxnotintable_i              : std_logic_vector(1 downto 0);
    --------------------------- Receive Ports - RX AFE -------------------------
    signal  gt3_gtxrxp_i                    : std_logic;
    ------------------------ Receive Ports - RX AFE Ports ----------------------
    signal  gt3_gtxrxn_i                    : std_logic;
    -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
    signal  gt3_rxmcommaalignen_i           : std_logic;
    signal  gt3_rxpcommaalignen_i           : std_logic;
    --------------------- Receive Ports - RX Equalizer Ports -------------------
    signal  gt3_rxdfeagchold_i              : std_logic;
    signal  gt3_rxdfelpmreset_i             : std_logic;
    signal  gt3_rxmonitorout_i              : std_logic_vector(6 downto 0);
    signal  gt3_rxmonitorsel_i              : std_logic_vector(1 downto 0);
    --------------- Receive Ports - RX Fabric Output Control Ports -------------
    signal  gt3_rxoutclk_i                  : std_logic;
    ------------- Receive Ports - RX Initialization and Reset Ports ------------
    signal  gt3_gtrxreset_i                 : std_logic;
    signal  gt3_rxpmareset_i                : std_logic;
    ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
    signal  gt3_rxchariscomma_i             : std_logic_vector(1 downto 0);
    signal  gt3_rxcharisk_i                 : std_logic_vector(1 downto 0);
    -------------- Receive Ports -RX Initialization and Reset Ports ------------
    signal  gt3_rxresetdone_i               : std_logic;
    --------------------- TX Initialization and Reset Ports --------------------
    signal  gt3_gttxreset_i                 : std_logic;
    signal  gt3_txuserrdy_i                 : std_logic;
    --------------- Transmit Ports - TX Configurable Driver Ports --------------
    signal  gt3_txdiffctrl_i                : std_logic_vector(3 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    signal  gt3_txdata_i                    : std_logic_vector(15 downto 0);
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    signal  gt3_gtxtxn_i                    : std_logic;
    signal  gt3_gtxtxp_i                    : std_logic;
    ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
    signal  gt3_txoutclk_i                  : std_logic;
    signal  gt3_txoutclkfabric_i            : std_logic;
    signal  gt3_txoutclkpcs_i               : std_logic;
    --------------------- Transmit Ports - TX Gearbox Ports --------------------
    signal  gt3_txcharisk_i                 : std_logic_vector(1 downto 0);
    ------------- Transmit Ports - TX Initialization and Reset Ports -----------
    signal  gt3_txresetdone_i               : std_logic;
    ------------------ Transmit Ports - pattern Generator Ports ----------------
    signal  gt3_txprbssel_i                 : std_logic_vector(2 downto 0);

    --________________________________________________________________________
    --________________________________________________________________________
    --GT4  (X1Y4)

    ---------------------------- Channel - DRP Ports  --------------------------
    signal  gt4_drpaddr_i                   : std_logic_vector(8 downto 0);
    signal  gt4_drpdi_i                     : std_logic_vector(15 downto 0);
    signal  gt4_drpdo_i                     : std_logic_vector(15 downto 0);
    signal  gt4_drpen_i                     : std_logic;
    signal  gt4_drprdy_i                    : std_logic;
    signal  gt4_drpwe_i                     : std_logic;
    ------------------------------- Loopback Ports -----------------------------
    signal  gt4_loopback_i                  : std_logic_vector(2 downto 0);
    --------------------- RX Initialization and Reset Ports --------------------
    signal  gt4_rxuserrdy_i                 : std_logic;
    -------------------------- RX Margin Analysis Ports ------------------------
    signal  gt4_eyescandataerror_i          : std_logic;
    ------------------------- Receive Ports - CDR Ports ------------------------
    signal  gt4_rxcdrlock_i                 : std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    signal  gt4_rxclkcorcnt_i               : std_logic_vector(1 downto 0);
    ------------------ Receive Ports - FPGA RX interface Ports -----------------
    signal  gt4_rxdata_i                    : std_logic_vector(15 downto 0);
    ------------------- Receive Ports - Pattern Checker Ports ------------------
    signal  gt4_rxprbserr_i                 : std_logic;
    signal  gt4_rxprbssel_i                 : std_logic_vector(2 downto 0);
    ------------------- Receive Ports - Pattern Checker ports ------------------
    signal  gt4_rxprbscntreset_i            : std_logic;
    ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
    signal  gt4_rxdisperr_i                 : std_logic_vector(1 downto 0);
    signal  gt4_rxnotintable_i              : std_logic_vector(1 downto 0);
    --------------------------- Receive Ports - RX AFE -------------------------
    signal  gt4_gtxrxp_i                    : std_logic;
    ------------------------ Receive Ports - RX AFE Ports ----------------------
    signal  gt4_gtxrxn_i                    : std_logic;
    -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
    signal  gt4_rxmcommaalignen_i           : std_logic;
    signal  gt4_rxpcommaalignen_i           : std_logic;
    --------------------- Receive Ports - RX Equalizer Ports -------------------
    signal  gt4_rxdfeagchold_i              : std_logic;
    signal  gt4_rxdfelpmreset_i             : std_logic;
    signal  gt4_rxmonitorout_i              : std_logic_vector(6 downto 0);
    signal  gt4_rxmonitorsel_i              : std_logic_vector(1 downto 0);
    --------------- Receive Ports - RX Fabric Output Control Ports -------------
    signal  gt4_rxoutclk_i                  : std_logic;
    ------------- Receive Ports - RX Initialization and Reset Ports ------------
    signal  gt4_gtrxreset_i                 : std_logic;
    signal  gt4_rxpmareset_i                : std_logic;
    ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
    signal  gt4_rxchariscomma_i             : std_logic_vector(1 downto 0);
    signal  gt4_rxcharisk_i                 : std_logic_vector(1 downto 0);
    -------------- Receive Ports -RX Initialization and Reset Ports ------------
    signal  gt4_rxresetdone_i               : std_logic;
    --------------------- TX Initialization and Reset Ports --------------------
    signal  gt4_gttxreset_i                 : std_logic;
    signal  gt4_txuserrdy_i                 : std_logic;
    --------------- Transmit Ports - TX Configurable Driver Ports --------------
    signal  gt4_txdiffctrl_i                : std_logic_vector(3 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    signal  gt4_txdata_i                    : std_logic_vector(15 downto 0);
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    signal  gt4_gtxtxn_i                    : std_logic;
    signal  gt4_gtxtxp_i                    : std_logic;
    ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
    signal  gt4_txoutclk_i                  : std_logic;
    signal  gt4_txoutclkfabric_i            : std_logic;
    signal  gt4_txoutclkpcs_i               : std_logic;
    --------------------- Transmit Ports - TX Gearbox Ports --------------------
    signal  gt4_txcharisk_i                 : std_logic_vector(1 downto 0);
    ------------- Transmit Ports - TX Initialization and Reset Ports -----------
    signal  gt4_txresetdone_i               : std_logic;
    ------------------ Transmit Ports - pattern Generator Ports ----------------
    signal  gt4_txprbssel_i                 : std_logic_vector(2 downto 0);

    --________________________________________________________________________
    --________________________________________________________________________
    --GT5  (X1Y5)

    ---------------------------- Channel - DRP Ports  --------------------------
    signal  gt5_drpaddr_i                   : std_logic_vector(8 downto 0);
    signal  gt5_drpdi_i                     : std_logic_vector(15 downto 0);
    signal  gt5_drpdo_i                     : std_logic_vector(15 downto 0);
    signal  gt5_drpen_i                     : std_logic;
    signal  gt5_drprdy_i                    : std_logic;
    signal  gt5_drpwe_i                     : std_logic;
    ------------------------------- Loopback Ports -----------------------------
    signal  gt5_loopback_i                  : std_logic_vector(2 downto 0);
    --------------------- RX Initialization and Reset Ports --------------------
    signal  gt5_rxuserrdy_i                 : std_logic;
    -------------------------- RX Margin Analysis Ports ------------------------
    signal  gt5_eyescandataerror_i          : std_logic;
    ------------------------- Receive Ports - CDR Ports ------------------------
    signal  gt5_rxcdrlock_i                 : std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    signal  gt5_rxclkcorcnt_i               : std_logic_vector(1 downto 0);
    ------------------ Receive Ports - FPGA RX interface Ports -----------------
    signal  gt5_rxdata_i                    : std_logic_vector(15 downto 0);
    ------------------- Receive Ports - Pattern Checker Ports ------------------
    signal  gt5_rxprbserr_i                 : std_logic;
    signal  gt5_rxprbssel_i                 : std_logic_vector(2 downto 0);
    ------------------- Receive Ports - Pattern Checker ports ------------------
    signal  gt5_rxprbscntreset_i            : std_logic;
    ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
    signal  gt5_rxdisperr_i                 : std_logic_vector(1 downto 0);
    signal  gt5_rxnotintable_i              : std_logic_vector(1 downto 0);
    --------------------------- Receive Ports - RX AFE -------------------------
    signal  gt5_gtxrxp_i                    : std_logic;
    ------------------------ Receive Ports - RX AFE Ports ----------------------
    signal  gt5_gtxrxn_i                    : std_logic;
    -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
    signal  gt5_rxmcommaalignen_i           : std_logic;
    signal  gt5_rxpcommaalignen_i           : std_logic;
    --------------------- Receive Ports - RX Equalizer Ports -------------------
    signal  gt5_rxdfeagchold_i              : std_logic;
    signal  gt5_rxdfelpmreset_i             : std_logic;
    signal  gt5_rxmonitorout_i              : std_logic_vector(6 downto 0);
    signal  gt5_rxmonitorsel_i              : std_logic_vector(1 downto 0);
    --------------- Receive Ports - RX Fabric Output Control Ports -------------
    signal  gt5_rxoutclk_i                  : std_logic;
    ------------- Receive Ports - RX Initialization and Reset Ports ------------
    signal  gt5_gtrxreset_i                 : std_logic;
    signal  gt5_rxpmareset_i                : std_logic;
    ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
    signal  gt5_rxchariscomma_i             : std_logic_vector(1 downto 0);
    signal  gt5_rxcharisk_i                 : std_logic_vector(1 downto 0);
    -------------- Receive Ports -RX Initialization and Reset Ports ------------
    signal  gt5_rxresetdone_i               : std_logic;
    --------------------- TX Initialization and Reset Ports --------------------
    signal  gt5_gttxreset_i                 : std_logic;
    signal  gt5_txuserrdy_i                 : std_logic;
    --------------- Transmit Ports - TX Configurable Driver Ports --------------
    signal  gt5_txdiffctrl_i                : std_logic_vector(3 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    signal  gt5_txdata_i                    : std_logic_vector(15 downto 0);
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    signal  gt5_gtxtxn_i                    : std_logic;
    signal  gt5_gtxtxp_i                    : std_logic;
    ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
    signal  gt5_txoutclk_i                  : std_logic;
    signal  gt5_txoutclkfabric_i            : std_logic;
    signal  gt5_txoutclkpcs_i               : std_logic;
    --------------------- Transmit Ports - TX Gearbox Ports --------------------
    signal  gt5_txcharisk_i                 : std_logic_vector(1 downto 0);
    ------------- Transmit Ports - TX Initialization and Reset Ports -----------
    signal  gt5_txresetdone_i               : std_logic;
    ------------------ Transmit Ports - pattern Generator Ports ----------------
    signal  gt5_txprbssel_i                 : std_logic_vector(2 downto 0);

    --________________________________________________________________________
    --________________________________________________________________________
    --GT6  (X1Y6)

    ---------------------------- Channel - DRP Ports  --------------------------
    signal  gt6_drpaddr_i                   : std_logic_vector(8 downto 0);
    signal  gt6_drpdi_i                     : std_logic_vector(15 downto 0);
    signal  gt6_drpdo_i                     : std_logic_vector(15 downto 0);
    signal  gt6_drpen_i                     : std_logic;
    signal  gt6_drprdy_i                    : std_logic;
    signal  gt6_drpwe_i                     : std_logic;
    ------------------------------- Loopback Ports -----------------------------
    signal  gt6_loopback_i                  : std_logic_vector(2 downto 0);
    --------------------- RX Initialization and Reset Ports --------------------
    signal  gt6_rxuserrdy_i                 : std_logic;
    -------------------------- RX Margin Analysis Ports ------------------------
    signal  gt6_eyescandataerror_i          : std_logic;
    ------------------------- Receive Ports - CDR Ports ------------------------
    signal  gt6_rxcdrlock_i                 : std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    signal  gt6_rxclkcorcnt_i               : std_logic_vector(1 downto 0);
    ------------------ Receive Ports - FPGA RX interface Ports -----------------
    signal  gt6_rxdata_i                    : std_logic_vector(15 downto 0);
    ------------------- Receive Ports - Pattern Checker Ports ------------------
    signal  gt6_rxprbserr_i                 : std_logic;
    signal  gt6_rxprbssel_i                 : std_logic_vector(2 downto 0);
    ------------------- Receive Ports - Pattern Checker ports ------------------
    signal  gt6_rxprbscntreset_i            : std_logic;
    ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
    signal  gt6_rxdisperr_i                 : std_logic_vector(1 downto 0);
    signal  gt6_rxnotintable_i              : std_logic_vector(1 downto 0);
    --------------------------- Receive Ports - RX AFE -------------------------
    signal  gt6_gtxrxp_i                    : std_logic;
    ------------------------ Receive Ports - RX AFE Ports ----------------------
    signal  gt6_gtxrxn_i                    : std_logic;
    -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
    signal  gt6_rxmcommaalignen_i           : std_logic;
    signal  gt6_rxpcommaalignen_i           : std_logic;
    --------------------- Receive Ports - RX Equalizer Ports -------------------
    signal  gt6_rxdfeagchold_i              : std_logic;
    signal  gt6_rxdfelpmreset_i             : std_logic;
    signal  gt6_rxmonitorout_i              : std_logic_vector(6 downto 0);
    signal  gt6_rxmonitorsel_i              : std_logic_vector(1 downto 0);
    --------------- Receive Ports - RX Fabric Output Control Ports -------------
    signal  gt6_rxoutclk_i                  : std_logic;
    ------------- Receive Ports - RX Initialization and Reset Ports ------------
    signal  gt6_gtrxreset_i                 : std_logic;
    signal  gt6_rxpmareset_i                : std_logic;
    ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
    signal  gt6_rxchariscomma_i             : std_logic_vector(1 downto 0);
    signal  gt6_rxcharisk_i                 : std_logic_vector(1 downto 0);
    -------------- Receive Ports -RX Initialization and Reset Ports ------------
    signal  gt6_rxresetdone_i               : std_logic;
    --------------------- TX Initialization and Reset Ports --------------------
    signal  gt6_gttxreset_i                 : std_logic;
    signal  gt6_txuserrdy_i                 : std_logic;
    --------------- Transmit Ports - TX Configurable Driver Ports --------------
    signal  gt6_txdiffctrl_i                : std_logic_vector(3 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    signal  gt6_txdata_i                    : std_logic_vector(15 downto 0);
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    signal  gt6_gtxtxn_i                    : std_logic;
    signal  gt6_gtxtxp_i                    : std_logic;
    ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
    signal  gt6_txoutclk_i                  : std_logic;
    signal  gt6_txoutclkfabric_i            : std_logic;
    signal  gt6_txoutclkpcs_i               : std_logic;
    --------------------- Transmit Ports - TX Gearbox Ports --------------------
    signal  gt6_txcharisk_i                 : std_logic_vector(1 downto 0);
    ------------- Transmit Ports - TX Initialization and Reset Ports -----------
    signal  gt6_txresetdone_i               : std_logic;
    ------------------ Transmit Ports - pattern Generator Ports ----------------
    signal  gt6_txprbssel_i                 : std_logic_vector(2 downto 0);

    --________________________________________________________________________
    --________________________________________________________________________
    --GT7  (X1Y7)

    ---------------------------- Channel - DRP Ports  --------------------------
    signal  gt7_drpaddr_i                   : std_logic_vector(8 downto 0);
    signal  gt7_drpdi_i                     : std_logic_vector(15 downto 0);
    signal  gt7_drpdo_i                     : std_logic_vector(15 downto 0);
    signal  gt7_drpen_i                     : std_logic;
    signal  gt7_drprdy_i                    : std_logic;
    signal  gt7_drpwe_i                     : std_logic;
    ------------------------------- Loopback Ports -----------------------------
    signal  gt7_loopback_i                  : std_logic_vector(2 downto 0);
    --------------------- RX Initialization and Reset Ports --------------------
    signal  gt7_rxuserrdy_i                 : std_logic;
    -------------------------- RX Margin Analysis Ports ------------------------
    signal  gt7_eyescandataerror_i          : std_logic;
    ------------------------- Receive Ports - CDR Ports ------------------------
    signal  gt7_rxcdrlock_i                 : std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    signal  gt7_rxclkcorcnt_i               : std_logic_vector(1 downto 0);
    ------------------ Receive Ports - FPGA RX interface Ports -----------------
    signal  gt7_rxdata_i                    : std_logic_vector(15 downto 0);
    ------------------- Receive Ports - Pattern Checker Ports ------------------
    signal  gt7_rxprbserr_i                 : std_logic;
    signal  gt7_rxprbssel_i                 : std_logic_vector(2 downto 0);
    ------------------- Receive Ports - Pattern Checker ports ------------------
    signal  gt7_rxprbscntreset_i            : std_logic;
    ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
    signal  gt7_rxdisperr_i                 : std_logic_vector(1 downto 0);
    signal  gt7_rxnotintable_i              : std_logic_vector(1 downto 0);
    --------------------------- Receive Ports - RX AFE -------------------------
    signal  gt7_gtxrxp_i                    : std_logic;
    ------------------------ Receive Ports - RX AFE Ports ----------------------
    signal  gt7_gtxrxn_i                    : std_logic;
    -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
    signal  gt7_rxmcommaalignen_i           : std_logic;
    signal  gt7_rxpcommaalignen_i           : std_logic;
    --------------------- Receive Ports - RX Equalizer Ports -------------------
    signal  gt7_rxdfeagchold_i              : std_logic;
    signal  gt7_rxdfelpmreset_i             : std_logic;
    signal  gt7_rxmonitorout_i              : std_logic_vector(6 downto 0);
    signal  gt7_rxmonitorsel_i              : std_logic_vector(1 downto 0);
    --------------- Receive Ports - RX Fabric Output Control Ports -------------
    signal  gt7_rxoutclk_i                  : std_logic;
    ------------- Receive Ports - RX Initialization and Reset Ports ------------
    signal  gt7_gtrxreset_i                 : std_logic;
    signal  gt7_rxpmareset_i                : std_logic;
    ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
    signal  gt7_rxchariscomma_i             : std_logic_vector(1 downto 0);
    signal  gt7_rxcharisk_i                 : std_logic_vector(1 downto 0);
    -------------- Receive Ports -RX Initialization and Reset Ports ------------
    signal  gt7_rxresetdone_i               : std_logic;
    --------------------- TX Initialization and Reset Ports --------------------
    signal  gt7_gttxreset_i                 : std_logic;
    signal  gt7_txuserrdy_i                 : std_logic;
    --------------- Transmit Ports - TX Configurable Driver Ports --------------
    signal  gt7_txdiffctrl_i                : std_logic_vector(3 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    signal  gt7_txdata_i                    : std_logic_vector(15 downto 0);
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    signal  gt7_gtxtxn_i                    : std_logic;
    signal  gt7_gtxtxp_i                    : std_logic;
    ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
    signal  gt7_txoutclk_i                  : std_logic;
    signal  gt7_txoutclkfabric_i            : std_logic;
    signal  gt7_txoutclkpcs_i               : std_logic;
    --------------------- Transmit Ports - TX Gearbox Ports --------------------
    signal  gt7_txcharisk_i                 : std_logic_vector(1 downto 0);
    ------------- Transmit Ports - TX Initialization and Reset Ports -----------
    signal  gt7_txresetdone_i               : std_logic;
    ------------------ Transmit Ports - pattern Generator Ports ----------------
    signal  gt7_txprbssel_i                 : std_logic_vector(2 downto 0);

    --________________________________________________________________________
    --________________________________________________________________________
    --GT8  (X1Y8)

    ---------------------------- Channel - DRP Ports  --------------------------
    signal  gt8_drpaddr_i                   : std_logic_vector(8 downto 0);
    signal  gt8_drpdi_i                     : std_logic_vector(15 downto 0);
    signal  gt8_drpdo_i                     : std_logic_vector(15 downto 0);
    signal  gt8_drpen_i                     : std_logic;
    signal  gt8_drprdy_i                    : std_logic;
    signal  gt8_drpwe_i                     : std_logic;
    ------------------------------- Loopback Ports -----------------------------
    signal  gt8_loopback_i                  : std_logic_vector(2 downto 0);
    --------------------- RX Initialization and Reset Ports --------------------
    signal  gt8_rxuserrdy_i                 : std_logic;
    -------------------------- RX Margin Analysis Ports ------------------------
    signal  gt8_eyescandataerror_i          : std_logic;
    ------------------------- Receive Ports - CDR Ports ------------------------
    signal  gt8_rxcdrlock_i                 : std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    signal  gt8_rxclkcorcnt_i               : std_logic_vector(1 downto 0);
    ------------------ Receive Ports - FPGA RX interface Ports -----------------
    signal  gt8_rxdata_i                    : std_logic_vector(15 downto 0);
    ------------------- Receive Ports - Pattern Checker Ports ------------------
    signal  gt8_rxprbserr_i                 : std_logic;
    signal  gt8_rxprbssel_i                 : std_logic_vector(2 downto 0);
    ------------------- Receive Ports - Pattern Checker ports ------------------
    signal  gt8_rxprbscntreset_i            : std_logic;
    ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
    signal  gt8_rxdisperr_i                 : std_logic_vector(1 downto 0);
    signal  gt8_rxnotintable_i              : std_logic_vector(1 downto 0);
    --------------------------- Receive Ports - RX AFE -------------------------
    signal  gt8_gtxrxp_i                    : std_logic;
    ------------------------ Receive Ports - RX AFE Ports ----------------------
    signal  gt8_gtxrxn_i                    : std_logic;
    -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
    signal  gt8_rxmcommaalignen_i           : std_logic;
    signal  gt8_rxpcommaalignen_i           : std_logic;
    --------------------- Receive Ports - RX Equalizer Ports -------------------
    signal  gt8_rxdfeagchold_i              : std_logic;
    signal  gt8_rxdfelpmreset_i             : std_logic;
    signal  gt8_rxmonitorout_i              : std_logic_vector(6 downto 0);
    signal  gt8_rxmonitorsel_i              : std_logic_vector(1 downto 0);
    --------------- Receive Ports - RX Fabric Output Control Ports -------------
    signal  gt8_rxoutclk_i                  : std_logic;
    ------------- Receive Ports - RX Initialization and Reset Ports ------------
    signal  gt8_gtrxreset_i                 : std_logic;
    signal  gt8_rxpmareset_i                : std_logic;
    ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
    signal  gt8_rxchariscomma_i             : std_logic_vector(1 downto 0);
    signal  gt8_rxcharisk_i                 : std_logic_vector(1 downto 0);
    -------------- Receive Ports -RX Initialization and Reset Ports ------------
    signal  gt8_rxresetdone_i               : std_logic;
    --------------------- TX Initialization and Reset Ports --------------------
    signal  gt8_gttxreset_i                 : std_logic;
    signal  gt8_txuserrdy_i                 : std_logic;
    --------------- Transmit Ports - TX Configurable Driver Ports --------------
    signal  gt8_txdiffctrl_i                : std_logic_vector(3 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    signal  gt8_txdata_i                    : std_logic_vector(15 downto 0);
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    signal  gt8_gtxtxn_i                    : std_logic;
    signal  gt8_gtxtxp_i                    : std_logic;
    ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
    signal  gt8_txoutclk_i                  : std_logic;
    signal  gt8_txoutclkfabric_i            : std_logic;
    signal  gt8_txoutclkpcs_i               : std_logic;
    --------------------- Transmit Ports - TX Gearbox Ports --------------------
    signal  gt8_txcharisk_i                 : std_logic_vector(1 downto 0);
    ------------- Transmit Ports - TX Initialization and Reset Ports -----------
    signal  gt8_txresetdone_i               : std_logic;
    ------------------ Transmit Ports - pattern Generator Ports ----------------
    signal  gt8_txprbssel_i                 : std_logic_vector(2 downto 0);

    --________________________________________________________________________
    --________________________________________________________________________
    --GT9  (X1Y9)

    ---------------------------- Channel - DRP Ports  --------------------------
    signal  gt9_drpaddr_i                   : std_logic_vector(8 downto 0);
    signal  gt9_drpdi_i                     : std_logic_vector(15 downto 0);
    signal  gt9_drpdo_i                     : std_logic_vector(15 downto 0);
    signal  gt9_drpen_i                     : std_logic;
    signal  gt9_drprdy_i                    : std_logic;
    signal  gt9_drpwe_i                     : std_logic;
    ------------------------------- Loopback Ports -----------------------------
    signal  gt9_loopback_i                  : std_logic_vector(2 downto 0);
    --------------------- RX Initialization and Reset Ports --------------------
    signal  gt9_rxuserrdy_i                 : std_logic;
    -------------------------- RX Margin Analysis Ports ------------------------
    signal  gt9_eyescandataerror_i          : std_logic;
    ------------------------- Receive Ports - CDR Ports ------------------------
    signal  gt9_rxcdrlock_i                 : std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    signal  gt9_rxclkcorcnt_i               : std_logic_vector(1 downto 0);
    ------------------ Receive Ports - FPGA RX interface Ports -----------------
    signal  gt9_rxdata_i                    : std_logic_vector(15 downto 0);
    ------------------- Receive Ports - Pattern Checker Ports ------------------
    signal  gt9_rxprbserr_i                 : std_logic;
    signal  gt9_rxprbssel_i                 : std_logic_vector(2 downto 0);
    ------------------- Receive Ports - Pattern Checker ports ------------------
    signal  gt9_rxprbscntreset_i            : std_logic;
    ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
    signal  gt9_rxdisperr_i                 : std_logic_vector(1 downto 0);
    signal  gt9_rxnotintable_i              : std_logic_vector(1 downto 0);
    --------------------------- Receive Ports - RX AFE -------------------------
    signal  gt9_gtxrxp_i                    : std_logic;
    ------------------------ Receive Ports - RX AFE Ports ----------------------
    signal  gt9_gtxrxn_i                    : std_logic;
    -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
    signal  gt9_rxmcommaalignen_i           : std_logic;
    signal  gt9_rxpcommaalignen_i           : std_logic;
    --------------------- Receive Ports - RX Equalizer Ports -------------------
    signal  gt9_rxdfeagchold_i              : std_logic;
    signal  gt9_rxdfelpmreset_i             : std_logic;
    signal  gt9_rxmonitorout_i              : std_logic_vector(6 downto 0);
    signal  gt9_rxmonitorsel_i              : std_logic_vector(1 downto 0);
    --------------- Receive Ports - RX Fabric Output Control Ports -------------
    signal  gt9_rxoutclk_i                  : std_logic;
    ------------- Receive Ports - RX Initialization and Reset Ports ------------
    signal  gt9_gtrxreset_i                 : std_logic;
    signal  gt9_rxpmareset_i                : std_logic;
    ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
    signal  gt9_rxchariscomma_i             : std_logic_vector(1 downto 0);
    signal  gt9_rxcharisk_i                 : std_logic_vector(1 downto 0);
    -------------- Receive Ports -RX Initialization and Reset Ports ------------
    signal  gt9_rxresetdone_i               : std_logic;
    --------------------- TX Initialization and Reset Ports --------------------
    signal  gt9_gttxreset_i                 : std_logic;
    signal  gt9_txuserrdy_i                 : std_logic;
    --------------- Transmit Ports - TX Configurable Driver Ports --------------
    signal  gt9_txdiffctrl_i                : std_logic_vector(3 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    signal  gt9_txdata_i                    : std_logic_vector(15 downto 0);
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    signal  gt9_gtxtxn_i                    : std_logic;
    signal  gt9_gtxtxp_i                    : std_logic;
    ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
    signal  gt9_txoutclk_i                  : std_logic;
    signal  gt9_txoutclkfabric_i            : std_logic;
    signal  gt9_txoutclkpcs_i               : std_logic;
    --------------------- Transmit Ports - TX Gearbox Ports --------------------
    signal  gt9_txcharisk_i                 : std_logic_vector(1 downto 0);
    ------------- Transmit Ports - TX Initialization and Reset Ports -----------
    signal  gt9_txresetdone_i               : std_logic;
    ------------------ Transmit Ports - pattern Generator Ports ----------------
    signal  gt9_txprbssel_i                 : std_logic_vector(2 downto 0);

    --________________________________________________________________________
    --________________________________________________________________________
    --GT10  (X1Y10)

    ---------------------------- Channel - DRP Ports  --------------------------
    signal  gt10_drpaddr_i                  : std_logic_vector(8 downto 0);
    signal  gt10_drpdi_i                    : std_logic_vector(15 downto 0);
    signal  gt10_drpdo_i                    : std_logic_vector(15 downto 0);
    signal  gt10_drpen_i                    : std_logic;
    signal  gt10_drprdy_i                   : std_logic;
    signal  gt10_drpwe_i                    : std_logic;
    ------------------------------- Loopback Ports -----------------------------
    signal  gt10_loopback_i                 : std_logic_vector(2 downto 0);
    --------------------- RX Initialization and Reset Ports --------------------
    signal  gt10_rxuserrdy_i                : std_logic;
    -------------------------- RX Margin Analysis Ports ------------------------
    signal  gt10_eyescandataerror_i         : std_logic;
    ------------------------- Receive Ports - CDR Ports ------------------------
    signal  gt10_rxcdrlock_i                : std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    signal  gt10_rxclkcorcnt_i              : std_logic_vector(1 downto 0);
    ------------------ Receive Ports - FPGA RX interface Ports -----------------
    signal  gt10_rxdata_i                   : std_logic_vector(15 downto 0);
    ------------------- Receive Ports - Pattern Checker Ports ------------------
    signal  gt10_rxprbserr_i                : std_logic;
    signal  gt10_rxprbssel_i                : std_logic_vector(2 downto 0);
    ------------------- Receive Ports - Pattern Checker ports ------------------
    signal  gt10_rxprbscntreset_i           : std_logic;
    ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
    signal  gt10_rxdisperr_i                : std_logic_vector(1 downto 0);
    signal  gt10_rxnotintable_i             : std_logic_vector(1 downto 0);
    --------------------------- Receive Ports - RX AFE -------------------------
    signal  gt10_gtxrxp_i                   : std_logic;
    ------------------------ Receive Ports - RX AFE Ports ----------------------
    signal  gt10_gtxrxn_i                   : std_logic;
    -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
    signal  gt10_rxmcommaalignen_i          : std_logic;
    signal  gt10_rxpcommaalignen_i          : std_logic;
    --------------------- Receive Ports - RX Equalizer Ports -------------------
    signal  gt10_rxdfeagchold_i             : std_logic;
    signal  gt10_rxdfelpmreset_i            : std_logic;
    signal  gt10_rxmonitorout_i             : std_logic_vector(6 downto 0);
    signal  gt10_rxmonitorsel_i             : std_logic_vector(1 downto 0);
    --------------- Receive Ports - RX Fabric Output Control Ports -------------
    signal  gt10_rxoutclk_i                 : std_logic;
    ------------- Receive Ports - RX Initialization and Reset Ports ------------
    signal  gt10_gtrxreset_i                : std_logic;
    signal  gt10_rxpmareset_i               : std_logic;
    ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
    signal  gt10_rxchariscomma_i            : std_logic_vector(1 downto 0);
    signal  gt10_rxcharisk_i                : std_logic_vector(1 downto 0);
    -------------- Receive Ports -RX Initialization and Reset Ports ------------
    signal  gt10_rxresetdone_i              : std_logic;
    --------------------- TX Initialization and Reset Ports --------------------
    signal  gt10_gttxreset_i                : std_logic;
    signal  gt10_txuserrdy_i                : std_logic;
    --------------- Transmit Ports - TX Configurable Driver Ports --------------
    signal  gt10_txdiffctrl_i               : std_logic_vector(3 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    signal  gt10_txdata_i                   : std_logic_vector(15 downto 0);
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    signal  gt10_gtxtxn_i                   : std_logic;
    signal  gt10_gtxtxp_i                   : std_logic;
    ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
    signal  gt10_txoutclk_i                 : std_logic;
    signal  gt10_txoutclkfabric_i           : std_logic;
    signal  gt10_txoutclkpcs_i              : std_logic;
    --------------------- Transmit Ports - TX Gearbox Ports --------------------
    signal  gt10_txcharisk_i                : std_logic_vector(1 downto 0);
    ------------- Transmit Ports - TX Initialization and Reset Ports -----------
    signal  gt10_txresetdone_i              : std_logic;
    ------------------ Transmit Ports - pattern Generator Ports ----------------
    signal  gt10_txprbssel_i                : std_logic_vector(2 downto 0);

    --________________________________________________________________________
    --________________________________________________________________________
    --GT11  (X1Y11)

    ---------------------------- Channel - DRP Ports  --------------------------
    signal  gt11_drpaddr_i                  : std_logic_vector(8 downto 0);
    signal  gt11_drpdi_i                    : std_logic_vector(15 downto 0);
    signal  gt11_drpdo_i                    : std_logic_vector(15 downto 0);
    signal  gt11_drpen_i                    : std_logic;
    signal  gt11_drprdy_i                   : std_logic;
    signal  gt11_drpwe_i                    : std_logic;
    ------------------------------- Loopback Ports -----------------------------
    signal  gt11_loopback_i                 : std_logic_vector(2 downto 0);
    --------------------- RX Initialization and Reset Ports --------------------
    signal  gt11_rxuserrdy_i                : std_logic;
    -------------------------- RX Margin Analysis Ports ------------------------
    signal  gt11_eyescandataerror_i         : std_logic;
    ------------------------- Receive Ports - CDR Ports ------------------------
    signal  gt11_rxcdrlock_i                : std_logic;
    ------------------- Receive Ports - Clock Correction Ports -----------------
    signal  gt11_rxclkcorcnt_i              : std_logic_vector(1 downto 0);
    ------------------ Receive Ports - FPGA RX interface Ports -----------------
    signal  gt11_rxdata_i                   : std_logic_vector(15 downto 0);
    ------------------- Receive Ports - Pattern Checker Ports ------------------
    signal  gt11_rxprbserr_i                : std_logic;
    signal  gt11_rxprbssel_i                : std_logic_vector(2 downto 0);
    ------------------- Receive Ports - Pattern Checker ports ------------------
    signal  gt11_rxprbscntreset_i           : std_logic;
    ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
    signal  gt11_rxdisperr_i                : std_logic_vector(1 downto 0);
    signal  gt11_rxnotintable_i             : std_logic_vector(1 downto 0);
    --------------------------- Receive Ports - RX AFE -------------------------
    signal  gt11_gtxrxp_i                   : std_logic;
    ------------------------ Receive Ports - RX AFE Ports ----------------------
    signal  gt11_gtxrxn_i                   : std_logic;
    -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
    signal  gt11_rxmcommaalignen_i          : std_logic;
    signal  gt11_rxpcommaalignen_i          : std_logic;
    --------------------- Receive Ports - RX Equalizer Ports -------------------
    signal  gt11_rxdfeagchold_i             : std_logic;
    signal  gt11_rxdfelpmreset_i            : std_logic;
    signal  gt11_rxmonitorout_i             : std_logic_vector(6 downto 0);
    signal  gt11_rxmonitorsel_i             : std_logic_vector(1 downto 0);
    --------------- Receive Ports - RX Fabric Output Control Ports -------------
    signal  gt11_rxoutclk_i                 : std_logic;
    ------------- Receive Ports - RX Initialization and Reset Ports ------------
    signal  gt11_gtrxreset_i                : std_logic;
    signal  gt11_rxpmareset_i               : std_logic;
    ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
    signal  gt11_rxchariscomma_i            : std_logic_vector(1 downto 0);
    signal  gt11_rxcharisk_i                : std_logic_vector(1 downto 0);
    -------------- Receive Ports -RX Initialization and Reset Ports ------------
    signal  gt11_rxresetdone_i              : std_logic;
    --------------------- TX Initialization and Reset Ports --------------------
    signal  gt11_gttxreset_i                : std_logic;
    signal  gt11_txuserrdy_i                : std_logic;
    --------------- Transmit Ports - TX Configurable Driver Ports --------------
    signal  gt11_txdiffctrl_i               : std_logic_vector(3 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    signal  gt11_txdata_i                   : std_logic_vector(15 downto 0);
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    signal  gt11_gtxtxn_i                   : std_logic;
    signal  gt11_gtxtxp_i                   : std_logic;
    ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
    signal  gt11_txoutclk_i                 : std_logic;
    signal  gt11_txoutclkfabric_i           : std_logic;
    signal  gt11_txoutclkpcs_i              : std_logic;
    --------------------- Transmit Ports - TX Gearbox Ports --------------------
    signal  gt11_txcharisk_i                : std_logic_vector(1 downto 0);
    ------------- Transmit Ports - TX Initialization and Reset Ports -----------
    signal  gt11_txresetdone_i              : std_logic;
    ------------------ Transmit Ports - pattern Generator Ports ----------------
    signal  gt11_txprbssel_i                : std_logic_vector(2 downto 0);

    --____________________________COMMON PORTS________________________________
    ------------------------- Common Block - QPLL Ports ------------------------
    signal  gt0_qplllock_i                  : std_logic;
    signal  gt0_qpllrefclklost_i            : std_logic;
    signal  gt0_qpllreset_i                 : std_logic;

    --____________________________COMMON PORTS________________________________
    ------------------------- Common Block - QPLL Ports ------------------------
    signal  gt1_qplllock_i                  : std_logic;
    signal  gt1_qpllrefclklost_i            : std_logic;
    signal  gt1_qpllreset_i                 : std_logic;

    --____________________________COMMON PORTS________________________________
    ------------------------- Common Block - QPLL Ports ------------------------
    signal  gt2_qplllock_i                  : std_logic;
    signal  gt2_qpllrefclklost_i            : std_logic;
    signal  gt2_qpllreset_i                 : std_logic;


    ------------------------------- Global Signals -----------------------------
    signal  gt0_tx_system_reset_c           : std_logic;
    signal  gt0_rx_system_reset_c           : std_logic;
    signal  gt1_tx_system_reset_c           : std_logic;
    signal  gt1_rx_system_reset_c           : std_logic;
    signal  gt2_tx_system_reset_c           : std_logic;
    signal  gt2_rx_system_reset_c           : std_logic;
    signal  gt3_tx_system_reset_c           : std_logic;
    signal  gt3_rx_system_reset_c           : std_logic;
    signal  gt4_tx_system_reset_c           : std_logic;
    signal  gt4_rx_system_reset_c           : std_logic;
    signal  gt5_tx_system_reset_c           : std_logic;
    signal  gt5_rx_system_reset_c           : std_logic;
    signal  gt6_tx_system_reset_c           : std_logic;
    signal  gt6_rx_system_reset_c           : std_logic;
    signal  gt7_tx_system_reset_c           : std_logic;
    signal  gt7_rx_system_reset_c           : std_logic;
    signal  gt8_tx_system_reset_c           : std_logic;
    signal  gt8_rx_system_reset_c           : std_logic;
    signal  gt9_tx_system_reset_c           : std_logic;
    signal  gt9_rx_system_reset_c           : std_logic;
    signal  gt10_tx_system_reset_c          : std_logic;
    signal  gt10_rx_system_reset_c          : std_logic;
    signal  gt11_tx_system_reset_c          : std_logic;
    signal  gt11_rx_system_reset_c          : std_logic;
    signal  tied_to_ground_i                : std_logic;
    signal  tied_to_ground_vec_i            : std_logic_vector(63 downto 0);
    signal  tied_to_vcc_i                   : std_logic;
    signal  tied_to_vcc_vec_i               : std_logic_vector(7 downto 0);
    signal  drpclk_in_i                     : std_logic;
    signal  GTTXRESET_IN                    : std_logic;
    signal  GTRXRESET_IN                    : std_logic;
    signal  QPLLRESET_IN                    : std_logic;

    attribute keep: string;
   ------------------------------- User Clocks ---------------------------------
    signal    gt0_txusrclk_i                  : std_logic; 
    signal    gt0_txusrclk2_i                 : std_logic; 
    signal    gt0_rxusrclk_i                  : std_logic; 
    signal    gt0_rxusrclk2_i                 : std_logic; 
    attribute keep of gt0_txusrclk_i : signal is "true";
    attribute keep of gt0_txusrclk2_i : signal is "true";
    attribute keep of gt0_rxusrclk_i : signal is "true";
    attribute keep of gt0_rxusrclk2_i : signal is "true";
    signal    gt1_txusrclk_i                  : std_logic; 
    signal    gt1_txusrclk2_i                 : std_logic; 
    signal    gt1_rxusrclk_i                  : std_logic; 
    signal    gt1_rxusrclk2_i                 : std_logic; 
    attribute keep of gt1_txusrclk_i : signal is "true";
    attribute keep of gt1_txusrclk2_i : signal is "true";
    attribute keep of gt1_rxusrclk_i : signal is "true";
    attribute keep of gt1_rxusrclk2_i : signal is "true";
    signal    gt2_txusrclk_i                  : std_logic; 
    signal    gt2_txusrclk2_i                 : std_logic; 
    signal    gt2_rxusrclk_i                  : std_logic; 
    signal    gt2_rxusrclk2_i                 : std_logic; 
    attribute keep of gt2_txusrclk_i : signal is "true";
    attribute keep of gt2_txusrclk2_i : signal is "true";
    attribute keep of gt2_rxusrclk_i : signal is "true";
    attribute keep of gt2_rxusrclk2_i : signal is "true";
    signal    gt3_txusrclk_i                  : std_logic; 
    signal    gt3_txusrclk2_i                 : std_logic; 
    signal    gt3_rxusrclk_i                  : std_logic; 
    signal    gt3_rxusrclk2_i                 : std_logic; 
    attribute keep of gt3_txusrclk_i : signal is "true";
    attribute keep of gt3_txusrclk2_i : signal is "true";
    attribute keep of gt3_rxusrclk_i : signal is "true";
    attribute keep of gt3_rxusrclk2_i : signal is "true";
    signal    gt4_txusrclk_i                  : std_logic; 
    signal    gt4_txusrclk2_i                 : std_logic; 
    signal    gt4_rxusrclk_i                  : std_logic; 
    signal    gt4_rxusrclk2_i                 : std_logic; 
    attribute keep of gt4_txusrclk_i : signal is "true";
    attribute keep of gt4_txusrclk2_i : signal is "true";
    attribute keep of gt4_rxusrclk_i : signal is "true";
    attribute keep of gt4_rxusrclk2_i : signal is "true";
    signal    gt5_txusrclk_i                  : std_logic; 
    signal    gt5_txusrclk2_i                 : std_logic; 
    signal    gt5_rxusrclk_i                  : std_logic; 
    signal    gt5_rxusrclk2_i                 : std_logic; 
    attribute keep of gt5_txusrclk_i : signal is "true";
    attribute keep of gt5_txusrclk2_i : signal is "true";
    attribute keep of gt5_rxusrclk_i : signal is "true";
    attribute keep of gt5_rxusrclk2_i : signal is "true";
    signal    gt6_txusrclk_i                  : std_logic; 
    signal    gt6_txusrclk2_i                 : std_logic; 
    signal    gt6_rxusrclk_i                  : std_logic; 
    signal    gt6_rxusrclk2_i                 : std_logic; 
    attribute keep of gt6_txusrclk_i : signal is "true";
    attribute keep of gt6_txusrclk2_i : signal is "true";
    attribute keep of gt6_rxusrclk_i : signal is "true";
    attribute keep of gt6_rxusrclk2_i : signal is "true";
    signal    gt7_txusrclk_i                  : std_logic; 
    signal    gt7_txusrclk2_i                 : std_logic; 
    signal    gt7_rxusrclk_i                  : std_logic; 
    signal    gt7_rxusrclk2_i                 : std_logic; 
    attribute keep of gt7_txusrclk_i : signal is "true";
    attribute keep of gt7_txusrclk2_i : signal is "true";
    attribute keep of gt7_rxusrclk_i : signal is "true";
    attribute keep of gt7_rxusrclk2_i : signal is "true";
    signal    gt8_txusrclk_i                  : std_logic; 
    signal    gt8_txusrclk2_i                 : std_logic; 
    signal    gt8_rxusrclk_i                  : std_logic; 
    signal    gt8_rxusrclk2_i                 : std_logic; 
    attribute keep of gt8_txusrclk_i : signal is "true";
    attribute keep of gt8_txusrclk2_i : signal is "true";
    attribute keep of gt8_rxusrclk_i : signal is "true";
    attribute keep of gt8_rxusrclk2_i : signal is "true";
    signal    gt9_txusrclk_i                  : std_logic; 
    signal    gt9_txusrclk2_i                 : std_logic; 
    signal    gt9_rxusrclk_i                  : std_logic; 
    signal    gt9_rxusrclk2_i                 : std_logic; 
    attribute keep of gt9_txusrclk_i : signal is "true";
    attribute keep of gt9_txusrclk2_i : signal is "true";
    attribute keep of gt9_rxusrclk_i : signal is "true";
    attribute keep of gt9_rxusrclk2_i : signal is "true";
    signal    gt10_txusrclk_i                 : std_logic; 
    signal    gt10_txusrclk2_i                : std_logic; 
    signal    gt10_rxusrclk_i                 : std_logic; 
    signal    gt10_rxusrclk2_i                : std_logic; 
    attribute keep of gt10_txusrclk_i : signal is "true";
    attribute keep of gt10_txusrclk2_i : signal is "true";
    attribute keep of gt10_rxusrclk_i : signal is "true";
    attribute keep of gt10_rxusrclk2_i : signal is "true";
    signal    gt11_txusrclk_i                 : std_logic; 
    signal    gt11_txusrclk2_i                : std_logic; 
    signal    gt11_rxusrclk_i                 : std_logic; 
    signal    gt11_rxusrclk2_i                : std_logic; 
    attribute keep of gt11_txusrclk_i : signal is "true";
    attribute keep of gt11_txusrclk2_i : signal is "true";
    attribute keep of gt11_rxusrclk_i : signal is "true";
    attribute keep of gt11_rxusrclk2_i : signal is "true";
    ----------------------------- Reference Clocks ----------------------------
    
signal    q1_clk1_refclk_i                : std_logic;


    ----------------------- Frame check/gen Module Signals --------------------
signal    gt0_matchn_i                    : std_logic;
    
signal    gt0_txcharisk_float_i           : std_logic_vector(5 downto 0);
    
signal    gt0_txdata_float16_i            : std_logic_vector(15 downto 0);
signal    gt0_txdata_float_i              : std_logic_vector(47 downto 0);
    
signal    gt0_track_data_i                : std_logic;
signal    gt0_block_sync_i                : std_logic;
signal    gt0_error_count_i               : std_logic_vector(7 downto 0);
signal    gt0_frame_check_reset_i         : std_logic;
signal    gt0_inc_in_i                    : std_logic;
signal    gt0_inc_out_i                   : std_logic;
signal    gt0_unscrambled_data_i          : std_logic_vector(15 downto 0);

signal    gt1_matchn_i                    : std_logic;
    
signal    gt1_txcharisk_float_i           : std_logic_vector(5 downto 0);
    
signal    gt1_txdata_float16_i            : std_logic_vector(15 downto 0);
signal    gt1_txdata_float_i              : std_logic_vector(47 downto 0);
    
signal    gt1_track_data_i                : std_logic;
signal    gt1_block_sync_i                : std_logic;
signal    gt1_error_count_i               : std_logic_vector(7 downto 0);
signal    gt1_frame_check_reset_i         : std_logic;
signal    gt1_inc_in_i                    : std_logic;
signal    gt1_inc_out_i                   : std_logic;
signal    gt1_unscrambled_data_i          : std_logic_vector(15 downto 0);

signal    gt2_matchn_i                    : std_logic;
    
signal    gt2_txcharisk_float_i           : std_logic_vector(5 downto 0);
    
signal    gt2_txdata_float16_i            : std_logic_vector(15 downto 0);
signal    gt2_txdata_float_i              : std_logic_vector(47 downto 0);
    
signal    gt2_track_data_i                : std_logic;
signal    gt2_block_sync_i                : std_logic;
signal    gt2_error_count_i               : std_logic_vector(7 downto 0);
signal    gt2_frame_check_reset_i         : std_logic;
signal    gt2_inc_in_i                    : std_logic;
signal    gt2_inc_out_i                   : std_logic;
signal    gt2_unscrambled_data_i          : std_logic_vector(15 downto 0);

signal    gt3_matchn_i                    : std_logic;
    
signal    gt3_txcharisk_float_i           : std_logic_vector(5 downto 0);
    
signal    gt3_txdata_float16_i            : std_logic_vector(15 downto 0);
signal    gt3_txdata_float_i              : std_logic_vector(47 downto 0);
    
signal    gt3_track_data_i                : std_logic;
signal    gt3_block_sync_i                : std_logic;
signal    gt3_error_count_i               : std_logic_vector(7 downto 0);
signal    gt3_frame_check_reset_i         : std_logic;
signal    gt3_inc_in_i                    : std_logic;
signal    gt3_inc_out_i                   : std_logic;
signal    gt3_unscrambled_data_i          : std_logic_vector(15 downto 0);

signal    gt4_matchn_i                    : std_logic;
    
signal    gt4_txcharisk_float_i           : std_logic_vector(5 downto 0);
    
signal    gt4_txdata_float16_i            : std_logic_vector(15 downto 0);
signal    gt4_txdata_float_i              : std_logic_vector(47 downto 0);
    
signal    gt4_track_data_i                : std_logic;
signal    gt4_block_sync_i                : std_logic;
signal    gt4_error_count_i               : std_logic_vector(7 downto 0);
signal    gt4_frame_check_reset_i         : std_logic;
signal    gt4_inc_in_i                    : std_logic;
signal    gt4_inc_out_i                   : std_logic;
signal    gt4_unscrambled_data_i          : std_logic_vector(15 downto 0);

signal    gt5_matchn_i                    : std_logic;
    
signal    gt5_txcharisk_float_i           : std_logic_vector(5 downto 0);
    
signal    gt5_txdata_float16_i            : std_logic_vector(15 downto 0);
signal    gt5_txdata_float_i              : std_logic_vector(47 downto 0);
    
signal    gt5_track_data_i                : std_logic;
signal    gt5_block_sync_i                : std_logic;
signal    gt5_error_count_i               : std_logic_vector(7 downto 0);
signal    gt5_frame_check_reset_i         : std_logic;
signal    gt5_inc_in_i                    : std_logic;
signal    gt5_inc_out_i                   : std_logic;
signal    gt5_unscrambled_data_i          : std_logic_vector(15 downto 0);

signal    gt6_matchn_i                    : std_logic;
    
signal    gt6_txcharisk_float_i           : std_logic_vector(5 downto 0);
    
signal    gt6_txdata_float16_i            : std_logic_vector(15 downto 0);
signal    gt6_txdata_float_i              : std_logic_vector(47 downto 0);
    
signal    gt6_track_data_i                : std_logic;
signal    gt6_block_sync_i                : std_logic;
signal    gt6_error_count_i               : std_logic_vector(7 downto 0);
signal    gt6_frame_check_reset_i         : std_logic;
signal    gt6_inc_in_i                    : std_logic;
signal    gt6_inc_out_i                   : std_logic;
signal    gt6_unscrambled_data_i          : std_logic_vector(15 downto 0);

signal    gt7_matchn_i                    : std_logic;
    
signal    gt7_txcharisk_float_i           : std_logic_vector(5 downto 0);
    
signal    gt7_txdata_float16_i            : std_logic_vector(15 downto 0);
signal    gt7_txdata_float_i              : std_logic_vector(47 downto 0);
    
signal    gt7_track_data_i                : std_logic;
signal    gt7_block_sync_i                : std_logic;
signal    gt7_error_count_i               : std_logic_vector(7 downto 0);
signal    gt7_frame_check_reset_i         : std_logic;
signal    gt7_inc_in_i                    : std_logic;
signal    gt7_inc_out_i                   : std_logic;
signal    gt7_unscrambled_data_i          : std_logic_vector(15 downto 0);

signal    gt8_matchn_i                    : std_logic;
    
signal    gt8_txcharisk_float_i           : std_logic_vector(5 downto 0);
    
signal    gt8_txdata_float16_i            : std_logic_vector(15 downto 0);
signal    gt8_txdata_float_i              : std_logic_vector(47 downto 0);
    
signal    gt8_track_data_i                : std_logic;
signal    gt8_block_sync_i                : std_logic;
signal    gt8_error_count_i               : std_logic_vector(7 downto 0);
signal    gt8_frame_check_reset_i         : std_logic;
signal    gt8_inc_in_i                    : std_logic;
signal    gt8_inc_out_i                   : std_logic;
signal    gt8_unscrambled_data_i          : std_logic_vector(15 downto 0);

signal    gt9_matchn_i                    : std_logic;
    
signal    gt9_txcharisk_float_i           : std_logic_vector(5 downto 0);
    
signal    gt9_txdata_float16_i            : std_logic_vector(15 downto 0);
signal    gt9_txdata_float_i              : std_logic_vector(47 downto 0);
    
signal    gt9_track_data_i                : std_logic;
signal    gt9_block_sync_i                : std_logic;
signal    gt9_error_count_i               : std_logic_vector(7 downto 0);
signal    gt9_frame_check_reset_i         : std_logic;
signal    gt9_inc_in_i                    : std_logic;
signal    gt9_inc_out_i                   : std_logic;
signal    gt9_unscrambled_data_i          : std_logic_vector(15 downto 0);

signal    gt10_matchn_i                   : std_logic;
    
signal    gt10_txcharisk_float_i          : std_logic_vector(5 downto 0);
    
signal    gt10_txdata_float16_i           : std_logic_vector(15 downto 0);
signal    gt10_txdata_float_i             : std_logic_vector(47 downto 0);
    
signal    gt10_track_data_i               : std_logic;
signal    gt10_block_sync_i               : std_logic;
signal    gt10_error_count_i              : std_logic_vector(7 downto 0);
signal    gt10_frame_check_reset_i        : std_logic;
signal    gt10_inc_in_i                   : std_logic;
signal    gt10_inc_out_i                  : std_logic;
signal    gt10_unscrambled_data_i         : std_logic_vector(15 downto 0);

signal    gt11_matchn_i                   : std_logic;
    
signal    gt11_txcharisk_float_i          : std_logic_vector(5 downto 0);
    
signal    gt11_txdata_float16_i           : std_logic_vector(15 downto 0);
signal    gt11_txdata_float_i             : std_logic_vector(47 downto 0);
    
signal    gt11_track_data_i               : std_logic;
signal    gt11_block_sync_i               : std_logic;
signal    gt11_error_count_i              : std_logic_vector(7 downto 0);
signal    gt11_frame_check_reset_i        : std_logic;
signal    gt11_inc_in_i                   : std_logic;
signal    gt11_inc_out_i                  : std_logic;
signal    gt11_unscrambled_data_i         : std_logic_vector(15 downto 0);

signal    reset_on_data_error_i           : std_logic;
signal    track_data_out_i                : std_logic;
  

    ----------------------- Debug Signals ---------------------------------

    signal  tx_data_vio_control_i           : std_logic_vector(35 downto 0);
    signal  rx_data_vio_control_i           : std_logic_vector(35 downto 0);
    signal  shared_vio_control_i            : std_logic_vector(35 downto 0);
    signal  ila_control_i                   : std_logic_vector(35 downto 0);
    signal  channel_drp_vio_control_i       : std_logic_vector(35 downto 0);
    signal  common_drp_vio_control_i        : std_logic_vector(35 downto 0);
    signal  tx_data_vio_async_in_i          : std_logic_vector(31 downto 0);
    signal  tx_data_vio_sync_in_i           : std_logic_vector(31 downto 0);
    signal  tx_data_vio_async_out_i         : std_logic_vector(31 downto 0);
    signal  tx_data_vio_sync_out_i          : std_logic_vector(31 downto 0);
    signal  rx_data_vio_async_in_i          : std_logic_vector(31 downto 0);
    signal  rx_data_vio_sync_in_i           : std_logic_vector(31 downto 0);
    signal  rx_data_vio_async_out_i         : std_logic_vector(31 downto 0);
    signal  rx_data_vio_sync_out_i          : std_logic_vector(31 downto 0);
    signal  shared_vio_in_i                 : std_logic_vector(31 downto 0);
    signal  shared_vio_out_i                : std_logic_vector(31 downto 0);
    signal  ila_in_i                        : std_logic_vector(163 downto 0);
    signal  channel_drp_vio_async_in_i      : std_logic_vector(31 downto 0);
    signal  channel_drp_vio_sync_in_i       : std_logic_vector(31 downto 0);
    signal  channel_drp_vio_async_out_i     : std_logic_vector(31 downto 0);
    signal  channel_drp_vio_sync_out_i      : std_logic_vector(31 downto 0);
    signal  common_drp_vio_async_in_i       : std_logic_vector(31 downto 0);
    signal  common_drp_vio_sync_in_i        : std_logic_vector(31 downto 0);
    signal  common_drp_vio_async_out_i      : std_logic_vector(31 downto 0);
    signal  common_drp_vio_sync_out_i       : std_logic_vector(31 downto 0);

    signal  gt0_tx_data_vio_async_in_i      : std_logic_vector(31 downto 0);
    signal  gt0_tx_data_vio_sync_in_i       : std_logic_vector(31 downto 0);
    signal  gt0_tx_data_vio_async_out_i     : std_logic_vector(31 downto 0);
    signal  gt0_tx_data_vio_sync_out_i      : std_logic_vector(31 downto 0);
    signal  gt0_rx_data_vio_async_in_i      : std_logic_vector(31 downto 0);
    signal  gt0_rx_data_vio_sync_in_i       : std_logic_vector(31 downto 0);
    signal  gt0_rx_data_vio_async_out_i     : std_logic_vector(31 downto 0);
    signal  gt0_rx_data_vio_sync_out_i      : std_logic_vector(31 downto 0);
    signal  gt0_ila_in_i                    : std_logic_vector(163 downto 0);
    signal  gt0_channel_drp_vio_async_in_i  : std_logic_vector(31 downto 0);
    signal  gt0_channel_drp_vio_sync_in_i   : std_logic_vector(31 downto 0);
    signal  gt0_channel_drp_vio_async_out_i : std_logic_vector(31 downto 0);
    signal  gt0_channel_drp_vio_sync_out_i  : std_logic_vector(31 downto 0);
    signal  gt0_common_drp_vio_async_in_i   : std_logic_vector(31 downto 0);
    signal  gt0_common_drp_vio_sync_in_i    : std_logic_vector(31 downto 0);
    signal  gt0_common_drp_vio_async_out_i  : std_logic_vector(31 downto 0);
    signal  gt0_common_drp_vio_sync_out_i   : std_logic_vector(31 downto 0);

    signal  gt1_tx_data_vio_async_in_i      : std_logic_vector(31 downto 0);
    signal  gt1_tx_data_vio_sync_in_i       : std_logic_vector(31 downto 0);
    signal  gt1_tx_data_vio_async_out_i     : std_logic_vector(31 downto 0);
    signal  gt1_tx_data_vio_sync_out_i      : std_logic_vector(31 downto 0);
    signal  gt1_rx_data_vio_async_in_i      : std_logic_vector(31 downto 0);
    signal  gt1_rx_data_vio_sync_in_i       : std_logic_vector(31 downto 0);
    signal  gt1_rx_data_vio_async_out_i     : std_logic_vector(31 downto 0);
    signal  gt1_rx_data_vio_sync_out_i      : std_logic_vector(31 downto 0);
    signal  gt1_ila_in_i                    : std_logic_vector(163 downto 0);
    signal  gt1_channel_drp_vio_async_in_i  : std_logic_vector(31 downto 0);
    signal  gt1_channel_drp_vio_sync_in_i   : std_logic_vector(31 downto 0);
    signal  gt1_channel_drp_vio_async_out_i : std_logic_vector(31 downto 0);
    signal  gt1_channel_drp_vio_sync_out_i  : std_logic_vector(31 downto 0);
    signal  gt1_common_drp_vio_async_in_i   : std_logic_vector(31 downto 0);
    signal  gt1_common_drp_vio_sync_in_i    : std_logic_vector(31 downto 0);
    signal  gt1_common_drp_vio_async_out_i  : std_logic_vector(31 downto 0);
    signal  gt1_common_drp_vio_sync_out_i   : std_logic_vector(31 downto 0);

    signal  gt2_tx_data_vio_async_in_i      : std_logic_vector(31 downto 0);
    signal  gt2_tx_data_vio_sync_in_i       : std_logic_vector(31 downto 0);
    signal  gt2_tx_data_vio_async_out_i     : std_logic_vector(31 downto 0);
    signal  gt2_tx_data_vio_sync_out_i      : std_logic_vector(31 downto 0);
    signal  gt2_rx_data_vio_async_in_i      : std_logic_vector(31 downto 0);
    signal  gt2_rx_data_vio_sync_in_i       : std_logic_vector(31 downto 0);
    signal  gt2_rx_data_vio_async_out_i     : std_logic_vector(31 downto 0);
    signal  gt2_rx_data_vio_sync_out_i      : std_logic_vector(31 downto 0);
    signal  gt2_ila_in_i                    : std_logic_vector(163 downto 0);
    signal  gt2_channel_drp_vio_async_in_i  : std_logic_vector(31 downto 0);
    signal  gt2_channel_drp_vio_sync_in_i   : std_logic_vector(31 downto 0);
    signal  gt2_channel_drp_vio_async_out_i : std_logic_vector(31 downto 0);
    signal  gt2_channel_drp_vio_sync_out_i  : std_logic_vector(31 downto 0);
    signal  gt2_common_drp_vio_async_in_i   : std_logic_vector(31 downto 0);
    signal  gt2_common_drp_vio_sync_in_i    : std_logic_vector(31 downto 0);
    signal  gt2_common_drp_vio_async_out_i  : std_logic_vector(31 downto 0);
    signal  gt2_common_drp_vio_sync_out_i   : std_logic_vector(31 downto 0);

    signal  gt3_tx_data_vio_async_in_i      : std_logic_vector(31 downto 0);
    signal  gt3_tx_data_vio_sync_in_i       : std_logic_vector(31 downto 0);
    signal  gt3_tx_data_vio_async_out_i     : std_logic_vector(31 downto 0);
    signal  gt3_tx_data_vio_sync_out_i      : std_logic_vector(31 downto 0);
    signal  gt3_rx_data_vio_async_in_i      : std_logic_vector(31 downto 0);
    signal  gt3_rx_data_vio_sync_in_i       : std_logic_vector(31 downto 0);
    signal  gt3_rx_data_vio_async_out_i     : std_logic_vector(31 downto 0);
    signal  gt3_rx_data_vio_sync_out_i      : std_logic_vector(31 downto 0);
    signal  gt3_ila_in_i                    : std_logic_vector(163 downto 0);
    signal  gt3_channel_drp_vio_async_in_i  : std_logic_vector(31 downto 0);
    signal  gt3_channel_drp_vio_sync_in_i   : std_logic_vector(31 downto 0);
    signal  gt3_channel_drp_vio_async_out_i : std_logic_vector(31 downto 0);
    signal  gt3_channel_drp_vio_sync_out_i  : std_logic_vector(31 downto 0);
    signal  gt3_common_drp_vio_async_in_i   : std_logic_vector(31 downto 0);
    signal  gt3_common_drp_vio_sync_in_i    : std_logic_vector(31 downto 0);
    signal  gt3_common_drp_vio_async_out_i  : std_logic_vector(31 downto 0);
    signal  gt3_common_drp_vio_sync_out_i   : std_logic_vector(31 downto 0);

    signal  gt4_tx_data_vio_async_in_i      : std_logic_vector(31 downto 0);
    signal  gt4_tx_data_vio_sync_in_i       : std_logic_vector(31 downto 0);
    signal  gt4_tx_data_vio_async_out_i     : std_logic_vector(31 downto 0);
    signal  gt4_tx_data_vio_sync_out_i      : std_logic_vector(31 downto 0);
    signal  gt4_rx_data_vio_async_in_i      : std_logic_vector(31 downto 0);
    signal  gt4_rx_data_vio_sync_in_i       : std_logic_vector(31 downto 0);
    signal  gt4_rx_data_vio_async_out_i     : std_logic_vector(31 downto 0);
    signal  gt4_rx_data_vio_sync_out_i      : std_logic_vector(31 downto 0);
    signal  gt4_ila_in_i                    : std_logic_vector(163 downto 0);
    signal  gt4_channel_drp_vio_async_in_i  : std_logic_vector(31 downto 0);
    signal  gt4_channel_drp_vio_sync_in_i   : std_logic_vector(31 downto 0);
    signal  gt4_channel_drp_vio_async_out_i : std_logic_vector(31 downto 0);
    signal  gt4_channel_drp_vio_sync_out_i  : std_logic_vector(31 downto 0);
    signal  gt4_common_drp_vio_async_in_i   : std_logic_vector(31 downto 0);
    signal  gt4_common_drp_vio_sync_in_i    : std_logic_vector(31 downto 0);
    signal  gt4_common_drp_vio_async_out_i  : std_logic_vector(31 downto 0);
    signal  gt4_common_drp_vio_sync_out_i   : std_logic_vector(31 downto 0);

    signal  gt5_tx_data_vio_async_in_i      : std_logic_vector(31 downto 0);
    signal  gt5_tx_data_vio_sync_in_i       : std_logic_vector(31 downto 0);
    signal  gt5_tx_data_vio_async_out_i     : std_logic_vector(31 downto 0);
    signal  gt5_tx_data_vio_sync_out_i      : std_logic_vector(31 downto 0);
    signal  gt5_rx_data_vio_async_in_i      : std_logic_vector(31 downto 0);
    signal  gt5_rx_data_vio_sync_in_i       : std_logic_vector(31 downto 0);
    signal  gt5_rx_data_vio_async_out_i     : std_logic_vector(31 downto 0);
    signal  gt5_rx_data_vio_sync_out_i      : std_logic_vector(31 downto 0);
    signal  gt5_ila_in_i                    : std_logic_vector(163 downto 0);
    signal  gt5_channel_drp_vio_async_in_i  : std_logic_vector(31 downto 0);
    signal  gt5_channel_drp_vio_sync_in_i   : std_logic_vector(31 downto 0);
    signal  gt5_channel_drp_vio_async_out_i : std_logic_vector(31 downto 0);
    signal  gt5_channel_drp_vio_sync_out_i  : std_logic_vector(31 downto 0);
    signal  gt5_common_drp_vio_async_in_i   : std_logic_vector(31 downto 0);
    signal  gt5_common_drp_vio_sync_in_i    : std_logic_vector(31 downto 0);
    signal  gt5_common_drp_vio_async_out_i  : std_logic_vector(31 downto 0);
    signal  gt5_common_drp_vio_sync_out_i   : std_logic_vector(31 downto 0);

    signal  gt6_tx_data_vio_async_in_i      : std_logic_vector(31 downto 0);
    signal  gt6_tx_data_vio_sync_in_i       : std_logic_vector(31 downto 0);
    signal  gt6_tx_data_vio_async_out_i     : std_logic_vector(31 downto 0);
    signal  gt6_tx_data_vio_sync_out_i      : std_logic_vector(31 downto 0);
    signal  gt6_rx_data_vio_async_in_i      : std_logic_vector(31 downto 0);
    signal  gt6_rx_data_vio_sync_in_i       : std_logic_vector(31 downto 0);
    signal  gt6_rx_data_vio_async_out_i     : std_logic_vector(31 downto 0);
    signal  gt6_rx_data_vio_sync_out_i      : std_logic_vector(31 downto 0);
    signal  gt6_ila_in_i                    : std_logic_vector(163 downto 0);
    signal  gt6_channel_drp_vio_async_in_i  : std_logic_vector(31 downto 0);
    signal  gt6_channel_drp_vio_sync_in_i   : std_logic_vector(31 downto 0);
    signal  gt6_channel_drp_vio_async_out_i : std_logic_vector(31 downto 0);
    signal  gt6_channel_drp_vio_sync_out_i  : std_logic_vector(31 downto 0);
    signal  gt6_common_drp_vio_async_in_i   : std_logic_vector(31 downto 0);
    signal  gt6_common_drp_vio_sync_in_i    : std_logic_vector(31 downto 0);
    signal  gt6_common_drp_vio_async_out_i  : std_logic_vector(31 downto 0);
    signal  gt6_common_drp_vio_sync_out_i   : std_logic_vector(31 downto 0);

    signal  gt7_tx_data_vio_async_in_i      : std_logic_vector(31 downto 0);
    signal  gt7_tx_data_vio_sync_in_i       : std_logic_vector(31 downto 0);
    signal  gt7_tx_data_vio_async_out_i     : std_logic_vector(31 downto 0);
    signal  gt7_tx_data_vio_sync_out_i      : std_logic_vector(31 downto 0);
    signal  gt7_rx_data_vio_async_in_i      : std_logic_vector(31 downto 0);
    signal  gt7_rx_data_vio_sync_in_i       : std_logic_vector(31 downto 0);
    signal  gt7_rx_data_vio_async_out_i     : std_logic_vector(31 downto 0);
    signal  gt7_rx_data_vio_sync_out_i      : std_logic_vector(31 downto 0);
    signal  gt7_ila_in_i                    : std_logic_vector(163 downto 0);
    signal  gt7_channel_drp_vio_async_in_i  : std_logic_vector(31 downto 0);
    signal  gt7_channel_drp_vio_sync_in_i   : std_logic_vector(31 downto 0);
    signal  gt7_channel_drp_vio_async_out_i : std_logic_vector(31 downto 0);
    signal  gt7_channel_drp_vio_sync_out_i  : std_logic_vector(31 downto 0);
    signal  gt7_common_drp_vio_async_in_i   : std_logic_vector(31 downto 0);
    signal  gt7_common_drp_vio_sync_in_i    : std_logic_vector(31 downto 0);
    signal  gt7_common_drp_vio_async_out_i  : std_logic_vector(31 downto 0);
    signal  gt7_common_drp_vio_sync_out_i   : std_logic_vector(31 downto 0);

    signal  gt8_tx_data_vio_async_in_i      : std_logic_vector(31 downto 0);
    signal  gt8_tx_data_vio_sync_in_i       : std_logic_vector(31 downto 0);
    signal  gt8_tx_data_vio_async_out_i     : std_logic_vector(31 downto 0);
    signal  gt8_tx_data_vio_sync_out_i      : std_logic_vector(31 downto 0);
    signal  gt8_rx_data_vio_async_in_i      : std_logic_vector(31 downto 0);
    signal  gt8_rx_data_vio_sync_in_i       : std_logic_vector(31 downto 0);
    signal  gt8_rx_data_vio_async_out_i     : std_logic_vector(31 downto 0);
    signal  gt8_rx_data_vio_sync_out_i      : std_logic_vector(31 downto 0);
    signal  gt8_ila_in_i                    : std_logic_vector(163 downto 0);
    signal  gt8_channel_drp_vio_async_in_i  : std_logic_vector(31 downto 0);
    signal  gt8_channel_drp_vio_sync_in_i   : std_logic_vector(31 downto 0);
    signal  gt8_channel_drp_vio_async_out_i : std_logic_vector(31 downto 0);
    signal  gt8_channel_drp_vio_sync_out_i  : std_logic_vector(31 downto 0);
    signal  gt8_common_drp_vio_async_in_i   : std_logic_vector(31 downto 0);
    signal  gt8_common_drp_vio_sync_in_i    : std_logic_vector(31 downto 0);
    signal  gt8_common_drp_vio_async_out_i  : std_logic_vector(31 downto 0);
    signal  gt8_common_drp_vio_sync_out_i   : std_logic_vector(31 downto 0);

    signal  gt9_tx_data_vio_async_in_i      : std_logic_vector(31 downto 0);
    signal  gt9_tx_data_vio_sync_in_i       : std_logic_vector(31 downto 0);
    signal  gt9_tx_data_vio_async_out_i     : std_logic_vector(31 downto 0);
    signal  gt9_tx_data_vio_sync_out_i      : std_logic_vector(31 downto 0);
    signal  gt9_rx_data_vio_async_in_i      : std_logic_vector(31 downto 0);
    signal  gt9_rx_data_vio_sync_in_i       : std_logic_vector(31 downto 0);
    signal  gt9_rx_data_vio_async_out_i     : std_logic_vector(31 downto 0);
    signal  gt9_rx_data_vio_sync_out_i      : std_logic_vector(31 downto 0);
    signal  gt9_ila_in_i                    : std_logic_vector(163 downto 0);
    signal  gt9_channel_drp_vio_async_in_i  : std_logic_vector(31 downto 0);
    signal  gt9_channel_drp_vio_sync_in_i   : std_logic_vector(31 downto 0);
    signal  gt9_channel_drp_vio_async_out_i : std_logic_vector(31 downto 0);
    signal  gt9_channel_drp_vio_sync_out_i  : std_logic_vector(31 downto 0);
    signal  gt9_common_drp_vio_async_in_i   : std_logic_vector(31 downto 0);
    signal  gt9_common_drp_vio_sync_in_i    : std_logic_vector(31 downto 0);
    signal  gt9_common_drp_vio_async_out_i  : std_logic_vector(31 downto 0);
    signal  gt9_common_drp_vio_sync_out_i   : std_logic_vector(31 downto 0);

    signal  gt10_tx_data_vio_async_in_i     : std_logic_vector(31 downto 0);
    signal  gt10_tx_data_vio_sync_in_i      : std_logic_vector(31 downto 0);
    signal  gt10_tx_data_vio_async_out_i    : std_logic_vector(31 downto 0);
    signal  gt10_tx_data_vio_sync_out_i     : std_logic_vector(31 downto 0);
    signal  gt10_rx_data_vio_async_in_i     : std_logic_vector(31 downto 0);
    signal  gt10_rx_data_vio_sync_in_i      : std_logic_vector(31 downto 0);
    signal  gt10_rx_data_vio_async_out_i    : std_logic_vector(31 downto 0);
    signal  gt10_rx_data_vio_sync_out_i     : std_logic_vector(31 downto 0);
    signal  gt10_ila_in_i                   : std_logic_vector(163 downto 0);
    signal  gt10_channel_drp_vio_async_in_i : std_logic_vector(31 downto 0);
    signal  gt10_channel_drp_vio_sync_in_i  : std_logic_vector(31 downto 0);
    signal  gt10_channel_drp_vio_async_out_i: std_logic_vector(31 downto 0);
    signal  gt10_channel_drp_vio_sync_out_i : std_logic_vector(31 downto 0);
    signal  gt10_common_drp_vio_async_in_i  : std_logic_vector(31 downto 0);
    signal  gt10_common_drp_vio_sync_in_i   : std_logic_vector(31 downto 0);
    signal  gt10_common_drp_vio_async_out_i : std_logic_vector(31 downto 0);
    signal  gt10_common_drp_vio_sync_out_i  : std_logic_vector(31 downto 0);

    signal  gt11_tx_data_vio_async_in_i     : std_logic_vector(31 downto 0);
    signal  gt11_tx_data_vio_sync_in_i      : std_logic_vector(31 downto 0);
    signal  gt11_tx_data_vio_async_out_i    : std_logic_vector(31 downto 0);
    signal  gt11_tx_data_vio_sync_out_i     : std_logic_vector(31 downto 0);
    signal  gt11_rx_data_vio_async_in_i     : std_logic_vector(31 downto 0);
    signal  gt11_rx_data_vio_sync_in_i      : std_logic_vector(31 downto 0);
    signal  gt11_rx_data_vio_async_out_i    : std_logic_vector(31 downto 0);
    signal  gt11_rx_data_vio_sync_out_i     : std_logic_vector(31 downto 0);
    signal  gt11_ila_in_i                   : std_logic_vector(163 downto 0);
    signal  gt11_channel_drp_vio_async_in_i : std_logic_vector(31 downto 0);
    signal  gt11_channel_drp_vio_sync_in_i  : std_logic_vector(31 downto 0);
    signal  gt11_channel_drp_vio_async_out_i: std_logic_vector(31 downto 0);
    signal  gt11_channel_drp_vio_sync_out_i : std_logic_vector(31 downto 0);
    signal  gt11_common_drp_vio_async_in_i  : std_logic_vector(31 downto 0);
    signal  gt11_common_drp_vio_sync_in_i   : std_logic_vector(31 downto 0);
    signal  gt11_common_drp_vio_async_out_i : std_logic_vector(31 downto 0);
    signal  gt11_common_drp_vio_sync_out_i  : std_logic_vector(31 downto 0);


signal    gttxreset_i                     : std_logic;
signal    gtrxreset_i                     : std_logic;
signal    mux_sel_i                       : std_logic_vector(3 downto 0);

signal    user_tx_reset_i                 : std_logic;
signal    user_rx_reset_i                 : std_logic;
signal    tx_vio_clk_i                    : std_logic;
signal    tx_vio_clk_mux_out_i            : std_logic;    
signal    rx_vio_ila_clk_i                : std_logic;
signal    rx_vio_ila_clk_mux_out_i        : std_logic;    

signal    qpllreset_i                     : std_logic;
    


   function and_reduce(arg: std_logic_vector) return std_logic is
	variable result: std_logic;
    begin
	result := '1';
	for i in arg'range loop
	    result := result and arg(i);
	end loop;
        return result;
    end;


--**************************** Main Body of Code *******************************
begin

    --  Static signal Assigments
tied_to_ground_i                             <= '0';
tied_to_ground_vec_i                         <= x"0000000000000000";
tied_to_vcc_i                                <= '1';
tied_to_vcc_vec_i                            <= "11111111";

    
  
    
  
    
  
    
  
    
  
    
  
    
  
    
  
    
  
    
  
    
  
    
  
    gt_usrclk_source : AMC_GTXv_GT_USRCLK_SOURCE
    port map
   (
        Q1_CLK1_GTREFCLK_PAD_N_IN       =>      Q1_CLK1_GTREFCLK_PAD_N_IN,
        Q1_CLK1_GTREFCLK_PAD_P_IN       =>      Q1_CLK1_GTREFCLK_PAD_P_IN,
        Q1_CLK1_GTREFCLK_OUT            =>      q1_clk1_refclk_i,
 
        GT0_TXUSRCLK_OUT                =>      gt0_txusrclk_i,
        GT0_TXUSRCLK2_OUT               =>      gt0_txusrclk2_i,
        GT0_TXOUTCLK_IN                 =>      gt0_txoutclk_i,
        GT0_RXUSRCLK_OUT                =>      gt0_rxusrclk_i,
        GT0_RXUSRCLK2_OUT               =>      gt0_rxusrclk2_i,
 
        GT1_TXUSRCLK_OUT                =>      gt1_txusrclk_i,
        GT1_TXUSRCLK2_OUT               =>      gt1_txusrclk2_i,
        GT1_TXOUTCLK_IN                 =>      gt1_txoutclk_i,
        GT1_RXUSRCLK_OUT                =>      gt1_rxusrclk_i,
        GT1_RXUSRCLK2_OUT               =>      gt1_rxusrclk2_i,
 
        GT2_TXUSRCLK_OUT                =>      gt2_txusrclk_i,
        GT2_TXUSRCLK2_OUT               =>      gt2_txusrclk2_i,
        GT2_TXOUTCLK_IN                 =>      gt2_txoutclk_i,
        GT2_RXUSRCLK_OUT                =>      gt2_rxusrclk_i,
        GT2_RXUSRCLK2_OUT               =>      gt2_rxusrclk2_i,
 
        GT3_TXUSRCLK_OUT                =>      gt3_txusrclk_i,
        GT3_TXUSRCLK2_OUT               =>      gt3_txusrclk2_i,
        GT3_TXOUTCLK_IN                 =>      gt3_txoutclk_i,
        GT3_RXUSRCLK_OUT                =>      gt3_rxusrclk_i,
        GT3_RXUSRCLK2_OUT               =>      gt3_rxusrclk2_i,
 
        GT4_TXUSRCLK_OUT                =>      gt4_txusrclk_i,
        GT4_TXUSRCLK2_OUT               =>      gt4_txusrclk2_i,
        GT4_TXOUTCLK_IN                 =>      gt4_txoutclk_i,
        GT4_RXUSRCLK_OUT                =>      gt4_rxusrclk_i,
        GT4_RXUSRCLK2_OUT               =>      gt4_rxusrclk2_i,
 
        GT5_TXUSRCLK_OUT                =>      gt5_txusrclk_i,
        GT5_TXUSRCLK2_OUT               =>      gt5_txusrclk2_i,
        GT5_TXOUTCLK_IN                 =>      gt5_txoutclk_i,
        GT5_RXUSRCLK_OUT                =>      gt5_rxusrclk_i,
        GT5_RXUSRCLK2_OUT               =>      gt5_rxusrclk2_i,
 
        GT6_TXUSRCLK_OUT                =>      gt6_txusrclk_i,
        GT6_TXUSRCLK2_OUT               =>      gt6_txusrclk2_i,
        GT6_TXOUTCLK_IN                 =>      gt6_txoutclk_i,
        GT6_RXUSRCLK_OUT                =>      gt6_rxusrclk_i,
        GT6_RXUSRCLK2_OUT               =>      gt6_rxusrclk2_i,
 
        GT7_TXUSRCLK_OUT                =>      gt7_txusrclk_i,
        GT7_TXUSRCLK2_OUT               =>      gt7_txusrclk2_i,
        GT7_TXOUTCLK_IN                 =>      gt7_txoutclk_i,
        GT7_RXUSRCLK_OUT                =>      gt7_rxusrclk_i,
        GT7_RXUSRCLK2_OUT               =>      gt7_rxusrclk2_i,
 
        GT8_TXUSRCLK_OUT                =>      gt8_txusrclk_i,
        GT8_TXUSRCLK2_OUT               =>      gt8_txusrclk2_i,
        GT8_TXOUTCLK_IN                 =>      gt8_txoutclk_i,
        GT8_RXUSRCLK_OUT                =>      gt8_rxusrclk_i,
        GT8_RXUSRCLK2_OUT               =>      gt8_rxusrclk2_i,
 
        GT9_TXUSRCLK_OUT                =>      gt9_txusrclk_i,
        GT9_TXUSRCLK2_OUT               =>      gt9_txusrclk2_i,
        GT9_TXOUTCLK_IN                 =>      gt9_txoutclk_i,
        GT9_RXUSRCLK_OUT                =>      gt9_rxusrclk_i,
        GT9_RXUSRCLK2_OUT               =>      gt9_rxusrclk2_i,
 
        GT10_TXUSRCLK_OUT               =>      gt10_txusrclk_i,
        GT10_TXUSRCLK2_OUT              =>      gt10_txusrclk2_i,
        GT10_TXOUTCLK_IN                =>      gt10_txoutclk_i,
        GT10_RXUSRCLK_OUT               =>      gt10_rxusrclk_i,
        GT10_RXUSRCLK2_OUT              =>      gt10_rxusrclk2_i,
 
        GT11_TXUSRCLK_OUT               =>      gt11_txusrclk_i,
        GT11_TXUSRCLK2_OUT              =>      gt11_txusrclk2_i,
        GT11_TXOUTCLK_IN                =>      gt11_txoutclk_i,
        GT11_RXUSRCLK_OUT               =>      gt11_rxusrclk_i,
        GT11_RXUSRCLK2_OUT              =>      gt11_rxusrclk2_i,
        DRPCLK_IN                       =>      DRP_CLK_IN,
        DRPCLK_OUT                      =>      drpclk_in_i

    );

    ----------------------------- The GT Wrapper -----------------------------
    
    -- Use the instantiation template in the example directory to add the GT wrapper to your design.
    -- In this example, the wrapper is wired up for basic operation with a frame generator and frame 
    -- checker. The GTs will reset, then attempt to align and transmit data. If channel bonding is 
    -- enabled, bonding should occur after alignment.


    AMC_GTXv_init_i : AMC_GTXv_init
    generic map
    (
        EXAMPLE_SIM_GTRESET_SPEEDUP     =>      EXAMPLE_SIM_GTRESET_SPEEDUP,
        EXAMPLE_SIMULATION              =>      EXAMPLE_SIMULATION,
        EXAMPLE_USE_CHIPSCOPE           =>      EXAMPLE_USE_CHIPSCOPE
    )
    port map
    (
        SYSCLK_IN                       =>      SYSCLK_IN,
        SOFT_RESET_IN                   =>      tied_to_ground_i,
        DONT_RESET_ON_DATA_ERROR_IN     =>      tied_to_ground_i,
        GT0_TX_FSM_RESET_DONE_OUT       =>      gt0_txfsmresetdone_i,
        GT0_RX_FSM_RESET_DONE_OUT       =>      gt0_rxfsmresetdone_i,
        GT0_DATA_VALID_IN               =>      gt0_track_data_i,
        GT1_TX_FSM_RESET_DONE_OUT       =>      gt1_txfsmresetdone_i,
        GT1_RX_FSM_RESET_DONE_OUT       =>      gt1_rxfsmresetdone_i,
        GT1_DATA_VALID_IN               =>      gt1_track_data_i,
        GT2_TX_FSM_RESET_DONE_OUT       =>      gt2_txfsmresetdone_i,
        GT2_RX_FSM_RESET_DONE_OUT       =>      gt2_rxfsmresetdone_i,
        GT2_DATA_VALID_IN               =>      gt2_track_data_i,
        GT3_TX_FSM_RESET_DONE_OUT       =>      gt3_txfsmresetdone_i,
        GT3_RX_FSM_RESET_DONE_OUT       =>      gt3_rxfsmresetdone_i,
        GT3_DATA_VALID_IN               =>      gt3_track_data_i,
        GT4_TX_FSM_RESET_DONE_OUT       =>      gt4_txfsmresetdone_i,
        GT4_RX_FSM_RESET_DONE_OUT       =>      gt4_rxfsmresetdone_i,
        GT4_DATA_VALID_IN               =>      gt4_track_data_i,
        GT5_TX_FSM_RESET_DONE_OUT       =>      gt5_txfsmresetdone_i,
        GT5_RX_FSM_RESET_DONE_OUT       =>      gt5_rxfsmresetdone_i,
        GT5_DATA_VALID_IN               =>      gt5_track_data_i,
        GT6_TX_FSM_RESET_DONE_OUT       =>      gt6_txfsmresetdone_i,
        GT6_RX_FSM_RESET_DONE_OUT       =>      gt6_rxfsmresetdone_i,
        GT6_DATA_VALID_IN               =>      gt6_track_data_i,
        GT7_TX_FSM_RESET_DONE_OUT       =>      gt7_txfsmresetdone_i,
        GT7_RX_FSM_RESET_DONE_OUT       =>      gt7_rxfsmresetdone_i,
        GT7_DATA_VALID_IN               =>      gt7_track_data_i,
        GT8_TX_FSM_RESET_DONE_OUT       =>      gt8_txfsmresetdone_i,
        GT8_RX_FSM_RESET_DONE_OUT       =>      gt8_rxfsmresetdone_i,
        GT8_DATA_VALID_IN               =>      gt8_track_data_i,
        GT9_TX_FSM_RESET_DONE_OUT       =>      gt9_txfsmresetdone_i,
        GT9_RX_FSM_RESET_DONE_OUT       =>      gt9_rxfsmresetdone_i,
        GT9_DATA_VALID_IN               =>      gt9_track_data_i,
        GT10_TX_FSM_RESET_DONE_OUT      =>      gt10_txfsmresetdone_i,
        GT10_RX_FSM_RESET_DONE_OUT      =>      gt10_rxfsmresetdone_i,
        GT10_DATA_VALID_IN              =>      gt10_track_data_i,
        GT11_TX_FSM_RESET_DONE_OUT      =>      gt11_txfsmresetdone_i,
        GT11_RX_FSM_RESET_DONE_OUT      =>      gt11_rxfsmresetdone_i,
        GT11_DATA_VALID_IN              =>      gt11_track_data_i,

  
 
 

        --_____________________________________________________________________
        --_____________________________________________________________________
        --GT0  (X1Y0)

        ---------------------------- Channel - DRP Ports  --------------------------
        GT0_DRPADDR_IN                  =>      gt0_drpaddr_i,
        GT0_DRPCLK_IN                   =>      drpclk_in_i,
        GT0_DRPDI_IN                    =>      gt0_drpdi_i,
        GT0_DRPDO_OUT                   =>      gt0_drpdo_i,
        GT0_DRPEN_IN                    =>      gt0_drpen_i,
        GT0_DRPRDY_OUT                  =>      gt0_drprdy_i,
        GT0_DRPWE_IN                    =>      gt0_drpwe_i,
        ------------------------------- Loopback Ports -----------------------------
        GT0_LOOPBACK_IN                 =>      "000",
        --------------------- RX Initialization and Reset Ports --------------------
        GT0_RXUSERRDY_IN                =>      gt0_rxuserrdy_i,
        -------------------------- RX Margin Analysis Ports ------------------------
        GT0_EYESCANDATAERROR_OUT        =>      gt0_eyescandataerror_i,
        ------------------------- Receive Ports - CDR Ports ------------------------
        GT0_RXCDRLOCK_OUT               =>      gt0_rxcdrlock_i,
        ------------------- Receive Ports - Clock Correction Ports -----------------
        GT0_RXCLKCORCNT_OUT             =>      gt0_rxclkcorcnt_i,
        ------------------ Receive Ports - FPGA RX Interface Ports -----------------
        GT0_RXUSRCLK_IN                 =>      gt0_txusrclk_i,
        GT0_RXUSRCLK2_IN                =>      gt0_txusrclk_i,
        ------------------ Receive Ports - FPGA RX interface Ports -----------------
        GT0_RXDATA_OUT                  =>      gt0_rxdata_i,
        ------------------- Receive Ports - Pattern Checker Ports ------------------
        GT0_RXPRBSERR_OUT               =>      gt0_rxprbserr_i,
        GT0_RXPRBSSEL_IN                =>      gt0_rxprbssel_i,
        ------------------- Receive Ports - Pattern Checker ports ------------------
        GT0_RXPRBSCNTRESET_IN           =>      gt0_rxprbscntreset_i,
        ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
        GT0_RXDISPERR_OUT               =>      gt0_rxdisperr_i,
        GT0_RXNOTINTABLE_OUT            =>      gt0_rxnotintable_i,
        --------------------------- Receive Ports - RX AFE -------------------------
        GT0_GTXRXP_IN                   =>      RXP_IN(0),
        ------------------------ Receive Ports - RX AFE Ports ----------------------
        GT0_GTXRXN_IN                   =>      RXN_IN(0),
        -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
        GT0_RXMCOMMAALIGNEN_IN          =>      gt0_rxmcommaalignen_i,
        GT0_RXPCOMMAALIGNEN_IN          =>      gt0_rxpcommaalignen_i,
        --------------------- Receive Ports - RX Equalizer Ports -------------------
        GT0_RXDFELPMRESET_IN            =>      gt0_rxdfelpmreset_i,
        GT0_RXMONITOROUT_OUT            =>      gt0_rxmonitorout_i,
        GT0_RXMONITORSEL_IN             =>      gt0_rxmonitorsel_i,
        ------------- Receive Ports - RX Initialization and Reset Ports ------------
        GT0_GTRXRESET_IN                =>      gt0_gtrxreset_i,
        GT0_RXPMARESET_IN               =>      gt0_rxpmareset_i,
        ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
        GT0_RXCHARISCOMMA_OUT           =>      gt0_rxchariscomma_i,
        GT0_RXCHARISK_OUT               =>      gt0_rxcharisk_i,
        -------------- Receive Ports -RX Initialization and Reset Ports ------------
        GT0_RXRESETDONE_OUT             =>      gt0_rxresetdone_i,
        --------------------- TX Initialization and Reset Ports --------------------
        GT0_GTTXRESET_IN                =>      gt0_gttxreset_i,
        GT0_TXUSERRDY_IN                =>      gt0_txuserrdy_i,
        ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
        GT0_TXUSRCLK_IN                 =>      gt0_txusrclk_i,
        GT0_TXUSRCLK2_IN                =>      gt0_txusrclk_i,
        --------------- Transmit Ports - TX Configurable Driver Ports --------------
        GT0_TXDIFFCTRL_IN               =>      gt0_txdiffctrl_i,
        ------------------ Transmit Ports - TX Data Path interface -----------------
        GT0_TXDATA_IN                   =>      gt0_txdata_i,
        ---------------- Transmit Ports - TX Driver and OOB signaling --------------
        GT0_GTXTXN_OUT                  =>      TXN_OUT(0),
        GT0_GTXTXP_OUT                  =>      TXP_OUT(0),
        ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
        GT0_TXOUTCLK_OUT                =>      gt0_txoutclk_i,
        GT0_TXOUTCLKFABRIC_OUT          =>      gt0_txoutclkfabric_i,
        GT0_TXOUTCLKPCS_OUT             =>      gt0_txoutclkpcs_i,
        --------------------- Transmit Ports - TX Gearbox Ports --------------------
        GT0_TXCHARISK_IN                =>      gt0_txcharisk_i,
        ------------- Transmit Ports - TX Initialization and Reset Ports -----------
        GT0_TXRESETDONE_OUT             =>      gt0_txresetdone_i,
        ------------------ Transmit Ports - pattern Generator Ports ----------------
        GT0_TXPRBSSEL_IN                =>      gt0_txprbssel_i,


  
 
 

        --_____________________________________________________________________
        --_____________________________________________________________________
        --GT1  (X1Y1)

        ---------------------------- Channel - DRP Ports  --------------------------
        GT1_DRPADDR_IN                  =>      gt1_drpaddr_i,
        GT1_DRPCLK_IN                   =>      drpclk_in_i,
        GT1_DRPDI_IN                    =>      gt1_drpdi_i,
        GT1_DRPDO_OUT                   =>      gt1_drpdo_i,
        GT1_DRPEN_IN                    =>      gt1_drpen_i,
        GT1_DRPRDY_OUT                  =>      gt1_drprdy_i,
        GT1_DRPWE_IN                    =>      gt1_drpwe_i,
        ------------------------------- Loopback Ports -----------------------------
        GT1_LOOPBACK_IN                 =>      "000",
        --------------------- RX Initialization and Reset Ports --------------------
        GT1_RXUSERRDY_IN                =>      gt1_rxuserrdy_i,
        -------------------------- RX Margin Analysis Ports ------------------------
        GT1_EYESCANDATAERROR_OUT        =>      gt1_eyescandataerror_i,
        ------------------------- Receive Ports - CDR Ports ------------------------
        GT1_RXCDRLOCK_OUT               =>      gt1_rxcdrlock_i,
        ------------------- Receive Ports - Clock Correction Ports -----------------
        GT1_RXCLKCORCNT_OUT             =>      gt1_rxclkcorcnt_i,
        ------------------ Receive Ports - FPGA RX Interface Ports -----------------
        GT1_RXUSRCLK_IN                 =>      gt0_txusrclk_i,
        GT1_RXUSRCLK2_IN                =>      gt0_txusrclk_i,
        ------------------ Receive Ports - FPGA RX interface Ports -----------------
        GT1_RXDATA_OUT                  =>      gt1_rxdata_i,
        ------------------- Receive Ports - Pattern Checker Ports ------------------
        GT1_RXPRBSERR_OUT               =>      gt1_rxprbserr_i,
        GT1_RXPRBSSEL_IN                =>      gt1_rxprbssel_i,
        ------------------- Receive Ports - Pattern Checker ports ------------------
        GT1_RXPRBSCNTRESET_IN           =>      gt1_rxprbscntreset_i,
        ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
        GT1_RXDISPERR_OUT               =>      gt1_rxdisperr_i,
        GT1_RXNOTINTABLE_OUT            =>      gt1_rxnotintable_i,
        --------------------------- Receive Ports - RX AFE -------------------------
        GT1_GTXRXP_IN                   =>      RXP_IN(1),
        ------------------------ Receive Ports - RX AFE Ports ----------------------
        GT1_GTXRXN_IN                   =>      RXN_IN(1),
        -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
        GT1_RXMCOMMAALIGNEN_IN          =>      gt1_rxmcommaalignen_i,
        GT1_RXPCOMMAALIGNEN_IN          =>      gt1_rxpcommaalignen_i,
        --------------------- Receive Ports - RX Equalizer Ports -------------------
        GT1_RXDFELPMRESET_IN            =>      gt1_rxdfelpmreset_i,
        GT1_RXMONITOROUT_OUT            =>      gt1_rxmonitorout_i,
        GT1_RXMONITORSEL_IN             =>      gt1_rxmonitorsel_i,
        ------------- Receive Ports - RX Initialization and Reset Ports ------------
        GT1_GTRXRESET_IN                =>      gt1_gtrxreset_i,
        GT1_RXPMARESET_IN               =>      gt1_rxpmareset_i,
        ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
        GT1_RXCHARISCOMMA_OUT           =>      gt1_rxchariscomma_i,
        GT1_RXCHARISK_OUT               =>      gt1_rxcharisk_i,
        -------------- Receive Ports -RX Initialization and Reset Ports ------------
        GT1_RXRESETDONE_OUT             =>      gt1_rxresetdone_i,
        --------------------- TX Initialization and Reset Ports --------------------
        GT1_GTTXRESET_IN                =>      gt1_gttxreset_i,
        GT1_TXUSERRDY_IN                =>      gt1_txuserrdy_i,
        ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
        GT1_TXUSRCLK_IN                 =>      gt0_txusrclk_i,
        GT1_TXUSRCLK2_IN                =>      gt0_txusrclk_i,
        --------------- Transmit Ports - TX Configurable Driver Ports --------------
        GT1_TXDIFFCTRL_IN               =>      gt1_txdiffctrl_i,
        ------------------ Transmit Ports - TX Data Path interface -----------------
        GT1_TXDATA_IN                   =>      gt1_txdata_i,
        ---------------- Transmit Ports - TX Driver and OOB signaling --------------
        GT1_GTXTXN_OUT                  =>      TXN_OUT(1),
        GT1_GTXTXP_OUT                  =>      TXP_OUT(1),
        ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
        GT1_TXOUTCLK_OUT                =>      gt1_txoutclk_i,
        GT1_TXOUTCLKFABRIC_OUT          =>      gt1_txoutclkfabric_i,
        GT1_TXOUTCLKPCS_OUT             =>      gt1_txoutclkpcs_i,
        --------------------- Transmit Ports - TX Gearbox Ports --------------------
        GT1_TXCHARISK_IN                =>      gt1_txcharisk_i,
        ------------- Transmit Ports - TX Initialization and Reset Ports -----------
        GT1_TXRESETDONE_OUT             =>      gt1_txresetdone_i,
        ------------------ Transmit Ports - pattern Generator Ports ----------------
        GT1_TXPRBSSEL_IN                =>      gt1_txprbssel_i,


  
 
 

        --_____________________________________________________________________
        --_____________________________________________________________________
        --GT2  (X1Y2)

        ---------------------------- Channel - DRP Ports  --------------------------
        GT2_DRPADDR_IN                  =>      gt2_drpaddr_i,
        GT2_DRPCLK_IN                   =>      drpclk_in_i,
        GT2_DRPDI_IN                    =>      gt2_drpdi_i,
        GT2_DRPDO_OUT                   =>      gt2_drpdo_i,
        GT2_DRPEN_IN                    =>      gt2_drpen_i,
        GT2_DRPRDY_OUT                  =>      gt2_drprdy_i,
        GT2_DRPWE_IN                    =>      gt2_drpwe_i,
        ------------------------------- Loopback Ports -----------------------------
        GT2_LOOPBACK_IN                 =>      "000",
        --------------------- RX Initialization and Reset Ports --------------------
        GT2_RXUSERRDY_IN                =>      gt2_rxuserrdy_i,
        -------------------------- RX Margin Analysis Ports ------------------------
        GT2_EYESCANDATAERROR_OUT        =>      gt2_eyescandataerror_i,
        ------------------------- Receive Ports - CDR Ports ------------------------
        GT2_RXCDRLOCK_OUT               =>      gt2_rxcdrlock_i,
        ------------------- Receive Ports - Clock Correction Ports -----------------
        GT2_RXCLKCORCNT_OUT             =>      gt2_rxclkcorcnt_i,
        ------------------ Receive Ports - FPGA RX Interface Ports -----------------
        GT2_RXUSRCLK_IN                 =>      gt0_txusrclk_i,
        GT2_RXUSRCLK2_IN                =>      gt0_txusrclk_i,
        ------------------ Receive Ports - FPGA RX interface Ports -----------------
        GT2_RXDATA_OUT                  =>      gt2_rxdata_i,
        ------------------- Receive Ports - Pattern Checker Ports ------------------
        GT2_RXPRBSERR_OUT               =>      gt2_rxprbserr_i,
        GT2_RXPRBSSEL_IN                =>      gt2_rxprbssel_i,
        ------------------- Receive Ports - Pattern Checker ports ------------------
        GT2_RXPRBSCNTRESET_IN           =>      gt2_rxprbscntreset_i,
        ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
        GT2_RXDISPERR_OUT               =>      gt2_rxdisperr_i,
        GT2_RXNOTINTABLE_OUT            =>      gt2_rxnotintable_i,
        --------------------------- Receive Ports - RX AFE -------------------------
        GT2_GTXRXP_IN                   =>      RXP_IN(2),
        ------------------------ Receive Ports - RX AFE Ports ----------------------
        GT2_GTXRXN_IN                   =>      RXN_IN(2),
        -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
        GT2_RXMCOMMAALIGNEN_IN          =>      gt2_rxmcommaalignen_i,
        GT2_RXPCOMMAALIGNEN_IN          =>      gt2_rxpcommaalignen_i,
        --------------------- Receive Ports - RX Equalizer Ports -------------------
        GT2_RXDFELPMRESET_IN            =>      gt2_rxdfelpmreset_i,
        GT2_RXMONITOROUT_OUT            =>      gt2_rxmonitorout_i,
        GT2_RXMONITORSEL_IN             =>      gt2_rxmonitorsel_i,
        ------------- Receive Ports - RX Initialization and Reset Ports ------------
        GT2_GTRXRESET_IN                =>      gt2_gtrxreset_i,
        GT2_RXPMARESET_IN               =>      gt2_rxpmareset_i,
        ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
        GT2_RXCHARISCOMMA_OUT           =>      gt2_rxchariscomma_i,
        GT2_RXCHARISK_OUT               =>      gt2_rxcharisk_i,
        -------------- Receive Ports -RX Initialization and Reset Ports ------------
        GT2_RXRESETDONE_OUT             =>      gt2_rxresetdone_i,
        --------------------- TX Initialization and Reset Ports --------------------
        GT2_GTTXRESET_IN                =>      gt2_gttxreset_i,
        GT2_TXUSERRDY_IN                =>      gt2_txuserrdy_i,
        ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
        GT2_TXUSRCLK_IN                 =>      gt0_txusrclk_i,
        GT2_TXUSRCLK2_IN                =>      gt0_txusrclk_i,
        --------------- Transmit Ports - TX Configurable Driver Ports --------------
        GT2_TXDIFFCTRL_IN               =>      gt2_txdiffctrl_i,
        ------------------ Transmit Ports - TX Data Path interface -----------------
        GT2_TXDATA_IN                   =>      gt2_txdata_i,
        ---------------- Transmit Ports - TX Driver and OOB signaling --------------
        GT2_GTXTXN_OUT                  =>      TXN_OUT(2),
        GT2_GTXTXP_OUT                  =>      TXP_OUT(2),
        ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
        GT2_TXOUTCLK_OUT                =>      gt2_txoutclk_i,
        GT2_TXOUTCLKFABRIC_OUT          =>      gt2_txoutclkfabric_i,
        GT2_TXOUTCLKPCS_OUT             =>      gt2_txoutclkpcs_i,
        --------------------- Transmit Ports - TX Gearbox Ports --------------------
        GT2_TXCHARISK_IN                =>      gt2_txcharisk_i,
        ------------- Transmit Ports - TX Initialization and Reset Ports -----------
        GT2_TXRESETDONE_OUT             =>      gt2_txresetdone_i,
        ------------------ Transmit Ports - pattern Generator Ports ----------------
        GT2_TXPRBSSEL_IN                =>      gt2_txprbssel_i,


  
 
 

        --_____________________________________________________________________
        --_____________________________________________________________________
        --GT3  (X1Y3)

        ---------------------------- Channel - DRP Ports  --------------------------
        GT3_DRPADDR_IN                  =>      gt3_drpaddr_i,
        GT3_DRPCLK_IN                   =>      drpclk_in_i,
        GT3_DRPDI_IN                    =>      gt3_drpdi_i,
        GT3_DRPDO_OUT                   =>      gt3_drpdo_i,
        GT3_DRPEN_IN                    =>      gt3_drpen_i,
        GT3_DRPRDY_OUT                  =>      gt3_drprdy_i,
        GT3_DRPWE_IN                    =>      gt3_drpwe_i,
        ------------------------------- Loopback Ports -----------------------------
        GT3_LOOPBACK_IN                 =>      "000",
        --------------------- RX Initialization and Reset Ports --------------------
        GT3_RXUSERRDY_IN                =>      gt3_rxuserrdy_i,
        -------------------------- RX Margin Analysis Ports ------------------------
        GT3_EYESCANDATAERROR_OUT        =>      gt3_eyescandataerror_i,
        ------------------------- Receive Ports - CDR Ports ------------------------
        GT3_RXCDRLOCK_OUT               =>      gt3_rxcdrlock_i,
        ------------------- Receive Ports - Clock Correction Ports -----------------
        GT3_RXCLKCORCNT_OUT             =>      gt3_rxclkcorcnt_i,
        ------------------ Receive Ports - FPGA RX Interface Ports -----------------
        GT3_RXUSRCLK_IN                 =>      gt0_txusrclk_i,
        GT3_RXUSRCLK2_IN                =>      gt0_txusrclk_i,
        ------------------ Receive Ports - FPGA RX interface Ports -----------------
        GT3_RXDATA_OUT                  =>      gt3_rxdata_i,
        ------------------- Receive Ports - Pattern Checker Ports ------------------
        GT3_RXPRBSERR_OUT               =>      gt3_rxprbserr_i,
        GT3_RXPRBSSEL_IN                =>      gt3_rxprbssel_i,
        ------------------- Receive Ports - Pattern Checker ports ------------------
        GT3_RXPRBSCNTRESET_IN           =>      gt3_rxprbscntreset_i,
        ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
        GT3_RXDISPERR_OUT               =>      gt3_rxdisperr_i,
        GT3_RXNOTINTABLE_OUT            =>      gt3_rxnotintable_i,
        --------------------------- Receive Ports - RX AFE -------------------------
        GT3_GTXRXP_IN                   =>      RXP_IN(3),
        ------------------------ Receive Ports - RX AFE Ports ----------------------
        GT3_GTXRXN_IN                   =>      RXN_IN(3),
        -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
        GT3_RXMCOMMAALIGNEN_IN          =>      gt3_rxmcommaalignen_i,
        GT3_RXPCOMMAALIGNEN_IN          =>      gt3_rxpcommaalignen_i,
        --------------------- Receive Ports - RX Equalizer Ports -------------------
        GT3_RXDFELPMRESET_IN            =>      gt3_rxdfelpmreset_i,
        GT3_RXMONITOROUT_OUT            =>      gt3_rxmonitorout_i,
        GT3_RXMONITORSEL_IN             =>      gt3_rxmonitorsel_i,
        ------------- Receive Ports - RX Initialization and Reset Ports ------------
        GT3_GTRXRESET_IN                =>      gt3_gtrxreset_i,
        GT3_RXPMARESET_IN               =>      gt3_rxpmareset_i,
        ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
        GT3_RXCHARISCOMMA_OUT           =>      gt3_rxchariscomma_i,
        GT3_RXCHARISK_OUT               =>      gt3_rxcharisk_i,
        -------------- Receive Ports -RX Initialization and Reset Ports ------------
        GT3_RXRESETDONE_OUT             =>      gt3_rxresetdone_i,
        --------------------- TX Initialization and Reset Ports --------------------
        GT3_GTTXRESET_IN                =>      gt3_gttxreset_i,
        GT3_TXUSERRDY_IN                =>      gt3_txuserrdy_i,
        ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
        GT3_TXUSRCLK_IN                 =>      gt0_txusrclk_i,
        GT3_TXUSRCLK2_IN                =>      gt0_txusrclk_i,
        --------------- Transmit Ports - TX Configurable Driver Ports --------------
        GT3_TXDIFFCTRL_IN               =>      gt3_txdiffctrl_i,
        ------------------ Transmit Ports - TX Data Path interface -----------------
        GT3_TXDATA_IN                   =>      gt3_txdata_i,
        ---------------- Transmit Ports - TX Driver and OOB signaling --------------
        GT3_GTXTXN_OUT                  =>      TXN_OUT(3),
        GT3_GTXTXP_OUT                  =>      TXP_OUT(3),
        ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
        GT3_TXOUTCLK_OUT                =>      gt3_txoutclk_i,
        GT3_TXOUTCLKFABRIC_OUT          =>      gt3_txoutclkfabric_i,
        GT3_TXOUTCLKPCS_OUT             =>      gt3_txoutclkpcs_i,
        --------------------- Transmit Ports - TX Gearbox Ports --------------------
        GT3_TXCHARISK_IN                =>      gt3_txcharisk_i,
        ------------- Transmit Ports - TX Initialization and Reset Ports -----------
        GT3_TXRESETDONE_OUT             =>      gt3_txresetdone_i,
        ------------------ Transmit Ports - pattern Generator Ports ----------------
        GT3_TXPRBSSEL_IN                =>      gt3_txprbssel_i,


  
 
 

        --_____________________________________________________________________
        --_____________________________________________________________________
        --GT4  (X1Y4)

        ---------------------------- Channel - DRP Ports  --------------------------
        GT4_DRPADDR_IN                  =>      gt4_drpaddr_i,
        GT4_DRPCLK_IN                   =>      drpclk_in_i,
        GT4_DRPDI_IN                    =>      gt4_drpdi_i,
        GT4_DRPDO_OUT                   =>      gt4_drpdo_i,
        GT4_DRPEN_IN                    =>      gt4_drpen_i,
        GT4_DRPRDY_OUT                  =>      gt4_drprdy_i,
        GT4_DRPWE_IN                    =>      gt4_drpwe_i,
        ------------------------------- Loopback Ports -----------------------------
        GT4_LOOPBACK_IN                 =>      "000",
        --------------------- RX Initialization and Reset Ports --------------------
        GT4_RXUSERRDY_IN                =>      gt4_rxuserrdy_i,
        -------------------------- RX Margin Analysis Ports ------------------------
        GT4_EYESCANDATAERROR_OUT        =>      gt4_eyescandataerror_i,
        ------------------------- Receive Ports - CDR Ports ------------------------
        GT4_RXCDRLOCK_OUT               =>      gt4_rxcdrlock_i,
        ------------------- Receive Ports - Clock Correction Ports -----------------
        GT4_RXCLKCORCNT_OUT             =>      gt4_rxclkcorcnt_i,
        ------------------ Receive Ports - FPGA RX Interface Ports -----------------
        GT4_RXUSRCLK_IN                 =>      gt0_txusrclk_i,
        GT4_RXUSRCLK2_IN                =>      gt0_txusrclk_i,
        ------------------ Receive Ports - FPGA RX interface Ports -----------------
        GT4_RXDATA_OUT                  =>      gt4_rxdata_i,
        ------------------- Receive Ports - Pattern Checker Ports ------------------
        GT4_RXPRBSERR_OUT               =>      gt4_rxprbserr_i,
        GT4_RXPRBSSEL_IN                =>      gt4_rxprbssel_i,
        ------------------- Receive Ports - Pattern Checker ports ------------------
        GT4_RXPRBSCNTRESET_IN           =>      gt4_rxprbscntreset_i,
        ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
        GT4_RXDISPERR_OUT               =>      gt4_rxdisperr_i,
        GT4_RXNOTINTABLE_OUT            =>      gt4_rxnotintable_i,
        --------------------------- Receive Ports - RX AFE -------------------------
        GT4_GTXRXP_IN                   =>      RXP_IN(4),
        ------------------------ Receive Ports - RX AFE Ports ----------------------
        GT4_GTXRXN_IN                   =>      RXN_IN(4),
        -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
        GT4_RXMCOMMAALIGNEN_IN          =>      gt4_rxmcommaalignen_i,
        GT4_RXPCOMMAALIGNEN_IN          =>      gt4_rxpcommaalignen_i,
        --------------------- Receive Ports - RX Equalizer Ports -------------------
        GT4_RXDFELPMRESET_IN            =>      gt4_rxdfelpmreset_i,
        GT4_RXMONITOROUT_OUT            =>      gt4_rxmonitorout_i,
        GT4_RXMONITORSEL_IN             =>      gt4_rxmonitorsel_i,
        ------------- Receive Ports - RX Initialization and Reset Ports ------------
        GT4_GTRXRESET_IN                =>      gt4_gtrxreset_i,
        GT4_RXPMARESET_IN               =>      gt4_rxpmareset_i,
        ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
        GT4_RXCHARISCOMMA_OUT           =>      gt4_rxchariscomma_i,
        GT4_RXCHARISK_OUT               =>      gt4_rxcharisk_i,
        -------------- Receive Ports -RX Initialization and Reset Ports ------------
        GT4_RXRESETDONE_OUT             =>      gt4_rxresetdone_i,
        --------------------- TX Initialization and Reset Ports --------------------
        GT4_GTTXRESET_IN                =>      gt4_gttxreset_i,
        GT4_TXUSERRDY_IN                =>      gt4_txuserrdy_i,
        ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
        GT4_TXUSRCLK_IN                 =>      gt0_txusrclk_i,
        GT4_TXUSRCLK2_IN                =>      gt0_txusrclk_i,
        --------------- Transmit Ports - TX Configurable Driver Ports --------------
        GT4_TXDIFFCTRL_IN               =>      gt4_txdiffctrl_i,
        ------------------ Transmit Ports - TX Data Path interface -----------------
        GT4_TXDATA_IN                   =>      gt4_txdata_i,
        ---------------- Transmit Ports - TX Driver and OOB signaling --------------
        GT4_GTXTXN_OUT                  =>      TXN_OUT(4),
        GT4_GTXTXP_OUT                  =>      TXP_OUT(4),
        ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
        GT4_TXOUTCLK_OUT                =>      gt4_txoutclk_i,
        GT4_TXOUTCLKFABRIC_OUT          =>      gt4_txoutclkfabric_i,
        GT4_TXOUTCLKPCS_OUT             =>      gt4_txoutclkpcs_i,
        --------------------- Transmit Ports - TX Gearbox Ports --------------------
        GT4_TXCHARISK_IN                =>      gt4_txcharisk_i,
        ------------- Transmit Ports - TX Initialization and Reset Ports -----------
        GT4_TXRESETDONE_OUT             =>      gt4_txresetdone_i,
        ------------------ Transmit Ports - pattern Generator Ports ----------------
        GT4_TXPRBSSEL_IN                =>      gt4_txprbssel_i,


  
 
 

        --_____________________________________________________________________
        --_____________________________________________________________________
        --GT5  (X1Y5)

        ---------------------------- Channel - DRP Ports  --------------------------
        GT5_DRPADDR_IN                  =>      gt5_drpaddr_i,
        GT5_DRPCLK_IN                   =>      drpclk_in_i,
        GT5_DRPDI_IN                    =>      gt5_drpdi_i,
        GT5_DRPDO_OUT                   =>      gt5_drpdo_i,
        GT5_DRPEN_IN                    =>      gt5_drpen_i,
        GT5_DRPRDY_OUT                  =>      gt5_drprdy_i,
        GT5_DRPWE_IN                    =>      gt5_drpwe_i,
        ------------------------------- Loopback Ports -----------------------------
        GT5_LOOPBACK_IN                 =>      "000",
        --------------------- RX Initialization and Reset Ports --------------------
        GT5_RXUSERRDY_IN                =>      gt5_rxuserrdy_i,
        -------------------------- RX Margin Analysis Ports ------------------------
        GT5_EYESCANDATAERROR_OUT        =>      gt5_eyescandataerror_i,
        ------------------------- Receive Ports - CDR Ports ------------------------
        GT5_RXCDRLOCK_OUT               =>      gt5_rxcdrlock_i,
        ------------------- Receive Ports - Clock Correction Ports -----------------
        GT5_RXCLKCORCNT_OUT             =>      gt5_rxclkcorcnt_i,
        ------------------ Receive Ports - FPGA RX Interface Ports -----------------
        GT5_RXUSRCLK_IN                 =>      gt0_txusrclk_i,
        GT5_RXUSRCLK2_IN                =>      gt0_txusrclk_i,
        ------------------ Receive Ports - FPGA RX interface Ports -----------------
        GT5_RXDATA_OUT                  =>      gt5_rxdata_i,
        ------------------- Receive Ports - Pattern Checker Ports ------------------
        GT5_RXPRBSERR_OUT               =>      gt5_rxprbserr_i,
        GT5_RXPRBSSEL_IN                =>      gt5_rxprbssel_i,
        ------------------- Receive Ports - Pattern Checker ports ------------------
        GT5_RXPRBSCNTRESET_IN           =>      gt5_rxprbscntreset_i,
        ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
        GT5_RXDISPERR_OUT               =>      gt5_rxdisperr_i,
        GT5_RXNOTINTABLE_OUT            =>      gt5_rxnotintable_i,
        --------------------------- Receive Ports - RX AFE -------------------------
        GT5_GTXRXP_IN                   =>      RXP_IN(5),
        ------------------------ Receive Ports - RX AFE Ports ----------------------
        GT5_GTXRXN_IN                   =>      RXN_IN(5),
        -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
        GT5_RXMCOMMAALIGNEN_IN          =>      gt5_rxmcommaalignen_i,
        GT5_RXPCOMMAALIGNEN_IN          =>      gt5_rxpcommaalignen_i,
        --------------------- Receive Ports - RX Equalizer Ports -------------------
        GT5_RXDFELPMRESET_IN            =>      gt5_rxdfelpmreset_i,
        GT5_RXMONITOROUT_OUT            =>      gt5_rxmonitorout_i,
        GT5_RXMONITORSEL_IN             =>      gt5_rxmonitorsel_i,
        ------------- Receive Ports - RX Initialization and Reset Ports ------------
        GT5_GTRXRESET_IN                =>      gt5_gtrxreset_i,
        GT5_RXPMARESET_IN               =>      gt5_rxpmareset_i,
        ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
        GT5_RXCHARISCOMMA_OUT           =>      gt5_rxchariscomma_i,
        GT5_RXCHARISK_OUT               =>      gt5_rxcharisk_i,
        -------------- Receive Ports -RX Initialization and Reset Ports ------------
        GT5_RXRESETDONE_OUT             =>      gt5_rxresetdone_i,
        --------------------- TX Initialization and Reset Ports --------------------
        GT5_GTTXRESET_IN                =>      gt5_gttxreset_i,
        GT5_TXUSERRDY_IN                =>      gt5_txuserrdy_i,
        ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
        GT5_TXUSRCLK_IN                 =>      gt0_txusrclk_i,
        GT5_TXUSRCLK2_IN                =>      gt0_txusrclk_i,
        --------------- Transmit Ports - TX Configurable Driver Ports --------------
        GT5_TXDIFFCTRL_IN               =>      gt5_txdiffctrl_i,
        ------------------ Transmit Ports - TX Data Path interface -----------------
        GT5_TXDATA_IN                   =>      gt5_txdata_i,
        ---------------- Transmit Ports - TX Driver and OOB signaling --------------
        GT5_GTXTXN_OUT                  =>      TXN_OUT(5),
        GT5_GTXTXP_OUT                  =>      TXP_OUT(5),
        ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
        GT5_TXOUTCLK_OUT                =>      gt5_txoutclk_i,
        GT5_TXOUTCLKFABRIC_OUT          =>      gt5_txoutclkfabric_i,
        GT5_TXOUTCLKPCS_OUT             =>      gt5_txoutclkpcs_i,
        --------------------- Transmit Ports - TX Gearbox Ports --------------------
        GT5_TXCHARISK_IN                =>      gt5_txcharisk_i,
        ------------- Transmit Ports - TX Initialization and Reset Ports -----------
        GT5_TXRESETDONE_OUT             =>      gt5_txresetdone_i,
        ------------------ Transmit Ports - pattern Generator Ports ----------------
        GT5_TXPRBSSEL_IN                =>      gt5_txprbssel_i,


  
 
 

        --_____________________________________________________________________
        --_____________________________________________________________________
        --GT6  (X1Y6)

        ---------------------------- Channel - DRP Ports  --------------------------
        GT6_DRPADDR_IN                  =>      gt6_drpaddr_i,
        GT6_DRPCLK_IN                   =>      drpclk_in_i,
        GT6_DRPDI_IN                    =>      gt6_drpdi_i,
        GT6_DRPDO_OUT                   =>      gt6_drpdo_i,
        GT6_DRPEN_IN                    =>      gt6_drpen_i,
        GT6_DRPRDY_OUT                  =>      gt6_drprdy_i,
        GT6_DRPWE_IN                    =>      gt6_drpwe_i,
        ------------------------------- Loopback Ports -----------------------------
        GT6_LOOPBACK_IN                 =>      "000",
        --------------------- RX Initialization and Reset Ports --------------------
        GT6_RXUSERRDY_IN                =>      gt6_rxuserrdy_i,
        -------------------------- RX Margin Analysis Ports ------------------------
        GT6_EYESCANDATAERROR_OUT        =>      gt6_eyescandataerror_i,
        ------------------------- Receive Ports - CDR Ports ------------------------
        GT6_RXCDRLOCK_OUT               =>      gt6_rxcdrlock_i,
        ------------------- Receive Ports - Clock Correction Ports -----------------
        GT6_RXCLKCORCNT_OUT             =>      gt6_rxclkcorcnt_i,
        ------------------ Receive Ports - FPGA RX Interface Ports -----------------
        GT6_RXUSRCLK_IN                 =>      gt0_txusrclk_i,
        GT6_RXUSRCLK2_IN                =>      gt0_txusrclk_i,
        ------------------ Receive Ports - FPGA RX interface Ports -----------------
        GT6_RXDATA_OUT                  =>      gt6_rxdata_i,
        ------------------- Receive Ports - Pattern Checker Ports ------------------
        GT6_RXPRBSERR_OUT               =>      gt6_rxprbserr_i,
        GT6_RXPRBSSEL_IN                =>      gt6_rxprbssel_i,
        ------------------- Receive Ports - Pattern Checker ports ------------------
        GT6_RXPRBSCNTRESET_IN           =>      gt6_rxprbscntreset_i,
        ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
        GT6_RXDISPERR_OUT               =>      gt6_rxdisperr_i,
        GT6_RXNOTINTABLE_OUT            =>      gt6_rxnotintable_i,
        --------------------------- Receive Ports - RX AFE -------------------------
        GT6_GTXRXP_IN                   =>      RXP_IN(6),
        ------------------------ Receive Ports - RX AFE Ports ----------------------
        GT6_GTXRXN_IN                   =>      RXN_IN(6),
        -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
        GT6_RXMCOMMAALIGNEN_IN          =>      gt6_rxmcommaalignen_i,
        GT6_RXPCOMMAALIGNEN_IN          =>      gt6_rxpcommaalignen_i,
        --------------------- Receive Ports - RX Equalizer Ports -------------------
        GT6_RXDFELPMRESET_IN            =>      gt6_rxdfelpmreset_i,
        GT6_RXMONITOROUT_OUT            =>      gt6_rxmonitorout_i,
        GT6_RXMONITORSEL_IN             =>      gt6_rxmonitorsel_i,
        ------------- Receive Ports - RX Initialization and Reset Ports ------------
        GT6_GTRXRESET_IN                =>      gt6_gtrxreset_i,
        GT6_RXPMARESET_IN               =>      gt6_rxpmareset_i,
        ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
        GT6_RXCHARISCOMMA_OUT           =>      gt6_rxchariscomma_i,
        GT6_RXCHARISK_OUT               =>      gt6_rxcharisk_i,
        -------------- Receive Ports -RX Initialization and Reset Ports ------------
        GT6_RXRESETDONE_OUT             =>      gt6_rxresetdone_i,
        --------------------- TX Initialization and Reset Ports --------------------
        GT6_GTTXRESET_IN                =>      gt6_gttxreset_i,
        GT6_TXUSERRDY_IN                =>      gt6_txuserrdy_i,
        ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
        GT6_TXUSRCLK_IN                 =>      gt0_txusrclk_i,
        GT6_TXUSRCLK2_IN                =>      gt0_txusrclk_i,
        --------------- Transmit Ports - TX Configurable Driver Ports --------------
        GT6_TXDIFFCTRL_IN               =>      gt6_txdiffctrl_i,
        ------------------ Transmit Ports - TX Data Path interface -----------------
        GT6_TXDATA_IN                   =>      gt6_txdata_i,
        ---------------- Transmit Ports - TX Driver and OOB signaling --------------
        GT6_GTXTXN_OUT                  =>      TXN_OUT(6),
        GT6_GTXTXP_OUT                  =>      TXP_OUT(6),
        ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
        GT6_TXOUTCLK_OUT                =>      gt6_txoutclk_i,
        GT6_TXOUTCLKFABRIC_OUT          =>      gt6_txoutclkfabric_i,
        GT6_TXOUTCLKPCS_OUT             =>      gt6_txoutclkpcs_i,
        --------------------- Transmit Ports - TX Gearbox Ports --------------------
        GT6_TXCHARISK_IN                =>      gt6_txcharisk_i,
        ------------- Transmit Ports - TX Initialization and Reset Ports -----------
        GT6_TXRESETDONE_OUT             =>      gt6_txresetdone_i,
        ------------------ Transmit Ports - pattern Generator Ports ----------------
        GT6_TXPRBSSEL_IN                =>      gt6_txprbssel_i,


  
 
 

        --_____________________________________________________________________
        --_____________________________________________________________________
        --GT7  (X1Y7)

        ---------------------------- Channel - DRP Ports  --------------------------
        GT7_DRPADDR_IN                  =>      gt7_drpaddr_i,
        GT7_DRPCLK_IN                   =>      drpclk_in_i,
        GT7_DRPDI_IN                    =>      gt7_drpdi_i,
        GT7_DRPDO_OUT                   =>      gt7_drpdo_i,
        GT7_DRPEN_IN                    =>      gt7_drpen_i,
        GT7_DRPRDY_OUT                  =>      gt7_drprdy_i,
        GT7_DRPWE_IN                    =>      gt7_drpwe_i,
        ------------------------------- Loopback Ports -----------------------------
        GT7_LOOPBACK_IN                 =>      "000",
        --------------------- RX Initialization and Reset Ports --------------------
        GT7_RXUSERRDY_IN                =>      gt7_rxuserrdy_i,
        -------------------------- RX Margin Analysis Ports ------------------------
        GT7_EYESCANDATAERROR_OUT        =>      gt7_eyescandataerror_i,
        ------------------------- Receive Ports - CDR Ports ------------------------
        GT7_RXCDRLOCK_OUT               =>      gt7_rxcdrlock_i,
        ------------------- Receive Ports - Clock Correction Ports -----------------
        GT7_RXCLKCORCNT_OUT             =>      gt7_rxclkcorcnt_i,
        ------------------ Receive Ports - FPGA RX Interface Ports -----------------
        GT7_RXUSRCLK_IN                 =>      gt0_txusrclk_i,
        GT7_RXUSRCLK2_IN                =>      gt0_txusrclk_i,
        ------------------ Receive Ports - FPGA RX interface Ports -----------------
        GT7_RXDATA_OUT                  =>      gt7_rxdata_i,
        ------------------- Receive Ports - Pattern Checker Ports ------------------
        GT7_RXPRBSERR_OUT               =>      gt7_rxprbserr_i,
        GT7_RXPRBSSEL_IN                =>      gt7_rxprbssel_i,
        ------------------- Receive Ports - Pattern Checker ports ------------------
        GT7_RXPRBSCNTRESET_IN           =>      gt7_rxprbscntreset_i,
        ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
        GT7_RXDISPERR_OUT               =>      gt7_rxdisperr_i,
        GT7_RXNOTINTABLE_OUT            =>      gt7_rxnotintable_i,
        --------------------------- Receive Ports - RX AFE -------------------------
        GT7_GTXRXP_IN                   =>      RXP_IN(7),
        ------------------------ Receive Ports - RX AFE Ports ----------------------
        GT7_GTXRXN_IN                   =>      RXN_IN(7),
        -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
        GT7_RXMCOMMAALIGNEN_IN          =>      gt7_rxmcommaalignen_i,
        GT7_RXPCOMMAALIGNEN_IN          =>      gt7_rxpcommaalignen_i,
        --------------------- Receive Ports - RX Equalizer Ports -------------------
        GT7_RXDFELPMRESET_IN            =>      gt7_rxdfelpmreset_i,
        GT7_RXMONITOROUT_OUT            =>      gt7_rxmonitorout_i,
        GT7_RXMONITORSEL_IN             =>      gt7_rxmonitorsel_i,
        ------------- Receive Ports - RX Initialization and Reset Ports ------------
        GT7_GTRXRESET_IN                =>      gt7_gtrxreset_i,
        GT7_RXPMARESET_IN               =>      gt7_rxpmareset_i,
        ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
        GT7_RXCHARISCOMMA_OUT           =>      gt7_rxchariscomma_i,
        GT7_RXCHARISK_OUT               =>      gt7_rxcharisk_i,
        -------------- Receive Ports -RX Initialization and Reset Ports ------------
        GT7_RXRESETDONE_OUT             =>      gt7_rxresetdone_i,
        --------------------- TX Initialization and Reset Ports --------------------
        GT7_GTTXRESET_IN                =>      gt7_gttxreset_i,
        GT7_TXUSERRDY_IN                =>      gt7_txuserrdy_i,
        ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
        GT7_TXUSRCLK_IN                 =>      gt0_txusrclk_i,
        GT7_TXUSRCLK2_IN                =>      gt0_txusrclk_i,
        --------------- Transmit Ports - TX Configurable Driver Ports --------------
        GT7_TXDIFFCTRL_IN               =>      gt7_txdiffctrl_i,
        ------------------ Transmit Ports - TX Data Path interface -----------------
        GT7_TXDATA_IN                   =>      gt7_txdata_i,
        ---------------- Transmit Ports - TX Driver and OOB signaling --------------
        GT7_GTXTXN_OUT                  =>      TXN_OUT(7),
        GT7_GTXTXP_OUT                  =>      TXP_OUT(7),
        ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
        GT7_TXOUTCLK_OUT                =>      gt7_txoutclk_i,
        GT7_TXOUTCLKFABRIC_OUT          =>      gt7_txoutclkfabric_i,
        GT7_TXOUTCLKPCS_OUT             =>      gt7_txoutclkpcs_i,
        --------------------- Transmit Ports - TX Gearbox Ports --------------------
        GT7_TXCHARISK_IN                =>      gt7_txcharisk_i,
        ------------- Transmit Ports - TX Initialization and Reset Ports -----------
        GT7_TXRESETDONE_OUT             =>      gt7_txresetdone_i,
        ------------------ Transmit Ports - pattern Generator Ports ----------------
        GT7_TXPRBSSEL_IN                =>      gt7_txprbssel_i,


  
 
 

        --_____________________________________________________________________
        --_____________________________________________________________________
        --GT8  (X1Y8)

        ---------------------------- Channel - DRP Ports  --------------------------
        GT8_DRPADDR_IN                  =>      gt8_drpaddr_i,
        GT8_DRPCLK_IN                   =>      drpclk_in_i,
        GT8_DRPDI_IN                    =>      gt8_drpdi_i,
        GT8_DRPDO_OUT                   =>      gt8_drpdo_i,
        GT8_DRPEN_IN                    =>      gt8_drpen_i,
        GT8_DRPRDY_OUT                  =>      gt8_drprdy_i,
        GT8_DRPWE_IN                    =>      gt8_drpwe_i,
        ------------------------------- Loopback Ports -----------------------------
        GT8_LOOPBACK_IN                 =>      "000",
        --------------------- RX Initialization and Reset Ports --------------------
        GT8_RXUSERRDY_IN                =>      gt8_rxuserrdy_i,
        -------------------------- RX Margin Analysis Ports ------------------------
        GT8_EYESCANDATAERROR_OUT        =>      gt8_eyescandataerror_i,
        ------------------------- Receive Ports - CDR Ports ------------------------
        GT8_RXCDRLOCK_OUT               =>      gt8_rxcdrlock_i,
        ------------------- Receive Ports - Clock Correction Ports -----------------
        GT8_RXCLKCORCNT_OUT             =>      gt8_rxclkcorcnt_i,
        ------------------ Receive Ports - FPGA RX Interface Ports -----------------
        GT8_RXUSRCLK_IN                 =>      gt0_txusrclk_i,
        GT8_RXUSRCLK2_IN                =>      gt0_txusrclk_i,
        ------------------ Receive Ports - FPGA RX interface Ports -----------------
        GT8_RXDATA_OUT                  =>      gt8_rxdata_i,
        ------------------- Receive Ports - Pattern Checker Ports ------------------
        GT8_RXPRBSERR_OUT               =>      gt8_rxprbserr_i,
        GT8_RXPRBSSEL_IN                =>      gt8_rxprbssel_i,
        ------------------- Receive Ports - Pattern Checker ports ------------------
        GT8_RXPRBSCNTRESET_IN           =>      gt8_rxprbscntreset_i,
        ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
        GT8_RXDISPERR_OUT               =>      gt8_rxdisperr_i,
        GT8_RXNOTINTABLE_OUT            =>      gt8_rxnotintable_i,
        --------------------------- Receive Ports - RX AFE -------------------------
        GT8_GTXRXP_IN                   =>      RXP_IN(8),
        ------------------------ Receive Ports - RX AFE Ports ----------------------
        GT8_GTXRXN_IN                   =>      RXN_IN(8),
        -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
        GT8_RXMCOMMAALIGNEN_IN          =>      gt8_rxmcommaalignen_i,
        GT8_RXPCOMMAALIGNEN_IN          =>      gt8_rxpcommaalignen_i,
        --------------------- Receive Ports - RX Equalizer Ports -------------------
        GT8_RXDFELPMRESET_IN            =>      gt8_rxdfelpmreset_i,
        GT8_RXMONITOROUT_OUT            =>      gt8_rxmonitorout_i,
        GT8_RXMONITORSEL_IN             =>      gt8_rxmonitorsel_i,
        ------------- Receive Ports - RX Initialization and Reset Ports ------------
        GT8_GTRXRESET_IN                =>      gt8_gtrxreset_i,
        GT8_RXPMARESET_IN               =>      gt8_rxpmareset_i,
        ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
        GT8_RXCHARISCOMMA_OUT           =>      gt8_rxchariscomma_i,
        GT8_RXCHARISK_OUT               =>      gt8_rxcharisk_i,
        -------------- Receive Ports -RX Initialization and Reset Ports ------------
        GT8_RXRESETDONE_OUT             =>      gt8_rxresetdone_i,
        --------------------- TX Initialization and Reset Ports --------------------
        GT8_GTTXRESET_IN                =>      gt8_gttxreset_i,
        GT8_TXUSERRDY_IN                =>      gt8_txuserrdy_i,
        ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
        GT8_TXUSRCLK_IN                 =>      gt0_txusrclk_i,
        GT8_TXUSRCLK2_IN                =>      gt0_txusrclk_i,
        --------------- Transmit Ports - TX Configurable Driver Ports --------------
        GT8_TXDIFFCTRL_IN               =>      gt8_txdiffctrl_i,
        ------------------ Transmit Ports - TX Data Path interface -----------------
        GT8_TXDATA_IN                   =>      gt8_txdata_i,
        ---------------- Transmit Ports - TX Driver and OOB signaling --------------
        GT8_GTXTXN_OUT                  =>      TXN_OUT(8),
        GT8_GTXTXP_OUT                  =>      TXP_OUT(8),
        ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
        GT8_TXOUTCLK_OUT                =>      gt8_txoutclk_i,
        GT8_TXOUTCLKFABRIC_OUT          =>      gt8_txoutclkfabric_i,
        GT8_TXOUTCLKPCS_OUT             =>      gt8_txoutclkpcs_i,
        --------------------- Transmit Ports - TX Gearbox Ports --------------------
        GT8_TXCHARISK_IN                =>      gt8_txcharisk_i,
        ------------- Transmit Ports - TX Initialization and Reset Ports -----------
        GT8_TXRESETDONE_OUT             =>      gt8_txresetdone_i,
        ------------------ Transmit Ports - pattern Generator Ports ----------------
        GT8_TXPRBSSEL_IN                =>      gt8_txprbssel_i,


  
 
 

        --_____________________________________________________________________
        --_____________________________________________________________________
        --GT9  (X1Y9)

        ---------------------------- Channel - DRP Ports  --------------------------
        GT9_DRPADDR_IN                  =>      gt9_drpaddr_i,
        GT9_DRPCLK_IN                   =>      drpclk_in_i,
        GT9_DRPDI_IN                    =>      gt9_drpdi_i,
        GT9_DRPDO_OUT                   =>      gt9_drpdo_i,
        GT9_DRPEN_IN                    =>      gt9_drpen_i,
        GT9_DRPRDY_OUT                  =>      gt9_drprdy_i,
        GT9_DRPWE_IN                    =>      gt9_drpwe_i,
        ------------------------------- Loopback Ports -----------------------------
        GT9_LOOPBACK_IN                 =>      "000",
        --------------------- RX Initialization and Reset Ports --------------------
        GT9_RXUSERRDY_IN                =>      gt9_rxuserrdy_i,
        -------------------------- RX Margin Analysis Ports ------------------------
        GT9_EYESCANDATAERROR_OUT        =>      gt9_eyescandataerror_i,
        ------------------------- Receive Ports - CDR Ports ------------------------
        GT9_RXCDRLOCK_OUT               =>      gt9_rxcdrlock_i,
        ------------------- Receive Ports - Clock Correction Ports -----------------
        GT9_RXCLKCORCNT_OUT             =>      gt9_rxclkcorcnt_i,
        ------------------ Receive Ports - FPGA RX Interface Ports -----------------
        GT9_RXUSRCLK_IN                 =>      gt0_txusrclk_i,
        GT9_RXUSRCLK2_IN                =>      gt0_txusrclk_i,
        ------------------ Receive Ports - FPGA RX interface Ports -----------------
        GT9_RXDATA_OUT                  =>      gt9_rxdata_i,
        ------------------- Receive Ports - Pattern Checker Ports ------------------
        GT9_RXPRBSERR_OUT               =>      gt9_rxprbserr_i,
        GT9_RXPRBSSEL_IN                =>      gt9_rxprbssel_i,
        ------------------- Receive Ports - Pattern Checker ports ------------------
        GT9_RXPRBSCNTRESET_IN           =>      gt9_rxprbscntreset_i,
        ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
        GT9_RXDISPERR_OUT               =>      gt9_rxdisperr_i,
        GT9_RXNOTINTABLE_OUT            =>      gt9_rxnotintable_i,
        --------------------------- Receive Ports - RX AFE -------------------------
        GT9_GTXRXP_IN                   =>      RXP_IN(9),
        ------------------------ Receive Ports - RX AFE Ports ----------------------
        GT9_GTXRXN_IN                   =>      RXN_IN(9),
        -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
        GT9_RXMCOMMAALIGNEN_IN          =>      gt9_rxmcommaalignen_i,
        GT9_RXPCOMMAALIGNEN_IN          =>      gt9_rxpcommaalignen_i,
        --------------------- Receive Ports - RX Equalizer Ports -------------------
        GT9_RXDFELPMRESET_IN            =>      gt9_rxdfelpmreset_i,
        GT9_RXMONITOROUT_OUT            =>      gt9_rxmonitorout_i,
        GT9_RXMONITORSEL_IN             =>      gt9_rxmonitorsel_i,
        ------------- Receive Ports - RX Initialization and Reset Ports ------------
        GT9_GTRXRESET_IN                =>      gt9_gtrxreset_i,
        GT9_RXPMARESET_IN               =>      gt9_rxpmareset_i,
        ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
        GT9_RXCHARISCOMMA_OUT           =>      gt9_rxchariscomma_i,
        GT9_RXCHARISK_OUT               =>      gt9_rxcharisk_i,
        -------------- Receive Ports -RX Initialization and Reset Ports ------------
        GT9_RXRESETDONE_OUT             =>      gt9_rxresetdone_i,
        --------------------- TX Initialization and Reset Ports --------------------
        GT9_GTTXRESET_IN                =>      gt9_gttxreset_i,
        GT9_TXUSERRDY_IN                =>      gt9_txuserrdy_i,
        ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
        GT9_TXUSRCLK_IN                 =>      gt0_txusrclk_i,
        GT9_TXUSRCLK2_IN                =>      gt0_txusrclk_i,
        --------------- Transmit Ports - TX Configurable Driver Ports --------------
        GT9_TXDIFFCTRL_IN               =>      gt9_txdiffctrl_i,
        ------------------ Transmit Ports - TX Data Path interface -----------------
        GT9_TXDATA_IN                   =>      gt9_txdata_i,
        ---------------- Transmit Ports - TX Driver and OOB signaling --------------
        GT9_GTXTXN_OUT                  =>      TXN_OUT(9),
        GT9_GTXTXP_OUT                  =>      TXP_OUT(9),
        ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
        GT9_TXOUTCLK_OUT                =>      gt9_txoutclk_i,
        GT9_TXOUTCLKFABRIC_OUT          =>      gt9_txoutclkfabric_i,
        GT9_TXOUTCLKPCS_OUT             =>      gt9_txoutclkpcs_i,
        --------------------- Transmit Ports - TX Gearbox Ports --------------------
        GT9_TXCHARISK_IN                =>      gt9_txcharisk_i,
        ------------- Transmit Ports - TX Initialization and Reset Ports -----------
        GT9_TXRESETDONE_OUT             =>      gt9_txresetdone_i,
        ------------------ Transmit Ports - pattern Generator Ports ----------------
        GT9_TXPRBSSEL_IN                =>      gt9_txprbssel_i,


  
 
 

        --_____________________________________________________________________
        --_____________________________________________________________________
        --GT10  (X1Y10)

        ---------------------------- Channel - DRP Ports  --------------------------
        GT10_DRPADDR_IN                 =>      gt10_drpaddr_i,
        GT10_DRPCLK_IN                  =>      drpclk_in_i,
        GT10_DRPDI_IN                   =>      gt10_drpdi_i,
        GT10_DRPDO_OUT                  =>      gt10_drpdo_i,
        GT10_DRPEN_IN                   =>      gt10_drpen_i,
        GT10_DRPRDY_OUT                 =>      gt10_drprdy_i,
        GT10_DRPWE_IN                   =>      gt10_drpwe_i,
        ------------------------------- Loopback Ports -----------------------------
        GT10_LOOPBACK_IN                =>      "000",
        --------------------- RX Initialization and Reset Ports --------------------
        GT10_RXUSERRDY_IN               =>      gt10_rxuserrdy_i,
        -------------------------- RX Margin Analysis Ports ------------------------
        GT10_EYESCANDATAERROR_OUT       =>      gt10_eyescandataerror_i,
        ------------------------- Receive Ports - CDR Ports ------------------------
        GT10_RXCDRLOCK_OUT              =>      gt10_rxcdrlock_i,
        ------------------- Receive Ports - Clock Correction Ports -----------------
        GT10_RXCLKCORCNT_OUT            =>      gt10_rxclkcorcnt_i,
        ------------------ Receive Ports - FPGA RX Interface Ports -----------------
        GT10_RXUSRCLK_IN                =>      gt0_txusrclk_i,
        GT10_RXUSRCLK2_IN               =>      gt0_txusrclk_i,
        ------------------ Receive Ports - FPGA RX interface Ports -----------------
        GT10_RXDATA_OUT                 =>      gt10_rxdata_i,
        ------------------- Receive Ports - Pattern Checker Ports ------------------
        GT10_RXPRBSERR_OUT              =>      gt10_rxprbserr_i,
        GT10_RXPRBSSEL_IN               =>      gt10_rxprbssel_i,
        ------------------- Receive Ports - Pattern Checker ports ------------------
        GT10_RXPRBSCNTRESET_IN          =>      gt10_rxprbscntreset_i,
        ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
        GT10_RXDISPERR_OUT              =>      gt10_rxdisperr_i,
        GT10_RXNOTINTABLE_OUT           =>      gt10_rxnotintable_i,
        --------------------------- Receive Ports - RX AFE -------------------------
        GT10_GTXRXP_IN                  =>      RXP_IN(10),
        ------------------------ Receive Ports - RX AFE Ports ----------------------
        GT10_GTXRXN_IN                  =>      RXN_IN(10),
        -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
        GT10_RXMCOMMAALIGNEN_IN         =>      gt10_rxmcommaalignen_i,
        GT10_RXPCOMMAALIGNEN_IN         =>      gt10_rxpcommaalignen_i,
        --------------------- Receive Ports - RX Equalizer Ports -------------------
        GT10_RXDFELPMRESET_IN           =>      gt10_rxdfelpmreset_i,
        GT10_RXMONITOROUT_OUT           =>      gt10_rxmonitorout_i,
        GT10_RXMONITORSEL_IN            =>      gt10_rxmonitorsel_i,
        ------------- Receive Ports - RX Initialization and Reset Ports ------------
        GT10_GTRXRESET_IN               =>      gt10_gtrxreset_i,
        GT10_RXPMARESET_IN              =>      gt10_rxpmareset_i,
        ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
        GT10_RXCHARISCOMMA_OUT          =>      gt10_rxchariscomma_i,
        GT10_RXCHARISK_OUT              =>      gt10_rxcharisk_i,
        -------------- Receive Ports -RX Initialization and Reset Ports ------------
        GT10_RXRESETDONE_OUT            =>      gt10_rxresetdone_i,
        --------------------- TX Initialization and Reset Ports --------------------
        GT10_GTTXRESET_IN               =>      gt10_gttxreset_i,
        GT10_TXUSERRDY_IN               =>      gt10_txuserrdy_i,
        ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
        GT10_TXUSRCLK_IN                =>      gt0_txusrclk_i,
        GT10_TXUSRCLK2_IN               =>      gt0_txusrclk_i,
        --------------- Transmit Ports - TX Configurable Driver Ports --------------
        GT10_TXDIFFCTRL_IN              =>      gt10_txdiffctrl_i,
        ------------------ Transmit Ports - TX Data Path interface -----------------
        GT10_TXDATA_IN                  =>      gt10_txdata_i,
        ---------------- Transmit Ports - TX Driver and OOB signaling --------------
        GT10_GTXTXN_OUT                 =>      TXN_OUT(10),
        GT10_GTXTXP_OUT                 =>      TXP_OUT(10),
        ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
        GT10_TXOUTCLK_OUT               =>      gt10_txoutclk_i,
        GT10_TXOUTCLKFABRIC_OUT         =>      gt10_txoutclkfabric_i,
        GT10_TXOUTCLKPCS_OUT            =>      gt10_txoutclkpcs_i,
        --------------------- Transmit Ports - TX Gearbox Ports --------------------
        GT10_TXCHARISK_IN               =>      gt10_txcharisk_i,
        ------------- Transmit Ports - TX Initialization and Reset Ports -----------
        GT10_TXRESETDONE_OUT            =>      gt10_txresetdone_i,
        ------------------ Transmit Ports - pattern Generator Ports ----------------
        GT10_TXPRBSSEL_IN               =>      gt10_txprbssel_i,


  
 
 

        --_____________________________________________________________________
        --_____________________________________________________________________
        --GT11  (X1Y11)

        ---------------------------- Channel - DRP Ports  --------------------------
        GT11_DRPADDR_IN                 =>      gt11_drpaddr_i,
        GT11_DRPCLK_IN                  =>      drpclk_in_i,
        GT11_DRPDI_IN                   =>      gt11_drpdi_i,
        GT11_DRPDO_OUT                  =>      gt11_drpdo_i,
        GT11_DRPEN_IN                   =>      gt11_drpen_i,
        GT11_DRPRDY_OUT                 =>      gt11_drprdy_i,
        GT11_DRPWE_IN                   =>      gt11_drpwe_i,
        ------------------------------- Loopback Ports -----------------------------
        GT11_LOOPBACK_IN                =>      "000",
        --------------------- RX Initialization and Reset Ports --------------------
        GT11_RXUSERRDY_IN               =>      gt11_rxuserrdy_i,
        -------------------------- RX Margin Analysis Ports ------------------------
        GT11_EYESCANDATAERROR_OUT       =>      gt11_eyescandataerror_i,
        ------------------------- Receive Ports - CDR Ports ------------------------
        GT11_RXCDRLOCK_OUT              =>      gt11_rxcdrlock_i,
        ------------------- Receive Ports - Clock Correction Ports -----------------
        GT11_RXCLKCORCNT_OUT            =>      gt11_rxclkcorcnt_i,
        ------------------ Receive Ports - FPGA RX Interface Ports -----------------
        GT11_RXUSRCLK_IN                =>      gt0_txusrclk_i,
        GT11_RXUSRCLK2_IN               =>      gt0_txusrclk_i,
        ------------------ Receive Ports - FPGA RX interface Ports -----------------
        GT11_RXDATA_OUT                 =>      gt11_rxdata_i,
        ------------------- Receive Ports - Pattern Checker Ports ------------------
        GT11_RXPRBSERR_OUT              =>      gt11_rxprbserr_i,
        GT11_RXPRBSSEL_IN               =>      gt11_rxprbssel_i,
        ------------------- Receive Ports - Pattern Checker ports ------------------
        GT11_RXPRBSCNTRESET_IN          =>      gt11_rxprbscntreset_i,
        ------------------ Receive Ports - RX 8B/10B Decoder Ports -----------------
        GT11_RXDISPERR_OUT              =>      gt11_rxdisperr_i,
        GT11_RXNOTINTABLE_OUT           =>      gt11_rxnotintable_i,
        --------------------------- Receive Ports - RX AFE -------------------------
        GT11_GTXRXP_IN                  =>      RXP_IN(11),
        ------------------------ Receive Ports - RX AFE Ports ----------------------
        GT11_GTXRXN_IN                  =>      RXN_IN(11),
        -------------- Receive Ports - RX Byte and Word Alignment Ports ------------
        GT11_RXMCOMMAALIGNEN_IN         =>      gt11_rxmcommaalignen_i,
        GT11_RXPCOMMAALIGNEN_IN         =>      gt11_rxpcommaalignen_i,
        --------------------- Receive Ports - RX Equalizer Ports -------------------
        GT11_RXDFELPMRESET_IN           =>      gt11_rxdfelpmreset_i,
        GT11_RXMONITOROUT_OUT           =>      gt11_rxmonitorout_i,
        GT11_RXMONITORSEL_IN            =>      gt11_rxmonitorsel_i,
        ------------- Receive Ports - RX Initialization and Reset Ports ------------
        GT11_GTRXRESET_IN               =>      gt11_gtrxreset_i,
        GT11_RXPMARESET_IN              =>      gt11_rxpmareset_i,
        ------------------- Receive Ports - RX8B/10B Decoder Ports -----------------
        GT11_RXCHARISCOMMA_OUT          =>      gt11_rxchariscomma_i,
        GT11_RXCHARISK_OUT              =>      gt11_rxcharisk_i,
        -------------- Receive Ports -RX Initialization and Reset Ports ------------
        GT11_RXRESETDONE_OUT            =>      gt11_rxresetdone_i,
        --------------------- TX Initialization and Reset Ports --------------------
        GT11_GTTXRESET_IN               =>      gt11_gttxreset_i,
        GT11_TXUSERRDY_IN               =>      gt11_txuserrdy_i,
        ------------------ Transmit Ports - FPGA TX Interface Ports ----------------
        GT11_TXUSRCLK_IN                =>      gt0_txusrclk_i,
        GT11_TXUSRCLK2_IN               =>      gt0_txusrclk_i,
        --------------- Transmit Ports - TX Configurable Driver Ports --------------
        GT11_TXDIFFCTRL_IN              =>      gt11_txdiffctrl_i,
        ------------------ Transmit Ports - TX Data Path interface -----------------
        GT11_TXDATA_IN                  =>      gt11_txdata_i,
        ---------------- Transmit Ports - TX Driver and OOB signaling --------------
        GT11_GTXTXN_OUT                 =>      TXN_OUT(11),
        GT11_GTXTXP_OUT                 =>      TXP_OUT(11),
        ----------- Transmit Ports - TX Fabric Clock Output Control Ports ----------
        GT11_TXOUTCLK_OUT               =>      gt11_txoutclk_i,
        GT11_TXOUTCLKFABRIC_OUT         =>      gt11_txoutclkfabric_i,
        GT11_TXOUTCLKPCS_OUT            =>      gt11_txoutclkpcs_i,
        --------------------- Transmit Ports - TX Gearbox Ports --------------------
        GT11_TXCHARISK_IN               =>      gt11_txcharisk_i,
        ------------- Transmit Ports - TX Initialization and Reset Ports -----------
        GT11_TXRESETDONE_OUT            =>      gt11_txresetdone_i,
        ------------------ Transmit Ports - pattern Generator Ports ----------------
        GT11_TXPRBSSEL_IN               =>      gt11_txprbssel_i,




    --____________________________COMMON PORTS________________________________
        ---------------------- Common Block  - Ref Clock Ports ---------------------
        GT0_GTREFCLK0_COMMON_IN         =>      q1_clk1_refclk_i,
        ------------------------- Common Block - QPLL Ports ------------------------
        GT0_QPLLLOCK_OUT                =>      gt0_qplllock_i,
        GT0_QPLLLOCKDETCLK_IN           =>      drpclk_in_i,
        GT0_QPLLRESET_IN                =>      gt0_qpllreset_i,


    --____________________________COMMON PORTS________________________________
        ---------------------- Common Block  - Ref Clock Ports ---------------------
        GT1_GTREFCLK0_COMMON_IN         =>      q1_clk1_refclk_i,
        ------------------------- Common Block - QPLL Ports ------------------------
        GT1_QPLLLOCK_OUT                =>      gt1_qplllock_i,
        GT1_QPLLLOCKDETCLK_IN           =>      drpclk_in_i,
        GT1_QPLLRESET_IN                =>      gt1_qpllreset_i,


    --____________________________COMMON PORTS________________________________
        ---------------------- Common Block  - Ref Clock Ports ---------------------
        GT2_GTREFCLK0_COMMON_IN         =>      q1_clk1_refclk_i,
        ------------------------- Common Block - QPLL Ports ------------------------
        GT2_QPLLLOCK_OUT                =>      gt2_qplllock_i,
        GT2_QPLLLOCKDETCLK_IN           =>      drpclk_in_i,
        GT2_QPLLRESET_IN                =>      gt2_qpllreset_i

    );



    -------------------------- User Module Resets -----------------------------
    -- All the User Modules i.e. FRAME_GEN, FRAME_CHECK and the sync modules
    -- are held in reset till the RESETDONE goes high. 
    -- The RESETDONE is registered a couple of times on USRCLK2 and connected 
    -- to the reset of the modules
    
process(gt0_txusrclk_i,gt0_rxresetdone_i)
    begin
        if(gt0_rxresetdone_i = '0') then
            gt0_rxresetdone_r  <= '0'   after DLY;
            gt0_rxresetdone_r2 <= '0'   after DLY;
            gt0_rxresetdone_r3 <= '0'   after DLY;
elsif (gt0_txusrclk_i'event and gt0_txusrclk_i = '1') then
            gt0_rxresetdone_r  <= gt0_rxresetdone_i   after DLY;
            gt0_rxresetdone_r2 <= gt0_rxresetdone_r   after DLY;
            gt0_rxresetdone_r3  <= gt0_rxresetdone_r2   after DLY;
        end if;
    end process;

process(gt0_txusrclk_i,gt0_txfsmresetdone_i)
    begin
        if(gt0_txfsmresetdone_i = '0') then
            gt0_txfsmresetdone_r  <= '0'   after DLY;
            gt0_txfsmresetdone_r2 <= '0'   after DLY;
elsif (gt0_txusrclk_i'event and gt0_txusrclk_i = '1') then
            gt0_txfsmresetdone_r  <= gt0_txfsmresetdone_i   after DLY;
            gt0_txfsmresetdone_r2 <= gt0_txfsmresetdone_r   after DLY;
        end if;
    end process;
process(gt0_txusrclk_i,gt1_rxresetdone_i)
    begin
        if(gt1_rxresetdone_i = '0') then
            gt1_rxresetdone_r  <= '0'   after DLY;
            gt1_rxresetdone_r2 <= '0'   after DLY;
            gt1_rxresetdone_r3 <= '0'   after DLY;
elsif (gt0_txusrclk_i'event and gt0_txusrclk_i = '1') then
            gt1_rxresetdone_r  <= gt1_rxresetdone_i   after DLY;
            gt1_rxresetdone_r2 <= gt1_rxresetdone_r   after DLY;
            gt1_rxresetdone_r3  <= gt1_rxresetdone_r2   after DLY;
        end if;
    end process;

process(gt0_txusrclk_i,gt1_txfsmresetdone_i)
    begin
        if(gt1_txfsmresetdone_i = '0') then
            gt1_txfsmresetdone_r  <= '0'   after DLY;
            gt1_txfsmresetdone_r2 <= '0'   after DLY;
elsif (gt0_txusrclk_i'event and gt0_txusrclk_i = '1') then
            gt1_txfsmresetdone_r  <= gt1_txfsmresetdone_i   after DLY;
            gt1_txfsmresetdone_r2 <= gt1_txfsmresetdone_r   after DLY;
        end if;
    end process;
process(gt0_txusrclk_i,gt2_rxresetdone_i)
    begin
        if(gt2_rxresetdone_i = '0') then
            gt2_rxresetdone_r  <= '0'   after DLY;
            gt2_rxresetdone_r2 <= '0'   after DLY;
            gt2_rxresetdone_r3 <= '0'   after DLY;
elsif (gt0_txusrclk_i'event and gt0_txusrclk_i = '1') then
            gt2_rxresetdone_r  <= gt2_rxresetdone_i   after DLY;
            gt2_rxresetdone_r2 <= gt2_rxresetdone_r   after DLY;
            gt2_rxresetdone_r3  <= gt2_rxresetdone_r2   after DLY;
        end if;
    end process;

process(gt0_txusrclk_i,gt2_txfsmresetdone_i)
    begin
        if(gt2_txfsmresetdone_i = '0') then
            gt2_txfsmresetdone_r  <= '0'   after DLY;
            gt2_txfsmresetdone_r2 <= '0'   after DLY;
elsif (gt0_txusrclk_i'event and gt0_txusrclk_i = '1') then
            gt2_txfsmresetdone_r  <= gt2_txfsmresetdone_i   after DLY;
            gt2_txfsmresetdone_r2 <= gt2_txfsmresetdone_r   after DLY;
        end if;
    end process;
process(gt0_txusrclk_i,gt3_rxresetdone_i)
    begin
        if(gt3_rxresetdone_i = '0') then
            gt3_rxresetdone_r  <= '0'   after DLY;
            gt3_rxresetdone_r2 <= '0'   after DLY;
            gt3_rxresetdone_r3 <= '0'   after DLY;
elsif (gt0_txusrclk_i'event and gt0_txusrclk_i = '1') then
            gt3_rxresetdone_r  <= gt3_rxresetdone_i   after DLY;
            gt3_rxresetdone_r2 <= gt3_rxresetdone_r   after DLY;
            gt3_rxresetdone_r3  <= gt3_rxresetdone_r2   after DLY;
        end if;
    end process;

process(gt0_txusrclk_i,gt3_txfsmresetdone_i)
    begin
        if(gt3_txfsmresetdone_i = '0') then
            gt3_txfsmresetdone_r  <= '0'   after DLY;
            gt3_txfsmresetdone_r2 <= '0'   after DLY;
elsif (gt0_txusrclk_i'event and gt0_txusrclk_i = '1') then
            gt3_txfsmresetdone_r  <= gt3_txfsmresetdone_i   after DLY;
            gt3_txfsmresetdone_r2 <= gt3_txfsmresetdone_r   after DLY;
        end if;
    end process;
process(gt0_txusrclk_i,gt4_rxresetdone_i)
    begin
        if(gt4_rxresetdone_i = '0') then
            gt4_rxresetdone_r  <= '0'   after DLY;
            gt4_rxresetdone_r2 <= '0'   after DLY;
            gt4_rxresetdone_r3 <= '0'   after DLY;
elsif (gt0_txusrclk_i'event and gt0_txusrclk_i = '1') then
            gt4_rxresetdone_r  <= gt4_rxresetdone_i   after DLY;
            gt4_rxresetdone_r2 <= gt4_rxresetdone_r   after DLY;
            gt4_rxresetdone_r3  <= gt4_rxresetdone_r2   after DLY;
        end if;
    end process;

process(gt0_txusrclk_i,gt4_txfsmresetdone_i)
    begin
        if(gt4_txfsmresetdone_i = '0') then
            gt4_txfsmresetdone_r  <= '0'   after DLY;
            gt4_txfsmresetdone_r2 <= '0'   after DLY;
elsif (gt0_txusrclk_i'event and gt0_txusrclk_i = '1') then
            gt4_txfsmresetdone_r  <= gt4_txfsmresetdone_i   after DLY;
            gt4_txfsmresetdone_r2 <= gt4_txfsmresetdone_r   after DLY;
        end if;
    end process;
process(gt0_txusrclk_i,gt5_rxresetdone_i)
    begin
        if(gt5_rxresetdone_i = '0') then
            gt5_rxresetdone_r  <= '0'   after DLY;
            gt5_rxresetdone_r2 <= '0'   after DLY;
            gt5_rxresetdone_r3 <= '0'   after DLY;
elsif (gt0_txusrclk_i'event and gt0_txusrclk_i = '1') then
            gt5_rxresetdone_r  <= gt5_rxresetdone_i   after DLY;
            gt5_rxresetdone_r2 <= gt5_rxresetdone_r   after DLY;
            gt5_rxresetdone_r3  <= gt5_rxresetdone_r2   after DLY;
        end if;
    end process;

process(gt0_txusrclk_i,gt5_txfsmresetdone_i)
    begin
        if(gt5_txfsmresetdone_i = '0') then
            gt5_txfsmresetdone_r  <= '0'   after DLY;
            gt5_txfsmresetdone_r2 <= '0'   after DLY;
elsif (gt0_txusrclk_i'event and gt0_txusrclk_i = '1') then
            gt5_txfsmresetdone_r  <= gt5_txfsmresetdone_i   after DLY;
            gt5_txfsmresetdone_r2 <= gt5_txfsmresetdone_r   after DLY;
        end if;
    end process;
process(gt0_txusrclk_i,gt6_rxresetdone_i)
    begin
        if(gt6_rxresetdone_i = '0') then
            gt6_rxresetdone_r  <= '0'   after DLY;
            gt6_rxresetdone_r2 <= '0'   after DLY;
            gt6_rxresetdone_r3 <= '0'   after DLY;
elsif (gt0_txusrclk_i'event and gt0_txusrclk_i = '1') then
            gt6_rxresetdone_r  <= gt6_rxresetdone_i   after DLY;
            gt6_rxresetdone_r2 <= gt6_rxresetdone_r   after DLY;
            gt6_rxresetdone_r3  <= gt6_rxresetdone_r2   after DLY;
        end if;
    end process;

process(gt0_txusrclk_i,gt6_txfsmresetdone_i)
    begin
        if(gt6_txfsmresetdone_i = '0') then
            gt6_txfsmresetdone_r  <= '0'   after DLY;
            gt6_txfsmresetdone_r2 <= '0'   after DLY;
elsif (gt0_txusrclk_i'event and gt0_txusrclk_i = '1') then
            gt6_txfsmresetdone_r  <= gt6_txfsmresetdone_i   after DLY;
            gt6_txfsmresetdone_r2 <= gt6_txfsmresetdone_r   after DLY;
        end if;
    end process;
process(gt0_txusrclk_i,gt7_rxresetdone_i)
    begin
        if(gt7_rxresetdone_i = '0') then
            gt7_rxresetdone_r  <= '0'   after DLY;
            gt7_rxresetdone_r2 <= '0'   after DLY;
            gt7_rxresetdone_r3 <= '0'   after DLY;
elsif (gt0_txusrclk_i'event and gt0_txusrclk_i = '1') then
            gt7_rxresetdone_r  <= gt7_rxresetdone_i   after DLY;
            gt7_rxresetdone_r2 <= gt7_rxresetdone_r   after DLY;
            gt7_rxresetdone_r3  <= gt7_rxresetdone_r2   after DLY;
        end if;
    end process;

process(gt0_txusrclk_i,gt7_txfsmresetdone_i)
    begin
        if(gt7_txfsmresetdone_i = '0') then
            gt7_txfsmresetdone_r  <= '0'   after DLY;
            gt7_txfsmresetdone_r2 <= '0'   after DLY;
elsif (gt0_txusrclk_i'event and gt0_txusrclk_i = '1') then
            gt7_txfsmresetdone_r  <= gt7_txfsmresetdone_i   after DLY;
            gt7_txfsmresetdone_r2 <= gt7_txfsmresetdone_r   after DLY;
        end if;
    end process;
process(gt0_txusrclk_i,gt8_rxresetdone_i)
    begin
        if(gt8_rxresetdone_i = '0') then
            gt8_rxresetdone_r  <= '0'   after DLY;
            gt8_rxresetdone_r2 <= '0'   after DLY;
            gt8_rxresetdone_r3 <= '0'   after DLY;
elsif (gt0_txusrclk_i'event and gt0_txusrclk_i = '1') then
            gt8_rxresetdone_r  <= gt8_rxresetdone_i   after DLY;
            gt8_rxresetdone_r2 <= gt8_rxresetdone_r   after DLY;
            gt8_rxresetdone_r3  <= gt8_rxresetdone_r2   after DLY;
        end if;
    end process;

process(gt0_txusrclk_i,gt8_txfsmresetdone_i)
    begin
        if(gt8_txfsmresetdone_i = '0') then
            gt8_txfsmresetdone_r  <= '0'   after DLY;
            gt8_txfsmresetdone_r2 <= '0'   after DLY;
elsif (gt0_txusrclk_i'event and gt0_txusrclk_i = '1') then
            gt8_txfsmresetdone_r  <= gt8_txfsmresetdone_i   after DLY;
            gt8_txfsmresetdone_r2 <= gt8_txfsmresetdone_r   after DLY;
        end if;
    end process;
process(gt0_txusrclk_i,gt9_rxresetdone_i)
    begin
        if(gt9_rxresetdone_i = '0') then
            gt9_rxresetdone_r  <= '0'   after DLY;
            gt9_rxresetdone_r2 <= '0'   after DLY;
            gt9_rxresetdone_r3 <= '0'   after DLY;
elsif (gt0_txusrclk_i'event and gt0_txusrclk_i = '1') then
            gt9_rxresetdone_r  <= gt9_rxresetdone_i   after DLY;
            gt9_rxresetdone_r2 <= gt9_rxresetdone_r   after DLY;
            gt9_rxresetdone_r3  <= gt9_rxresetdone_r2   after DLY;
        end if;
    end process;

process(gt0_txusrclk_i,gt9_txfsmresetdone_i)
    begin
        if(gt9_txfsmresetdone_i = '0') then
            gt9_txfsmresetdone_r  <= '0'   after DLY;
            gt9_txfsmresetdone_r2 <= '0'   after DLY;
elsif (gt0_txusrclk_i'event and gt0_txusrclk_i = '1') then
            gt9_txfsmresetdone_r  <= gt9_txfsmresetdone_i   after DLY;
            gt9_txfsmresetdone_r2 <= gt9_txfsmresetdone_r   after DLY;
        end if;
    end process;
process(gt0_txusrclk_i,gt10_rxresetdone_i)
    begin
        if(gt10_rxresetdone_i = '0') then
            gt10_rxresetdone_r  <= '0'   after DLY;
            gt10_rxresetdone_r2 <= '0'   after DLY;
            gt10_rxresetdone_r3 <= '0'   after DLY;
elsif (gt0_txusrclk_i'event and gt0_txusrclk_i = '1') then
            gt10_rxresetdone_r  <= gt10_rxresetdone_i   after DLY;
            gt10_rxresetdone_r2 <= gt10_rxresetdone_r   after DLY;
            gt10_rxresetdone_r3  <= gt10_rxresetdone_r2   after DLY;
        end if;
    end process;

process(gt0_txusrclk_i,gt10_txfsmresetdone_i)
    begin
        if(gt10_txfsmresetdone_i = '0') then
            gt10_txfsmresetdone_r  <= '0'   after DLY;
            gt10_txfsmresetdone_r2 <= '0'   after DLY;
elsif (gt0_txusrclk_i'event and gt0_txusrclk_i = '1') then
            gt10_txfsmresetdone_r  <= gt10_txfsmresetdone_i   after DLY;
            gt10_txfsmresetdone_r2 <= gt10_txfsmresetdone_r   after DLY;
        end if;
    end process;
process(gt0_txusrclk_i,gt11_rxresetdone_i)
    begin
        if(gt11_rxresetdone_i = '0') then
            gt11_rxresetdone_r  <= '0'   after DLY;
            gt11_rxresetdone_r2 <= '0'   after DLY;
            gt11_rxresetdone_r3 <= '0'   after DLY;
elsif (gt0_txusrclk_i'event and gt0_txusrclk_i = '1') then
            gt11_rxresetdone_r  <= gt11_rxresetdone_i   after DLY;
            gt11_rxresetdone_r2 <= gt11_rxresetdone_r   after DLY;
            gt11_rxresetdone_r3  <= gt11_rxresetdone_r2   after DLY;
        end if;
    end process;

process(gt0_txusrclk_i,gt11_txfsmresetdone_i)
    begin
        if(gt11_txfsmresetdone_i = '0') then
            gt11_txfsmresetdone_r  <= '0'   after DLY;
            gt11_txfsmresetdone_r2 <= '0'   after DLY;
elsif (gt0_txusrclk_i'event and gt0_txusrclk_i = '1') then
            gt11_txfsmresetdone_r  <= gt11_txfsmresetdone_i   after DLY;
            gt11_txfsmresetdone_r2 <= gt11_txfsmresetdone_r   after DLY;
        end if;
    end process;

    ------------------------------ Frame Generators ---------------------------
    -- The example design uses Block RAM based frame generators to provide test
    -- data to the GTs for transmission. By default the frame generators are 
    -- loaded with an incrementing data sequence that includes commas/alignment
    -- characters for alignment. If your protocol uses channel bonding, the 
    -- frame generator will also be preloaded with a channel bonding sequence.
    
    -- You can modify the data transmitted by changing the INIT values of the frame
    -- generator in this file. Pay careful attention to bit order and the spacing
    -- of your control and alignment characters.

    gt0_frame_gen : AMC_GTXv_GT_FRAME_GEN
    generic map
    (
        WORDS_IN_BRAM                   =>      EXAMPLE_WORDS_IN_BRAM
    )
    port map
    (
        -- User Interface
        TX_DATA_OUT(79 downto 32)       =>      gt0_txdata_float_i,
        TX_DATA_OUT(15 downto 0)        =>      gt0_txdata_float16_i,
        TX_DATA_OUT(31 downto 16)       =>      gt0_txdata_i,
 
        TXCTRL_OUT(7 downto 2)          =>      gt0_txcharisk_float_i,
        TXCTRL_OUT(1 downto 0)          =>      gt0_txcharisk_i,
        -- System Interface
        USER_CLK                        =>      gt0_txusrclk_i,
        SYSTEM_RESET                    =>      gt0_tx_system_reset_c
    );
    
    gt1_frame_gen : AMC_GTXv_GT_FRAME_GEN
    generic map
    (
        WORDS_IN_BRAM                   =>      EXAMPLE_WORDS_IN_BRAM
    )
    port map
    (
        -- User Interface
        TX_DATA_OUT(79 downto 32)       =>      gt1_txdata_float_i,
        TX_DATA_OUT(15 downto 0)        =>      gt1_txdata_float16_i,
        TX_DATA_OUT(31 downto 16)       =>      gt1_txdata_i,
 
        TXCTRL_OUT(7 downto 2)          =>      gt1_txcharisk_float_i,
        TXCTRL_OUT(1 downto 0)          =>      gt1_txcharisk_i,
        -- System Interface
        USER_CLK                        =>      gt0_txusrclk_i,
        SYSTEM_RESET                    =>      gt1_tx_system_reset_c
    );
    
    gt2_frame_gen : AMC_GTXv_GT_FRAME_GEN
    generic map
    (
        WORDS_IN_BRAM                   =>      EXAMPLE_WORDS_IN_BRAM
    )
    port map
    (
        -- User Interface
        TX_DATA_OUT(79 downto 32)       =>      gt2_txdata_float_i,
        TX_DATA_OUT(15 downto 0)        =>      gt2_txdata_float16_i,
        TX_DATA_OUT(31 downto 16)       =>      gt2_txdata_i,
 
        TXCTRL_OUT(7 downto 2)          =>      gt2_txcharisk_float_i,
        TXCTRL_OUT(1 downto 0)          =>      gt2_txcharisk_i,
        -- System Interface
        USER_CLK                        =>      gt0_txusrclk_i,
        SYSTEM_RESET                    =>      gt2_tx_system_reset_c
    );
    
    gt3_frame_gen : AMC_GTXv_GT_FRAME_GEN
    generic map
    (
        WORDS_IN_BRAM                   =>      EXAMPLE_WORDS_IN_BRAM
    )
    port map
    (
        -- User Interface
        TX_DATA_OUT(79 downto 32)       =>      gt3_txdata_float_i,
        TX_DATA_OUT(15 downto 0)        =>      gt3_txdata_float16_i,
        TX_DATA_OUT(31 downto 16)       =>      gt3_txdata_i,
 
        TXCTRL_OUT(7 downto 2)          =>      gt3_txcharisk_float_i,
        TXCTRL_OUT(1 downto 0)          =>      gt3_txcharisk_i,
        -- System Interface
        USER_CLK                        =>      gt0_txusrclk_i,
        SYSTEM_RESET                    =>      gt3_tx_system_reset_c
    );
    
    gt4_frame_gen : AMC_GTXv_GT_FRAME_GEN
    generic map
    (
        WORDS_IN_BRAM                   =>      EXAMPLE_WORDS_IN_BRAM
    )
    port map
    (
        -- User Interface
        TX_DATA_OUT(79 downto 32)       =>      gt4_txdata_float_i,
        TX_DATA_OUT(15 downto 0)        =>      gt4_txdata_float16_i,
        TX_DATA_OUT(31 downto 16)       =>      gt4_txdata_i,
 
        TXCTRL_OUT(7 downto 2)          =>      gt4_txcharisk_float_i,
        TXCTRL_OUT(1 downto 0)          =>      gt4_txcharisk_i,
        -- System Interface
        USER_CLK                        =>      gt0_txusrclk_i,
        SYSTEM_RESET                    =>      gt4_tx_system_reset_c
    );
    
    gt5_frame_gen : AMC_GTXv_GT_FRAME_GEN
    generic map
    (
        WORDS_IN_BRAM                   =>      EXAMPLE_WORDS_IN_BRAM
    )
    port map
    (
        -- User Interface
        TX_DATA_OUT(79 downto 32)       =>      gt5_txdata_float_i,
        TX_DATA_OUT(15 downto 0)        =>      gt5_txdata_float16_i,
        TX_DATA_OUT(31 downto 16)       =>      gt5_txdata_i,
 
        TXCTRL_OUT(7 downto 2)          =>      gt5_txcharisk_float_i,
        TXCTRL_OUT(1 downto 0)          =>      gt5_txcharisk_i,
        -- System Interface
        USER_CLK                        =>      gt0_txusrclk_i,
        SYSTEM_RESET                    =>      gt5_tx_system_reset_c
    );
    
    gt6_frame_gen : AMC_GTXv_GT_FRAME_GEN
    generic map
    (
        WORDS_IN_BRAM                   =>      EXAMPLE_WORDS_IN_BRAM
    )
    port map
    (
        -- User Interface
        TX_DATA_OUT(79 downto 32)       =>      gt6_txdata_float_i,
        TX_DATA_OUT(15 downto 0)        =>      gt6_txdata_float16_i,
        TX_DATA_OUT(31 downto 16)       =>      gt6_txdata_i,
 
        TXCTRL_OUT(7 downto 2)          =>      gt6_txcharisk_float_i,
        TXCTRL_OUT(1 downto 0)          =>      gt6_txcharisk_i,
        -- System Interface
        USER_CLK                        =>      gt0_txusrclk_i,
        SYSTEM_RESET                    =>      gt6_tx_system_reset_c
    );
    
    gt7_frame_gen : AMC_GTXv_GT_FRAME_GEN
    generic map
    (
        WORDS_IN_BRAM                   =>      EXAMPLE_WORDS_IN_BRAM
    )
    port map
    (
        -- User Interface
        TX_DATA_OUT(79 downto 32)       =>      gt7_txdata_float_i,
        TX_DATA_OUT(15 downto 0)        =>      gt7_txdata_float16_i,
        TX_DATA_OUT(31 downto 16)       =>      gt7_txdata_i,
 
        TXCTRL_OUT(7 downto 2)          =>      gt7_txcharisk_float_i,
        TXCTRL_OUT(1 downto 0)          =>      gt7_txcharisk_i,
        -- System Interface
        USER_CLK                        =>      gt0_txusrclk_i,
        SYSTEM_RESET                    =>      gt7_tx_system_reset_c
    );
    
    gt8_frame_gen : AMC_GTXv_GT_FRAME_GEN
    generic map
    (
        WORDS_IN_BRAM                   =>      EXAMPLE_WORDS_IN_BRAM
    )
    port map
    (
        -- User Interface
        TX_DATA_OUT(79 downto 32)       =>      gt8_txdata_float_i,
        TX_DATA_OUT(15 downto 0)        =>      gt8_txdata_float16_i,
        TX_DATA_OUT(31 downto 16)       =>      gt8_txdata_i,
 
        TXCTRL_OUT(7 downto 2)          =>      gt8_txcharisk_float_i,
        TXCTRL_OUT(1 downto 0)          =>      gt8_txcharisk_i,
        -- System Interface
        USER_CLK                        =>      gt0_txusrclk_i,
        SYSTEM_RESET                    =>      gt8_tx_system_reset_c
    );
    
    gt9_frame_gen : AMC_GTXv_GT_FRAME_GEN
    generic map
    (
        WORDS_IN_BRAM                   =>      EXAMPLE_WORDS_IN_BRAM
    )
    port map
    (
        -- User Interface
        TX_DATA_OUT(79 downto 32)       =>      gt9_txdata_float_i,
        TX_DATA_OUT(15 downto 0)        =>      gt9_txdata_float16_i,
        TX_DATA_OUT(31 downto 16)       =>      gt9_txdata_i,
 
        TXCTRL_OUT(7 downto 2)          =>      gt9_txcharisk_float_i,
        TXCTRL_OUT(1 downto 0)          =>      gt9_txcharisk_i,
        -- System Interface
        USER_CLK                        =>      gt0_txusrclk_i,
        SYSTEM_RESET                    =>      gt9_tx_system_reset_c
    );
    
    gt10_frame_gen : AMC_GTXv_GT_FRAME_GEN
    generic map
    (
        WORDS_IN_BRAM                   =>      EXAMPLE_WORDS_IN_BRAM
    )
    port map
    (
        -- User Interface
        TX_DATA_OUT(79 downto 32)       =>      gt10_txdata_float_i,
        TX_DATA_OUT(15 downto 0)        =>      gt10_txdata_float16_i,
        TX_DATA_OUT(31 downto 16)       =>      gt10_txdata_i,
 
        TXCTRL_OUT(7 downto 2)          =>      gt10_txcharisk_float_i,
        TXCTRL_OUT(1 downto 0)          =>      gt10_txcharisk_i,
        -- System Interface
        USER_CLK                        =>      gt0_txusrclk_i,
        SYSTEM_RESET                    =>      gt10_tx_system_reset_c
    );
    
    gt11_frame_gen : AMC_GTXv_GT_FRAME_GEN
    generic map
    (
        WORDS_IN_BRAM                   =>      EXAMPLE_WORDS_IN_BRAM
    )
    port map
    (
        -- User Interface
        TX_DATA_OUT(79 downto 32)       =>      gt11_txdata_float_i,
        TX_DATA_OUT(15 downto 0)        =>      gt11_txdata_float16_i,
        TX_DATA_OUT(31 downto 16)       =>      gt11_txdata_i,
 
        TXCTRL_OUT(7 downto 2)          =>      gt11_txcharisk_float_i,
        TXCTRL_OUT(1 downto 0)          =>      gt11_txcharisk_i,
        -- System Interface
        USER_CLK                        =>      gt0_txusrclk_i,
        SYSTEM_RESET                    =>      gt11_tx_system_reset_c
    );
    


    ---------------------------------- Frame Checkers -------------------------
    -- The example design uses Block RAM based frame checkers to verify incoming  
    -- data. By default the frame generators are loaded with a data sequence that 
    -- matches the outgoing sequence of the frame generators for the TX ports.
    
    -- You can modify the expected data sequence by changing the INIT values of the frame
    -- checkers in this file. Pay careful attention to bit order and the spacing
    -- of your control and alignment characters.
    
    -- When the frame checker receives data, it attempts to synchronise to the 
    -- incoming pattern by looking for the first sequence in the pattern. Once it 
    -- finds the first sequence, it increments through the sequence, and indicates an 
    -- error whenever the next value received does not match the expected value.

gt0_frame_check_reset_i                      <= reset_on_data_error_i when (EXAMPLE_CONFIG_INDEPENDENT_LANES=0) else gt0_matchn_i;

    -- gt0_frame_check0 is always connected to the lane with the start of char 
    -- and this lane starts off the data checking on all the other lanes. The INC_IN port is tied off
gt0_inc_in_i                                 <= '0';

    gt0_frame_check : AMC_GTXv_GT_FRAME_CHECK
    generic map
    (
        RX_DATA_WIDTH                   =>      16,
        RXCTRL_WIDTH                    =>      2,
        COMMA_DOUBLE                    =>      x"02bc",
        WORDS_IN_BRAM                   =>      EXAMPLE_WORDS_IN_BRAM,
        START_OF_PACKET_CHAR            =>      x"02bc"
    )
    port map
    (
        -- GT Interface
        RX_DATA_IN                      =>      gt0_rxdata_i,
        RXCTRL_IN                       =>      gt0_rxcharisk_i,
        RXENMCOMMADET_OUT               =>      gt0_rxmcommaalignen_i,
        RXENPCOMMADET_OUT               =>      gt0_rxpcommaalignen_i,
        RX_ENCHAN_SYNC_OUT              =>      open,
        RX_CHANBOND_SEQ_IN              =>      tied_to_ground_i,
        -- Control Interface
        INC_IN                          =>      gt0_inc_in_i,
        INC_OUT                         =>      gt0_inc_out_i,
        PATTERN_MATCHB_OUT              =>      gt0_matchn_i,
        RESET_ON_ERROR_IN               =>      gt0_frame_check_reset_i,
        -- System Interface
        USER_CLK                        =>      gt0_txusrclk_i,
        SYSTEM_RESET                    =>      gt0_rx_system_reset_c,
        ERROR_COUNT_OUT                 =>      gt0_error_count_i,
        TRACK_DATA_OUT                  =>      gt0_track_data_i
    );

gt1_frame_check_reset_i                      <= reset_on_data_error_i when (EXAMPLE_CONFIG_INDEPENDENT_LANES=0) else gt1_matchn_i;

    -- in the "independent lanes" configuration, each of the lanes looks for the unique start char and
    -- in this case, the INC_IN port is tied off.
    -- Else, the data checking is triggered by the "master" lane
gt1_inc_in_i                                 <= gt0_inc_out_i when  (EXAMPLE_CONFIG_INDEPENDENT_LANES=0) else '0';

    gt1_frame_check : AMC_GTXv_GT_FRAME_CHECK
    generic map
    (
        RX_DATA_WIDTH                   =>      16,
        RXCTRL_WIDTH                    =>      2,
        COMMA_DOUBLE                    =>      x"02bc",
        WORDS_IN_BRAM                   =>      EXAMPLE_WORDS_IN_BRAM,
        START_OF_PACKET_CHAR            =>      x"02bc"
    )
    port map
    (
        -- GT Interface
        RX_DATA_IN                      =>      gt1_rxdata_i,
        RXCTRL_IN                       =>      gt1_rxcharisk_i,
        RXENMCOMMADET_OUT               =>      gt1_rxmcommaalignen_i,
        RXENPCOMMADET_OUT               =>      gt1_rxpcommaalignen_i,
        RX_ENCHAN_SYNC_OUT              =>      open,
        RX_CHANBOND_SEQ_IN              =>      tied_to_ground_i,
        -- Control Interface
        INC_IN                          =>      gt1_inc_in_i,
        INC_OUT                         =>      gt1_inc_out_i,
        PATTERN_MATCHB_OUT              =>      gt1_matchn_i,
        RESET_ON_ERROR_IN               =>      gt1_frame_check_reset_i,
        -- System Interface
        USER_CLK                        =>      gt0_txusrclk_i,
        SYSTEM_RESET                    =>      gt1_rx_system_reset_c,
        ERROR_COUNT_OUT                 =>      gt1_error_count_i,
        TRACK_DATA_OUT                  =>      gt1_track_data_i
    );

gt2_frame_check_reset_i                      <= reset_on_data_error_i when (EXAMPLE_CONFIG_INDEPENDENT_LANES=0) else gt2_matchn_i;

    -- in the "independent lanes" configuration, each of the lanes looks for the unique start char and
    -- in this case, the INC_IN port is tied off.
    -- Else, the data checking is triggered by the "master" lane
gt2_inc_in_i                                 <= gt0_inc_out_i when  (EXAMPLE_CONFIG_INDEPENDENT_LANES=0) else '0';

    gt2_frame_check : AMC_GTXv_GT_FRAME_CHECK
    generic map
    (
        RX_DATA_WIDTH                   =>      16,
        RXCTRL_WIDTH                    =>      2,
        COMMA_DOUBLE                    =>      x"02bc",
        WORDS_IN_BRAM                   =>      EXAMPLE_WORDS_IN_BRAM,
        START_OF_PACKET_CHAR            =>      x"02bc"
    )
    port map
    (
        -- GT Interface
        RX_DATA_IN                      =>      gt2_rxdata_i,
        RXCTRL_IN                       =>      gt2_rxcharisk_i,
        RXENMCOMMADET_OUT               =>      gt2_rxmcommaalignen_i,
        RXENPCOMMADET_OUT               =>      gt2_rxpcommaalignen_i,
        RX_ENCHAN_SYNC_OUT              =>      open,
        RX_CHANBOND_SEQ_IN              =>      tied_to_ground_i,
        -- Control Interface
        INC_IN                          =>      gt2_inc_in_i,
        INC_OUT                         =>      gt2_inc_out_i,
        PATTERN_MATCHB_OUT              =>      gt2_matchn_i,
        RESET_ON_ERROR_IN               =>      gt2_frame_check_reset_i,
        -- System Interface
        USER_CLK                        =>      gt0_txusrclk_i,
        SYSTEM_RESET                    =>      gt2_rx_system_reset_c,
        ERROR_COUNT_OUT                 =>      gt2_error_count_i,
        TRACK_DATA_OUT                  =>      gt2_track_data_i
    );

gt3_frame_check_reset_i                      <= reset_on_data_error_i when (EXAMPLE_CONFIG_INDEPENDENT_LANES=0) else gt3_matchn_i;

    -- in the "independent lanes" configuration, each of the lanes looks for the unique start char and
    -- in this case, the INC_IN port is tied off.
    -- Else, the data checking is triggered by the "master" lane
gt3_inc_in_i                                 <= gt0_inc_out_i when  (EXAMPLE_CONFIG_INDEPENDENT_LANES=0) else '0';

    gt3_frame_check : AMC_GTXv_GT_FRAME_CHECK
    generic map
    (
        RX_DATA_WIDTH                   =>      16,
        RXCTRL_WIDTH                    =>      2,
        COMMA_DOUBLE                    =>      x"02bc",
        WORDS_IN_BRAM                   =>      EXAMPLE_WORDS_IN_BRAM,
        START_OF_PACKET_CHAR            =>      x"02bc"
    )
    port map
    (
        -- GT Interface
        RX_DATA_IN                      =>      gt3_rxdata_i,
        RXCTRL_IN                       =>      gt3_rxcharisk_i,
        RXENMCOMMADET_OUT               =>      gt3_rxmcommaalignen_i,
        RXENPCOMMADET_OUT               =>      gt3_rxpcommaalignen_i,
        RX_ENCHAN_SYNC_OUT              =>      open,
        RX_CHANBOND_SEQ_IN              =>      tied_to_ground_i,
        -- Control Interface
        INC_IN                          =>      gt3_inc_in_i,
        INC_OUT                         =>      gt3_inc_out_i,
        PATTERN_MATCHB_OUT              =>      gt3_matchn_i,
        RESET_ON_ERROR_IN               =>      gt3_frame_check_reset_i,
        -- System Interface
        USER_CLK                        =>      gt0_txusrclk_i,
        SYSTEM_RESET                    =>      gt3_rx_system_reset_c,
        ERROR_COUNT_OUT                 =>      gt3_error_count_i,
        TRACK_DATA_OUT                  =>      gt3_track_data_i
    );

gt4_frame_check_reset_i                      <= reset_on_data_error_i when (EXAMPLE_CONFIG_INDEPENDENT_LANES=0) else gt4_matchn_i;

    -- in the "independent lanes" configuration, each of the lanes looks for the unique start char and
    -- in this case, the INC_IN port is tied off.
    -- Else, the data checking is triggered by the "master" lane
gt4_inc_in_i                                 <= gt0_inc_out_i when  (EXAMPLE_CONFIG_INDEPENDENT_LANES=0) else '0';

    gt4_frame_check : AMC_GTXv_GT_FRAME_CHECK
    generic map
    (
        RX_DATA_WIDTH                   =>      16,
        RXCTRL_WIDTH                    =>      2,
        COMMA_DOUBLE                    =>      x"02bc",
        WORDS_IN_BRAM                   =>      EXAMPLE_WORDS_IN_BRAM,
        START_OF_PACKET_CHAR            =>      x"02bc"
    )
    port map
    (
        -- GT Interface
        RX_DATA_IN                      =>      gt4_rxdata_i,
        RXCTRL_IN                       =>      gt4_rxcharisk_i,
        RXENMCOMMADET_OUT               =>      gt4_rxmcommaalignen_i,
        RXENPCOMMADET_OUT               =>      gt4_rxpcommaalignen_i,
        RX_ENCHAN_SYNC_OUT              =>      open,
        RX_CHANBOND_SEQ_IN              =>      tied_to_ground_i,
        -- Control Interface
        INC_IN                          =>      gt4_inc_in_i,
        INC_OUT                         =>      gt4_inc_out_i,
        PATTERN_MATCHB_OUT              =>      gt4_matchn_i,
        RESET_ON_ERROR_IN               =>      gt4_frame_check_reset_i,
        -- System Interface
        USER_CLK                        =>      gt0_txusrclk_i,
        SYSTEM_RESET                    =>      gt4_rx_system_reset_c,
        ERROR_COUNT_OUT                 =>      gt4_error_count_i,
        TRACK_DATA_OUT                  =>      gt4_track_data_i
    );

gt5_frame_check_reset_i                      <= reset_on_data_error_i when (EXAMPLE_CONFIG_INDEPENDENT_LANES=0) else gt5_matchn_i;

    -- in the "independent lanes" configuration, each of the lanes looks for the unique start char and
    -- in this case, the INC_IN port is tied off.
    -- Else, the data checking is triggered by the "master" lane
gt5_inc_in_i                                 <= gt0_inc_out_i when  (EXAMPLE_CONFIG_INDEPENDENT_LANES=0) else '0';

    gt5_frame_check : AMC_GTXv_GT_FRAME_CHECK
    generic map
    (
        RX_DATA_WIDTH                   =>      16,
        RXCTRL_WIDTH                    =>      2,
        COMMA_DOUBLE                    =>      x"02bc",
        WORDS_IN_BRAM                   =>      EXAMPLE_WORDS_IN_BRAM,
        START_OF_PACKET_CHAR            =>      x"02bc"
    )
    port map
    (
        -- GT Interface
        RX_DATA_IN                      =>      gt5_rxdata_i,
        RXCTRL_IN                       =>      gt5_rxcharisk_i,
        RXENMCOMMADET_OUT               =>      gt5_rxmcommaalignen_i,
        RXENPCOMMADET_OUT               =>      gt5_rxpcommaalignen_i,
        RX_ENCHAN_SYNC_OUT              =>      open,
        RX_CHANBOND_SEQ_IN              =>      tied_to_ground_i,
        -- Control Interface
        INC_IN                          =>      gt5_inc_in_i,
        INC_OUT                         =>      gt5_inc_out_i,
        PATTERN_MATCHB_OUT              =>      gt5_matchn_i,
        RESET_ON_ERROR_IN               =>      gt5_frame_check_reset_i,
        -- System Interface
        USER_CLK                        =>      gt0_txusrclk_i,
        SYSTEM_RESET                    =>      gt5_rx_system_reset_c,
        ERROR_COUNT_OUT                 =>      gt5_error_count_i,
        TRACK_DATA_OUT                  =>      gt5_track_data_i
    );

gt6_frame_check_reset_i                      <= reset_on_data_error_i when (EXAMPLE_CONFIG_INDEPENDENT_LANES=0) else gt6_matchn_i;

    -- in the "independent lanes" configuration, each of the lanes looks for the unique start char and
    -- in this case, the INC_IN port is tied off.
    -- Else, the data checking is triggered by the "master" lane
gt6_inc_in_i                                 <= gt0_inc_out_i when  (EXAMPLE_CONFIG_INDEPENDENT_LANES=0) else '0';

    gt6_frame_check : AMC_GTXv_GT_FRAME_CHECK
    generic map
    (
        RX_DATA_WIDTH                   =>      16,
        RXCTRL_WIDTH                    =>      2,
        COMMA_DOUBLE                    =>      x"02bc",
        WORDS_IN_BRAM                   =>      EXAMPLE_WORDS_IN_BRAM,
        START_OF_PACKET_CHAR            =>      x"02bc"
    )
    port map
    (
        -- GT Interface
        RX_DATA_IN                      =>      gt6_rxdata_i,
        RXCTRL_IN                       =>      gt6_rxcharisk_i,
        RXENMCOMMADET_OUT               =>      gt6_rxmcommaalignen_i,
        RXENPCOMMADET_OUT               =>      gt6_rxpcommaalignen_i,
        RX_ENCHAN_SYNC_OUT              =>      open,
        RX_CHANBOND_SEQ_IN              =>      tied_to_ground_i,
        -- Control Interface
        INC_IN                          =>      gt6_inc_in_i,
        INC_OUT                         =>      gt6_inc_out_i,
        PATTERN_MATCHB_OUT              =>      gt6_matchn_i,
        RESET_ON_ERROR_IN               =>      gt6_frame_check_reset_i,
        -- System Interface
        USER_CLK                        =>      gt0_txusrclk_i,
        SYSTEM_RESET                    =>      gt6_rx_system_reset_c,
        ERROR_COUNT_OUT                 =>      gt6_error_count_i,
        TRACK_DATA_OUT                  =>      gt6_track_data_i
    );

gt7_frame_check_reset_i                      <= reset_on_data_error_i when (EXAMPLE_CONFIG_INDEPENDENT_LANES=0) else gt7_matchn_i;

    -- in the "independent lanes" configuration, each of the lanes looks for the unique start char and
    -- in this case, the INC_IN port is tied off.
    -- Else, the data checking is triggered by the "master" lane
gt7_inc_in_i                                 <= gt0_inc_out_i when  (EXAMPLE_CONFIG_INDEPENDENT_LANES=0) else '0';

    gt7_frame_check : AMC_GTXv_GT_FRAME_CHECK
    generic map
    (
        RX_DATA_WIDTH                   =>      16,
        RXCTRL_WIDTH                    =>      2,
        COMMA_DOUBLE                    =>      x"02bc",
        WORDS_IN_BRAM                   =>      EXAMPLE_WORDS_IN_BRAM,
        START_OF_PACKET_CHAR            =>      x"02bc"
    )
    port map
    (
        -- GT Interface
        RX_DATA_IN                      =>      gt7_rxdata_i,
        RXCTRL_IN                       =>      gt7_rxcharisk_i,
        RXENMCOMMADET_OUT               =>      gt7_rxmcommaalignen_i,
        RXENPCOMMADET_OUT               =>      gt7_rxpcommaalignen_i,
        RX_ENCHAN_SYNC_OUT              =>      open,
        RX_CHANBOND_SEQ_IN              =>      tied_to_ground_i,
        -- Control Interface
        INC_IN                          =>      gt7_inc_in_i,
        INC_OUT                         =>      gt7_inc_out_i,
        PATTERN_MATCHB_OUT              =>      gt7_matchn_i,
        RESET_ON_ERROR_IN               =>      gt7_frame_check_reset_i,
        -- System Interface
        USER_CLK                        =>      gt0_txusrclk_i,
        SYSTEM_RESET                    =>      gt7_rx_system_reset_c,
        ERROR_COUNT_OUT                 =>      gt7_error_count_i,
        TRACK_DATA_OUT                  =>      gt7_track_data_i
    );

gt8_frame_check_reset_i                      <= reset_on_data_error_i when (EXAMPLE_CONFIG_INDEPENDENT_LANES=0) else gt8_matchn_i;

    -- in the "independent lanes" configuration, each of the lanes looks for the unique start char and
    -- in this case, the INC_IN port is tied off.
    -- Else, the data checking is triggered by the "master" lane
gt8_inc_in_i                                 <= gt0_inc_out_i when  (EXAMPLE_CONFIG_INDEPENDENT_LANES=0) else '0';

    gt8_frame_check : AMC_GTXv_GT_FRAME_CHECK
    generic map
    (
        RX_DATA_WIDTH                   =>      16,
        RXCTRL_WIDTH                    =>      2,
        COMMA_DOUBLE                    =>      x"02bc",
        WORDS_IN_BRAM                   =>      EXAMPLE_WORDS_IN_BRAM,
        START_OF_PACKET_CHAR            =>      x"02bc"
    )
    port map
    (
        -- GT Interface
        RX_DATA_IN                      =>      gt8_rxdata_i,
        RXCTRL_IN                       =>      gt8_rxcharisk_i,
        RXENMCOMMADET_OUT               =>      gt8_rxmcommaalignen_i,
        RXENPCOMMADET_OUT               =>      gt8_rxpcommaalignen_i,
        RX_ENCHAN_SYNC_OUT              =>      open,
        RX_CHANBOND_SEQ_IN              =>      tied_to_ground_i,
        -- Control Interface
        INC_IN                          =>      gt8_inc_in_i,
        INC_OUT                         =>      gt8_inc_out_i,
        PATTERN_MATCHB_OUT              =>      gt8_matchn_i,
        RESET_ON_ERROR_IN               =>      gt8_frame_check_reset_i,
        -- System Interface
        USER_CLK                        =>      gt0_txusrclk_i,
        SYSTEM_RESET                    =>      gt8_rx_system_reset_c,
        ERROR_COUNT_OUT                 =>      gt8_error_count_i,
        TRACK_DATA_OUT                  =>      gt8_track_data_i
    );

gt9_frame_check_reset_i                      <= reset_on_data_error_i when (EXAMPLE_CONFIG_INDEPENDENT_LANES=0) else gt9_matchn_i;

    -- in the "independent lanes" configuration, each of the lanes looks for the unique start char and
    -- in this case, the INC_IN port is tied off.
    -- Else, the data checking is triggered by the "master" lane
gt9_inc_in_i                                 <= gt0_inc_out_i when  (EXAMPLE_CONFIG_INDEPENDENT_LANES=0) else '0';

    gt9_frame_check : AMC_GTXv_GT_FRAME_CHECK
    generic map
    (
        RX_DATA_WIDTH                   =>      16,
        RXCTRL_WIDTH                    =>      2,
        COMMA_DOUBLE                    =>      x"02bc",
        WORDS_IN_BRAM                   =>      EXAMPLE_WORDS_IN_BRAM,
        START_OF_PACKET_CHAR            =>      x"02bc"
    )
    port map
    (
        -- GT Interface
        RX_DATA_IN                      =>      gt9_rxdata_i,
        RXCTRL_IN                       =>      gt9_rxcharisk_i,
        RXENMCOMMADET_OUT               =>      gt9_rxmcommaalignen_i,
        RXENPCOMMADET_OUT               =>      gt9_rxpcommaalignen_i,
        RX_ENCHAN_SYNC_OUT              =>      open,
        RX_CHANBOND_SEQ_IN              =>      tied_to_ground_i,
        -- Control Interface
        INC_IN                          =>      gt9_inc_in_i,
        INC_OUT                         =>      gt9_inc_out_i,
        PATTERN_MATCHB_OUT              =>      gt9_matchn_i,
        RESET_ON_ERROR_IN               =>      gt9_frame_check_reset_i,
        -- System Interface
        USER_CLK                        =>      gt0_txusrclk_i,
        SYSTEM_RESET                    =>      gt9_rx_system_reset_c,
        ERROR_COUNT_OUT                 =>      gt9_error_count_i,
        TRACK_DATA_OUT                  =>      gt9_track_data_i
    );

gt10_frame_check_reset_i                     <= reset_on_data_error_i when (EXAMPLE_CONFIG_INDEPENDENT_LANES=0) else gt10_matchn_i;

    -- in the "independent lanes" configuration, each of the lanes looks for the unique start char and
    -- in this case, the INC_IN port is tied off.
    -- Else, the data checking is triggered by the "master" lane
gt10_inc_in_i                                <= gt0_inc_out_i when  (EXAMPLE_CONFIG_INDEPENDENT_LANES=0) else '0';

    gt10_frame_check : AMC_GTXv_GT_FRAME_CHECK
    generic map
    (
        RX_DATA_WIDTH                   =>      16,
        RXCTRL_WIDTH                    =>      2,
        COMMA_DOUBLE                    =>      x"02bc",
        WORDS_IN_BRAM                   =>      EXAMPLE_WORDS_IN_BRAM,
        START_OF_PACKET_CHAR            =>      x"02bc"
    )
    port map
    (
        -- GT Interface
        RX_DATA_IN                      =>      gt10_rxdata_i,
        RXCTRL_IN                       =>      gt10_rxcharisk_i,
        RXENMCOMMADET_OUT               =>      gt10_rxmcommaalignen_i,
        RXENPCOMMADET_OUT               =>      gt10_rxpcommaalignen_i,
        RX_ENCHAN_SYNC_OUT              =>      open,
        RX_CHANBOND_SEQ_IN              =>      tied_to_ground_i,
        -- Control Interface
        INC_IN                          =>      gt10_inc_in_i,
        INC_OUT                         =>      gt10_inc_out_i,
        PATTERN_MATCHB_OUT              =>      gt10_matchn_i,
        RESET_ON_ERROR_IN               =>      gt10_frame_check_reset_i,
        -- System Interface
        USER_CLK                        =>      gt0_txusrclk_i,
        SYSTEM_RESET                    =>      gt10_rx_system_reset_c,
        ERROR_COUNT_OUT                 =>      gt10_error_count_i,
        TRACK_DATA_OUT                  =>      gt10_track_data_i
    );

gt11_frame_check_reset_i                     <= reset_on_data_error_i when (EXAMPLE_CONFIG_INDEPENDENT_LANES=0) else gt11_matchn_i;

    -- in the "independent lanes" configuration, each of the lanes looks for the unique start char and
    -- in this case, the INC_IN port is tied off.
    -- Else, the data checking is triggered by the "master" lane
gt11_inc_in_i                                <= gt0_inc_out_i when  (EXAMPLE_CONFIG_INDEPENDENT_LANES=0) else '0';

    gt11_frame_check : AMC_GTXv_GT_FRAME_CHECK
    generic map
    (
        RX_DATA_WIDTH                   =>      16,
        RXCTRL_WIDTH                    =>      2,
        COMMA_DOUBLE                    =>      x"02bc",
        WORDS_IN_BRAM                   =>      EXAMPLE_WORDS_IN_BRAM,
        START_OF_PACKET_CHAR            =>      x"02bc"
    )
    port map
    (
        -- GT Interface
        RX_DATA_IN                      =>      gt11_rxdata_i,
        RXCTRL_IN                       =>      gt11_rxcharisk_i,
        RXENMCOMMADET_OUT               =>      gt11_rxmcommaalignen_i,
        RXENPCOMMADET_OUT               =>      gt11_rxpcommaalignen_i,
        RX_ENCHAN_SYNC_OUT              =>      open,
        RX_CHANBOND_SEQ_IN              =>      tied_to_ground_i,
        -- Control Interface
        INC_IN                          =>      gt11_inc_in_i,
        INC_OUT                         =>      gt11_inc_out_i,
        PATTERN_MATCHB_OUT              =>      gt11_matchn_i,
        RESET_ON_ERROR_IN               =>      gt11_frame_check_reset_i,
        -- System Interface
        USER_CLK                        =>      gt0_txusrclk_i,
        SYSTEM_RESET                    =>      gt11_rx_system_reset_c,
        ERROR_COUNT_OUT                 =>      gt11_error_count_i,
        TRACK_DATA_OUT                  =>      gt11_track_data_i
    );




TRACK_DATA_OUT                               <= track_data_out_i;

track_data_out_i                             <= 
                                gt0_track_data_i  and
                                gt1_track_data_i  and
                                gt2_track_data_i  and
                                gt3_track_data_i  and
                                gt4_track_data_i  and
                                gt5_track_data_i  and
                                gt6_track_data_i  and
                                gt7_track_data_i  and
                                gt8_track_data_i  and
                                gt9_track_data_i  and
                                gt10_track_data_i  and
                                gt11_track_data_i ;






























-------------------------------------------------------------------------------
----------------------------- Debug Signals assignment -----------------------

------------ optional Ports assignments --------------
gt0_rxprbscntreset_i                         <= tied_to_ground_i;
gt0_rxprbssel_i                              <= (others => '0');
gt0_loopback_i                               <= (others => '0');
 
gt0_txdiffctrl_i                             <= (others => '0');
 ------GTH/GTP
gt0_rxdfelpmreset_i                          <= tied_to_ground_i;
gt0_rxpmareset_i                             <= tied_to_ground_i;
gt0_txprbssel_i                              <= (others => '0');
gt1_rxprbscntreset_i                         <= tied_to_ground_i;
gt1_rxprbssel_i                              <= (others => '0');
gt1_loopback_i                               <= (others => '0');
 
gt1_txdiffctrl_i                             <= (others => '0');
 ------GTH/GTP
gt1_rxdfelpmreset_i                          <= tied_to_ground_i;
gt1_rxpmareset_i                             <= tied_to_ground_i;
gt1_txprbssel_i                              <= (others => '0');
gt2_rxprbscntreset_i                         <= tied_to_ground_i;
gt2_rxprbssel_i                              <= (others => '0');
gt2_loopback_i                               <= (others => '0');
 
gt2_txdiffctrl_i                             <= (others => '0');
 ------GTH/GTP
gt2_rxdfelpmreset_i                          <= tied_to_ground_i;
gt2_rxpmareset_i                             <= tied_to_ground_i;
gt2_txprbssel_i                              <= (others => '0');
gt3_rxprbscntreset_i                         <= tied_to_ground_i;
gt3_rxprbssel_i                              <= (others => '0');
gt3_loopback_i                               <= (others => '0');
 
gt3_txdiffctrl_i                             <= (others => '0');
 ------GTH/GTP
gt3_rxdfelpmreset_i                          <= tied_to_ground_i;
gt3_rxpmareset_i                             <= tied_to_ground_i;
gt3_txprbssel_i                              <= (others => '0');
gt4_rxprbscntreset_i                         <= tied_to_ground_i;
gt4_rxprbssel_i                              <= (others => '0');
gt4_loopback_i                               <= (others => '0');
 
gt4_txdiffctrl_i                             <= (others => '0');
 ------GTH/GTP
gt4_rxdfelpmreset_i                          <= tied_to_ground_i;
gt4_rxpmareset_i                             <= tied_to_ground_i;
gt4_txprbssel_i                              <= (others => '0');
gt5_rxprbscntreset_i                         <= tied_to_ground_i;
gt5_rxprbssel_i                              <= (others => '0');
gt5_loopback_i                               <= (others => '0');
 
gt5_txdiffctrl_i                             <= (others => '0');
 ------GTH/GTP
gt5_rxdfelpmreset_i                          <= tied_to_ground_i;
gt5_rxpmareset_i                             <= tied_to_ground_i;
gt5_txprbssel_i                              <= (others => '0');
gt6_rxprbscntreset_i                         <= tied_to_ground_i;
gt6_rxprbssel_i                              <= (others => '0');
gt6_loopback_i                               <= (others => '0');
 
gt6_txdiffctrl_i                             <= (others => '0');
 ------GTH/GTP
gt6_rxdfelpmreset_i                          <= tied_to_ground_i;
gt6_rxpmareset_i                             <= tied_to_ground_i;
gt6_txprbssel_i                              <= (others => '0');
gt7_rxprbscntreset_i                         <= tied_to_ground_i;
gt7_rxprbssel_i                              <= (others => '0');
gt7_loopback_i                               <= (others => '0');
 
gt7_txdiffctrl_i                             <= (others => '0');
 ------GTH/GTP
gt7_rxdfelpmreset_i                          <= tied_to_ground_i;
gt7_rxpmareset_i                             <= tied_to_ground_i;
gt7_txprbssel_i                              <= (others => '0');
gt8_rxprbscntreset_i                         <= tied_to_ground_i;
gt8_rxprbssel_i                              <= (others => '0');
gt8_loopback_i                               <= (others => '0');
 
gt8_txdiffctrl_i                             <= (others => '0');
 ------GTH/GTP
gt8_rxdfelpmreset_i                          <= tied_to_ground_i;
gt8_rxpmareset_i                             <= tied_to_ground_i;
gt8_txprbssel_i                              <= (others => '0');
gt9_rxprbscntreset_i                         <= tied_to_ground_i;
gt9_rxprbssel_i                              <= (others => '0');
gt9_loopback_i                               <= (others => '0');
 
gt9_txdiffctrl_i                             <= (others => '0');
 ------GTH/GTP
gt9_rxdfelpmreset_i                          <= tied_to_ground_i;
gt9_rxpmareset_i                             <= tied_to_ground_i;
gt9_txprbssel_i                              <= (others => '0');
gt10_rxprbscntreset_i                        <= tied_to_ground_i;
gt10_rxprbssel_i                             <= (others => '0');
gt10_loopback_i                              <= (others => '0');
 
gt10_txdiffctrl_i                            <= (others => '0');
 ------GTH/GTP
gt10_rxdfelpmreset_i                         <= tied_to_ground_i;
gt10_rxpmareset_i                            <= tied_to_ground_i;
gt10_txprbssel_i                             <= (others => '0');
gt11_rxprbscntreset_i                        <= tied_to_ground_i;
gt11_rxprbssel_i                             <= (others => '0');
gt11_loopback_i                              <= (others => '0');
 
gt11_txdiffctrl_i                            <= (others => '0');
 ------GTH/GTP
gt11_rxdfelpmreset_i                         <= tied_to_ground_i;
gt11_rxpmareset_i                            <= tied_to_ground_i;
gt11_txprbssel_i                             <= (others => '0');
------------------------------------------------------

    -- assign resets for frame_gen modules
gt0_tx_system_reset_c                        <= not gt0_txfsmresetdone_r2;
gt1_tx_system_reset_c                        <= not gt1_txfsmresetdone_r2;
gt2_tx_system_reset_c                        <= not gt2_txfsmresetdone_r2;
gt3_tx_system_reset_c                        <= not gt3_txfsmresetdone_r2;
gt4_tx_system_reset_c                        <= not gt4_txfsmresetdone_r2;
gt5_tx_system_reset_c                        <= not gt5_txfsmresetdone_r2;
gt6_tx_system_reset_c                        <= not gt6_txfsmresetdone_r2;
gt7_tx_system_reset_c                        <= not gt7_txfsmresetdone_r2;
gt8_tx_system_reset_c                        <= not gt8_txfsmresetdone_r2;
gt9_tx_system_reset_c                        <= not gt9_txfsmresetdone_r2;
gt10_tx_system_reset_c                       <= not gt10_txfsmresetdone_r2;
gt11_tx_system_reset_c                       <= not gt11_txfsmresetdone_r2;

    -- assign resets for frame_check modules
gt0_rx_system_reset_c                        <= not gt0_rxresetdone_r3;
gt1_rx_system_reset_c                        <= not gt1_rxresetdone_r3;
gt2_rx_system_reset_c                        <= not gt2_rxresetdone_r3;
gt3_rx_system_reset_c                        <= not gt3_rxresetdone_r3;
gt4_rx_system_reset_c                        <= not gt4_rxresetdone_r3;
gt5_rx_system_reset_c                        <= not gt5_rxresetdone_r3;
gt6_rx_system_reset_c                        <= not gt6_rxresetdone_r3;
gt7_rx_system_reset_c                        <= not gt7_rxresetdone_r3;
gt8_rx_system_reset_c                        <= not gt8_rxresetdone_r3;
gt9_rx_system_reset_c                        <= not gt9_rxresetdone_r3;
gt10_rx_system_reset_c                       <= not gt10_rxresetdone_r3;
gt11_rx_system_reset_c                       <= not gt11_rxresetdone_r3;



end RTL;


